;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Armors\BuildingClass.psc
Modified : 2020-08-30 02:26:18
Compiled : 2021-01-07 11:24:07
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:Armors:BuildingClass extends Form Const
{ Holds a building class's data }

;-- Properties --------------------------------------
Group Config
	Keyword Property PlotTypeKeyword Auto Const mandatory
	{ The PlotTypeKeyword of the plot type this class is for. }
	Keyword Property ClassKeyword Auto Const mandatory
	{ Keyword representing this class. }
	objectmod Property BuildingClassDescription Auto Const mandatory
	{ Make a copy of the ObjectMod SS2_Template_BuildingClassDescription. The Desc should be a short description of what your building class provides. Note that the title field will be displayed on the plot information screen under the Building Class section and similar places where no additional information is needed beyond the name of the class, the actual selectable object name the player will see is on the Armor record this is attached to. }
	Form Property InformationIcon Auto Const mandatory
	{ Activator form with InformationIcon script - will display next to the primary plot type icon to help player's identify the special significance of that building. }
	string Property sHUDIcon = "" Auto Const
	{ This can be a look up string as defined by the HUDIconMap_InfoBox property in SS2_HUDManager. TODO: Allow injection of custom swf files with an icon. }
	ActorValue Property IconResource Auto Const
	{ This determines the type of icon the settler receives when multiple people are assigned to a plot (by default the game will only give the first NPC an icon - so this is for us to hack that). 
	Generally this should be Food for Agricultural, Safety for Martial, WorkshopRatingScavengeGeneral for Industrial, and one of the WorkshopRatingVendorType's for Commercial. 
	NOTE: This only affects the vanilla workshop HUD. SS2's custom HUD instead uses the sHUDIcon field. }
EndGroup

Group Optional_Extras
	Message Property DefaultAssignmentTitle Auto Const
	{ This determines the job title to display on the NPC Inspection tool. If not filled out, the default title for the plot type will be used }
	GlobalVariable Property gUnlock Auto Const
	{ GlobalVariable controlling whether these plans are available yet }
	LocationRefType Property LocationRefTypeL1 Auto Const
	{ [Optional] Will cause the plot to be flagged as a LocationRefType of this type for that settlement at level 1 }
	LocationRefType Property LocationRefTypeL2 Auto Const
	{ [Optional] Will cause the plot to be flagged as a LocationRefType of this type for that settlement at level 2 }
	LocationRefType Property LocationRefTypeL3 Auto Const
	{ [Optional] Will cause the plot to be flagged as a LocationRefType of this type for that settlement at level 3 }
EndGroup

Group Advanced collapsedonbase collapsedonref
	bool[] Property bAlwaysRequirePower Auto Const
	{ 1 entry per level, including 0. Overrides plot configuration if set. }
	bool[] Property bDoesNotRequirePower Auto Const
	{ 1 entry per level, including 0. Overrides plot configuration if set. If bAlwaysRequirePower conflicts with this, bAlwaysRequirePower will win out. }
	MiscObject Property Requirements Auto Const
	{ Requirements for this to be built and operated. Must be of type SimSettlementsV2:MiscObjects:UsageRequirements }
	int Property iPriority = 0 Auto Const
	{ Currently unused. }
	int Property iMaxPerSettlement = 0 Auto Const
	{ [Optional] Set this to limit the number of this item that can appear in a settlement. 0 = unlimited }
	int Property iMaxPerGame = 0 Auto Const
	{ [Optional] Set this to limit the number of this item that can appear at a time in the game. 0 = unlimited }
	Form Property IdleWorkerRefHolderForm Auto Const
	{ Form that will be placed for each worker assigned to the plot. These forms will be added and removed to signify when a worker is available. Used by the SettlerMissionManager. }
EndGroup

Group Resources collapsedonbase collapsedonref
	bool Property ConstructionCostsAreAdditional = True Auto Const
	{ If false, the ConstructionCosts will replace those at the Plot level }
	simsettlementsv2:datastructures#plotconsumption[] Property ConstructionCosts Auto Const
	{ Items this level plan will consume in order to be constructed/upgraded. iOccupants field is not used. }
	bool Property OperatingCostsAreAdditional = True Auto Const
	{ If false, the OperatingCosts will replace those at the Plot level }
	simsettlementsv2:datastructures#plotconsumption[] Property OperatingCosts Auto Const
	{ Items this building plan will consume each cycle, if not available, the building will be made inactive until it can next consume the appropriate costs. The iOccupants field can be used to adjust the affects based on the number of people occupying the plot (ie. if iOccupants is > 1, that entry will only go into affect if at least that many people occupy the plot). The iLevel field is ignored on BuildingLevelPlan objects since they are tied to a specific level. }
	bool Property ProducedItemsAreAdditional = True Auto Const
	{ If false, the ProduceItems will replace those at the Plot level }
	simsettlementsv2:datastructures#plotproduction[] Property ProducedItems Auto Const
	{ Items this building plan will produce each cycle . The iOccupants field can be used to adjust the affects based on the number of people occupying the plot (ie. if iOccupants is > 1, that entry will only go into affect if at least that many people occupy the plot). The iLevel field is ignored on BuildingLevelPlan objects since they are tied to a specific level. }
	bool Property SettlementResourcesAreAdditional = True Auto Const
	{ If false, the SettlementResources will replace those at the Plot level }
	simsettlementsv2:datastructures#plotresource[] Property SettlementResources Auto Const
	{ These AVs will be set on the settlement while this is active. This is used to add things like, food, water, defense, etc as well as virtual resources like settlement building materials. The iOccupants field can be used to adjust the affects based on the number of people occupying the plot (ie. if iOccupants is > 1, that entry will only go into affect if at least that many people occupy the plot). The iLevel field is ignored on BuildingLevelPlan objects since they are tied to a specific level. }
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

simsettlementsv2:miscobjects:usagerequirements Function GetRequirements()
	return (Requirements as Form) as simsettlementsv2:miscobjects:usagerequirements
EndFunction

Function UpdateClassActorFunctionality(Actor akActorRef, simsettlementsv2:objectreferences:simplot akPlotRef, bool abRemove)
	; Empty function
EndFunction
