;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\AmaraBlackmoonQuest.psc
Modified : 2020-12-29 14:32:42
Compiled : 2021-01-07 11:24:47
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:AmaraBlackmoonQuest extends Quest

;-- Properties --------------------------------------
Group Controllers
	GlobalVariable Property Settings_SimpleObjectives Auto Const
	GlobalVariable Property CurrentVersion Auto Const
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property BeaconItem Auto Const mandatory
	ReferenceAlias Property Radstag Auto Const mandatory
	ReferenceAlias[] Property RadstagDoes Auto Const mandatory
	ReferenceAlias Property SpawnPoint Auto Const mandatory
EndGroup

Group Assets
	Form Property BeaconObject Auto Const mandatory
	LeveledItem Property CapReward Auto Const mandatory
	Actor Property AmaraBlackmoon Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property WorkshopAssignHomePermanentActor Auto Const mandatory
	Keyword Property BlockPlayerActivation Auto Const mandatory
EndGroup

float Property InstalledVersion = 0 Auto hidden
int Property iInitialStage = 1 AutoReadOnly
int Property iStage_HasObjective = 10 AutoReadOnly
int Property iStage_NearRadstags = 15 AutoReadOnly
int Property iStage_KilledRadstag = 20 AutoReadOnly
int Property iStage_KilledDoes = 25 AutoReadOnly
int Property iStage_TaggedBody = 30 AutoReadOnly
int Property iStage_ReturnedToAmara = 35 AutoReadOnly
int Property iStage_AmaraJoined = 40 AutoReadOnly
int Property iObjective_TrackRadstags = 10 AutoReadOnly
int Property iObjective_KillHerd = 20 AutoReadOnly
int Property iObjective_PlaceBeacon = 30 AutoReadOnly
int Property iObjective_ReturnToAmara = 40 AutoReadOnly

;-- Variables ---------------------------------------
bool bRecentStageChange = False
int iLastStageSet = 0

;-- Functions ---------------------------------------

Event OnQuestShutdown()
	Self.UnregisterForAllEvents()
EndEvent

Event ObjectReference.OnItemAdded(ObjectReference akAddedTo, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	If (akAddedTo == Radstag.GetActorReference() as ObjectReference && akBaseItem == BeaconObject)
		Self.UnregisterForRemoteEvent(akAddedTo as ScriptObject, "OnItemAdded")
		ObjectReference kTemp = akAddedTo.PlaceAtMe(BeaconObject, 1, False, False, True)
		kTemp.MoveTo(akAddedTo, 0, 0, 40, True)
		kTemp.AddKeyword(BlockPlayerActivation)
		akAddedTo.RemoveItem(BeaconObject, 1, True, None)
		Self.SetStage(Self.iStage_TaggedBody)
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (auiStageID >= Self.iInitialStage)
		iLastStageSet = auiStageID
	EndIf
	If (auiStageID == -1)
		If (auiItemID == -3)
			Self.ConfigureObjectives(True)
		ElseIf (auiItemID == -1)
			Self.Startup()
		EndIf
	Else
		bRecentStageChange = True
		Self.UpdateAliases()
		Self.ConfigureObjectives(False)
		Self.HandleStageChanges(auiStageID, auiItemID)
	EndIf
EndEvent

Event Actor.OnDeath(Actor akSender, Actor akKiller)
	If (akSender == Radstag.GetActorReference())
		Self.SetStage(Self.iStage_KilledRadstag)
	EndIf
	If (Self.RadstagDoesDead())
		Self.SetStage(Self.iStage_KilledDoes)
	EndIf
EndEvent

Function UpdateAliases()
	If (iLastStageSet == Self.iInitialStage)
		
	EndIf
EndFunction

bool Function RadstagDoesDead()
	int I = 0
	While (I < RadstagDoes.length)
		If (!RadstagDoes[I].GetActorReference().IsDead())
			return False
		EndIf
		I += 1
	EndWhile
	return True
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == Self.iStage_HasObjective)
		PlayerRef.AddItem(BeaconItem.GetRef() as Form, 1, False)
		Actor kRadstagRef = Radstag.GetActorReference()
		kRadstagRef.Enable(False)
		Self.RegisterForRemoteEvent(kRadstagRef as ScriptObject, "OnCombatStateChanged")
		Self.RegisterForRemoteEvent(kRadstagRef as ScriptObject, "OnDeath")
		Self.AddInventoryEventFilter(BeaconObject)
		Self.RegisterForRemoteEvent(kRadstagRef as ScriptObject, "OnItemAdded")
		int I = 0
		While (I < RadstagDoes.length)
			Actor kDoeRef = RadstagDoes[I].GetActorReference()
			If (kDoeRef)
				kDoeRef.Enable(False)
				Self.RegisterForRemoteEvent(kDoeRef as ScriptObject, "OnDeath")
			EndIf
			I += 1
		EndWhile
	ElseIf (auiStageID == Self.iStage_ReturnedToAmara)
		Self.SendAmaraToWorkshop()
	ElseIf (auiStageID == Self.iStage_AmaraJoined)
		PlayerRef.AddItem(CapReward as Form, 1, False)
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.Stop()
	EndIf
EndFunction

Event Actor.OnCombatStateChanged(Actor akSender, Actor akTarget, int aeCombatState)
	If (akTarget == PlayerRef)
		Self.SetStage(Self.iStage_NearRadstags)
		Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnCombatStateChanged")
	EndIf
EndEvent

Function ConfigureObjectives(bool bSimpleSwap)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (bSimpleSwap)
		
	EndIf
	If (iLastStageSet == Self.iStage_HasObjective)
		Self.SetObjectiveDisplayed(Self.iObjective_TrackRadstags, True, False)
	ElseIf (iLastStageSet == Self.iStage_NearRadstags)
		Self.SetObjectiveCompleted(Self.iObjective_TrackRadstags, True)
		Self.SetObjectiveDisplayed(Self.iObjective_KillHerd, True, False)
	ElseIf (iLastStageSet == Self.iStage_KilledDoes || iLastStageSet == Self.iStage_KilledRadstag)
		If (Self.GetStageDone(Self.iStage_KilledDoes) && Self.GetStageDone(Self.iStage_KilledRadstag))
			Self.SetObjectiveCompleted(Self.iObjective_KillHerd, True)
			Self.SetObjectiveDisplayed(Self.iObjective_PlaceBeacon, True, False)
		EndIf
	ElseIf (iLastStageSet == Self.iStage_TaggedBody)
		Self.SetObjectiveCompleted(Self.iObjective_PlaceBeacon, True)
		Self.SetObjectiveDisplayed(Self.iObjective_ReturnToAmara, True, False)
	EndIf
EndFunction

Event Actor.OnPlayerLoadGame(Actor akActorRef)
	Self.Startup()
EndEvent

Function Startup()
	If (InstalledVersion * 10000 as float < CurrentVersion.GetValue() * 10000 as float)
		If (InstalledVersion > 0 as float)
			Self.InstallModChanges()
		Else
			InstalledVersion = CurrentVersion.GetValue()
		EndIf
	EndIf
EndFunction

Function InstallModChanges()
	InstalledVersion = CurrentVersion.GetValue()
EndFunction

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
	Self.Startup()
EndEvent

Function SendAmaraToWorkshop()
	Utility.Wait(1)
	Location targetLocation = (AmaraBlackmoon as workshopnpcscript).OpenWorkshopSettlementMenu(WorkshopAssignHomePermanentActor, None, None)
	If (targetLocation != None)
		Self.SetStage(Self.iStage_AmaraJoined)
	EndIf
EndFunction
