;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\AprilLiQuest.psc
Modified : 2020-12-29 14:31:26
Compiled : 2021-01-07 11:24:58
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:AprilLiQuest extends Quest

;-- Properties --------------------------------------
Group Controllers
	Quest Property DialogueQuest Auto Const mandatory
	{ April's DialogueQuest isn't started initially so that we can start it to spawn her dog }
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property AprilLi Auto Const mandatory
	ReferenceAlias Property AprilLisDog Auto Const mandatory
	ReferenceAlias Property Polly Auto Const mandatory
	ReferenceAlias Property Myrna Auto Const mandatory
	ReferenceAlias Property Percy Auto Const mandatory
	ReferenceAlias Property PollyPackage Auto Const mandatory
	ReferenceAlias Property MyrnaPackage Auto Const mandatory
	ReferenceAlias Property PercyPackage Auto Const mandatory
	LocationAlias Property CastleLocation Auto Const mandatory
EndGroup

Group RadioScene
	GlobalVariable Property MinutemenRadioFrequency Auto Const
	Scene Property AprilRadioScene Auto Const mandatory
	workshopscript Property kCastleWorkshopRef Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iLastInstalledVersion = 0
int iTimerID_QuestStartupComplete = 100 Const
int iStage_Started = 1 Const
int iStage_PlayerGivenObjective = 10 Const
int iStage_PackageFromMyrna = 16 Const
int iObjective_ReturnToAprilLi = 20 Const
int iStage_PlayerHasSupplies = 20 Const
int iObjective_FindSupplies = 10 Const
int iStage_PackageFromPolly = 15 Const
int iStage_StartupComplete = 2 Const
int iStage_PlayerDeclined = 5 Const
int iStage_PlayerCompletedQuest = 30 Const
int iStage_MetAprilLi = 4 Const
int iStage_RadioScenePlayed = 3 Const
int iObjective_SpeakToAprilLiAtCastle = 5 Const
int iStage_PackageFromPercy = 17 Const

;-- Functions ---------------------------------------

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
	Self.CheckForCastleRadio()
EndEvent

Function CheckForCastleRadio()
	If (!Self.GetStageDone(iStage_MetAprilLi))
		If (AprilLi.GetActorRef().GetCurrentLocation() == CastleLocation.GetLocation() && kCastleWorkshopRef.OwnedByPlayer && Game.IsPlayerRadioOn() && Game.GetPlayerRadioFrequency() == MinutemenRadioFrequency.GetValue())
			Game.TurnPlayerRadioOn(False)
			AprilRadioScene.Start()
		Else
			Self.StartTimerGameTime(24, 0)
		EndIf
	EndIf
EndFunction

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		AprilLisDog.TryToEnable()
	ElseIf (auiStageID == iStage_RadioScenePlayed)
		Game.TurnPlayerRadioOn(True)
		Self.SetObjectiveDisplayed(iObjective_SpeakToAprilLiAtCastle, True, False)
	ElseIf (auiStageID == iStage_MetAprilLi)
		If (Self.IsObjectiveDisplayed(iObjective_SpeakToAprilLiAtCastle))
			Self.SetObjectiveCompleted(iObjective_SpeakToAprilLiAtCastle, True)
		EndIf
	ElseIf (auiStageID == iStage_PlayerGivenObjective)
		Self.SetObjectiveDisplayed(iObjective_FindSupplies, True, False)
		Polly.GetActorRef().AddItem(PollyPackage.GetRef() as Form, 1, False)
		Myrna.GetActorRef().AddItem(MyrnaPackage.GetRef() as Form, 1, False)
		Percy.GetActorRef().AddItem(PercyPackage.GetRef() as Form, 1, False)
	ElseIf (auiStageID == iStage_PackageFromMyrna)
		Myrna.GetActorRef().RemoveItem(MyrnaPackage.GetRef() as Form, 1, False, PlayerRef as ObjectReference)
		Percy.GetActorRef().RemoveItem(PercyPackage.GetRef() as Form, 1, False, None)
		If (PlayerRef.GetItemCount(PollyPackage.GetRef().GetBaseObject()) > 0)
			Self.SetStage(iStage_PlayerHasSupplies)
		EndIf
	ElseIf (auiStageID == iStage_PackageFromPercy)
		Percy.GetActorRef().RemoveItem(PercyPackage.GetRef() as Form, 1, False, PlayerRef as ObjectReference)
		Myrna.GetActorRef().RemoveItem(MyrnaPackage.GetRef() as Form, 1, False, None)
		If (PlayerRef.GetItemCount(PollyPackage.GetRef().GetBaseObject()) > 0)
			Self.SetStage(iStage_PlayerHasSupplies)
		EndIf
	ElseIf (auiStageID == iStage_PackageFromPolly)
		Polly.GetActorRef().RemoveItem(PollyPackage.GetRef() as Form, 1, False, PlayerRef as ObjectReference)
		If (PlayerRef.GetItemCount(MyrnaPackage.GetRef().GetBaseObject()) > 0)
			Self.SetStage(iStage_PlayerHasSupplies)
		EndIf
	ElseIf (auiStageID == iStage_PlayerHasSupplies)
		Self.SetObjectiveCompleted(iObjective_FindSupplies, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToAprilLi, True, False)
	ElseIf (auiStageID == iStage_PlayerCompletedQuest)
		PlayerRef.RemoveItem(MyrnaPackage.GetRef().GetBaseObject(), -1, False, None)
		PlayerRef.RemoveItem(PollyPackage.GetRef().GetBaseObject(), -1, False, None)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(AprilLi.GetActorRef(), True, True, True)
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.Stop()
	EndIf
EndEvent

Event OnTimerGameTime(int auiTimerID)
	Self.CheckForCastleRadio()
EndEvent
