;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\ArchibaldCharacterQuest.psc
Modified : 2020-11-29 00:02:07
Compiled : 2021-01-07 11:24:57
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:ArchibaldCharacterQuest extends Quest

;-- Properties --------------------------------------
Group Aliases
	ReferenceAlias Property Archibald Auto Const mandatory
	ReferenceAlias Property Treadwell Auto Const mandatory
	ReferenceAlias Property MemoryDenNote Auto Const mandatory
	ReferenceAlias Property ScienceCenterTerminal Auto Const mandatory
	ReferenceAlias Property MedtekTerminal Auto Const mandatory
	ReferenceAlias Property ConcordMapMarkerAlias Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Assets
	Potion Property VanillaMentats Auto Const mandatory
	LeveledItem Property QuestReward Auto Const mandatory
	holotape Property FormulaHolotape Auto Const mandatory
	Keyword Property SS2_LinkCustom_Other_02 Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iTimerID_ReturnToTreadwellNotice = 101 Const
int iObjective_GiveMentatsToTreadwell = 60 Const
int iStage_FoundAllIngredients = 50 Const
int iObjective_GiveFormulaToTreadwell = 40 Const
int iStage_FoundRecipe = 30 Const
int iStage_Started = 1 Const
int iObjective_CheckMemoryDen = 10 Const
int iStage_FoundScienceCenterNote = 21 Const
int iStage_TurnedInRecipe = 31 Const
int iStage_AgreedToHelpFurther = 40 Const
int iStage_TurnedInMentats = 70 Const
int iObjective_CraftRefinedMentats = 50 Const
int iStage_StartupComplete = 2 Const
int iStage_QuestComplete = 90 Const
int iStage_FoundMemoryDenNote = 20 Const
int iStage_TellPlayerToReturnToTreadwell = 5 Const
int iStage_Accepted = 10 Const
int iStage_DeclinedFurtherHelp = 35 Const
int iStage_ArchibaldCured = 80 Const
int iLastInstalledVersion = 0
int iObjective_CheckScienceCenter = 20 Const
int iObjective_CheckMedTek = 30 Const
int iTimerID_QuestStartupComplete = 100 Const
int iObjective_VisitTreadwell = 5 Const
int iStage_CraftedRecipe = 60 Const

;-- Functions ---------------------------------------

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		Self.StartTimerGameTime(24, iTimerID_ReturnToTreadwellNotice)
	ElseIf (auiStageID == iStage_Accepted)
		Treadwell.GetActorRef().SetLinkedRef(None, SS2_LinkCustom_Other_02)
		Treadwell.GetActorRef().EvaluatePackage(False)
		Utility.Wait(0.1)
		Treadwell.GetActorRef().SetLinkedRef(Archibald.GetActorRef() as ObjectReference, SS2_LinkCustom_Other_02)
		Treadwell.GetActorRef().EvaluatePackage(False)
		If (Self.IsObjectiveDisplayed(iObjective_VisitTreadwell))
			Self.SetObjectiveCompleted(iObjective_VisitTreadwell, True)
		EndIf
		Self.CancelTimerGameTime(iTimerID_ReturnToTreadwellNotice)
		MemoryDenNote.TryToEnable()
		ScienceCenterTerminal.TryToEnable()
		MedtekTerminal.TryToEnable()
		Self.SetObjectiveDisplayed(iObjective_CheckMemoryDen, True, False)
		Self.SetObjectiveDisplayed(iObjective_CheckScienceCenter, True, False)
	ElseIf (auiStageID == iStage_FoundMemoryDenNote)
		Self.SetObjectiveCompleted(iObjective_CheckMemoryDen, True)
		If (Self.IsObjectiveCompleted(iObjective_CheckScienceCenter))
			Self.SetObjectiveDisplayed(iObjective_CheckMedTek, True, False)
		EndIf
	ElseIf (auiStageID == iStage_FoundScienceCenterNote)
		Self.SetObjectiveCompleted(iObjective_CheckScienceCenter, True)
		If (Self.IsObjectiveCompleted(iObjective_CheckMemoryDen))
			Self.SetObjectiveDisplayed(iObjective_CheckMedTek, True, False)
		EndIf
	ElseIf (auiStageID == iStage_FoundRecipe)
		Self.SetObjectiveCompleted(iObjective_CheckMedTek, True)
		Self.SetObjectiveDisplayed(iObjective_GiveFormulaToTreadwell, True, False)
	ElseIf (auiStageID == iStage_TurnedInRecipe)
		PlayerRef.RemoveItem(FormulaHolotape as Form, 1, False, None)
		Self.SetObjectiveCompleted(iObjective_GiveFormulaToTreadwell, True)
	ElseIf (auiStageID == iStage_DeclinedFurtherHelp)
		Self.SetStage(iStage_QuestComplete)
	ElseIf (auiStageID == iStage_AgreedToHelpFurther)
		Self.SetObjectiveDisplayed(iObjective_CraftRefinedMentats, True, False)
		Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnItemAdded")
		Self.AddInventoryEventFilter(VanillaMentats as Form)
	ElseIf (auiStageID == iStage_CraftedRecipe)
		Self.SetObjectiveCompleted(iObjective_CraftRefinedMentats, True)
		Self.SetObjectiveDisplayed(iObjective_GiveMentatsToTreadwell, True, False)
	ElseIf (auiStageID == iStage_TurnedInMentats)
		PlayerRef.RemoveItem(VanillaMentats as Form, 1, False, None)
		PlayerRef.AddItem(QuestReward as Form, 1, False)
		Self.SetObjectiveCompleted(iObjective_GiveMentatsToTreadwell, True)
	ElseIf (auiStageID == iStage_ArchibaldCured)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(Archibald.GetActorRef(), True, True, True)
		Self.SetStage(iStage_QuestComplete)
	ElseIf (auiStageID == iStage_QuestComplete)
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Treadwell.GetActorRef().SetLinkedRef(None, SS2_LinkCustom_Other_02)
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.Stop()
	EndIf
EndEvent

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iTimerID_ReturnToTreadwellNotice)
		Treadwell.GetActorRef().SetLinkedRef(ConcordMapMarkerAlias.GetRef(), SS2_LinkCustom_Other_02)
		Treadwell.GetActorRef().EvaluatePackage(False)
		Self.SetObjectiveDisplayed(iObjective_VisitTreadwell, True, True)
	EndIf
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Event ObjectReference.OnItemAdded(ObjectReference akAddedTo, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	If (akBaseItem == VanillaMentats as Form)
		If (!Self.GetStageDone(iStage_CraftedRecipe))
			Self.SetStage(iStage_CraftedRecipe)
		EndIf
		Self.UnregisterForRemoteEvent(akAddedTo as ScriptObject, "OnItemAdded")
	EndIf
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent
