;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\ArchibaldDialogueQuest.psc
Modified : 2020-11-28 22:24:11
Compiled : 2021-01-07 11:25:04
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:ArchibaldDialogueQuest extends Quest

;-- Properties --------------------------------------
Group Aliases
	ReferenceAlias Property RadioSignal Auto Const mandatory
	ReferenceAlias Property Archibald Auto Const mandatory
	ReferenceAlias Property Treadwell Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Assets
	Scene Property RadioScene Auto Const mandatory
	Quest Property RadiantQuest Auto Const mandatory
	Quest Property CharacterQuest Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_AdditionalRadiantTrigger = 60 Const
int iLastInstalledVersion = 0
int iTimerID_QuestStartupComplete = 100 Const
int iStage_ArchibaldInWorld = 5 Const
int iStage_FirstRadiantComplete = 40 Const
int iStage_RadioSignalStarted = 20 Const
int iStage_IntroComplete = 10 Const
int iTimerID_StartRadiantLoop = 102 Const
int iStage_PostCharacterQuestTimePassed = 55 Const
int iTimerID_StartRadioSignal = 101 Const
int iStage_AdditionalRadiantTurnIn = 70 Const
int iStage_RadioSignalHeard = 25 Const
int iStage_CharacterQuestComplete = 50 Const
int iStage_StartupComplete = 2 Const
int iStage_Started = 1 Const
int iStage_FirstRadiantStarted = 30 Const

;-- Functions ---------------------------------------

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event Quest.OnQuestShutdown(Quest akSender)
	If (akSender == RadiantQuest)
		If (!Self.GetStageDone(iStage_FirstRadiantComplete))
			Self.SetStage(iStage_FirstRadiantComplete)
		EndIf
	ElseIf (akSender == CharacterQuest)
		Self.SetStage(iStage_CharacterQuestComplete)
	EndIf
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnQuestShutdown")
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iTimerID_StartRadioSignal)
		Self.SetStage(iStage_RadioSignalStarted)
	ElseIf (aiTimerID == iTimerID_StartRadiantLoop)
		Self.SetStage(iStage_PostCharacterQuestTimePassed)
	EndIf
EndEvent

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_ArchibaldInWorld)
		Treadwell.GetActorRef().MoveTo(Archibald.GetActorRef() as ObjectReference, 0, 0, 0, True)
	ElseIf (auiStageID == iStage_IntroComplete)
		Self.StartTimerGameTime(24, iTimerID_StartRadioSignal)
	ElseIf (auiStageID == iStage_RadioSignalStarted)
		RadioScene.Start()
		RadioSignal.TryToEnable()
	ElseIf (auiStageID == iStage_RadioSignalHeard)
		Self.SetObjectiveDisplayed(10, True, False)
	ElseIf (auiStageID == iStage_FirstRadiantStarted)
		Self.SetObjectiveCompleted(10, True)
		RadiantQuest.Start()
		Self.RegisterForRemoteEvent(RadiantQuest as ScriptObject, "OnQuestShutdown")
	ElseIf (auiStageID == iStage_FirstRadiantComplete)
		RadiantQuest.SetStage(30)
		CharacterQuest.Start()
		Self.RegisterForRemoteEvent(CharacterQuest as ScriptObject, "OnQuestShutdown")
	ElseIf (auiStageID == iStage_CharacterQuestComplete)
		Self.StartTimerGameTime(24, iTimerID_StartRadiantLoop)
	ElseIf (auiStageID == iStage_PostCharacterQuestTimePassed)
		Self.SetObjectiveDisplayed(20, True, False)
	ElseIf (auiStageID == iStage_AdditionalRadiantTrigger)
		If (Self.IsObjectiveDisplayed(20))
			Self.SetObjectiveCompleted(20, True)
		EndIf
		If (!RadiantQuest.IsRunning())
			RadiantQuest.Start()
		EndIf
	ElseIf (auiStageID == iStage_AdditionalRadiantTurnIn)
		If (RadiantQuest.IsRunning())
			RadiantQuest.SetStage(30)
		EndIf
	EndIf
EndEvent

Function InstallChanges()
	int iHotfix102aVersion = 17
	If (iLastInstalledVersion < iHotfix102aVersion)
		If (Self.GetStageDone(iStage_FirstRadiantStarted) && !Self.GetStageDone(iStage_FirstRadiantComplete))
			If (RadiantQuest.IsRunning())
				Self.RegisterForRemoteEvent(RadiantQuest as ScriptObject, "OnQuestShutdown")
			Else
				Self.SetStage(iStage_FirstRadiantComplete)
			EndIf
		EndIf
	EndIf
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction
