;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\ArchibaldRadiantQuest.psc
Modified : 2020-09-22 16:39:30
Compiled : 2021-01-07 11:25:03
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:ArchibaldRadiantQuest extends Quest

;-- Properties --------------------------------------
Group Aliases
	ReferenceAlias Property ItemToFetch Auto Const mandatory
EndGroup

Group Assets
	Form Property QuestReward Auto Const
	{ Generally, these should be LeveledItems, which provide max flexibility - but if you don't know how to set those up, you can use anything under the Items section in the CK. }
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Options
	bool Property bEnableQuestItemWhenPlayerHasObjective = True Auto Const
	{ It true, the item will be set to enabled (ie. visible to the player) after the objective is received. If set to false, this assumes you want your quest item to be enabled in the world already before the player has the objective. Or that you will handle enabling the item yourself. }
	bool Property bImmediatelyCompleteOnTurnIn = True Auto Const
	{ If true, this quest will immediately go to stage 40 and complete after stage 30 is triggered and the item is turned in. If set to false, this assumes you will determine when to call CompleteQuest or set stage 40 }
	bool Property bStopQuestAfterComplete = True Auto Const
	{ The quest will immediately shutdown after completion. This is generally a good idea unless you need some of the dialogue or aliases to remain accessible. }
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_PlayerTurnedInItem = 30 Const
int iObjective_FindItem = 10 Const
int iStage_Started = 1 Const
int iStage_PlayerCompletedQuest = 40 Const
int iLastInstalledVersion = 0
int iStage_PlayerGivenObjective = 10 Const
int iStage_StartupComplete = 2 Const
int iStage_PlayerHasItem = 20 Const
int iTimerID_QuestStartupComplete = 100 Const
int iObjective_TurnInItem = 20 Const

;-- Functions ---------------------------------------

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		Self.SetStage(iStage_PlayerGivenObjective)
	ElseIf (auiStageID == iStage_PlayerGivenObjective)
		If (bEnableQuestItemWhenPlayerHasObjective)
			ItemToFetch.TryToEnable()
		EndIf
		Self.SetObjectiveDisplayed(iObjective_FindItem, True, True)
	ElseIf (auiStageID == iStage_PlayerHasItem)
		Self.SetObjectiveCompleted(iObjective_FindItem, True)
		Self.SetObjectiveDisplayed(iObjective_TurnInItem, True, True)
	ElseIf (auiStageID == iStage_PlayerTurnedInItem)
		PlayerRef.RemoveItem(ItemToFetch.GetRef() as Form, 1, False, None)
		If (QuestReward != None)
			PlayerRef.AddItem(QuestReward, 1, False)
		EndIf
		If (bImmediatelyCompleteOnTurnIn)
			Self.SetStage(iStage_PlayerCompletedQuest)
		EndIf
	ElseIf (auiStageID == iStage_PlayerCompletedQuest)
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		If (bStopQuestAfterComplete)
			Self.Stop()
		EndIf
	EndIf
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent
