;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\BenniStrongQuest.psc
Modified : 2020-08-07 12:22:42
Compiled : 2021-01-07 11:25:05
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:BenniStrongQuest extends Quest

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
	GlobalVariable Property gCollectedCounter Auto Const mandatory
	GlobalVariable Property gQuestItemTotal Auto Const mandatory
EndGroup

Group Aliases
	LocationAlias Property ArtStudioLocation Auto Const mandatory
	ReferenceAlias Property BenniStrong Auto Const mandatory
	ReferenceAlias Property QuestItemEnableParent Auto Const mandatory
EndGroup

Group Assets
	int Property iSuppliesRequired = 12 Auto Const
	Form Property QuestReward Auto Const mandatory
	FormList Property ArtSuppliesList Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_Started = 1 Const
int iStage_StartupComplete = 2 Const
int iObjective_FindSupplies = 10 Const
int iStage_PlayerTurnedInSupplies = 30 Const
int iStage_PlayerGivenObjective = 10 Const
int iStage_PlayerCompletedQuest = 40 Const
int iStage_PlayerHasSupplies = 20 Const
int iLastInstalledVersion = 0
int iObjective_ReturnToBenniStrong = 20 Const
int iTimerID_QuestStartupComplete = 100 Const

;-- Functions ---------------------------------------

Function CheckForArtSupplies()
	int iSupplies = PlayerRef.GetItemCount(ArtSuppliesList as Form)
	If (iSupplies >= iSuppliesRequired)
		Self.SetStage(iStage_PlayerHasSupplies)
	EndIf
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_PlayerGivenObjective)
		If (ArtStudioLocation.GetLocation().IsCleared())
			ArtStudioLocation.GetLocation().Reset()
		EndIf
		QuestItemEnableParent.TryToEnable()
		gQuestItemTotal.SetValueInt(iSuppliesRequired)
		Self.UpdateCurrentInstanceGlobal(gQuestItemTotal)
		Self.SetObjectiveDisplayed(iObjective_FindSupplies, True, False)
		Self.AddInventoryEventFilter(ArtSuppliesList as Form)
		Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnItemAdded")
		Self.CheckForArtSupplies()
	ElseIf (auiStageID == iStage_PlayerHasSupplies)
		Self.SetObjectiveCompleted(iObjective_FindSupplies, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToBenniStrong, True, False)
	ElseIf (auiStageID == iStage_PlayerTurnedInSupplies)
		Self.UnregisterForRemoteEvent(PlayerRef as ScriptObject, "OnItemAdded")
		PlayerRef.RemoveItem(ArtSuppliesList as Form, -1, False, None)
		PlayerRef.AddItem(QuestReward, 1, False)
	ElseIf (auiStageID == iStage_PlayerCompletedQuest)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(BenniStrong.GetActorRef(), True, True, True)
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.Stop()
	EndIf
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event ObjectReference.OnItemAdded(ObjectReference akSender, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	If (ArtSuppliesList.HasForm(akBaseItem) && !Self.GetStageDone(iStage_PlayerHasSupplies))
		Self.ModObjectiveGlobal(1, gCollectedCounter, iObjective_FindSupplies, iSuppliesRequired as float, True, False, True, False)
		Self.CheckForArtSupplies()
	EndIf
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent
