;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\CarlMeadeQuest.psc
Modified : 2020-08-05 21:48:14
Compiled : 2021-01-07 11:25:50
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:CarlMeadeQuest extends Quest conditional

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property CarlMeade Auto Const mandatory
	ReferenceAlias Property FirstTameFeral Auto Const mandatory
	ReferenceAlias Property CarlMarker Auto Const mandatory
	ReferenceAlias Property GhoulChair Auto Const mandatory
	ReferenceAlias Property GhoulChairFurniture Auto Const mandatory
EndGroup

Group Assets
	Form Property QuestReward Auto Const mandatory
	Weapon Property Syringer Auto Const mandatory
	Form Property TranquilizerDart Auto Const mandatory
	workshopparentscript Property WorkshopParent Auto Const mandatory
	Keyword Property WorkshopItemKeyword Auto Const mandatory
	Scene Property CarlSoothGhoulScene Auto Const mandatory
	Keyword Property WorkshopLinkCenter Auto Const mandatory
	Keyword Property SS2_PlotType_Commercial Auto Const mandatory
	Keyword Property SS2_PlotSubType_Commercial_Clinic Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
bool bDartsGivenRecently = False conditional
int iLastInstalledVersion = 0
int iStage_Started = 1 Const
int iObjective_TranquilizeFeral = 10 Const
int iObjective_ReturnToCarlMeade = 20 Const
int iTimerID_FeralGhoulConversion = 101 Const
int iStage_FeralConverted = 40 Const
int iStage_FeralTranquilized = 20 Const
int iStage_GiveSyringerAndDarts = 8 Const
int iTimerID_QuestStartupComplete = 100 Const
int iStage_PlayerGivenObjective = 10 Const
int iTimerID_DartCooldown = 102 Const
int iStage_CarlAssignedToClinic = 15 Const
int iStage_PlayerTurnedIn = 30 Const
int iObjective_AssignCarlToClinic = 5 Const
int iStage_StartupComplete = 2 Const

;-- Functions ---------------------------------------

Function CheckForClinicAssignment()
	workshopnpcscript CarlRef = CarlMeade.GetActorRef() as workshopnpcscript
	workshopscript thisWorkshop = CarlRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	ObjectReference[] kOwnedRefs = thisWorkshop.GetWorkshopOwnedObjects(CarlRef as Actor)
	bool bOwned = False
	int I = 0
	While (I < kOwnedRefs.length && !bOwned)
		simsettlementsv2:objectreferences:simplot asPlot = kOwnedRefs[I] as simsettlementsv2:objectreferences:simplot
		If (asPlot)
			simsettlementsv2:miscobjects:plotconfiguration thisPlotconfig = asPlot.GetPlotConfig()
			If (thisPlotconfig as bool && thisPlotconfig.PlotTypeKeyword == SS2_PlotType_Commercial)
				If (asPlot.iCurrentLevel > 0 && asPlot.GetClassKeyword() == SS2_PlotSubType_Commercial_Clinic)
					bOwned = True
					Self.SetStage(iStage_CarlAssignedToClinic)
					Self.UnregisterForCustomEvent(asPlot as ScriptObject, "simsettlementsv2:objectreferences:simplot_PlotLevelChanged")
				Else
					Self.RegisterForCustomEvent(asPlot as ScriptObject, "simsettlementsv2:objectreferences:simplot_PlotLevelChanged")
				EndIf
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_GiveSyringerAndDarts)
		PlayerRef.AddItem(Syringer as Form, 1, False)
		PlayerRef.AddItem(TranquilizerDart, 5, False)
	ElseIf (auiStageID == iStage_PlayerGivenObjective)
		Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopActorAssignedToWork")
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(CarlMeade.GetActorRef(), True, True, True)
		Self.SetObjectiveDisplayed(iObjective_AssignCarlToClinic, True, False)
	ElseIf (auiStageID == iStage_CarlAssignedToClinic)
		Self.UnregisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopActorAssignedToWork")
		Self.SetObjectiveCompleted(iObjective_AssignCarlToClinic, True)
		Self.SetObjectiveDisplayed(iObjective_TranquilizeFeral, True, False)
	ElseIf (auiStageID == iStage_FeralTranquilized)
		FirstTameFeral.TryToEnable()
		GhoulChair.TryToEnable()
		GhoulChairFurniture.TryToEnable()
		If (CarlMeade.GetRef().Is3dLoaded())
			Self.RegisterForDistanceLessThanEvent(PlayerRef as ScriptObject, CarlMeade.GetRef() as ScriptObject, 1000)
		Else
			Self.RegisterForRemoteEvent(CarlMeade.GetRef() as ScriptObject, "OnLoad")
		EndIf
		Self.SetObjectiveCompleted(iObjective_TranquilizeFeral, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToCarlMeade, True, False)
	ElseIf (auiStageID == iStage_PlayerTurnedIn)
		PlayerRef.AddItem(QuestReward, 1, False)
		Self.StartTimerGameTime(24, iTimerID_FeralGhoulConversion)
		CarlSoothGhoulScene.Start()
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
	ElseIf (auiStageID == iStage_FeralConverted)
		CarlSoothGhoulScene.Stop()
		WorkshopParent.AddActorToWorkshopPUBLIC(FirstTameFeral.GetActorRef() as workshopnpcscript, CarlMeade.GetActorRef().GetLinkedRef(WorkshopItemKeyword) as workshopscript, False)
		GhoulChair.GetRef().Disable(False)
		GhoulChairFurniture.GetRef().Disable(False)
		Self.UnregisterForAllEvents()
		Self.Stop()
	EndIf
EndEvent

Function SetupChairScene()
	workshopscript kWorkshopRef = workshopframework:wsfw_api.GetNearestWorkshop(CarlMeade.GetRef())
	ObjectReference kNearRef = kWorkshopRef.GetLinkedRef(WorkshopLinkCenter)
	If (!kNearRef)
		kNearRef = kWorkshopRef as ObjectReference
	EndIf
	ObjectReference kChairRef = GhoulChair.GetRef()
	float[] fPosition = kNearRef.GetSafePosition(2000, 300)
	If (fPosition.length == 3)
		kChairRef.SetPosition(fPosition[0], fPosition[1], fPosition[2])
	Else
		kChairRef.MoveToNearestNavmeshLocation()
	EndIf
	kChairRef.Disable(False)
	kChairRef.Enable(False)
	float[] fRelativePosition = new float[3]
	float[] fRelativeAngle = new float[3]
	fRelativePosition[0] = 12.036
	fRelativePosition[1] = -12.0374
	fRelativePosition[2] = 59.9575
	fRelativeAngle[0] = -5.616
	fRelativeAngle[1] = 1.1364
	fRelativeAngle[2] = 101.404
	workshopframework:library:thirdparty:cobb:cobblibraryrotations.MoveObjectRelativeToObject(GhoulChairFurniture.GetRef(), kChairRef, fRelativePosition, fRelativeAngle)
	fRelativePosition[0] = 8.3389
	fRelativePosition[1] = 86.2663
	fRelativePosition[2] = 0
	fRelativeAngle[0] = 0
	fRelativeAngle[1] = 0
	fRelativeAngle[2] = -162.33
	workshopframework:library:thirdparty:cobb:cobblibraryrotations.MoveObjectRelativeToObject(CarlMarker.GetRef(), kChairRef, fRelativePosition, fRelativeAngle)
	FirstTameFeral.GetActorRef().SnapIntoInteraction(GhoulChairFurniture.GetRef())
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Function GiveMoreDarts()
	If (bDartsGivenRecently)
		return 
	EndIf
	bDartsGivenRecently = True
	PlayerRef.AddItem(TranquilizerDart, 5, False)
	Self.StartTimerGameTime(24, iTimerID_DartCooldown)
EndFunction

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event ObjectReference.OnLoad(ObjectReference akSender)
	Self.SetupChairScene()
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnLoad")
EndEvent

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iTimerID_FeralGhoulConversion)
		Self.SetStage(iStage_FeralConverted)
	ElseIf (aiTimerID == iTimerID_DartCooldown)
		Self.GiveMoreDarts()
	EndIf
EndEvent

Event OnDistanceLessThan(ObjectReference akObj1, ObjectReference akObj2, float afDistance)
	Self.SetupChairScene()
	Self.UnregisterForDistanceEvents(akObj1 as ScriptObject, akObj2 as ScriptObject)
EndEvent

Event SimSettlementsV2:ObjectReferences:SimPlot.PlotLevelChanged(simsettlementsv2:objectreferences:simplot akPlotRef, var[] akArgs)
	If (akPlotRef.PrimaryOwner == CarlMeade.GetActorRef())
		Self.CheckForClinicAssignment()
	EndIf
EndEvent

Event WorkshopParentScript.WorkshopActorAssignedToWork(workshopparentscript akSenderRef, var[] akArgs)
	If (akArgs[2] as Actor == CarlMeade.GetActorRef())
		Self.CheckForClinicAssignment()
	EndIf
EndEvent
