;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\CarneAsadaQuest.psc
Modified : 2020-08-05 21:44:31
Compiled : 2021-01-07 11:25:10
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:CarneAsadaQuest extends Quest

;-- Properties --------------------------------------
Group Controllers
	GlobalVariable Property Settings_SimpleObjectives Auto Const
	GlobalVariable Property CurrentVersion Auto Const
	Actor Property PlayerRef Auto Const mandatory
	Quest Property RandomDungeonQuest Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property CarneAsada Auto Const mandatory
EndGroup

Group Assets
	Form Property StashObject Auto Const mandatory
	MiscObject Property Caps001 Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property WorkshopAssignHomePermanentActor Auto Const mandatory
EndGroup

float Property InstalledVersion = 0 Auto hidden
int Property iInitialStage = 1 AutoReadOnly
int Property iStage_QuestDeclinedInitially = 10 AutoReadOnly
int Property iStage_QuestAccepted = 20 AutoReadOnly
int Property iStage_StashFound = 40 AutoReadOnly
int Property iStage_SpeechCheck1Passed = 43 AutoReadOnly
int Property iStage_SpeechCheck2Passed = 44 AutoReadOnly
int Property iStage_SpeechCheck3Passed = 45 AutoReadOnly
int Property iStage_QuestTurnedIn = 50 AutoReadOnly
int Property iRemoteStage_QuestStarted = 1 AutoReadOnly
int Property iRemoteStage_StashFound = 5 AutoReadOnly
int Property iRemoteObjective_RecoverStash = 5 AutoReadOnly
int Property iRemoteObjective_ReturnToCarne = 10 AutoReadOnly
GlobalVariable Property Settings_ShowQuestCredits Auto Const mandatory
int[] Property CreditsObjectiveIDs Auto Const

;-- Variables ---------------------------------------
int iLastStageSet = 0
bool bRecentStageChange = False

;-- Functions ---------------------------------------

Function Startup()
	If (InstalledVersion * 10000 as float < CurrentVersion.GetValue() * 10000 as float)
		If (InstalledVersion > 0 as float)
			Self.InstallModChanges()
		Else
			InstalledVersion = CurrentVersion.GetValue()
		EndIf
	EndIf
EndFunction

Function UpdateAliases()
	If (iLastStageSet == Self.iInitialStage)
		
	EndIf
EndFunction

Function CompleteRandomDungeonQuest()
	If (Settings_ShowQuestCredits.GetValueInt() == 1)
		int I = 0
		While (I < CreditsObjectiveIDs.length)
			RandomDungeonQuest.SetObjectiveDisplayed(CreditsObjectiveIDs[I], True, True)
			Utility.Wait(0.1)
			RandomDungeonQuest.SetObjectiveDisplayed(CreditsObjectiveIDs[I], False, False)
			I += 1
		EndWhile
	EndIf
	RandomDungeonQuest.CompleteAllObjectives()
	RandomDungeonQuest.CompleteQuest()
EndFunction

Event Quest.OnStageSet(Quest akSender, int auiStageID, int auiItemID)
	If (auiStageID == Self.iRemoteStage_QuestStarted)
		RandomDungeonQuest.SetObjectiveDisplayed(Self.iRemoteObjective_RecoverStash, True, False)
	ElseIf (auiStageID == Self.iRemoteStage_StashFound)
		Self.SetStage(Self.iStage_StashFound)
		RandomDungeonQuest.SetObjectiveCompleted(Self.iRemoteObjective_RecoverStash, True)
		RandomDungeonQuest.SetObjectiveDisplayed(Self.iRemoteObjective_ReturnToCarne, True, False)
	EndIf
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(RandomDungeonQuest as ScriptObject, "OnStageSet")
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
	Self.Startup()
EndEvent

Function InstallModChanges()
	InstalledVersion = CurrentVersion.GetValue()
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == Self.iStage_QuestAccepted)
		RandomDungeonQuest.Start()
	ElseIf (auiStageID == Self.iStage_QuestTurnedIn)
		int iRewardCaps = 200
		If (Self.GetStageDone(Self.iStage_SpeechCheck3Passed))
			iRewardCaps = 700
		ElseIf (Self.GetStageDone(Self.iStage_SpeechCheck2Passed))
			iRewardCaps = 600
		ElseIf (Self.GetStageDone(Self.iStage_SpeechCheck1Passed))
			iRewardCaps = 400
		EndIf
		PlayerRef.RemoveItem(StashObject, -1, False, None)
		PlayerRef.AddItem(Caps001 as Form, iRewardCaps, False)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(CarneAsada.GetActorRef(), True, True, True)
		Self.CompleteRandomDungeonQuest()
	EndIf
EndFunction

Event Actor.OnPlayerLoadGame(Actor akActorRef)
	Self.Startup()
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (auiStageID >= Self.iInitialStage)
		iLastStageSet = auiStageID
	EndIf
	If (auiStageID == -1)
		If (auiItemID == -3)
			Self.ConfigureObjectives(True)
		ElseIf (auiItemID == -1)
			Self.Startup()
		EndIf
	Else
		bRecentStageChange = True
		Self.UpdateAliases()
		Self.ConfigureObjectives(False)
		Self.HandleStageChanges(auiStageID, auiItemID)
	EndIf
EndEvent

Function ConfigureObjectives(bool bSimpleSwap)
	; Empty function
EndFunction
