;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\CleffQuest.psc
Modified : 2020-08-05 22:17:07
Compiled : 2021-01-07 11:25:15
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:CleffQuest extends Quest conditional

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property Cleff Auto Const mandatory
	ReferenceAlias Property ArchiveTerminal Auto Const mandatory
	ReferenceAlias Property DoorAlias Auto Const mandatory
EndGroup

Group Assets
	Form Property HolotapeForm Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_PlayerGivenObjective = 20 Const
int iTimerID_QuestStartupComplete = 100 Const
int iStage_StartupComplete = 2 Const
int iStage_TimerComplete = 50 Const
int iObjective_ReturnToCleff = 20 Const
int iObjective_CheckBackWithCleff = 40 Const
int iLastInstalledVersion = 0
int iStage_QuestComplete = 60 Const
int iStage_Started = 1 Const
int iStage_HolotapeDataGathered = 30 Const
int iTimerID_DecryptionTimer = 101 Const
int iStage_TurnedInHolotape = 40 Const
int iObjective_GiveTime = 30 Const
int iObjective_UseHolotape = 10 Const

;-- Functions ---------------------------------------

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iTimerID_DecryptionTimer)
		Self.SetStage(iStage_TimerComplete)
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_PlayerGivenObjective)
		DoorAlias.GetRef().SetLockLevel(75)
		DoorAlias.GetRef().Lock(True, False)
		PlayerRef.AddItem(HolotapeForm, 1, False)
		Self.SetObjectiveDisplayed(iObjective_UseHolotape, True, False)
	ElseIf (auiStageID == iStage_HolotapeDataGathered)
		Utility.Wait(8)
		ArchiveTerminal.GetRef().SetLockLevel(254)
		Self.SetObjectiveCompleted(iObjective_UseHolotape, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToCleff, True, False)
	ElseIf (auiStageID == iStage_TurnedInHolotape)
		PlayerRef.RemoveItem(HolotapeForm, 1, False, None)
		Self.SetObjectiveCompleted(iObjective_ReturnToCleff, True)
		Self.SetObjectiveDisplayed(iObjective_GiveTime, True, False)
		Self.StartTimerGameTime(48, iTimerID_DecryptionTimer)
	ElseIf (auiStageID == iStage_TimerComplete)
		Self.SetObjectiveCompleted(iObjective_GiveTime, True)
		Self.SetObjectiveDisplayed(iObjective_CheckBackWithCleff, True, False)
	ElseIf (auiStageID == iStage_QuestComplete)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(Cleff.GetActorRef(), True, True, True)
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.UnregisterForAllEvents()
		Self.Stop()
	EndIf
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction
