;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\CorvusTwinsQuestAndDialogue.psc
Modified : 2020-08-05 21:53:34
Compiled : 2021-01-07 11:25:17
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:CorvusTwinsQuestAndDialogue extends Quest

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	LocationAlias Property CorvusSettlementLocation Auto Const mandatory
	ReferenceAlias Property CorvusWorkshop Auto Const mandatory
	ReferenceAlias Property Raven Auto Const mandatory
	ReferenceAlias Property Crow Auto Const mandatory
	ReferenceAlias Property HoldingCellSpawnPoint Auto Const mandatory
	ReferenceAlias Property CrowCaptureMarker Auto Const mandatory
EndGroup

Group Assets
	workshopparentscript Property WorkshopParent Auto Const mandatory
	Quest Property CrowRescueQuest Auto Const mandatory
	LeveledItem Property RavenReward Auto Const mandatory
	LeveledItem Property CrowReward Auto Const mandatory
	Faction Property CorvusFaction Auto Const mandatory
	Faction Property PlayerFaction Auto Const mandatory
	Faction Property CaptiveFaction Auto Const mandatory
	Faction Property BoundCaptiveFaction Auto Const mandatory
	LeveledItem Property CrowEquipment Auto Const mandatory
EndGroup

GlobalVariable Property Settings_ShowQuestCredits Auto Const mandatory
int[] Property CreditsObjectiveIDs Auto Const

;-- Variables ---------------------------------------
int iRemoteObjective_ReturnToCorvusTwins = 20 Const
int iStage_PlayerTurnedInToBoth = 60 Const
int iStage_CrowRescued = 30 Const
int iStage_PlayerTurnedInToRaven = 40 Const
int iStage_StartupComplete = 2 Const
int iTimerID_QuestStartupComplete = 100 Const
int iStage_CrowDied = 1000 Const
int iStage_RavenDied = 1001 Const
int iLastInstalledVersion = 0
int iStage_PlayerShouldCapsFromCrowAtEnd = 49 Const
int iStage_Started = 1 Const
int iStage_PlayerTurnedInToCrow = 50 Const
int iStage_PlayerGivenObjective = 10 Const
int iRemoteObjective_RescueCrow = 10 Const

;-- Functions ---------------------------------------

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
	Self.RegisterForRemoteEvent(Crow.GetActorRef() as ScriptObject, "OnDeath")
	Self.RegisterForRemoteEvent(Raven.GetActorRef() as ScriptObject, "OnDeath")
	Self.RegisterForRemoteEvent(Raven.GetActorRef() as ScriptObject, "OnWorkshopNPCTransfer")
EndEvent

Function CompleteRescueQuest()
	If (Settings_ShowQuestCredits.GetValueInt() == 1)
		int I = 0
		While (I < CreditsObjectiveIDs.length)
			CrowRescueQuest.SetObjectiveDisplayed(CreditsObjectiveIDs[I], True, True)
			Utility.Wait(0.1)
			CrowRescueQuest.SetObjectiveDisplayed(CreditsObjectiveIDs[I], False, False)
			I += 1
		EndWhile
	EndIf
	CrowRescueQuest.CompleteAllObjectives()
	CrowRescueQuest.CompleteQuest()
	CrowRescueQuest.Stop()
EndFunction

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_PlayerGivenObjective)
		CrowRescueQuest.Start()
		CrowRescueQuest.SetObjectiveDisplayed(iRemoteObjective_RescueCrow, True, False)
		Location ChosenLocation = workshopframework:workshopfunctions.MakePermanentNPCFullSettler(Raven.GetActorRef(), True, True, True)
		If (ChosenLocation == None)
			ChosenLocation = workshopframework:workshopfunctions.MakePermanentNPCFullSettler(Raven.GetActorRef(), True, True, True)
		EndIf
		ObjectReference kCaptureMarkerRef = CrowCaptureMarker.GetRef()
		Crow.GetActorRef().MoveTo(kCaptureMarkerRef, 0, 0, 0, True)
		CorvusSettlementLocation.ForceLocationTo(ChosenLocation)
		workshopscript thisWorkshop = WorkshopParent.GetWorkshopFromLocation(ChosenLocation)
		CorvusWorkshop.ForceRefTo(thisWorkshop as ObjectReference)
	ElseIf (auiStageID == iStage_CrowRescued)
		Actor CrowRef = Crow.GetActorRef()
		workshopnpcscript akWorkshopNPC = CrowRef as workshopnpcscript
		CrowRef.RemoveFromFaction(BoundCaptiveFaction)
		CrowRef.RemoveFromFaction(CaptiveFaction)
		CrowRef.EvaluatePackage(False)
		CrowRescueQuest.SetObjectiveCompleted(iRemoteObjective_RescueCrow, True)
		CrowRescueQuest.SetObjectiveDisplayed(iRemoteObjective_ReturnToCorvusTwins, True, False)
		WorkshopParent.AddPermanentActorToWorkshopPUBLIC(akWorkshopNPC as Actor, (CorvusWorkshop.GetRef() as workshopscript).GetWorkshopID(), True)
		akWorkshopNPC.bCommandable = True
		akWorkshopNPC.bAllowCaravan = False
		akWorkshopNPC.bAllowMove = True
		Self.RegisterForRemoteEvent(Crow.GetActorRef() as ScriptObject, "OnWorkshopNPCTransfer")
	ElseIf (auiStageID == iStage_PlayerTurnedInToRaven)
		PlayerRef.AddItem(RavenReward as Form, 1, False)
		If (Self.GetStageDone(iStage_PlayerTurnedInToCrow))
			Self.SetStage(iStage_PlayerTurnedInToBoth)
		EndIf
	ElseIf (auiStageID == iStage_PlayerTurnedInToCrow)
		Crow.GetActorRef().AddItem(CrowEquipment as Form, 1, False)
		If (Self.GetStageDone(iStage_PlayerShouldCapsFromCrowAtEnd))
			PlayerRef.AddItem(CrowReward as Form, 1, False)
		EndIf
		If (Self.GetStageDone(iStage_PlayerTurnedInToRaven))
			Self.SetStage(iStage_PlayerTurnedInToBoth)
		EndIf
	ElseIf (auiStageID == iStage_PlayerTurnedInToBoth)
		Self.CompleteRescueQuest()
	ElseIf (auiStageID == iStage_CrowDied || auiStageID == iStage_RavenDied)
		Actor crowref = Crow.GetActorRef()
		Actor RavenRef = Raven.GetActorRef()
		WorkshopParent.RemoveActorFromWorkshopPUBLIC(crowref as workshopnpcscript)
		WorkshopParent.RemoveActorFromWorkshopPUBLIC(Raven.GetActorRef() as workshopnpcscript)
		CorvusFaction.SetEnemy(PlayerFaction, False, False)
		If (auiStageID == iStage_CrowDied)
			If (!Self.GetStageDone(iStage_RavenDied))
				If (!RavenRef.Is3dLoaded())
					RavenRef.MoveTo(HoldingCellSpawnPoint.GetRef(), 0, 0, 0, True)
				Else
					RavenRef.StartCombat(PlayerRef, False)
				EndIf
			EndIf
		ElseIf (auiStageID == iStage_RavenDied)
			If (!Self.GetStageDone(iStage_CrowDied))
				If (!crowref.Is3dLoaded())
					crowref.MoveTo(HoldingCellSpawnPoint.GetRef(), 0, 0, 0, True)
				Else
					crowref.StartCombat(PlayerRef, False)
				EndIf
			EndIf
		EndIf
		If (!CrowRescueQuest.IsCompleted())
			CrowRescueQuest.FailAllObjectives()
			CrowRescueQuest.Stop()
		EndIf
		Self.Stop()
	EndIf
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Event ObjectReference.OnWorkshopNPCTransfer(ObjectReference akSender, Location akNewWorkshop, Keyword akActionKW)
	Actor thisSender = akSender as Actor
	Actor CrowRef = Crow.GetActorRef()
	Actor RavenRef = Raven.GetActorRef()
	Actor MoveMe = None
	If (thisSender == CrowRef)
		MoveMe = RavenRef
	Else
		MoveMe = CrowRef
	EndIf
	workshopscript thisWorkshop = WorkshopParent.GetWorkshopFromLocation(akNewWorkshop)
	If (MoveMe != None && thisWorkshop != None)
		int iWorkshopID = thisWorkshop.GetWorkshopID()
		WorkshopParent.AddPermanentActorToWorkshopPUBLIC(MoveMe, iWorkshopID, True)
		CorvusSettlementLocation.ForceLocationTo(akNewWorkshop)
		CorvusWorkshop.ForceRefTo(thisWorkshop as ObjectReference)
	EndIf
EndEvent

Event Actor.OnDeath(Actor akSender, Actor akKiller)
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnDeath")
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnWorkshopNPCTransfer")
	If (akSender == Crow.GetActorRef())
		Self.SetStage(iStage_CrowDied)
	Else
		Self.SetStage(iStage_RavenDied)
	EndIf
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction
