;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\DarseniaQuest.psc
Modified : 2020-08-05 21:58:54
Compiled : 2021-01-07 11:25:18
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:DarseniaQuest extends Quest

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property Darsenia Auto Const mandatory
	ReferenceAlias Property DeadCourser Auto Const mandatory
	ReferenceAlias Property LivingCourser Auto Const mandatory
	ReferenceAlias Property LivingCourserEnableParent Auto Const mandatory
EndGroup

Group Assets
	Form Property PartsForm Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_AskedForReward = 12 Const
int iStage_LearnedAboutPast = 20 Const
int iObjective_CollectParts = 10 Const
int iStage_Started = 1 Const
int iStage_DeclinesToHelp = 9 Const
int iObjective_ReturnToDarsenia = 20 Const
int iStage_StartupComplete = 2 Const
int iStage_HasSpareParts = 30 Const
int iLastInstalledVersion = 0
int iStage_TurnedInQuest = 40 Const
int iStage_DarseniaDead = 100 Const
int iStage_HasObjective = 15 Const
int iStage_HatesSynths = 7 Const
int iStage_DarseniaMadeSettler = 50 Const
int iTimerID_QuestStartupComplete = 100 Const

;-- Functions ---------------------------------------

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_HatesSynths)
		Darsenia.GetActorRef().StartCombat(PlayerRef, False)
	ElseIf (auiStageID == iStage_HasObjective)
		Self.SetObjectiveDisplayed(iObjective_CollectParts, True, False)
		If (!Self.GetStageDone(iStage_LearnedAboutPast))
			LivingCourserEnableParent.TryToEnable()
		EndIf
	ElseIf (auiStageID == iStage_LearnedAboutPast)
		LivingCourserEnableParent.TryToDisable()
		DeadCourser.TryToEnable()
	ElseIf (auiStageID == iStage_HasSpareParts)
		Self.SetObjectiveCompleted(iObjective_CollectParts, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToDarsenia, True, False)
	ElseIf (auiStageID == iStage_TurnedInQuest)
		Self.SetObjectiveCompleted(iObjective_ReturnToDarsenia, True)
		PlayerRef.RemoveItem(PartsForm, -1, False, None)
		Location ChosenLocation = workshopframework:workshopfunctions.MakePermanentNPCFullSettler(Darsenia.GetActorRef(), True, True, True)
		If (ChosenLocation != None)
			Self.SetStage(iStage_DarseniaMadeSettler)
		EndIf
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.Stop()
	ElseIf (auiStageID == iStage_DarseniaMadeSettler)
		
	ElseIf (auiStageID == iStage_DarseniaDead)
		Self.FailAllObjectives()
	EndIf
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction
