;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\DrMeztliJonesQuest.psc
Modified : 2020-08-05 21:55:21
Compiled : 2021-01-07 11:25:25
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:DrMeztliJonesQuest extends Quest

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property DrMeztliJones Auto Const mandatory
	ReferenceAlias Property OverdueBookEnabler Auto Const mandatory
EndGroup

Group Assets
	Form Property OverdueBook Auto Const mandatory
	Form Property Caps001 Auto Const mandatory
	Outfit Property UnhoodedOutfit Auto Const mandatory
	int Property iCapsPerBook = 50 Auto Const
EndGroup


;-- Variables ---------------------------------------
int iLastInstalledVersion = 0
int iStage_PlayerGivenObjective = 10 Const
int iStage_PlayerTurnedInFirstBooks = 30 Const
int iStage_Started = 1 Const
int iStage_StartupComplete = 2 Const
int iObjective_FindBooks = 10 Const
int iStage_PlayerCompletedQuest = 40 Const
int iTimerID_QuestStartupComplete = 100 Const
int iObjective_ReturnToDrMeztliJones = 20 Const
int iStage_PlayerHasBooks = 20 Const

;-- Functions ---------------------------------------

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Function CashInBooks()
	int iBooks = PlayerRef.GetItemCount(OverdueBook)
	PlayerRef.RemoveItem(OverdueBook, -1, False, None)
	PlayerRef.AddItem(Caps001, iBooks * 50, False)
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_PlayerGivenObjective)
		OverdueBookEnabler.GetRef().Enable(False)
		Self.SetObjectiveDisplayed(iObjective_FindBooks, True, False)
		Self.AddInventoryEventFilter(OverdueBook)
		Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnItemAdded")
		Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnItemRemoved")
		Self.CheckForOverdueBooks()
	ElseIf (auiStageID == iStage_PlayerTurnedInFirstBooks)
		Self.UnregisterForRemoteEvent(PlayerRef as ScriptObject, "OnItemAdded")
		Self.UnregisterForRemoteEvent(PlayerRef as ScriptObject, "OnItemRemoved")
		PlayerRef.RemoveItem(OverdueBook, 5, False, None)
		PlayerRef.AddItem(Caps001, iCapsPerBook * 5, False)
	ElseIf (auiStageID == iStage_PlayerCompletedQuest)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(DrMeztliJones.GetActorRef(), True, True, True)
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.RegisterForRemoteEvent(DrMeztliJones.GetRef() as ScriptObject, "OnUnload")
	EndIf
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event ObjectReference.OnUnload(ObjectReference akSender)
	DrMeztliJones.GetActorRef().SetOutfit(UnhoodedOutfit, False)
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnUnload")
EndEvent

Function CheckForOverdueBooks()
	int iBooks = PlayerRef.GetItemCount(OverdueBook)
	If (iBooks >= 5)
		Self.SetObjectiveCompleted(iObjective_FindBooks, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToDrMeztliJones, True, False)
	Else
		Self.SetObjectiveCompleted(iObjective_FindBooks, False)
		Self.SetObjectiveDisplayed(iObjective_FindBooks, True, False)
		Self.SetObjectiveDisplayed(iObjective_ReturnToDrMeztliJones, False, False)
	EndIf
EndFunction

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event ObjectReference.OnItemRemoved(ObjectReference akSender, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	If (akBaseItem == OverdueBook && !Self.GetStageDone(iStage_PlayerCompletedQuest))
		Self.CheckForOverdueBooks()
	EndIf
EndEvent

Event ObjectReference.OnItemAdded(ObjectReference akSender, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	If (akBaseItem == OverdueBook && !Self.GetStageDone(iStage_PlayerCompletedQuest))
		Self.CheckForOverdueBooks()
	EndIf
EndEvent
