;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\EdRockeQuest.psc
Modified : 2020-09-03 17:53:07
Compiled : 2021-01-07 11:25:25
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:EdRockeQuest extends Quest conditional

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property EdRocke Auto Const mandatory
	ReferenceAlias Property RT Auto Const mandatory
	ReferenceAlias Property EnemyDog Auto Const mandatory
	ReferenceAlias Property EdsBandana Auto Const mandatory
	ReferenceAlias Property DogFightingEnabler Auto Const mandatory
	ReferenceAlias Property OutsideEnemyEnabler Auto Const mandatory
EndGroup

Group Assets
	Idle Property PairedDogmeatHumanGreetHand Auto Const mandatory
	Faction Property ScavengerFaction Auto Const mandatory
	defaultcrowdeventmanager Property LexingtonUndergroundCrowdManager Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iObjective_ReturnToEdRocke = 40 Const
int iTimerID_QuestStartupComplete = 100 Const
int iObjective_SearchForRT = 10 Const
int iObjective_SaveRT = 20 Const
int iLastInstalledVersion = 0
int iStage_RTRescued = 21 Const
int iStage_RTFound = 20 Const
int iStage_RTSniff = 30 Const
int iStage_QuestAccepted = 10 Const
int iStage_UnlockedArenaGate = 22 Const
int iStage_StartupComplete = 2 Const
int iObjective_LetRTSniff = 30 Const
int iStage_QuestComplete = 40 Const
int iStage_Started = 1 Const

;-- Functions ---------------------------------------

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Function TriggerHooliganCombat()
	ScavengerFaction.SetPlayerEnemy(True)
	LexingtonUndergroundCrowdManager.RefCollection.StartCombatAll(PlayerRef)
EndFunction

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event Actor.OnCombatStateChanged(Actor akSender, Actor akTarget, int aeCombatState)
	If (akTarget as ObjectReference == EnemyDog.GetRef())
		Self.SetStage(iStage_UnlockedArenaGate)
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_QuestAccepted)
		OutsideEnemyEnabler.TryToEnable()
		DogFightingEnabler.TryToEnable()
		PlayerRef.AddItem(EdsBandana.GetRef() as Form, 1, False)
		Self.SetObjectiveDisplayed(iObjective_SearchForRT, True, False)
		Self.RegisterForRemoteEvent(RT.GetRef() as ScriptObject, "OnLoad")
	ElseIf (auiStageID == iStage_RTFound)
		Self.SetObjectiveCompleted(iObjective_SearchForRT, True)
		Self.SetObjectiveDisplayed(iObjective_SaveRT, True, True)
		Utility.Wait(3)
		LexingtonUndergroundCrowdManager.CreateCrowdInLoadedArea()
		LexingtonUndergroundCrowdManager.RegisterForOnHitEvents()
		RT.GetActorRef().StartCombat(EnemyDog.GetActorRef(), False)
		Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnCombatStateChanged")
		Self.RegisterForRemoteEvent(EnemyDog.GetActorRef() as ScriptObject, "OnDeath")
	ElseIf (auiStageID == iStage_RTRescued)
		Self.TriggerHooliganCombat()
		Self.SetObjectiveCompleted(iObjective_SaveRT, True)
		Utility.Wait(0.1)
		Self.SetObjectiveDisplayed(iObjective_LetRTSniff, True, True)
		Self.RegisterForRemoteEvent(RT.GetRef() as ScriptObject, "OnActivate")
	ElseIf (auiStageID == iStage_UnlockedArenaGate)
		Self.TriggerHooliganCombat()
	ElseIf (auiStageID == iStage_RTSniff)
		Self.SetObjectiveCompleted(iObjective_LetRTSniff, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToEdRocke, True, False)
	ElseIf (auiStageID == iStage_QuestComplete)
		ScavengerFaction.SetPlayerEnemy(False)
		PlayerRef.RemoveItem(EdsBandana.GetRef() as Form, 1, False, None)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(EdRocke.GetActorRef(), True, True, True)
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.UnregisterForAllEvents()
		Self.Stop()
	EndIf
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event ObjectReference.OnLoad(ObjectReference akSender)
	Self.SetStage(iStage_RTFound)
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnLoad")
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event Actor.OnDeath(Actor akActorRef, Actor akKillerRef)
	Self.SetStage(iStage_RTRescued)
	Self.UnregisterForRemoteEvent(akActorRef as ScriptObject, "OnDeath")
EndEvent

Event ObjectReference.OnActivate(ObjectReference akSender, ObjectReference akActivatedBy)
	If (akActivatedBy == PlayerRef as ObjectReference)
		If (PlayerRef.PlayIdleWithTarget(PairedDogmeatHumanGreetHand, RT.GetActorRef() as ObjectReference))
			
		EndIf
		Self.SetStage(iStage_RTSniff)
		Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnActivate")
	EndIf
EndEvent
