;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\EmilyMarcusQuest.psc
Modified : 2020-05-18 17:20:56
Compiled : 2021-01-07 11:25:30
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:EmilyMarcusQuest extends Quest

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property EmilyMarcus Auto Const mandatory
	RefCollectionAlias Property Enemies Auto Const mandatory
	LocationAlias Property UnclearedDungeon Auto Const mandatory
	LocationAlias Property ActualDungeon Auto Const mandatory
	ReferenceAlias Property DungeonCenter Auto Const mandatory
	ReferenceAlias Property DungeonChest Auto Const mandatory
	ReferenceAlias Property DungeonCaptiveMarker Auto Const mandatory
EndGroup

Group Assets
	LeveledItem Property DickheadReward Auto Const mandatory
	LeveledItem Property NiceguyReward Auto Const mandatory
	ActorBase Property LvlGunner Auto Const mandatory
	Outfit Property MinutemenOutfit Auto Const mandatory
	Weapon Property LaserMusket Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_DeclinedLater = 25 Const
int iStage_TurnedIn = 30 Const
int iObjective_KillGunners = 10 Const
int iLastInstalledVersion = 0
int iStage_Started = 1 Const
int iTimerID_QuestStartupComplete = 100 Const
int iStage_AcceptedQuest = 10 Const
int iObjective_ReturnToEmily = 20 Const
int iStage_PassedCharismaCheck = 9 Const
int iStage_StartupComplete = 2 Const
int iStage_GunnersDead = 20 Const
int iStage_GiveReward = 29 Const
int iTimerID_DoubleCheckDead = 101 Const
int iStage_Shutdown = 40 Const

;-- Functions ---------------------------------------

Event Actor.OnDeath(Actor akSender, Actor akKiller)
	Self.CheckIfAllDead()
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (aiTimerID == iTimerID_DoubleCheckDead)
		Self.CheckIfAllDead()
	EndIf
EndEvent

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Function CheckIfAllDead()
	int I = 0
	bool bAllDead = True
	While (I < Enemies.GetCount() && bAllDead)
		Actor thisActor = Enemies.GetAt(I) as Actor
		If (!thisActor.IsDead() && !thisActor.IsDisabled())
			bAllDead = False
		EndIf
		I += 1
	EndWhile
	If (bAllDead)
		Self.SetStage(iStage_GunnersDead)
	Else
		Self.StartTimer(30, iTimerID_DoubleCheckDead)
	EndIf
EndFunction

Event Location.OnLocationCleared(Location akSender)
	Self.SetStage(iStage_GunnersDead)
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_AcceptedQuest)
		Self.SetObjectiveDisplayed(iObjective_KillGunners, True, False)
		If (UnclearedDungeon.GetLocation() == None || ActualDungeon.GetLocation() != UnclearedDungeon.GetLocation())
			int I = 0
			int iFoundEnemies = Enemies.GetCount()
			ObjectReference[] kSpawnPoints = new ObjectReference[0]
			While (I < iFoundEnemies)
				Actor thisEnemy = Enemies.GetAt(I) as Actor
				If (thisEnemy.IsDead())
					kSpawnPoints.add(thisEnemy as ObjectReference, 1)
				EndIf
				I += 1
			EndWhile
			I = 0
			While (I < kSpawnPoints.length)
				Enemies.RemoveRef(kSpawnPoints[I])
				I += 1
			EndWhile
			ObjectReference kCenterPoint = DungeonCenter.GetRef()
			If (kCenterPoint != None)
				kSpawnPoints.add(kCenterPoint, 1)
			EndIf
			ObjectReference kCaptiveMarker = DungeonCaptiveMarker.GetRef()
			If (kCaptiveMarker != None)
				kSpawnPoints.add(kCaptiveMarker, 1)
			EndIf
			ObjectReference kChestMarker = DungeonChest.GetRef()
			If (kChestMarker != None)
				kSpawnPoints.add(kChestMarker, 1)
				Actor kBoss = kChestMarker.PlaceActorAtMe(LvlGunner, 3, None)
				Self.RegisterForRemoteEvent(kBoss as ScriptObject, "OnDeath")
				Enemies.AddRef(kBoss as ObjectReference)
			EndIf
			I = 0
			While (I < 15)
				ObjectReference kSpawnAt = kSpawnPoints[Utility.RandomInt(0, kSpawnPoints.length - 1)]
				Actor thisActor = kSpawnAt.PlaceActorAtMe(LvlGunner, 4, None)
				Self.RegisterForRemoteEvent(thisActor as ScriptObject, "OnDeath")
				I += 1
			EndWhile
		Else
			Self.RegisterForRemoteEvent(ActualDungeon.GetLocation() as ScriptObject, "OnLocationCleared")
		EndIf
	ElseIf (auiStageID == iStage_GunnersDead)
		Self.SetObjectiveCompleted(iObjective_KillGunners, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToEmily, True, False)
	ElseIf (auiStageID == iStage_GiveReward)
		If (Self.GetStageDone(iStage_PassedCharismaCheck))
			PlayerRef.AddItem(DickheadReward as Form, 1, False)
		Else
			PlayerRef.AddItem(NiceguyReward as Form, 1, False)
		EndIf
	ElseIf (auiStageID == iStage_TurnedIn)
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(EmilyMarcus.GetActorRef(), True, True, True)
	ElseIf (auiStageID == iStage_Shutdown)
		Actor kEmilyRef = EmilyMarcus.GetActorRef()
		kEmilyRef.AddItem(LaserMusket.GetAmmo() as Form, 50, False)
		kEmilyRef.EquipItem(LaserMusket as Form, False, False)
		kEmilyRef.SetOutfit(MinutemenOutfit, False)
		Self.Stop()
	EndIf
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction
