;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\FishFoodQuest.psc
Modified : 2020-11-16 01:14:22
Compiled : 2021-01-07 11:25:34
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:FishFoodQuest extends Quest conditional

;-- Properties --------------------------------------
Group Controllers
	GlobalVariable Property Settings_SimpleObjectives Auto Const
	GlobalVariable Property CurrentVersion Auto Const
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group StoryProperties
	Keyword Property WorkshopAssignHomePermanentActor Auto Const mandatory
	Key Property FishfoodPassword Auto Const mandatory
	Quest Property MQ106 Auto Const mandatory
	Quest Property FishFoodDialogueQuest Auto Const mandatory
	ReferenceAlias Property FishFood Auto Const mandatory
	ReferenceAlias Property Alias_Note Auto Const mandatory
	ReferenceAlias Property Alias_Ghoul01 Auto Const mandatory
	ReferenceAlias Property Alias_Ghoul02 Auto Const mandatory
	ReferenceAlias Property Alias_Ghoul03 Auto Const mandatory
	ReferenceAlias Property Alias_Ghoul04 Auto Const mandatory
	ReferenceAlias Property SaferoomDoor Auto Const mandatory
	ReferenceAlias Property SaferoomTerminal Auto Const mandatory
	ReferenceAlias Property CircuitMaster Auto Const mandatory
	ReferenceAlias Property RelayTower Auto Const mandatory
	ReferenceAlias Property TransmitterSource Auto Const mandatory
	LocationAlias Property MassFusionShedLocation Auto Const mandatory
EndGroup

float Property InstalledVersion = 0 Auto hidden
int Property iInitialStage = 1 AutoReadOnly
int Property iStage_NoteEnabled = 10 AutoReadOnly
int Property iStage_LearnedOfLead = 15 AutoReadOnly
int Property iStage_ReadNote = 20 AutoReadOnly
int Property iStage_DetectedStation = 25 AutoReadOnly
int Property iStage_ListenedToStation = 30 AutoReadOnly
int Property iStage_CloseToStation = 32 AutoReadOnly
int Property iStage_UnlockedDoor = 35 AutoReadOnly
int Property iStage_EnteredSaferoom = 40 AutoReadOnly
int Property iStage_SpokeToFishfood = 50 AutoReadOnly
int Property iStage_TurnedOffTransmitter = 60 AutoReadOnly
int Property iStage_ReturnedToFishFood = 100 AutoReadOnly
int Property iRemoteStage_Recruited = 5 AutoReadOnly
int Property iRemoteStage_Declined = 10 AutoReadOnly
int Property iObjective_ReadNote = 5 AutoReadOnly
int Property iObjective_FindRadioSignal = 10 AutoReadOnly
int Property iObjective_ListenToRadioSignal = 15 AutoReadOnly
int Property iObjective_TrackDownTheSignalSource = 18 AutoReadOnly
int Property iObjective_EnterSafeRoom = 20 AutoReadOnly
int Property iObjective_TalkToFishFood = 30 AutoReadOnly
int Property iObjective_DisableTransmitter = 40 AutoReadOnly
int Property iObjective_ReturnToFishFood = 50 AutoReadOnly

;-- Variables ---------------------------------------
bool bRecentStageChange = False
int iLastStageSet = 0

;-- Functions ---------------------------------------

Event OnTimer(int aiTimerID)
	Self.Stop()
EndEvent

Event ObjectReference.OnPipboyRadioDetection(ObjectReference akSender, bool abDetected)
	If (akSender == TransmitterSource.GetRef())
		Self.SetStage(Self.iStage_DetectedStation)
		Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnPipboyRadioDetection")
	EndIf
EndEvent

Event ObjectReference.OnActivate(ObjectReference akSender, ObjectReference akActivatedBy)
	If (akSender == SaferoomTerminal.GetRef() && akActivatedBy == PlayerRef as ObjectReference)
		If (!SaferoomDoor.GetRef().IsLocked())
			Self.SetStage(Self.iStage_UnlockedDoor)
		Else
			Self.RegisterForMenuOpenCloseEvent("TerminalMenu")
		EndIf
	EndIf
EndEvent

Function Startup()
	If (InstalledVersion * 10000 as float < CurrentVersion.GetValue() * 10000 as float)
		If (InstalledVersion > 0 as float)
			Self.InstallModChanges()
		Else
			InstalledVersion = CurrentVersion.GetValue()
		EndIf
	EndIf
	If (!Self.IsCompleted())
		TransmitterSource.TryToEnable()
	EndIf
EndFunction

Function ConfigureObjectives(bool bSimpleSwap)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (bSimpleSwap)
		
	EndIf
	If (iLastStageSet == Self.iStage_LearnedOfLead)
		Self.SetObjectiveDisplayed(Self.iObjective_ReadNote, True, False)
	ElseIf (iLastStageSet == Self.iStage_ReadNote)
		If (Self.IsObjectiveDisplayed(Self.iObjective_ReadNote))
			Self.SetObjectiveCompleted(Self.iObjective_ReadNote, True)
		EndIf
		Self.SetObjectiveDisplayed(Self.iObjective_FindRadioSignal, True, False)
	ElseIf (iLastStageSet == Self.iStage_DetectedStation)
		If (Self.IsObjectiveDisplayed(Self.iObjective_FindRadioSignal))
			Self.SetObjectiveCompleted(Self.iObjective_FindRadioSignal, True)
		EndIf
		Self.SetObjectiveDisplayed(Self.iObjective_ListenToRadioSignal, True, False)
	ElseIf (iLastStageSet == Self.iStage_ListenedToStation)
		Self.SetObjectiveCompleted(Self.iObjective_ListenToRadioSignal, True)
		If (!Self.GetStageDone(Self.iStage_CloseToStation))
			Self.SetObjectiveDisplayed(Self.iObjective_TrackDownTheSignalSource, True, False)
		Else
			Self.SetObjectiveDisplayed(Self.iObjective_EnterSafeRoom, True, False)
		EndIf
	ElseIf (iLastStageSet == Self.iStage_CloseToStation)
		If (Self.IsObjectiveDisplayed(Self.iObjective_TrackDownTheSignalSource))
			Self.SetObjectiveCompleted(Self.iObjective_TrackDownTheSignalSource, True)
		EndIf
		If (Self.GetStageDone(Self.iStage_ListenedToStation))
			Self.SetObjectiveDisplayed(Self.iObjective_EnterSafeRoom, True, False)
		EndIf
	ElseIf (iLastStageSet == Self.iStage_EnteredSaferoom)
		Self.SetObjectiveCompleted(Self.iObjective_EnterSafeRoom, True)
		Self.SetObjectiveDisplayed(Self.iObjective_TalkToFishFood, True, False)
	ElseIf (iLastStageSet == Self.iStage_SpokeToFishfood)
		Self.SetObjectiveCompleted(Self.iObjective_TalkToFishFood, True)
		Self.SetObjectiveDisplayed(Self.iObjective_DisableTransmitter, True, False)
	ElseIf (iLastStageSet == Self.iStage_TurnedOffTransmitter)
		Self.SetObjectiveCompleted(Self.iObjective_DisableTransmitter, True)
		Self.SetObjectiveDisplayed(Self.iObjective_ReturnToFishFood, True, False)
	EndIf
EndFunction

Event OnDistanceLessThan(ObjectReference akObj1, ObjectReference akObj2, float afDistance)
	If (akObj1 == PlayerRef as ObjectReference || akObj2 == PlayerRef as ObjectReference)
		Self.SetStage(Self.iStage_CloseToStation)
		Self.UnregisterForDistanceEvents(akObj1 as ScriptObject, akObj2 as ScriptObject)
	EndIf
EndEvent

Event OnQuestInit()
	TransmitterSource.TryToEnable()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
	Self.RegisterForRemoteEvent(TransmitterSource.GetRef() as ScriptObject, "OnPipboyRadioDetection")
	Self.Startup()
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (auiStageID >= Self.iInitialStage)
		iLastStageSet = auiStageID
	EndIf
	If (auiStageID == -1)
		If (auiItemID == -3)
			Self.ConfigureObjectives(True)
		ElseIf (auiItemID == -1)
			Self.Startup()
		EndIf
	Else
		bRecentStageChange = True
		Self.UpdateAliases()
		Self.ConfigureObjectives(False)
		Self.HandleStageChanges(auiStageID, auiItemID)
	EndIf
EndEvent

Function HandleShutdown()
	Self.UnregisterForAllEvents()
EndFunction

Function UpdateAliases()
	If (iLastStageSet == Self.iInitialStage)
		
	EndIf
EndFunction

Event OnQuestShutdown()
	Self.HandleShutdown()
EndEvent

Event Actor.OnPlayerLoadGame(Actor akActorRef)
	Self.Startup()
EndEvent

Event ObjectReference.OnLoad(ObjectReference akSender)
	If (akSender == FishFood.GetRef())
		Self.SetStage(Self.iStage_EnteredSaferoom)
		Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnLoad")
	EndIf
EndEvent

Function InstallModChanges()
	InstalledVersion = CurrentVersion.GetValue()
EndFunction

Event Quest.OnStageSet(Quest akSender, int auiStageID, int auiItemID)
	If (akSender == FishFoodDialogueQuest)
		If (!Self.GetStageDone(Self.iStage_ReturnedToFishFood))
			Self.SetStage(Self.iStage_ReturnedToFishFood)
		EndIf
		If (auiStageID == Self.iRemoteStage_Recruited)
			Self.StartTimer(30, 0)
		ElseIf (auiStageID == Self.iRemoteStage_Declined)
			Location ShedLocation = MassFusionShedLocation.GetLocation()
			FishFood.GetRef().SetPersistLoc(ShedLocation)
		EndIf
	EndIf
EndEvent

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
	If (asMenuName == "TerminalMenu")
		If (!SaferoomDoor.GetRef().IsLocked())
			Self.SetStage(Self.iStage_UnlockedDoor)
			Self.UnregisterForRemoteEvent(SaferoomTerminal.GetRef() as ScriptObject, "OnActivate")
			Self.UnregisterForMenuOpenCloseEvent("TerminalMenu")
		EndIf
	EndIf
EndEvent

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == Self.iInitialStage)
		Alias_Note.GetRef().Enable(False)
		Self.SetStage(Self.iStage_NoteEnabled)
	ElseIf (auiStageID == Self.iStage_DetectedStation)
		Self.RegisterForDistanceLessThanEvent(PlayerRef as ScriptObject, TransmitterSource.GetRef() as ScriptObject, 2000)
		Self.RegisterForRemoteEvent(SaferoomTerminal.GetRef() as ScriptObject, "OnActivate")
	ElseIf (auiStageID == Self.iStage_CloseToStation)
		PlayerRef.AddItem(FishfoodPassword as Form, 1, True)
	ElseIf (auiStageID == Self.iStage_UnlockedDoor)
		(RelayTower.GetRef() as relaytowerscript).MoveTower()
		Utility.Wait(3)
		Alias_Ghoul01.GetActorRef().Enable(False)
		Alias_Ghoul02.GetActorRef().Enable(False)
		Alias_Ghoul03.GetActorRef().Enable(False)
		Alias_Ghoul04.GetActorRef().Enable(False)
		Self.RegisterForRemoteEvent(FishFood.GetRef() as ScriptObject, "OnLoad")
	ElseIf (auiStageID == Self.iStage_SpokeToFishfood)
		(CircuitMaster.GetRef() as circuitbreakermasterscript).DenyOnPosition = False
	ElseIf (auiStageID == Self.iStage_TurnedOffTransmitter)
		(RelayTower.GetRef() as relaytowerscript).MoveTower()
		Self.RegisterForRemoteEvent(FishFoodDialogueQuest as ScriptObject, "OnStageSet")
	ElseIf (auiStageID == Self.iStage_ReturnedToFishFood)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(FishFood.GetActorRef(), True, True, True)
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
	EndIf
EndFunction
