;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\FrenchyJrQuest.psc
Modified : 2020-08-05 22:11:25
Compiled : 2021-01-07 11:25:36
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:FrenchyJrQuest extends Quest

;-- Properties --------------------------------------
Group Controllers
	GlobalVariable Property Settings_SimpleObjectives Auto Const
	GlobalVariable Property CurrentVersion Auto Const
	Actor Property PlayerRef Auto Const mandatory
	Quest Property FrenchyDialogueQuest Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property FrenchyJr Auto Const mandatory
	ReferenceAlias Property BlankHolotape Auto Const mandatory
	ReferenceAlias[] Property MagnoliaRecordings Auto Const mandatory
	LocationAlias Property ThirdRailLocation Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property WorkshopAssignHomePermanentActor Auto Const mandatory
EndGroup

Group Messages
	Message Property NotInThirdRail Auto Const mandatory
	Message Property WaitForSongToFinish Auto Const mandatory
EndGroup

Group Scenes
	Scene[] Property MagnoliaSongs Auto Const mandatory
EndGroup

float Property InstalledVersion = 0 Auto hidden
int Property iInitialStage = 1 AutoReadOnly
int Property iStage_PlayerMetFrenchy = 10 AutoReadOnly
int Property iStage_PlayerHasObjective = 15 AutoReadOnly
int Property iStage_StartedRecording = 20 AutoReadOnly
int Property iStage_SongFinished = 25 AutoReadOnly
int Property iStage_TurnedInHolotape = 30 AutoReadOnly
int Property iStage_SentToSettlement = 40 AutoReadOnly
int Property iObjective_RecordMagnolia = 10 AutoReadOnly
int Property iObjective_ReturnToFrenchy = 20 AutoReadOnly
GlobalVariable Property Settings_ShowQuestCredits Auto Const mandatory
int[] Property CreditsObjectiveIDs Auto Const

;-- Variables ---------------------------------------
int iSongSceneFinished = -1
bool bRecentStageChange = False
bool bRecording = False
int iLastStageSet = 0

;-- Functions ---------------------------------------

Function HandleShutdown()
	Self.UnregisterForAllEvents()
EndFunction

Event Actor.OnLocationChange(Actor akSender, Location akOldLoc, Location akNewLoc)
	If (akSender == PlayerRef)
		If (akOldLoc == ThirdRailLocation.GetLocation())
			bRecording = False
		EndIf
	EndIf
EndEvent

Function UpdateAliases()
	If (iLastStageSet == Self.iInitialStage)
		
	EndIf
EndFunction

Event Quest.OnStageSet(Quest akSender, int auiStageID, int auiItemID)
	If (akSender == FrenchyDialogueQuest && auiStageID == 10)
		Self.SetStage(Self.iStage_PlayerHasObjective)
	EndIf
EndEvent

Event Scene.OnPhaseEnd(Scene akSender, int auiPhaseIndex)
	If (auiPhaseIndex == 3 && bRecording && PlayerRef.GetCurrentLocation() == ThirdRailLocation.GetLocation())
		iSongSceneFinished = MagnoliaSongs.find(akSender, 0)
		If (iSongSceneFinished > -1)
			Self.SetStage(Self.iStage_SongFinished)
		EndIf
	EndIf
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
	Self.RegisterForRemoteEvent(FrenchyDialogueQuest as ScriptObject, "OnStageSet")
	Self.Startup()
EndEvent

Function TryToRecord()
	If (PlayerRef.GetCurrentLocation() == ThirdRailLocation.GetLocation())
		bRecording = True
		WaitForSongToFinish.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		Self.SetStage(Self.iStage_StartedRecording)
	Else
		bRecording = False
		NotInThirdRail.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	EndIf
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == Self.iStage_PlayerHasObjective)
		PlayerRef.AddItem(BlankHolotape.GetRef() as Form, 1, False)
	ElseIf (auiStageID == Self.iStage_StartedRecording)
		Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnLocationChange")
		int I = 0
		While (I < MagnoliaSongs.length)
			Self.RegisterForRemoteEvent(MagnoliaSongs[I] as ScriptObject, "OnPhaseEnd")
			I += 1
		EndWhile
	ElseIf (auiStageID == Self.iStage_SongFinished)
		bRecording = False
		PlayerRef.RemoveItem(BlankHolotape.GetRef() as Form, 1, True, None)
		PlayerRef.AddItem(MagnoliaRecordings[iSongSceneFinished].GetRef() as Form, 1, False)
	ElseIf (auiStageID == Self.iStage_TurnedInHolotape)
		int i = 0
		While (i < MagnoliaSongs.length)
			MagnoliaSongs[i].Stop()
			i += 1
		EndWhile
		PlayerRef.RemoveItem(MagnoliaRecordings[iSongSceneFinished].GetRef() as Form, 1, False, None)
		Utility.Wait(1)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(FrenchyJr.GetActorRef(), True, True, True)
		Self.SetStage(Self.iStage_SentToSettlement)
	ElseIf (auiStageID == Self.iStage_SentToSettlement)
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
	EndIf
EndFunction

Event OnQuestShutdown()
	Self.HandleShutdown()
EndEvent

Function CompleteAllObjectives()
	If (Settings_ShowQuestCredits.GetValueInt() == 1)
		int I = 0
		While (I < CreditsObjectiveIDs.length)
			Self.SetObjectiveDisplayed(CreditsObjectiveIDs[I], True, False)
			I += 1
		EndWhile
	EndIf
	Parent.CompleteAllObjectives()
EndFunction

Function InstallModChanges()
	InstalledVersion = CurrentVersion.GetValue()
EndFunction

Function Startup()
	If (InstalledVersion * 10000 as float < CurrentVersion.GetValue() * 10000 as float)
		If (InstalledVersion > 0 as float)
			Self.InstallModChanges()
		Else
			InstalledVersion = CurrentVersion.GetValue()
		EndIf
	EndIf
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (auiStageID >= Self.iInitialStage)
		iLastStageSet = auiStageID
	EndIf
	If (auiStageID == -1)
		If (auiItemID == -3)
			Self.ConfigureObjectives(True)
		ElseIf (auiItemID == -1)
			Self.Startup()
		EndIf
	Else
		bRecentStageChange = True
		Self.UpdateAliases()
		Self.ConfigureObjectives(False)
		Self.HandleStageChanges(auiStageID, auiItemID)
	EndIf
EndEvent

Function ConfigureObjectives(bool bSimpleSwap)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (bSimpleSwap)
		
	EndIf
	If (iLastStageSet == Self.iStage_PlayerHasObjective)
		Self.SetObjectiveDisplayed(Self.iObjective_RecordMagnolia, True, False)
	ElseIf (iLastStageSet == Self.iStage_SongFinished)
		Self.SetObjectiveCompleted(Self.iObjective_RecordMagnolia, True)
		Self.SetObjectiveDisplayed(Self.iObjective_ReturnToFrenchy, True, False)
	ElseIf (iLastStageSet == Self.iStage_TurnedInHolotape)
		Self.SetObjectiveCompleted(Self.iObjective_ReturnToFrenchy, True)
	EndIf
EndFunction

Event Actor.OnPlayerLoadGame(Actor akActorRef)
	Self.Startup()
EndEvent
