;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\IsaiahQuest.psc
Modified : 2020-08-05 21:45:13
Compiled : 2021-01-07 11:25:40
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:IsaiahQuest extends Quest conditional

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property Isaiah Auto Const mandatory
	ReferenceAlias Property Locket Auto Const mandatory
	LocationAlias Property DungeonAlias Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_Started = 1 Const
int iTimerID_QuestStartupComplete = 100 Const
int iStage_StartupComplete = 2 Const
int iStage_MadeSettler = 40 Const
int iStage_DeclinedAsSettler = 41 Const
int iStage_QuestComplete = 50 Const
int iStage_QuestAccepted = 10 Const
int iObjective_ReturnToIsaiah = 30 Const
int iLastInstalledVersion = 0
int iStage_KeepsLocket = 35 Const
int iObjective_AcquireLocket = 20 Const
int iStage_RaidersKilled = 21 Const
int iStage_ReturnsLocket = 34 Const
int iStage_TurnInStarted = 30 Const
int iObjective_KillTheRaiders = 10 Const
int iStage_LocketRecovered = 20 Const

;-- Functions ---------------------------------------

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_QuestAccepted)
		Location DungeonLoc = DungeonAlias.GetLocation()
		If (DungeonLoc.IsCleared())
			DungeonLoc.Reset()
		EndIf
		Self.RegisterForRemoteEvent(DungeonLoc as ScriptObject, "OnLocationCleared")
		Self.SetObjectiveDisplayed(iObjective_KillTheRaiders, True, False)
		Self.SetObjectiveDisplayed(iObjective_AcquireLocket, True, False)
	ElseIf (auiStageID == iStage_LocketRecovered)
		Self.SetObjectiveCompleted(iObjective_AcquireLocket, True)
		If (Self.IsObjectiveCompleted(iObjective_KillTheRaiders))
			Self.SetObjectiveDisplayed(iObjective_ReturnToIsaiah, True, False)
		EndIf
	ElseIf (auiStageID == iStage_RaidersKilled)
		Self.SetObjectiveCompleted(iObjective_KillTheRaiders, True)
		If (Self.IsObjectiveCompleted(iObjective_AcquireLocket))
			Self.SetObjectiveDisplayed(iObjective_ReturnToIsaiah, True, False)
		EndIf
	ElseIf (auiStageID == iStage_ReturnsLocket)
		PlayerRef.RemoveItem(Locket.GetRef() as Form, 1, False, None)
	ElseIf (auiStageID == iStage_MadeSettler)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(Isaiah.GetActorRef(), True, True, True)
		Self.SetStage(iStage_QuestComplete)
	ElseIf (auiStageID == iStage_DeclinedAsSettler)
		Self.SetStage(iStage_QuestComplete)
	ElseIf (auiStageID == iStage_QuestComplete)
		If (Self.GetStageDone(iStage_KeepsLocket) && !Self.GetStageDone(iStage_ReturnsLocket))
			PlayerRef.AddItem(Locket.GetRef().GetBaseObject(), 1, True)
			PlayerRef.RemoveItem(Locket.GetRef() as Form, 1, True, None)
		EndIf
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.UnregisterForAllEvents()
		Self.Stop()
	EndIf
EndEvent

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event Location.OnLocationCleared(Location akSender)
	Self.SetStage(iStage_RaidersKilled)
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnLocationCleared")
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent
