;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\KatherineDrakeCharacterQuest.psc
Modified : 2020-08-05 21:51:29
Compiled : 2021-01-07 11:26:38
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:KatherineDrakeCharacterQuest extends Quest

;-- Properties --------------------------------------
Group Aliases
	ReferenceAlias Property Katherine Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Assets
	Form Property KatherineBuildingPlan Auto Const mandatory
	simsettlementsv2:quests:plotmanager Property PlotManager Auto Const mandatory
	Keyword Property WorkshopItemKeyword Auto Const mandatory
	Keyword Property SS2_PlotSize_2x2 Auto Const mandatory
	Keyword Property SS2_PlotType_Industrial Auto Const mandatory
	workshopparentscript Property WorkshopParent Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_Started = 1 Const
int iObjective_AssignTo2x2Industrial = 10 Const
int iStage_QuestComplete = 40 Const
int iStage_FinishedBuildingWorkshop = 30 Const
int iLastInstalledVersion = 0
simsettlementsv2:objectreferences:simplot kPlotRef
int iObjective_ReturnToKatherine = 30 Const
int iObjective_AwaitBuildingConstruction = 20 Const
int iStage_Accepted = 10 Const
int iStage_StartupComplete = 2 Const
int iTimerID_QuestStartupComplete = 100 Const
int iStage_AssignedToIndustrial2x2 = 20 Const

;-- Functions ---------------------------------------

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event WorkshopParentScript.WorkshopActorAssignedToWork(workshopparentscript akSenderRef, var[] akArgs)
	If (akArgs[2] as Actor == Katherine.GetActorRef())
		Self.CheckForIndustrialPlotAssignment()
	EndIf
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_Accepted)
		Self.SetObjectiveDisplayed(iObjective_AssignTo2x2Industrial, True, False)
		Self.CheckForIndustrialPlotAssignment()
		If (!Self.GetStageDone(iStage_AssignedToIndustrial2x2))
			Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopActorAssignedToWork")
		EndIf
	ElseIf (auiStageID == iStage_AssignedToIndustrial2x2)
		Self.SetObjectiveCompleted(iObjective_AssignTo2x2Industrial, True)
		Self.SetObjectiveDisplayed(iObjective_AwaitBuildingConstruction, True, False)
		simsettlementsv2:weapons:buildingplan CurrentBuildingPlan = kPlotRef.GetParentBuildingPlan()
		If (CurrentBuildingPlan as Form == KatherineBuildingPlan && kPlotRef.iCurrentLevel < 0)
			Self.SetStage(iStage_FinishedBuildingWorkshop)
		Else
			kPlotRef.AssignBuildingPlan(KatherineBuildingPlan as simsettlementsv2:weapons:buildingplan)
			kPlotRef.TryToUnlockLevel(False, False)
			Self.RegisterForCustomEvent(kPlotRef as ScriptObject, "simsettlementsv2:objectreferences:simplot_PlotLevelChanged")
		EndIf
	ElseIf (auiStageID == iStage_FinishedBuildingWorkshop)
		Self.SetObjectiveCompleted(iObjective_AwaitBuildingConstruction, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToKatherine, True, False)
	ElseIf (auiStageID == iStage_QuestComplete)
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.Stop()
	EndIf
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function CheckForIndustrialPlotAssignment()
	workshopnpcscript KatherineRef = Katherine.GetActorRef() as workshopnpcscript
	workshopscript thisWorkshop = KatherineRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	ObjectReference[] kOwnedRefs = thisWorkshop.GetWorkshopOwnedObjects(KatherineRef as Actor)
	bool bIndustrial2x2Owned = False
	int I = 0
	While (I < kOwnedRefs.length && !bIndustrial2x2Owned)
		simsettlementsv2:objectreferences:simplot asPlot = kOwnedRefs[I] as simsettlementsv2:objectreferences:simplot
		If (asPlot)
			simsettlementsv2:miscobjects:plotconfiguration thisPlotconfig = asPlot.GetPlotConfig()
			If (thisPlotconfig as bool && thisPlotconfig.PlotSizeKeyword == SS2_PlotSize_2x2 && thisPlotconfig.PlotTypeKeyword == SS2_PlotType_Industrial)
				bIndustrial2x2Owned = True
				kPlotRef = asPlot
				Self.SetStage(iStage_AssignedToIndustrial2x2)
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction

Event SimSettlementsV2:ObjectReferences:SimPlot.PlotLevelChanged(simsettlementsv2:objectreferences:simplot akPlotRef, var[] akArgs)
	If (akPlotRef.PrimaryOwner == Katherine.GetActorRef() && akPlotRef.GetParentBuildingPlan() == KatherineBuildingPlan as simsettlementsv2:weapons:buildingplan)
		Self.SetStage(iStage_FinishedBuildingWorkshop)
	EndIf
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent
