;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\KatherineDrakeDialogueQuest.psc
Modified : 2020-06-10 10:56:39
Compiled : 2021-01-07 11:26:38
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:KatherineDrakeDialogueQuest extends Quest conditional

;-- Properties --------------------------------------
Group Aliases
	ReferenceAlias Property Katherine Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Assets
	Quest Property CharacterQuest Auto Const mandatory
	Quest Property RadiantQuest Auto Const mandatory
	LeveledItem[] Property QuestRewards Auto Const mandatory
	workshopparentscript Property WorkshopParent Auto Const mandatory
	Form Property KatherineBuildingPlan Auto Const mandatory
	Keyword Property WorkshopItemKeyword Auto Const mandatory
EndGroup

int Property iQuestRewardIndex = 0 Auto conditional hidden
bool Property bEligibleToGiveRadiants = False Auto conditional hidden

;-- Variables ---------------------------------------
int iTimerID_QuestStartupComplete = 100 Const
bool bFirstRadiantGiven = False
int iStage_CharacterQuestAccepted = 30 Const
int iLastInstalledVersion = 0
int iStage_CharacterQuestComplete = 40 Const
int iTimerID_CharacterQuestStartTimer = 101 Const
int iTimerID_RadiantQuestStartTimer = 102 Const
int iStage_Started = 1 Const
int iStage_TriggerRadiant = 60 Const
int iStage_CompleteRadiant = 70 Const
int iStage_RadiantReward = 80 Const
int iStage_JoinedSettlement = 10 Const
int iStage_StartupComplete = 2 Const
int iStage_ReadyForRadiants = 50 Const
int iObjective_TalkToKatherine = 10 Const
int iStage_TimerComplete = 20 Const

;-- Functions ---------------------------------------

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iTimerID_CharacterQuestStartTimer)
		CharacterQuest.Start()
		Self.SetObjectiveDisplayed(iObjective_TalkToKatherine, True, False)
		Self.RegisterForRemoteEvent(CharacterQuest as ScriptObject, "OnStageSet")
	ElseIf (aiTimerID == iTimerID_RadiantQuestStartTimer)
		Self.CheckForKatherinesBuildingPlan()
	EndIf
EndEvent

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event Quest.OnStageSet(Quest akSender, int auiStageID, int auiItemID)
	If (akSender == CharacterQuest)
		If (auiStageID == 5)
			Self.SetObjectiveDisplayed(iObjective_TalkToKatherine, False, False)
		ElseIf (auiStageID == 10)
			Self.SetObjectiveDisplayed(iObjective_TalkToKatherine, False, False)
			Self.SetStage(iStage_CharacterQuestAccepted)
		ElseIf (auiStageID == 40)
			Self.SetStage(iStage_CharacterQuestComplete)
		EndIf
	EndIf
EndEvent

Function CheckForKatherinesBuildingPlan()
	workshopnpcscript KatherineRef = Katherine.GetActorRef() as workshopnpcscript
	workshopscript thisWorkshop = KatherineRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	ObjectReference[] kOwnedRefs = thisWorkshop.GetWorkshopOwnedObjects(KatherineRef as Actor)
	bEligibleToGiveRadiants = False
	int I = 0
	While (I < kOwnedRefs.length && !bEligibleToGiveRadiants)
		simsettlementsv2:objectreferences:simplot asPlot = kOwnedRefs[I] as simsettlementsv2:objectreferences:simplot
		If (asPlot)
			If (asPlot.GetParentBuildingPlan() == KatherineBuildingPlan as simsettlementsv2:weapons:buildingplan)
				bEligibleToGiveRadiants = True
			EndIf
		EndIf
		I += 1
	EndWhile
	If (bEligibleToGiveRadiants)
		Self.UnregisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopActorAssignedToWork")
		If (!bFirstRadiantGiven)
			Self.SetObjectiveDisplayed(iObjective_TalkToKatherine, True, False)
		EndIf
	Else
		Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopActorAssignedToWork")
	EndIf
EndFunction

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event WorkshopParentScript.WorkshopActorAssignedToWork(workshopparentscript akSenderRef, var[] akArgs)
	If (akArgs[2] as Actor == Katherine.GetActorRef())
		Self.CheckForKatherinesBuildingPlan()
	EndIf
EndEvent

Event WorkshopParentScript.WorkshopAddActor(workshopparentscript akSenderRef, var[] akArgs)
	If (akArgs[0] as Actor == Katherine.GetActorRef())
		Self.StartTimerGameTime(48, iTimerID_CharacterQuestStartTimer)
		Self.UnregisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopAddActor")
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_JoinedSettlement)
		Location SettlementLocation = workshopframework:workshopfunctions.MakePermanentNPCFullSettler(Katherine.GetActorRef(), True, True, True)
		If (SettlementLocation == None)
			Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopAddActor")
		Else
			Self.StartTimerGameTime(24, iTimerID_CharacterQuestStartTimer)
		EndIf
	ElseIf (auiStageID == iStage_CharacterQuestComplete)
		Self.StartTimerGameTime(24, iTimerID_RadiantQuestStartTimer)
	ElseIf (auiStageID == iStage_TriggerRadiant)
		RadiantQuest.Start()
		bFirstRadiantGiven = True
		If (Self.IsObjectiveDisplayed(iObjective_TalkToKatherine))
			Self.SetObjectiveDisplayed(iObjective_TalkToKatherine, False, False)
		EndIf
		iQuestRewardIndex = Utility.RandomInt(0, QuestRewards.length - 1)
	ElseIf (auiStageID == iStage_CompleteRadiant)
		RadiantQuest.SetStage(30)
	ElseIf (auiStageID == iStage_RadiantReward)
		PlayerRef.AddItem(QuestRewards[iQuestRewardIndex] as Form, 1, False)
	EndIf
EndEvent
