;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\LaceyBucklesQuest.psc
Modified : 2020-12-08 14:31:11
Compiled : 2021-01-07 11:25:59
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:LaceyBucklesQuest extends Quest

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property LaceyBuckles Auto Const mandatory
	ReferenceAlias Property ButtercupContainer Auto Const mandatory
	ReferenceAlias Property Buttercup Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_StartupComplete = 2 Const
int iLastInstalledVersion = 0
int iObjective_ReturnToLacey = 20 Const
int iStage_QuestComplete = 40 Const
int iStage_PlayerAcceptedQuest = 10 Const
int iStage_PlayerFoundButtercup = 20 Const
int iStage_Started = 1 Const
int iTimerID_QuestStartupComplete = 100 Const
int iStage_PlayerTurnedInQuest = 30 Const
int iObjective_FetchButtercup = 10 Const

;-- Functions ---------------------------------------

Function InstallChanges()
	int iHotfix102eVersion = 18
	If (iLastInstalledVersion < iHotfix102eVersion)
		If (Self.GetStageDone(iStage_PlayerAcceptedQuest) && !Self.GetStageDone(iStage_PlayerFoundButtercup))
			ObjectReference ButtercupContainerRef = Game.GetFormFromFile(53245, "SS2.esm") as ObjectReference
			ButtercupContainerRef.Enable(False)
		EndIf
	EndIf
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_PlayerAcceptedQuest)
		ButtercupContainer.TryToEnable()
		Self.SetObjectiveDisplayed(iObjective_FetchButtercup, True, False)
	ElseIf (auiStageID == iStage_PlayerFoundButtercup)
		Self.SetObjectiveCompleted(iObjective_FetchButtercup, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToLacey, True, False)
	ElseIf (auiStageID == iStage_PlayerTurnedInQuest)
		Self.SetObjectiveCompleted(iObjective_ReturnToLacey, True)
	ElseIf (auiStageID == iStage_QuestComplete)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(LaceyBuckles.GetActorRef(), True, True, True)
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.Stop()
	EndIf
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction
