;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\OM0RQuest.psc
Modified : 2020-08-05 22:10:34
Compiled : 2021-01-07 11:26:12
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:OM0RQuest extends Quest

;-- Properties --------------------------------------
Group Controllers
	GlobalVariable Property Settings_SimpleObjectives Auto Const
	GlobalVariable Property CurrentVersion Auto Const
	Actor Property PlayerRef Auto Const mandatory
	Quest Property OM0RMQ01 Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property OM0R Auto Const mandatory
EndGroup

Group Assets
	Form Property AssaultronCircuitBoard Auto Const mandatory
	Form Property FusionCore Auto Const mandatory
	Form Property Caps001 Auto Const mandatory
EndGroup

float Property InstalledVersion = 0 Auto hidden
int Property iInitialStage = 1 AutoReadOnly
int Property iStage_EarlyPayment = 9 AutoReadOnly
int Property iStage_MQ01Start = 10 AutoReadOnly
int Property iStage_TurnedInItems = 20 AutoReadOnly
int Property iStage_StartTimer = 25 AutoReadOnly
int Property iStage_TimerCompleted = 30 AutoReadOnly
int Property iStage_AnsweredMemoryQuestion = 40 AutoReadOnly
int Property iStage_EraseMemories = 50 AutoReadOnly
int Property iStage_KeepMemories = 51 AutoReadOnly
int Property iStage_MQ01Complete = 100 AutoReadOnly
int Property iStage_Rudeness = 999 AutoReadOnly
int Property iRemoteObjective_BringItems = 10 AutoReadOnly
int Property iRemoteObjective_GiveOM0RTimeToRepair = 20 AutoReadOnly
int Property iRemoteObjective_ReturnToOM0r = 30 AutoReadOnly
GlobalVariable Property Settings_ShowQuestCredits Auto Const mandatory
int[] Property CreditsObjectiveIDs Auto Const

;-- Variables ---------------------------------------
int iSongSceneFinished = -1
int iLastStageSet = 0
bool bRecording = False
bool bRecentStageChange = False

;-- Functions ---------------------------------------

Function HandleShutdown()
	Self.UnregisterForAllEvents()
EndFunction

Event Actor.OnPlayerLoadGame(Actor akActorRef)
	Self.Startup()
EndEvent

Event OnQuestShutdown()
	Self.HandleShutdown()
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
	Self.Startup()
EndEvent

Function CompleteMQ()
	If (Settings_ShowQuestCredits.GetValueInt() == 1)
		int I = 0
		While (I < CreditsObjectiveIDs.length)
			OM0RMQ01.SetObjectiveDisplayed(CreditsObjectiveIDs[I], True, True)
			Utility.Wait(0.1)
			OM0RMQ01.SetObjectiveDisplayed(CreditsObjectiveIDs[I], False, False)
			I += 1
		EndWhile
	EndIf
	OM0RMQ01.CompleteAllObjectives()
	OM0RMQ01.CompleteQuest()
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (auiStageID >= Self.iInitialStage)
		iLastStageSet = auiStageID
	EndIf
	If (auiStageID == -1)
		If (auiItemID == -3)
			Self.ConfigureObjectives(True)
		ElseIf (auiItemID == -1)
			Self.Startup()
		EndIf
	Else
		bRecentStageChange = True
		Self.UpdateAliases()
		Self.ConfigureObjectives(False)
		Self.HandleStageChanges(auiStageID, auiItemID)
	EndIf
EndEvent

Event OnTimerGameTime(int aiTimerID)
	Self.SetStage(Self.iStage_TimerCompleted)
EndEvent

Function ConfigureObjectives(bool bSimpleSwap)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (bSimpleSwap)
		
	EndIf
	If (iLastStageSet == Self.iStage_MQ01Start)
		If (Self.GetStageDone(Self.iStage_EarlyPayment))
			PlayerRef.AddItem(Caps001, 73, False)
		EndIf
		OM0RMQ01.SetObjectiveDisplayed(Self.iRemoteObjective_BringItems, True, False)
	ElseIf (iLastStageSet == Self.iStage_TurnedInItems)
		OM0RMQ01.SetObjectiveCompleted(Self.iRemoteObjective_BringItems, True)
		OM0RMQ01.SetObjectiveDisplayed(Self.iRemoteObjective_GiveOM0RTimeToRepair, True, False)
	ElseIf (iLastStageSet == Self.iStage_TimerCompleted)
		OM0RMQ01.SetObjectiveDisplayed(Self.iRemoteObjective_ReturnToOM0r, True, False)
	ElseIf (iLastStageSet == Self.iStage_AnsweredMemoryQuestion)
		OM0RMQ01.SetObjectiveCompleted(Self.iRemoteObjective_ReturnToOM0r, True)
	EndIf
EndFunction

Function InstallModChanges()
	InstalledVersion = CurrentVersion.GetValue()
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == Self.iInitialStage)
		OM0RMQ01.Start()
	ElseIf (auiStageID == Self.iStage_TurnedInItems)
		PlayerRef.RemoveItem(FusionCore, 1, False, None)
		PlayerRef.RemoveItem(AssaultronCircuitBoard, 1, False, None)
	ElseIf (auiStageID == Self.iStage_StartTimer)
		Self.StartTimerGameTime(24, 0)
	ElseIf (auiStageID == Self.iStage_AnsweredMemoryQuestion)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(OM0R.GetActorRef(), True, True, True)
		Self.CompleteMQ()
	EndIf
EndFunction

Function UpdateAliases()
	If (iLastStageSet == Self.iInitialStage)
		
	EndIf
EndFunction

Function Startup()
	If (InstalledVersion * 10000 as float < CurrentVersion.GetValue() * 10000 as float)
		If (InstalledVersion > 0 as float)
			Self.InstallModChanges()
		Else
			InstalledVersion = CurrentVersion.GetValue()
		EndIf
	EndIf
EndFunction
