;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\RobLambairQuest.psc
Modified : 2020-09-03 17:12:52
Compiled : 2021-01-07 11:26:19
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:RobLambairQuest extends Quest

;-- Properties --------------------------------------
Group Controllers
	GlobalVariable Property Settings_SimpleObjectives Auto Const
	GlobalVariable Property CurrentVersion Auto Const
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property RobLambair Auto Const mandatory
	ReferenceAlias Property BunkerHatch Auto Const mandatory
	ReferenceAlias Property IntercomAlias Auto Const mandatory
	ReferenceAlias Property RadioTransmitter Auto Const mandatory
	ReferenceAlias Property SafeAlias Auto Const mandatory
EndGroup

Group Assets
	Form Property PasswordObject Auto Const mandatory
	LeveledItem Property CapReward Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property WorkshopAssignHomePermanentActor Auto Const mandatory
EndGroup

Group Scenes
	Scene Property RadioSignalScene Auto Const mandatory
	Scene Property IntercomLureScene Auto Const mandatory
	Scene Property IntercomScene Auto Const mandatory
EndGroup

float Property InstalledVersion = 0 Auto hidden
int Property iInitialStage = 1 AutoReadOnly
int Property iStage_RadioStarted = 10 AutoReadOnly
int Property iStage_PlayerTunedIn = 20 AutoReadOnly
int Property iStage_PlayerArrivesInVicinity = 30 AutoReadOnly
int Property iStage_PlayerActivatesIntercom = 40 AutoReadOnly
int Property iStage_FirstDialogueChoiceMade = 50 AutoReadOnly
int Property iStage_PlayerHasGetPasswordObjective = 60 AutoReadOnly
int Property iStage_PlayerCheckedSafe = 65 AutoReadOnly
int Property iStage_PlayerCollectedPassword = 70 AutoReadOnly
int Property iStage_PlayerReturnedToIntercom = 75 AutoReadOnly
int Property iStage_PlayerUnlockedHatch = 80 AutoReadOnly
int Property iStage_CapReward = 85 AutoReadOnly
int Property iStage_PlayerSpokeToRobInBunker = 90 AutoReadOnly
int Property iStage_PlayerAcceptedRobAsSettler = 100 AutoReadOnly
int Property iStage_PlayerDeclinedRobAsSettler = 110 AutoReadOnly
int Property iObjective_TuneIn = 10 AutoReadOnly
int Property iObjective_TrackSignal = 20 AutoReadOnly
int Property iObjective_ActivateIntercom = 30 AutoReadOnly
int Property iObjective_FindPassword = 40 AutoReadOnly
int Property iObjective_SearchForPassword = 45 AutoReadOnly
int Property iObjective_ReturnToIntercom = 50 AutoReadOnly
int Property iObjective_UnlockBunker = 60 AutoReadOnly
int Property iObjective_SpeakToRob = 70 AutoReadOnly

;-- Variables ---------------------------------------
bool bRecentStageChange = False
int iLastStageSet = 0

;-- Functions ---------------------------------------

Function UpdateAliases()
	If (iLastStageSet == Self.iInitialStage)
		
	EndIf
EndFunction

Event ObjectReference.OnActivate(ObjectReference akSender, ObjectReference akActivatedBy)
	If (akSender == IntercomAlias.GetRef())
		Self.SetStage(Self.iStage_PlayerActivatesIntercom)
	EndIf
EndEvent

Function ConfigureObjectives(bool bSimpleSwap)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (bSimpleSwap)
		
	EndIf
	If (iLastStageSet == Self.iStage_RadioStarted)
		Self.SetObjectiveDisplayed(Self.iObjective_TuneIn, True, False)
	ElseIf (iLastStageSet == Self.iStage_PlayerTunedIn)
		Self.SetObjectiveCompleted(Self.iObjective_TuneIn, True)
		Self.SetObjectiveDisplayed(Self.iObjective_TrackSignal, True, False)
	ElseIf (iLastStageSet == Self.iStage_PlayerArrivesInVicinity)
		Self.SetObjectiveCompleted(Self.iObjective_TrackSignal, True)
		Self.SetObjectiveDisplayed(Self.iObjective_ActivateIntercom, True, False)
	ElseIf (iLastStageSet == Self.iStage_PlayerActivatesIntercom)
		If (Self.IsObjectiveDisplayed(Self.iObjective_TuneIn))
			Self.SetObjectiveDisplayed(Self.iObjective_TuneIn, False, False)
		EndIf
		If (Self.IsObjectiveDisplayed(Self.iObjective_TrackSignal))
			Self.SetObjectiveDisplayed(Self.iObjective_TrackSignal, False, False)
		EndIf
	ElseIf (iLastStageSet == Self.iStage_PlayerHasGetPasswordObjective)
		If (Self.IsObjectiveDisplayed(Self.iObjective_ActivateIntercom))
			Self.SetObjectiveCompleted(Self.iObjective_ActivateIntercom, True)
		EndIf
		If (PlayerRef.GetItemCount(PasswordObject) > 0)
			Self.SetObjectiveDisplayed(Self.iObjective_ReturnToIntercom, True, False)
		Else
			Self.SetObjectiveDisplayed(Self.iObjective_FindPassword, True, False)
		EndIf
	ElseIf (iLastStageSet == Self.iStage_PlayerCheckedSafe)
		Self.SetObjectiveCompleted(Self.iObjective_FindPassword, True)
		If (!Self.GetStageDone(Self.iStage_PlayerCollectedPassword))
			Utility.Wait(0.1)
			Self.SetObjectiveDisplayed(Self.iObjective_SearchForPassword, True, True)
		EndIf
	ElseIf (iLastStageSet == Self.iStage_PlayerCollectedPassword)
		Self.SetObjectiveCompleted(Self.iObjective_SearchForPassword, True)
		Self.SetObjectiveCompleted(Self.iObjective_FindPassword, True)
		Self.SetObjectiveDisplayed(Self.iObjective_ReturnToIntercom, True, False)
	ElseIf (iLastStageSet == Self.iStage_PlayerReturnedToIntercom)
		Self.SetObjectiveCompleted(Self.iObjective_ReturnToIntercom, True)
		If (!Self.GetStageDone(Self.iStage_PlayerUnlockedHatch))
			Self.SetObjectiveDisplayed(Self.iObjective_UnlockBunker, True, False)
		EndIf
	ElseIf (iLastStageSet == Self.iStage_PlayerUnlockedHatch)
		If (Self.IsObjectiveDisplayed(Self.iObjective_ReturnToIntercom))
			Self.SetObjectiveDisplayed(Self.iObjective_ReturnToIntercom, False, False)
		EndIf
		Self.SetObjectiveCompleted(Self.iObjective_UnlockBunker, True)
		Self.SetObjectiveDisplayed(Self.iObjective_SpeakToRob, True, False)
	ElseIf (iLastStageSet == Self.iStage_PlayerSpokeToRobInBunker)
		Self.SetObjectiveCompleted(Self.iObjective_SpeakToRob, True)
	EndIf
EndFunction

Event Actor.OnPlayerLoadGame(Actor akActorRef)
	Self.Startup()
EndEvent

Function HandleShutdown()
	Self.UnregisterForAllEvents()
EndFunction

Event ObjectReference.OnItemAdded(ObjectReference akAddedTo, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	If (akAddedTo == PlayerRef as ObjectReference && akBaseItem == PasswordObject)
		Self.UnregisterForRemoteEvent(PlayerRef as ScriptObject, "OnItemAdded")
		Self.SetStage(Self.iStage_PlayerCollectedPassword)
	EndIf
EndEvent

Event OnDistanceLessThan(ObjectReference akObj1, ObjectReference akObj2, float afDistance)
	ObjectReference kIntercomRef = IntercomAlias.GetRef()
	ObjectReference kSafeRef = SafeAlias.GetRef()
	If (akObj1 == kIntercomRef || akObj2 == kIntercomRef)
		Self.SetStage(Self.iStage_PlayerArrivesInVicinity)
		Self.UnregisterForDistanceEvents(akObj1 as ScriptObject, akObj2 as ScriptObject)
	ElseIf (akObj1 == kSafeRef || akObj2 == kSafeRef)
		Self.SetStage(Self.iStage_PlayerCheckedSafe)
		Self.UnregisterForDistanceEvents(akObj1 as ScriptObject, akObj2 as ScriptObject)
	EndIf
EndEvent

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == Self.iStage_PlayerTunedIn)
		Self.RegisterForDistanceLessThanEvent(PlayerRef as ScriptObject, IntercomAlias.GetRef() as ScriptObject, 500)
	ElseIf (auiStageID == Self.iStage_PlayerArrivesInVicinity)
		IntercomLureScene.Start()
	ElseIf (auiStageID == Self.iStage_PlayerActivatesIntercom)
		RadioSignalScene.Stop()
	ElseIf (auiStageID == Self.iStage_PlayerHasGetPasswordObjective)
		If (PlayerRef.GetItemCount(PasswordObject) > 0)
			Self.SetStage(Self.iStage_PlayerCollectedPassword)
		Else
			Self.RegisterForDistanceLessThanEvent(SafeAlias.GetRef() as ScriptObject, PlayerRef as ScriptObject, 100)
			Self.AddInventoryEventFilter(PasswordObject)
			Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnItemAdded")
		EndIf
	ElseIf (auiStageID == Self.iStage_PlayerUnlockedHatch)
		Actor RobLambairRef = RobLambair.GetActorReference()
		RobLambairRef.MoveTo(BunkerHatch.GetRef(), 0, 0, 0, True)
		RobLambairRef.PathToReference(PlayerRef as ObjectReference, 1)
	ElseIf (auiStageID == Self.iStage_CapReward)
		PlayerRef.AddItem(CapReward as Form, 1, False)
	ElseIf (auiStageID == Self.iStage_PlayerSpokeToRobInBunker)
		Utility.Wait(1)
		Location targetLocation = (RobLambair.GetRef() as workshopnpcscript).OpenWorkshopSettlementMenu(WorkshopAssignHomePermanentActor, None, None)
		If (targetLocation != None)
			Self.SetStage(Self.iStage_PlayerAcceptedRobAsSettler)
		Else
			Self.SetStage(Self.iStage_PlayerDeclinedRobAsSettler)
		EndIf
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
	EndIf
EndFunction

Function Startup()
	If (InstalledVersion * 10000 as float < CurrentVersion.GetValue() * 10000 as float)
		If (InstalledVersion > 0 as float)
			Self.InstallModChanges()
		Else
			InstalledVersion = CurrentVersion.GetValue()
		EndIf
	EndIf
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (auiStageID >= Self.iInitialStage)
		iLastStageSet = auiStageID
	EndIf
	If (auiStageID == -1)
		If (auiItemID == -3)
			Self.ConfigureObjectives(True)
		ElseIf (auiItemID == -1)
			Self.Startup()
		EndIf
	Else
		bRecentStageChange = True
		Self.UpdateAliases()
		Self.ConfigureObjectives(False)
		Self.HandleStageChanges(auiStageID, auiItemID)
	EndIf
EndEvent

Function InstallModChanges()
	InstalledVersion = CurrentVersion.GetValue()
EndFunction

Event OnQuestInit()
	Self.RegisterForRemoteEvent(IntercomAlias.GetRef() as ScriptObject, "OnActivate")
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
	Self.Startup()
	RadioTransmitter.TryToEnable()
	RadioSignalScene.Start()
	Self.SetStage(Self.iStage_RadioStarted)
EndEvent
