;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : D:\SteamLibrary\steamapps\common\Fallout 4\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\SS2_Dialogue_MansfieldRadiants.psc
Modified : 2021-01-06 00:30:34
Compiled : 2021-01-09 22:08:27
User     : derek
Computer : DESKTOP-CIN7DKE
/;
ScriptName SimSettlementsV2:CharacterQuests:SS2_Dialogue_MansfieldRadiants extends Quest

;-- Properties --------------------------------------
Group Globals
	GlobalVariable Property PluginVersion Auto Const mandatory
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Quests
	Quest Property Patrol_1 Auto Const mandatory
	Quest Property Patrol_2 Auto Const mandatory
	Quest Property Patrol_3 Auto Const mandatory
	Quest Property YGPest Auto Const mandatory
	Quest Property RDPest Auto Const mandatory
	Quest Property BFPest Auto Const mandatory
	Quest Property DGPest Auto Const mandatory
	Quest Property GLPest Auto Const mandatory
	Quest Property CourierQuest Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_ReturnToMans = 60 Const
int iStage_RadiantReward = 70 Const
int iStage_Pest_RD = 42 Const
int iStage_StartupComplete = 2 Const
int iStage_LoadCourier = 50 Const
int iStage_StartPatrol = 30 Const
int iStage_Pest_BF = 43 Const
int iStage_Pest_DG = 44 Const
int iTimerID_QuestStartupComplete = 100 Const
int iStage_Pest_YG = 41 Const
int iLastInstalledVersion = 0
int iStage_Started = 1 Const
int iStage_Pest_GL = 45 Const
int iStage_StartCourier = 51 Const

;-- Functions ---------------------------------------

Function InstallChanges()
	iLastInstalledVersion = PluginVersion.GetValueInt()
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Function Startup()
	int iPluginVersion = PluginVersion.GetValueInt()
	If (iLastInstalledVersion < iPluginVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iPluginVersion
		EndIf
	EndIf
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	Self.HandleStageChanges(auiStageID, auiItemID)
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		
	ElseIf (auiStageID == iStage_StartPatrol)
		int iRandom = Utility.RandomInt(1, 3)
		If (iRandom == 1)
			Patrol_1.Start()
		ElseIf (iRandom == 2)
			Patrol_2.Start()
		ElseIf (iRandom == 3)
			Patrol_3.Start()
		EndIf
	ElseIf (auiStageID == iStage_Pest_YG)
		YGPest.Start()
	ElseIf (auiStageID == iStage_Pest_RD)
		RDPest.Start()
	ElseIf (auiStageID == iStage_Pest_BF)
		BFPest.Start()
	ElseIf (auiStageID == iStage_Pest_DG)
		DGPest.Start()
	ElseIf (auiStageID == iStage_Pest_GL)
		GLPest.Start()
	ElseIf (auiStageID == iStage_LoadCourier)
		CourierQuest.Start()
	ElseIf (auiStageID == iStage_StartCourier)
		CourierQuest.SetStage(5)
	ElseIf (auiStageID == iStage_ReturnToMans)
		If (Patrol_1.IsRunning())
			Patrol_1.SetStage(25)
		ElseIf (Patrol_2.IsRunning())
			Patrol_2.SetStage(25)
		ElseIf (Patrol_3.IsRunning())
			Patrol_3.SetStage(25)
		EndIf
	ElseIf (auiStageID == iStage_RadiantReward)
		If (CourierQuest.IsRunning())
			CourierQuest.SetStage(20)
		ElseIf (YGPest.IsRunning())
			YGPest.SetStage(20)
		ElseIf (RDPest.IsRunning())
			RDPest.SetStage(20)
		ElseIf (BFPest.IsRunning())
			BFPest.SetStage(20)
		ElseIf (DGPest.IsRunning())
			DGPest.SetStage(20)
		ElseIf (GLPest.IsRunning())
			GLPest.SetStage(20)
		ElseIf (Patrol_1.IsRunning())
			Patrol_1.SetStage(30)
		ElseIf (Patrol_2.IsRunning())
			Patrol_2.SetStage(30)
		ElseIf (Patrol_3.IsRunning())
			Patrol_3.SetStage(30)
		EndIf
		Self.SetStage(20)
	EndIf
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent
