;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\SS2_Radiant_Mansfield_Patrol01.psc
Modified : 2021-01-14 23:15:44
Compiled : 2021-01-14 23:16:46
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:SS2_Radiant_Mansfield_Patrol01 extends Quest

;-- Properties --------------------------------------
Group Globals
	GlobalVariable Property PluginVersion Auto Const mandatory
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
	ReferenceAlias Property Vault81Patrol Auto Const mandatory
	ReferenceAlias Property PatrolBossYaoGuai Auto Const mandatory
	ReferenceAlias Property PatrolBossRaider Auto Const mandatory
	ReferenceAlias Property PatrolRaider01 Auto Const mandatory
	ReferenceAlias Property PatrolRaider02 Auto Const mandatory
	ReferenceAlias Property PatrolBossBloatfly Auto Const mandatory
	ReferenceAlias Property PatrolBloatfly01 Auto Const mandatory
	ReferenceAlias Property PatrolBloatfly02 Auto Const mandatory
	ReferenceAlias Property PatrolBossDog Auto Const mandatory
	ReferenceAlias Property PatrolDog01 Auto Const mandatory
	ReferenceAlias Property PatrolDog02 Auto Const mandatory
	ReferenceAlias Property PatrolBossGhoul Auto Const mandatory
	ReferenceAlias Property PatrolGhoul01 Auto Const mandatory
	ReferenceAlias Property PatrolGhoul02 Auto Const mandatory
	ReferenceAlias Property PatrolSpawn Auto Const mandatory
	ReferenceAlias Property PatrolReward Auto Const mandatory
EndGroup

Group Quests
	Quest Property MansfieldDialogueQuest Auto Const mandatory
	Quest Property PersistentPatrolQuest Auto Const mandatory
EndGroup

Group Assets
	Form Property Caps001 Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iTimerID_ProtectedTimer = 101 Const
int iStage_PatrolReturn = 20 Const
int iStage_Started = 1 Const
int iStage_Pest02Dead = 13 Const
int iStage_AliveCheck = 14 Const
int iStage_DisablePatrol = 25 Const
int iStage_NotProtected = 5 Const
int iStage_TalkToPatrol = 15 Const
int iStage_BossDead = 11 Const
int iStage_Murderer = 17 Const
int iLastInstalledVersion = 0
int iTimerID_QuestStartupComplete = 100 Const
int iStage_PatrolReward = 16 Const
int iStage_CompleteQuest = 30 Const
int iStage_StartupComplete = 2 Const
int iStage_Pest01Dead = 12 Const
int iStage_PatrolFail = 10 Const

;-- Functions ---------------------------------------

Event OnStageSet(int auiStageID, int auiItemID)
	Self.HandleStageChanges(auiStageID, auiItemID)
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

bool Function IsPlayerEngagedWithEnemies()
	bool bEngaged = PlayerRef.GetCombatTarget() as ObjectReference == PatrolBossYaoGuai.GetRef() || PlayerRef.GetCombatTarget() as ObjectReference == PatrolBossRaider.GetRef() || PlayerRef.GetCombatTarget() as ObjectReference == PatrolBossBloatfly.GetRef() || PlayerRef.GetCombatTarget() as ObjectReference == PatrolBossDog.GetRef() || PlayerRef.GetCombatTarget() as ObjectReference == PatrolBossGhoul.GetRef()
	If (bEngaged)
		Self.SetStage(5)
	EndIf
	return bEngaged
EndFunction

Function Startup()
	int iPluginVersion = PluginVersion.GetValueInt()
	If (iLastInstalledVersion < iPluginVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iPluginVersion
		EndIf
	EndIf
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		int iRandom = Utility.RandomInt(1, 5)
		If (iRandom == 1)
			PatrolBossYaoGuai.TryToEnable()
		ElseIf (iRandom == 2)
			PatrolBossRaider.TryToEnable()
			PatrolRaider01.TryToEnable()
			PatrolRaider02.TryToEnable()
		ElseIf (iRandom == 3)
			PatrolBossBloatfly.TryToEnable()
			PatrolBloatfly01.TryToEnable()
			PatrolBloatfly02.TryToEnable()
		ElseIf (iRandom == 4)
			PatrolBossDog.TryToEnable()
			PatrolDog01.TryToEnable()
			PatrolDog02.TryToEnable()
		ElseIf (iRandom == 5)
			PatrolBossGhoul.TryToEnable()
			PatrolGhoul01.TryToEnable()
			PatrolGhoul02.TryToEnable()
		EndIf
		PersistentPatrolQuest.SetStage(10)
		Vault81Patrol.GetActorRef().MoveTo(PatrolSpawn.GetRef(), 0, 0, 0, True)
		Vault81Patrol.TryToEnable()
		Self.SetObjectiveDisplayed(10, True, True)
		Self.RegisterForRemoteEvent(Vault81Patrol.GetActorRef() as ScriptObject, "OnLoad")
	ElseIf (auiStageID == iStage_NotProtected)
		Vault81Patrol.GetActorRef().SetProtected(False)
		Self.SetObjectiveDisplayed(5, True, False)
	ElseIf (auiStageID == iStage_PatrolFail)
		
	ElseIf (auiStageID == iStage_BossDead)
		If (Self.GetStageDone(12) == 1 as bool && Self.GetStageDone(13) == 1 as bool)
			Self.SetStage(14)
		EndIf
	ElseIf (auiStageID == iStage_Pest01Dead)
		If (Self.GetStageDone(11) == 1 as bool && Self.GetStageDone(13) == 1 as bool)
			Self.SetStage(14)
		EndIf
	ElseIf (auiStageID == iStage_Pest02Dead)
		If (Self.GetStageDone(11) == 1 as bool && Self.GetStageDone(12) == 1 as bool)
			Self.SetStage(14)
		EndIf
	ElseIf (auiStageID == iStage_AliveCheck)
		Self.SetObjectiveCompleted(5, True)
		If (Self.GetStageDone(10) == 1 as bool)
			Self.SetObjectiveDisplayed(30, True, True)
		Else
			Self.SetObjectiveCompleted(10, True)
			Self.SetStage(15)
		EndIf
	ElseIf (auiStageID == iStage_TalkToPatrol)
		Self.SetObjectiveDisplayed(20, True, True)
	ElseIf (auiStageID == iStage_PatrolReward)
		PlayerRef.AddItem(PatrolReward.GetRef() as Form, 1, False)
		Self.SetStage(20)
	ElseIf (auiStageID == iStage_Murderer)
		Self.SetObjectiveFailed(20, True)
		Self.SetObjectiveDisplayed(20, False, False)
		Self.SetObjectiveDisplayed(10, True, False)
		Self.SetObjectiveFailed(10, True)
		Self.SetObjectiveDisplayed(10, False, False)
		Self.SetObjectiveDisplayed(30, True, True)
	ElseIf (auiStageID == iStage_PatrolReturn)
		Self.SetObjectiveCompleted(20, True)
		Self.SetObjectiveDisplayed(30, True, True)
	ElseIf (auiStageID == iStage_DisablePatrol)
		Vault81Patrol.TryToDisable()
		PersistentPatrolQuest.Start()
	ElseIf (auiStageID == iStage_CompleteQuest)
		Self.SetObjectiveCompleted(30, True)
		PlayerRef.AddItem(Caps001, 220, False)
		Self.UnregisterForAllEvents()
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.Stop()
	EndIf
EndFunction

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event ObjectReference.OnLoad(ObjectReference akSender)
	Self.StartTimer(2, iTimerID_ProtectedTimer)
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnLoad")
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Function InstallChanges()
	iLastInstalledVersion = PluginVersion.GetValueInt()
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (aiTimerID == iTimerID_ProtectedTimer)
		If (!Self.IsPlayerEngagedWithEnemies())
			Self.StartTimer(2, iTimerID_ProtectedTimer)
		EndIf
	EndIf
EndEvent
