;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\SS2_WC_DeeQuestScript.psc
Modified : 2020-08-05 22:05:50
Compiled : 2021-01-07 11:27:36
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:SS2_WC_DeeQuestScript extends Quest

;-- Properties --------------------------------------
Group Controllers
	GlobalVariable Property Settings_SimpleObjectives Auto Const
	GlobalVariable Property CurrentVersion Auto Const
EndGroup

Group PlotWatch
	Weapon Property ChemicalPlantBuildingPlanForm Auto Const mandatory
	simsettlementsv2:quests:plotmanager Property PlotManager Auto Const mandatory
EndGroup

int Property InstalledVersion = 0 Auto hidden
int Property iInitialStage = 0 AutoReadOnly
int Property iSpawnStage = 10 AutoReadOnly
int Property iFindChemStage = 20 AutoReadOnly
int Property iDeliveredChemStage = 30 AutoReadOnly
int Property iBuildPlotStage = 35 AutoReadOnly
int Property iPlotBuiltStage = 40 AutoReadOnly
int Property iCompleteStage = 50 AutoReadOnly
int Property iFailStage = 100 AutoReadOnly
int Property iFindChemObj = 10 AutoReadOnly
int Property iBuildPlotObj = 20 AutoReadOnly
int Property iTalkObj = 30 AutoReadOnly
ReferenceAlias Property Dee Auto Const
MiscObject Property Caps Auto Const mandatory
Potion Property DaddyO Auto Const mandatory
ReferenceAlias Property DeeVendorChest Auto Const mandatory
LeveledItem Property DaddyOLL Auto Const mandatory

;-- Variables ---------------------------------------
int iLastStageSet = 0

;-- Functions ---------------------------------------

Function Startup()
	If (InstalledVersion < CurrentVersion.GetValueInt())
		If (InstalledVersion > 0)
			Self.InstallModChanges()
		Else
			InstalledVersion = CurrentVersion.GetValueInt()
		EndIf
	EndIf
EndFunction

Function ConfigureObjectives(bool bSimpleSwap)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (bSimpleSwap)
		
	EndIf
	If (iLastStageSet == Self.iInitialStage)
		If (bSimple)
			
		EndIf
	EndIf
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (auiStageID >= Self.iInitialStage)
		iLastStageSet = auiStageID
	EndIf
	If (auiStageID == -1)
		If (auiItemID == -3)
			Self.ConfigureObjectives(True)
		ElseIf (auiItemID == -1)
			Self.Startup()
		EndIf
	Else
		Self.UpdateAliases()
		Self.ConfigureObjectives(False)
		Self.HandleStageChanges(auiStageID, auiItemID)
	EndIf
EndEvent

Event SimSettlementsV2:Quests:PlotManager.PlotLevelChanged(simsettlementsv2:quests:plotmanager akSender, var[] akArgs)
	int iCurrentLevel = akArgs[1] as int
	If (iCurrentLevel > 0)
		simsettlementsv2:weapons:buildinglevelplan thisPlan = akArgs[3] as simsettlementsv2:weapons:buildinglevelplan
		If (thisPlan as bool && thisPlan.ParentBuildingPlan == ChemicalPlantBuildingPlanForm)
			simsettlementsv2:objectreferences:simplot thisPlot = akArgs[0] as simsettlementsv2:objectreferences:simplot
			If (thisPlot)
				If (thisPlot.PrimaryOwner == Dee.GetActorRef())
					Self.SetStage(Self.iPlotBuiltStage)
				EndIf
			EndIf
		EndIf
	EndIf
EndEvent

Function InstallModChanges()
	InstalledVersion = CurrentVersion.GetValueInt()
EndFunction

Event ReferenceAlias.OnDeath(ReferenceAlias akSenderRef, Actor akKiller)
	If (akSenderRef == Dee)
		Self.SetStage(Self.iFailStage)
	EndIf
EndEvent

Function UpdateAliases()
	If (iLastStageSet == Self.iInitialStage)
		
	EndIf
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == Self.iSpawnStage)
		Self.RegisterForRemoteEvent(Dee as ScriptObject, "OnDeath")
	ElseIf (auiStageID == Self.iFindChemStage)
		Self.SetObjectiveDisplayed(Self.iFindChemObj, True, False)
	ElseIf (auiStageID == Self.iDeliveredChemStage)
		Self.SetObjectiveCompleted(Self.iFindChemObj, True)
		Game.GetPlayer().Additem(Caps as Form, 50, False)
		Game.GetPlayer().RemoveItem(DaddyO as Form, 1, False, None)
	ElseIf (auiStageID == Self.iBuildPlotStage)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(Dee.GetActorRef(), True, True, True)
		Self.RegisterForCustomEvent(PlotManager as ScriptObject, "simsettlementsv2:quests:plotmanager_PlotLevelChanged")
		Self.SetObjectiveDisplayed(Self.iBuildPlotObj, True, False)
	ElseIf (auiStageID == Self.iPlotBuiltStage)
		Self.SetObjectiveCompleted(Self.iBuildPlotObj, True)
		Self.SetObjectiveDisplayed(Self.iTalkObj, True, False)
		Self.UnregisterForCustomEvent(PlotManager as ScriptObject, "simsettlementsv2:quests:plotmanager_PlotLevelChanged")
	ElseIf (auiStageID == Self.iCompleteStage)
		Game.GetPlayer().Additem(Caps as Form, 50, False)
		DeeVendorChest.GetReference().Additem(DaddyOLL as Form, 1, False)
		Self.UnregisterForRemoteEvent(Dee.GetActorReference() as ScriptObject, "OnDeath")
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
	ElseIf (auiStageID == Self.iFailStage)
		Self.FailAllObjectives()
		Self.UnregisterForRemoteEvent(Dee.GetActorReference() as ScriptObject, "OnDeath")
	EndIf
EndFunction
