;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\SS2_WC_HesperQuestScript.psc
Modified : 2020-08-05 22:01:42
Compiled : 2021-01-07 11:27:02
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:SS2_WC_HesperQuestScript extends Quest

;-- Properties --------------------------------------
Group Controllers
	GlobalVariable Property Settings_SimpleObjectives Auto Const
	GlobalVariable Property CurrentVersion Auto Const
EndGroup

int Property InstalledVersion = 0 Auto hidden
bool Property bRecentStageChange Auto hidden
int Property StartStage = 10 AutoReadOnly
int Property AcceptedStage = 20 AutoReadOnly
int Property ClearedStage = 30 AutoReadOnly
int Property ReplacedStage = 40 AutoReadOnly
int Property CompletedStage = 50 AutoReadOnly
int Property FailStage = 900 AutoReadOnly
int Property iInitialStage = 0 AutoReadOnly
int Property StartObj = 10 AutoReadOnly
int Property KillObj = 20 AutoReadOnly
int Property FixObj = 30 AutoReadOnly
int Property ReturnObj = 40 AutoReadOnly
ReferenceAlias Property Hesper Auto Const mandatory
ReferenceAlias Property Device Auto Const mandatory
ReferenceAlias Property Boss Auto Const mandatory
Message Property FixedMessage Auto Const mandatory
MiscObject Property Caps001 Auto Const mandatory

;-- Variables ---------------------------------------
int iLastStageSet = 0

;-- Functions ---------------------------------------

Event OnStageSet(int auiStageID, int auiItemID)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (auiStageID >= Self.iInitialStage)
		iLastStageSet = auiStageID
	EndIf
	If (auiStageID == -1)
		If (auiItemID == -3)
			Self.ConfigureObjectives(True)
		ElseIf (auiItemID == -1)
			Self.Startup()
		EndIf
	Else
		bRecentStageChange = True
		Self.UpdateAliases()
		Self.ConfigureObjectives(False)
		Self.HandleStageChanges(auiStageID, auiItemID)
	EndIf
EndEvent

Function UpdateAliases()
	If (iLastStageSet == Self.iInitialStage)
		
	EndIf
EndFunction

Function Startup()
	If (InstalledVersion < CurrentVersion.GetValueInt())
		If (InstalledVersion > 0)
			Self.InstallModChanges()
		Else
			InstalledVersion = CurrentVersion.GetValueInt()
		EndIf
	EndIf
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == Self.StartStage)
		Self.RegisterForRemoteEvent(Hesper.GetActorReference() as ScriptObject, "OnDeath")
	ElseIf (auiStageID == Self.AcceptedStage)
		Self.SetObjectiveDisplayed(Self.KillObj, True, False)
		Device.TryToEnable()
		Boss.TryToEnable()
		Self.RegisterForRemoteEvent(Boss.GetActorReference() as ScriptObject, "OnDeath")
	ElseIf (auiStageID == Self.ClearedStage)
		Self.SetObjectiveCompleted(Self.KillObj, True)
		Self.SetObjectiveDisplayed(Self.FixObj, True, False)
		Self.UnregisterForRemoteEvent(Boss.GetActorReference() as ScriptObject, "OnDeath")
	ElseIf (auiStageID == Self.ReplacedStage)
		FixedMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		Self.SetObjectiveCompleted(Self.FixObj, True)
		Self.SetObjectiveDisplayed(Self.ReturnObj, True, False)
	ElseIf (auiStageID == Self.CompletedStage)
		Game.GetPlayer().AddItem(Caps001 as Form, 100, False)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(Hesper.GetActorRef(), True, True, True)
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
	ElseIf (auiStageID == Self.FailStage)
		Self.FailAllObjectives()
	EndIf
EndFunction

Function ConfigureObjectives(bool bSimpleSwap)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (bSimpleSwap)
		
	EndIf
	If (iLastStageSet == Self.iInitialStage)
		If (bSimple)
			
		EndIf
	EndIf
EndFunction

Function InstallModChanges()
	InstalledVersion = CurrentVersion.GetValueInt()
EndFunction

Event Actor.OnDeath(Actor akSenderRef, Actor akKiller)
	If (akSenderRef == Boss.GetActorReference())
		Self.SetStage(Self.ClearedStage)
	ElseIf (akSenderRef == Hesper.GetActorReference())
		Self.SetStage(Self.FailStage)
	EndIf
EndEvent
