;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\SS2_WC_MontyBrewQuest.psc
Modified : 2021-01-21 17:12:03
Compiled : 2021-01-21 17:12:10
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:SS2_WC_MontyBrewQuest extends Quest conditional

;-- Properties --------------------------------------
Group Controllers
	GlobalVariable Property Settings_SimpleObjectives Auto Const
	GlobalVariable Property CurrentVersion Auto Const
EndGroup

int Property InstalledVersion = 0 Auto hidden
bool Property bRecentStageChange Auto hidden
int Property iInitialStage = 0 AutoReadOnly
int Property RecruitedStage = 5 AutoReadOnly
int Property IntroConvoStartStage = 10 AutoReadOnly
int Property GiveFirstRecipeStage = 12 AutoReadOnly
int Property GoBrewFirstBeerStage = 15 AutoReadOnly
int Property WaitStage = 20 AutoReadOnly
int Property ReadyForRecipeStage = 25 AutoReadOnly
int Property GoBrewStage = 100 AutoReadOnly
int Property ReturnBeerStage = 110 AutoReadOnly
int Property AllBrewedStage = 195 AutoReadOnly
int Property GrapeLineStage = 197 AutoReadOnly
int Property FailCheckStage = 198 AutoReadOnly
int Property PassCheckStage = 199 AutoReadOnly
int Property CompleteStage = 200 AutoReadOnly
int Property SettleInObj = 5 AutoReadOnly
int Property CheckInObj = 10 AutoReadOnly
int Property BrewObj = 15 AutoReadOnly
int Property WaitObj = 20 AutoReadOnly
int Property PickUpRecipeObj = 25 AutoReadOnly
int Property DeliverSampleObj = 30 AutoReadOnly
simsettlementsv2:quests:npc_recruitmentmanager Property NPC_RecruitmentManager Auto Const mandatory
ReferenceAlias Property Monty Auto Const mandatory
ReferenceAlias Property SpawnPoint Auto Const mandatory
ReferenceAlias Property BrewBeerAlias Auto Const mandatory
ObjectReference Property PREF Auto Const mandatory
FormList Property BeerList Auto Const mandatory
FormList Property RecipeList Auto Const mandatory
bool Property ReadyForNewRecipe = False Auto conditional
int Property TurnInBeerNum = 0 Auto conditional
bool Property CanTurnIn = False Auto conditional
int Property FirstWait = 24 AutoReadOnly
int Property RepeatWait = 24 AutoReadOnly
Book Property ABARecipe Auto Const mandatory
Potion Property AtomicBlondeAle Auto Const mandatory
Potion Property RuinedBeer Auto Const mandatory

;-- Variables ---------------------------------------
int iLastStageSet = 0

;-- Functions ---------------------------------------

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == Self.iInitialStage)
		
	ElseIf (auiStageID == Self.RecruitedStage)
		Self.SetObjectiveDisplayed(Self.SettleInObj, True, False)
		Self.StartTimerGameTime(Self.FirstWait as float, 7)
	ElseIf (auiStageID == Self.IntroConvoStartStage)
		Self.SetObjectiveCompleted(Self.SettleInObj, True)
		Self.SetObjectiveDisplayed(Self.CheckInObj, True, True)
	ElseIf (auiStageID == Self.GiveFirstRecipeStage)
		Game.GetPlayer().AddItem(ABARecipe as Form, 1, False)
	ElseIf (auiStageID == Self.GoBrewFirstBeerStage)
		Self.AddInventoryEventFilter(BeerList as Form)
		Self.RegisterForRemoteEvent(PREF as ScriptObject, "OnItemAdded")
		Self.SetObjectiveCompleted(Self.CheckInObj, True)
		BrewBeerAlias.ForceRefTo(SpawnPoint.GetRef().PlaceAtMe(AtomicBlondeAle as Form, 1, False, False, True))
		Self.SetObjectiveDisplayed(Self.BrewObj, True, True)
		TurnInBeerNum = 0
	ElseIf (auiStageID == Self.WaitStage)
		ReadyForNewRecipe = False
		CanTurnIn = False
		Game.GetPlayer().RemoveItem(BeerList.GetAt(TurnInBeerNum), 1, False, None)
		Self.UnregisterForRemoteEvent(PREF as ScriptObject, "OnItemAdded")
		Self.SetObjectiveCompleted(Self.DeliverSampleObj, True)
		Self.SetStage(Self.ReadyForRecipeStage)
	ElseIf (auiStageID == Self.ReadyForRecipeStage)
		ReadyForNewRecipe = True
		CanTurnIn = False
		TurnInBeerNum += 1
		If (TurnInBeerNum >= BeerList.GetSize())
			Self.SetStage(Self.AllBrewedStage)
		Else
			BrewBeerAlias.Clear()
			SpawnPoint.GetRef().Delete()
			SpawnPoint.GetRef().Disable(False)
			BrewBeerAlias.ForceRefTo(SpawnPoint.GetRef().PlaceAtMe(BeerList.GetAt(TurnInBeerNum), 1, False, False, True))
		EndIf
		Self.SetObjectiveDisplayed(Self.PickUpRecipeObj, True, True)
	ElseIf (auiStageID == Self.GoBrewStage)
		ReadyForNewRecipe = False
		CanTurnIn = True
		Game.GetPlayer().AddItem(RecipeList.GetAt(TurnInBeerNum), 1, False)
		Self.SetObjectiveCompleted(Self.PickUpRecipeObj, True)
		Self.SetObjectiveDisplayed(Self.BrewObj, True, True)
		Self.AddInventoryEventFilter(BeerList as Form)
		Self.RegisterForRemoteEvent(PREF as ScriptObject, "OnItemAdded")
	ElseIf (auiStageID == Self.GrapeLineStage)
		Game.GetPlayer().RemoveItem(RuinedBeer as Form, 1, False, None)
	ElseIf (auiStageID == Self.FailCheckStage)
		Self.SetStage(Self.CompleteStage)
	ElseIf (auiStageID == Self.PassCheckStage)
		Self.SetStage(Self.CompleteStage)
	ElseIf (auiStageID == Self.CompleteStage)
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		If (Self.GetStageDone(Self.FailCheckStage))
			Actor kMontyRef = Monty.GetActorRef()
			workshopscript kCurrentWorkshop = kMontyRef.GetLinkedRef(workshopframework:workshopfunctions.GetWorkshopItemKeyword()) as workshopscript
			workshopframework:workshopfunctions.RemoveActorFromWorkshop(kMontyRef, None, False)
			NPC_RecruitmentManager.MakeUniqueVisitor(kMontyRef, kCurrentWorkshop, None)
		EndIf
	EndIf
EndFunction

Event ObjectReference.OnItemAdded(ObjectReference sender, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	If (sender == Game.GetPlayer() as ObjectReference)
		int index = BeerList.Find(akBaseItem)
		If (index >= 0)
			If (index == TurnInBeerNum)
				Self.SetObjectiveCompleted(Self.BrewObj, True)
				Self.SetObjectiveDisplayed(Self.DeliverSampleObj, True, True)
			EndIf
		EndIf
	EndIf
EndEvent

Function ConfigureObjectives(bool bSimpleSwap)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (bSimpleSwap)
		
	EndIf
	If (iLastStageSet == Self.iInitialStage)
		If (bSimple)
			
		EndIf
	EndIf
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (auiStageID >= Self.iInitialStage)
		iLastStageSet = auiStageID
	EndIf
	If (auiStageID == -1)
		If (auiItemID == -3)
			Self.ConfigureObjectives(True)
		ElseIf (auiItemID == -1)
			Self.Startup()
		EndIf
	Else
		bRecentStageChange = True
		Self.UpdateAliases()
		Self.ConfigureObjectives(False)
		Self.HandleStageChanges(auiStageID, auiItemID)
	EndIf
EndEvent

Event OnTimerGameTime(int TimerID)
	If (TimerID == 7)
		Self.SetStage(Self.IntroConvoStartStage)
	ElseIf (TimerID == 9)
		Self.SetStage(Self.ReadyForRecipeStage)
	EndIf
EndEvent

Function InstallModChanges()
	InstalledVersion = CurrentVersion.GetValueInt()
EndFunction

Function UpdateAliases()
	If (iLastStageSet == Self.iInitialStage)
		
	EndIf
EndFunction

Function Startup()
	If (InstalledVersion < CurrentVersion.GetValueInt())
		If (InstalledVersion > 0)
			Self.InstallModChanges()
		Else
			InstalledVersion = CurrentVersion.GetValueInt()
		EndIf
	EndIf
EndFunction
