;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\SneakeQuestScript.psc
Modified : 2020-12-02 01:54:33
Compiled : 2021-01-07 11:27:09
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:SneakeQuestScript extends Quest

;-- Properties --------------------------------------
Group Controllers
	GlobalVariable Property Settings_SimpleObjectives Auto Const
	GlobalVariable Property CurrentVersion Auto Const
	workshopparentscript Property WorkshopParent Auto Const
	simsettlementsv2:quests:settlementmanager Property SettlementManager Auto Const mandatory
EndGroup

Group References
	Actor Property PlayerREF Auto
EndGroup

Group Assets
	ReferenceAlias Property Sneake Auto Const
	Weapon Property Unarmed Auto Const
	Scene Property WinScene Auto Const
	Scene Property CheatScene Auto Const
	Scene Property LoseScene Auto Const
	Scene Property ReturnScene Auto Const
	Scene Property LoseRepeat Auto Const
	Idle Property IdleStop Auto Const mandatory
	Faction Property GenericBrawlFaction Auto Const mandatory
	Weapon Property SneakeLeaderCard Auto Const mandatory
	Message Property SneakeIsStillLeaderMessage Auto Const mandatory
EndGroup

int Property InstalledVersion = 0 Auto hidden
int Property iInitialStage = 0 AutoReadOnly
int Property iIntroStage = 10 AutoReadOnly
int Property iBrawlStage = 20 AutoReadOnly
int Property iLoseStage = 30 AutoReadOnly
int Property iMakeLeaderStage = 35 AutoReadOnly
int Property iCheatStage = 40 AutoReadOnly
int Property iWinStage = 50 AutoReadOnly
int Property iReturnStage = 60 AutoReadOnly
int Property iCleanStage = 1000 AutoReadOnly
int Property iDoneStage = 1100 AutoReadOnly
int Property iTalkObj = 1 AutoReadOnly
int Property iFightObj = 2 AutoReadOnly

;-- Variables ---------------------------------------
int iLastStageSet = 0
int iCurrentStage = 0

;-- Functions ---------------------------------------

Function InstallModChanges()
	InstalledVersion = CurrentVersion.GetValueInt()
EndFunction

Function StopBrawlCombat()
	Actor SneakeRef = Sneake.GetActorRef()
	PlayerREF.StopCombatAlarm()
	SneakeRef.StopCombat()
	SneakeRef.StopCombatAlarm()
	Self.UnregisterForRemoteEvent(SneakeRef as ScriptObject, "OnEnterBleedout")
	Self.UnregisterForRemoteEvent(PlayerREF as ScriptObject, "OnEnterBleedout")
	SneakeRef.RemoveFromFaction(GenericBrawlFaction)
	PlayerREF.RemoveFromFaction(GenericBrawlFaction)
EndFunction

Event SimSettlementsV2:Quests:SettlementManager.LeaderUnassignedFromSettlement(simsettlementsv2:quests:settlementmanager akSender, var[] akArgs)
	If (akArgs[0] as Actor == Sneake.GetActorRef())
		If (!Self.GetStageDone(Self.iWinStage) && !Self.GetStageDone(Self.iCheatStage))
			Utility.Wait(5)
			SneakeIsStillLeaderMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
			Self.SetStage(Self.iMakeLeaderStage)
		EndIf
	EndIf
EndEvent

Event OnHit(ObjectReference akTarget, ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked, string apMaterial)
	If (akProjectile != None && PlayerREF.GetEquippedWeapon(1) != Unarmed && PlayerREF.GetEquippedWeapon(0) != Unarmed)
		Self.StopBrawlCombat()
		Sneake.GetActorReference().SetEssential(False)
		Self.SetStage(Self.iCheatStage)
	Else
		Self.RegisterForHitEvent(akTarget as ScriptObject, PlayerREF as ScriptObject, None, None, -1, -1, -1, -1, True)
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (auiStageID >= Self.iInitialStage)
		iLastStageSet = auiStageID
	EndIf
	If (auiStageID == -1)
		If (auiItemID == -3)
			Self.ConfigureObjectives(True)
		ElseIf (auiItemID == -1)
			Self.Startup()
		EndIf
	Else
		Self.UpdateAliases()
		Self.ConfigureObjectives(False)
		Self.HandleStageChanges(auiStageID, auiItemID)
	EndIf
EndEvent

Event Actor.OnEnterBleedout(Actor akSender)
	Self.StopBrawlCombat()
	Utility.Wait(3 as float)
	Actor SneakeRef = Sneake.GetActorReference()
	If (akSender == SneakeRef)
		Self.SetStage(Self.iWinStage)
	Else
		PlayerREF.PlayIdle(IdleStop)
		PlayerREF.ResetHealthAndLimbs()
		PlayerREF.SetEssential(False)
		SneakeRef.ResetHealthAndLimbs()
		SneakeRef.SetEssential(False)
		Self.SetStage(Self.iLoseStage)
	EndIf
EndEvent

Function Startup()
	If (InstalledVersion < CurrentVersion.GetValueInt())
		If (InstalledVersion > 0)
			Self.InstallModChanges()
		Else
			InstalledVersion = CurrentVersion.GetValueInt()
		EndIf
	EndIf
EndFunction

Function UpdateAliases()
	If (iLastStageSet == Self.iInitialStage)
		
	EndIf
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == Self.iIntroStage)
		
	ElseIf (auiStageID == Self.iBrawlStage || auiStageID == Self.iReturnStage)
		Self.SetObjectiveDisplayed(2, True, True)
		Utility.Wait(1 as float)
		Self.StartBrawl()
	ElseIf (auiStageID == Self.iLoseStage)
		If (Self.GetStageDone(Self.iReturnStage))
			LoseRepeat.ForceStart()
		Else
			LoseScene.ForceStart()
		EndIf
		Self.RegisterForRemoteEvent(ReturnScene as ScriptObject, "OnEnd")
	ElseIf (auiStageID == Self.iMakeLeaderStage)
		SettlementManager.AssignLeader(Sneake.GetActorRef(), workshopframework:wsfw_api.GetNearestWorkshop(Sneake.GetActorRef() as ObjectReference), (SneakeLeaderCard as Form) as simsettlementsv2:weapons:leadercard, True)
		Self.RegisterForCustomEvent(SettlementManager as ScriptObject, "simsettlementsv2:quests:settlementmanager_LeaderUnassignedFromSettlement")
	ElseIf (auiStageID == Self.iCheatStage)
		Self.SetObjectiveFailed(2, True)
		CheatScene.ForceStart()
	ElseIf (auiStageID == Self.iWinStage)
		Self.SetObjectiveCompleted(2, True)
		PlayerREF.SetEssential(False)
		WinScene.ForceStart()
	ElseIf (auiStageID == Self.iCleanStage)
		If (Self.GetStageDone(Self.iWinStage))
			workshopframework:workshopfunctions.MakePermanentNPCFullSettler(Sneake.GetActorRef(), True, True, True)
		EndIf
		Actor SneakeRef = Sneake.GetActorReference()
		SneakeRef.SetNoBleedoutRecovery(False)
		SneakeRef.AllowBleedoutDialogue(False)
		SneakeRef.ResetHealthAndLimbs()
		SneakeRef.SetEssential(False)
		SneakeRef.EvaluatePackage(False)
		PlayerREF.SetEssential(False)
		Self.SetStage(Self.iDoneStage)
		Self.UnregisterForAllEvents()
	ElseIf (auiStageID == Self.iDoneStage)
		If (Self.GetStageDone(Self.iMakeLeaderStage))
			SettlementManager.ClearLeader(workshopframework:wsfw_api.GetNearestWorkshop(Sneake.GetActorRef() as ObjectReference))
		EndIf
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		If (Self.GetStageDone(Self.iCheatStage))
			Self.Stop()
		Else
			Self.CompleteAllObjectives()
			Self.CompleteQuest()
		EndIf
	EndIf
EndFunction

Function StartBrawl()
	Actor SneakeRef = Sneake.GetActorRef()
	SneakeRef.AddToFaction(GenericBrawlFaction)
	PlayerREF.AddToFaction(GenericBrawlFaction)
	Self.RegisterForRemoteEvent(SneakeRef as ScriptObject, "OnEnterBleedout")
	Self.RegisterForRemoteEvent(PlayerREF as ScriptObject, "OnEnterBleedout")
	SneakeRef.SetEssential(True)
	PlayerREF.SetEssential(True)
	SneakeRef.SetNoBleedoutRecovery(True)
	SneakeRef.AllowBleedoutDialogue(True)
	Self.RegisterForHitEvent(SneakeRef as ScriptObject, PlayerREF as ScriptObject, None, None, -1, -1, -1, -1, True)
	PlayerREF.EquipItem(Unarmed as Form, False, True)
	SneakeRef.EquipItem(Unarmed as Form, False, True)
	SneakeRef.StartCombat(PlayerREF, False)
EndFunction

Function ConfigureObjectives(bool bSimpleSwap)
	bool bSimple = False
	If (Settings_SimpleObjectives.GetValue() == 1 as float)
		bSimple = True
	EndIf
	If (bSimpleSwap)
		
	EndIf
	If (iLastStageSet == Self.iInitialStage)
		If (bSimple)
			
		EndIf
	EndIf
EndFunction

Event Scene.OnEnd(Scene akEndedScene)
	Utility.Wait(1 as float)
EndEvent
