;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\CharacterQuests\ViceroyQuest.psc
Modified : 2020-08-05 22:24:37
Compiled : 2021-01-07 11:28:27
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:CharacterQuests:ViceroyQuest extends Quest conditional

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property Viceroy Auto Const mandatory
	ReferenceAlias Property LuckyCoin Auto Const mandatory
	ReferenceAlias Property BountyHunter01 Auto Const mandatory
	ReferenceAlias Property Note Auto Const mandatory
	ReferenceAlias Property HotelDoor Auto Const mandatory
	ReferenceAlias Property HotelMarker Auto Const mandatory
	ReferenceAlias Property BountyHunter02 Auto Const mandatory
	ReferenceAlias Property BountyBot Auto Const mandatory
EndGroup

Group Assets
	Scene Property RobotDeathMarchScene Auto Const mandatory
	Form Property RabbitsFoot Auto Const mandatory
	LeveledItem Property BountyReward Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iTimerID_QuestStartupComplete = 100 Const
int iStage_StartupComplete = 2 Const
int iStage_Started = 1 Const
int iObjective_SearchBody02 = 50 Const
int iStage_DoorUnlocked = 34 Const
int iObjective_TrackCoordinates = 70 Const
int iStage_QuestComplete = 60 Const
int iStage_TurnedInCoin = 45 Const
int iObjective_KillBountyHunter = 10 Const
int iStage_FirstBountyHunterAttack = 10 Const
int iStage_SecondBountyHunterDead = 36 Const
int iObjective_SearchBody01 = 20 Const
int iStage_SecondBountyHunterAttack = 35 Const
int iLastInstalledVersion = 0
int iStage_FirstBountyHunterDead = 20 Const
int iObjective_SearchHotel = 40 Const
int iObjective_ReturnToViceroy = 80 Const
int iObjective_ListenToHolotape = 60 Const
int iStage_ListenedToHolotape = 38 Const
int iStage_RobotOnDeathMarch = 50 Const
int iStage_FoundNote = 21 Const
int iStage_QuestAccepted = 30 Const
int iStage_NoteTurnedIn = 23 Const
int iStage_FoundHolotape = 37 Const
int iObjective_SpeakToViceroy = 30 Const

;-- Functions ---------------------------------------

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event OnDistanceLessThan(ObjectReference akObj1, ObjectReference akObj2, float afDistance)
	If (!Self.GetStageDone(iStage_RobotOnDeathMarch))
		Self.SetStage(iStage_SecondBountyHunterAttack)
	EndIf
	Self.UnregisterForDistanceEvents(akObj1 as ScriptObject, akObj2 as ScriptObject)
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_FirstBountyHunterAttack)
		Actor kBountyHunter = BountyHunter01.GetActorRef()
		simsettlementsv2:utilityfunctions.MoveBehindPlayer(kBountyHunter as ObjectReference, 750)
		kBountyHunter.MoveToNearestNavmeshLocation()
		kBountyHunter.Enable(False)
		kBountyHunter.StartCombat(Viceroy.GetActorRef(), False)
		Self.SetObjectiveDisplayed(iObjective_KillBountyHunter, True, False)
	ElseIf (auiStageID == iStage_FirstBountyHunterDead)
		Self.SetObjectiveCompleted(iObjective_KillBountyHunter, True)
		Self.SetObjectiveDisplayed(iObjective_SearchBody01, True, False)
	ElseIf (auiStageID == iStage_FoundNote)
		Self.SetObjectiveCompleted(iObjective_SearchBody01, True)
		Self.SetObjectiveDisplayed(iObjective_SpeakToViceroy, True, False)
	ElseIf (auiStageID == iStage_NoteTurnedIn)
		PlayerRef.RemoveItem(Note.GetRef() as Form, 1, False, None)
	ElseIf (auiStageID == iStage_QuestAccepted)
		PlayerRef.AddItem(LuckyCoin.GetRef() as Form, 1, False)
		Self.SetObjectiveCompleted(iObjective_SpeakToViceroy, True)
		Self.SetObjectiveDisplayed(iObjective_SearchHotel, True, False)
		BountyBot.TryToEnable()
		HotelDoor.GetRef().SetLockLevel(25)
		HotelDoor.GetRef().Lock(True, False)
		Self.RegisterForDistanceLessThanEvent(HotelMarker.GetRef() as ScriptObject, PlayerRef as ScriptObject, 50)
	ElseIf (auiStageID == iStage_SecondBountyHunterAttack)
		BountyHunter02.TryToEnable()
		BountyHunter02.GetActorRef().StartCombat(PlayerRef, False)
	ElseIf (auiStageID == iStage_SecondBountyHunterDead)
		Self.SetObjectiveCompleted(iObjective_SearchHotel, True)
		Self.SetObjectiveDisplayed(iObjective_SearchBody02, True, False)
	ElseIf (auiStageID == iStage_FoundHolotape)
		Self.SetObjectiveCompleted(iObjective_SearchBody02, True)
		Self.SetObjectiveDisplayed(iObjective_ListenToHolotape, True, False)
	ElseIf (auiStageID == iStage_ListenedToHolotape)
		Self.SetObjectiveCompleted(iObjective_ListenToHolotape, True)
		Self.SetObjectiveDisplayed(iObjective_TrackCoordinates, True, False)
	ElseIf (auiStageID == iStage_TurnedInCoin)
		PlayerRef.RemoveItem(LuckyCoin.GetRef() as Form, 1, False, None)
	ElseIf (auiStageID == iStage_RobotOnDeathMarch)
		PlayerRef.AddItem(BountyReward as Form, 1, False)
		RobotDeathMarchScene.Start()
		Self.SetObjectiveCompleted(iObjective_TrackCoordinates, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToViceroy, True, False)
	ElseIf (auiStageID == iStage_QuestComplete)
		PlayerRef.AddItem(RabbitsFoot, 1, False)
		workshopframework:workshopfunctions.MakePermanentNPCFullSettler(Viceroy.GetActorRef(), True, True, True)
		If ((Self as Quest) as simsettlementsv2:quests:mi:questcredits)
			((Self as Quest) as simsettlementsv2:quests:mi:questcredits).ShowCredits()
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.UnregisterForAllEvents()
		BountyBot.GetActorRef().KillEssential(None)
		Self.Stop()
	EndIf
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent
