;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\DataStructures.psc
Compiled : 2021-04-16 11:26:11
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName simsettlementsv2:datastructures extends ScriptObject Const

;-- Structs -----------------------------------------
Struct BehaviorModifier
	Form RelatedForm02
	float fAmount
	int iModifierType
	Form RelatedForm01
	int iOperatorType
	Keyword TargetKeyword
EndStruct

Struct FactionEmpireDataMap
	Faction FactionForm
	int iDataStoreIndex = -1
EndStruct

Struct SkinItemStruct
	MiscObject StageItemDetails
	{ Holds specifics about the item to be spawned. Must be type SimSettlementsV2:MiscObjects:StageItem }
	int iOwnerNumber = 0
	{ [Optional] If your level plan allows for more than one occupant, you can flag each item to be owned by a specific owner. With 1 being the original occupant, 2 being the 2nd occupant, etc. If you don't set an iOwnerNumber, all items will be given to the first occupant, then if additional occupants move in, the items will be divided between all occupants. This is especially useful if you wanted to have something, for example, like a Commercial Plot, where the first occupant is the shop keeper, and the others are just assistants that don't sell things, but just sweep and do other activities. }
EndStruct

Struct AppliedPlotResource
	int iVirtualResourceHandling = 0
	{ 0 = Not a virtual resource, applies directly to the plot/workshop; 1 = Virtual Resource affecting the value; 2 = Virtual Resource affecting the maximum value only }
	ActorValue ResourceAV
	float fAmount
EndStruct

Struct SalvageReward
	int iBaseCount = 1
	{ Number of RewardForm to provide, assuming no fEncounterLevelMultiplier is set }
	Form RewardForm
	{ Virtual Resource AV or leveled item }
	float fEncounterLevelMultiplier = 0
	{ If set to 0, the Reward will be = to iBaseCount. If > 0, iBaseCount will be multiplied by this and the encounter level. For example, if iBaseCount = 1, Encounter Level = 10, and fEncounterLevelMultiplier = 0.5, 1*10*0.5 = 5. So the reward would include 5 x RewardForm }
	float fSpecialMultiplier01 = 0.05
	Keyword LocTagKeyword
	{ Keyword location must have for this to apply. If None, this will be treated as a backup reward if no other matches are found for a location. }
	simsettlementsv2:miscobjects:usagerequirements UsageRequirements
	{ Specific requirements before this reward is allowed }
	ActorValue SpecialAV01
	{ [Optional] If set, the salvage leader's current stat will be multiplied by fSpecialMultiplier01 and the total item count after encounter level multiplier to create a boost to the reward. }
	Form RewardNameHolder
	{ [Optional] If RewardForm can't be used correctly for displaying a name field, this can be a MiscObject record with the Name field filled out to show the reward contents. }
	int iMinEncounterLevel = 0
	{ Encounter must be of at least this level to provide this reward }
	ActorValue SpecialAV02
	{ [Optional] If set, the salvage leader's current stat will be multiplied by fSpecialMultiplier02 and the total item count after encounter level multiplier to create a boost to the reward. }
	float fSpecialMultiplier02 = 0.05
EndStruct

Struct NonPlotRatings
	ActorValue AVForm
	{ Use the VirtualResource_Daily types for daily costs }
	int iCount
	string WorkshopObjectPlugin
	{ Fill out this and WorkshopObjectFormID; or WorkshopObjectForm, not both. }
	int WorkshopObjectFormID
	{ Fill out this and WorkshopObjectPlugin; or WorkshopObjectForm, not both. }
	string sLabel
	{ [Optional] Used for identifying which item this is when FormID/Plugin are used. }
	Form WorkshopObjectForm
	{ Fill out this; or WorkshopObjectFormID/WorkshopObjectPlugin, not both. }
EndStruct

Struct VirtualResourceGroup
	ActorValue ResourceAV
	float fConversionRate = 1
	{ The rate these are converted to a generic value when we need to do value based conversion. }
	int iType = -1
	{ If -1, this resource will be considered a category only, and therefore will never be set directly by calls to Adjust/Set the virtual resource. }
EndStruct

Struct PlotConsumption
	Form Item
	{ Base inventory object (weapon, armor, miscobject, etc), Keyword, Formlist, or ActorValue (for Virtual Resources - note that generally you should use the SettlementResources field with the VirtualResourceDaily_ types for this sort of resource generation as it will then show up in the HUD ) }
	int iCount = 1
	Form NameHolderForm
	{ [Optional] If the form you used for the "Item" field is a non-simple type (eg. Keyword or Formlist), you can create a MiscObject record with a name that can be displayed in the cost pop-up messages for the plot }
	simsettlementsv2:miscobjects:usagerequirements UsageRequirements
	{ If set, this can establish additional requirements before this resource is used }
	int iLevel = -1
	{ [Optional] The level the plot should be for this to apply, leave -1 to apply to all levels }
	Keyword PullOnlyFromContainerKeyword
	{ [Optional] See the Workshop Framework container system documentation }
	int iOccupantCount = 1
	{ [Optional] The number of settlers that must be occupying the plot before this item is consumed }
EndStruct

Struct VirtualResource
	bool bUsesBaseValueAsCapacity = True
	{ If true, the VirtualResource is treated like a "health bar" in that the base value is the storage cap, and the current value is the available amount. If false, this is treated as a resource with no storage limit and both the current and max value of the resource will be adjusted each time. }
	int iPhysicalExchangeMultiplier = 1
	{ Each physical object will provide 1 point of this virtual resource multiplied by this multiplier. For example, if this value is set to 3, each item will provide 3 points of this resource }
	Form NameHolder
	{ An object with the name field set to what this component should be called when presenting costs in word format. }
	bool bWorkshopRating = False
	{ [Advanced] If true, this RatingResourceForm will be checked on the workshop reference itself. If false, it will be checked on the data store instead. }
	ActorValue RatingResourceForm
	{ Determines daily production/consumption }
	Form PhysicalEquivalent
	{ Physical object in the game world that can be exchanged for this resource. This can be an item, a keyword, or a formlist of eligible items (do NOT use leveled items). Leave blank if no physical equivalent exists. }
	ActorValue VirtualResourceForm
	{ Determines current stored amount and capacity }
EndStruct

Struct FanfareMessage
	Message Message02
	{ Optional }
	Message Message01
	string sIdentifier
	{ Used as a lookup so we can have meaningful names in our scripts without a bunch of duplicate properties. }
	bool bOneTime = False
	{ If true, this message will only ever show one time }
	Message Message04
	{ Optional }
	Sound SoundToPlay
	{ Optional }
	Message Message03
	{ Optional }
	int iMessageType = 0
	{ Typify the message so players can suspend them by type. 1 = Tutorial }
EndStruct

Struct CityPlanLayoutPairingData
	int iPreviousLayoutIndex = -1
	{ Corresponding index in the layout this object last existed }
	int iLayoutGroupType = 1
	{ The object group type these correspond to. At the time of this implementation, 1 = workshop resource, 2 = non-resources; additional options may be added in the future. }
	int iNewLayoutIndex = -1
	{ Corresponding index in the layout this object should get its new positional data from }
EndStruct

Struct VirtualResourceCategoryMap
	ActorValue ResourceAV
	int iCategoryIndex = -1
	{ Index in the VirtualResourceCategories property this resource is grouped with. Leave as -1 for category types. }
	float fConversionRate = 1
	{ The rate these are converted to a generic value when we need to do value based conversion. }
EndStruct

Struct StageItemStruct
	int iStageEnd = -1
	{ [Optional] Last stage this item should exist - after this it will be removed. If left blank, this will last exactly one stage. }
	int iOwnerNumber = 0
	{ [Optional] If your level plan allows for more than one occupant, you can flag each item to be owned by a specific owner. With 1 being the original occupant, 2 being the 2nd occupant, etc. If you don't set an iOwnerNumber, all items will be given to the first occupant, then if additional occupants move in, the items will be divided between all occupants. This is especially useful if you wanted to have something, for example, like a Commercial Plot, where the first occupant is the shop keeper, and the others are just assistants that don't sell things, but just sweep and do other activities. }
	string sLabel
	{ [Optional] For your personal use to keep the items organized }
	MiscObject StageItemDetails
	{ Holds specifics about the item to be spawned. Must be type SimSettlementsV2:MiscObjects:StageItem }
	int iStageNum = -1
	{ [Optional] Stage number this should be spawned during. If left blank, this will spawn on the last stage of the current level. }
EndStruct

Struct StageModelOverride
	int iLevel
	Form ModelForm
EndStruct

Struct TransactionItem
	Form Item
	int iCount
	Keyword ContainerKeyword
EndStruct

Struct FactionDataStoreMap
	Faction FactionForm
	int iDataStoreIndex = -1
EndStruct

Struct StatTraining
	ActorValue TrainingProgressAV
	Keyword IsTrainingKeyword
	Keyword BuildingPlanClassKeyword
	ActorValue StatAV
	ActorValue TrainingTimestampAV
EndStruct

Struct AddonPackRemoveEntries
	float fVersionRemoved
	FormList RemoveList
	{ A formlist starting with a target keyword identifying the list you're attempting to remove entries from, followed with the entries you want to remove. Note: This is designed for removing things from your addon you no longer want to register with SS, not things from SS itself. }
EndStruct

Struct OutfitMap
	Outfit OutfitForm
	Faction FactionForm
	Race RaceForm
	{ Race these clothes work on }
	int iFactionRank = 0
EndStruct

Struct ComponentMap
	component ComponentForm
	MiscObject MiscObjectForm
EndStruct

Struct AddonPackEdit
	int iEntries
	FormList EditedList
EndStruct

Struct HotSwapOMOD
	Form TargetEquipmentForm
	objectmod ModBForm
	string sHotswapID = ""
	{ Used for the outfit manager script to handle specific conditions }
	objectmod ModAForm
EndStruct

Struct Disease
	Potion Cure
	Message Name
	GlobalVariable gVaccineDiscovered
	GlobalVariable gCureDiscovered
	GlobalVariable gDeadCounter
	int iSeverity
	Message Description
	int iTransmissionRate
	GlobalVariable gInfectedCounter
	GlobalVariable gInfoDiscovered
	Keyword ImmunityKeyword
	Spell DiseaseSpell
EndStruct

Struct NPCPreferenceMap
	Actor kActorRef
	simsettlementsv2:miscobjects:npcpreferences PreferenceForm
EndStruct

Struct ActorBaseChance
	float fChance
	ActorBase ActorBaseForm
EndStruct

Struct PlotDefaultSelections
	Form Foundation
	{ Must be of type SimSettlementsV2:MiscObjects:Foundation }
	Form PowerPole
	{ Must be of type SimSettlementsV2:MiscObjects:PowerPole }
	Form PlotForm
EndStruct

Struct LevelAVChange
	float AVValue = 0
	ActorValue AVToChange
	int iLevel = 0
EndStruct

Struct VirtualResourceCategory
	ActorValue ResourceAV
	int iParentCategoryIndex = -1
	{ If this is not a top level category, set it to the index of the parent category in the VirtualResourceCategories property }
EndStruct

Struct FactionRankMessageMap
	Faction FactionForm
	int iFactionRank = 0
	Message MessageForm
EndStruct

Struct SalvageTeamRun
	Actor CaravaneerRef
	bool bDropOffIsDonation = False
	simsettlementsv2:objectreferences:simplot CaravanServicesPlot
	float fCalculatedTravelTime_Pickup
	float fCalculatedTravelTime_ReturnHome
	ObjectReference FauxBeaconRef
	Actor PackAnimalRef
	int iTimerID
	int iRunType
	ObjectReference OriginalBeaconRef
	float fCalculatedTravelTime_Dropoff
	ObjectReference DropoffPointRef
	workshopscript OriginWorkshopRef
	ObjectReference ProtectedContainerRef
	ObjectReference ActualContainerRef
	ObjectReference PickupPointRef
	int iCurrentStage = 0
EndStruct

Struct SceneWorldObject
	float fPosY = 0
	bool bForceStatic = False
	int iFormID = -1
	{ Decimal conversion of the last 6 digits of a forms Hex ID. [Optional] Either this + sPluginName, or ObjectForm have to be set. }
	float fAngleY = 0
	float fExtraDataFlag = 0
	{ Special field different systems can use however they need }
	string sPluginName = ""
	{ Exact file name the form is from (ex. Fallout.esm). [Optional] Either this + iFormID, or ObjectForm have to be set. }
	float fScale = 1
	float fAngleZ = 0
	float fPosZ = 0
	ReferenceAlias TargetAlias
	Form ObjectForm
	{ Form to be created. [Optional] Either this, or iFormID + sPluginName have to be set. }
	float fAngleX = 0
	float fPosX = 0
EndStruct

Struct ResourceMessageItem
	float fCount
	{ Number of this object }
	Form NameHolderForm
	{ Form with name of object that can be temporarily spawned to show name. Or if an ObjectReference, it's exact name will be used }
	Form TargetNameHolderForm
	{ [Optional] Some resource messages take an additional alias to display more information }
	float fColorValue = 99
	{ 0 to 99 - will change the coloration of the number that is displayed. }
EndStruct

Struct SoftDependency
	FormList DependentList
	string sPlugin
EndStruct

Struct CityPlanLayoutPlotLevelData
	int iLayoutIndex = -1
	{ Corresponding index in the layout }
	int iLevel = -2
	{ -2 = don't change level, -1 = max level, 0+ = set specific level }
EndStruct

Struct AVBasedConsumption
	ActorValue ActorValueForm
	bool bIsComponentFormList = False
	Keyword SearchContainerKeyword
	Form ConsumeForm
EndStruct

Struct RaceModifier
	int iMax_Agility = -1
	int iMax_Luck = -1
	int iMax_Intelligence = -1
	Race RaceForm
	int iMin_Strength = 1
	int iMin_Charisma = 1
	int iMin_Endurance = 1
	int iMax_Strength = -1
	int iMax_Endurance = -1
	int iMin_Luck = 1
	int iMin_Agility = 1
	int iMin_Intelligence = 1
	int iMax_Charisma = -1
	int iMax_Perception = -1
	int iMin_Perception = 1
EndStruct

Struct CinematicCircleData
	float fOverrideTangentMagnitude
	int iChangeToAfterLoopCount
	float fOverrideSpeed
	float fDistance
	float fHeight
EndStruct

Struct WorkshopCaravanData
	workshopscript akWorkshopRef
	simsettlementsv2:objectreferences:simplot akPlotRef
	Actor akActorRef
EndStruct

Struct ItemCount
	Form Item
	{ Keyword (will use any item with the keyword), Formlist (will use any item in the formlist), inventory object (weapon, armor, miscobject, etc), ActorValue will be applied considered a Virtual Resource cost }
	int iCount = 1
EndStruct

Struct ResourceNetwork
	int iCaravanNetwork = -1
	int iPowerNetwork = -1
	int iCommunicationsNetwork = -1
	int iDefenseNetwork = -1
EndStruct

Struct ProductionItem
	Form Item
	{ Virtual Resource Actor Value, Base inventory object (weapon, armor, miscobject, etc), or Formlist of items. LeveledItems technically work, but should NOT be used if using the sTargetVendorType field to point your production at one of the shop types, which is the preferred way to handle item production in SS2. }
	int iCount = 1
	{ To have this value automatically calculated based on the value of the Item specifie, and the Operating Costs of the plot, set this to -1. }
	Keyword TargetContainerKeyword
	{ [Optional] See the Workshop Framework container system documentation }
	string sTargetVendorType = ""
	{ [Optional] If this is filled out, this production will be injected into each settlement vendor's inventory with matching sTargetVendorType and iTargetVendorLevel. Vanilla vendor types just enter the number: 0 = General Store, 1 = Armor, 2 = Weapons, 3 = Bar, 4 = Clinic, 5 = Clothing. Sim Settlement vendor types: SSBookStore, SSFurnitureStore, SSPetStore, SSPowerArmorStore, SSBarber }
	int iTargetVendorLevel = 0
	{ [Optional] If sTargetVendorType is filled out, this production will be injected into each settlement vendor's inventory with matching sTargetVendorType and iTargetVendorLevel. 0 = Level 1 shop, 1 = Level 2 shop, 2 = Level 3 shop }
EndStruct

Struct FormlistInjection
	Form FormToInject
	Keyword TargetFormlistKeyword
	{ Use this or the TargetFormlist, not both }
	FormList TargetFormlist
	{ Use this or the TargetFormlistKeyword, not both }
EndStruct

Struct LookupForm
	Form LookupForm
	string sLookupString
EndStruct

Struct BuildingPlanListMap
	FormList SkinList
	{ The formlist used by the PlotConfig to determine which skins are for which }
	FormList UnlockableList
	{ The formlist to hold unlockable plans so we don't have to constantly test them like we do for building plans with UsageRequirements }
	FormList PlanList
	{ The formlist used by the PlotConfig to determine which building plans a plot should use }
EndStruct

Struct LevelKeywordChange
	Keyword KeywordToAdd
	int iLevel = 0
	int iRemoveLevel = 0
EndStruct

Struct NonPlotRatingsToWorkshopRatingMap
	ActorValue AVForm
	{ Use the VirtualResource_Daily types for daily costs }
	ActorValue WorkshopRatingAVForm
	{ The AV we'll check items for to see if this applied }
	float fMultiplier = 1
	{ Amount of this AV to multiply the WorkshopRatingAVForm value of the object }
EndStruct

Struct HUDIconMap
	int iIconID
	ActorValue AVForm
	{ Corresponding AV }
	string sLookupString
	{ String to reference this by for non AV related icons }
EndStruct

Struct ThemeRuleSetActiveDefinitionMap
	simsettlementsv2:miscobjects:themeruleset RuleSet
	simsettlementsv2:armors:themedefinition Definition
EndStruct

Struct CameraModeMusicData
	Sound TrackSound
	float fTrackLength
EndStruct

Struct FormlistKeywordMap
	FormList TargetFormlist
	Keyword IdentifierKeyword
EndStruct

Struct NPCClass
	LocationRefType ClassRefType
	Keyword ClassKeyword
	ReferenceAlias ClassName
EndStruct

Struct WeightedSound
	Sound SoundToPlay
	int Weight
EndStruct

Struct PlotCount
	Keyword PlotType
	int iL2Count = 0
	int iL1Count = 0
	int iL0Count = 0
	int iL3Count = 0
	Keyword BuildingClass
EndStruct

Struct IndexedFormList
	FormList IndexedList
	int iListIndex = -1
EndStruct

Struct WorldspaceMarker
	ObjectReference kMarkerRef
	WorldSpace MarkerWorldspace
EndStruct

Struct KeywordDensity
	Keyword KeywordToCheck
	float fDensity
EndStruct

Struct PlotTypeMap
	MiscObject PlotConfig
	{ Must be of type SimSettlementsV2:MiscObjects:PlotConfiguration }
	GlobalVariable gPlansAvailable
EndStruct

Struct UpdateAlias
	ObjectReference kReference
	{ Use this if persistence is not an issue [Use this or iReferenceFormID/sReferencePlugin, not both!] }
	ReferenceAlias TargetAlias
	{ The alias to fill }
	int iReferenceFormID
	{ Use this plus sReferencePlugin if you want to avoid persistence or if you are loading from an external plugin [Use this or kReference, not both!] }
	string sReferencePlugin
	{ Use this plus iReferenceFormID if you want to avoid persistence or if you are loading from an external plugin [Use this or kReference, not both!] }
EndStruct

Struct BuildingPlanFirstLocationTracking
	Quest QuestToSetStage
	{ Quest to trigger stage }
	LocationAlias FirstLocationAlias
	{ LocationAlias to put the location of the plot in }
	int iStageNum
	{ Stage to set on QuestToSetStage }
	Form BuildingPlan
	{ Building plan to monitor for }
EndStruct

Struct CustomVendorData
	Faction CustomVendorFaction
	{ [Optional] NOT FOR USE LIKE TYPICAL VENDOR FACTIONS! Workshop vendor factions work much differently than other types, so this should NOT be a faction with a vendor container. Instead, this should be used to offer new dialogue options to the assigned settler of this type. If left blank, WorkshopParent will default to using WorkshopVendorFactionMisc. }
	string sCustomVendorID
	{ Used on the sCustomVendorID field of your shop furniture markers' WorkshopObjectScript }
	FormList CustomVendorInventoryFormlist
	{ Should have 3 Container entries with the corresponding inventory for that shop level. Note that each level is added to the previous. So that L2 shop keepers also have access to L1 inventory containers, and the same for L3 having access to both L2 and L1. }
	Keyword CustomVendorKeyword
	{ Required for SS2 to detect your vendor type. }
EndStruct

Struct AVBasedProduction
	LeveledItem ProduceForm
	Keyword TargetContainerKeyword
	ActorValue ActorValueForm
EndStruct

Struct WorkshopEmpireDataMap
	workshopscript kWorkshopRef
	int iDataStoreIndex = -1
EndStruct

Struct CityPlanCostMultiplier
	Form Item
	{ Cost to be applied }
	int iCount
	{ Amount of cost form to be applied }
	Form NameHolderForm
	{ [Optional] If the form you used for the "Item" field is a non-simple type (eg. Keyword or Formlist), you can create a MiscObject record with a name that can be displayed in the cost pop-up messages }
	int iLevel = -1
	{ Level of CityPlan for this to count. -1 for all levels. }
	Keyword RequiredKeyword
	{ Only if item has this Keyword will this be applied. Leave blank to apply to all items. }
EndStruct

Struct PlotTypeBuildingClassMap
	Keyword ClassKeyword
	Keyword PlotTypeKeyword
EndStruct

Struct PlotSubClass
	Form BuildingClassForm
	{ Must be of type SimSettlementsV2:Armors:BuildingClass }
	Keyword ClassKeyword
	{ Building plan class keyword }
	Keyword PlotTypeKeyword
	{ The plot type this class belongs to }
EndStruct

Struct LocationDataStoreMap
	Location kLocationRef
	int iDataStoreIndex = -1
EndStruct

Struct CachedList
	bool bUpdateInProgress
	FormList ListNoRequirements
	ObjectReference kListContainerRef
	FormList OriginalList
	int iRequirementsListIndex
	int iListIndex
	FormList ListWithRequirements
EndStruct

Struct WorkshopDataStoreMap
	workshopscript kWorkshopRef
	int iDataStoreIndex = -1
EndStruct

Struct PlotPlanSet
	simsettlementsv2:weapons:buildingplan Plan
	simsettlementsv2:weapons:buildinglevelskin LevelSkin
	simsettlementsv2:weapons:buildinglevelplan Level
	simsettlementsv2:weapons:buildingskin Skin
EndStruct

Struct PlotLocRefType
	Keyword ClassKeyword
	{ Building plan class keyword }
	LocationRefType PlotLocRefType
	{ Corresponding LocationRefType for this plot type }
EndStruct

Struct HUDResource
	ActorValue AVForm
	{ The resource we're pulling }
	int iMinComplexity = 1
	{ If the complexity setting is less than this, the resource will be skipped }
	int iResourceID
	{ Resource index as defined in the flash source SS2HUD.as in the function ConfigureVariableMaps. }
	bool bGetNetwork = False
	{ If true, this will get the network's value instead of the local }
	bool bGetMax = False
	{ If true, this will get the max value instead of the current value }
	bool bWorkshopRating = False
	{ If true, this will check the workshop instead of the data store for this value }
EndStruct

Struct ResourceNetworkForms
	LocationRefType L2RefType
	Keyword NetworkKeyword
	GlobalVariable gInterWorldspaceUnlock
	{ TODO: Introduce tech unlock to expand this }
	LocationRefType L3RefType
	GlobalVariable gSameWorldspaceDistanceMax
	{ TODO: Introduce tech unlock to expand this }
	LocationRefType L1RefType
EndStruct

Struct AVToInventoryFormMap
	ActorValue AVForm
	Form InventoryItem
	{ Intventory item that represents this actor value. }
	float fMultiplier = 1
	{ The amount of AVForm will be multiplied by this to determine the number of InventoryItem this is worth. }
EndStruct

Struct LocationEmpireDataMap
	Location kLocationRef
	int iDataStoreIndex = -1
EndStruct

Struct ResourceNetworkSpecialStatusMap
	Keyword NetworkKeyword
	Keyword PlotSubTypeKeyword
	Form NoneWithinDistanceNameHolderForm
EndStruct

Struct PlotSpecialStatAdjustment
	Keyword BuildingClassKeyword
	int iVirtualResourceHandling = 0
	{ 0 = Not a virtual resource, applies directly to the plot/workshop; 1 = Virtual Resource affecting the value; 2 = Virtual Resource affecting the maximum value only }
	ActorValue ResourceAV
	float fStatToResourceConversionMultiplier = 1
	ActorValue SpecialStatAV
EndStruct

Struct PlotResource
	int iVirtualResourceHandling = 0
	{ 0 = Not a virtual resource, applies directly to the plot/workshop; 1 = Virtual Resource affecting the value; 2 = Virtual Resource affecting the maximum value only }
	ActorValue ResourceAV
	float fAmount = 0
	int iLevel = -1
	{ [Ignored By Level Plan] The level the plot should be, leave -1 to apply to all levels }
	simsettlementsv2:miscobjects:usagerequirements UsageRequirements
	{ If set, this can establish additional requirements before this resource is used }
	int iOccupantCount = 1
	{ The number of settlers that must be occupying the plot before this resource value is applied }
EndStruct

Struct PlotProduction
	Form Item
	{ Virtual Resource Actor Value, Base inventory object (weapon, armor, miscobject, etc), or Formlist of items. LeveledItems technically work, but should NOT be used if using the sTargetVendorType field to point your production at one of the shop types, which is the preferred way to handle item production in SS2. }
	int iCount = 1
	{ To have this value automatically calculated based on the value of the Item specifie, and the Operating Costs of the plot, set this to -1. }
	int iOccupantCount = 1
	{ [Optional] The number of settlers that must be occupying the plot before this item is produced }
	Keyword TargetContainerKeyword
	{ [Optional] See the Workshop Framework container system documentation }
	string sTargetVendorType = ""
	{ [Optional] If this is filled out, this production will be injected into each settlement vendor's inventory with matching sTargetVendorType and iTargetVendorLevel. Vanilla vendor types just enter the number: 0 = General Store, 1 = Armor, 2 = Weapons, 3 = Bar, 4 = Clinic, 5 = Clothing. Sim Settlement vendor types: SSBookStore, SSFurnitureStore, SSPetStore, SSPowerArmorStore, SSBarber }
	simsettlementsv2:miscobjects:usagerequirements UsageRequirements
	{ If set, this can establish additional requirements before this resource is used }
	Form NameHolderForm
	{ [Optional] If the form you used for the "Item" field is a non-simple type (eg. LeveledItem or Formlist), you can create a MiscObject record with a name that can be displayed in the production pop-up messages for the plot }
	int iTargetVendorLevel = 0
	{ [Optional] If sTargetVendorType is filled out, this production will be injected into each settlement vendor's inventory with matching sTargetVendorType and iTargetVendorLevel. 0 = Level 1 shop, 1 = Level 2 shop, 2 = Level 3 shop }
	int iLevel = -1
	{ [Optional] The level the plot should be, leave -1 to apply to all levels }
EndStruct

