;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\HQ\HQActionManagerQuest.psc
Modified : 2021-01-22 23:02:55
Compiled : 2021-01-29 16:30:57
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:HQ:HQActionManagerQuest extends SimSettlementsV2:HQ:Library:Quests:HQQuest

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const mandatory
	workshopframework:uimanager Property WSFW_UIManager Auto Const mandatory
	workshopframework:quests:taskmanager Property WSFW_TaskManager Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property SafeSpawnPointAlias Auto Const mandatory
EndGroup

Group Assets
	MiscObject Property SS2_HQDefaultActionGroup Auto Const mandatory
	{ The default action group if no action group is found for a registered action }
	Form Property SS2_HQExecuteActionTask Auto Const mandatory
	{ Should be of type SimSettlementsV2:HQ:Library:ObjectRefs:HQTask }
	Container Property SS2_DummyContainer_NoPlayerDisplay Auto Const mandatory
EndGroup

Group Messages
	Message Property SS2_HQActionRequirementMissingMessage Auto Const mandatory
	{ Message displayed when an action is missing a requirement }
EndGroup

Group Formlists
	FormList Property SS2_HQUISelectionHelperFormlist Auto Const mandatory
	{ Blank dummy formlist used for certain UI actions to temporarily store forms }
	FormList Property SS2_HQDefaultCompletedRequirementsFormList Auto Const mandatory
	{ The default completed formlist requirements use }
	FormList Property SS2_HQRunningActionsFormList Auto Const mandatory
	{ The formlist which contains all actively running actions }
	FormList Property SS2_HQTestActionFormList Auto Const mandatory
	{ Test actions which can be registered by calling the registertestactions api function. }
EndGroup

int Property ERC_INVALID_PARAMETER = -1 AutoReadOnly hidden
int Property ERC_NON_PERMANENT_RESEARCH = -2 AutoReadOnly hidden
int Property ERC_NOT_ENOUGH_SPACE = -3 AutoReadOnly hidden
int Property ERC_FAILED_TO_LOCK_QUEST = -4 AutoReadOnly hidden
int Property ERC_FAILED_TO_CREATE_TASK = -5 AutoReadOnly hidden

;-- Variables ---------------------------------------
simsettlementsv2:hq:library:hqdatastructures#hqrunningactionstruct[] marrRunningActions
int mintDeferTimerID = 101
int mintDailyTimerID = 100
float mfltDailyTimerDuration = 24
float mfltDeferTimerDuration = 5
simsettlementsv2:hq:library:hqdatastructures#hqregisteredactiongroupstruct[] marrActionGroups

;-- Functions ---------------------------------------

simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction Function HQ_API_SelectAction(Keyword pkwdFilterKeyword, simsettlementsv2:hq:library:miscobjects:hqactiongroup pacgGroup)
	Self.HQTrace("HQ_API_SelectAction(" + pkwdFilterKeyword as string + "," + pacgGroup as string + ")", 0, False)
	simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction acrAction = None
	If (!pacgGroup)
		pacgGroup = Self.HQ_API_SelectGroup(pkwdFilterKeyword, False)
	EndIf
	If (pacgGroup)
		acrAction = pacgGroup.SelectAction(False, False, pkwdFilterKeyword)
		return acrAction
	Else
		Self.HQTrace("  No group selected!", 0, False)
	EndIf
	return None
EndFunction

Function _EvaluateAllActions()
	Self.HQTrace(" _EvaluateAllActions()", 0, False)
	int I = 0
	While (I < marrActionGroups.length)
		Self._EvaluateActions(marrActionGroups[I], True)
		I += 1
	EndWhile
EndFunction

Event SimSettlementsV2:HQ:Library:MiscObjects:HQRequirement.HQRequirementCompleted(simsettlementsv2:hq:library:miscobjects:hqrequirement preqSender, var[] parrParams)
	Self.HQTrace("HandleEvent:HQRequirementCompleted(" + preqSender as string + ", " + parrParams as string + ")", 0, False)
	Self._EvaluateDependentActionGroups(preqSender as Form)
	Self.UnregisterForCustomEvent(preqSender as ScriptObject, "simsettlementsv2:hq:library:miscobjects:hqrequirement_HQRequirementCompleted")
	preqSender.RegisterCompletionEvents(Self as ScriptObject)
EndEvent

int Function _ScheduleAction(simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction pactAction, float pfltDuration, bool pblnRealTimeTimer, int pintNumberOfExecutions)
	Self.HQTrace(" _ScheduleAction(" + pactAction as string + ")", 0, False)
	int intTaskID = 0
	If (pfltDuration <= 0 as float)
		pactAction.Execute()
	Else
		If (marrRunningActions.length >= 128)
			return Self.ERC_NOT_ENOUGH_SPACE
		EndIf
		var[] arrParams = new var[0]
		arrParams.add(pactAction as var, 1)
		simsettlementsv2:hq:library:objectrefs:tasks:hqexecuteactiontask kTaskRef = WSFW_TaskManager.CreateTask(SS2_HQExecuteActionTask, pfltDuration, pblnRealTimeTimer, pintNumberOfExecutions, False) as simsettlementsv2:hq:library:objectrefs:tasks:hqexecuteactiontask
		If (kTaskRef == None)
			return Self.ERC_FAILED_TO_CREATE_TASK
		EndIf
		kTaskRef.StoreParameters(arrParams)
		WSFW_TaskManager.StartTask(kTaskRef as workshopframework:library:objectrefs:task)
		intTaskID = kTaskRef.iUniqueTaskID
		If (intTaskID > 0)
			simsettlementsv2:hq:library:hqdatastructures#hqrunningactionstruct vntRunningAction = new simsettlementsv2:hq:library:hqdatastructures#hqrunningactionstruct
			vntRunningAction.TaskID = intTaskID
			vntRunningAction.ActionType = pactAction
			marrRunningActions.add(vntRunningAction, 1)
		EndIf
	EndIf
	return intTaskID
EndFunction

Event SimSettlementsV2:HQ:Library:MiscObjects:HQActionGroup.HQEvaluationCompleted(simsettlementsv2:hq:library:miscobjects:hqactiongroup pacgSender, var[] parrParams)
	Self.HQTrace("HandleEvent:HQEvaluationCompleted(" + pacgSender as string + ", " + parrParams as string + ")", 0, False)
	simsettlementsv2:hq:library:hqdatastructures#hqregisteredactiongroupstruct vntGroup = marrActionGroups[marrActionGroups.findstruct("ActionGroup", pacgSender, 0)]
	vntGroup.Evaluating = False
	Self.UnregisterForCustomEvent(pacgSender as ScriptObject, "simsettlementsv2:hq:library:miscobjects:hqactiongroup_HQEvaluationCompleted")
EndEvent

simsettlementsv2:hq:library:miscobjects:hqactiongroup Function _GetActionGroup(simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction pacrAction)
	Self.HQTrace("   _GetActionGroup(" + pacrAction as string + ")", 0, False)
	simsettlementsv2:hq:library:miscobjects:hqactiongroup acgGroup = pacrAction.GetActionGroup()
	If (acgGroup)
		return acgGroup
	EndIf
	return SS2_HQDefaultActionGroup as simsettlementsv2:hq:library:miscobjects:hqactiongroup
EndFunction

Event Quest.OnStageSet(Quest akSenderRef, int aiStageID, int aiStageItemID)
	Self.HQTrace("HandleEvent:OnStageSet(" + akSenderRef as string + ", " + aiStageID as string + ", " + aiStageItemID as string + ")", 0, False)
	Self._EvaluateDependentActionGroups(akSenderRef as Form)
EndEvent

Function _EvaluateActions(simsettlementsv2:hq:library:hqdatastructures#hqregisteredactiongroupstruct pvntGroup, bool pblnWait)
	Self.HQTrace("   _EvaluateActions(" + pvntGroup as string + ", " + pblnWait as string + ")", 0, False)
	If (!pvntGroup.Evaluating)
		pvntGroup.Evaluating = True
		If (!pblnWait)
			Self.RegisterForCustomEvent(pvntGroup.ActionGroup as ScriptObject, "simsettlementsv2:hq:library:miscobjects:hqactiongroup_HQEvaluationCompleted")
			var[] arrParams = new var[1]
			arrParams[0] = True as var
			pvntGroup.ActionGroup.CallFunctionNoWait("EvaluateActions", arrParams)
		Else
			pvntGroup.ActionGroup.EvaluateActions(True)
			pvntGroup.Evaluating = False
		EndIf
	EndIf
EndFunction

Function HQ_TEST_DumpActionGroups()
	Self.HQTrace("HQ_TEST_DumpActionGroups()", 0, False)
	int I = marrActionGroups.length
	If (I == 0)
		Self.HQTrace("  No registered action groups!", 0, False)
	Else
		While (I > 0)
			I -= 1
			Self.HQTrace("  Action group: " + marrActionGroups[I] as string, 0, False)
			FormList fmlRegisteredActions = marrActionGroups[I].ActionGroup.RegisteredActions
			FormList fmlUnlockedActions = marrActionGroups[I].ActionGroup.UnlockedActions
			int j = fmlRegisteredActions.GetSize()
			simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction acrAction = None
			While (j > 0)
				j -= 1
				acrAction = fmlRegisteredActions.GetAt(j) as simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction
				Self.HQTrace("    " + acrAction as string + " Unlocked: " + fmlUnlockedActions.HasForm(acrAction as Form) as string + "    Completed: " + acrAction.IsComplete() as string, 0, False)
			EndWhile
		EndWhile
	EndIf
EndFunction

Function _CleanFormLists()
	Self.HQTrace(" _CleanFormLists()", 0, False)
	workshopframework:library:utilityfunctions.CleanFormList(SS2_HQTestActionFormList, -1)
	int I = marrActionGroups.length
	While (I > 0)
		I -= 1
		If (marrActionGroups[I])
			marrActionGroups[I].ActionGroup.CleanFormLists()
		Else
			marrActionGroups.remove(I, 1)
		EndIf
	EndWhile
EndFunction

ObjectReference Function _CreateActionGroupCache()
	return SafeSpawnPointAlias.GetRef().PlaceAtMe(SS2_DummyContainer_NoPlayerDisplay as Form, 1, False, False, False)
EndFunction

Function _EvaluateDependentActionGroups(Form pfrmDependency)
	Self.HQTrace(" _EvaluateDependentActionGroups(" + pfrmDependency as string + ")", 0, False)
	If (pfrmDependency)
		int I = 0
		While (I < marrActionGroups.length)
			If (!marrActionGroups[I].Evaluating && marrActionGroups[I].Prerequisites.HasForm(pfrmDependency))
				Self._EvaluateActions(marrActionGroups[I], True)
			EndIf
			I += 1
		EndWhile
	EndIf
EndFunction

ObjectReference Function GetActionGroupCacheContainer(simsettlementsv2:hq:library:miscobjects:hqactiongroup pacrActionGroup)
	int iIndex = marrActionGroups.findstruct("ActionGroup", pacrActionGroup, 0)
	If (iIndex >= 0)
		return marrActionGroups[iIndex].CacheContainerRef
	EndIf
	return None
EndFunction

Function HQ_TEST_RegisterActions()
	Self.HQTrace("HQ_TEST_RegisterActions()", 0, False)
	int I = SS2_HQTestActionFormList.GetSize()
	simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction acrAction = None
	Self.HQTrace(" Attempting to register " + I as string + " actions", 0, False)
	While (I > 0)
		I -= 1
		acrAction = SS2_HQTestActionFormList.GetAt(I) as simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction
		If (!acrAction)
			Self.HQTrace("  Could not cast form list to research: " + I as string, 0, False)
			return 
		ElseIf (acrAction.Register() < 0)
			Self.HQTrace("  Failed to register action" + acrAction as string, 0, False)
			return 
		EndIf
	EndWhile
EndFunction

int Function HQ_API_EvaluateActions(simsettlementsv2:hq:library:miscobjects:hqactiongroup pacgActionGroup)
	Self.HQTrace("HQ_API_EvaluateActions(" + pacgActionGroup as string + ")", 0, False)
	int intResult = 0
	int intLockKey = Self.GetLock(0, True)
	If (intLockKey > 0)
		If (pacgActionGroup)
			simsettlementsv2:hq:library:hqdatastructures#hqregisteredactiongroupstruct vntGroup = marrActionGroups[marrActionGroups.findstruct("ActionGroup", pacgActionGroup, 0)]
			Self._EvaluateActions(vntGroup, True)
		Else
			Self._EvaluateAllActions()
		EndIf
		Self.ReleaseLock(intLockKey)
	Else
		intResult = Self.ERC_FAILED_TO_LOCK_QUEST
	EndIf
	return intResult
EndFunction

Event Location.OnLocationCleared(Location akSenderLoc)
	Self._EvaluateDependentActionGroups(akSenderLoc as Form)
EndEvent

Event OnTimer(int pintTimerID)
	Self.HQTrace("HandleEvent:OnTimer(" + pintTimerID as string + ")", 0, False)
	If (pintTimerID == mintDeferTimerID)
		Self._EvaluateAllActions()
	EndIf
EndEvent

Function HQ_TEST_StartAction(Keyword pkwdFilterKeyword, simsettlementsv2:hq:library:miscobjects:hqactiongroup pacgGroup)
	Self.HQTrace("HQ_TEST_StartAction(" + pkwdFilterKeyword as string + "," + pacgGroup as string + ")", 0, False)
	simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction actAction = Self.HQ_API_SelectAction(pkwdFilterKeyword, pacgGroup)
	If (actAction)
		actAction.StartAction()
	EndIf
EndFunction

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
	Self.HQTrace("HandleEvent:OnPlayerGameLoad(" + Self as string + ")", 0, False)
	Self._CleanFormLists()
EndFunction

Event SimSettlementsV2:HQ:Library:MiscObjects:HQActionGroup.HQActionRegistered(simsettlementsv2:hq:library:miscobjects:hqactiongroup pacgSender, var[] parrParams)
	Self.HQTrace("HandleEvent:HQActionRegistered(" + pacgSender as string + ", " + parrParams as string + ")", 0, False)
	If (parrParams as bool && parrParams.length == 2)
		simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction actRegistered = parrParams[0] as simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction
		FormList fmlPrerequisitesFormList = parrParams[1] as FormList
		If (actRegistered as bool && fmlPrerequisitesFormList as bool)
			actRegistered.RegisterUnlockEvents(Self as ScriptObject, fmlPrerequisitesFormList)
		EndIf
	EndIf
EndEvent

Event WorkshopParentScript.WorkshopPlayerOwnershipChanged(workshopparentscript akSender, var[] akArgs)
	Self._EvaluateDependentActionGroups(akArgs[1] as Form)
EndEvent

simsettlementsv2:hq:library:miscobjects:hqactiongroup Function HQ_API_SelectGroup(Keyword pkwdFilterKeyword, bool pblnIncludeEmpty)
	Self.HQTrace("HQ_API_SelectGroup()", 0, False)
	simsettlementsv2:hq:library:miscobjects:hqactiongroup[] arrActionGroups = new simsettlementsv2:hq:library:miscobjects:hqactiongroup[0]
	int I = 0
	While (I < marrActionGroups.length)
		If (pblnIncludeEmpty || marrActionGroups[I].ActionGroup.UnlockedActions.GetSize() > 0)
			arrActionGroups.add(marrActionGroups[I].ActionGroup, 1)
		EndIf
		I += 1
	EndWhile
	Form[] arrFilteredActionGroups = arrActionGroups as Form[]
	If (pkwdFilterKeyword != None)
		arrFilteredActionGroups = workshopframework:library:utilityfunctions.FilterFormArrayByKeyword(arrActionGroups as Form[], pkwdFilterKeyword)
	EndIf
	int intResult = WSFW_UIManager.ShowMessageSelectorMenuAndWait(arrFilteredActionGroups, None, None)
	If (intResult < 0)
		Self.HQTrace("  Failed to start message selector: " + intResult as string, 2, False)
		return None
	EndIf
	If (intResult >= arrFilteredActionGroups.length)
		Self.HQTrace("  Selected index is somehow higher than length of form array sent to message selector: " + intResult as string, 2, False)
		return None
	EndIf
	return arrFilteredActionGroups[intResult] as simsettlementsv2:hq:library:miscobjects:hqactiongroup
EndFunction

Event SimSettlementsV2:HQ:Library:MiscObjects:HQRequirement.HQRequirementUncompleted(simsettlementsv2:hq:library:miscobjects:hqrequirement preqSender, var[] parrParams)
	Self.HQTrace("HandleEvent:HQRequirementUncompleted(" + preqSender as string + ", " + parrParams as string + ")", 0, False)
	Self._EvaluateDependentActionGroups(preqSender as Form)
	Self.UnregisterForCustomEvent(preqSender as ScriptObject, "simsettlementsv2:hq:library:miscobjects:hqrequirement_HQRequirementUncompleted")
	preqSender.RegisterCompletionEvents(Self as ScriptObject)
EndEvent

Event OnTimerGameTime(int pintTimerID)
	Self.HQTrace("HandleEvent:OnTimerGameTime(" + pintTimerID as string + ")", 0, False)
	If (pintTimerID == mintDailyTimerID)
		Self._EvaluateAllActions()
		Self.StartTimerGameTime(mfltDailyTimerDuration, mintDailyTimerID)
	EndIf
EndEvent

int Function _RegisterActionGroup(simsettlementsv2:hq:library:miscobjects:hqactiongroup pacgActionGroup)
	Self.HQTrace(" _RegisterActionGroup(" + pacgActionGroup as string + ")", 0, False)
	If (!pacgActionGroup)
		return Self.ERC_INVALID_PARAMETER
	EndIf
	If (marrActionGroups.findstruct("ActionGroup", pacgActionGroup, 0) < 0)
		simsettlementsv2:hq:library:hqdatastructures#hqregisteredactiongroupstruct vntGroup = new simsettlementsv2:hq:library:hqdatastructures#hqregisteredactiongroupstruct
		vntGroup.ActionGroup = pacgActionGroup
		vntGroup.Prerequisites = pacgActionGroup.Prerequisites
		vntGroup.CacheContainerRef = Self._CreateActionGroupCache()
		marrActionGroups.add(vntGroup, 1)
		Self.RegisterForCustomEvent(pacgActionGroup as ScriptObject, "simsettlementsv2:hq:library:miscobjects:hqactiongroup_HQActionRegistered")
	EndIf
	return 0
EndFunction

int Function ScheduleAction(simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction pactAction, float pfltDuration, bool pblnRealTimeTimer, int pintNumberOfExecutions)
	Self.HQTrace("ScheduleAction(" + pactAction as string + ")", 0, False)
	int intResult = 0
	int intLockKey = Self.GetLock(0, True)
	If (intLockKey > 0)
		Self._ScheduleAction(pactAction, pfltDuration, pblnRealTimeTimer, pintNumberOfExecutions)
		Self.ReleaseLock(intLockKey)
	Else
		intResult = Self.ERC_FAILED_TO_LOCK_QUEST
	EndIf
	return intResult
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
	Self.StartHQUserLog("HQActMgrQst", True, False)
	Self.HQTrace("HandleEvent:OnQuestInit(" + Self as string + ")", 0, False)
	marrActionGroups = new simsettlementsv2:hq:library:hqdatastructures#hqregisteredactiongroupstruct[1]
	marrActionGroups[0] = new simsettlementsv2:hq:library:hqdatastructures#hqregisteredactiongroupstruct
	marrActionGroups[0].ActionGroup = SS2_HQDefaultActionGroup as simsettlementsv2:hq:library:miscobjects:hqactiongroup
	marrActionGroups[0].Prerequisites = (SS2_HQDefaultActionGroup as simsettlementsv2:hq:library:miscobjects:hqactiongroup).Prerequisites
	marrActionGroups[0].CacheContainerRef = Self._CreateActionGroupCache()
	marrRunningActions = new simsettlementsv2:hq:library:hqdatastructures#hqrunningactionstruct[0]
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopPlayerOwnershipChanged")
	Self.StartTimerGameTime(mfltDailyTimerDuration, mintDailyTimerID)
EndFunction

int Function HQ_API_RegisterActionGroup(simsettlementsv2:hq:library:miscobjects:hqactiongroup pacgActionGroup)
	Self.HQTrace("HQ_API_RegisterActionGroup(" + pacgActionGroup as string + ")", 0, False)
	int intResult = 0
	int intLockKey = Self.GetLock(0, True)
	If (intLockKey > 0)
		intResult = Self._RegisterActionGroup(pacgActionGroup)
		Self.ReleaseLock(intLockKey)
	Else
		intResult = Self.ERC_FAILED_TO_LOCK_QUEST
	EndIf
	return intResult
EndFunction
