;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\HQ\HQManagerQuest.psc
Modified : 2021-02-26 00:41:13
Compiled : 2021-02-26 00:41:24
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:HQ:HQManagerQuest extends WorkshopFramework:Library:SlaveQuest
{ Handles HQ data management for HQ configured locations }

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const mandatory
	workshopframework:mainthreadmanager Property ThreadManager Auto Const mandatory
	simsettlementsv2:quests:resourcemanager Property ResourceManager Auto Const mandatory
	simsettlementsv2:quests:hudmanager Property HUDManager Auto Const mandatory
	workshopframework:mainquest Property WSFW_Main Auto Const mandatory
	simsettlementsv2:hq:hqworkermanagerquest Property HQWorkerManager Auto Const mandatory
	workshopframework:uimanager Property UIManager Auto Const mandatory
	simsettlementsv2:datastructures#avtoinventoryformmap[] Property TokenExchange Auto Const mandatory
	{ Define alternate token exchange for certain virtual resources for use in translating caravan network goods into spendable resources at HQ }
EndGroup

Group Aliases
	ReferenceAlias Property SafeSpawnPoint Auto Const mandatory
	ReferenceAlias[] Property DepartmentAliases Auto Const mandatory
	ReferenceAlias[] Property DepartmentNameStampAliases Auto Const mandatory
EndGroup

Group Assets
	Form Property HQDataForm Auto Const mandatory
	Form Property NameHolder_SelectRoom Auto Const mandatory
	FormList Property RoomBarterSelectionFormlist Auto Const mandatory
	{ Blank formlist for results to be fed in by UIManager }
EndGroup

Group Keywords
	Keyword Property HQLocationKeyword Auto Const mandatory
	Keyword Property WorkshopItemKeyword Auto Const mandatory
	Keyword Property RoomSelectTagKeyword Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property Settings_ResourceComplexity Auto Const mandatory
EndGroup

int Property ERC_INVALID_PARAMETER = -1 AutoReadOnly hidden
int Property ERC_FAILED_TO_LOCK_QUEST = -2 AutoReadOnly hidden
int Property ERC_INVALID_LOCKKEY = -3 AutoReadOnly hidden
int Property ERC_STORY_EVENT_FAILURE = -4 AutoReadOnly hidden
int Property ERC_HQREF_NOT_ESTABLISHED = -5 AutoReadOnly hidden
int Property ERC_NOT_ENOUGH_DEPARTMENT_ALIASES = -6 AutoReadOnly hidden
simsettlementsv2:hq:library:objectrefs:hqdata[] Property HQDataStores Auto hidden

;-- Variables ---------------------------------------
int iTimerID_UpdateHUD = 201 Const
simsettlementsv2:datastructures#workshopdatastoremap[] WorkshopHQDataMaps
simsettlementsv2:datastructures#locationdatastoremap[] LocationHQDataMaps
string sHQLogName = "SS2HQManager" Const
bool bBarterRoomInterfaceInUse = False
bool bDataStoresUpdatingBlock = False

;-- Functions ---------------------------------------

simsettlementsv2:hq:library:objectrefs:room Function HQ_API_ShowSelectRoom(simsettlementsv2:hq:library:objectrefs:room[] akRoomRefs)
	If (bBarterRoomInterfaceInUse)
		return None
	EndIf
	bBarterRoomInterfaceInUse = True
	simsettlementsv2:hq:library:objectrefs:room SelectedRoom = None
	ObjectReference[] kRoomSelectors = new ObjectReference[0]
	ObjectReference kSafeSpawnPointRef = SafeSpawnPoint.GetRef()
	int I = 0
	While (I < akRoomRefs.length)
		If (akRoomRefs[I].UIRepresentationForm != None)
			ObjectReference kSelector = kSafeSpawnPointRef.PlaceAtMe(akRoomRefs[I].UIRepresentationForm, 1, False, False, True)
			If (kSelector != None)
				kRoomSelectors.add(kSelector, 1)
			EndIf
		EndIf
		I += 1
	EndWhile
	If (kRoomSelectors.length > 0)
		Keyword[] FilterKeywords = new Keyword[1]
		FilterKeywords[0] = RoomSelectTagKeyword
		int iResult = UIManager.ShowBarterSelectMenuAndWait(NameHolder_SelectRoom, kRoomSelectors as Form[], RoomBarterSelectionFormlist, FilterKeywords, 2, None, False, True, 600)
		If (iResult > 0)
			PlayerRef.RemoveItem(RoomSelectTagKeyword as Form, -1, True, None)
			Form[] SelectedRooms = new Form[0]
			I = 0
			While (I < RoomBarterSelectionFormlist.GetSize() - 1)
				SelectedRooms.add(RoomBarterSelectionFormlist.GetAt(I), 1)
				I += 1
			EndWhile
			SelectedRoom = (SelectedRooms[Utility.RandomInt(0, SelectedRooms.length - 1)] as simsettlementsv2:hq:library:weapons:roomselector).RoomRef
			Self._ResetRoomSelection()
		EndIf
	EndIf
	bBarterRoomInterfaceInUse = False
	return SelectedRoom
EndFunction

Function DumpDataStore(workshopscript akHQRef)
	If (akHQRef == None)
		akHQRef = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
	EndIf
	simsettlementsv2:hq:library:objectrefs:hqdata thisDataStore = Self.HQ_API_GetHQDataStoreFromWorkshop(akHQRef)
	workshopframework:library:utilityfunctions.ModTraceCustom(sHQLogName, "============== Dumping HQ DataStore for " + akHQRef as string + " =======", 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(sHQLogName, "Departments: " + thisDataStore.marrRegisteredDepartments as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(sHQLogName, "ResidentialLocations: " + thisDataStore.marrResidentialLocations as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(sHQLogName, " > > > Begin Dump of Worker Structs: ", 0, False)
	int I = 0
	While (I < thisDataStore.marrWorkers.length)
		workshopframework:library:utilityfunctions.ModTraceCustom(sHQLogName, "Worker " + I as string + ": " + thisDataStore.marrWorkers[I] as string, 0, False)
		I += 1
	EndWhile
	workshopframework:library:utilityfunctions.ModTraceCustom(sHQLogName, "============== End Dump of HQ DataStore for " + akHQRef as string + " =======", 0, False)
EndFunction

int Function _FindDepartmentAliasIndex(simsettlementsv2:hq:library:objectrefs:departmentobject akDepartmentRef)
	int I = 0
	While (I < DepartmentAliases.length)
		If (DepartmentAliases[I].GetRef() == akDepartmentRef as ObjectReference)
			return I
		EndIf
		I += 1
	EndWhile
	return -1
EndFunction

Function _RegisterEnabledDepartments(workshopscript akHQRef)
	simsettlementsv2:hq:library:objectrefs:departmentobject[] Departments = Self._GetDepartmentsFromWorkshop(akHQRef, True)
	int I = 0
	While (I < Departments.length)
		Self._RegisterDepartment(Departments[I], akHQRef)
		I += 1
	EndWhile
EndFunction

simsettlementsv2:hq:library:objectrefs:hqdata Function HQ_API_GetHQDataStoreFromLocation(Location akLocationRef)
	int iIndex = LocationHQDataMaps.findstruct("kLocationRef", akLocationRef, 0)
	If (iIndex >= 0)
		return HQDataStores[iIndex]
	EndIf
	return None
EndFunction

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
	If (asMenuName == "WorkshopMenu")
		If (!abOpening)
			workshopscript kWorkshopRef = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
			simsettlementsv2:hq:library:objectrefs:hqdata thisDataStore = Self.HQ_API_GetHQDataStoreFromWorkshop(kWorkshopRef)
			If (thisDataStore != None)
				Self._UpdateResourcePool(thisDataStore)
			EndIf
		EndIf
	EndIf
EndEvent

simsettlementsv2:hq:library:objectrefs:hqdata Function HQ_API_GetHQDataStoreFromWorkshop(workshopscript akWorkshopRef)
	int iIndex = WorkshopHQDataMaps.findstruct("kWorkshopRef", akWorkshopRef, 0)
	If (iIndex >= 0)
		return HQDataStores[iIndex]
	EndIf
	return None
EndFunction

Function _ResetRoomSelection()
	RoomBarterSelectionFormlist.Revert()
EndFunction

bool Function HQ_API_IsPlayerInHQ()
	return Self._IsPlayerInHQ()
EndFunction

simsettlementsv2:hq:library:objectrefs:hqdata Function _ConfigureHQDataStore(workshopscript akWorkshopRef)
	ObjectReference kPlaceAt = SafeSpawnPoint.GetRef()
	If (kPlaceAt)
		ObjectReference kDataStore = kPlaceAt.PlaceAtMe(HQDataForm, 1, True, False, False)
		If (kDataStore)
			simsettlementsv2:hq:library:objectrefs:hqdata asDataStore = kDataStore as simsettlementsv2:hq:library:objectrefs:hqdata
			If (asDataStore)
				asDataStore.kWorkshopRef = akWorkshopRef
				If (HQDataStores == None || HQDataStores.length == 0)
					HQDataStores = new simsettlementsv2:hq:library:objectrefs:hqdata[0]
				EndIf
				HQDataStores.add(asDataStore, 1)
				int iIndex = WorkshopHQDataMaps.findstruct("kWorkshopRef", akWorkshopRef, 0)
				If (iIndex < 0)
					simsettlementsv2:datastructures#workshopdatastoremap newEntry = new simsettlementsv2:datastructures#workshopdatastoremap
					newEntry.kWorkshopRef = akWorkshopRef
					newEntry.iDataStoreIndex = HQDataStores.length - 1
					If (WorkshopHQDataMaps == None || WorkshopHQDataMaps.length == 0)
						WorkshopHQDataMaps = new simsettlementsv2:datastructures#workshopdatastoremap[0]
					EndIf
					WorkshopHQDataMaps.add(newEntry, 1)
				EndIf
				Location thisLocation = akWorkshopRef.myLocation
				iIndex = LocationHQDataMaps.findstruct("kLocationRef", thisLocation, 0)
				If (iIndex < 0)
					simsettlementsv2:datastructures#locationdatastoremap newentry = new simsettlementsv2:datastructures#locationdatastoremap
					newentry.kLocationRef = thisLocation
					newentry.iDataStoreIndex = HQDataStores.length - 1
					If (LocationHQDataMaps == None || LocationHQDataMaps.length == 0)
						LocationHQDataMaps = new simsettlementsv2:datastructures#locationdatastoremap[0]
					EndIf
					LocationHQDataMaps.add(newentry, 1)
				EndIf
			EndIf
		EndIf
	EndIf
	return HQDataStores[HQDataStores.length - 1]
EndFunction

Event ObjectReference.OnWorkshopObjectDestroyed(ObjectReference akSenderRef, ObjectReference akPlacedRef)
	workshopscript kWorkshopRef = akSenderRef as workshopscript
	If (kWorkshopRef)
		Self.StartTimer(1.5, iTimerID_UpdateHUD)
	EndIf
EndEvent

Event OnTimer(int aiTimerID)
	Parent.OnTimer(aiTimerID)
	If (aiTimerID == iTimerID_UpdateHUD)
		workshopscript kCurrentWorkshop = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
		If (kCurrentWorkshop != None && kCurrentWorkshop.myLocation.GetKeywordData(HQLocationKeyword) > 0 as float)
			kCurrentWorkshop.RecalculateWorkshopResources(True)
			HUDManager.UpdateHQDepartmentsFromLocation(kCurrentWorkshop)
		EndIf
	EndIf
EndEvent

Function HandleGameLoaded()
	Debug.OpenUserLog(sHQLogName)
	Parent.HandleGameLoaded()
	Self.RegisterForMenuOpenCloseEvent("WorkshopMenu")
	Self.RegisterForCustomEvent(WSFW_Main as ScriptObject, "workshopframework:mainquest_PlayerEnteredSettlement")
	int I = 0
	While (I < HQDataStores.length)
		Self.RegisterForRemoteEvent(HQDataStores[I].kWorkshopRef as ScriptObject, "OnWorkshopObjectPlaced")
		Self.RegisterForRemoteEvent(HQDataStores[I].kWorkshopRef as ScriptObject, "OnWorkshopObjectDestroyed")
		I += 1
	EndWhile
EndFunction

Function HQ_API_StampDepartmentNameOnRef(simsettlementsv2:hq:library:objectrefs:departmentobject akDepartmentRef, ObjectReference akRenameRef)
	int iIndex = Self._FindDepartmentAliasIndex(akDepartmentRef)
	If (iIndex >= 0)
		DepartmentNameStampAliases[iIndex].ApplyToRef(akRenameRef)
	EndIf
EndFunction

simsettlementsv2:hq:library:objectrefs:hqdata Function _EstablishNewHQ(workshopscript akWorkshopRef)
	simsettlementsv2:hq:library:objectrefs:hqdata thisDataStore = Self.HQ_API_GetHQDataStoreFromWorkshop(akWorkshopRef)
	If (thisDataStore == None)
		If (akWorkshopRef.myLocation == None)
			akWorkshopRef.myLocation = akWorkshopRef.GetCurrentLocation()
		EndIf
		Self._FlagLocationAsHQ(akWorkshopRef.myLocation)
		Self.RegisterForRemoteEvent(akWorkshopRef as ScriptObject, "OnWorkshopObjectPlaced")
		Self.RegisterForRemoteEvent(akWorkshopRef as ScriptObject, "OnWorkshopObjectDestroyed")
		thisDataStore = Self._ConfigureHQDataStore(akWorkshopRef)
		Self.SendHQEstablishedEvent(akWorkshopRef)
		Self._RegisterEnabledDepartments(akWorkshopRef)
	EndIf
	return thisDataStore
EndFunction

Function SendHQDepartmentRegisteredEvent(simsettlementsv2:hq:library:objectrefs:departmentobject akDepartmentRef, workshopscript akHQRef)
	var[] kArgs = new var[0]
	kArgs.add(akDepartmentRef as var, 1)
	kArgs.add(akHQRef as var, 1)
	Self.SendCustomEvent("simsettlementsv2:hq:hqmanagerquest_HQDepartmentRegistered", kArgs)
EndFunction

int Function _StoreDepartmentInAlias(simsettlementsv2:hq:library:objectrefs:departmentobject akDepartmentRef)
	int intLockKey = Self.GetLock(0, True)
	int intResult = Self.ERC_NOT_ENOUGH_DEPARTMENT_ALIASES
	If (intLockKey > 0)
		int I = 0
		bool bFoundSlot = False
		While (I < DepartmentAliases.length && !bFoundSlot)
			If (DepartmentAliases[I].GetRef() == None)
				DepartmentAliases[I].ForceRefTo(akDepartmentRef as ObjectReference)
				bFoundSlot = True
				intResult = 1
			EndIf
			I += 1
		EndWhile
		Self.ReleaseLock(intLockKey)
	Else
		intResult = Self.ERC_FAILED_TO_LOCK_QUEST
	EndIf
	return intResult
EndFunction

simsettlementsv2:hq:library:objectrefs:hqdata Function HQ_API_EstablishNewHQ(workshopscript akWorkshopRef)
	workshopframework:library:utilityfunctions.ModTraceCustom(sHQLogName, "HQ_API_EstablishNewHQ(" + akWorkshopRef as string + ")", 0, False)
	int intLockKey = Self.GetLock(0, True)
	simsettlementsv2:hq:library:objectrefs:hqdata thisHQDataStore = None
	If (intLockKey > 0)
		thisHQDataStore = Self._EstablishNewHQ(akWorkshopRef)
		Self.ReleaseLock(intLockKey)
	EndIf
	return thisHQDataStore
EndFunction

Function PrepHQ()
	workshopscript kHQRef = Game.GetFormFromFile(14196, "SS2HQGNN.esm") as workshopscript
	Self.HQ_API_EstablishNewHQ(kHQRef)
	Debug.MessageBox("HQ Prepped. Resource complexity forced to Simple, as we only have costs defined in basic form so far.")
	Settings_ResourceComplexity.SetValueInt(1)
EndFunction

Function _UpdateResourcePool(simsettlementsv2:hq:library:objectrefs:hqdata akHQDataStore)
	workshopframework:library:utilityfunctions.ModTraceCustom(sHQLogName, "_UpdateResourcePool(" + akHQDataStore as string + ")", 0, False)
	If (akHQDataStore == None)
		return 
	EndIf
	workshopscript kHQRef = akHQDataStore.kWorkshopRef
	kHQRef.RemoveAllItems(None, False)
	int I = 0
	While (I < akHQDataStore.marrRegisteredDepartments.length)
		float fUpkeep = kHQRef.GetValue(akHQDataStore.marrRegisteredDepartments[I].WorkshopResourceUpkeep)
		float fEnergy = kHQRef.GetValue(akHQDataStore.marrRegisteredDepartments[I].WorkshopResourceProvided)
		int iAvailableEnergy = Math.Floor(fEnergy - fUpkeep)
		If (iAvailableEnergy > 0)
			kHQRef.AddItem(akHQDataStore.marrRegisteredDepartments[I].ResourceToken, iAvailableEnergy, False)
		EndIf
		I += 1
	EndWhile
	int iComplexitySetting = Settings_ResourceComplexity.GetValueInt()
	simsettlementsv2:datastructures#virtualresource[] TrackedVirtualResourceTypes01 = ResourceManager.TrackedVirtualResourceTypes01
	If (iComplexitySetting == 1 || iComplexitySetting == 2)
		simsettlementsv2:datastructures#virtualresourcecategory[] VRCategories = ResourceManager.VirtualResourceCategories
		I = 0
		While (I < VRCategories.length)
			If (VRCategories[I].iParentCategoryIndex == -1 && iComplexitySetting == 1 || VRCategories[I].iParentCategoryIndex >= 0 && iComplexitySetting == 2)
				int iIndex = TrackedVirtualResourceTypes01.findstruct("VirtualResourceForm", VRCategories[I].ResourceAV, 0)
				If (iIndex >= 0)
					Self._AddVirtualResourceTokens(kHQRef, TrackedVirtualResourceTypes01[iIndex])
				EndIf
			EndIf
			I += 1
		EndWhile
		simsettlementsv2:datastructures#virtualresourcecategorymap[] VRCategoryMaps = ResourceManager.VirtualResourceCategoryMaps
		I = 0
		While (I < TrackedVirtualResourceTypes01.length)
			If (VRCategoryMaps.findstruct("ResourceAV", TrackedVirtualResourceTypes01[I].VirtualResourceForm, 0) < 0)
				Self._AddVirtualResourceTokens(kHQRef, TrackedVirtualResourceTypes01[I])
			EndIf
			I += 1
		EndWhile
	Else
		I = 0
		While (I < TrackedVirtualResourceTypes01.length)
			If (TrackedVirtualResourceTypes01[I].VirtualResourceForm == ResourceManager.FindVirtualResourceOverride(TrackedVirtualResourceTypes01[I].VirtualResourceForm))
				Self._AddVirtualResourceTokens(kHQRef, TrackedVirtualResourceTypes01[I])
			EndIf
			I += 1
		EndWhile
	EndIf
EndFunction

simsettlementsv2:hq:library:objectrefs:departmentobject[] Function _GetDepartmentsFromLocation(Location akLocation, bool abEnabledOnly)
	simsettlementsv2:hq:library:quests:grabhqcontrollerobjects HQObjectGrabber = (Self as Quest) as simsettlementsv2:hq:library:quests:grabhqcontrollerobjects
	If (akLocation == None)
		akLocation = PlayerRef.GetCurrentLocation()
	EndIf
	return HQObjectGrabber.GetDepartmentsFromLocation(akLocation, abEnabledOnly)
EndFunction

Event WorkshopFramework:MainQuest.PlayerEnteredSettlement(workshopframework:mainquest akQuestRef, var[] akArgs)
	workshopscript kWorkshopRef = akArgs[0] as workshopscript
	bool bPreviouslyUnloaded = akArgs[1] as bool
	Self._HandlePlayerEnteredSettlement(kWorkshopRef)
EndEvent

simsettlementsv2:hq:library:objectrefs:room Function HQ_API_ShowSelectRoomMenuForLocation(Location akLocation)
	If (akLocation == None)
		akLocation = PlayerRef.GetCurrentLocation()
		If (akLocation == None)
			Debug.MessageBox("Must have a location to show room selection.")
			return None
		EndIf
	EndIf
	If (akLocation.GetKeywordData(HQLocationKeyword) <= 0 as float)
		Debug.MessageBox("This location is not an HQ.")
		return None
	EndIf
	simsettlementsv2:hq:library:objectrefs:room[] kRoomRefs = simsettlementsv2:hq:library:hqutilityfunctions.GetRoomsFromLocation(akLocation, True)
	return Self.HQ_API_ShowSelectRoom(kRoomRefs)
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
EndFunction

int Function HQ_API_RegisterDepartment(simsettlementsv2:hq:library:objectrefs:departmentobject akDepartmentRef, workshopscript akHQRef)
	workshopframework:library:utilityfunctions.ModTraceCustom(sHQLogName, "HQ_API_RegisterDepartment(" + akDepartmentRef as string + ", " + akHQRef as string + ")", 0, False)
	int intLockKey = Self.GetLock(0, True)
	int intResult = 0
	If (intLockKey > 0)
		If (!akHQRef)
			akHQRef = akDepartmentRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
		EndIf
		intResult = Self._RegisterDepartment(akDepartmentRef, akHQRef)
		Self.ReleaseLock(intLockKey)
	Else
		intResult = Self.ERC_FAILED_TO_LOCK_QUEST
	EndIf
	return intResult
EndFunction

Function SendHQEstablishedEvent(workshopscript akHQRef)
	var[] kArgs = new var[0]
	kArgs.add(akHQRef as var, 1)
	Self.SendCustomEvent("simsettlementsv2:hq:hqmanagerquest_HQEstablished", kArgs)
EndFunction

bool Function _IsPlayerInHQ()
	workshopscript kCurrentWorkshop = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
	If (kCurrentWorkshop != None && kCurrentWorkshop.myLocation.GetKeywordData(HQLocationKeyword) > 0 as float)
		return True
	EndIf
	return False
EndFunction

simsettlementsv2:hq:library:objectrefs:departmentobject[] Function _GetDepartmentsFromWorkshop(workshopscript akWorkshopRef, bool abEnabledOnly)
	simsettlementsv2:hq:library:quests:grabhqcontrollerobjects HQObjectGrabber = (Self as Quest) as simsettlementsv2:hq:library:quests:grabhqcontrollerobjects
	return HQObjectGrabber.GetDepartmentsFromLocation(akWorkshopRef.myLocation, abEnabledOnly)
EndFunction

Function _AddVirtualResourceTokens(workshopscript akHQRef, simsettlementsv2:datastructures#virtualresource aVirtualResource)
	int iCount = Math.Floor(ResourceManager.GetNetworkVirtualResource_BySettlement(akHQRef, aVirtualResource.VirtualResourceForm, True))
	Form PhysicalForm = None
	int iTokenExchangeIndex = TokenExchange.findstruct("AVForm", aVirtualResource.VirtualResourceForm, 0)
	workshopframework:library:utilityfunctions.ModTraceCustom(sHQLogName, "Checking for VirtualResourceForm: " + aVirtualResource.VirtualResourceForm as string + "...", 0, False)
	If (iTokenExchangeIndex >= 0)
		iCount += Math.Floor(iCount as float * TokenExchange[iTokenExchangeIndex].fMultiplier)
		PhysicalForm = TokenExchange[iTokenExchangeIndex].InventoryItem
		workshopframework:library:utilityfunctions.ModTraceCustom(sHQLogName, "Found iTokenExchangeIndex " + iTokenExchangeIndex as string + ", PhysicalForm " + PhysicalForm as string + "...", 0, False)
	EndIf
	If (PhysicalForm == None)
		PhysicalForm = aVirtualResource.PhysicalEquivalent
		If (PhysicalForm as component)
			PhysicalForm = ResourceManager.GetComponentInventoryObject(PhysicalForm as component)
		EndIf
	EndIf
	If (PhysicalForm != None && !PhysicalForm as Keyword)
		akHQRef.AddItem(PhysicalForm, iCount, False)
	EndIf
EndFunction

Function _HandlePlayerEnteredSettlement(workshopscript akWorkshopRef)
	bool bIsEstablishedHQ = False
	int I = 0
	While (I < HQDataStores.length && !bIsEstablishedHQ)
		If (HQDataStores[I].kWorkshopRef == akWorkshopRef)
			bIsEstablishedHQ = True
			Self._UpdateResourcePool(HQDataStores[I])
		EndIf
		I += 1
	EndWhile
EndFunction

int Function _RegisterDepartment(simsettlementsv2:hq:library:objectrefs:departmentobject akDepartmentRef, workshopscript akHQRef)
	workshopframework:library:utilityfunctions.ModTraceCustom(sHQLogName, " _RegisterDepartment(" + akDepartmentRef as string + ")", 0, False)
	If (!akDepartmentRef)
		return Self.ERC_INVALID_PARAMETER
	EndIf
	HQWorkerManager._RegisterDepartmentStatDisplayForms(akDepartmentRef)
	If (!akHQRef)
		akHQRef = akDepartmentRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	EndIf
	simsettlementsv2:hq:library:objectrefs:hqdata thisDataStore = Self.HQ_API_GetHQDataStoreFromWorkshop(akHQRef)
	If (!thisDataStore)
		return Self.ERC_HQREF_NOT_ESTABLISHED
	EndIf
	If (Self._FindDepartmentAliasIndex(akDepartmentRef) < 0)
		Self._StoreDepartmentInAlias(akDepartmentRef)
	EndIf
	int iIndex = thisDataStore.marrRegisteredDepartments.find(akDepartmentRef, 0)
	If (iIndex < 0)
		If (thisDataStore.marrRegisteredDepartments == None)
			thisDataStore.marrRegisteredDepartments = new simsettlementsv2:hq:library:objectrefs:departmentobject[0]
		EndIf
		thisDataStore.marrRegisteredDepartments.add(akDepartmentRef, 1)
		Self.SendHQDepartmentRegisteredEvent(akDepartmentRef, akHQRef)
	EndIf
	return 0
EndFunction

Event ObjectReference.OnWorkshopObjectPlaced(ObjectReference akSenderRef, ObjectReference akPlacedRef)
	workshopscript kWorkshopRef = akSenderRef as workshopscript
	If (kWorkshopRef)
		Self.StartTimer(1.5, iTimerID_UpdateHUD)
	EndIf
EndEvent

Function _FlagLocationAsHQ(Location akHQLocation)
	akHQLocation.SetKeywordData(HQLocationKeyword, 1)
EndFunction
