;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\HQ\HQWorkerManagerQuest.psc
Modified : 2021-03-02 22:59:05
Compiled : 2021-03-02 22:59:16
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:HQ:HQWorkerManagerQuest extends SimSettlementsV2:HQ:Library:Quests:HQQuest

;-- Properties --------------------------------------
Group ACTOR_VALUES
	ActorValue Property SS2_HQWorkerID Auto Const mandatory
	ActorValue Property WorkshopPlayerOwnershipAV Auto Const mandatory
	ActorValue Property Strength Auto Const mandatory
	ActorValue Property Perception Auto Const mandatory
	ActorValue Property Endurance Auto Const mandatory
	ActorValue Property Charisma Auto Const mandatory
	ActorValue Property Intelligence Auto Const mandatory
	ActorValue Property Agility Auto Const mandatory
	ActorValue Property Luck Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property SafeSpawnPoint Auto Const mandatory
	ReferenceAlias Property MessageAlias_CurrentDepartmentName Auto Const mandatory
	ReferenceAlias Property MessageAlias_CurrentDepartmentHead Auto Const mandatory
	ReferenceAlias Property HQWorkerApply Auto Const mandatory
	ReferenceAlias Property AssignmentBarterContainer Auto Const mandatory
	simsettlementsv2:hq:library:hqdatastructures#statdisplayaliases[] Property StatDisplayAliasMaps Auto Const mandatory
EndGroup

Group Assets
	MiscObject Property SS2_HQDepartmentActionGroup Auto Const mandatory
	Form Property NameHolderForm_ChooseADepartment Auto Const mandatory
	Form Property NameHolderForm_Unassigned Auto Const mandatory
	Form Property Warning_NoRegisteredDepartments Auto Const mandatory
	FormList Property AssignmentBarterSelectionFormlist Auto Const mandatory
	{ Blank formlist for results to be fed in by UIManager }
	FormList Property AssignmentBarterHelperFormlist Auto Const mandatory
	{ Blank formlist for helping sort out the assignment barter system }
	simsettlementsv2:hq:library:hqdatastructures#statdisplayforms[] Property DefaultStatDisplayMaps Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property HQLocationKeyword Auto Const mandatory
	Keyword Property WorkshopItemKeyword Auto Const mandatory
	Keyword Property SS2_HQResidentialLocationStoryEventKeyword Auto Const mandatory
	Keyword Property SS2_Link_AssignedDepartment Auto Const mandatory
	Keyword Property AssignmentBarterFormTag Auto Const mandatory
EndGroup

Group GlobalVariables
	GlobalVariable Property Settings_ChooseHQDepartmentOnNPCTransfer Auto Const mandatory
EndGroup

Group Messages
	Message Property Warning_RequestedDepartmentIsFull Auto Const mandatory
	Message Property SS2_Notification_GeneratingHQAssignmentMenu Auto Const mandatory
EndGroup

Group Controllers
	simsettlementsv2:hq:hqmanagerquest Property HQManager Auto Const mandatory
	simsettlementsv2:quests:hudmanager Property HUDManager Auto Const mandatory
	workshopparentscript Property WorkshopParent Auto Const mandatory
	workshopframework:quests:storyeventmanager Property WSFW_StoryEventManager Auto Const mandatory
	workshopframework:uimanager Property UIManager Auto Const mandatory
	workshopframework:npcmanager Property NPCManager Auto Const mandatory
EndGroup

simsettlementsv2:hq:library:hqdatastructures#statdisplayforms[] Property StatDisplayMaps Auto hidden
int Property ERC_INVALID_PARAMETER = -1 AutoReadOnly hidden
int Property ERC_WORKER_LIST_FULL = -2 AutoReadOnly hidden
int Property ERC_FAILED_TO_LOCK_QUEST = -3 AutoReadOnly hidden
int Property ERC_INVALID_LOCKKEY = -4 AutoReadOnly hidden
int Property ERC_STORY_EVENT_FAILURE = -5 AutoReadOnly hidden
int Property ERC_HQREF_NOT_ESTABLISHED = -6 AutoReadOnly hidden
int Property _NextWorkerID hidden
	int Function Get()
		int intNextWorkerID = mintNextWorkerID
		mintNextWorkerID += 1
		return intNextWorkerID
	EndFunction
EndProperty

;-- Variables ---------------------------------------
bool bBarterAssignmentInterfaceInUse = False
int mintNextResidentialLocationID = 1024
int mintNextWorkerID = 1024

;-- Functions ---------------------------------------

Event WorkshopParentScript.WorkshopAddActor(workshopparentscript akSender, var[] akArgs)
	Self.HQTrace("HandleEvent:WorkshopAddActor(" + Self as string + ", " + akArgs as string + ")", 0, False)
	Actor actActor = akArgs[0] as Actor
	int iWorkshopID = akArgs[1] as int
	workshopscript thisWorkshop = WorkshopParent.GetWorkshop(iWorkshopID)
	If (thisWorkshop == None || actActor == None)
		return 
	EndIf
	Location thisLocation = thisWorkshop.myLocation
	If (thisLocation.GetKeywordData(HQLocationKeyword) <= 0 as float)
		Self.HQTrace("  HQ tried to handle WorkshopAddActor event to a non-HQ location: " + thisLocation as string, 0, False)
		return 
	EndIf
	bool bAutoAssignToDepartment = True
	bool bShowDepartmentAssignmentInterface = Settings_ChooseHQDepartmentOnNPCTransfer.GetValueInt() == 1
	If (workshopframework:wsfw_api.IsPlayerInWorkshopMode())
		bAutoAssignToDepartment = False
	Else
		bShowDepartmentAssignmentInterface = False
	EndIf
	int intResult = Self.HQ_API_RegisterWorker(actActor, thisWorkshop, bAutoAssignToDepartment)
	If (intResult >= 0)
		Debug.Notification("Sending to HQ")
		If (bShowDepartmentAssignmentInterface)
			Self.HQTrace("  Showing department select for " + actActor as string + "...", 0, False)
			simsettlementsv2:hq:library:objectrefs:departmentobject SelectedDepartment = Self._ShowDeparmentSelectionMenu(thisWorkshop)
			bool bSuccessfulAssignment = False
			While (SelectedDepartment != None && !bSuccessfulAssignment)
				Self.HQTrace("  Player selected department " + SelectedDepartment as string + " for " + actActor as string + ", attempting assignment...", 0, False)
				bSuccessfulAssignment = SelectedDepartment.HandleManualAssignment(actActor)
				If (bSuccessfulAssignment)
					simsettlementsv2:hq:library:objectrefs:hqdata thisDataStore = HQManager.HQ_API_GetHQDataStoreFromWorkshop(thisWorkshop)
					If (thisDataStore)
						int iDataStoreWorkerIndex = thisDataStore.FindTrackedWorker(intResult)
						If (iDataStoreWorkerIndex >= 0)
							thisDataStore.marrWorkers[iDataStoreWorkerIndex].Department = SelectedDepartment
						EndIf
					EndIf
				Else
					Warning_RequestedDepartmentIsFull.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
					SelectedDepartment = Self._ShowDeparmentSelectionMenu(thisWorkshop)
				EndIf
			EndWhile
		EndIf
		HUDManager.ShowPanel(HUDManager.iPanelID_HQ)
	Else
		Debug.Notification("Failed sending to HQ")
		Self.HQTrace("  Something went wrong when registering " + actActor as string + " as an HQ worker: " + intResult as string, 0, False)
	EndIf
EndEvent

Function HandleQuestInit()
	Parent.HandleQuestInit()
	Self.StartHQUserLog("HQWrkMgrQst", True, False)
	Self.HQTrace("HandleEvent:OnQuestInit()", 0, False)
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopAddActor")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopRemoveActor")
	HUDManager.Stop()
	Utility.Wait(0.1)
	HUDManager.Start()
EndFunction

int Function _RegisterWorker(Actor pactWorker, workshopscript pkHQRef, bool pbAutoAssign)
	Self.HQTrace(" _RegisterWorker(" + pactWorker as string + ", " + pkHQRef as string + ")", 0, False)
	If (!pactWorker)
		return Self.ERC_INVALID_PARAMETER
	EndIf
	simsettlementsv2:hq:library:objectrefs:hqdata thisDataStore = HQManager.HQ_API_GetHQDataStoreFromWorkshop(pkHQRef)
	If (!thisDataStore)
		return Self.ERC_HQREF_NOT_ESTABLISHED
	EndIf
	int intWorkerID = pactWorker.GetValue(SS2_HQWorkerID) as int
	If (intWorkerID > 0 && thisDataStore.IsTrackedWorker(intWorkerID))
		return intWorkerID
	EndIf
	If (thisDataStore.CanAddNewWorker())
		simsettlementsv2:hq:library:hqdatastructures#hqworkerstruct vntWorker = Self._ConvertSettlerToWorker(pactWorker)
		If (pbAutoAssign)
			vntWorker.Department = Self._TryToAutoAssignDepartment(pactWorker, pkHQRef)
		EndIf
		If (thisDataStore.marrWorkers == None)
			thisDataStore.marrWorkers = new simsettlementsv2:hq:library:hqdatastructures#hqworkerstruct[0]
		EndIf
		thisDataStore.marrWorkers.add(vntWorker, 1)
		return vntWorker.WorkerID
	Else
		return Self.ERC_WORKER_LIST_FULL
	EndIf
EndFunction

Function _InsertIntoOrderedAVM(workshopframework:library:datastructures#actorvaluemap[] parrMap, workshopframework:library:datastructures#actorvaluemap pvntValue)
	If (parrMap.length == 0)
		parrMap.add(pvntValue, 1)
		return 
	EndIf
	int I = 0
	While (I < parrMap.length)
		If (parrMap[I].fValue < pvntValue.fValue)
			parrMap.insert(pvntValue, I - 1)
			return 
		EndIf
		I += 1
	EndWhile
	parrMap.insert(pvntValue, I - 1)
EndFunction

Function _RegisterDepartmentStatDisplayForms(simsettlementsv2:hq:library:objectrefs:departmentobject akDepartmentRef)
	If (akDepartmentRef != None && akDepartmentRef.UniqueStatAV_NameHolderForm_Abbreviation != None && akDepartmentRef.UniqueStatAV_DummyForm != None)
		simsettlementsv2:hq:library:hqdatastructures#statdisplayforms newEntry = new simsettlementsv2:hq:library:hqdatastructures#statdisplayforms
		newEntry.StatAV = akDepartmentRef.ResourceProvidedFromStat
		newEntry.NameHolderForm_StatAbbreviation = akDepartmentRef.UniqueStatAV_NameHolderForm_Abbreviation
		newEntry.DummyForm = akDepartmentRef.UniqueStatAV_DummyForm
		Self._RegisterStatDisplayMap(newEntry)
	EndIf
EndFunction

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
	Self.HQTrace("HandleEvent:OnPlayerGameLoad()", 0, False)
	Self._UpdateVars()
	Self._SanityCheck()
EndFunction

int Function _UnregisterWorker(Actor pactWorker, workshopscript pkHQRef)
	Self.HQTrace(" _UnregisterWorker(" + pactWorker as string + ")", 0, False)
	If (!pactWorker)
		return Self.ERC_INVALID_PARAMETER
	EndIf
	simsettlementsv2:hq:library:objectrefs:hqdata thisDataStore = HQManager.HQ_API_GetHQDataStoreFromWorkshop(pkHQRef)
	If (!thisDataStore)
		return Self.ERC_HQREF_NOT_ESTABLISHED
	EndIf
	int intWorkerID = pactWorker.GetValue(SS2_HQWorkerID) as int
	int intWorkerArrayIndex = thisDataStore.FindTrackedWorker(intWorkerID)
	If (intWorkerArrayIndex > 0)
		Self._ConvertWorkerToSettler(pactWorker)
		thisDataStore.marrWorkers.remove(intWorkerArrayIndex, 1)
		Self._UnassignFromDepartment(pactWorker)
		return 1
	Else
		return Self.ERC_INVALID_PARAMETER
	EndIf
EndFunction

Function _UnassignFromDepartment(Actor packWorker)
	Self.HQTrace("   _UnassignFromDepartment(" + packWorker as string + ")", 0, False)
	simsettlementsv2:hq:library:objectrefs:departmentobject kDepartmentRef = packWorker.GetLinkedRef(SS2_Link_AssignedDepartment) as simsettlementsv2:hq:library:objectrefs:departmentobject
	If (kDepartmentRef == None)
		workshopscript thisWorkshop = packWorker.GetLinkedRef(WorkshopItemKeyword) as workshopscript
		int iWorkerID = packWorker.GetValue(SS2_HQWorkerID) as int
		simsettlementsv2:hq:library:objectrefs:hqdata thisDataStore = HQManager.HQ_API_GetHQDataStoreFromWorkshop(thisWorkshop)
		If (thisDataStore)
			simsettlementsv2:hq:library:hqdatastructures#hqworkerstruct WorkerData = thisDataStore.GetTrackedWorkerData(iWorkerID)
			If (WorkerData != None)
				kDepartmentRef = WorkerData.Department
			EndIf
		EndIf
	EndIf
	If (kDepartmentRef != None)
		kDepartmentRef.UnassignNPCFromDepartment(packWorker, False)
	EndIf
EndFunction

workshopframework:library:datastructures#actorvaluemap[] Function _GetOrderedStats(simsettlementsv2:hq:library:hqdatastructures#hqworkerstruct pvntWorker)
	Self.HQTrace("   _GetBestStats(" + pvntWorker as string + ")", 0, False)
	workshopframework:library:datastructures#actorvaluemap[] arrAVs = new workshopframework:library:datastructures#actorvaluemap[0]
	Self._InsertIntoOrderedAVM(arrAVs, Self._BuildAVMap(Strength, pvntWorker.Strength))
	Self._InsertIntoOrderedAVM(arrAVs, Self._BuildAVMap(Perception, pvntWorker.Perception))
	Self._InsertIntoOrderedAVM(arrAVs, Self._BuildAVMap(Endurance, pvntWorker.Endurance))
	Self._InsertIntoOrderedAVM(arrAVs, Self._BuildAVMap(Charisma, pvntWorker.Charisma))
	Self._InsertIntoOrderedAVM(arrAVs, Self._BuildAVMap(Intelligence, pvntWorker.Intelligence))
	Self._InsertIntoOrderedAVM(arrAVs, Self._BuildAVMap(Agility, pvntWorker.Agility))
	Self._InsertIntoOrderedAVM(arrAVs, Self._BuildAVMap(Luck, pvntWorker.Luck))
	return arrAVs
EndFunction

simsettlementsv2:hq:library:objectrefs:departmentobject Function _TryToAutoAssignDepartment(Actor pkActorRef, workshopscript pkHQRef)
	Self.HQTrace("   _TryToAutoAssignDepartment(" + pkActorRef as string + ", " + pkHQRef as string + ")", 0, False)
	If (!pkActorRef)
		return None
	EndIf
	simsettlementsv2:hq:library:objectrefs:hqdata thisDataStore = HQManager.HQ_API_GetHQDataStoreFromWorkshop(pkHQRef)
	If (!thisDataStore)
		return None
	EndIf
	workshopframework:library:datastructures#actorvaluemap[] arrStats = Self._GetActorsTrackedStats(pkActorRef, True, True)
	simsettlementsv2:hq:library:objectrefs:departmentobject[] RegisteredDepartments = thisDataStore.marrRegisteredDepartments
	int j = 0
	While (j < arrStats.length)
		int I = 0
		While (I < RegisteredDepartments.length)
			If (RegisteredDepartments[I].ResourceProvidedFromStat == arrStats[j].ActorValueForm)
				If (RegisteredDepartments[I].TryToAssignNPCToDepartment(pkActorRef, True))
					return RegisteredDepartments[I]
				EndIf
			EndIf
			I += 1
		EndWhile
		j += 1
	EndWhile
	return None
EndFunction

Function _ConvertWorkerToSettler(Actor pactSettler)
	workshopframework:workshopfunctions.SetAllowCaravan(pactSettler, True)
	HQWorkerApply.RemoveFromRef(pactSettler as ObjectReference)
	NPCManager.WorkshopActorApply.ApplyToRef(pactSettler as ObjectReference)
	pactSettler.SetValue(SS2_HQWorkerID, 0)
EndFunction

int Function HQ_API_UnregisterWorker(Actor pactWorker, workshopscript pkHQRef)
	Self.HQTrace("HQ_API_UnregisterWorker(" + pactWorker as string + ", " + pkHQRef as string + ")", 0, False)
	int intLockKey = Self.GetLock(0, True)
	int intResult = 0
	If (intLockKey > 0)
		intResult = Self._UnregisterWorker(pactWorker, pkHQRef)
		Self.ReleaseLock(intLockKey)
	Else
		intResult = Self.ERC_FAILED_TO_LOCK_QUEST
	EndIf
	return intResult
EndFunction

workshopframework:library:datastructures#actorvaluemap Function _BuildAVMap(ActorValue pavlActorValue, float pfltValue)
	workshopframework:library:datastructures#actorvaluemap avmTemp = new workshopframework:library:datastructures#actorvaluemap
	avmTemp.ActorValueForm = pavlActorValue
	avmTemp.fValue = pfltValue
	return avmTemp
EndFunction

int Function HQ_API_EvaluatePersonnelRequest(simsettlementsv2:hq:library:hqdatastructures#hqpersonnelrequirementsstruct[] parrPersonnelRequest)
	Self.HQTrace("HQ_API_EvaluatePersonnelRequest(" + parrPersonnelRequest as string + ")", 0, False)
	int intLockKey = Self.GetLock(0, True)
	int intResult = 0
	If (intLockKey > 0)
		intResult = Self._EvaluatePersonnelRequest(parrPersonnelRequest)
		Self.ReleaseLock(intLockKey)
	Else
		intResult = Self.ERC_FAILED_TO_LOCK_QUEST
	EndIf
	return intResult
EndFunction

Function _ResetBarterAssignment()
	AssignmentBarterSelectionFormlist.Revert()
	AssignmentBarterContainer.GetRef().RemoveAllItems(None, False)
	int I = 0
	While (I < StatDisplayAliasMaps.length)
		StatDisplayAliasMaps[I].PutNPCInAlias.Clear()
		StatDisplayAliasMaps[I].PutSelectorInAlias.Clear()
		I += 1
	EndWhile
EndFunction

Function _SanityCheck()
	Self.HQTrace(" _SanityCheck()", 0, False)
EndFunction

simsettlementsv2:hq:library:objectrefs:departmentobject Function _ShowDeparmentSelectionMenu(workshopscript pkHQRef)
	Self.HQTrace(" _ShowDeparmentSelectionMenu(" + pkHQRef as string + ")", 0, False)
	simsettlementsv2:hq:library:objectrefs:hqdata thisDataStore = HQManager.HQ_API_GetHQDataStoreFromWorkshop(pkHQRef)
	If (!thisDataStore)
		return None
	EndIf
	Form[] DepartmentOptions = new Form[0]
	simsettlementsv2:hq:library:objectrefs:departmentobject[] RegisteredDepartments = thisDataStore.marrRegisteredDepartments
	If (RegisteredDepartments == None || RegisteredDepartments.length == 0)
		return None
	EndIf
	int I = 0
	While (I < RegisteredDepartments.length)
		DepartmentOptions.add(RegisteredDepartments[I].GetBaseObject(), 1)
		I += 1
	EndWhile
	int iSelected = UIManager.ShowMessageSelectorMenuAndWait(DepartmentOptions, NameHolderForm_ChooseADepartment, None)
	If (iSelected >= 0)
		return RegisteredDepartments[iSelected]
	EndIf
	return None
EndFunction

int Function _EvaluatePersonnelRequest(simsettlementsv2:hq:library:hqdatastructures#hqpersonnelrequirementsstruct[] parrPersonnelRequest)
	Self.HQTrace(" _EvaluateWorkOrder(" + parrPersonnelRequest as string + ")", 0, False)
	return 0
EndFunction

Function HQ_API_ShowAssignDepartmentWorkersMenu(simsettlementsv2:hq:library:objectrefs:departmentobject akDepartment, bool abUnassignedOnly)
	If (akDepartment == None)
		Debug.MessageBox("Invalid department object")
		return 
	EndIf
	Actor[] HQWorkers = new Actor[0]
	workshopscript thisWorkshop = workshopframework:wsfw_api.GetNearestWorkshop(akDepartment as ObjectReference)
	If (thisWorkshop == None)
		return 
	EndIf
	HQWorkers = Self._GetSettlers(thisWorkshop, True)
	If (HQWorkers.length == 0)
		Debug.MessageBox("No workers found")
		return 
	EndIf
	If (bBarterAssignmentInterfaceInUse)
		return 
	EndIf
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Called ShowAssignDepartmentWorkersMenu", 0, False)
	SS2_Notification_GeneratingHQAssignmentMenu.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	bBarterAssignmentInterfaceInUse = True
	Form TargetDepartmentBaseForm = akDepartment.GetBaseObject()
	ObjectReference kSafeSpawnPointRef = SafeSpawnPoint.GetRef()
	ObjectReference kBarterContainerRef = AssignmentBarterContainer.GetRef()
	kBarterContainerRef.RemoveAllItems(None, False)
	ActorValue TargetDepartmentStatAV = akDepartment.ResourceProvidedFromStat
	int iTargetDepartmentStatDisplayMapIndex = StatDisplayMaps.findstruct("StatAV", TargetDepartmentStatAV, 0)
	Form BaseWeaponForm = StatDisplayMaps[iTargetDepartmentStatDisplayMapIndex].DummyForm
	Form TargetDepartmentStatAbbreviationForm = StatDisplayMaps[iTargetDepartmentStatDisplayMapIndex].NameHolderForm_StatAbbreviation
	simsettlementsv2:hq:library:objectrefs:departmentobject[] kDepartmentRefs = simsettlementsv2:hq:library:hqutilityfunctions.GetDepartmentsFromLocation(akDepartment.GetCurrentLocation(), True)
	int I = 0
	Actor[] kDepartmentHeadRefs = new Actor[0]
	While (I < kDepartmentRefs.length)
		kDepartmentHeadRefs.add(kDepartmentRefs[I].DepartmentHead, 1)
		I += 1
	EndWhile
	I = 0
	int iPresentingWorkers = 0
	While (I < HQWorkers.length)
		simsettlementsv2:hq:library:objectrefs:departmentobject kAssignedDepartment = HQWorkers[I].GetLinkedRef(SS2_Link_AssignedDepartment) as simsettlementsv2:hq:library:objectrefs:departmentobject
		If (kDepartmentHeadRefs.find(HQWorkers[I], 0) < 0 && (!abUnassignedOnly || kAssignedDepartment == None || kAssignedDepartment == akDepartment))
			float[] thisWorkersStats = Self._GetActorsTrackedStatValues(HQWorkers[I], False)
			int iHighestStatIndex = -1
			float fCurrentHighestStat = 0 as float
			int j = 0
			While (j < thisWorkersStats.length)
				If (thisWorkersStats[j] > fCurrentHighestStat)
					fCurrentHighestStat = thisWorkersStats[j]
					iHighestStatIndex = j
				EndIf
				j += 1
			EndWhile
			bool bHighestStatTiedWithTargetStat = False
			If (thisWorkersStats[iTargetDepartmentStatDisplayMapIndex] == fCurrentHighestStat)
				bHighestStatTiedWithTargetStat = True
				BaseWeaponForm = StatDisplayMaps[iTargetDepartmentStatDisplayMapIndex].DummyForm
			Else
				BaseWeaponForm = StatDisplayMaps[iHighestStatIndex].DummyForm
			EndIf
			ObjectReference kNameRef = kSafeSpawnPointRef.PlaceAtMe(BaseWeaponForm, 1, False, False, True)
			If (kNameRef != None)
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Adding " + kNameRef as string + " to barter assign screen.", 0, False)
				kNameRef.AddTextReplacementData("TarDepStatAbbr", TargetDepartmentStatAbbreviationForm)
				int iTargetDepartmentStatValue = thisWorkersStats[iTargetDepartmentStatDisplayMapIndex] as int
				ActorValue CurrentDepartmentStatAV = None
				int iCurrentDepartmentStatValue = 0
				int iCurrentDepartmentStatDisplayMapIndex = -1
				If (kAssignedDepartment != None)
					CurrentDepartmentStatAV = kAssignedDepartment.ResourceProvidedFromStat
					iCurrentDepartmentStatDisplayMapIndex = StatDisplayMaps.findstruct("StatAV", CurrentDepartmentStatAV, 0)
					iCurrentDepartmentStatValue = thisWorkersStats[iCurrentDepartmentStatDisplayMapIndex] as int
					kNameRef.AddTextReplacementData("CurDepStatAbbr", StatDisplayMaps[iCurrentDepartmentStatDisplayMapIndex].NameHolderForm_StatAbbreviation)
					kNameRef.AddTextReplacementData("CurrentDepartment", kAssignedDepartment.GetBaseObject())
				Else
					iCurrentDepartmentStatValue = fCurrentHighestStat as int
					If (bHighestStatTiedWithTargetStat)
						kNameRef.AddTextReplacementData("CurDepStatAbbr", TargetDepartmentStatAbbreviationForm)
					Else
						kNameRef.AddTextReplacementData("CurDepStatAbbr", StatDisplayMaps[iHighestStatIndex].NameHolderForm_StatAbbreviation)
					EndIf
					kNameRef.AddTextReplacementData("CurrentDepartment", NameHolderForm_Unassigned)
				EndIf
				If (CurrentDepartmentStatAV == TargetDepartmentStatAV && iCurrentDepartmentStatValue != iTargetDepartmentStatValue)
					workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found stat mismatch. " + HQWorkers[I] as string + ", stats = " + thisWorkersStats as string + ". Iteration is reporting current value of " + CurrentDepartmentStatAV as string + " = " + iCurrentDepartmentStatValue as string + ", and " + TargetDepartmentStatAV as string + " = " + iTargetDepartmentStatValue as string, 0, False)
				EndIf
				StatDisplayAliasMaps[iPresentingWorkers].PutNPCInAlias.ForceRefTo(HQWorkers[I] as ObjectReference)
				StatDisplayAliasMaps[iPresentingWorkers].PutSelectorInAlias.ForceRefTo(kNameRef)
				StatDisplayAliasMaps[iPresentingWorkers].gCurrentDepartmentStat.SetValueInt(iCurrentDepartmentStatValue)
				Self.UpdateCurrentInstanceGlobal(StatDisplayAliasMaps[iPresentingWorkers].gCurrentDepartmentStat)
				StatDisplayAliasMaps[iPresentingWorkers].gTargetDepartmentStat.SetValueInt(iTargetDepartmentStatValue)
				Self.UpdateCurrentInstanceGlobal(StatDisplayAliasMaps[iPresentingWorkers].gTargetDepartmentStat)
				kBarterContainerRef.AddItem(kNameRef as Form, 1, False)
				If (kAssignedDepartment == akDepartment)
					AssignmentBarterHelperFormlist.AddForm(kNameRef as Form)
				EndIf
				iPresentingWorkers += 1
			EndIf
		EndIf
		I += 1
	EndWhile
	If (iPresentingWorkers > 0)
		Keyword[] FilterKeywords = new Keyword[1]
		FilterKeywords[0] = AssignmentBarterFormTag
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Calling UIManager.ShowCachedBarterSelectMenuAndWait with a container that has " + kBarterContainerRef.GetItemCount(None) as string + " items, and a formlist with " + AssignmentBarterHelperFormlist.GetSize() as string + " items.", 0, False)
		int iResult = UIManager.ShowCachedBarterSelectMenuAndWait(TargetDepartmentBaseForm, kBarterContainerRef, AssignmentBarterSelectionFormlist, FilterKeywords, 2, AssignmentBarterHelperFormlist, True, True, 600)
		If (iResult > 0)
			PlayerRef.RemoveItem(AssignmentBarterFormTag as Form, -1, True, None)
			Self._HandleBarterAssignment(akDepartment)
			Self._ResetBarterAssignment()
		EndIf
	Else
		Debug.MessageBox("No workers found ")
	EndIf
	bBarterAssignmentInterfaceInUse = False
EndFunction

Function SendWorkerAssignedToDepartmentEvent(Actor akActorRef, simsettlementsv2:hq:library:objectrefs:departmentobject akDepartmentRef, workshopscript akHQRef)
	If (akHQRef == None)
		akHQRef = akDepartmentRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	EndIf
	var[] kArgs = new var[0]
	kArgs.add(akActorRef as var, 1)
	kArgs.add(akDepartmentRef as var, 1)
	kArgs.add(akHQRef as var, 1)
	Self.SendCustomEvent("simsettlementsv2:hq:hqworkermanagerquest_WorkerAssignedToDepartment", kArgs)
EndFunction

int Function HQ_API_RegisterWorker(Actor pactWorker, workshopscript pkHQRef, bool pbAutoAssign)
	Self.HQTrace("HQ_API_RegisterWorker(" + pactWorker as string + ")", 0, False)
	int intLockKey = Self.GetLock(0, True)
	int intResult = 0
	If (intLockKey > 0)
		intResult = Self._RegisterWorker(pactWorker, pkHQRef, pbAutoAssign)
		Self.ReleaseLock(intLockKey)
	Else
		intResult = Self.ERC_FAILED_TO_LOCK_QUEST
	EndIf
	return intResult
EndFunction

Function SendWorkerRemovedFromDepartmentEvent(Actor akActorRef, simsettlementsv2:hq:library:objectrefs:departmentobject akDepartmentRef, workshopscript akHQRef)
	If (akHQRef == None)
		akHQRef = akDepartmentRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	EndIf
	var[] kArgs = new var[0]
	kArgs.add(akActorRef as var, 1)
	kArgs.add(akDepartmentRef as var, 1)
	kArgs.add(akHQRef as var, 1)
	Self.SendCustomEvent("simsettlementsv2:hq:hqworkermanagerquest_WorkerRemovedFromDepartment", kArgs)
EndFunction

float[] Function _GetActorsTrackedStatValues(Actor pkActorRef, bool abIgnoreModifiers)
	workshopframework:library:datastructures#actorvaluemap[] TrackedStats = Self._GetActorsTrackedStats(pkActorRef, abIgnoreModifiers, False)
	float[] StatValues = new float[0]
	int I = 0
	While (I < TrackedStats.length)
		StatValues.add(TrackedStats[I].fValue, 1)
		I += 1
	EndWhile
	return StatValues
EndFunction

simsettlementsv2:hq:library:hqdatastructures#hqworkerstruct Function _ConvertSettlerToWorker(Actor pactSettler)
	Self.HQTrace("   _ConvertSettlerToWorker(" + pactSettler as string + ")", 0, False)
	workshopframework:workshopfunctions.SetAllowCaravan(pactSettler, False)
	NPCManager.WorkshopActorApply.RemoveFromRef(pactSettler as ObjectReference)
	WorkshopParent.WorkshopActorApply.RemoveFromRef(pactSettler as ObjectReference)
	HQWorkerApply.ApplyToRef(pactSettler as ObjectReference)
	simsettlementsv2:hq:library:hqdatastructures#hqworkerstruct vntWorker = new simsettlementsv2:hq:library:hqdatastructures#hqworkerstruct
	vntWorker.Strength = pactSettler.GetBaseValue(Strength)
	vntWorker.Perception = pactSettler.GetBaseValue(Perception)
	vntWorker.Endurance = pactSettler.GetBaseValue(Endurance)
	vntWorker.Charisma = pactSettler.GetBaseValue(Charisma)
	vntWorker.Intelligence = pactSettler.GetBaseValue(Intelligence)
	vntWorker.Agility = pactSettler.GetBaseValue(Agility)
	vntWorker.Luck = pactSettler.GetBaseValue(Luck)
	vntWorker.WorkerID = Self._NextWorkerID
	pactSettler.SetValue(SS2_HQWorkerID, vntWorker.WorkerID as float)
	return vntWorker
EndFunction

Function _UpdateVars()
	int I = 0
	While (I < DefaultStatDisplayMaps.length)
		Self._RegisterStatDisplayMap(DefaultStatDisplayMaps[I])
		I += 1
	EndWhile
EndFunction

Actor[] Function _GetSettlers(workshopscript akWorkshopRef, bool abIncludePermanent)
	simsettlementsv2:quests:mi:grabnpcs NPCGrabber = (Self as Quest) as simsettlementsv2:quests:mi:grabnpcs
	return NPCGrabber.GetSettlers(akWorkshopRef, abIncludePermanent)
EndFunction

workshopframework:library:datastructures#actorvaluemap[] Function _GetActorsTrackedStats(Actor pkActorRef, bool abIgnoreModifiers, bool abSortBestToWorst)
	workshopframework:library:datastructures#actorvaluemap[] Stats = new workshopframework:library:datastructures#actorvaluemap[0]
	int I = 0
	While (I < StatDisplayMaps.length)
		If (abIgnoreModifiers)
			Stats.add(Self._BuildAVMap(StatDisplayMaps[I].StatAV, pkActorRef.GetValue(StatDisplayMaps[I].StatAV)), 1)
		Else
			Stats.add(Self._BuildAVMap(StatDisplayMaps[I].StatAV, pkActorRef.GetValue(StatDisplayMaps[I].StatAV)), 1)
		EndIf
		I += 1
	EndWhile
	If (abSortBestToWorst)
		workshopframework:library:datastructures#actorvaluemap[] Sorted = new workshopframework:library:datastructures#actorvaluemap[0]
		I = 0
		While (I < Stats.length)
			Self._InsertIntoOrderedAVM(Sorted, Stats[I])
			I += 1
		EndWhile
		return Sorted
	EndIf
	return Stats
EndFunction

Function _RegisterStatDisplayMap(simsettlementsv2:hq:library:hqdatastructures#statdisplayforms aDisplayFormMap)
	If (StatDisplayMaps == None)
		StatDisplayMaps = new simsettlementsv2:hq:library:hqdatastructures#statdisplayforms[0]
	EndIf
	int iIndex = StatDisplayMaps.findstruct("StatAV", aDisplayFormMap.StatAV, 0)
	If (iIndex < 0)
		StatDisplayMaps.add(aDisplayFormMap, 1)
	EndIf
EndFunction

Event WorkshopParentScript.WorkshopRemoveActor(workshopparentscript akSender, var[] akArgs)
	Self.HQTrace("HandleEvent:WorkshopRemoveActor(" + Self as string + ", " + akArgs as string + ")", 0, False)
	Actor thisActor = akArgs[0] as Actor
	workshopscript thisWorkshop = akArgs[1] as workshopscript
	Location thisLocation = thisWorkshop.myLocation
	If (thisLocation.GetKeywordData(HQLocationKeyword) >= 0 as float)
		int intResult = Self.HQ_API_UnregisterWorker(thisActor, thisWorkshop)
	EndIf
EndEvent

Function SendDepartmentHeadChangedEvent(simsettlementsv2:hq:library:objectrefs:departmentobject akDepartmentRef, Actor akPreviousDepartmentHead, Actor akNewDepartmentHead, workshopscript akHQRef)
	If (akHQRef == None)
		akHQRef = akDepartmentRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	EndIf
	var[] kArgs = new var[0]
	kArgs.add(akDepartmentRef as var, 1)
	kArgs.add(akPreviousDepartmentHead as var, 1)
	kArgs.add(akNewDepartmentHead as var, 1)
	kArgs.add(akHQRef as var, 1)
	Self.SendCustomEvent("simsettlementsv2:hq:hqworkermanagerquest_DepartmentHeadChanged", kArgs)
EndFunction

Function _HandleBarterAssignment(simsettlementsv2:hq:library:objectrefs:departmentobject akDepartment)
	int iSelected = AssignmentBarterSelectionFormlist.GetSize()
	ObjectReference[] kFoundRefs = new ObjectReference[0]
	Actor[] kAssignActors = new Actor[0]
	int I = 0
	While (I < iSelected)
		ObjectReference thisRef = AssignmentBarterSelectionFormlist.GetAt(I) as ObjectReference
		If (thisRef != None)
			kFoundRefs.add(thisRef, 1)
		EndIf
		I += 1
	EndWhile
	I = 0
	While (I < StatDisplayAliasMaps.length)
		int iIndex = kFoundRefs.find(StatDisplayAliasMaps[I].PutSelectorInAlias.GetRef(), 0)
		If (iIndex >= 0)
			kAssignActors.add(StatDisplayAliasMaps[I].PutNPCInAlias.GetActorRef(), 1)
		EndIf
		I += 1
	EndWhile
	ObjectReference[] PreviousDepartmentWorkers = akDepartment.GetLinkedRefChildren(SS2_Link_AssignedDepartment)
	Actor kDepartmentHeadRef = akDepartment.GetAssignedNPC()
	I = 0
	While (I < PreviousDepartmentWorkers.length)
		Actor thisWorker = PreviousDepartmentWorkers[I] as Actor
		If (thisWorker != None)
			int iAssignIndex = kAssignActors.find(thisWorker, 0)
			If (iAssignIndex >= 0)
				kAssignActors.remove(iAssignIndex, 1)
			ElseIf (thisWorker != kDepartmentHeadRef)
				akDepartment.UnassignNPCFromDepartment(thisWorker, True)
			EndIf
		EndIf
		I += 1
	EndWhile
	I = 0
	While (I < kAssignActors.length)
		akDepartment.AssignNPCToDepartment(kAssignActors[I], True, True)
		I += 1
	EndWhile
	akDepartment.UpdateWorkerStatResources()
	HUDManager.UpdateHQDepartmentArray(simsettlementsv2:hq:library:hqutilityfunctions.GetDepartmentsFromLocation(akDepartment.GetCurrentLocation(), True))
	akDepartment.DistributeWorkersToRooms()
EndFunction
