;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\HQ\Library\MiscObjects\HQActionGroup.psc
Modified : 2021-01-19 23:53:03
Compiled : 2021-01-29 16:31:06
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:HQ:Library:MiscObjects:HQActionGroup extends SimSettlementsV2:HQ:Library:HQMiscObject Const

;-- Properties --------------------------------------
Group BASE_PROPERTIES
	FormList Property RegisteredActions Auto Const mandatory
	{ The formlist containing all registered actions contained in this group }
	FormList Property UnlockedActions Auto Const mandatory
	{ The formlist containing the unlocked actions contained in this group }
	FormList Property CompletedActions Auto Const mandatory
	{ The formlist containing the completed actions contained in this group }
	FormList Property Prerequisites Auto Const mandatory
	{ The formlist containing prerequisites for actions registered to this group.  The action group will re-evaluate upon a prerequisite sending particular events. }
EndGroup

int Property ERC_ACTION_ALREADY_REGISTERED = -1 AutoReadOnly hidden

;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

Function _SendActionRegisteredEvent(simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction pactAction)
	var[] arrParams = new var[2]
	arrParams[0] = pactAction as var
	arrParams[1] = Prerequisites as var
	Self.SendCustomEvent("simsettlementsv2:hq:library:miscobjects:hqactiongroup_HQActionRegistered", arrParams)
EndFunction

simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction Function SelectAction(bool pblnShowAllRegistered, bool pblnUseMessageSelector, Keyword pkwdFilterKeyword)
	Self.HQTrace("SelectAction(" + pblnShowAllRegistered as string + ", " + pblnUseMessageSelector as string + ", " + pkwdFilterKeyword as string + ")", 0, False)
	workshopframework:uimanager UIManagerQuest = simsettlementsv2:hq:library:hqutilityfunctions.GetUIManagerQuest()
	simsettlementsv2:hq:hqactionmanagerquest ActionManagerQuest = simsettlementsv2:hq:library:hqutilityfunctions.GetActionManagerQuest()
	If (!ActionManagerQuest)
		Debug.Notification("Failed to retrieve ActionManager quest")
		Self.HQTrace("  Failed to retrieve ActionManager quest!", 2, False)
	EndIf
	FormList UISelectionHelperFormlist = ActionManagerQuest.SS2_HQUISelectionHelperFormlist
	If (UIManagerQuest)
		int intResult = 0
		FormList fmlList = None
		If (pblnShowAllRegistered)
			fmlList = RegisteredActions
		Else
			fmlList = UnlockedActions
		EndIf
		If (pblnUseMessageSelector)
			FormList aSelectFromOptionsList = fmlList
			If (pkwdFilterKeyword != None)
				UISelectionHelperFormlist.Revert()
				workshopframework:library:utilityfunctions.FilterFormlistByKeywordToFormlist(aSelectFromOptionsList, pkwdFilterKeyword, UISelectionHelperFormlist)
				aSelectFromOptionsList = UISelectionHelperFormlist
			EndIf
			intResult = UIManagerQuest.ShowMessageSelectorMenuFormlistAndWait(aSelectFromOptionsList, Self as Form, None)
			If (intResult >= 0)
				return aSelectFromOptionsList.GetAt(intResult) as simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction
			EndIf
		Else
			ObjectReference kCacheRef = ActionManagerQuest.GetActionGroupCacheContainer(Self)
			Keyword[] FilterKeywords = new Keyword[0]
			If (pkwdFilterKeyword != None)
				FilterKeywords.add(pkwdFilterKeyword, 1)
			EndIf
			UISelectionHelperFormlist.Revert()
			If (kCacheRef)
				intResult = UIManagerQuest.ShowCachedBarterSelectMenuAndWait(Self as Form, kCacheRef, UISelectionHelperFormlist, FilterKeywords, 2, None, False, False, 60)
			Else
				intResult = UIManagerQuest.ShowFormlistBarterSelectMenuAndWait(Self as Form, fmlList, UISelectionHelperFormlist, FilterKeywords, 2, None, False, False, 60)
			EndIf
			If (intResult >= 0)
				If (UISelectionHelperFormlist.GetSize() == 0)
					Self.HQTrace("    Barter menu displayed, but Player didn't make a selection.", 2, False)
					intResult = -1
				Else
					return UISelectionHelperFormlist.GetAt(0) as simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction
				EndIf
			EndIf
		EndIf
		If (intResult < 0)
			Self.HQTrace("    Failed to make selection selection!", 2, False)
			Debug.Notification("Failed to make a selection")
		EndIf
	Else
		Debug.Notification("Failed to retrieve UIManager quest")
		Self.HQTrace("  Failed to retrieve UIManager quest!", 2, False)
	EndIf
	return None
EndFunction

int Function Register()
	Self.HQTrace("Register()", 0, False)
	simsettlementsv2:hq:hqactionmanagerquest HQActionManagerQuest = simsettlementsv2:hq:library:hqutilityfunctions.GetActionManagerQuest()
	return HQActionManagerQuest.HQ_API_RegisterActionGroup(Self)
EndFunction

Function EvaluateActions(bool pblnWait)
	Self.HQTrace("EvaluateActions(" + pblnWait as string + ")", 0, False)
	int I = RegisteredActions.GetSize()
	ScriptObject scoAction = None
	While (I > 0)
		I -= 1
		scoAction = RegisteredActions.GetAt(I).CastAs("simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction")
		If (!scoAction)
			Self.HQTrace("  Could not cast " + RegisteredActions.GetAt(I) as string + " as an SimSettlementsV2:HQ:Library:MiscObjects:RequirementTypes:HQAction", 0, False)
		ElseIf (pblnWait)
			scoAction.CallFunction("Evaluate", None)
		Else
			scoAction.CallFunctionNoWait("Evaluate", None)
		EndIf
	EndWhile
	Self._SendEvaluationCompletedEvent()
EndFunction

int Function RegisterAction(simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction pactAction)
	Self.HQTrace("RegisterAction(" + pactAction as string + ")", 0, False)
	int intResult = Self.Register()
	If (intResult >= 0)
		If (!RegisteredActions.HasForm(pactAction as Form))
			RegisteredActions.AddForm(pactAction as Form)
			intResult = 0
			Self._SendActionRegisteredEvent(pactAction)
		Else
			intResult = Self.ERC_ACTION_ALREADY_REGISTERED
		EndIf
	EndIf
	return intResult
EndFunction

Function UnlockAction(simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction pactAction)
	Self.HQTrace("UnlockAction(" + pactAction as string + ")", 0, False)
	If (!UnlockedActions.HasForm(pactAction as Form))
		UnlockedActions.AddForm(pactAction as Form)
	EndIf
EndFunction

string Function LogName()
	return "HQActionGroup"
EndFunction

Function _SendEvaluationCompletedEvent()
	Self.SendCustomEvent("simsettlementsv2:hq:library:miscobjects:hqactiongroup_HQEvaluationCompleted", None)
EndFunction

Function RelockAction(simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction pactAction)
	Self.HQTrace("RelockAction(" + pactAction as string + ")", 0, False)
	If (UnlockedActions.HasForm(pactAction as Form))
		UnlockedActions.RemoveAddedForm(pactAction as Form)
	EndIf
EndFunction

Function CleanFormLists()
	Self.HQTrace("CleanFormlists()", 0, False)
	If (CompletedActions)
		workshopframework:library:utilityfunctions.CleanFormList(CompletedActions, -1)
	Else
		Self.HQTrace("  Invalid action group! Missing completed actions formlist!", 2, False)
	EndIf
	If (UnlockedActions)
		workshopframework:library:utilityfunctions.CleanFormList(UnlockedActions, -1)
	Else
		Self.HQTrace("  Invalid action group! Missing unlocked actions formlist!", 2, False)
	EndIf
	If (RegisteredActions)
		workshopframework:library:utilityfunctions.CleanFormList(RegisteredActions, -1)
	Else
		Self.HQTrace("  Invalid action group! Missing registered actions formlist!", 2, False)
	EndIf
	If (Prerequisites)
		workshopframework:library:utilityfunctions.CleanFormList(Prerequisites, -1)
	Else
		Self.HQTrace("  Invalid action group! Missing prerequisites formlist!", 2, False)
	EndIf
EndFunction

string Function Postfix()
	return Self.GetFormID() as string
EndFunction
