;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\HQ\Library\MiscObjects\HQRequirement.psc
Modified : 2021-01-09 16:02:37
Compiled : 2021-01-29 16:31:13
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:HQ:Library:MiscObjects:HQRequirement extends SimSettlementsV2:HQ:Library:HQMiscObject Const
{ Configuration of an HQ requirement }

;-- Properties --------------------------------------
Group Completable collapsedonbase collapsedonref
	bool Property Completable Auto Const
	{ [Optional] If true, when this is completed, a completion flag is cached in a formlist, global variable, quest objective, or quest stage. 
		Completable requirements improve performance, especially with complicated checks. 
		Should be true if meeting this requirement cannot be reversed (such as getting a perk, completing a quest, or setting a flag).
		Should be false if meeting this requirement is fluid or subject to change (such as a cost in caps, or based on a location, or number of settlements owned) }
	FormList Property SetFormlist Auto Const
	{ [Optional] The Formlist this form will be added to upon completion. If no formlist is provided the default completion formlist will be used. }
	workshopframework:library:datastructures#actorvalueset Property SetActorValue Auto Const
	{ [Optional] The Actor Value that will be set upon completion. If no actor form is provided, the HQ workbench will be used. The corresponding actor value will be marked completed upon completion and the actor value will be checked for completion to determine if this is completed. 
			Actor Values are checked before global variables. }
	workshopframework:library:datastructures#globalvariableset Property SetGlobal Auto Const
	{ [Optional] The global that will be set upon completion. Value must not be 0.
		Global variables are checked before HQ Workbench Actor Values. }
	workshopframework:library:datastructures#questobjectiveset Property SetQuestObjective Auto Const
	{ [Optional] The quest & quest objectives that will be set upon completion. The corresponding quest objective will be marked completed upon completion and the objective will be checked for completion to determine if this is completed. 
		Quest objectives are checked before global variables. }
	workshopframework:library:datastructures#queststageset Property SetQuestStage Auto Const
	{ [Optional] The quest & quest stages that will be set upon completion. The owning quest's stage will be set to this stage upon completion and the owning quest's stage will be checked to determine if this is completed. 
		Quest stages are checked before quest objectives. 
		WARNING: Quest stages cannot be uncompleted! If this needs to be toggled from completed to uncompleted use formlists, global variables, or quest objectives instead. }
	bool Property bPlaySound = False Auto Const
	{ If true, a sound effect will play upon completion, or if set, the SoundEffectOverride sound will play. }
	Sound Property SoundEffectOverride Auto Const
	{ To play something other than the default sound effect upon completion }
	Form Property FeaturedItem Auto Const
	{ [Optional] Display an object to the player representing the unlock. Note this item will be added to their inventory to trigger the featured item screen and then immediately removed (unless bKeepFeaturedItem is on). Note: you can use the object you have this script on as the FeaturedItem, simply save the form before filling out this property. }
	bool Property bKeepFeaturedItem = False Auto Const
	{ The featured item will be immediately removed unless this is changed to true. }
	Message Property CompletionMessage Auto Const
	{ [Optional] Display a message to the player upon completion. If both the FeaturedItem and CompletionMessage are set, the FeaturedItem will trigger first with the CompletionMessage displaying a second later. }
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

bool Function PreventUncompletion()
	return False
EndFunction

workshopframework:library:datastructures#queststageset Function GetCompletionQuestStageSet()
	Self.HQTrace("  GetCompletionQuestStageSet()", 0, False)
	workshopframework:library:datastructures#queststageset vntQuestStageSet = Self.OverrideCompletionQuestStageSet()
	If (!vntQuestStageSet)
		vntQuestStageSet = SetQuestStage
	EndIf
	return vntQuestStageSet
EndFunction

Function HandleCompleted()
	; Empty function
EndFunction

Function _SendRequirementCompletedEvent(var[] parrParam)
	Self.HQTrace("   _SendRequirementCompletedEvent(" + parrParam as string + ")", 0, False)
	Self.SendCustomEvent("simsettlementsv2:hq:library:miscobjects:hqrequirement_HQRequirementCompleted", parrParam)
EndFunction

bool Function CheckRequirement(var[] parrParams)
	Self.HQTrace("CheckRequirement(" + parrParams as string + ")", 0, False)
	bool blnCompletable = Self._IsCompletable()
	If (blnCompletable && Self._IsComplete(True, None, None, None, None, None))
		return True
	EndIf
	bool blnResult = Self.HandleCheckRequirement(parrParams)
	If (blnResult)
		If (blnCompletable)
			Self.Complete()
		EndIf
	EndIf
	return blnResult
EndFunction

Function _SendRequirementUncompletedEvent(var[] parrParam)
	Self.HQTrace("   _SendRequirementUncompletedEvent(" + parrParam as string + ")", 0, False)
	Self.SendCustomEvent("simsettlementsv2:hq:library:miscobjects:hqrequirement_HQRequirementUncompleted", parrParam)
EndFunction

workshopframework:library:datastructures#globalvariableset Function GetCompletionGlobalVariableSet()
	Self.HQTrace("  GetCompletionGlobalVariableSet()", 0, False)
	workshopframework:library:datastructures#globalvariableset vntGlobalVariableSet = Self.OverrideCompletionGlobalVariableSet()
	If (!vntGlobalVariableSet)
		vntGlobalVariableSet = SetGlobal
	EndIf
	return vntGlobalVariableSet
EndFunction

bool Function IsComplete()
	Self.HQTrace("IsComplete()", 0, False)
	return Self._IsCompletable() && Self._IsComplete(True, None, None, None, None, None)
EndFunction

bool Function RegisterCompletionEvents(ScriptObject pscoToRegister)
	Self.HQTrace("RegisterCompletionEvents(" + pscoToRegister as string + ")", 0, False)
	If (Self._IsCompletable())
		If (!Self._IsComplete(True, None, None, None, None, None))
			pscoToRegister.RegisterForCustomEvent(Self as ScriptObject, "simsettlementsv2:hq:library:miscobjects:hqrequirement_HQRequirementCompleted")
			return True
		ElseIf (Self._IsUncompletable(None))
			pscoToRegister.RegisterForCustomEvent(Self as ScriptObject, "simsettlementsv2:hq:library:miscobjects:hqrequirement_HQRequirementUncompleted")
			return True
		EndIf
	EndIf
	return False
EndFunction

ObjectReference Function GetCompletionActorValueTarget()
	Self.HQTrace("  GetCompletionActorValueTarget()", 0, False)
	ObjectReference objTarget = Self.OverrideActorValueTarget()
	If (!objTarget)
		objTarget = simsettlementsv2:hq:library:hqutilityfunctions.GetHQWorkbench() as ObjectReference
	EndIf
	return objTarget
EndFunction

Function HandleFanfare(bool pblnPlaysound, Sound psndEffectOverride, Form pfrmFeaturedItem, bool pblnKeepFeaturedItem, Message pmsgMessage)
	Self.HQTrace("   HandleFanfare(" + pblnPlaysound as string + ", " + psndEffectOverride as string + ", " + pfrmFeaturedItem as string + ", " + pblnKeepFeaturedItem as string + ", " + pmsgMessage as string + ")", 0, False)
	Actor PlayerRef = Game.GetPlayer()
	simsettlementsv2:quests:unlockmanager UnlockManager = simsettlementsv2:hq:library:hqutilityfunctions.GetUnlockManager()
	If (pblnPlaysound)
		If (psndEffectOverride)
			psndEffectOverride.Play(PlayerRef as ObjectReference)
		Else
			UnlockManager.UnlockSound.Play(PlayerRef as ObjectReference)
		EndIf
	EndIf
	If (pfrmFeaturedItem)
		Self.HQTrace("Adding featured item: " + pfrmFeaturedItem as string, 0, False)
		PlayerRef.AddItem(pfrmFeaturedItem, 1, True)
		If (!pblnKeepFeaturedItem)
			PlayerRef.RemoveItem(pfrmFeaturedItem, 1, True, None)
		EndIf
		If (pmsgMessage)
			Utility.Wait(1)
			pmsgMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		EndIf
	ElseIf (pmsgMessage)
		pmsgMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	EndIf
EndFunction

workshopframework:library:datastructures#questobjectiveset Function OverrideCompletionQuestObjectiveSet()
	return None
EndFunction

string Function LogName()
	return "HQRequirement"
EndFunction

workshopframework:library:datastructures#questobjectiveset Function GetCompletionQuestObjectiveSet()
	Self.HQTrace("  GetCompletionQuestObjectiveSet()", 0, False)
	workshopframework:library:datastructures#questobjectiveset vntQuestObjectiveSet = Self.OverrideCompletionQuestObjectiveSet()
	If (!vntQuestObjectiveSet)
		vntQuestObjectiveSet = SetQuestObjective
	EndIf
	return vntQuestObjectiveSet
EndFunction

ObjectReference Function OverrideActorValueTarget()
	return None
EndFunction

bool Function ForceCompletable()
	return False
EndFunction

workshopframework:library:datastructures#actorvalueset Function GetCompletionActorValueSet()
	Self.HQTrace("  GetCompletionActorValueSet()", 0, False)
	workshopframework:library:datastructures#actorvalueset vntActorValueSet = Self.OverrideActorValueSet()
	If (!vntActorValueSet)
		vntActorValueSet = SetActorValue
	EndIf
	return vntActorValueSet
EndFunction

FormList Function GetCompletionFormList()
	Self.HQTrace("  GetCompletionFormList()", 0, False)
	FormList fmlList = Self.OverrideCompletionFormList()
	If (fmlList)
		return fmlList
	ElseIf (SetFormlist)
		return SetFormlist
	Else
		return simsettlementsv2:hq:library:hqutilityfunctions.GetActionManagerQuest().SS2_HQDefaultCompletedRequirementsFormList
	EndIf
EndFunction

workshopframework:library:datastructures#globalvariableset Function OverrideCompletionGlobalVariableSet()
	return None
EndFunction

bool Function _IsUncompletable(workshopframework:library:datastructures#queststageset pvntQuestStageSet)
	Self.HQTrace("  _IsUncompletable()", 0, False)
	If (!Self._IsCompletable() || Self.PreventUncompletion())
		return False
	EndIf
	workshopframework:library:datastructures#queststageset vntQuestStageSet = None
	If (pvntQuestStageSet)
		vntQuestStageSet = pvntQuestStageSet
	Else
		vntQuestStageSet = Self.GetCompletionQuestStageSet()
	EndIf
	If (vntQuestStageSet)
		return False
	EndIf
	return True
EndFunction

bool Function _IsComplete(bool pblnRetrieveFlags, workshopframework:library:datastructures#queststageset pvntQuestStageSet, workshopframework:library:datastructures#questobjectiveset pvntQuestObjectiveSet, workshopframework:library:datastructures#globalvariableset pvntGlobalVariableSet, workshopframework:library:datastructures#actorvalueset pvntActorValueSet, FormList pfmlCompletionFormList)
	Self.HQTrace("  _IsComplete(" + pvntQuestStageSet as string + ", " + pvntQuestObjectiveSet as string + ", " + pvntGlobalVariableSet as string + ", " + pfmlCompletionFormList as string + ")", 0, False)
	workshopframework:library:datastructures#queststageset vntQuestStageSet = None
	If (!pblnRetrieveFlags)
		vntQuestStageSet = pvntQuestStageSet
	Else
		vntQuestStageSet = Self.GetCompletionQuestStageSet()
	EndIf
	If (vntQuestStageSet)
		return workshopframework:library:utilityfunctions.CheckQuestStageSet(vntQuestStageSet)
	EndIf
	workshopframework:library:datastructures#questobjectiveset vntQuestObjectiveSet = None
	If (!pblnRetrieveFlags)
		vntQuestObjectiveSet = pvntQuestObjectiveSet
	Else
		vntQuestObjectiveSet = Self.GetCompletionQuestObjectiveSet()
	EndIf
	If (vntQuestObjectiveSet)
		return workshopframework:library:utilityfunctions.CheckQuestObjectiveSet(vntQuestObjectiveSet)
	EndIf
	workshopframework:library:datastructures#globalvariableset vntGlobalVariableSet = None
	If (!pblnRetrieveFlags)
		vntGlobalVariableSet = pvntGlobalVariableSet
	Else
		vntGlobalVariableSet = Self.GetCompletionGlobalVariableSet()
	EndIf
	If (vntGlobalVariableSet)
		return workshopframework:library:utilityfunctions.CheckGlobalVariableSet(vntGlobalVariableSet)
	EndIf
	workshopframework:library:datastructures#actorvalueset vntActorValueSet = None
	If (!pblnRetrieveFlags)
		vntActorValueSet = pvntActorValueSet
	Else
		vntActorValueSet = Self.GetCompletionActorValueSet()
	EndIf
	If (vntActorValueSet)
		ObjectReference objTargetActor = Self.GetCompletionActorValueTarget()
		return workshopframework:library:utilityfunctions.CheckActorValueSet(objTargetActor, vntActorValueSet, False)
	EndIf
	FormList fmlCompletionFormList = None
	If (!pblnRetrieveFlags)
		fmlCompletionFormList = pfmlCompletionFormList
	Else
		fmlCompletionFormList = Self.GetCompletionFormList()
	EndIf
	return fmlCompletionFormList.HasForm(Self as Form)
EndFunction

string Function Postfix()
	return Self as string
EndFunction

bool Function HandleCheckRequirement(var[] parrParams)
	return False
EndFunction

Function HandleUncompleted()
	; Empty function
EndFunction

bool Function _IsCompletable()
	Self.HQTrace("  _IsCompletable()", 0, False)
	return Completable || Self.ForceCompletable()
EndFunction

bool Function Uncomplete()
	Self.HQTrace("Uncomplete()", 0, False)
	If (!Self._IsUncompletable(None))
		return False
	EndIf
	If (Self._IsComplete(True, None, None, None, None, None))
		workshopframework:library:datastructures#queststageset vntQuestStageSet = Self.GetCompletionQuestStageSet()
		If (vntQuestStageSet)
			Self.HQTrace("  Attempted to uncomplete a requirement with a quest stage flag!", 0, False)
			return False
		EndIf
		workshopframework:library:datastructures#questobjectiveset vntQuestObjectiveSet = Self.GetCompletionQuestObjectiveSet()
		If (vntQuestObjectiveSet)
			vntQuestObjectiveSet.QuestForm.SetObjectiveCompleted(vntQuestObjectiveSet.iObjective, False)
		EndIf
		workshopframework:library:datastructures#globalvariableset vntGlobalVariableSet = Self.GetCompletionGlobalVariableSet()
		If (vntGlobalVariableSet)
			vntGlobalVariableSet.GlobalForm.SetValue(0)
		EndIf
		workshopframework:library:datastructures#actorvalueset vntActorValueSet = Self.GetCompletionActorValueSet()
		If (vntActorValueSet)
			ObjectReference objTarget = Self.GetCompletionActorValueTarget()
			If (objTarget)
				objTarget.SetValue(vntActorValueSet.AVForm, 0)
			EndIf
		EndIf
		Self.GetCompletionFormList().RemoveAddedForm(Self as Form)
	EndIf
	Self.HandleUncompleted()
	Self._SendRequirementUncompletedEvent(None)
	return True
EndFunction

workshopframework:library:datastructures#queststageset Function OverrideCompletionQuestStageSet()
	return None
EndFunction

bool Function Complete()
	Self.HQTrace("Complete()", 0, False)
	If (!Self._IsCompletable())
		return False
	EndIf
	FormList fmlCompletionFormList = Self.GetCompletionFormList()
	workshopframework:library:datastructures#actorvalueset vntActorValueSet = Self.GetCompletionActorValueSet()
	workshopframework:library:datastructures#queststageset vntQuestStageSet = Self.GetCompletionQuestStageSet()
	workshopframework:library:datastructures#questobjectiveset vntQuestObjectiveSet = Self.GetCompletionQuestObjectiveSet()
	workshopframework:library:datastructures#globalvariableset vntGlobalVariableSet = Self.GetCompletionGlobalVariableSet()
	If (Self._IsComplete(False, vntQuestStageSet, vntQuestObjectiveSet, vntGlobalVariableSet, vntActorValueSet, fmlCompletionFormList))
		return True
	EndIf
	fmlCompletionFormList.AddForm(Self as Form)
	If (vntQuestStageSet)
		vntQuestStageSet.QuestForm.SetStage(vntQuestStageSet.iStage)
	EndIf
	If (vntQuestObjectiveSet)
		vntQuestObjectiveSet.QuestForm.SetObjectiveCompleted(vntQuestObjectiveSet.iObjective, True)
	EndIf
	If (vntGlobalVariableSet)
		vntGlobalVariableSet.GlobalForm.SetValue(vntGlobalVariableSet.fValue)
	EndIf
	Self.HandleCompleted()
	Self.HandleFanfare(bPlaySound, SoundEffectOverride, FeaturedItem, bKeepFeaturedItem, CompletionMessage)
	Self._SendRequirementCompletedEvent(None)
	return True
EndFunction

bool Function IsCompletable()
	Self.HQTrace("IsCompletable()", 0, False)
	return Self._IsCompletable()
EndFunction

FormList Function OverrideCompletionFormList()
	return None
EndFunction

workshopframework:library:datastructures#actorvalueset Function OverrideActorValueSet()
	return None
EndFunction
