;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\HQ\Library\MiscObjects\RequirementTypes\HQAction.psc
Modified : 2021-01-09 16:23:38
Compiled : 2021-01-29 16:31:21
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName simsettlementsv2:hq:library:miscobjects:requirementtypes:hqaction extends SimSettlementsV2:HQ:Library:MiscObjects:HQRequirement Const
{ Configuration of an HQ action requirement }

;-- Properties --------------------------------------
Group Parameters
	simsettlementsv2:hq:library:hqdatastructures#hqpersonnelrequirementsstruct[] Property Personnel Auto Const
	{ [Optional] The personnel required to start the action. }
	simsettlementsv2:datastructures#transactionitem[] Property ResourceCost Auto Const
	{ [Optional] The resources which will be consumed when the action begins. }
	simsettlementsv2:datastructures#productionitem[] Property ResourceProduced Auto Const
	{ [Optional] The resources which will be produced when the action completes. }
	float Property Duration = 0 Auto Const
	{ [Optional] The number of in-game hours or real-time seconds it takes to execute. 0 or negative numbers means the action will exectue immediately. }
	bool Property RealTimeTimer = False Auto Const
	{ [Optional] If true, the action will execute using a real-time timer instead of a game-time timer. Duration is measured in seconds with a real-time timer. }
EndGroup

Group UnlockRequirements
	Form Property Requirements Auto Const
	{ [Optional] SS2 Usage requirements which must be met before this is unlocked. 
		Must be of type SimSettlementsV2:MiscObjects:UsageRequirements }
	workshopframework:library:datastructures#questobjectiveset[] Property QuestObjectiveRequirements Auto Const
	{ If specific quest objectives must be set }
	simsettlementsv2:datastructures#plotcount[] Property MinimumPlotsBuilt Auto Const
	{ Minimum number of a particular plot type or building class and the minimum level each must have reached. }
	simsettlementsv2:datastructures#plotcount[] Property MinimumPlotsActive Auto Const
	{ Minimum number of a particular plot type or building class and the minimum level each must have reached. These plots must be currently powered and active. }
	int[] Property MinimumCityPlansAtEachLevel Auto Const
	{ Each entry you add to this array represents the number of City Plans that should be at that level or higher. So if your first entry is 5, there needs to be at least 5 city plans at level 0 or higher (level 0 = foundation level). If your second entry is 8, at least 8 city plans must be at level 1 or higher, etc. To remember this easily, look at the index column in the property screen for this field and treat this as the level. }
	workshopframework:library:datastructures#universalform[] Property MustOwnSettlements Auto Const
	{ If set, the player must own these settlements in order to trigger the unlock. }
	workshopframework:library:datastructures#universalform[] Property ClearedLocations Auto Const
	{ If set, the corresponding locations must be cleared in order to trigger the unlock. }
	int Property iMinPlayerLevel = 0 Auto Const
	{ If set, the player must be at least this level in order to trigger the unlock. }
	int Property iMinOwnedSettlements = 0 Auto Const
	{ If set, the player must control at least this many settlements to trigger the unlock. }
	MiscObject[] Property Prerequisites Auto Const
	{ [Optional] Other HQRequirements which must be met before this is unlocked. 
		Must be of type SimSettlementsV2:HQ:Library:MiscObjects:HQRequirement }
	bool Property bPlayUnlockSound = False Auto Const
	{ If true, a sound effect will play upon unlock, or if set, the SoundEffectOverride sound will play. }
	Sound Property UnlockSoundEffectOverride Auto Const
	{ [Optional] To play something other than the default sound effect upon unlock }
	Form Property UnlockFeaturedItem Auto Const
	{ [Optional] Display an object to the player representing the unlock. Note this item will be added to their inventory to trigger the featured item screen and then immediately removed (unless bKeepFeaturedItem is on). Note: you can use the object you have this script on as the UnlockFeaturedItem, simply save the form before filling out this property. }
	bool Property bKeepUnlockFeaturedItem = False Auto Const
	{ The featured item will be immediately removed unless this is changed to true. }
	Message Property UnlockMessage Auto Const
	{ [Optional] Display a message to the player upon unlock. If both the UnlockFeaturedItem and UnlockMessage are set, the UnlockFeaturedItem will trigger first with the UnlockMessage displaying a second later. }
EndGroup

Group ADVANCED collapsedonref collapsedonbase
	MiscObject Property ActionGroup Auto Const
	{ [Optional] The action group this belongs to. }
	bool Property EvaluateOnRegistration = True Auto Const
	{ If true, the action will evaluate if it is unlocked requirement check on initial registration. }
	int Property NumberOfExecutions = 1 Auto Const
	{ [Optional] The number of times this should repeat on a timer. Default: 1, -1 means to repeat indefinitely }
EndGroup

int Property ERC_NO_WORKER_QUEST = -1 AutoReadOnly hidden
int Property ERC_NO_RESOURCE_QUEST = -2 AutoReadOnly hidden
int Property ERC_NO_TASK_QUEST = -3 AutoReadOnly hidden
int Property ERC_ALREADY_REGISTERED = 1 AutoReadOnly hidden

;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

simsettlementsv2:hq:library:miscobjects:hqactiongroup Function GetActionGroup()
	simsettlementsv2:hq:library:miscobjects:hqactiongroup acgGroup = Self.OverrideActionGroup()
	If (acgGroup)
		return acgGroup
	ElseIf (ActionGroup)
		return ActionGroup as simsettlementsv2:hq:library:miscobjects:hqactiongroup
	Else
		return simsettlementsv2:hq:library:hqutilityfunctions.GetActionManagerQuest().SS2_HQDefaultActionGroup as simsettlementsv2:hq:library:miscobjects:hqactiongroup
	EndIf
EndFunction

bool Function HandleActionExecuted()
	return True
EndFunction

Function HandleActionCompleted()
	; Empty function
EndFunction

Function Unlock()
	Self.HQTrace("Unlock()", 0, False)
	Self.GetActionGroup().UnlockAction(Self)
	Self.HandleFanfare(bPlayUnlockSound, UnlockSoundEffectOverride, UnlockFeaturedItem, bKeepUnlockFeaturedItem, UnlockMessage)
EndFunction

Function HandleActionStarted()
	; Empty function
EndFunction

int Function StartAction()
	Self.HQTrace("StartAction()", 0, False)
	int intResourceTransactionResult = 0
	int intTaskID = -1
	int iWorkshopID = -1
	simsettlementsv2:quests:resourcemanager ResourceManager = None
	If (ResourceCost as bool && ResourceCost.length > 0)
		ResourceManager = simsettlementsv2:hq:library:hqutilityfunctions.GetResourceManager()
		If (!ResourceManager)
			Self.HQTrace("  Could not retreive resource manager quest...)", 2, False)
			return Self.ERC_NO_RESOURCE_QUEST
		Else
			iWorkshopID = simsettlementsv2:hq:library:hqutilityfunctions.GetHQWorkbench().GetWorkshopID()
			If (!ResourceManager.SimpleSettlementTransaction(iWorkshopID, ResourceCost, True, False))
				return -1
			EndIf
		EndIf
	EndIf
	If (intResourceTransactionResult >= 0)
		intTaskID = simsettlementsv2:hq:library:hqutilityfunctions.GetActionManagerQuest().ScheduleAction(Self, Duration, RealTimeTimer, NumberOfExecutions)
	EndIf
	If (intTaskID < 0)
		If (ResourceCost as bool && ResourceCost.length > 0 && intResourceTransactionResult >= 0)
			simsettlementsv2:datastructures#productionitem[] ReversedCost = Self._ConvertTransactionItemsToProductionItems(ResourceCost)
			ResourceManager.ProduceSettlementResources(iWorkshopID, ReversedCost, True)
		EndIf
	Else
		Self.HandleActionStarted()
	EndIf
	return intTaskID
EndFunction

simsettlementsv2:hq:library:miscobjects:hqactiongroup Function OverrideActionGroup()
	return None
EndFunction

int Function Register()
	Self.HQTrace("Register()", 0, False)
	int intResult = Self.GetActionGroup().RegisterAction(Self)
	If (intResult == 0)
		Self.HandleActionRegistered()
		If (EvaluateOnRegistration)
			Self.Evaluate()
		EndIf
	EndIf
	return intResult
EndFunction

Function HandleCompleted()
	Self.HQTrace("HandleCompleted()", 0, False)
	Self.HandleActionCompleted()
	Self.Evaluate()
EndFunction

simsettlementsv2:miscobjects:usagerequirements Function GetRequirements()
	return Requirements as simsettlementsv2:miscobjects:usagerequirements
EndFunction

simsettlementsv2:datastructures#transactionitem[] Function _InvertTransaction(simsettlementsv2:datastructures#transactionitem[] parrTransaction)
	Self.HQTrace(" _InvertTransaction(" + parrTransaction as string + ")", 0, False)
	simsettlementsv2:datastructures#transactionitem[] NegativeCost = new simsettlementsv2:datastructures#transactionitem[parrTransaction.length]
	int I = parrTransaction.length
	While (I > 0)
		I -= 1
		simsettlementsv2:datastructures#transactionitem vntNegativeItem = new simsettlementsv2:datastructures#transactionitem
		vntNegativeItem.ContainerKeyword = parrTransaction[I].ContainerKeyword
		vntNegativeItem.Item = parrTransaction[I].ContainerKeyword as Form
		vntNegativeItem.iCount = 0 - parrTransaction[I].iCount
		NegativeCost[I] = vntNegativeItem
	EndWhile
	return NegativeCost
EndFunction

simsettlementsv2:datastructures#productionitem[] Function _ConvertTransactionItemsToProductionItems(simsettlementsv2:datastructures#transactionitem[] parrTransaction)
	Self.HQTrace(" _InvertTransaction(" + parrTransaction as string + ")", 0, False)
	simsettlementsv2:datastructures#productionitem[] Production = new simsettlementsv2:datastructures#productionitem[parrTransaction.length]
	int I = parrTransaction.length
	While (I > 0)
		I -= 1
		simsettlementsv2:datastructures#productionitem vntProductionItem = new simsettlementsv2:datastructures#productionitem
		vntProductionItem.TargetContainerKeyword = parrTransaction[I].ContainerKeyword
		vntProductionItem.Item = parrTransaction[I].ContainerKeyword as Form
		vntProductionItem.iCount = 0 - parrTransaction[I].iCount
		Production[I] = vntProductionItem
	EndWhile
	return Production
EndFunction

bool Function Execute()
	Self.HQTrace("Execute()", 0, False)
	bool blnExecuted = Self.HandleActionExecuted()
	If (blnExecuted)
		If (ResourceProduced as bool && ResourceProduced.length > 0)
			simsettlementsv2:quests:resourcemanager ResourceManager = simsettlementsv2:hq:library:hqutilityfunctions.GetResourceManager()
			ResourceManager.ProduceSettlementResources(simsettlementsv2:hq:library:hqutilityfunctions.GetHQWorkbench().GetWorkshopID(), ResourceProduced, True)
		EndIf
		If (Self.AutoCompleteOnActionExecuted())
			Self.Complete()
		EndIf
	EndIf
	return blnExecuted
EndFunction

Function RegisterUnlockEvents(ScriptObject pscoToRegister, FormList pfmlPrerequisitesFormList)
	If (Prerequisites as bool && Prerequisites.length > 0)
		int I = 0
		While (I < Prerequisites.length)
			SimSettlementsV2:HQ:Library:MiscObjects:HQRequirement reqPrerequisite = Prerequisites[I] as SimSettlementsV2:HQ:Library:MiscObjects:HQRequirement
			If (reqPrerequisite as bool && reqPrerequisite.RegisterCompletionEvents(pscoToRegister))
				pfmlPrerequisitesFormList.AddForm(Prerequisites[I] as Form)
			EndIf
			I += 1
		EndWhile
	EndIf
	If (ClearedLocations as bool && ClearedLocations.length > 0)
		int i = 0
		While (i < ClearedLocations.length)
			Location locLocation = workshopframework:library:utilityfunctions.GetUniversalForm(ClearedLocations[i]) as Location
			If (locLocation as bool && !locLocation.HasEverBeenCleared())
				pfmlPrerequisitesFormList.AddForm(locLocation as Form)
				pscoToRegister.RegisterForRemoteEvent(locLocation as ScriptObject, "OnLocationCleared")
			EndIf
			i += 1
		EndWhile
	EndIf
	simsettlementsv2:miscobjects:usagerequirements usgRequirements = Self.GetRequirements()
	If (usgRequirements)
		workshopframework:library:datastructures#queststageset[] arrQuestStageSet = usgRequirements.QuestRequirements
		If (arrQuestStageSet as bool && arrQuestStageSet.length > 0)
			int i = 0
			While (i < arrQuestStageSet.length)
				If (arrQuestStageSet[i].iStage >= 0)
					If (!arrQuestStageSet[i].QuestForm)
						arrQuestStageSet[i].QuestForm = workshopframework:library:utilityfunctions.GetQuestStageSetForm(arrQuestStageSet[i])
					EndIf
					If (arrQuestStageSet[i].QuestForm)
						pfmlPrerequisitesFormList.AddForm(arrQuestStageSet[i].QuestForm as Form)
						pscoToRegister.RegisterForRemoteEvent(arrQuestStageSet[i].QuestForm as ScriptObject, "OnStageSet")
					EndIf
				EndIf
				i += 1
			EndWhile
		EndIf
	EndIf
	If (MustOwnSettlements as bool && MustOwnSettlements.length > 0)
		int i = 0
		While (i < MustOwnSettlements.length)
			workshopscript wksWorkbench = None
			If (!MustOwnSettlements[i].BaseForm)
				wksWorkbench = workshopframework:library:utilityfunctions.GetUniversalForm(MustOwnSettlements[i]) as workshopscript
			Else
				wksWorkbench = MustOwnSettlements[i].BaseForm as workshopscript
			EndIf
			If (wksWorkbench)
				pfmlPrerequisitesFormList.AddForm(wksWorkbench as Form)
			EndIf
			i += 1
		EndWhile
	EndIf
EndFunction

Function Relock()
	Self.HQTrace("Relock()", 0, False)
	Self.GetActionGroup().RelockAction(Self)
EndFunction

Function Evaluate()
	Self.HQTrace("Evaluate()", 0, False)
	If (!Self.IsComplete() && Self.CheckUnlockRequirements(True))
		Self.HQTrace("  Should be unlocked!", 0, False)
		Self.Unlock()
	Else
		Self.HQTrace("  Should be locked!", 0, False)
		Self.Relock()
	EndIf
EndFunction

Function HandleUncompleted()
	Self.HQTrace("HandleUncompleted()", 0, False)
	Self.HandleActionUncompleted()
	Self.Evaluate()
EndFunction

FormList Function OverrideCompletionFormList()
	return Self.GetActionGroup().CompletedActions
EndFunction

bool Function CanStartAction(bool pblnSilent)
	Self.HQTrace("CanStartAction(" + pblnSilent as string + ")", 0, False)
	If (!Self.IsUnlocked(True))
		return False
	EndIf
	If (ResourceCost as bool && ResourceCost.length > 0)
		simsettlementsv2:quests:resourcemanager ResourceManager = simsettlementsv2:hq:library:hqutilityfunctions.GetResourceManager()
		int iWorkshopID = simsettlementsv2:hq:library:hqutilityfunctions.GetHQWorkbench().GetWorkshopID()
		If (!ResourceManager)
			Self.HQTrace("  Could not retreive resource manager quest...)", 2, False)
			return False
		ElseIf (!ResourceManager.EvaluateSettlementTransaction(iWorkshopID, ResourceCost, True, False))
			Debug.MessageBox("Not enough resources!")
			return False
		EndIf
	EndIf
	return True
EndFunction

Function HandleActionRegistered()
	; Empty function
EndFunction

string Function LogName()
	return "HQAction"
EndFunction

Function HandleActionUncompleted()
	; Empty function
EndFunction

bool Function AutoCompleteOnActionExecuted()
	return True
EndFunction

bool Function IsUnlocked(bool pblnEvaluate)
	Self.HQTrace("IsUnlocked(" + pblnEvaluate as string + ")", 0, False)
	If (Self.IsCompletable() && Self._IsComplete(True, None, None, None, None, None))
		return True
	EndIf
	If (pblnEvaluate)
		Self.Evaluate()
	EndIf
	FormList fmlUnlockList = Self.GetActionGroup().UnlockedActions
	return fmlUnlockList.HasForm(Self as Form)
EndFunction

bool Function CheckUnlockRequirements(bool pblnSilent)
	Self.HQTrace("CheckUnlockRequirements(" + pblnSilent as string + ")", 0, False)
	If (iMinPlayerLevel > 0)
		Self.HQTrace("  Checking player level...", 0, False)
		If (Game.GetPlayer().GetLevel() < iMinPlayerLevel)
			Self.HQTrace("   Failed!", 0, False)
			return False
		EndIf
	Else
		Self.HQTrace("  No player level requirement", 0, False)
	EndIf
	workshopscript[] OwnedSettlements = new workshopscript[0]
	bool bOwnedSettlementsCheckedAlready = False
	simsettlementsv2:quests:settlementmanager SettlementManager = simsettlementsv2:hq:library:hqutilityfunctions.GetSettlementManager()
	If (iMinOwnedSettlements > 0)
		Self.HQTrace("  Checking owned settlements...", 0, False)
		bOwnedSettlementsCheckedAlready = True
		OwnedSettlements = workshopframework:workshopfunctions.GetPlayerOwnedSettlements(True, True, False)
		If (OwnedSettlements.length < iMinOwnedSettlements)
			Self.HQTrace("   Failed!", 0, False)
			return False
		EndIf
	Else
		Self.HQTrace("  No min owned settlement requirement", 0, False)
	EndIf
	If (Requirements)
		Self.HQTrace("  Checking usage requirements...", 0, False)
		simsettlementsv2:miscobjects:usagerequirements urqRequirements = Self.GetRequirements()
		If (urqRequirements as bool && !simsettlementsv2:utilityfunctions.CheckRequirements(urqRequirements, None, None, None))
			Self.HQTrace("   Failed!", 0, False)
			return False
		EndIf
	Else
		Self.HQTrace("  No usage requirement", 0, False)
	EndIf
	If (MinimumPlotsBuilt != None)
		int i = 0
		While (i < MinimumPlotsBuilt.length)
			If (MinimumPlotsBuilt[i].iL0Count > 0)
				Self.HQTrace("  Checking minimum L0 plots built...", 0, False)
				int iPlots = 0
				If (MinimumPlotsBuilt[i].BuildingClass != None)
					iPlots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].BuildingClass, 0, -1, False, True)
				Else
					iPlots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].PlotType, 0, -1, False, True)
				EndIf
				If (iPlots < MinimumPlotsBuilt[i].iL0Count)
					Self.HQTrace("   Failed!", 0, False)
					return False
				EndIf
			EndIf
			If (MinimumPlotsBuilt[i].iL1Count > 0)
				Self.HQTrace("  Checking minimum L1 plots built...", 0, False)
				int iplots = 0
				If (MinimumPlotsBuilt[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].BuildingClass, 1, -1, False, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].PlotType, 1, -1, False, True)
				EndIf
				If (iplots < MinimumPlotsBuilt[i].iL1Count)
					Self.HQTrace("   Failed!", 0, False)
					return False
				EndIf
			EndIf
			If (MinimumPlotsBuilt[i].iL2Count > 0)
				Self.HQTrace("  Checking minimum L2 plots built...", 0, False)
				int iplots = 0
				If (MinimumPlotsBuilt[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].BuildingClass, 2, -1, False, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].PlotType, 2, -1, False, True)
				EndIf
				If (iplots < MinimumPlotsBuilt[i].iL2Count)
					Self.HQTrace("   Failed!", 0, False)
					return False
				EndIf
			EndIf
			If (MinimumPlotsBuilt[i].iL3Count > 0)
				Self.HQTrace("  Checking minimum L3 plots built...", 0, False)
				int iplots = 0
				If (MinimumPlotsBuilt[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].BuildingClass, 3, -1, False, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].PlotType, 3, -1, False, True)
				EndIf
				If (iplots < MinimumPlotsBuilt[i].iL3Count)
					Self.HQTrace("   Failed!", 0, False)
					return False
				EndIf
			EndIf
			i += 1
		EndWhile
	Else
		Self.HQTrace("  No minimum plots built requirement", 0, False)
	EndIf
	If (MinimumPlotsActive != None)
		int i = 0
		While (i < MinimumPlotsActive.length)
			If (MinimumPlotsActive[i].iL0Count > 0)
				Self.HQTrace("  Checking minimum L0 plots active...", 0, False)
				int iplots = 0
				If (MinimumPlotsActive[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].BuildingClass, 0, -1, True, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].PlotType, 0, -1, True, True)
				EndIf
				If (iplots < MinimumPlotsActive[i].iL0Count)
					Self.HQTrace("   Failed!", 0, False)
					return False
				EndIf
			EndIf
			If (MinimumPlotsActive[i].iL1Count > 0)
				Self.HQTrace("  Checking minimum L1 plots active...", 0, False)
				int iplots = 0
				If (MinimumPlotsActive[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].BuildingClass, 1, -1, True, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].PlotType, 1, -1, True, True)
				EndIf
				If (iplots < MinimumPlotsActive[i].iL1Count)
					Self.HQTrace("   Failed!", 0, False)
					return False
				EndIf
			EndIf
			If (MinimumPlotsActive[i].iL2Count > 0)
				Self.HQTrace("  Checking minimum L2 plots active...", 0, False)
				int iplots = 0
				If (MinimumPlotsActive[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].BuildingClass, 2, -1, True, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].PlotType, 2, -1, True, True)
				EndIf
				If (iplots < MinimumPlotsActive[i].iL2Count)
					Self.HQTrace("   Failed!", 0, False)
					return False
				EndIf
			EndIf
			If (MinimumPlotsActive[i].iL3Count > 0)
				Self.HQTrace("  Checking minimum L3 plots active...", 0, False)
				int iplots = 0
				If (MinimumPlotsActive[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].BuildingClass, 3, -1, True, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].PlotType, 3, -1, True, True)
				EndIf
				If (iplots < MinimumPlotsActive[i].iL3Count)
					Self.HQTrace("   Failed!", 0, False)
					return False
				EndIf
			EndIf
			i += 1
		EndWhile
	Else
		Self.HQTrace("  No minimum plots active requirement", 0, False)
	EndIf
	If (MustOwnSettlements != None)
		Self.HQTrace("  Checking owned settlements...", 0, False)
		int i = 0
		While (i < MustOwnSettlements.length)
			ObjectReference thisRef = workshopframework:library:utilityfunctions.GetUniversalForm(MustOwnSettlements[i]) as ObjectReference
			If (thisRef != None)
				workshopscript thisWorkshop = thisRef as workshopscript
				If (bOwnedSettlementsCheckedAlready)
					If (OwnedSettlements.find(thisWorkshop, 0) < 0)
						Self.HQTrace("   Failed!", 0, False)
						return False
					EndIf
				ElseIf (thisWorkshop == None || !thisWorkshop.OwnedByPlayer)
					Self.HQTrace("   Failed!", 0, False)
					return False
				EndIf
			Else
				Self.HQTrace("   Failed!", 0, False)
				return False
			EndIf
			i += 1
		EndWhile
	Else
		Self.HQTrace("  No owned settlement requirement", 0, False)
	EndIf
	If (ClearedLocations != None)
		Self.HQTrace("  Checking cleared locations...", 0, False)
		int i = 0
		While (i < ClearedLocations.length)
			Location thisLocation = workshopframework:library:utilityfunctions.GetUniversalForm(ClearedLocations[i]) as Location
			If (thisLocation != None)
				If (thisLocation == None || !thisLocation.HasEverBeenCleared())
					Self.HQTrace("   Failed!", 0, False)
					return False
				EndIf
			Else
				Self.HQTrace("   Failed!", 0, False)
				return False
			EndIf
			i += 1
		EndWhile
	Else
		Self.HQTrace("  No cleared location requirement", 0, False)
	EndIf
	If (MinimumCityPlansAtEachLevel != None)
		Self.HQTrace("  Checking minimum city plans...", 0, False)
		simsettlementsv2:objectreferences:settlementdata[] SettlementDataStores = SettlementManager.SettlementDataStores
		int[] iLevelCounts = new int[128]
		int i = 0
		While (i < SettlementDataStores.length)
			int iCurrentLevel = SettlementDataStores[i].iCityLevel
			If (iCurrentLevel >= 0)
				iLevelCounts[iCurrentLevel] = iLevelCounts[iCurrentLevel] + 1
			EndIf
			i += 1
		EndWhile
		i = 0
		While (i < MinimumCityPlansAtEachLevel.length)
			If (iLevelCounts[i] < MinimumCityPlansAtEachLevel[i])
				Self.HQTrace("   Failed!", 0, False)
				return False
			EndIf
			i += 1
		EndWhile
	Else
		Self.HQTrace("  No minimum city plan level requirement", 0, False)
	EndIf
	int I = 0
	If (I < Prerequisites.length)
		SimSettlementsV2:HQ:Library:MiscObjects:HQRequirement reqRequirement = None
		Self.HQTrace("  Checking prerequisites...", 0, False)
		While (I < Prerequisites.length)
			reqRequirement = Prerequisites[I] as SimSettlementsV2:HQ:Library:MiscObjects:HQRequirement
			If (reqRequirement)
				Self.HQTrace("    Checking " + reqRequirement as string + "...", 0, False)
				If (!reqRequirement.CheckRequirement(None))
					Self.HQTrace("     Failed " + reqRequirement as string + "!", 0, False)
					return False
				EndIf
			EndIf
			I += 1
		EndWhile
	Else
		Self.HQTrace("  No action prerequisites", 0, False)
	EndIf
	return True
EndFunction
