;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\HQ\Library\ObjectRefs\ActionTrigger.psc
Modified : 2021-02-24 00:06:16
Compiled : 2021-02-24 00:06:36
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:HQ:Library:ObjectRefs:ActionTrigger extends ObjectReference Const
{ Test script to start working out details of how buildable ActionTriggers might need to be rigged up. }

;-- Structs -----------------------------------------
Struct EnableState
	bool bEnable = True
	{ Set to false to have this disable instead }
	bool bFade = True
	{ Set to false to have the enable/disable pop into place quickly }
	ObjectReference kTargetRef
	{ The reference to enable or disable }
EndStruct


;-- Properties --------------------------------------
Group Config
	simsettlementsv2:hq:library:objectrefs:actiontrigger#enablestate[] Property EnableState_WhileRunning Auto Const
	{ These references will be enabled or disabled while this action is running, and then reversed once it is canceled or completed. }
	simsettlementsv2:hq:library:objectrefs:actiontrigger#enablestate[] Property EnableState_OnCompletion Auto Const
	{ These references will be enabled or disabled once the action completes. }
	simsettlementsv2:hq:library:objectrefs:room Property RelatedRoom Auto Const
	{ Room this is tied to (used for assigning AI to room) }
	simsettlementsv2:hq:library:objectrefs:departmentobject Property ManagingDepartment Auto Const
	{ The department whose NPCs should use this room while the action is in progress }
	simsettlementsv2:hq:library:objectrefs:departmentobject Property AssignToDepartmentOnCompletion Auto Const
	simsettlementsv2:hq:library:quests:specifichqmanager Property SpecificHQManager Auto Const mandatory
	{ The management quest for the specific HQ this is tied to }
	string Property ConditionalTrackingVariable = "" Auto Const
	{ If this is tracked by a conditional variable on SpecificHQManager, enter the variable name here to have that set as this action advances. }
	bool Property bAssignManagingDepartmentToRoomWhileInProgress = True Auto Const
	float Property fActionTime = 24 Auto Const
	{ Time in game hours this will take to run }
EndGroup

Group Temporary
	bool Property bOpenAssignmentMenu = False Auto Const
	bool Property bOpenRoomMenu = False Auto Const
EndGroup


;-- Variables ---------------------------------------
int iProjectStatus_InProgress = 1 Const
int iProjectStatus_Unstarted = 0 Const
int iProjectStatus_Completed = 2 Const

;-- Functions ---------------------------------------

Function SelfDestruct()
	Self.HandleEnableStates(EnableState_WhileRunning, True)
	SpecificHQManager.DestroyBuildableAction(Self)
EndFunction

Event OnWorkshopObjectDestroyed(ObjectReference akActionRef)
	Self.UpdateTracking(iProjectStatus_Unstarted)
	Debug.MessageBox("Project Canceled.")
EndEvent

Event OnTimerGameTime(int aiTimerID)
	Self.CompleteAction()
EndEvent

Function HandleEnableStates(simsettlementsv2:hq:library:objectrefs:actiontrigger#enablestate[] aEnableStateArray, bool abFlip)
	int I = 0
	While (I < aEnableStateArray.length)
		If (aEnableStateArray[I].bEnable && !abFlip || !aEnableStateArray[I].bEnable && abFlip)
			aEnableStateArray[I].kTargetRef.Enable(aEnableStateArray[I].bFade)
		Else
			aEnableStateArray[I].kTargetRef.Disable(aEnableStateArray[I].bFade)
		EndIf
		I += 1
	EndWhile
EndFunction

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
	If (asMenuName == "WorkshopMenu")
		Self.MoveTo(Self as ObjectReference, 0, 0, -2000, True)
		Self.UnregisterForMenuOpenCloseEvent("WorkshopMenu")
	EndIf
EndEvent

Function CompleteAction()
	Self.HandleEnableStates(EnableState_OnCompletion, False)
	Self.UpdateTracking(iProjectStatus_Completed)
	If (RelatedRoom != None && AssignToDepartmentOnCompletion != None)
		AssignToDepartmentOnCompletion.AssignRoomToDepartment(RelatedRoom)
	EndIf
	If (bOpenRoomMenu)
		simsettlementsv2:hq:library:hqutilityfunctions.GetHQManager().HQ_API_ShowSelectRoomMenuForLocation(None)
	ElseIf (bOpenAssignmentMenu)
		simsettlementsv2:hq:library:hqutilityfunctions.GetWorkerManagerQuest().HQ_API_ShowAssignDepartmentWorkersMenu(ManagingDepartment, False)
	Else
		Debug.MessageBox("Project completed! TODO: Make this a UI element with SFX while in HQ, and route through WSFW message manager when not in HQ.")
	EndIf
	Self.SelfDestruct()
EndFunction

Function UpdateTracking(int aiStatus)
	If (ConditionalTrackingVariable != "")
		SpecificHQManager.SetPropertyValue(ConditionalTrackingVariable, aiStatus as var)
	EndIf
EndFunction

bool Function CanActionRun()
	If (ConditionalTrackingVariable != "")
		If (SpecificHQManager.GetPropertyValue(ConditionalTrackingVariable) as int != iProjectStatus_Unstarted)
			Debug.MessageBox("Action cannot be run. " + ConditionalTrackingVariable + " = " + (SpecificHQManager.GetPropertyValue(ConditionalTrackingVariable) as int) as string)
			return False
		EndIf
	EndIf
	return True
EndFunction

Event OnInit()
	Self.HandleInit()
EndEvent

Function HandleInit()
	If (!Self.CanActionRun())
		Self.SelfDestruct()
		return 
	EndIf
	Self.RegisterForMenuOpenCloseEvent("WorkshopMenu")
	Self.HandleEnableStates(EnableState_WhileRunning, False)
	Self.UpdateTracking(iProjectStatus_InProgress)
	If (fActionTime > 0 as float)
		Self.StartTimerGameTime(fActionTime, 0)
		If (bAssignManagingDepartmentToRoomWhileInProgress && RelatedRoom != None && ManagingDepartment != None)
			ManagingDepartment.AssignRoomToDepartment(RelatedRoom)
		EndIf
	Else
		Self.CompleteAction()
	EndIf
EndFunction
