;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\HQ\Library\ObjectRefs\DepartmentObject.psc
Modified : 2021-03-02 23:24:38
Compiled : 2021-03-02 23:24:44
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:HQ:Library:ObjectRefs:DepartmentObject extends WorkshopObjectScript

;-- Properties --------------------------------------
Group Department_Forms
	ActorValue Property WorkshopResourceUpkeep Auto Const mandatory
	{ Should be of type Resource }
	ActorValue Property WorkshopResourceProvided Auto Const mandatory
	{ Should be of type Resource }
	ActorValue Property WorkshopResourceProjectUsage Auto Const mandatory
	{ Should be of type Resource }
	ActorValue Property WorkshopResourceJobs Auto Const mandatory
	{ Should be of type Resource }
	ActorValue Property ResourceProvidedFromStat Auto Const mandatory
	{ Should be a stat AV found on actors, such as a SPECIAL stat }
	Form Property ResourceToken Auto Const mandatory
	{ The MiscObject (do not use the Component type here, that should only be used on the construction records) that should be used in workshop mode construction to represent the department provided resource. For example, if HQ has 5 WorkshopResourceUpkeep and 10 WorkshopResourceProvided, the player will be given 5 of these tokens to use on projects. }
	Faction Property DepartmentFaction Auto Const mandatory
	{ NPCs in this department will be added to this faction }
	int Property iDepartmentHeadRank = 10 Auto Const mandatory
	{ This can be used to control which furniture markers they will use }
	simsettlementsv2:datastructures#outfitmap[] Property DefaultOutfits Auto Const mandatory
	{ Outfit generic NPCs will equip in this department if none is defined by the room layout. Important: Put these in order from highest to lowest priority, as the first match will be used. TODO - Allow players to override this (both in allowing unique NPCs to also be equipped, and in preventing the outfits from being touched). TODO - Add in outfits as an upgrade to HQ from Administration. }
	simsettlementsv2:datastructures#factionrankmessagemap[] Property DefaultTitles Auto Const mandatory
	{ Title NPCs will have instead of the "Talk" button if none is defined by the room layout. }
	Form Property UniqueStatAV_NameHolderForm_Abbreviation Auto Const
	{ [Optional] If this department is not using one of the default stats for ResourceProvidedFromStat, as defined in HQWorkerManagerQuest.DefaultStatDisplayForms, use this to register the abbreviation for this new stat. }
	Form Property UniqueStatAV_DummyForm Auto Const
	{ [Optional] If this department is not using one of the default stats for ResourceProvidedFromStat, as defined in HQWorkerManagerQuest.DefaultStatDisplayForms, use this to register the MiscObject form that has the model configured that this stat should be represented by. This should be based off of record SS2_HQWorkerSelectForm_Template (which has appropriate keywords applied). }
EndGroup

Group Department_HUDInfo
	int Property iDepartmentID Auto Const mandatory
	{ Each department in your HQ must have a unique ID number. ID is used to identify hud data, as well as for sorting the order they appear. }
	int Property iDefaultIconFrame = 1 Auto Const
	{ The frame in the SS2HUD.swf HQDepartmentIcon object that has the icon this department should use }
	Form Property CustomIconSwfPathHolderForm Auto Const
	{ [Optional] To provide a custom swf file icon for a department, put the file name (and path relative to Data\interface if you put in a subfolder) as the Name field for a misc object and point this at that object. }
EndGroup

Actor Property DepartmentHead Auto hidden
workshopobjectscript[] Property UnusedDummyRefs Auto hidden
workshopobjectscript[] Property AssignmentDummyRefs Auto hidden
int Property iAssignedWorkerCount = 0 Auto hidden
int Property MaxWorkerCount
	int Function Get()
		return Self.GetHQRef().GetValue(WorkshopResourceJobs) as int
	EndFunction
EndProperty
bool Property bRecalculationNeeded = False Auto hidden
simsettlementsv2:quests:hudmanager Property HUDManager Auto hidden
ActorValue Property SS2_HQWorkerID Auto hidden
Form Property DummyWorkshopObjectForm Auto hidden
Form Property NameHolderForm_None Auto hidden
Keyword Property SS2_Link_AssignedDepartment Auto hidden
Keyword Property SS2_Link_AssignmentDummy Auto hidden
Keyword Property SS2_Link_WorkerToPost Auto hidden
Keyword Property SS2_Link_RoomToDepartment Auto hidden
Keyword Property WorkshopItemKeyword Auto hidden
Message Property SS2_Confirm_DepartmentHead Auto hidden
Message Property SS2_MessageBox_NewDepartmentHead Auto hidden
Message Property SS2_Notification_AssignedToDepartment Auto hidden
Message Property SS2_Menu_HQ_ManageDepartment Auto hidden
Message Property Warning_RequestedDepartmentIsFull Auto hidden
GlobalVariable Property MenuControl_AssignLeader Auto hidden
GlobalVariable Property MenuControl_DismissLeader Auto hidden
GlobalVariable Property MenuControl_AssignEmployees Auto hidden
GlobalVariable Property MenuControl_ManageProjects Auto hidden
GlobalVariable Property SS2_Settings_UseJobTitles Auto hidden
GlobalVariable Property SS2_Settings_AllowPlotsToEquipSettlers Auto hidden
simsettlementsv2:hq:hqworkermanagerquest Property HQWorkerManager Auto hidden
simsettlementsv2:hq:hqactionmanagerquest Property HQActionManager Auto hidden
simsettlementsv2:hq:hqmanagerquest Property HQManager Auto hidden

;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

Function UpdateJobTitle(Actor akActorRef, simsettlementsv2:hq:library:objectrefs:room akAssignedRoom)
	If (!akActorRef || SS2_Settings_UseJobTitles.GetValueInt() == 0)
		return 
	EndIf
	SimSettlementsV2:HQ:Library:ObjectRefs:DepartmentObject kCurrentDepartment = akActorRef.GetLinkedRef(SS2_Link_AssignedDepartment) as SimSettlementsV2:HQ:Library:ObjectRefs:DepartmentObject
	If (kCurrentDepartment == None)
		Self.ClearJobTitle(akActorRef)
		return 
	EndIf
	Message TitleToApply = None
	If (akAssignedRoom != None)
		
	EndIf
	If (TitleToApply == None)
		Race ActorRace = akActorRef.GetRace()
		int I = 0
		While (I < DefaultTitles.length && TitleToApply == None)
			If (DefaultTitles[I].FactionForm == None || akActorRef.GetFactionRank(DefaultTitles[I].FactionForm) >= DefaultTitles[I].iFactionRank)
				TitleToApply = DefaultTitles[I].MessageForm
			EndIf
			I += 1
		EndWhile
	EndIf
	If (TitleToApply != None)
		akActorRef.SetActivateTextOverride(TitleToApply)
	EndIf
EndFunction

Function DistributeWorkersToRooms()
	ObjectReference[] LinkedRooms = Self.GetLinkedRefChildren(SS2_Link_RoomToDepartment)
	ObjectReference[] DepartmentWorkers = Self.GetLinkedRefChildren(SS2_Link_AssignedDepartment)
	If (DepartmentWorkers.length == 0)
		return 
	EndIf
	If (LinkedRooms.length == 0)
		int i = 0
		While (i < DepartmentWorkers.length)
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), Self as string + ": Updating Outfit/Title for " + DepartmentWorkers[i] as string, 0, False)
			Self.UpdateOutfit(DepartmentWorkers[i] as Actor, None)
			Self.UpdateJobTitle(DepartmentWorkers[i] as Actor, None)
			i += 1
		EndWhile
		return 
	EndIf
	int I = 0
	int iNextWorkerIndex = 0
	int iPerRoom = Math.Max(1, Math.Floor((DepartmentWorkers.length / LinkedRooms.length) as float) as float) as int
	While (I < LinkedRooms.length)
		int j = 0
		While (j < iPerRoom)
			Self.AssignPost(DepartmentWorkers[iNextWorkerIndex] as Actor, LinkedRooms[I] as simsettlementsv2:hq:library:objectrefs:room)
			iNextWorkerIndex += 1
			j += 1
		EndWhile
		I += 1
	EndWhile
	While (iNextWorkerIndex < DepartmentWorkers.length)
		Self.AssignPost(DepartmentWorkers[iNextWorkerIndex] as Actor, LinkedRooms[LinkedRooms.length - 1] as simsettlementsv2:hq:library:objectrefs:room)
		iNextWorkerIndex += 1
	EndWhile
EndFunction

Function AssignRoomToDepartment(simsettlementsv2:hq:library:objectrefs:room akRoomRef)
	If (!akRoomRef)
		return 
	EndIf
	SimSettlementsV2:HQ:Library:ObjectRefs:DepartmentObject kPreviousDepartment = akRoomRef.GetLinkedRef(SS2_Link_RoomToDepartment) as SimSettlementsV2:HQ:Library:ObjectRefs:DepartmentObject
	If (kPreviousDepartment != Self)
		akRoomRef.SetLinkedRef(Self as ObjectReference, SS2_Link_RoomToDepartment)
		Self.DistributeWorkersToRooms()
		If (kPreviousDepartment != None)
			kPreviousDepartment.DistributeWorkersToRooms()
		EndIf
	EndIf
EndFunction

Function UpdateWorkerStatResources()
	ObjectReference[] AssignedWorkers = Self.GetLinkedRefChildren(SS2_Link_AssignedDepartment)
	int I = 0
	float fTotalResourceValue = 0
	While (I < AssignedWorkers.length)
		If (AssignedWorkers[I] as Actor)
			fTotalResourceValue += AssignedWorkers[I].GetValue(ResourceProvidedFromStat)
		EndIf
		I += 1
	EndWhile
	Self.SetValue(WorkshopResourceProvided, fTotalResourceValue)
	workshopscript workshopRef = Self.GetWorkshop()
	workshopRef.RecalculateResources()
	HUDManager.UpdateHQDepartment(Self)
EndFunction

Event OnInit()
	Parent.OnInit()
	Self.UpdateVars()
EndEvent

bool Function HandleManualAssignment(Actor akActorRef)
	If (!Self.CanAssignNPCToDepartment(akActorRef))
		Warning_RequestedDepartmentIsFull.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		return False
	EndIf
	akActorRef.setDoingFavor(False, False)
	akActorRef.UnregisterForDistanceEvents(akActorRef as ScriptObject, Self.GetWorkshop() as ScriptObject)
	akActorRef.SayCustom(WorkshopParent.WorkshopParentAssignConfirmTopicType, None, False, None)
	Actor kPreviousDepartmentHead = Self.GetAssignedNPC()
	bool bAlreadyHead = akActorRef == kPreviousDepartmentHead
	bool bMakeDepartmentHead = False
	If (!bAlreadyHead)
		HQWorkerManager.MessageAlias_CurrentDepartmentHead.ForceRefTo(akActorRef as ObjectReference)
		HQWorkerManager.MessageAlias_CurrentDepartmentName.ForceRefTo(Self as ObjectReference)
		int iChoice = SS2_Confirm_DepartmentHead.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		If (iChoice == 0)
			
		ElseIf (iChoice == 1)
			bMakeDepartmentHead = True
		EndIf
	EndIf
	If (bMakeDepartmentHead)
		workshopframework:workshopfunctions.AssignActorToObject(Self as WorkshopObjectScript, akActorRef, True, True, False)
		akActorRef.SetFactionRank(DepartmentFaction, iDepartmentHeadRank)
		If (kPreviousDepartmentHead.IsInFaction(DepartmentFaction))
			kPreviousDepartmentHead.SetFactionRank(DepartmentFaction, 0)
		EndIf
		HQWorkerManager.MessageAlias_CurrentDepartmentName.ForceRefTo(Self as ObjectReference)
		HQWorkerManager.MessageAlias_CurrentDepartmentHead.ForceRefTo(akActorRef as ObjectReference)
		SS2_MessageBox_NewDepartmentHead.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		HQWorkerManager.SendDepartmentHeadChangedEvent(Self, kPreviousDepartmentHead, akActorRef, Self.GetHQRef())
	EndIf
	If (akActorRef.GetLinkedRef(SS2_Link_AssignedDepartment) != Self as ObjectReference)
		Self.AssignNPCToDepartment(akActorRef, False, False)
		If (!bMakeDepartmentHead)
			HQWorkerManager.MessageAlias_CurrentDepartmentName.ForceRefTo(Self as ObjectReference)
			SS2_Notification_AssignedToDepartment.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		EndIf
	EndIf
	akActorRef.EvaluatePackage(False)
	return True
EndFunction

Function UpdateVars()
	If (HQManager == None)
		HQManager = Game.GetFormFromFile(3995, "SS2HQGNN.esm") as simsettlementsv2:hq:hqmanagerquest
	EndIf
	If (HUDManager == None)
		HUDManager = Game.GetFormFromFile(133960, "SS2.esm") as simsettlementsv2:quests:hudmanager
	EndIf
	If (HQWorkerManager == None)
		HQWorkerManager = Game.GetFormFromFile(3999, "SS2HQGNN.esm") as simsettlementsv2:hq:hqworkermanagerquest
	EndIf
	If (HQActionManager == None)
		HQActionManager = Game.GetFormFromFile(4000, "SS2HQGNN.esm") as simsettlementsv2:hq:hqactionmanagerquest
	EndIf
	If (SS2_HQWorkerID == None)
		SS2_HQWorkerID = Game.GetFormFromFile(17034, "SS2HQGNN.esm") as ActorValue
	EndIf
	If (DummyWorkshopObjectForm == None)
		DummyWorkshopObjectForm = Game.GetFormFromFile(17076, "SS2HQGNN.esm")
	EndIf
	If (NameHolderForm_None == None)
		NameHolderForm_None = Game.GetFormFromFile(17075, "SS2HQGNN.esm")
	EndIf
	If (SS2_Link_AssignedDepartment == None)
		SS2_Link_AssignedDepartment = Game.GetFormFromFile(16472, "SS2HQGNN.esm") as Keyword
	EndIf
	If (SS2_Link_AssignmentDummy == None)
		SS2_Link_AssignmentDummy = Game.GetFormFromFile(17074, "SS2HQGNN.esm") as Keyword
	EndIf
	If (SS2_Link_WorkerToPost == None)
		SS2_Link_WorkerToPost = Game.GetFormFromFile(17681, "SS2HQGNN.esm") as Keyword
	EndIf
	If (SS2_Link_RoomToDepartment == None)
		SS2_Link_RoomToDepartment = Game.GetFormFromFile(17057, "SS2HQGNN.esm") as Keyword
	EndIf
	If (WorkshopItemKeyword == None)
		WorkshopItemKeyword = Game.GetFormFromFile(347046, "Fallout4.esm") as Keyword
	EndIf
	If (SS2_Confirm_DepartmentHead == None)
		SS2_Confirm_DepartmentHead = Game.GetFormFromFile(16486, "SS2HQGNN.esm") as Message
	EndIf
	If (SS2_MessageBox_NewDepartmentHead == None)
		SS2_MessageBox_NewDepartmentHead = Game.GetFormFromFile(16489, "SS2HQGNN.esm") as Message
	EndIf
	If (SS2_Notification_AssignedToDepartment == None)
		SS2_Notification_AssignedToDepartment = Game.GetFormFromFile(16490, "SS2HQGNN.esm") as Message
	EndIf
	If (SS2_Menu_HQ_ManageDepartment == None)
		SS2_Menu_HQ_ManageDepartment = Game.GetFormFromFile(17072, "SS2HQGNN.esm") as Message
	EndIf
	If (Warning_RequestedDepartmentIsFull == None)
		Warning_RequestedDepartmentIsFull = Game.GetFormFromFile(17084, "SS2HQGNN.esm") as Message
	EndIf
	If (MenuControl_AssignLeader == None)
		MenuControl_AssignLeader = Game.GetFormFromFile(17068, "SS2HQGNN.esm") as GlobalVariable
	EndIf
	If (MenuControl_DismissLeader == None)
		MenuControl_DismissLeader = Game.GetFormFromFile(17069, "SS2HQGNN.esm") as GlobalVariable
	EndIf
	If (MenuControl_AssignEmployees == None)
		MenuControl_AssignEmployees = Game.GetFormFromFile(17070, "SS2HQGNN.esm") as GlobalVariable
	EndIf
	If (MenuControl_ManageProjects == None)
		MenuControl_ManageProjects = Game.GetFormFromFile(17071, "SS2HQGNN.esm") as GlobalVariable
	EndIf
	If (SS2_Settings_UseJobTitles == None)
		SS2_Settings_UseJobTitles = Game.GetFormFromFile(84869, "SS2.esm") as GlobalVariable
	EndIf
	If (SS2_Settings_AllowPlotsToEquipSettlers == None)
		SS2_Settings_AllowPlotsToEquipSettlers = Game.GetFormFromFile(84867, "SS2.esm") as GlobalVariable
	EndIf
EndFunction

workshopscript Function GetHQRef()
	return Self.GetLinkedRef(WorkshopItemKeyword) as workshopscript
EndFunction

int Function GetWorkerCount()
	ObjectReference[] AssignedWorkers = Self.GetLinkedRefChildren(SS2_Link_AssignedDepartment)
	return AssignedWorkers.length
EndFunction

Function ClearPost(Actor akActorRef)
	akActorRef.SetLinkedRef(None, SS2_Link_WorkerToPost)
EndFunction

Function UnssignActorFromDummyRef(Actor akActorRef)
	WorkshopObjectScript thisDummy = akActorRef.GetLinkedRef(SS2_Link_AssignmentDummy) as WorkshopObjectScript
	If (thisDummy != None)
		thisDummy.AssignNPC(None)
	EndIf
	If (UnusedDummyRefs.find(thisDummy, 0) < 0)
		UnusedDummyRefs.add(thisDummy, 1)
	EndIf
	int iIndex = AssignmentDummyRefs.find(thisDummy, 0)
	If (iIndex >= 0)
		AssignmentDummyRefs.remove(iIndex, 1)
	EndIf
	akActorRef.SetLinkedRef(None, SS2_Link_AssignmentDummy)
EndFunction

Function UnassignNPCFromDepartment(Actor akActorRef, bool abBulkAssignment)
	iAssignedWorkerCount -= 1
	If (iAssignedWorkerCount < 0)
		iAssignedWorkerCount = 0
		bRecalculationNeeded = True
	EndIf
	akActorRef.SetLinkedRef(None, SS2_Link_AssignedDepartment)
	Self.UnssignActorFromDummyRef(akActorRef)
	If (akActorRef == Self.GetAssignedNPC())
		HQWorkerManager.SendDepartmentHeadChangedEvent(Self, akActorRef, None, Self.GetHQRef())
		Self.AssignNPC(None)
	EndIf
	Self.ClearPost(akActorRef)
	akActorRef.RemoveFromFaction(DepartmentFaction)
	akActorRef.EvaluatePackage(False)
	If (!abBulkAssignment)
		Self.UpdateWorkerStatResources()
		Self.DistributeWorkersToRooms()
	EndIf
	workshopscript thisWorkshop = Self.GetHQRef()
	simsettlementsv2:hq:library:objectrefs:hqdata thisData = HQManager.HQ_API_GetHQDataStoreFromWorkshop(thisWorkshop)
	If (thisData != None)
		int iWorkerID = akActorRef.GetValue(SS2_HQWorkerID) as int
		int iTrackedWorkerIndex = thisData.FindTrackedWorker(iWorkerID)
		simsettlementsv2:hq:library:hqdatastructures#hqworkerstruct CurrentWorkerData = thisData.GetTrackedWorkerData(iWorkerID)
		If (CurrentWorkerData.Department == Self)
			CurrentWorkerData.Department = None
			thisData.UpdateTrackedWorker(iWorkerID, CurrentWorkerData)
		EndIf
	EndIf
	HQWorkerManager.SendWorkerRemovedFromDepartmentEvent(akActorRef, Self, thisWorkshop)
EndFunction

Function AssignActorToDummyRef(Actor akActorRef)
	If (AssignmentDummyRefs == None)
		AssignmentDummyRefs = new workshopobjectscript[0]
	EndIf
	bool bHasDummyRef = False
	int I = 0
	While (I < AssignmentDummyRefs.length && !bHasDummyRef)
		If (AssignmentDummyRefs[I].GetActorRefOwner() == akActorRef)
			bHasDummyRef = True
		EndIf
		I += 1
	EndWhile
	If (!bHasDummyRef)
		WorkshopObjectScript kDummyRef = Self.GetUnusedDummyRef()
		int iIndex = UnusedDummyRefs.find(kDummyRef, 0)
		AssignmentDummyRefs.add(kDummyRef, 1)
		UnusedDummyRefs.remove(iIndex, 1)
		akActorRef.SetLinkedRef(kDummyRef as ObjectReference, SS2_Link_AssignmentDummy)
		kDummyRef.AssignNPC(akActorRef)
	EndIf
EndFunction

Function ClearPreviousDepartmentAssignment(Actor akActorRef)
	SimSettlementsV2:HQ:Library:ObjectRefs:DepartmentObject previousDepartmentRef = akActorRef.GetLinkedRef(SS2_Link_AssignedDepartment) as SimSettlementsV2:HQ:Library:ObjectRefs:DepartmentObject
	If (previousDepartmentRef != None && previousDepartmentRef != Self)
		previousDepartmentRef.UnassignNPCFromDepartment(akActorRef, False)
	EndIf
EndFunction

Function CleanupDummyArrays()
	int I = UnusedDummyRefs.length - 1
	While (I >= 0)
		WorkshopObjectScript thisDummy = UnusedDummyRefs[I]
		If (thisDummy as bool && thisDummy.GetActorRefOwner() != None)
			UnusedDummyRefs.remove(I, 1)
			If (AssignmentDummyRefs.find(thisDummy, 0) < 0)
				If (AssignmentDummyRefs == None)
					AssignmentDummyRefs = new workshopobjectscript[0]
				EndIf
				AssignmentDummyRefs.add(thisDummy, 1)
			EndIf
		EndIf
		I -= 1
	EndWhile
	I = AssignmentDummyRefs.length - 1
	While (I >= 0)
		WorkshopObjectScript thisdummy = UnusedDummyRefs[I]
		If (thisdummy as bool && thisdummy.GetActorRefOwner() == None)
			AssignmentDummyRefs.remove(I, 1)
			If (UnusedDummyRefs.find(thisdummy, 0) < 0)
				If (UnusedDummyRefs == None)
					UnusedDummyRefs = new workshopobjectscript[0]
				EndIf
				UnusedDummyRefs.add(thisdummy, 1)
			EndIf
		EndIf
		I -= 1
	EndWhile
EndFunction

Event OnActivate(ObjectReference akActivatedBy)
	Parent.OnActivate(akActivatedBy)
	If (akActivatedBy == Game.GetPlayer() as ObjectReference)
		MenuControl_AssignLeader.SetValueInt(1)
		If (DepartmentHead == None)
			MenuControl_DismissLeader.SetValueInt(0)
			MenuControl_AssignEmployees.SetValueInt(0)
			MenuControl_ManageProjects.SetValueInt(0)
		Else
			MenuControl_DismissLeader.SetValueInt(1)
			MenuControl_AssignEmployees.SetValueInt(1)
			MenuControl_ManageProjects.SetValueInt(1)
		EndIf
		HQWorkerManager.MessageAlias_CurrentDepartmentName.ForceRefTo(Self as ObjectReference)
		If (DepartmentHead == None)
			ObjectReference kNoneNamedRef = Self.PlaceAtMe(NameHolderForm_None, 1, False, False, True)
			HQWorkerManager.MessageAlias_CurrentDepartmentHead.ForceRefTo(kNoneNamedRef)
		Else
			HQWorkerManager.MessageAlias_CurrentDepartmentHead.ForceRefTo(DepartmentHead as ObjectReference)
		EndIf
		int iConfirm = SS2_Menu_HQ_ManageDepartment.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		If (iConfirm == 0)
			
		ElseIf (iConfirm == 1)
			Debug.MessageBox("TODO: Present interface for selecting department heads, like leader card system")
		ElseIf (iConfirm == 2)
			Self.AssignNPC(None)
		ElseIf (iConfirm == 3)
			HQWorkerManager.HQ_API_ShowAssignDepartmentWorkersMenu(Self, False)
		ElseIf (iConfirm == 4)
			Debug.MessageBox("TODO: Hook into Action Manager")
		EndIf
	EndIf
EndEvent

Function AssignToAvailablePost(Actor akActorRef)
	ObjectReference[] LinkedRooms = Self.GetLinkedRefChildren(SS2_Link_RoomToDepartment)
	simsettlementsv2:hq:library:objectrefs:room kAssignTo = None
	int iLeastActorsAsssigned = 9999
	int I = 0
	While (I < LinkedRooms.length)
		ObjectReference[] kPrimitives = (LinkedRooms[I] as simsettlementsv2:hq:library:objectrefs:room).GetAIPrimitives()
		If (kPrimitives != None && kPrimitives.length > 0)
			ObjectReference[] kLinkedToPrimitive = kPrimitives[0].GetLinkedRefChildren(SS2_Link_WorkerToPost)
			If (kLinkedToPrimitive.length < iLeastActorsAsssigned)
				kAssignTo = LinkedRooms[I] as simsettlementsv2:hq:library:objectrefs:room
				iLeastActorsAsssigned = kLinkedToPrimitive.length
			EndIf
		EndIf
		I += 1
	EndWhile
	If (kAssignTo)
		Self.AssignPost(akActorRef, kAssignTo)
	EndIf
EndFunction

Function ActivatedByWorkshopNPC(Actor akSettlerRef)
	If (akSettlerRef as bool && akSettlerRef.IsDoingFavor() && akSettlerRef.IsInFaction(WorkshopParent.Followers.CurrentCompanionFaction) == False)
		If (bAllowPlayerAssignment)
			bool bSuccess = Self.HandleManualAssignment(akSettlerRef)
		Else
			WorkshopParent.WorkshopResourceNoAssignmentMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		EndIf
	EndIf
EndFunction

Function AssignNPC(Actor newActor)
	Parent.AssignNPC(newActor)
	DepartmentHead = newActor
EndFunction

Function ClearJobTitle(Actor akActorRef)
	akActorRef.SetActivateTextOverride(None)
EndFunction

Function UpdateOutfit(Actor akActorRef, simsettlementsv2:hq:library:objectrefs:room akAssignedRoom)
	If (!akActorRef || akActorRef.GetLinkedRef(SS2_Link_AssignedDepartment) != Self as ObjectReference || SS2_Settings_AllowPlotsToEquipSettlers.GetValueInt() == 0)
		return 
	EndIf
	If (akActorRef.GetActorBase().IsUnique())
		return 
	EndIf
	Outfit OutfitToApply = None
	If (akAssignedRoom != None)
		
	EndIf
	If (OutfitToApply == None)
		Race ActorRace = akActorRef.GetRace()
		int I = 0
		While (I < DefaultOutfits.length && OutfitToApply == None)
			If (DefaultOutfits[I].RaceForm == None || DefaultOutfits[I].RaceForm == ActorRace)
				If (DefaultOutfits[I].FactionForm == None || akActorRef.GetFactionRank(DefaultOutfits[I].FactionForm) >= DefaultOutfits[I].iFactionRank)
					OutfitToApply = DefaultOutfits[I].OutfitForm
				EndIf
			EndIf
			I += 1
		EndWhile
	EndIf
	If (OutfitToApply != None)
		akActorRef.SetOutfit(OutfitToApply, False)
	EndIf
EndFunction

Function AssignPost(Actor akActorRef, simsettlementsv2:hq:library:objectrefs:room akRoomRef)
	If (akActorRef == None || akRoomRef == None)
		return 
	EndIf
	ObjectReference[] kPrimitives = akRoomRef.GetAIPrimitives()
	ObjectReference kCurrentPost = akActorRef.GetLinkedRef(SS2_Link_WorkerToPost)
	If (kPrimitives.find(kCurrentPost, 0) < 0)
		akActorRef.SetLinkedRef(kPrimitives[0], SS2_Link_WorkerToPost)
		If (!Game.GetPlayer().HasDetectionLOS(akActorRef as ObjectReference))
			akActorRef.MoveTo(kPrimitives[0], 0, 0, 0, True)
			Utility.Wait(0.01)
			akActorRef.MoveToNearestNavmeshLocation()
		EndIf
	EndIf
	Self.UpdateOutfit(akActorRef, akRoomRef)
	Self.UpdateJobTitle(akActorRef, akRoomRef)
EndFunction

bool Function TryToAssignNPCToDepartment(Actor akActorRef, bool abMakeHeadIfNoneFound)
	If (Self.CanAssignNPCToDepartment(akActorRef))
		Self.AssignNPCToDepartment(akActorRef, abMakeHeadIfNoneFound, False)
		return True
	Else
		return False
	EndIf
EndFunction

WorkshopObjectScript Function GetUnusedDummyRef()
	WorkshopObjectScript kDummyRef = None
	If (UnusedDummyRefs.length > 0)
		kDummyRef = UnusedDummyRefs[UnusedDummyRefs.length - 1]
	EndIf
	If (!kDummyRef)
		kDummyRef = Self.PlaceAtMe(DummyWorkshopObjectForm, 1, False, False, False) as WorkshopObjectScript
		HQManager.HQ_API_StampDepartmentNameOnRef(Self, kDummyRef as ObjectReference)
		kDummyRef.SetLinkedRef(Self.GetLinkedRef(WorkshopItemKeyword), WorkshopItemKeyword)
		kDummyRef.SetLinkedRef(Self as ObjectReference, SS2_Link_AssignmentDummy)
		UnusedDummyRefs.add(kDummyRef, 1)
	EndIf
	return kDummyRef
EndFunction

bool Function CanAssignNPCToDepartment(Actor akActorRef)
	return iAssignedWorkerCount < Self.MaxWorkerCount
EndFunction

Function AssignNPCToDepartment(Actor akActorRef, bool abMakeHeadIfNoneFound, bool abBulkAssignment)
	Self.ClearPreviousDepartmentAssignment(akActorRef)
	iAssignedWorkerCount += 1
	If (iAssignedWorkerCount < 1)
		iAssignedWorkerCount = 1
		bRecalculationNeeded = True
	EndIf
	akActorRef.SetLinkedRef(Self as ObjectReference, SS2_Link_AssignedDepartment)
	If (abMakeHeadIfNoneFound && DepartmentHead == None)
		workshopframework:workshopfunctions.AssignActorToObject(Self as WorkshopObjectScript, akActorRef, True, True, False)
	Else
		Self.AssignActorToDummyRef(akActorRef)
	EndIf
	If (!abBulkAssignment)
		Self.UpdateWorkerStatResources()
		Self.AssignToAvailablePost(akActorRef)
	EndIf
	akActorRef.AddToFaction(DepartmentFaction)
	akActorRef.EvaluatePackage(False)
	workshopscript thisWorkshop = Self.GetHQRef()
	simsettlementsv2:hq:library:objectrefs:hqdata thisData = HQManager.HQ_API_GetHQDataStoreFromWorkshop(thisWorkshop)
	If (thisData != None)
		int iWorkerID = akActorRef.GetValue(SS2_HQWorkerID) as int
		If (iWorkerID > 0)
			int iTrackedWorkerIndex = thisData.FindTrackedWorker(iWorkerID)
			If (iTrackedWorkerIndex >= 0)
				simsettlementsv2:hq:library:hqdatastructures#hqworkerstruct CurrentWorkerData = thisData.GetTrackedWorkerData(iWorkerID)
				CurrentWorkerData.Department = Self
				thisData.UpdateTrackedWorker(iWorkerID, CurrentWorkerData)
			EndIf
		EndIf
	EndIf
	HQWorkerManager.SendWorkerAssignedToDepartmentEvent(akActorRef, Self, thisWorkshop)
EndFunction
