;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\HQ\Library\Weapons\RoomLayout.psc
Modified : 2021-01-19 23:27:11
Compiled : 2021-03-14 00:05:41
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName simsettlementsv2:hq:library:weapons:roomlayout extends WorkshopFramework:Weapons:SettlementLayout Const
{ Holds room layout details. }

;-- Properties --------------------------------------
Group LayoutDetails
	Form Property TargetRoomOrRoomType Auto Const mandatory
	{ This should be pointed at the room object reference, or the room type which can be used to look up the room it is applied to. }
EndGroup

Group Resources collapsedonref collapsedonbase
	bool Property OperatingCostsAreAdditional = True Auto Const
	{ If false, the OperatingCosts will replace those at the RoomConfig level }
	simsettlementsv2:datastructures#plotconsumption[] Property OperatingCosts Auto Const
	{ Items this layout will consume each cycle, if not available, the room will be made inactive until it can next consume the appropriate costs. }
	bool Property ProducedItemsAreAdditional = True Auto Const
	{ If false, the ProduceItems will replace those at the RoomConfig level }
	simsettlementsv2:datastructures#plotproduction[] Property ProducedItems Auto Const
	{ Items this layout will produce each cycle. }
	bool Property SettlementResourcesAreAdditional = True Auto Const
	{ If false, the SettlementResources will replace those at the RoomConfig level }
	simsettlementsv2:datastructures#plotresource[] Property SettlementResources Auto Const
	{ These AVs will be set on the settlement while this is active. This is used to add features to the settlement, and is generally NOT meant for food/water/scrap - as produced resources like that should be coming from caravans. }
EndGroup

Group Advanced collapsedonref collapsedonbase
	Form[] Property DependentRoomLayouts Auto Const
	{ These layouts must remain applied for this layout to be available/remain applied }
	MiscObject Property Requirements Auto Const
	{ If you are looking to set requirements on whether a room layout can be built in the first place, you should set them up on the HQ Upgrade Action. Requirements filled out here are used to determine if this layout should be scrapped later due to failing them - in order words, these are requirements for this layout to remain in place. Must be of type SimSettlementsV2:MiscObjects:UsageRequirements }
	bool Property bIgnorePerformanceOptions = False Auto Const
	{ When set to true, these items will be displayed regardless of performance options. This should only be used for very small layouts. }
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

simsettlementsv2:miscobjects:usagerequirements Function GetRequirements()
	return (Requirements as Form) as simsettlementsv2:miscobjects:usagerequirements
EndFunction

Keyword Function GetRoomLinkedKeyword()
	return Game.GetFormFromFile(84478, "SS2.esm") as Keyword
EndFunction

int Function RemoveLayoutObjects(workshopscript akWorkshopRef, bool abCallbacksNeeded)
	simsettlementsv2:hq:library:objectrefs:room kRoomRef = Self.GetRoomReference()
	If (kRoomRef)
		Keyword RoomLinkedKeyword = Self.GetRoomLinkedKeyword()
		ObjectReference[] kLinkedRefs = kRoomRef.GetLinkedRefChildren(RoomLinkedKeyword)
		int I = 0
		While (I < kLinkedRefs.length)
			kLinkedRefs[I].SetLinkedRef(None, RoomLinkedKeyword)
			I += 1
		EndWhile
	EndIf
	Parent.RemoveLayoutObjects(akWorkshopRef, abCallbacksNeeded)
EndFunction

GlobalVariable Function GetAllDLCInstalled()
	return Game.GetFormFromFile(304706, "SS2.esm") as GlobalVariable
EndFunction

bool Function ShouldPlaceObject(workshopscript akWorkshopRef, int aiObjectsGroupType, int aiObjectsGroupIndex)
	Form FormToCheck = None
	If (aiObjectsGroupType == iGroupType_WorkshopResources)
		FormToCheck = workshopframework:library:utilityfunctions.GetWorldObjectForm(WorkshopResources[aiObjectsGroupIndex], -1)
	ElseIf (aiObjectsGroupType == iGroupType_NonResources)
		FormToCheck = workshopframework:library:utilityfunctions.GetWorldObjectForm(NonResourceObjects[aiObjectsGroupIndex], -1)
	EndIf
	If (Self.GetAllDLCInstalled().GetValueInt() == 0)
		simsettlementsv2:quests:cityplanmanager CityPlanManager = simsettlementsv2:utilityfunctions.GetCityPlanManager()
		If (!CityPlanManager.SoftDLCRequirementsMet(FormToCheck))
			return False
		EndIf
	EndIf
	return True
EndFunction

simsettlementsv2:hq:library:objectrefs:room Function GetRoomReference()
	simsettlementsv2:hq:library:objectrefs:room kRoomRef = TargetRoomOrRoomType as simsettlementsv2:hq:library:objectrefs:room
	If (kRoomRef == None)
		
	EndIf
	return kRoomRef
EndFunction

bool Function PlaceObjectThreadLastCall(ObjectReference akThreadRef)
	workshopframework:objectrefs:thread_placeobject asPlaceObjectThread = akThreadRef as workshopframework:objectrefs:thread_placeobject
	Keyword RoomSpawnedKeyword = Self.GetRoomSpawnedKeyword()
	Keyword RoomLinkedKeyword = Self.GetRoomLinkedKeyword()
	asPlaceObjectThread.bFauxPowered = True
	asPlaceObjectThread.AddTagKeyword(RoomSpawnedKeyword)
	simsettlementsv2:hq:library:objectrefs:room kRoomRef = Self.GetRoomReference()
	asPlaceObjectThread.AddLinkedRef(kRoomRef as ObjectReference, RoomLinkedKeyword)
	return True
EndFunction

simsettlementsv2:quests:optionsmanager Function GetOptionsManager()
	return Game.GetFormFromFile(60195, "SS2.esm") as simsettlementsv2:quests:optionsmanager
EndFunction

Keyword Function GetRoomSpawnedKeyword()
	return Game.GetFormFromFile(88039, "SS2.esm") as Keyword
EndFunction
