;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\LaserTurret\SS2_WC_BFG_FurnScript.psc
Modified : 2021-03-02 01:18:53
Compiled : 2021-03-02 01:19:23
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:LaserTurret:SS2_WC_BFG_FurnScript extends workshopobjectscript

;-- Properties --------------------------------------
Group SS2LaserTurretProperties
	ActorBase Property LaserTurret Auto Const mandatory
	Keyword Property AttachPilot Auto Const mandatory
	Keyword Property LinkVehicle Auto Const mandatory
	Keyword Property WorkshopStackedItemParentKEYWORD Auto Const mandatory
	float Property fFurnitureAngleOffset = 0 Auto Const
EndGroup

Actor Property GunnerActor Auto hidden
Actor Property TurretActor Auto hidden
float Property angleX Auto hidden
float Property angleY Auto hidden
float Property angleZ Auto hidden
bool Property bHiding Auto hidden

;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

Function Hide()
	bHiding = True
	Self.Disable(False)
	bHiding = False
EndFunction

Event OnWorkshopObjectDestroyed(ObjectReference akReference)
	Self.Cleanup()
	Parent.OnWorkshopObjectDestroyed(akReference)
EndEvent

Event Actor.OnGetUp(Actor akSender, ObjectReference akFurniture)
	If (akSender == GunnerActor && akFurniture == TurretActor as ObjectReference)
		If (GunnerActor.IsDead())
			Self.Cleanup()
			Self.AssignActor(None)
		ElseIf (GunnerActor.IsBleedingOut())
			TurretActor.SetUnconscious(True)
		ElseIf (TurretActor.IsUnconscious() || TurretActor.IsDead() || TurretActor.IsBleedingOut())
			Self.Dismount()
		ElseIf (Self.Is3dLoaded())
			Self.Dismount()
		EndIf
	EndIf
EndEvent

Function Delete()
	Self.Cleanup()
	Parent.Delete()
EndFunction

Event Actor.OnCommandModeGiveCommand(Actor akSender, int aeCommandType, ObjectReference akTarget)
	If (akSender == GunnerActor && aeCommandType == 3)
		Self.Dismount()
	EndIf
EndEvent

Function Disable(bool abFadeOut)
	If (!bHiding)
		Self.Dismount()
	EndIf
	Parent.Disable(abFadeOut)
	If (!bHiding)
		Self.Cleanup()
	EndIf
EndFunction

Function Cleanup()
	Self.Dismount()
	If (GunnerActor)
		Self.UnregisterForRemoteEvent(GunnerActor as ScriptObject, "OnCommandModeGiveCommand")
		Self.UnregisterForRemoteEvent(GunnerActor as ScriptObject, "OnGetUp")
		Self.UnregisterForRemoteEvent(GunnerActor as ScriptObject, "OnSit")
	EndIf
	GunnerActor = None
	TurretActor = None
EndFunction

Function Dismount()
	If (TurretActor != None)
		TurretActor.SetUnconscious(True)
	EndIf
	Self.Enable(False)
	If (GunnerActor)
		GunnerActor.SetAngle(0, 0, GunnerActor.Z)
		GunnerActor.RemoveKeyword(AttachPilot)
		GunnerActor.SetLinkedRef(None, LinkVehicle)
		GunnerActor.SetVehicle(None)
		If (!GunnerActor.IsDead())
			If (GunnerActor.GetSitState() == 3)
				GunnerActor.SnapIntoInteraction(Self as ObjectReference)
				Self.Activate(GunnerActor as ObjectReference, False)
				Utility.Wait(0.1)
			EndIf
		EndIf
	EndIf
	Self.ClearTurretActor()
EndFunction

Function HandleSit()
	If (TurretActor == None)
		TurretActor = Self.PlaceAtMe(LaserTurret as Form, 1, False, False, False) as Actor
		TurretActor.SetUnconscious(True)
		TurretActor.SetAngle(angleX, angleY, angleZ)
		TurretActor.SetLinkedRef(Self as ObjectReference, WorkshopStackedItemParentKEYWORD)
		Self.RegisterForRemoteEvent(TurretActor as ScriptObject, "OnExitFurniture")
	EndIf
	GunnerActor.AddKeyword(AttachPilot)
	GunnerActor.SetLinkedRef(TurretActor as ObjectReference, LinkVehicle)
	GunnerActor.SetVehicle(TurretActor)
	GunnerActor.SnapIntoInteraction(TurretActor as ObjectReference)
	TurretActor.SetUnconscious(False)
	Self.Hide()
	Utility.Wait(0.1)
EndFunction

Event Actor.OnSit(Actor akSender, ObjectReference akFurniture)
	If (akSender == GunnerActor && akFurniture == Self as ObjectReference)
		Self.HandleSit()
	EndIf
EndEvent

Function ClearTurretActor()
	If (TurretActor != None)
		Self.UnregisterForRemoteEvent(TurretActor as ScriptObject, "OnExitFurniture")
		TurretActor.SetLinkedRef(None, WorkshopStackedItemParentKEYWORD)
		TurretActor.Disable(False)
		TurretActor.Delete()
	EndIf
	TurretActor = None
EndFunction

Event ObjectReference.OnExitFurniture(ObjectReference akFurnitureRef, ObjectReference akActionRef)
	Self.Dismount()
EndEvent

Function AssignNPC(Actor newActor)
	If (newActor)
		Parent.AssignNPC(newActor)
		Self.RegisterForRemoteEvent(newActor as ScriptObject, "OnGetUp")
		Self.RegisterForRemoteEvent(newActor as ScriptObject, "OnCommandModeGiveCommand")
		Self.RegisterForRemoteEvent(newActor as ScriptObject, "OnSit")
		If (newActor != GunnerActor)
			GunnerActor = newActor
			angleX = Self.GetAngleX()
			angleY = Self.GetAngleY()
			angleZ = Self.GetAngleZ() + fFurnitureAngleOffset
		EndIf
	Else
		Self.Cleanup()
		Parent.AssignNPC(None)
	EndIf
EndFunction
