;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\MiscObjects\CameraControlSequence.psc
Modified : 2020-05-11 15:05:49
Compiled : 2021-01-07 11:38:56
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:MiscObjects:CameraControlSequence extends Form Const
{ Holds configuration for a camera control sequence }

;-- Properties --------------------------------------
Group Configuration
	int Property iCameraMode Auto Const mandatory
	{ 1 = Cinematic Circle - ie. the camera will follow a looping path around a center point; 2 = Tour - ie. the camera will follow a set of object references }
	bool Property bUseSplines = True Auto Const
	{ Movement will be curved to smooth the transition between points }
	bool Property bDynamicallyToggleTangent = True Auto Const
	{ If bUseSplines is true, the tangent will be inverted at each camera marker, resulting in a smooth transition from one to the other in an S formation. If off, the transitions will make a W shape as they approach and leave each marker. }
	bool Property bDefaultForceLook = True Auto Const
	{ If player does not have Free Cam setting enabled for the camera control settings, this will force them to look at certain targets when this sequence is triggered }
	float Property fCameraSpeed = 250 Auto Const
	{ Warning, anything above 500 might cause issues with zones not loading in time. }
	float Property fTangentMagnitude = 1.3 Auto Const
	{ When bUseSplines is enabled, this is applied as a multiplier to adjust the curve between travel positions. }
	float Property fMaxRotationSpeed = 10 Auto Const
	{ 0 = no limit; This determines how quickly the camera will rotate towards its next target }
	float Property fShortCameraTravelDistanceMax = 2000 Auto Const
	{ If the travel distance for the camera is below this threshold, the ShortCameraTravelDistance modifiers will be used }
	float Property fLongCameraTravelDistanceMin = 4000 Auto Const
	{ If the travel distance for the camera is above this threshold, the LongCameraTravelDistance modifiers will be used }
	simsettlementsv2:datastructures#cinematiccircledata[] Property CinematicCircles Auto Const mandatory
	{ If iCameraMode == 1 (otherwise, can be skipped!), these can cause the camera to automatically change it's marker locations after a certain number of loops. For example, to pull back for a wider shot. }
	float Property fRotateCameraMarkersAngleEachLoop = 0 Auto Const
	{ If iCameraMode == 1, this will cause the camera markers to rotate around the center point by this amount after each loop, this makes each loop a little bit different to avoid it feeling repetitive. }
EndGroup

Group InitialSetup
	float Property fSetupSpeed = 500 Auto Const
	{ Speed the camera is moved into the initial position - this can generally be quite fast without issue since it's only used for the first leg of movement and will not require sustained high-speed rendering. }
	bool Property bFaceCenterMarkerDuringSetup = False Auto Const
	{ If true, the camera will face the center marker during the movement to get to the first camera marker. If false, it will instead face that first marker. }
EndGroup

Group ShortCameraTravelDistanceModifiers
	float Property fTangentMultiplier_ShortCameraTravelDistance = 115 Auto Const
	float Property fSpeedMultiplier_ShortCameraTravelDistance = 0.8 Auto Const
EndGroup

Group LongCameraTravelDistanceModifiers
	float Property fTangentMultiplier_LongCameraTravelDistance = 85 Auto Const
	float Property fSpeedMultiplier_LongCameraTravelDistance = 1.4 Auto Const
EndGroup

Group SoundAndMusic
	simsettlementsv2:datastructures#cameramodemusicdata[] Property MusicTracks Auto Const
	bool Property bPlaySequentially = False Auto Const
	{ If false, the tracks will be randomized }
	bool Property bTurnOffPipboyRadio = True Auto Const
	bool Property bMuteGameMusic = True Auto Const
	bool Property bMuteVoices = True Auto Const
	bool Property bMuteSoundscape = True Auto Const
EndGroup

Group Simulation
	bool Property bSpeedUpNPCs = False Auto Const
	{ If true, any NPCs in the area will be sped up to simulate a lot of time passing }
	Weather[] Property WeatherChanges Auto Const
	{ If set, weather will be changed between these throughout the camera sequence to simulate a lot of time passing (or to just have a constant weather, simply include one entry) }
	float Property fFirstWeatherChangeTime = 20 Auto Const
	{ How long after the camera mode starts should the first weather change occur? }
	float Property fWeatherChangeTime = 150 Auto Const
	{ How frequently to change the weather after the initial change }
EndGroup

Group Stop
	int Property iReturnPlayerToPosition = 1 Auto Const
	{ 1 = original position before camera mode started; 2 = Center point ref used to start the camera mode; 3 = nearest workshop fast travel marker; }
	int Property iMaxLoops = -1 Auto Const
	{ -1 = do not autostop to loop count; The camera sequence will automatically end after it has reached all targets this many times }
	int Property iMaxSongPlays = -1 Auto Const
	{ -1 = do not autostop to song play count; The camera sequence will automatically end after this many tracks have played }
	float Property fMaxSeconds = -1 Auto Const
	{ -1 = do not autostop to time; The camera sequence will automatically end after this many seconds }
EndGroup


;-- Variables ---------------------------------------
