;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\MiscObjects\PlotConfiguration.psc
Modified : 2020-12-14 15:53:41
Compiled : 2021-01-07 11:39:09
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:MiscObjects:PlotConfiguration extends Form Const
{ Holds configuration for a specific plot type }

;-- Properties --------------------------------------
Group Settings
	int Property iMaxLevel = 3 Auto Const
	{ Max levels this plot type supports }
	float[] Property BuildTimes Auto Const mandatory
	{ Number of seconds in real time it takes to complete each level. Must have a number of entries to match iMaxLevel. }
	float[] Property RealisticBuildTimes Auto Const mandatory
	{ Number of gametime hours it takes to complete each level if the RealisticBuildTime setting is used by the player. Must have a number of entries to match iMaxLevel }
	float Property fBuildTimeRandomizationMultiplier = 0.1 Auto Const
	{ Build time will be slightly randomized so that it be anywhere from BuildTimes[X] - (BuildTimes[X] * fBuildTimeRandomizationMultiplier) to BuildTimes[X] + (BuildTimes[X] * fBuildTimeRandomizationMultiplier) }
	MiscObject Property MessageSet Auto Const mandatory
	{ Group of messages this plot config should use. Must be of type SimSettlementsV2:MiscObjects:PlotMessages }
	bool Property bRequiresBuilder = True Auto Const
	{ Requires an NPC assigned to build }
	bool Property bRequiresBuilderToUpgrade = True Auto Const
	{ Requires an NPC assigned to upgrade }
	bool Property bRequiresOccupant = True Auto Const
	{ Requires an NPC assigned to operate it }
	bool[] Property bLevelRequiresPower Auto Const mandatory
	{ Include an entry for each level (including 0) }
	bool Property bPlotLevelResetsIfMoved = False Auto Const
	{ If set to false, the player will be able to pick up the plot and its contents and relocate them without penalty. This setting is override by the player controlled global SS2_Settings_AllowMovingPlotBuildings. It is designed to be an immersion feature in that the player is only control of the zone and the actual construction is handled by the owning NPC. }
EndGroup

Group Assets
	Sound Property SFX_PlotDemolition Auto Const
	Explosion Property VFX_PlotDemolition Auto Const
EndGroup

Group Indicators
	Form Property InformationIcon_PlotType Auto Const mandatory
	{ InformationIcon script type form to match the plot type }
	workshopframework:library:datastructures#worldobject[] Property DefaultPlotAccessories Auto Const
	{ Extra objects that will always be attached to the plot, regardless of plot status. This is used for things like the ASAM Sensor. }
	workshopframework:library:datastructures#worldobject[] Property UnderConstructionMarkers Auto Const
	{ Objects to spawn while the plot is under construction }
	workshopframework:library:datastructures#worldobject[] Property OccupiedMarkers Auto Const
	{ Objects to spawn while the plot is not under construction and is occupied }
	workshopframework:library:datastructures#worldobject[] Property UnoccupiedMarkers Auto Const
	{ Objects to spawn while the plot is not under construction and is unoccupied }
EndGroup

Group Keywords
	Keyword Property PlotTypeKeyword Auto Const mandatory
	{ Primary plot type, used in determining certain Sim Settlements logic }
	Keyword Property PlotSizeKeyword Auto Const mandatory
	{ Determines which plots this can be swapped with and which foundations/power poles to offer as options }
	Keyword[] Property AssignmentTypeKeywords Auto Const
	{ Settlers can own one of each assignment type - current options: Home, Job, Recreation. If this counts as multiple types, include each of those keywords. }
EndGroup

Group Formlists
	FormList Property BuildingPlansList Auto Const mandatory
	{ Eligible building plans for this plot type }
	FormList Property SkinsList Auto Const mandatory
	{ Eligible building plan skins for this plot type }
	FormList Property DefaultBuildingMaterialsStageModelList Auto Const mandatory
	{ List of building material piles this plot can place to start before it has a building plan }
	FormList Property FoundationForms Auto Const
	{ [Optional] Foundations must have the script SimSettlementsV2:MiscObjects:Foundation attached and appropriate properties filled out }
	FormList Property PowerPoleForms Auto Const
	{ [Optional] PowerPoles must have the script SimSettlementsV2:MiscObjects:PowerPole attached and appropriate properties filled out }
EndGroup

Group Resources collapsedonbase collapsedonref
	simsettlementsv2:datastructures#plotconsumption[] Property ConstructionCosts Auto Const
	{ Items this level plan will consume in order to be constructed/upgraded. iOccupants field is not used. }
	simsettlementsv2:datastructures#plotconsumption[] Property OperatingCosts Auto Const
	{ Items this building plan will consume each cycle, if not available, the building will be made inactive until it can next consume the appropriate costs. The iOccupants field can be used to adjust the affects based on the number of people occupying the plot (ie. if iOccupants is > 1, that entry will only go into affect if at least that many people occupy the plot). The iLevel field is ignored on BuildingLevelPlan objects since they are tied to a specific level. }
	simsettlementsv2:datastructures#plotproduction[] Property ProducedItems Auto Const
	{ Items this building plan will produce each cycle . The iOccupants field can be used to adjust the affects based on the number of people occupying the plot (ie. if iOccupants is > 1, that entry will only go into affect if at least that many people occupy the plot). The iLevel field is ignored on BuildingLevelPlan objects since they are tied to a specific level. }
	simsettlementsv2:datastructures#plotresource[] Property SettlementResources Auto Const
	{ These AVs will be set on the settlement while this is active. This is used to add things like, food, water, defense, etc as well as virtual resources like settlement building materials. The iOccupants field can be used to adjust the affects based on the number of people occupying the plot (ie. if iOccupants is > 1, that entry will only go into affect if at least that many people occupy the plot). The iLevel field is ignored on BuildingLevelPlan objects since they are tied to a specific level. }
EndGroup

Group UpgradeRequirements
	float[] Property fUpgradeRequirement_Time Auto Const mandatory
	{ Minimum amount of time required (in game days) to pass for each level to upgrade. Remember that level 0 counts as a level, so be sure to include an entry for it; enter 0 if you want the building to be able start building towards level 1 immediately. }
	MiscObject[] Property SpecificUpgradeRequirements Auto Const
	{ [Optional] Requirements for each level to be upgraded to. Note that level 1 counts as an upgrade as well, so your first entry will apply to whether or not a level 0 plot can upgrade to level 1. If you only want requirements on higher levels, put blank entries in before then. Additional more complex requirements can be configured by extending this script and redefining the IsEligibleForUpgrade function. Each must be of type SimSettlementsV2:MiscObjects:UsageRequirements }
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

bool Function IsEligibleForConstruction(simsettlementsv2:objectreferences:simplot akPlotRef)
	return True
EndFunction

simsettlementsv2:miscobjects:usagerequirements[] Function GetSpecificUpgradeRequirements()
	simsettlementsv2:miscobjects:usagerequirements[] TheseRequirements = new simsettlementsv2:miscobjects:usagerequirements[0]
	int I = 0
	While (I < SpecificUpgradeRequirements.length)
		TheseRequirements.add((SpecificUpgradeRequirements[I] as Form) as simsettlementsv2:miscobjects:usagerequirements, 1)
		I += 1
	EndWhile
	return TheseRequirements
EndFunction

bool Function DoesLevelRequirePower(int aiCheckLevel)
	If (bLevelRequiresPower.length > aiCheckLevel && bLevelRequiresPower[aiCheckLevel])
		return True
	Else
		return False
	EndIf
EndFunction

bool Function DoesPlotConfigRequirePower()
	int I = 0
	While (I < bLevelRequiresPower.length)
		If (bLevelRequiresPower[I])
			return True
		EndIf
		I += 1
	EndWhile
	return False
EndFunction

simsettlementsv2:miscobjects:usagerequirements Function GetSpecificUpgradeRequirement(int aiIndex)
	return (SpecificUpgradeRequirements[aiIndex] as Form) as simsettlementsv2:miscobjects:usagerequirements
EndFunction

simsettlementsv2:miscobjects:plotmessages Function GetMessageSet()
	return (MessageSet as Form) as simsettlementsv2:miscobjects:plotmessages
EndFunction

bool Function IsEligibleToProduce(simsettlementsv2:objectreferences:simplot akPlotRef)
	return True
EndFunction

bool Function IsEligibleForUpgrade(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (!akPlotRef)
		return False
	EndIf
	bool bTimeCheckPassed = True
	bool bSpecialChecksPassed = True
	bool bPowerCheckPassed = True
	int iCurrentLevel = akPlotRef.iCurrentLevel
	float fCurrentTime = Utility.GetCurrentGameTime()
	If (iCurrentLevel > 0)
		float fLastUpgradeTime = akPlotRef.fLastUpgradeTime
		float fUpgradeSpeedModifiers = akPlotRef.GetUpgradeSpeedModifiers(fUpgradeRequirement_Time[iCurrentLevel])
		float fNextUpgradeTime = fLastUpgradeTime + fUpgradeRequirement_Time[iCurrentLevel] + fUpgradeSpeedModifiers
		If (fCurrentTime < fNextUpgradeTime)
			bTimeCheckPassed = False
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Plot " + akPlotRef as string + " Can't Upgrade: Not enough time passed. Time passed since last upgrade: " + (fCurrentTime - fLastUpgradeTime) as string + ", time required to upgrade = " + fUpgradeRequirement_Time[iCurrentLevel] as string + "; fUpgradeSpeedModifiers = " + fUpgradeSpeedModifiers as string + ", fLastUpgradeTime = " + fLastUpgradeTime as string + ", fCurrentTime = " + fCurrentTime as string + ", fNextUpgradeTime = " + fNextUpgradeTime as string + ".", 0, False)
		ElseIf (fCurrentTime < fNextUpgradeTime + 1 as float)
			akPlotRef.UpdateInformationIcons()
		EndIf
	EndIf
	If (SpecificUpgradeRequirements != None && SpecificUpgradeRequirements.length > iCurrentLevel && SpecificUpgradeRequirements[iCurrentLevel] != None)
		bSpecialChecksPassed = simsettlementsv2:utilityfunctions.CheckRequirements(Self.GetSpecificUpgradeRequirement(iCurrentLevel), akPlotRef, None, None)
		If (!bSpecialChecksPassed)
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Plot " + akPlotRef as string + " Can't Upgrade: Failed SpecificUpgradeRequirements configured for plot type (see previous debug message for specific reason).", 0, False)
		EndIf
	EndIf
	If (Self.DoesLevelRequirePower(iCurrentLevel) && !akPlotRef.IsPowered())
		bPowerCheckPassed = False
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Plot " + akPlotRef as string + " Can't Upgrade: Requires power.", 0, False)
	EndIf
	If (bTimeCheckPassed && bSpecialChecksPassed && bPowerCheckPassed)
		return True
	EndIf
	return False
EndFunction
