;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\MiscObjects\PlotConfiguration_Agricultural.psc
Modified : 2020-10-16 13:26:20
Compiled : 2021-01-07 11:39:10
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:MiscObjects:PlotConfiguration_Agricultural extends SimSettlementsV2:MiscObjects:PlotConfiguration Const

;-- Properties --------------------------------------
Group UpgradeFormulaForms
	Keyword Property WorkshopItemKeyword Auto Const mandatory
	GlobalVariable Property gSettings_CitizenNeeds Auto Const mandatory
	float[] Property HappinessUpgradeRequirements Auto Const mandatory
	{ 3 entries - level 0 to 1, level 1 to 2, level 2 to 3 }
EndGroup

Group Assets
	EffectShader Property LackingDefenseIcon Auto Const mandatory
	EffectShader Property LackingWaterIcon Auto Const mandatory
	EffectShader Property LackingHappinessIcon Auto Const mandatory
EndGroup

Group Other
	GlobalVariable Property gSettings_WaterRequirement Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

bool Function IsEligibleToProduce(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (!akPlotRef)
		return False
	EndIf
	If (Parent.IsEligibleToProduce(akPlotRef))
		workshopscript kWorkshopRef = akPlotRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
		If (kWorkshopRef)
			int iWorkshopID = kWorkshopRef.GetWorkshopID()
			bool bWaterNeedsMet = True
			bool bIgnoreCitizenNeeds = False
			simsettlementsv2:objectreferences:settlementoptions kLocalOptionsRef = akPlotRef.SettlementOptions
			If (kLocalOptionsRef.GetSettingValue(gSettings_CitizenNeeds) == 0 as float)
				bIgnoreCitizenNeeds = True
			EndIf
			If (!bIgnoreCitizenNeeds)
				bWaterNeedsMet = kLocalOptionsRef.GetSettingValue(gSettings_WaterRequirement) == 0 as float || simsettlementsv2:utilityfunctions.AreWaterNeedsMet(kWorkshopRef)
			EndIf
			If (!bWaterNeedsMet)
				akPlotRef.AddStatusIcon(LackingWaterIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingWaterIcon, False)
			EndIf
			akPlotRef.UpdateInformationIcons()
			If (bWaterNeedsMet)
				return True
			Else
				return False
			EndIf
		EndIf
	EndIf
	return False
EndFunction

bool Function IsEligibleForUpgrade(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (!akPlotRef)
		return False
	EndIf
	If (Parent.IsEligibleForUpgrade(akPlotRef))
		int iCurrentLevel = akPlotRef.iCurrentLevel
		If (iCurrentLevel == 0)
			return True
		EndIf
		workshopscript kWorkshopRef = akPlotRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
		If (kWorkshopRef)
			int iWorkshopID = kWorkshopRef.GetWorkshopID()
			bool bSafetyNeedsMet = True
			bool bWaterNeedsMet = True
			bool bHappinessNeedsMet = True
			bool bIgnoreCitizenNeeds = False
			simsettlementsv2:objectreferences:settlementoptions kLocalOptionsRef = akPlotRef.SettlementOptions
			If (kLocalOptionsRef.GetSettingValue(gSettings_CitizenNeeds) == 0 as float)
				bIgnoreCitizenNeeds = True
			EndIf
			If (!bIgnoreCitizenNeeds)
				bSafetyNeedsMet = simsettlementsv2:utilityfunctions.AreSafetyNeedsMet(kWorkshopRef)
				bWaterNeedsMet = simsettlementsv2:utilityfunctions.AreWaterNeedsMet(kWorkshopRef)
				ActorValue HappinessAV = Game.GetFormFromFile(1216855, "Fallout4.esm") as ActorValue
				bHappinessNeedsMet = kWorkshopRef.GetValue(HappinessAV) >= HappinessUpgradeRequirements[iCurrentLevel]
			EndIf
			If (!bSafetyNeedsMet)
				akPlotRef.AddStatusIcon(LackingDefenseIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingDefenseIcon, False)
			EndIf
			If (!bWaterNeedsMet)
				akPlotRef.AddStatusIcon(LackingWaterIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingWaterIcon, False)
			EndIf
			If (!bHappinessNeedsMet)
				akPlotRef.AddStatusIcon(LackingHappinessIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingHappinessIcon, False)
			EndIf
			akPlotRef.UpdateInformationIcons()
			If (bSafetyNeedsMet && bWaterNeedsMet && bHappinessNeedsMet)
				return True
			Else
				return False
			EndIf
		EndIf
	Else
		akPlotRef.RemoveStatusIcon(LackingWaterIcon, False)
		akPlotRef.RemoveStatusIcon(LackingDefenseIcon, False)
		akPlotRef.RemoveStatusIcon(LackingHappinessIcon, False)
	EndIf
	return False
EndFunction
