;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\MiscObjects\PlotConfiguration_Commercial.psc
Modified : 2020-09-12 23:59:47
Compiled : 2021-01-07 11:39:10
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:MiscObjects:PlotConfiguration_Commercial extends SimSettlementsV2:MiscObjects:PlotConfiguration Const

;-- Properties --------------------------------------
Group UpgradeFormulaForms
	int[] Property iCustomerRequirements Auto Const mandatory
	{ Number of customers living in a settlement at each level for it to be buildable. Should have 3 entries. }
	ActorValue Property PopulationAV Auto Const mandatory
	ActorValue Property RobotPopulationAV Auto Const mandatory
	Keyword Property WorkshopItemKeyword Auto Const mandatory
	Keyword Property ResidentialKeyword Auto Const mandatory
	simsettlementsv2:quests:settlementmanager Property SettlementManager Auto Const mandatory
	GlobalVariable Property gSettings_CitizenNeeds Auto Const mandatory
	GlobalVariable Property gSettings_CommercialRequirement Auto Const mandatory
	float[] Property HappinessUpgradeRequirements Auto Const mandatory
	{ 3 entries - level 0 to 1, level 1 to 2, level 2 to 3 }
EndGroup

Group Assets
	EffectShader Property LackingDefenseIcon Auto Const mandatory
	EffectShader Property LackingCustomersIcon Auto Const mandatory
	EffectShader Property LackingHappinessIcon Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

bool Function IsEligibleToProduce(simsettlementsv2:objectreferences:simplot akPlotRef)
	return Parent.IsEligibleToProduce(akPlotRef)
EndFunction

bool Function IsEligibleForConstruction(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (!akPlotRef)
		return False
	EndIf
	If (Parent.IsEligibleForConstruction(akPlotRef))
		workshopscript kWorkshopRef = akPlotRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
		If (kWorkshopRef)
			int iWorkshopID = kWorkshopRef.GetWorkshopID()
			bool bCustomerNeedsMet = False
			simsettlementsv2:objectreferences:settlementoptions kLocalOptionsRef = akPlotRef.SettlementOptions
			bool bHomeCheck = True
			bool bPopulationCheck = False
			int iCommercialReq = kLocalOptionsRef.GetSettingValue(gSettings_CommercialRequirement) as int
			If (iCommercialReq == 0)
				bHomeCheck = False
				bPopulationCheck = False
			ElseIf (iCommercialReq == 1)
				bHomeCheck = True
				bPopulationCheck = False
			ElseIf (iCommercialReq == 2)
				bHomeCheck = False
				bPopulationCheck = True
			EndIf
			int iCustomersRequired = 0
			If (iCustomerRequirements.length > 0)
				iCustomersRequired = iCustomerRequirements[0]
			EndIf
			If (bHomeCheck)
				simsettlementsv2:objectreferences:settlementdata kDataStore = SettlementManager.GetSettlementDataStore(iWorkshopID)
				If (kDataStore)
					int I = 0
					int iEligibleHomes = 0
					int iRequiredLevel = akPlotRef.iCurrentLevel
					While (I < kDataStore.PlotCounters.length)
						If (kDataStore.PlotCounters[I].PlotType == ResidentialKeyword)
							If (iRequiredLevel <= 1)
								iEligibleHomes += kDataStore.PlotCounters[I].iL1Count
							EndIf
							If (iRequiredLevel <= 2)
								iEligibleHomes += kDataStore.PlotCounters[I].iL2Count
							EndIf
							If (iRequiredLevel <= 3)
								iEligibleHomes += kDataStore.PlotCounters[I].iL3Count
							EndIf
						EndIf
						I += 1
					EndWhile
					If (iEligibleHomes >= iCustomersRequired)
						bCustomerNeedsMet = True
					Else
						workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found " + iEligibleHomes as string + " homes vs " + iCustomersRequired as string + " required, unable to start construction on " + akPlotRef as string, 0, False)
					EndIf
				EndIf
			ElseIf (bPopulationCheck)
				float fPopulation = kWorkshopRef.GetBaseValue(PopulationAV)
				float fRobotPopulation = kWorkshopRef.GetBaseValue(RobotPopulationAV)
				If (fPopulation - fRobotPopulation >= iCustomersRequired as float)
					bCustomerNeedsMet = True
				EndIf
			Else
				bCustomerNeedsMet = True
			EndIf
			If (!bCustomerNeedsMet)
				akPlotRef.AddStatusIcon(LackingCustomersIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingCustomersIcon, False)
			EndIf
			akPlotRef.UpdateInformationIcons()
			If (bCustomerNeedsMet)
				return True
			Else
				return False
			EndIf
		EndIf
	EndIf
	return False
EndFunction

bool Function IsEligibleForUpgrade(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (!akPlotRef)
		return False
	EndIf
	If (Parent.IsEligibleForUpgrade(akPlotRef))
		workshopscript kWorkshopRef = akPlotRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
		If (kWorkshopRef)
			int iWorkshopID = kWorkshopRef.GetWorkshopID()
			int iCurrentLevel = akPlotRef.iCurrentLevel
			bool bSafetyNeedsMet = True
			bool bCustomerNeedsMet = False
			bool bHappinessNeedsMet = True
			bool bIgnoreCitizenNeeds = False
			simsettlementsv2:objectreferences:settlementoptions kLocalOptionsRef = akPlotRef.SettlementOptions
			If (kLocalOptionsRef.GetSettingValue(gSettings_CitizenNeeds) == 0 as float)
				bIgnoreCitizenNeeds = True
			EndIf
			If (!bIgnoreCitizenNeeds)
				bSafetyNeedsMet = simsettlementsv2:utilityfunctions.AreSafetyNeedsMet(kWorkshopRef)
				ActorValue HappinessAV = Game.GetFormFromFile(1216855, "Fallout4.esm") as ActorValue
				bHappinessNeedsMet = kWorkshopRef.GetValue(HappinessAV) >= HappinessUpgradeRequirements[iCurrentLevel]
			EndIf
			bool bHomeCheck = True
			bool bPopulationCheck = False
			int iCommercialReq = kLocalOptionsRef.GetSettingValue(gSettings_CommercialRequirement) as int
			If (iCommercialReq == 0)
				bHomeCheck = False
				bPopulationCheck = False
			ElseIf (iCommercialReq == 1)
				bHomeCheck = True
				bPopulationCheck = False
			ElseIf (iCommercialReq == 2)
				bHomeCheck = False
				bPopulationCheck = True
			EndIf
			int iCustomersRequired = 0
			If (iCustomerRequirements.length > iCurrentLevel)
				iCustomersRequired = iCustomerRequirements[iCurrentLevel]
			EndIf
			If (bHomeCheck)
				simsettlementsv2:objectreferences:settlementdata kDataStore = SettlementManager.GetSettlementDataStore(iWorkshopID)
				If (kDataStore)
					int I = 0
					int iEligibleHomes = 0
					int iRequiredLevel = iCurrentLevel
					While (I < kDataStore.PlotCounters.length)
						If (kDataStore.PlotCounters[I].PlotType == ResidentialKeyword)
							If (iRequiredLevel <= 1)
								iEligibleHomes += kDataStore.PlotCounters[I].iL1Count
							EndIf
							If (iRequiredLevel <= 2)
								iEligibleHomes += kDataStore.PlotCounters[I].iL2Count
							EndIf
							If (iRequiredLevel <= 3)
								iEligibleHomes += kDataStore.PlotCounters[I].iL3Count
							EndIf
						EndIf
						I += 1
					EndWhile
					If (iEligibleHomes >= iCustomersRequired)
						bCustomerNeedsMet = True
					EndIf
				EndIf
			ElseIf (bPopulationCheck)
				float fPopulation = kWorkshopRef.GetBaseValue(PopulationAV)
				float fRobotPopulation = kWorkshopRef.GetBaseValue(RobotPopulationAV)
				If (fPopulation - fRobotPopulation >= iCustomersRequired as float)
					bCustomerNeedsMet = True
				EndIf
			Else
				bCustomerNeedsMet = True
			EndIf
			If (bCustomerNeedsMet && iCurrentLevel == 0)
				return True
			EndIf
			If (!bSafetyNeedsMet)
				akPlotRef.AddStatusIcon(LackingDefenseIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingDefenseIcon, False)
			EndIf
			If (!bHappinessNeedsMet)
				akPlotRef.AddStatusIcon(LackingHappinessIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingHappinessIcon, False)
			EndIf
			If (!bCustomerNeedsMet)
				akPlotRef.AddStatusIcon(LackingCustomersIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingCustomersIcon, False)
			EndIf
			akPlotRef.UpdateInformationIcons()
			If (bSafetyNeedsMet && bCustomerNeedsMet && bHappinessNeedsMet)
				return True
			Else
				return False
			EndIf
		EndIf
	Else
		akPlotRef.RemoveStatusIcon(LackingCustomersIcon, False)
		akPlotRef.RemoveStatusIcon(LackingDefenseIcon, False)
		akPlotRef.RemoveStatusIcon(LackingHappinessIcon, False)
	EndIf
	return False
EndFunction
