;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\MiscObjects\PlotConfiguration_Industrial.psc
Modified : 2020-08-16 22:25:40
Compiled : 2021-01-07 11:39:11
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:MiscObjects:PlotConfiguration_Industrial extends SimSettlementsV2:MiscObjects:PlotConfiguration Const

;-- Properties --------------------------------------
Group UpgradeFormulaForms
	Keyword Property WorkshopItemKeyword Auto Const mandatory
	bool[] Property bProductionRequiresPower Auto Const mandatory
	GlobalVariable Property gSettings_CitizenNeeds Auto Const mandatory
	float[] Property HappinessUpgradeRequirements Auto Const mandatory
	{ 3 entries - level 0 to 1, level 1 to 2, level 2 to 3 }
EndGroup

Group Assets
	EffectShader Property LackingDefenseIcon Auto Const mandatory
	EffectShader Property LackingPowerIcon Auto Const mandatory
	EffectShader Property LackingHappinessIcon Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

bool Function IsEligibleForUpgrade(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (!akPlotRef)
		return False
	EndIf
	If (Parent.IsEligibleForUpgrade(akPlotRef))
		If (akPlotRef.iCurrentLevel == 0)
			return True
		EndIf
		workshopscript kWorkshopRef = akPlotRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
		If (kWorkshopRef)
			int iWorkshopID = kWorkshopRef.GetWorkshopID()
			int iCurrentLevel = akPlotRef.iCurrentLevel
			bool bSafetyNeedsMet = True
			bool bHappinessNeedsMet = True
			bool bIgnoreCitizenNeeds = False
			simsettlementsv2:objectreferences:settlementoptions kLocalOptionsRef = akPlotRef.SettlementOptions
			If (kLocalOptionsRef.GetSettingValue(gSettings_CitizenNeeds) == 0 as float)
				bIgnoreCitizenNeeds = True
			EndIf
			If (!bIgnoreCitizenNeeds)
				bSafetyNeedsMet = simsettlementsv2:utilityfunctions.AreSafetyNeedsMet(kWorkshopRef)
				ActorValue HappinessAV = Game.GetFormFromFile(1216855, "Fallout4.esm") as ActorValue
				bHappinessNeedsMet = kWorkshopRef.GetValue(HappinessAV) >= HappinessUpgradeRequirements[iCurrentLevel]
			EndIf
			If (!bSafetyNeedsMet)
				akPlotRef.AddStatusIcon(LackingDefenseIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingDefenseIcon, False)
			EndIf
			If (!bHappinessNeedsMet)
				akPlotRef.AddStatusIcon(LackingHappinessIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingHappinessIcon, False)
			EndIf
			akPlotRef.UpdateInformationIcons()
			If (bSafetyNeedsMet && bHappinessNeedsMet)
				return True
			Else
				return False
			EndIf
		EndIf
	Else
		akPlotRef.RemoveStatusIcon(LackingDefenseIcon, False)
		akPlotRef.RemoveStatusIcon(LackingHappinessIcon, False)
	EndIf
	return False
EndFunction

bool Function IsEligibleToProduce(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (!akPlotRef)
		return False
	EndIf
	If (Parent.IsEligibleToProduce(akPlotRef))
		workshopscript kWorkshopRef = akPlotRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
		If (kWorkshopRef)
			int iWorkshopID = kWorkshopRef.GetWorkshopID()
			int iCurrentLevel = akPlotRef.iCurrentLevel
			bool bPowerCheckPassed = True
			If (bProductionRequiresPower.length > iCurrentLevel && bProductionRequiresPower[iCurrentLevel])
				If (!akPlotRef.IsPowered() && akPlotRef.PlotRequiresPower(-1))
					bPowerCheckPassed = False
				EndIf
			EndIf
			If (!bPowerCheckPassed)
				akPlotRef.AddStatusIcon(LackingPowerIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingPowerIcon, False)
			EndIf
			akPlotRef.UpdateInformationIcons()
			If (bPowerCheckPassed)
				return True
			Else
				return False
			EndIf
		EndIf
	EndIf
	return False
EndFunction
