;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Users\simse\AppData\Local\Temp\PapyrusTemp\SimSettlementsV2\MiscObjects\PlotConfiguration_Martial.psc
Modified : 2021-01-16 14:51:11
Compiled : 2021-01-16 14:51:14
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:MiscObjects:PlotConfiguration_Martial extends SimSettlementsV2:MiscObjects:PlotConfiguration Const

;-- Properties --------------------------------------
Group UpgradeFormulaForms
	int[] Property iIndustrialRequirements Auto Const mandatory
	{ Number of Industrial plots required at each level to upgrade. Should have 3 entries. }
	Keyword Property WorkshopItemKeyword Auto Const mandatory
	Keyword Property IndustrialKeyword Auto Const mandatory
	simsettlementsv2:quests:settlementmanager Property SettlementManager Auto Const mandatory
	GlobalVariable Property gSettings_MartialIndustrialRequirement Auto Const mandatory
	GlobalVariable Property gSettings_CitizenNeeds Auto Const mandatory
	float[] Property HappinessUpgradeRequirements Auto Const mandatory
	{ 3 entries - level 0 to 1, level 1 to 2, level 2 to 3 }
EndGroup

Group Assets
	EffectShader Property LackingIndustrialIcon Auto Const mandatory
	EffectShader Property LackingHappinessIcon Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

bool Function IsEligibleForUpgrade(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (!akPlotRef)
		return False
	EndIf
	If (Parent.IsEligibleForUpgrade(akPlotRef))
		If (akPlotRef.iCurrentLevel == 0)
			return True
		EndIf
		workshopscript kWorkshopRef = akPlotRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
		If (kWorkshopRef)
			int iWorkshopID = kWorkshopRef.GetWorkshopID()
			int iCurrentLevel = akPlotRef.iCurrentLevel
			bool bHappinessNeedsMet = True
			bool bIgnoreCitizenNeeds = False
			bool bIndustrialNeedsMet = False
			int iIndustrialRequired = 0
			simsettlementsv2:objectreferences:settlementoptions kLocalOptionsRef = akPlotRef.SettlementOptions
			If (kLocalOptionsRef.GetSettingValue(gSettings_MartialIndustrialRequirement) == 0 as float)
				iIndustrialRequired = 0
			EndIf
			If (kLocalOptionsRef.GetSettingValue(gSettings_CitizenNeeds) == 0 as float)
				bIgnoreCitizenNeeds = True
			EndIf
			If (!bIgnoreCitizenNeeds)
				ActorValue HappinessAV = Game.GetFormFromFile(1216855, "Fallout4.esm") as ActorValue
				bHappinessNeedsMet = kWorkshopRef.GetValue(HappinessAV) >= HappinessUpgradeRequirements[iCurrentLevel]
			EndIf
			If (iIndustrialRequired <= 0)
				bIndustrialNeedsMet = True
			Else
				simsettlementsv2:objectreferences:settlementdata kDataStore = SettlementManager.GetSettlementDataStore(iWorkshopID)
				If (kDataStore)
					int I = 0
					int iEligiblePlots = 0
					int iRequiredLevel = akPlotRef.iCurrentLevel
					While (I < kDataStore.PlotCounters.length)
						If (kDataStore.PlotCounters[I].PlotType == IndustrialKeyword)
							If (iRequiredLevel <= 1)
								iEligiblePlots += kDataStore.PlotCounters[I].iL1Count
							EndIf
							If (iRequiredLevel <= 2)
								iEligiblePlots += kDataStore.PlotCounters[I].iL2Count
							EndIf
							If (iRequiredLevel <= 3)
								iEligiblePlots += kDataStore.PlotCounters[I].iL3Count
							EndIf
						EndIf
						I += 1
					EndWhile
					If (iEligiblePlots >= iIndustrialRequired)
						bIndustrialNeedsMet = True
					EndIf
				EndIf
			EndIf
			If (!bIndustrialNeedsMet)
				akPlotRef.AddStatusIcon(LackingIndustrialIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingIndustrialIcon, False)
			EndIf
			If (!bHappinessNeedsMet)
				akPlotRef.AddStatusIcon(LackingHappinessIcon, False)
			Else
				akPlotRef.RemoveStatusIcon(LackingHappinessIcon, False)
			EndIf
			akPlotRef.UpdateInformationIcons()
			If (bIndustrialNeedsMet && bHappinessNeedsMet)
				return True
			Else
				return False
			EndIf
		EndIf
	Else
		akPlotRef.RemoveStatusIcon(LackingIndustrialIcon, False)
		akPlotRef.RemoveStatusIcon(LackingHappinessIcon, False)
	EndIf
	return False
EndFunction
