;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\MiscObjects\Unlockable.psc
Modified : 2021-01-20 16:52:43
Compiled : 2021-01-20 16:53:10
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName simsettlementsv2:miscobjects:unlockable extends Form Const
{ Unlockable feature or object }

;-- Properties --------------------------------------
Group Notifications
	bool Property bPlaySound = False Auto Const
	{ If true, an unlock sound effect will play, or if set, the SoundEffectOverride sound will play. }
	Sound Property SoundEffectOverride Auto Const
	{ To play something other than the default sound effect when an unlock occurs }
	Form Property FeaturedItem Auto Const
	{ [Optional] Display an object to the player representing the unlock. Note this item will be added to their inventory to trigger the featured item screen and then immediately removed (unless bKeepFeaturedItem is on). Note: you can use the object you have this script on as the FeaturedItem, simply save the form before filling out this property. }
	bool Property bKeepFeaturedItem = False Auto Const
	{ The featured item will be immediately removed unless this is changed to true. }
	Message Property UnlockMessage Auto Const
	{ [Optional] Display a message to the player representing the unlock. If both the FeaturedItem and UnlockMessage are set, the FeaturedItem will trigger first with the UnlockMessage displaying a second later. }
EndGroup

Group Requirements
	MiscObject Property Requirements Auto Const
	{ Must be of type SimSettlementsV2:MiscObjects:UsageRequirements }
	simsettlementsv2:datastructures#plotcount[] Property MinimumPlotsBuilt Auto Const
	{ Minimum number of a particular plot type or building class and the minimum level each must have reached. }
	simsettlementsv2:datastructures#plotcount[] Property MinimumPlotsActive Auto Const
	{ Minimum number of a particular plot type or building class and the minimum level each must have reached. These plots must be currently powered and active. }
	int[] Property MinimumCityPlansAtEachLevel Auto Const
	{ Each entry you add to this array represents the number of City Plans that should be at that level or higher. So if your first entry is 5, there needs to be at least 5 city plans at level 0 or higher (level 0 = foundation level). If your second entry is 8, at least 8 city plans must be at level 1 or higher, etc. To remember this easily, look at the index column in the property screen for this field and treat this as the level. }
	workshopframework:library:datastructures#universalform[] Property MustOwnSettlements Auto Const
	{ If set, the player must own these settlements in order to trigger the unlock. }
	workshopframework:library:datastructures#universalform[] Property ClearedLocations Auto Const
	{ If set, the corresponding locations must be cleared in order to trigger the unlock. }
	int Property iMinPlayerLevel = 0 Auto Const
	{ If set, the player must be at least this level in order to trigger the unlock. }
	int Property iMinOwnedSettlements = 0 Auto Const
	{ If set, the player must control at least this many settlements to trigger the unlock. }
EndGroup

Group Triggers
	workshopframework:library:datastructures#globalvariableset[] Property SetGlobals Auto Const
	{ Globals to set when this becomes unlocked }
	workshopframework:library:datastructures#queststageset[] Property SetQuestStages Auto Const
	{ Quest stages to set when this becomes unlocked }
	simsettlementsv2:datastructures#formlistinjection[] Property RegisterForms Auto Const
	{ Forms to inject, this can be used to register various items the same way an addon pack would at game start by setting up the form to register and the target formlist keyword that you find as the first entry in the _AddonTemplate formlists. 
	
	For example, to make a new beer recipe available, set the FormToInject field as your beer recipe's SS2_BeerRecipe_ book record, and SS2_FLID_BeerRecipes as the TargetFormlistKeyword (which you would find in the SS2_BeerRecipes_AddonTemplate formlist). }
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

Function HandleFanfare()
	Actor PlayerRef = Game.GetPlayer()
	simsettlementsv2:quests:unlockmanager UnlockManager = Self.GetUnlockManager()
	If (bPlaySound)
		If (SoundEffectOverride)
			SoundEffectOverride.Play(PlayerRef as ObjectReference)
		Else
			UnlockManager.UnlockSound.Play(PlayerRef as ObjectReference)
		EndIf
	EndIf
	If (FeaturedItem)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Adding featured item: " + FeaturedItem as string, 0, False)
		PlayerRef.AddItem(FeaturedItem, 1, True)
		If (!bKeepFeaturedItem)
			PlayerRef.RemoveItem(FeaturedItem, 1, True, None)
		EndIf
		If (UnlockMessage)
			Utility.Wait(1)
			UnlockMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		EndIf
	ElseIf (UnlockMessage)
		UnlockMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	EndIf
EndFunction

simsettlementsv2:miscobjects:usagerequirements Function GetRequirements()
	return (Requirements as Form) as simsettlementsv2:miscobjects:usagerequirements
EndFunction

bool Function ShouldUnlock()
	If (iMinPlayerLevel > 0 && Game.GetPlayer().GetLevel() < iMinPlayerLevel)
		return False
	EndIf
	workshopscript[] OwnedSettlements = new workshopscript[0]
	bool bOwnedSettlementsCheckedAlready = False
	simsettlementsv2:quests:settlementmanager SettlementManager = Self.GetSettlementManager()
	simsettlementsv2:quests:unlockmanager UnlockManager = Self.GetUnlockManager()
	If (iMinOwnedSettlements > 0)
		bOwnedSettlementsCheckedAlready = True
		OwnedSettlements = workshopframework:workshopfunctions.GetPlayerOwnedSettlements(True, True, False)
		If (OwnedSettlements.length < iMinOwnedSettlements)
			return False
		EndIf
	EndIf
	If (Self.GetRequirements() != None)
		simsettlementsv2:miscobjects:usagerequirements theseRequirements = Self.GetRequirements()
		If (theseRequirements.SettlementAVRequirements != None || theseRequirements.SettlementKeywordRequirements != None || theseRequirements.SettlementKeywordRestrictions != None || theseRequirements.SettlementWorkshopRequirements != None || theseRequirements.SettlementDataRequirements != None)
			If (!bOwnedSettlementsCheckedAlready)
				bOwnedSettlementsCheckedAlready = True
				OwnedSettlements = workshopframework:workshopfunctions.GetPlayerOwnedSettlements(True, True, False)
			EndIf
			bool bValidSettlementFound = False
			int I = 0
			While (I < OwnedSettlements.length && !bValidSettlementFound)
				If (simsettlementsv2:utilityfunctions.CheckRequirements(theseRequirements, None, None, OwnedSettlements[I]))
					bValidSettlementFound = True
				EndIf
				I += 1
			EndWhile
			If (!bValidSettlementFound)
				return False
			EndIf
		ElseIf (!simsettlementsv2:utilityfunctions.CheckRequirements(theseRequirements, None, None, None))
			return False
		EndIf
	EndIf
	If (MinimumPlotsBuilt != None)
		int i = 0
		While (i < MinimumPlotsBuilt.length)
			If (MinimumPlotsBuilt[i].iL0Count > 0)
				int iPlots = 0
				If (MinimumPlotsBuilt[i].BuildingClass != None)
					iPlots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].BuildingClass, 0, -1, False, True)
				Else
					iPlots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].PlotType, 0, -1, False, True)
				EndIf
				If (iPlots < MinimumPlotsBuilt[i].iL0Count)
					return False
				EndIf
			EndIf
			If (MinimumPlotsBuilt[i].iL1Count > 0)
				int iplots = 0
				If (MinimumPlotsBuilt[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].BuildingClass, 1, -1, False, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].PlotType, 1, -1, False, True)
				EndIf
				If (iplots < MinimumPlotsBuilt[i].iL1Count)
					return False
				EndIf
			EndIf
			If (MinimumPlotsBuilt[i].iL2Count > 0)
				int iplots = 0
				If (MinimumPlotsBuilt[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].BuildingClass, 2, -1, False, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].PlotType, 2, -1, False, True)
				EndIf
				If (iplots < MinimumPlotsBuilt[i].iL2Count)
					return False
				EndIf
			EndIf
			If (MinimumPlotsBuilt[i].iL3Count > 0)
				int iplots = 0
				If (MinimumPlotsBuilt[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].BuildingClass, 3, -1, False, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsBuilt[i].PlotType, 3, -1, False, True)
				EndIf
				If (iplots < MinimumPlotsBuilt[i].iL3Count)
					return False
				EndIf
			EndIf
			i += 1
		EndWhile
	EndIf
	If (MinimumPlotsActive != None)
		int i = 0
		While (i < MinimumPlotsActive.length)
			If (MinimumPlotsActive[i].iL0Count > 0)
				int iplots = 0
				If (MinimumPlotsActive[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].BuildingClass, 0, -1, True, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].PlotType, 0, -1, True, True)
				EndIf
				If (iplots < MinimumPlotsActive[i].iL0Count)
					return False
				EndIf
			EndIf
			If (MinimumPlotsActive[i].iL1Count > 0)
				int iplots = 0
				If (MinimumPlotsActive[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].BuildingClass, 1, -1, True, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].PlotType, 1, -1, True, True)
				EndIf
				If (iplots < MinimumPlotsActive[i].iL1Count)
					return False
				EndIf
			EndIf
			If (MinimumPlotsActive[i].iL2Count > 0)
				int iplots = 0
				If (MinimumPlotsActive[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].BuildingClass, 2, -1, True, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].PlotType, 2, -1, True, True)
				EndIf
				If (iplots < MinimumPlotsActive[i].iL2Count)
					return False
				EndIf
			EndIf
			If (MinimumPlotsActive[i].iL3Count > 0)
				int iplots = 0
				If (MinimumPlotsActive[i].BuildingClass != None)
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].BuildingClass, 3, -1, True, True)
				Else
					iplots = SettlementManager.GetPlotCount(MinimumPlotsActive[i].PlotType, 3, -1, True, True)
				EndIf
				If (iplots < MinimumPlotsActive[i].iL3Count)
					return False
				EndIf
			EndIf
			i += 1
		EndWhile
	EndIf
	If (MustOwnSettlements != None)
		int i = 0
		While (i < MustOwnSettlements.length)
			ObjectReference thisRef = workshopframework:library:utilityfunctions.GetUniversalForm(MustOwnSettlements[i]) as ObjectReference
			If (thisRef != None)
				workshopscript thisWorkshop = thisRef as workshopscript
				If (bOwnedSettlementsCheckedAlready)
					If (OwnedSettlements.find(thisWorkshop, 0) < 0)
						return False
					EndIf
				ElseIf (thisWorkshop == None || !thisWorkshop.OwnedByPlayer)
					return False
				EndIf
			Else
				return False
			EndIf
			i += 1
		EndWhile
	EndIf
	If (ClearedLocations != None)
		int i = 0
		While (i < ClearedLocations.length)
			Location thisLocation = workshopframework:library:utilityfunctions.GetUniversalForm(ClearedLocations[i]) as Location
			If (thisLocation != None)
				If (thisLocation == None || !thisLocation.HasEverBeenCleared())
					return False
				Else
					UnlockManager.RegisterForRemoteEvent(thisLocation as ScriptObject, "OnLocationCleared")
				EndIf
			Else
				return False
			EndIf
			i += 1
		EndWhile
	EndIf
	If (MinimumCityPlansAtEachLevel != None)
		simsettlementsv2:objectreferences:settlementdata[] SettlementDataStores = SettlementManager.SettlementDataStores
		int[] iLevelCounts = new int[128]
		int i = 0
		While (i < SettlementDataStores.length)
			int iCurrentLevel = SettlementDataStores[i].iCityLevel
			If (iCurrentLevel >= 0)
				iLevelCounts[iCurrentLevel] = iLevelCounts[iCurrentLevel] + 1
			EndIf
			i += 1
		EndWhile
		i = 0
		While (i < MinimumCityPlansAtEachLevel.length)
			If (iLevelCounts[i] < MinimumCityPlansAtEachLevel[i])
				return False
			EndIf
			i += 1
		EndWhile
	EndIf
	return True
EndFunction

simsettlementsv2:quests:settlementmanager Function GetSettlementManager()
	return Game.GetFormFromFile(60192, "SS2.esm") as simsettlementsv2:quests:settlementmanager
EndFunction

Function HandleUnlock(bool abSuppressFanfare)
	If (!abSuppressFanfare)
		Self.HandleFanfare()
	EndIf
	If (SetGlobals as bool && SetGlobals.length > 0)
		int I = 0
		While (I < SetGlobals.length)
			GlobalVariable thisGlobal = workshopframework:library:utilityfunctions.GetGlobalVariableSetForm(SetGlobals[I])
			If (thisGlobal)
				thisGlobal.SetValue(SetGlobals[I].fValue)
			EndIf
			I += 1
		EndWhile
	EndIf
	If (SetQuestStages as bool && SetQuestStages.length > 0)
		int i = 0
		While (i < SetQuestStages.length)
			Quest thisQuest = workshopframework:library:utilityfunctions.GetQuestStageSetForm(SetQuestStages[i])
			If (thisQuest)
				thisQuest.SetStage(SetQuestStages[i].iStage)
			EndIf
			i += 1
		EndWhile
	EndIf
	If (RegisterForms as bool && RegisterForms.length > 0)
		simsettlementsv2:quests:ss2main SS2Main = Self.GetSS2Main()
		int i = 0
		While (i < RegisterForms.length)
			Form TargetListOrKeyword = RegisterForms[i].TargetFormlistKeyword as Form
			If (TargetListOrKeyword == None)
				TargetListOrKeyword = RegisterForms[i].TargetFormlist as Form
			EndIf
			If (TargetListOrKeyword != None)
				SS2Main.RegisterIndividualAddonItem(RegisterForms[i].FormToInject, TargetListOrKeyword, True)
			EndIf
			i += 1
		EndWhile
	EndIf
EndFunction

simsettlementsv2:quests:ss2main Function GetSS2Main()
	return Game.GetFormFromFile(60233, "SS2.esm") as simsettlementsv2:quests:ss2main
EndFunction

simsettlementsv2:quests:unlockmanager Function GetUnlockManager()
	return Game.GetFormFromFile(60154, "SS2.esm") as simsettlementsv2:quests:unlockmanager
EndFunction
