;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\MiscObjects\UnlockableCharacter.psc
Modified : 2020-09-15 02:05:09
Compiled : 2021-01-20 16:53:10
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:MiscObjects:UnlockableCharacter extends SimSettlementsV2:MiscObjects:Unlockable Const
{ Unlockable NPC. This system processes two stages, an eligibility point where a character is eligible to appear in the player's game. At this stage, the character is considered "Unlocked and Eligible", but not "Released". SS2 will periodically choose "Unlocked and Eligible" characters to trigger }

;-- Properties --------------------------------------
Group Character_SettlementRequirements
	float Property fMinHappiness = 0 Auto Const
	{ Settlement must be at this happiness or higher for it to be the starting settlement of this character }
	bool Property bPlayerOwnedOnly = True Auto Const
	{ If false, any settlement installed could be chosen as the starting location }
	bool Property bBeaconRequired = True Auto Const
	{ Settlements must have a radio beacon for this character to travel to them. }
	bool Property bConsiderAllRequirements = True Auto Const
	{ If true, all other requirements that would make sense to apply to a specific settlement will be checked. For example, if a requirement is set for MinimumPlotsActive, the potential starting settlement will be tested for these, rather than just the player's controlled terrories in general. The MustOwnSettlements field is treated as a limit to which settlements this character can start at (ie. if you want them to always go to a specific settlement, just enter that settlement as the MustOwnSettlements record ). }
	workshopframework:library:datastructures#universalform[] Property EligibleFactions Auto Const
	{ Settlement must be controlled by one of these factions. If you're only concerned about the player owning the settlement, you can skip this field. If you want the player created faction to count as a valid option, add PlayerFaction to this list. }
	workshopframework:library:datastructures#universalform[] Property IneligibleFactions Auto Const
	{ Settlement must NOT be controlled by any of these factions. }
	bool Property OutpostsAllowed = True Auto Const
	{ If true, this NPC will go to Outpost settlements. }
	bool Property VassalsAllowed = True Auto Const
	{ If true, this NPC will go to Vassal settlements. }
	bool Property NormalSettlementsAllowed = True Auto Const
	{ If true, this NPC will go to normal settlements. Note that if OutpostsAllowed and VassalsAllowed are set to false as well, this setting will be ignored as there would be no valid settlements. }
	workshopframework:library:datastructures#universalform[] Property LimitToSettlementsInWorldspaces Auto Const
	{ Add specific worldspaces to ensure only settlements in these are used }
EndGroup

Group Character_Triggers
	workshopframework:library:datastructures#universalform Property CharacterForm Auto Const mandatory
	{ This should point at the ActorBase form for the NPC with the Unique flag checked. (Advanced Users: If you pre-placed them in the world, SS2 can correctly grab their reference from this information alone - no need for an alias or anything) }
	int Property iPrimaryStatIndex = 0 Auto Const mandatory
	{ This allows one of our mechanics to quickly find your character for tracking when the player is seeking certain qualifications. If more than one stat are tied for highest, pick the one you'd like them to be associated with. 1 = Strength, 2 = Perception, 3 = Endurance, 4 = Charisma, 5 = Intelligence, 6 = Agility, 7 = Luck. }
	bool Property bDelayNormalUnlockTriggersUntilReleased = True Auto Const
	{ By default, all extended triggers will be delayed until the character is chosen for releasing by SS2. If you want the other triggers for the unlock configuration (those outside of the Character_Triggers heading) to trigger immediately when the character is eligible, uncheck this option. }
	bool Property bHandleSpawning = False Auto Const
	{ If you did not pre-place them in the world (if you do, be sure you persist them in some way, such as putting them in a quest alias on a quest that has Starts Game Enabled checked) , SS2 will spawn one CharacterForm into the world for you. }
	bool Property bEnableCharacter = False Auto Const
	{ If you preplaced the character in the world and started them disabled, set this to true to have the NPC enabled once this is triggered. }
	bool Property bSendCharacterToSettlement = True Auto Const
	{ If set, SS2 will handle the character and ensure they show up at an appropriate settlement. }
	bool Property bMakeASettler = False Auto Const
	{ If set, and bSendCharacterToSettlement is checked, SS2 will send them to the settlement as a settler. Otherwise, they will flagged a Visitor. }
	bool Property bMustHandleImmediately = False Auto Const
	{ By default, SS2 will stagger out NPCs registered with this system for release into the world. If it's important this character be handled immediately, checking this will make sure they are processed immediately after being unlocked, rather than waiting their turn for release. Ex. if you have a character that needs to come running in after a player completes a particular quest, or something in their dialogue acknowledges something happening very recently - you'd likely want this set to true. }
	bool Property bCanBeRecruited = True Auto Const
	{ If this character is not meant to become a settler eventually, set this to false. This will prevent the character from being tracked by other systems that help the player find potential new NPCs they can recruit. }
	ObjectReference Property TrackRefInsteadOfCharacter Auto Const
	{ If set, when the player tracks this record, this reference will be tracked instead of the NPC }
	ReferenceAlias Property TrackAliasInsteadOfCharacter Auto Const
	{ If set, when the player tracks this record, this reference will be tracked instead of the NPC }
EndGroup


;-- Variables ---------------------------------------
int iFormID_RecruitmentManagerQuest = 60232 Const

;-- Functions ---------------------------------------

Function HandleUnlock(bool abSuppressFanfare)
	If (!bDelayNormalUnlockTriggersUntilReleased)
		Self.RunParentUnlockCode(abSuppressFanfare)
	EndIf
	simsettlementsv2:quests:npc_recruitmentmanager RecruitmentManager = Game.GetFormFromFile(iFormID_RecruitmentManagerQuest, simsettlementsv2:utilityfunctions.GetPluginName()) as simsettlementsv2:quests:npc_recruitmentmanager
	If (RecruitmentManager)
		RecruitmentManager.RegisterUnlockedCharacter(Self)
	EndIf
EndFunction

Actor Function GetActorRef()
	Form thisForm = workshopframework:library:utilityfunctions.GetUniversalForm(CharacterForm)
	ActorBase thisActorForm = thisForm as ActorBase
	If (thisActorForm == None)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[UnlockableCharacter] Could not find ActorBase record for UnlockableCharacter " + Self as string + ".", 0, False)
		return None
	EndIf
	return thisActorForm.GetUniqueActor()
EndFunction

Function RunParentUnlockCode(bool abSuppressFanfare)
	Parent.HandleUnlock(abSuppressFanfare)
EndFunction
