;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\MiscObjects\UsageRequirements.psc
Modified : 2020-08-02 23:12:07
Compiled : 2021-01-07 11:39:44
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:MiscObjects:UsageRequirements extends Form Const
{ Holds Requirements for an item to be useable }

;-- Properties --------------------------------------
Group PlotRequirements
	workshopframework:library:datastructures#actorvalueset[] Property PlotAVRequirements Auto Const
	{ If the plot needs to have certain Actor Values }
	workshopframework:library:datastructures#universalform[] Property PlotKeywordRequirements Auto Const
	{ If the plot needs to have certain Keywords }
	workshopframework:library:datastructures#universalform[] Property PlotKeywordRestrictions Auto Const
	{ If the plot should NOT have certain keywords }
EndGroup

Group OwnerRequirements
	workshopframework:library:datastructures#actorvalueset[] Property OwnerAVRequirements Auto Const
	{ If the owner of this needs to have certain Actor Values }
	workshopframework:library:datastructures#universalform[] Property OwnerKeywordRequirements Auto Const
	{ If the owner of this needs to have certain Keywords }
	workshopframework:library:datastructures#universalform[] Property OwnerKeywordRestrictions Auto Const
	{ If the owner should NOT have certain keywords }
	bool Property bIgnoreOwnerRequirementsIfNoOwner = False Auto Const
	{ If set to true and plot has no owner, these checks will be skipped. Otherwise, it is implied that having an owner is part of the requirement when OwnerAVRequirements or OwnerKeywordRequirements are set. }
EndGroup

Group SettlementRequirements
	workshopframework:library:datastructures#actorvalueset[] Property SettlementAVRequirements Auto Const
	{ If the settlement this is in needs to have certain Actor Values }
	workshopframework:library:datastructures#universalform[] Property SettlementKeywordRequirements Auto Const
	{ If the settlement this is in needs to have certain Keywords }
	workshopframework:library:datastructures#universalform[] Property SettlementKeywordRestrictions Auto Const
	{ If the settlement should NOT have certain keywords }
	workshopframework:library:datastructures#scriptpropertyset[] Property SettlementWorkshopRequirements Auto Const
	{ Will be used to check specific script properties on the workshop ref. You may skip setting up the CheckForm section, in which case the workshop being tested will be used. }
	workshopframework:library:datastructures#scriptpropertyset[] Property SettlementDataRequirements Auto Const
	{ Will be used to check specific script properties on the settlement's corresponding SettlementData record }
EndGroup

Message Property FailureMessage Auto Const
{ [Optional] In certain circumstances, this message will be displayed to the player to explain that these requirements aren't met. The message should clearly explain to the player why something failed so they can resolve it. }
workshopframework:library:datastructures#plugincheck[] Property RequiredPlugins Auto Const
{ If specific content is required }
workshopframework:library:datastructures#globalvariableset[] Property GlobalRequirements Auto Const
{ If specific globals must be set }
workshopframework:library:datastructures#queststageset[] Property QuestRequirements Auto Const
{ If specific quest stages must be set }

;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

bool Function HasOwnerRequirements()
	If (OwnerAVRequirements != None && OwnerAVRequirements.length > 0)
		return True
	EndIf
	If (OwnerKeywordRequirements != None && OwnerKeywordRequirements.length > 0)
		return True
	EndIf
	return False
EndFunction

bool Function HasPlotRequirements()
	If (PlotAVRequirements != None && PlotAVRequirements.length > 0)
		return True
	EndIf
	If (PlotKeywordRequirements != None && PlotKeywordRequirements.length > 0)
		return True
	EndIf
	return False
EndFunction

bool Function HasSettlementRequirements()
	If (SettlementAVRequirements != None && SettlementAVRequirements.length > 0)
		return True
	EndIf
	If (SettlementKeywordRequirements != None && SettlementKeywordRequirements.length > 0)
		return True
	EndIf
	If (SettlementWorkshopRequirements != None && SettlementWorkshopRequirements.length > 0)
		return True
	EndIf
	If (SettlementDataRequirements != None && SettlementDataRequirements.length > 0)
		return True
	EndIf
	return False
EndFunction
