;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Nika_AltStartQuest.psc
Modified : 2020-02-11 00:31:10
Compiled : 2021-01-07 11:39:35
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:Nika_AltStartQuest extends Quest conditional

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Quests
	workshopparentscript Property WorkshopParent Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property JakeAlias Auto Const mandatory
	ReferenceAlias Property JakeWorkshopAlias Auto Const mandatory
	LocationAlias Property JakeWorkshopLocationAlias Auto Const mandatory
EndGroup

Group Assets
	ActorValue Property WorkshopRatingRadio Auto Const mandatory
	Keyword Property WorkshopLinkSpawn Auto Const mandatory
	Keyword Property WorkshopLinkCenter Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iTimerID_QuestStartupComplete = 100 Const
int iLastInstalledVersion = 0
int iStage_Started = 1 Const
int iStage_StartupComplete = 2 Const
int iStage_RadioBeaconFound = 20 Const

;-- Functions ---------------------------------------

Event WorkshopParentScript.WorkshopObjectBuilt(workshopparentscript akSenderRef, var[] akArgs)
	Self.CheckForActiveRadioBeacon()
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	Self.HandleStageChanges(auiStageID, auiItemID)
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopObjectBuilt")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopObjectDestroyed")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopObjectPowerStageChanged")
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		Self.CheckForActiveRadioBeacon()
	ElseIf (auiStageID == iStage_RadioBeaconFound)
		workshopscript kWorkshopRef = JakeWorkshopAlias.GetRef() as workshopscript
		ObjectReference kMoveTo = kWorkshopRef.GetLinkedRef(WorkshopLinkSpawn)
		If (!kMoveTo)
			kMoveTo = kWorkshopRef.GetLinkedRef(WorkshopLinkCenter)
			If (!kMoveTo)
				kMoveTo = kWorkshopRef as ObjectReference
			EndIf
		EndIf
		JakeAlias.GetActorRef().MoveTo(kMoveTo, 0, 0, 0, True)
		JakeAlias.TryToEnable()
	EndIf
EndFunction

Event WorkshopParentScript.WorkshopObjectPowerStageChanged(workshopparentscript akSenderRef, var[] akArgs)
	Self.CheckForActiveRadioBeacon()
EndEvent

Function CheckForActiveRadioBeacon()
	workshopscript kWorkshopRef = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
	bool bHasBeacon = kWorkshopRef.GetValue(WorkshopRatingRadio) > 0 as float
	If (bHasBeacon)
		Self.SetStage(iStage_RadioBeaconFound)
		WorkshopParent.AddPermanentActorToWorkshopPUBLIC((JakeAlias.GetActorRef() as workshopnpcscript) as Actor, kWorkshopRef.GetWorkshopID(), False)
		JakeWorkshopAlias.ForceRefTo(kWorkshopRef as ObjectReference)
		JakeWorkshopLocationAlias.ForceLocationTo(kWorkshopRef.myLocation)
	EndIf
EndFunction
