;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Nika_SSMainQuest2_5Script.psc
Modified : 2020-05-18 21:49:20
Compiled : 2021-01-07 11:40:00
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:Nika_SSMainQuest2_5Script extends Quest conditional

;-- Properties --------------------------------------
Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
	GlobalVariable Property gResidences Auto Const mandatory
	GlobalVariable Property gResidencesRequired Auto Const mandatory
	GlobalVariable Property gJobs Auto Const mandatory
	GlobalVariable Property gJobsRequired Auto Const mandatory
	GlobalVariable Property gSettlers Auto Const mandatory
	GlobalVariable Property gSettlersRequired Auto Const mandatory
EndGroup

Group Settings
	int Property iTotalSettlerCountNeeded = 10 Auto Const
EndGroup

Group Aliases
	ReferenceAlias Property JakeAlias Auto Const mandatory
	ReferenceAlias Property OldPaulAlias Auto Const mandatory
	ReferenceAlias Property LilyAlias Auto Const mandatory
	ReferenceAlias Property JakeWorkshopAlias Auto Const mandatory
	LocationAlias Property JakeWorkshopLocationAlias Auto Const mandatory
	RefCollectionAlias Property RaidersAlias Auto Const mandatory
	RefCollectionAlias Property LilyFollowersAlias Auto Const mandatory
EndGroup

Group Assets
	workshopparentscript Property WorkshopParent Auto Const mandatory
	workshopframework:npcmanager Property NPCManager Auto Const mandatory
	ActorValue Property WorkshopRatingRadio Auto Const mandatory
	ActorValue Property WorkshopRatingPopulation Auto Const mandatory
	simsettlementsv2:quests:npc_assignmentmanager Property AssignmentManager Auto Const mandatory
	simsettlementsv2:quests:plotmanager Property PlotManager Auto Const mandatory
	simsettlementsv2:quests:settlementmanager Property SettlementManager Auto Const mandatory
	ActorBase Property LvLRaider Auto Const mandatory
	Furniture Property NPCCaptiveMarker Auto Const mandatory
	Scene Property LilyAppproachScene Auto Const mandatory
	Scene Property RaiderAttackAnnouncementScene_Paul Auto Const mandatory
	Scene Property RaiderAttackAnnouncementScene_Radio Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property AssignmentType_Home Auto Const mandatory
	Keyword Property AssignmentType_Job Auto Const mandatory
	Keyword Property WorkshopItemKeyword Auto Const mandatory
	Keyword Property ResidentialPlotKeyword Auto Const mandatory
	Keyword Property LinkSpawn Auto Const mandatory
	Keyword Property LinkCenter Auto Const mandatory
EndGroup

bool Property bPlayerPresentAtRaiderAttackStart = False Auto conditional hidden

;-- Variables ---------------------------------------
int iStage_RadioBeaconFound = 75 Const
int iStage_LilyAndExtraSettlersArrive = 130 Const
int iObjective_BuildRecruitmentBeacon = 50 Const
int iObjective_AttractSettlers = 100 Const
int iInitialSettlerCount = 0
int iTimerID_QuestStartupComplete = 100 Const
int iStage_PlayerLacksRadioBeacon = 50 Const
int iStage_InitialSettlersSatisfied = 120 Const
int iObjective_BuildJobPlots = 120 Const
int iTimerID_RecheckBuildObjectives = 101 Const
int iStage_LilyMet = 140 Const
int iObjective_AwaitConstruction = 150 Const
int iStage_RaidersKilled = 450 Const
float fTimerLength_RaidStart = 120 Const
int iStage_NotifyPlayerOfAttack = 200 Const
int iStage_Started = 1 Const
int iStage_PlayerBuiltPlots = 150 Const
int iStage_Shutdown = 500 Const
int iLastInstalledVersion = 0
int iTimerID_RaidStart = 102 Const
int iStage_TriggerRaiderAttack = 400 Const
int iStage_BuildObjectiveGiven = 100 Const
int iObjective_BuildResidentialPlots = 110 Const
int iObjective_DefendSettlement = 200 Const
int iStage_StartupComplete = 2 Const

;-- Functions ---------------------------------------

Event WorkshopParentScript.WorkshopObjectPowerStageChanged(workshopparentscript akSenderRef, var[] akArgs)
	ObjectReference kJakeWorkshopRef = JakeWorkshopAlias.GetRef()
	If (akArgs[1] as ObjectReference == kJakeWorkshopRef)
		If (Self.GetStageDone(iStage_RadioBeaconFound))
			Self.UnregisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopObjectPowerStageChanged")
		ElseIf ((akArgs[1] as ObjectReference).GetValue(WorkshopRatingRadio) > 0 as float)
			Self.UpdateBuildObjectives()
		EndIf
	EndIf
EndEvent

Function UpdatePopulationObjective()
	workshopscript kWorkshopRef = JakeWorkshopAlias.GetRef() as workshopscript
	int iCurrentPopulation = kWorkshopRef.GetValue(WorkshopRatingPopulation) as int
	int iPreviousPopulation = gSettlers.GetValueInt()
	gSettlers.SetValueInt(iCurrentPopulation)
	Self.UpdateCurrentInstanceGlobal(gSettlers)
	If (iCurrentPopulation >= iTotalSettlerCountNeeded)
		Self.SetObjectiveCompleted(iObjective_AttractSettlers, True)
	Else
		If (Self.IsObjectiveCompleted(iObjective_AttractSettlers))
			Self.SetObjectiveCompleted(iObjective_AttractSettlers, False)
		EndIf
		Self.SetObjectiveDisplayed(iObjective_AttractSettlers, True, iPreviousPopulation != iCurrentPopulation)
	EndIf
EndFunction

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
	If (asMenuName == "WorkshopMenu")
		If (!abOpening)
			Self.StartTimer(10, iTimerID_RecheckBuildObjectives)
		EndIf
	EndIf
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (aiTimerID == iTimerID_RecheckBuildObjectives)
		Self.UpdateBuildObjectives()
	ElseIf (aiTimerID == iTimerID_RaidStart)
		Self.SetStage(iStage_NotifyPlayerOfAttack)
	EndIf
EndEvent

Function UpdateBuildObjectives()
	workshopscript kWorkshopRef = JakeWorkshopAlias.GetRef() as workshopscript
	If (!Self.GetStageDone(iStage_RadioBeaconFound))
		bool bHasBeacon = kWorkshopRef.GetValue(WorkshopRatingRadio) > 0 as float
		If (bHasBeacon)
			Self.SetStage(iStage_RadioBeaconFound)
		EndIf
	Else
		Actor[] kSettlerRefs = AssignmentManager.GetSettlers(kWorkshopRef, True)
		int iResidentialAssigned = 0
		int iResidentialAssignedAndConstructed = 0
		int iJobsAssigned = 0
		int iJobsAssignedAndConstructed = 0
		bool bAllAssignmentsFound = False
		bool bAllAssignedPlotsConstructionCompleted = False
		int I = 0
		While (I < kSettlerRefs.length)
			bool bHasHome = kSettlerRefs[I].HasKeyword(AssignmentType_Home)
			bool bHasJob = kSettlerRefs[I].HasKeyword(AssignmentType_Job)
			If (bHasHome || bHasJob)
				ObjectReference[] ResourceObjects = kWorkshopRef.GetWorkshopOwnedObjects(kSettlerRefs[I])
				int iResourceIndex = 0
				While (iResourceIndex < ResourceObjects.length)
					simsettlementsv2:objectreferences:simplot asPlot = ResourceObjects[iResourceIndex] as simsettlementsv2:objectreferences:simplot
					simsettlementsv2:objectreferences:multiassignmenthelper asHelper = ResourceObjects[iResourceIndex] as simsettlementsv2:objectreferences:multiassignmenthelper
					If (asHelper)
						asPlot = asHelper.GetOwningPlot()
					EndIf
					If (asPlot)
						simsettlementsv2:miscobjects:plotconfiguration thisPlotConfig = asPlot.GetPlotConfig()
						bool bIsBuilt = asPlot.iCurrentLevel > 0
						If (thisPlotConfig.AssignmentTypeKeywords)
							int j = 0
							While (j < thisPlotConfig.AssignmentTypeKeywords.length)
								If (thisPlotConfig.AssignmentTypeKeywords[j] == AssignmentType_Home)
									iResidentialAssigned += 1
									If (bIsBuilt)
										iResidentialAssignedAndConstructed += 1
									EndIf
								ElseIf (thisPlotConfig.AssignmentTypeKeywords[j] == AssignmentType_Job)
									iJobsAssigned += 1
									If (bIsBuilt)
										iJobsAssignedAndConstructed += 1
									EndIf
								EndIf
								j += 1
							EndWhile
						EndIf
					EndIf
					iResourceIndex += 1
				EndWhile
			EndIf
			I += 1
		EndWhile
		If (!Self.GetStageDone(iStage_InitialSettlersSatisfied) && iJobsAssigned >= iInitialSettlerCount && iResidentialAssigned >= iInitialSettlerCount)
			Self.SetStage(iStage_InitialSettlersSatisfied)
		EndIf
		If (iJobsAssigned >= iTotalSettlerCountNeeded && iResidentialAssigned >= iTotalSettlerCountNeeded)
			bAllAssignmentsFound = True
		EndIf
		If (iJobsAssignedAndConstructed >= iTotalSettlerCountNeeded && iResidentialAssignedAndConstructed >= iTotalSettlerCountNeeded)
			bAllAssignedPlotsConstructionCompleted = True
		EndIf
		If (!bAllAssignmentsFound)
			int iResidentialPlots = SettlementManager.GetLocalPlotCount(kWorkshopRef.GetWorkshopID(), ResidentialPlotKeyword, 0, -1, False, True)
			int iJobPlots = SettlementManager.GetLocalPlotCount(kWorkshopRef.GetWorkshopID(), None, 0, -1, False, True) - iResidentialPlots
			If (iResidentialPlots >= iTotalSettlerCountNeeded && iJobPlots >= iTotalSettlerCountNeeded)
				bAllAssignmentsFound = True
			EndIf
		EndIf
		If (bAllAssignmentsFound)
			If (bAllAssignedPlotsConstructionCompleted)
				Self.SetStage(iStage_PlayerBuiltPlots)
			Else
				Self.SetObjectiveCompleted(iObjective_BuildJobPlots, True)
				Self.SetObjectiveCompleted(iObjective_BuildResidentialPlots, True)
				Self.SetObjectiveDisplayed(iObjective_AwaitConstruction, True, False)
			EndIf
		Else
			int iPreviousResidential = gResidences.GetValueInt()
			int iPreviousJobs = gJobs.GetValueInt()
			gResidences.SetValueInt(iResidentialAssigned)
			Self.UpdateCurrentInstanceGlobal(gResidences)
			gJobs.SetValueInt(iJobsAssigned)
			Self.UpdateCurrentInstanceGlobal(gJobs)
			If (iResidentialAssigned >= iTotalSettlerCountNeeded)
				Self.SetObjectiveCompleted(iObjective_BuildResidentialPlots, True)
			Else
				If (Self.IsObjectiveCompleted(iObjective_BuildResidentialPlots))
					Self.SetObjectiveCompleted(iObjective_BuildResidentialPlots, False)
				EndIf
				Self.SetObjectiveDisplayed(iObjective_BuildResidentialPlots, True, iPreviousResidential != iResidentialAssigned)
			EndIf
			If (iJobsAssigned >= iTotalSettlerCountNeeded)
				Self.SetObjectiveCompleted(iObjective_BuildJobPlots, True)
			Else
				If (Self.IsObjectiveCompleted(iObjective_BuildJobPlots))
					Self.SetObjectiveCompleted(iObjective_BuildJobPlots, False)
				EndIf
				Self.SetObjectiveDisplayed(iObjective_BuildJobPlots, True, iPreviousJobs != iJobsAssigned)
			EndIf
		EndIf
	EndIf
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		workshopscript kWorkshopRef = JakeWorkshopAlias.GetRef() as workshopscript
		bool bHasBeacon = kWorkshopRef.GetValue(WorkshopRatingRadio) > 0 as float
		If (bHasBeacon)
			Self.SetStage(iStage_RadioBeaconFound)
		Else
			Self.SetStage(iStage_PlayerLacksRadioBeacon)
		EndIf
	ElseIf (auiStageID == iStage_PlayerLacksRadioBeacon)
		Self.SetObjectiveDisplayed(iObjective_BuildRecruitmentBeacon, True, False)
	ElseIf (auiStageID == iStage_RadioBeaconFound)
		workshopscript kworkshopref = JakeWorkshopAlias.GetRef() as workshopscript
		int iCurrentPopulation = kworkshopref.GetValue(WorkshopRatingPopulation) as int
		If (Self.IsObjectiveDisplayed(iObjective_BuildRecruitmentBeacon))
			Self.SetObjectiveCompleted(iObjective_BuildRecruitmentBeacon, True)
		ElseIf (iCurrentPopulation == 2)
			int I = 0
			int iAddPopulation = Utility.RandomInt(1, 3)
			While (I < iAddPopulation)
				NPCManager.CreateSettler(kworkshopref, None)
				I += 1
			EndWhile
			iCurrentPopulation += iAddPopulation
		EndIf
		iInitialSettlerCount = iCurrentPopulation
		gSettlersRequired.SetValueInt(iTotalSettlerCountNeeded)
		gJobsRequired.SetValueInt(iTotalSettlerCountNeeded)
		gResidencesRequired.SetValueInt(iTotalSettlerCountNeeded)
		Self.UpdateCurrentInstanceGlobal(gSettlersRequired)
		Self.UpdateCurrentInstanceGlobal(gJobsRequired)
		Self.UpdateCurrentInstanceGlobal(gResidencesRequired)
		Self.UpdateBuildObjectives()
	ElseIf (auiStageID == iStage_InitialSettlersSatisfied)
		Actor kLilyRef = LilyAlias.GetActorRef()
		workshopscript kworkshopref = JakeWorkshopAlias.GetRef() as workshopscript
		ObjectReference kMoveTo = kworkshopref.GetLinkedRef(LinkSpawn)
		If (kMoveTo == None)
			kMoveTo = kworkshopref.GetLinkedRef(LinkCenter)
			If (kMoveTo == None)
				kMoveTo = kworkshopref as ObjectReference
			EndIf
		EndIf
		kLilyRef.MoveTo(kMoveTo, 0, 0, 0, True)
		int iSettlersToSpawn = 1
		int icurrentpopulation = kworkshopref.GetValue(WorkshopRatingPopulation) as int + 2
		If (icurrentpopulation < iTotalSettlerCountNeeded)
			iSettlersToSpawn += iTotalSettlerCountNeeded - icurrentpopulation
		EndIf
		ActorBase SettlerForm = NPCManager.GetSettlerForm(kworkshopref)
		int i = 0
		While (i < iSettlersToSpawn)
			ObjectReference kSettlerRef = kLilyRef.PlaceAtMe(SettlerForm as Form, 1, False, True, True)
			If (kSettlerRef)
				LilyFollowersAlias.AddRef(kSettlerRef)
			EndIf
			i += 1
		EndWhile
		LilyFollowersAlias.EnableAll(False)
		kLilyRef.Enable(False)
		Self.SetStage(iStage_LilyAndExtraSettlersArrive)
	ElseIf (auiStageID == iStage_LilyAndExtraSettlersArrive)
		LilyAppproachScene.Start()
	ElseIf (auiStageID == iStage_LilyMet)
		workshopscript kworkshopref = JakeWorkshopAlias.GetRef() as workshopscript
		WorkshopParent.AddPermanentActorToWorkshopPUBLIC((LilyAlias.GetActorRef() as workshopnpcscript) as Actor, kworkshopref.GetWorkshopID(), False)
		int i = 0
		While (i < LilyFollowersAlias.GetCount())
			WorkshopParent.AddActorToWorkshopPublic(LilyFollowersAlias.GetAt(i) as workshopnpcscript, kworkshopref, False)
			i += 1
		EndWhile
		Self.UpdatePopulationObjective()
		If (Self.GetStageDone(iStage_PlayerBuiltPlots))
			Self.StartTimer(fTimerLength_RaidStart, iTimerID_RaidStart)
		EndIf
	ElseIf (auiStageID == iStage_PlayerBuiltPlots)
		If (Self.GetStageDone(iStage_LilyMet))
			Self.StartTimer(fTimerLength_RaidStart, iTimerID_RaidStart)
		EndIf
	ElseIf (auiStageID == iStage_NotifyPlayerOfAttack)
		If (JakeWorkshopAlias.GetRef().Is3dLoaded() || PlayerRef.GetCurrentLocation() == JakeWorkshopLocationAlias.GetLocation())
			bPlayerPresentAtRaiderAttackStart = True
			RaiderAttackAnnouncementScene_Paul.Start()
		Else
			bPlayerPresentAtRaiderAttackStart = False
			RaiderAttackAnnouncementScene_Radio.Start()
		EndIf
	ElseIf (auiStageID == iStage_TriggerRaiderAttack)
		
	ElseIf (auiStageID == iStage_RaidersKilled)
		
	ElseIf (auiStageID == iStage_Shutdown)
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.Stop()
	EndIf
EndFunction

Event WorkshopParentScript.WorkshopObjectBuilt(workshopparentscript akSenderRef, var[] akArgs)
	ObjectReference kJakeWorkshopRef = JakeWorkshopAlias.GetRef()
	If (akArgs[1] as ObjectReference == kJakeWorkshopRef)
		simsettlementsv2:objectreferences:simplot kAsPlot = akArgs[0] as simsettlementsv2:objectreferences:simplot
		If (kAsPlot != None || (akArgs[1] as ObjectReference).GetValue(WorkshopRatingRadio) > 0 as float)
			Self.UpdateBuildObjectives()
		EndIf
	EndIf
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event WorkshopParentScript.WorkshopObjectDestroyed(workshopparentscript akSenderRef, var[] akArgs)
	ObjectReference kJakeWorkshopRef = JakeWorkshopAlias.GetRef()
	If (akArgs[1] as ObjectReference == kJakeWorkshopRef)
		Self.UpdateBuildObjectives()
	EndIf
EndEvent

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event WorkshopFramework:NPCManager.WorkshopNPCSpawned(workshopframework:npcmanager akSender, var[] akArgs)
	ObjectReference kJakeWorkshopRef = JakeWorkshopAlias.GetRef()
	If (akArgs[1] as ObjectReference == kJakeWorkshopRef)
		Self.UpdatePopulationObjective()
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	Self.HandleStageChanges(auiStageID, auiItemID)
EndEvent

Event SimSettlementsV2:Quests:PlotManager.PlotLevelChanged(simsettlementsv2:quests:plotmanager akSender, var[] akArgs)
	If ((akArgs[0] as ObjectReference).GetLinkedRef(WorkshopItemKeyword) == JakeWorkshopAlias.GetRef())
		Self.UpdateBuildObjectives()
	EndIf
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopObjectBuilt")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopObjectDestroyed")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopObjectPowerStageChanged")
	Self.RegisterForCustomEvent(PlotManager as ScriptObject, "simsettlementsv2:quests:plotmanager_PlotLevelChanged")
	Self.RegisterForCustomEvent(NPCManager as ScriptObject, "workshopframework:npcmanager_WorkshopNPCSpawned")
	Self.RegisterForMenuOpenCloseEvent("WorkshopMenu")
EndEvent
