;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\ASAMSensorSpawner.psc
Modified : 2020-08-09 21:26:16
Compiled : 2021-01-07 11:40:25
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:ASAMSensorSpawner extends ObjectReference
{ Spawns the correct ASAM Sensor and moves it to the correct position based on the building plan }

;-- Properties --------------------------------------
Group Assets
	Form Property FreeStandingASAMSensorForm Auto Const mandatory
	Form Property WallMountedASAMSensorForm Auto Const mandatory
	Form Property FreeStandingASAMSensorMarkerForm Auto Const mandatory
	Form Property WallMountedASAMSensorMarkerForm Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property AccessoryLinkKeyword Auto Const mandatory
	Keyword Property ASAMSensorLinkKeyword Auto Const mandatory
	Keyword Property StageItemLinkKeyword Auto Const mandatory
	Keyword Property ASAMSensorMarkerKeyword Auto Const mandatory
	Keyword Property WorkshopStackedItemParentKEYWORD Auto Const mandatory
	Keyword Property ASAMRepairNeededKeyword Auto Const mandatory
	Keyword Property WorkshopItemKeyword Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iTimerID_RetryInit = 100 Const
simsettlementsv2:objectreferences:asamsensor kASAMSensor
bool bInitializationComplete = False
simsettlementsv2:quests:plotmanager PlotManager
int iFormID_PlotManager = 60231 Const
bool bUpdateNeeded = True

;-- Functions ---------------------------------------

Event OnTimer(int aiTimerID)
	If (iTimerID_RetryInit)
		Self.OnInit()
	EndIf
EndEvent

Event ObjectReference.OnDestructionStageChanged(ObjectReference akSender, int aiOldStage, int aiCurrentStage)
	If (akSender.IsDestroyed())
		simsettlementsv2:objectreferences:simplot thisPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, AccessoryLinkKeyword)
		If (thisPlot)
			thisPlot.AddKeyword(ASAMRepairNeededKeyword)
			thisPlot.BlockActivation(True, False)
		EndIf
	EndIf
EndEvent

Function UpdateVars()
	string sPluginName = simsettlementsv2:utilityfunctions.GetPluginName()
	If (!PlotManager)
		PlotManager = Game.GetFormFromFile(iFormID_PlotManager, sPluginName) as simsettlementsv2:quests:plotmanager
	EndIf
EndFunction

Function HandleSensorRepaired()
	simsettlementsv2:objectreferences:simplot thisPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, AccessoryLinkKeyword)
	If (thisPlot != None)
		thisPlot.RemoveKeyword(ASAMRepairNeededKeyword)
		thisPlot.BlockActivation(False, False)
	EndIf
EndFunction

Function Cleanup()
	Self.DeleteASAMSensor()
	Self.UnregisterForAllEvents()
EndFunction

Event OnLoad()
	If (bUpdateNeeded && bInitializationComplete)
		Self.UpdateASAMSensorPosition()
	EndIf
EndEvent

ObjectReference Function GetSensor()
	return kASAMSensor as ObjectReference
EndFunction

Function DeleteASAMSensor()
	If (!kASAMSensor)
		return 
	EndIf
	kASAMSensor.SetLinkedRef(None, ASAMSensorLinkKeyword)
	kASAMSensor.SetLinkedRef(None, WorkshopStackedItemParentKEYWORD)
	kASAMSensor.Disable(False)
	kASAMSensor.Delete()
	kASAMSensor = None
EndFunction

Function Delete()
	Self.Cleanup()
	Parent.Delete()
EndFunction

Event ObjectReference.OnWorkshopObjectDestroyed(ObjectReference akSender, ObjectReference akActionRef)
	If (akSender == kASAMSensor as ObjectReference)
		If (kASAMSensor.IsDestroyed())
			kASAMSensor.enable(False)
			Self.SetupSensorLinkedRefs()
			kASAMSensor.OnLoad()
		Else
			Self.DeleteASAMSensor()
			Self.TryToShowASAMMenu()
			Self.UpdateASAMSensorPosition()
		EndIf
	EndIf
EndEvent

Event ObjectReference.OnWorkshopObjectRepaired(ObjectReference akSender, ObjectReference akReference)
	Self.HandleSensorRepaired()
EndEvent

Function UpdateASAMSensorPosition()
	If (!Self.Is3dLoaded())
		bUpdateNeeded = True
		return 
	EndIf
	simsettlementsv2:objectreferences:simplot thisPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, AccessoryLinkKeyword)
	If (!thisPlot || thisPlot.bIsDestroyed)
		Self.Delete()
		return 
	EndIf
	ObjectReference kMarkerRef = None
	Form ASAMSensorForm = FreeStandingASAMSensorForm
	ObjectReference[] StageItemRefs = thisPlot.kLinkedRefHolder.GetLinkedRefChildren(StageItemLinkKeyword)
	int I = 0
	While (I < StageItemRefs.length)
		If (!StageItemRefs[I].IsDisabled() && StageItemRefs[I].HasKeyword(ASAMSensorMarkerKeyword))
			If (StageItemRefs[I].GetBaseObject() == WallMountedASAMSensorMarkerForm)
				ASAMSensorForm = WallMountedASAMSensorForm
			EndIf
			kMarkerRef = StageItemRefs[I]
		EndIf
		I += 1
	EndWhile
	If (!kMarkerRef)
		ObjectReference[] AccessoryRefs = thisPlot.kLinkedRefHolder.GetLinkedRefChildren(AccessoryLinkKeyword)
		I = 0
		While (I < AccessoryRefs.length && !kMarkerRef)
			If (!AccessoryRefs[I].IsDisabled() && AccessoryRefs[I].HasKeyword(ASAMSensorMarkerKeyword))
				If (AccessoryRefs[I].GetBaseObject() == WallMountedASAMSensorMarkerForm)
					ASAMSensorForm = WallMountedASAMSensorForm
				EndIf
				kMarkerRef = AccessoryRefs[I]
			EndIf
			I += 1
		EndWhile
	EndIf
	bool bStartDestroyed = kASAMSensor != None && kASAMSensor.IsDestroyed()
	If (kASAMSensor as bool && kASAMSensor.GetBaseObject() != ASAMSensorForm)
		Self.DeleteASAMSensor()
		kASAMSensor = None
	EndIf
	If (!kASAMSensor)
		Self.SpawnASAMSensor(ASAMSensorForm, kMarkerRef, bStartDestroyed)
	Else
		If (!kMarkerRef)
			kMarkerRef = Self as ObjectReference
		EndIf
		kASAMSensor.MoveTo(kMarkerRef, 0, 0, 0, True)
		kASAMSensor.SetScale(kMarkerRef.GetScale())
	EndIf
	bUpdateNeeded = False
EndFunction

Event SimSettlementsV2:ObjectReferences:SimPlot.PlotLevelChanged(simsettlementsv2:objectreferences:simplot akPlotRef, var[] akArgs)
	If (bInitializationComplete)
		Self.UpdateASAMSensorPosition()
	EndIf
EndEvent

Function SpawnASAMSensor(Form aSensorForm, ObjectReference akPositionAtRef, bool abStartDestroyed)
	simsettlementsv2:objectreferences:simplot thisPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, AccessoryLinkKeyword)
	If (!aSensorForm || !thisPlot)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[SS2] Unable to place ASAM Sensor (" + aSensorForm as string + ") for Plot: " + thisPlot as string, 0, False)
		return 
	EndIf
	If (kASAMSensor != None)
		Self.DeleteASAMSensor()
	EndIf
	If (!akPositionAtRef)
		akPositionAtRef = Self as ObjectReference
	EndIf
	kASAMSensor = akPositionAtRef.PlaceAtMe(aSensorForm, 1, False, True, False) as simsettlementsv2:objectreferences:asamsensor
	If (kASAMSensor)
		If (abStartDestroyed)
			kASAMSensor.DamageObject(9999 as float)
		EndIf
		Self.SetupSensorLinkedRefs()
		kASAMSensor.SetScale(akPositionAtRef.GetScale())
		kASAMSensor.enable(False)
		Self.RegisterForRemoteEvent(kASAMSensor as ScriptObject, "OnWorkshopObjectDestroyed")
		Self.RegisterForRemoteEvent(kASAMSensor as ScriptObject, "OnWorkshopObjectRepaired")
		Self.RegisterForRemoteEvent(kASAMSensor as ScriptObject, "OnDestructionStageChanged")
	EndIf
EndFunction

Event OnRelease()
	Self.UpdateASAMSensorPosition()
EndEvent

Function TryToShowASAMMenu()
	simsettlementsv2:objectreferences:simplot thisPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, AccessoryLinkKeyword)
	If (thisPlot as bool && !thisPlot.bIsDestroyed)
		var[] kArgs = new var[2]
		kArgs[0] = thisPlot as var
		kArgs[1] = PlotManager.iPlotMenuID_Main as var
		PlotManager.CallFunctionNoWait("ShowPlotMenu", kArgs)
	EndIf
EndFunction

Event OnInit()
	Self.UpdateVars()
	simsettlementsv2:objectreferences:simplot thisPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, AccessoryLinkKeyword)
	If (!thisPlot)
		Self.StartTimer(2, iTimerID_RetryInit)
	Else
		Self.RegisterForCustomEvent(thisPlot as ScriptObject, "simsettlementsv2:objectreferences:simplot_PlotLevelChanged")
		bInitializationComplete = True
		Self.UpdateASAMSensorPosition()
	EndIf
EndEvent

Function SetupSensorLinkedRefs()
	simsettlementsv2:objectreferences:simplot thisPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, AccessoryLinkKeyword)
	workshopscript thisWorkshop = thisPlot.GetWorkshop()
	kASAMSensor.SetLinkedRef(Self as ObjectReference, WorkshopStackedItemParentKEYWORD)
	kASAMSensor.SetLinkedRef(thisPlot.kLinkedRefHolder as ObjectReference, ASAMSensorLinkKeyword)
	kASAMSensor.SetLinkedRef(thisWorkshop as ObjectReference, WorkshopItemKeyword)
EndFunction
