;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\AnimatedObjectSpawner.psc
Modified : 2020-06-10 15:23:16
Compiled : 2021-01-07 11:40:22
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:AnimatedObjectSpawner extends ObjectReference

;-- Structs -----------------------------------------
Struct TransitionPhase
	float fOffsetX = 0
	float fOffsetY = 0
	float fOffsetZ = 0
	float fAngleOffsetX = 0
	float fAngleOffsetY = 0
	float fAngleOffsetZ = 0
	float fSpeed = 0
	float fHavokPause = 0
	{ Seconds to allow havok to take over temporarily }
	bool bDoNotRotate = False
	{ If set to true, the objects rotation at this phase will be maintained }
EndStruct

Struct InTransitionObject
	ObjectReference kObjectRef
	int iPhase
EndStruct


;-- Properties --------------------------------------
float Property fInitialMovementDelay = 0 Auto Const
{ Seconds to delay before starting the initial movement }
Form Property ObjectToAnimate Auto Const
{ Form to create and animate along transition phases, if a FormList, one will be picked at random }
int Property iTotalObjects = -1 Auto Const
{ The number of objects to create before stopping, -1 = continue creating objects forever }
float Property fPauseBetweenObjects = 1 Auto Const
{ Time to wait between spawning objects }
bool Property bWaitUntilTransitionCompletes = False Auto Const
{ If set to true, a new object will not be created until the previous one finishes all transition phases }
int Property iEndPositionObjectCount = 3 Auto Const
{ Total number of objects to allow to reach the final transition before deleting the first one. }
simsettlementsv2:objectreferences:animatedobjectspawner#transitionphase[] Property Phases Auto Const
{ The first entry will be the starting position, the object(s) will then be animated from position to position. Objects must have moveable collision to animate correctly. }
bool Property bPlotSpawned = True Auto Const
{ If used as part of a stage item spawn, set this to true to assume phase coordinates are from the center of a plot }

;-- Variables ---------------------------------------
simsettlementsv2:objectreferences:simplot kPlotRef
int iObjectHardCap = 100
int SpawnObjectTimerID = 0
bool bFirstLoad = True
float[] SpawnerRotation
float[] SpawnerPosition
simsettlementsv2:objectreferences:animatedobjectspawner#intransitionobject[] InTransitionObjects
float[] PlotOffsets
ObjectReference[] TransistionedObjects
int iSpawnedObjects = 0
Keyword LinkedStageItemKeyword
float fMinPause = 0.25

;-- Functions ---------------------------------------

Event OnUnload()
	Self.Cleanup()
EndEvent

Event ObjectReference.OnTranslationAlmostComplete(ObjectReference akTranslatedRef)
	int index = InTransitionObjects.findstruct("kObjectRef", akTranslatedRef, 0)
	If (index < 0)
		Self.UnregisterForRemoteEvent(akTranslatedRef as ScriptObject, "OnTranslationAlmostComplete")
		return 
	EndIf
	simsettlementsv2:objectreferences:animatedobjectspawner#intransitionobject thisObject = InTransitionObjects[index]
	If (thisObject.iPhase < Phases.length - 1)
		If (Phases[thisObject.iPhase].fHavokPause > 0 as float)
			akTranslatedRef.SetMotionType(Self.Motion_Dynamic, True)
			Utility.Wait(Phases[thisObject.iPhase].fHavokPause)
			akTranslatedRef.SetMotionType(Self.Motion_Keyframed, True)
		EndIf
		Self.AdvancePhase(thisObject.kObjectRef, thisObject.iPhase + 1)
	Else
		akTranslatedRef.SetMotionType(Self.Motion_Dynamic, True)
		InTransitionObjects.remove(index, 1)
		Self.UnregisterForRemoteEvent(akTranslatedRef as ScriptObject, "OnTranslationAlmostComplete")
		TransistionedObjects.add(akTranslatedRef, 1)
		If (TransistionedObjects.length > iEndPositionObjectCount || TransistionedObjects.length > iObjectHardCap)
			TransistionedObjects[0].Disable(False)
			TransistionedObjects[0].Delete()
			TransistionedObjects.remove(0, 1)
		EndIf
		If (bWaitUntilTransitionCompletes)
			Self.StartTimer(0, SpawnObjectTimerID)
		EndIf
	EndIf
EndEvent

Event ObjectReference.OnContainerChanged(ObjectReference akItemRef, ObjectReference akNewContainer, ObjectReference akOldContainer)
	int index = InTransitionObjects.findstruct("kObjectRef", akItemRef, 0)
	If (index > -1)
		InTransitionObjects.remove(index, 1)
	EndIf
	index = TransistionedObjects.find(akItemRef, 0)
	If (index > -1)
		TransistionedObjects.remove(index, 1)
	EndIf
	Self.UnregisterForRemoteEvent(akItemRef as ScriptObject, "OnContainerChanged")
EndEvent

Function Cleanup()
	Self.GoToState("Paused")
	Self.CancelTimer(SpawnObjectTimerID)
	int I = 0
	If (InTransitionObjects.length)
		While (I < InTransitionObjects.length)
			Self.UnregisterForRemoteEvent(InTransitionObjects[I].kObjectRef as ScriptObject, "OnTranslationAlmostComplete")
			Self.UnregisterForRemoteEvent(InTransitionObjects[I].kObjectRef as ScriptObject, "OnContainerChanged")
			Self.UnregisterForRemoteEvent(InTransitionObjects[I].kObjectRef as ScriptObject, "OnLoad")
			InTransitionObjects[I].kObjectRef.Delete()
			I += 1
		EndWhile
	EndIf
	If (TransistionedObjects.length)
		While (I < TransistionedObjects.length)
			Self.UnregisterForRemoteEvent(TransistionedObjects[I] as ScriptObject, "OnTranslationAlmostComplete")
			Self.UnregisterForRemoteEvent(TransistionedObjects[I] as ScriptObject, "OnContainerChanged")
			Self.UnregisterForRemoteEvent(TransistionedObjects[I] as ScriptObject, "OnLoad")
			TransistionedObjects[I].Delete()
			I += 1
		EndWhile
	EndIf
	InTransitionObjects = None
	TransistionedObjects = None
	iSpawnedObjects = 0
	Self.GoToState("")
EndFunction

Event OnLoad()
	ObjectReference[] spawns = Self.FindAllReferencesOfType(ObjectToAnimate, 1000)
	If (spawns.length)
		int I = 0
		While (I < spawns.length)
			spawns[I].Disable(False)
			spawns[I].Delete()
			I += 1
		EndWhile
		spawns = None
	EndIf
	If (Self.isDeleted())
		return 
	EndIf
	bool bInitialWaitComplete = False
	InTransitionObjects = new simsettlementsv2:objectreferences:animatedobjectspawner#intransitionobject[0]
	TransistionedObjects = new ObjectReference[0]
	If (bPlotSpawned)
		If (!kPlotRef)
			Utility.Wait(2)
			bInitialWaitComplete = True
			kPlotRef = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, LinkedStageItemKeyword)
		EndIf
		If (kPlotRef)
			PlotOffsets = kPlotRef.GetCurrentLevelPlan().PositionOffsets
		EndIf
	EndIf
	If (bFirstLoad)
		bFirstLoad = False
		ObjectReference placeholder = None
		SpawnerPosition = new float[3]
		SpawnerRotation = new float[3]
		If (bPlotSpawned)
			If (!bInitialWaitComplete)
				Utility.Wait(2)
			EndIf
			SpawnerPosition[0] = kPlotRef.X
			SpawnerPosition[1] = kPlotRef.Y
			SpawnerPosition[2] = kPlotRef.Z
			SpawnerRotation[0] = kPlotRef.GetAngleX()
			SpawnerRotation[1] = kPlotRef.GetAngleY()
			SpawnerRotation[2] = kPlotRef.GetAngleZ()
		Else
			SpawnerPosition[0] = Self.X
			SpawnerPosition[1] = Self.Y
			SpawnerPosition[2] = Self.Z
			SpawnerRotation[0] = Self.GetAngleX()
			SpawnerRotation[1] = Self.GetAngleY()
			SpawnerRotation[2] = Self.GetAngleZ()
		EndIf
	EndIf
	Self.StartTimer(0, SpawnObjectTimerID)
EndEvent

Event ObjectReference.OnLoad(ObjectReference akLoadedRef)
	akLoadedRef.SetMotionType(Self.Motion_Keyframed, True)
	Self.UnregisterForRemoteEvent(akLoadedRef as ScriptObject, "OnLoad")
EndEvent

Function Delete()
	Self.Cleanup()
	kPlotRef = None
	Parent.Delete()
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == SpawnObjectTimerID)
		Self.SpawnObject()
		If (!bWaitUntilTransitionCompletes && iTotalObjects == -1 || iSpawnedObjects < iTotalObjects)
			float fPause = fPauseBetweenObjects
			If (fPause < fMinPause)
				fPause = fMinPause
			EndIf
			Self.StartTimer(fPause, SpawnObjectTimerID)
		EndIf
	EndIf
EndEvent

Function SpawnObject()
	If (!Self.Is3DLoaded() || Self.isDeleted() || Self.IsDisabled())
		Self.Cleanup()
		return 
	EndIf
	Form spawnMe = Self.GetObjectForm()
	If (spawnMe)
		ObjectReference spawn = Self.PlaceAtMe(spawnMe, 1, False, False, True)
		Self.RegisterForRemoteEvent(spawn as ScriptObject, "OnLoad")
		If (spawn)
			iSpawnedObjects += 1
			spawn.SetMotionType(Self.Motion_Keyframed, True)
			spawn.MoveToMyEditorLocation()
			Self.RegisterForRemoteEvent(spawn as ScriptObject, "OnTranslationAlmostComplete")
			Self.RegisterForRemoteEvent(spawn as ScriptObject, "OnContainerChanged")
			Utility.Wait(fInitialMovementDelay)
			Self.AdvancePhase(spawn, 0)
		EndIf
	EndIf
EndFunction

Form Function GetObjectForm()
	Form spawnMe = ObjectToAnimate
	FormList asFormList = ObjectToAnimate as FormList
	If (asFormList)
		spawnMe = asFormList.GetAt(Utility.RandomInt(0, asFormList.GetSize() - 1))
	EndIf
	return spawnMe
EndFunction

Function AdvancePhase(ObjectReference akMoveMe, int iPhase)
	If (Self.isDeleted() || Self.IsDisabled() || !Phases || iPhase > Phases.length - 1 || !Phases[iPhase] || !Self.Is3DLoaded())
		return 
	EndIf
	int index = -1
	If (InTransitionObjects)
		index = InTransitionObjects.findstruct("kObjectRef", akMoveMe, 0)
	EndIf
	If (index > -1)
		InTransitionObjects[index].iPhase = iPhase
	Else
		simsettlementsv2:objectreferences:animatedobjectspawner#intransitionobject ito = new simsettlementsv2:objectreferences:animatedobjectspawner#intransitionobject
		ito.kObjectRef = akMoveMe
		ito.iPhase = iPhase
		InTransitionObjects.add(ito, 1)
	EndIf
	float[] OffsetPosition = new float[3]
	float[] OffsetRotation = new float[3]
	OffsetPosition[0] = Phases[iPhase].fOffsetX
	OffsetPosition[1] = Phases[iPhase].fOffsetY
	OffsetPosition[2] = Phases[iPhase].fOffsetZ
	OffsetRotation[0] = Phases[iPhase].fAngleOffsetX
	OffsetRotation[1] = Phases[iPhase].fAngleOffsetY
	OffsetRotation[2] = Phases[iPhase].fAngleOffsetZ
	If (bPlotSpawned && kPlotRef as bool && PlotOffsets.length as bool)
		OffsetPosition[0] = OffsetPosition[0] + PlotOffsets[0]
		OffsetPosition[1] = OffsetPosition[1] + PlotOffsets[1]
		OffsetPosition[2] = OffsetPosition[2] + PlotOffsets[2]
		OffsetRotation[0] = OffsetRotation[0] + PlotOffsets[3]
		OffsetRotation[1] = OffsetRotation[1] + PlotOffsets[4]
		OffsetRotation[2] = OffsetRotation[2] + PlotOffsets[5]
	EndIf
	float[] TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(SpawnerPosition, SpawnerRotation, OffsetPosition, OffsetRotation)
	If (Phases[iPhase].bDoNotRotate)
		TargetCoordinates[3] = akMoveMe.GetAngleX()
		TargetCoordinates[4] = akMoveMe.GetAngleY()
		TargetCoordinates[5] = akMoveMe.GetAngleZ()
	EndIf
	akMoveMe.TranslateTo(TargetCoordinates[0], TargetCoordinates[1], TargetCoordinates[2], TargetCoordinates[3], TargetCoordinates[4], TargetCoordinates[5], Phases[iPhase].fSpeed, 0)
EndFunction

Event OnInit()
	InTransitionObjects = new simsettlementsv2:objectreferences:animatedobjectspawner#intransitionobject[0]
	TransistionedObjects = new ObjectReference[0]
	LinkedStageItemKeyword = Game.GetFormFromFile(84478, simsettlementsv2:utilityfunctions.GetPluginName()) as Keyword
EndEvent

;-- State -------------------------------------------
State Paused

	Event OnTimer(int aiTimerID)
		; Empty function
	EndEvent

	Function SpawnObject()
		; Empty function
	EndFunction

	Function AdvancePhase(ObjectReference akMoveMe, int iPhase)
		; Empty function
	EndFunction
EndState
