;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\BasicLadder.psc
Modified : 2020-05-21 23:54:29
Compiled : 2021-01-07 11:40:17
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:BasicLadder extends ObjectReference

;-- Properties --------------------------------------
float[] Property Bottom Auto Const
{ Offset Position Player should be moved to at the base of the ladder - should have exactly 3 entries (X/Y/Z if ladder was at 0/0/0) }
float[] Property Top Auto Const
{ Offset Position Player should be moved to at the top to the ladder - should have exactly 3 entries (X/Y/Z if ladder was at 0/0/0) - recommend going slightly higher than necessary to combat gravity }
float Property TopForward = 0 Auto Const
{ Units to push the player forward after reaching the top of the ladder to avoid them falling down again }
Form Property XMarker Auto Const
{ Placed dynamically to ensure player is facing the ladder }
Keyword Property LadderKeyword Auto Const
Sound Property LadderSFX Auto Const
float Property fMoveSpeed = 100 Auto Const
float Property fFightGravityMultiplier = 0.3 Auto Const
Race Property FloatingRace Auto Const
Race Property HumanRace Auto Const

;-- Variables ---------------------------------------
bool bAtTop = False
int iFixRaceTimerID = 2
int iLadderSFXInstance = 0
int iStopSoundTimerID = 1
ObjectReference FaceTarget
Actor PlayerRef
inputenablelayer controlLayer
Race StartingRace
int iStartSoundTimerID = 0
float[] StartClimbPosition
bool bPlayerMovingUp = False

;-- Functions ---------------------------------------

Event OnActivate(ObjectReference akActionRef)
	PlayerRef = Game.GetPlayer()
	If (akActionRef == PlayerRef as ObjectReference)
		StartingRace = PlayerRef.GetRace()
		Self.CalculateDirection()
		ObjectReference MostLadder = Self.FindLadder(bPlayerMovingUp)
		float[] pfPositionStart = new float[3]
		float[] pfRotationStart = new float[3]
		pfPositionStart[0] = Self.X
		pfPositionStart[1] = Self.Y
		pfPositionStart[2] = Self.Z
		pfRotationStart[0] = Self.GetAngleX()
		pfRotationStart[1] = Self.GetAngleY()
		pfRotationStart[2] = Self.GetAngleZ()
		float[] pfPositionOffset = new float[3]
		float[] pfRotationOffset = new float[3]
		pfPositionOffset[0] = StartClimbPosition[0]
		pfPositionOffset[1] = StartClimbPosition[1]
		pfPositionOffset[2] = StartClimbPosition[2]
		pfRotationOffset[0] = 0
		pfRotationOffset[1] = 0
		pfRotationOffset[2] = 0
		float[] StartCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(pfPositionStart, pfRotationStart, pfPositionOffset, pfRotationOffset)
		float fClimbHeight = 0
		If (bPlayerMovingUp)
			fClimbHeight = Math.abs(MostLadder.Z - Self.Z) + MostLadder.GetHeight()
		Else
			fClimbHeight = Math.abs(MostLadder.Z - Self.Z) + Self.GetHeight()
		EndIf
		pfPositionOffset[0] = 0
		pfPositionOffset[1] = 256
		pfPositionOffset[2] = fClimbHeight / 2 as float
		pfRotationOffset[0] = 0
		pfRotationOffset[1] = 0
		pfRotationOffset[2] = 0
		float[] FaceCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(pfPositionStart, pfRotationStart, pfPositionOffset, pfRotationOffset)
		If (MostLadder as SimSettlementsV2:ObjectReferences:BasicLadder)
			(MostLadder as SimSettlementsV2:ObjectReferences:BasicLadder).ClimbLadder(StartCoordinates, FaceCoordinates)
		Else
			Self.ClimbLadder(StartCoordinates, FaceCoordinates)
		EndIf
	EndIf
EndEvent

Event ObjectReference.OnTranslationAlmostComplete(ObjectReference akObjectRef)
	float[] ladderPosition = new float[3]
	float[] ladderRotation = new float[3]
	float[] pfPositionOffset = new float[3]
	float[] pfRotationOffset = new float[3]
	float[] TargetCoordinates = None
	If (bPlayerMovingUp)
		If (FloatingRace)
			If (controlLayer)
				controlLayer.Delete()
			EndIf
			controlLayer = inputenablelayer.Create()
			controlLayer.EnableCamSwitch(False)
			Game.ForceFirstPerson()
			PlayerRef.SetRace(FloatingRace)
		EndIf
		If (!bAtTop)
			Game.StartDialogueCameraOrCenterOnTarget(FaceTarget)
			ladderPosition[0] = Self.X
			ladderPosition[1] = Self.Y
			ladderPosition[2] = Self.Z
			ladderRotation[0] = Self.GetAngleX()
			ladderRotation[1] = Self.GetAngleY()
			ladderRotation[2] = Self.GetAngleZ()
			pfPositionOffset[0] = Top[0]
			pfPositionOffset[1] = Top[1]
			pfPositionOffset[2] = Top[2] + fMoveSpeed * fFightGravityMultiplier
			pfRotationOffset[0] = 0
			pfRotationOffset[1] = 0
			pfRotationOffset[2] = 0
			TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(ladderPosition, ladderRotation, pfPositionOffset, pfRotationOffset)
			bAtTop = True
			Sound.StopInstance(iLadderSFXInstance)
			iLadderSFXInstance = LadderSFX.Play(Self as ObjectReference)
			Self.StartTimer(Math.abs(Game.GetPlayer().Z - TargetCoordinates[2]) / fMoveSpeed, iStopSoundTimerID)
		Else
			Self.UnregisterForRemoteEvent(akObjectRef as ScriptObject, "OnTranslationAlmostComplete")
			If (TopForward > 0 as float)
				ladderPosition[0] = akObjectRef.GetPositionX()
				ladderPosition[1] = akObjectRef.GetPositionY()
				ladderPosition[2] = akObjectRef.GetPositionZ()
				ladderRotation[0] = akObjectRef.GetAngleX()
				ladderRotation[1] = akObjectRef.GetAngleY()
				ladderRotation[2] = akObjectRef.GetAngleZ()
				pfPositionOffset[0] = 0
				pfPositionOffset[1] = TopForward
				pfPositionOffset[2] = 0
				If (!FloatingRace)
					pfPositionOffset[2] = (-1) as float * fMoveSpeed
				EndIf
				pfRotationOffset[0] = 0
				pfRotationOffset[1] = 0
				pfRotationOffset[2] = 0
				TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(ladderPosition, ladderRotation, pfPositionOffset, pfRotationOffset)
			EndIf
			Self.StartTimer(TopForward / fMoveSpeed, iFixRaceTimerID)
		EndIf
	Else
		Game.StartDialogueCameraOrCenterOnTarget(FaceTarget)
		Self.UnregisterForRemoteEvent(akObjectRef as ScriptObject, "OnTranslationAlmostComplete")
		ladderPosition[0] = Self.X
		ladderPosition[1] = Self.Y
		ladderPosition[2] = Self.Z
		ladderRotation[0] = Self.GetAngleX()
		ladderRotation[1] = Self.GetAngleY()
		ladderRotation[2] = Self.GetAngleZ()
		pfPositionOffset[0] = Bottom[0]
		pfPositionOffset[1] = Bottom[1]
		pfPositionOffset[2] = Bottom[2]
		pfRotationOffset[0] = 0
		pfRotationOffset[1] = 0
		pfRotationOffset[2] = 0
		TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(ladderPosition, ladderRotation, pfPositionOffset, pfRotationOffset)
		Sound.StopInstance(iLadderSFXInstance)
		iLadderSFXInstance = LadderSFX.Play(Self as ObjectReference)
		Self.StartTimer(Math.abs(Game.GetPlayer().Z - TargetCoordinates[2]) / fMoveSpeed, iStopSoundTimerID)
	EndIf
	If (TargetCoordinates.length)
		akObjectRef.TranslateTo(TargetCoordinates[0], TargetCoordinates[1], TargetCoordinates[2], TargetCoordinates[3], TargetCoordinates[4], TargetCoordinates[5], fMoveSpeed, 0)
	EndIf
EndEvent

ObjectReference Function FindLadder(bool bGoingUp)
	ObjectReference[] Ladders = Self.FindAllReferencesWithKeyword(LadderKeyword as Form, 10000)
	int I = 0
	ObjectReference MostLadder = None
	float fCurrentMostZ = Self.Z
	While (I < Ladders.length)
		float myX = Ladders[I].GetPositionX()
		float myY = Ladders[I].GetPositionY()
		float myZ = Ladders[I].GetPositionZ()
		If (myX < Self.X + 5 && myX > Self.X - 5 && myY < Self.Y + 5 && myY > Self.Y - 5)
			If (bGoingUp && myZ > Self.Z && myZ > fCurrentMostZ || !bGoingUp && myZ < Self.Z && myZ < fCurrentMostZ)
				MostLadder = Ladders[I]
				fCurrentMostZ = myZ
			EndIf
		EndIf
		I += 1
	EndWhile
	return MostLadder
EndFunction

Function ClimbLadder(float[] StartCoordinates, float[] FacePosition)
	PlayerRef = Game.GetPlayer()
	Self.CalculateDirection()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnTranslationAlmostComplete")
	PlayerRef.TranslateTo(StartCoordinates[0], StartCoordinates[1], StartCoordinates[2], StartCoordinates[3], StartCoordinates[4], StartCoordinates[5], fMoveSpeed, 0)
	If (FaceTarget)
		FaceTarget.Disable(False)
		FaceTarget.Delete()
		FaceTarget = None
	EndIf
	FaceTarget = Self.PlaceAtMe(XMarker, 1, False, False, True)
	FaceTarget.SetPosition(FacePosition[0], FacePosition[1], FacePosition[2])
EndFunction

Function CalculateDirection()
	float playerZ = Game.GetPlayer().GetPositionZ()
	StartClimbPosition = Top
	bAtTop = False
	If (playerZ > Self.GetPositionZ() + Top[2] / 2 as float)
		bPlayerMovingUp = False
	Else
		bPlayerMovingUp = True
		StartClimbPosition = Bottom
	EndIf
EndFunction

Function Disable(bool abFade)
	If (FaceTarget)
		FaceTarget.Disable(False)
		FaceTarget.Delete()
	EndIf
	Parent.Disable(abFade)
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iStopSoundTimerID)
		Sound.StopInstance(iLadderSFXInstance)
	ElseIf (aiTimerID == iFixRaceTimerID)
		If (controlLayer)
			controlLayer.Delete()
		EndIf
		If (StartingRace)
			PlayerRef.SetRace(StartingRace)
		ElseIf (HumanRace)
			PlayerRef.SetRace(HumanRace)
		EndIf
	EndIf
EndEvent
