;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\BirdCritterScript.psc
Modified : 2019-12-03 04:51:04
Compiled : 2021-01-07 11:40:21
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:BirdCritterScript extends ObjectReference
{ Inivdial bird controls for individual bird behavior }

;-- Properties --------------------------------------
Keyword Property LinkCustom01 Auto
{ Keyword for Flee marker, used with interior fleeing }
Sound Property NPCCrowCall Auto
Sound Property NPCCrowCallDistressed Auto
Sound Property NPCCrowWingFlap Auto
Sound Property NPCCrowWingFlapLand Auto
Sound Property NPCCrowWingFlapTakeoff Auto
simsettlementsv2:objectreferences:birdspawner Property myParentScript Auto
{ parent script on trigger }

;-- Variables ---------------------------------------
int flyToTreeID = 1 Const
int hidingCaw = 2 Const
bool birdSpawned = False
int numLinkedRefs
ObjectReference nextPerch
Sound myCallSound
bool playerInZone = False
string myPerchName
ObjectReference currentPerch

;-- Functions ---------------------------------------

Event SimSettlementsV2:ObjectReferences:BirdSpawner.safe(simsettlementsv2:objectreferences:birdspawner akSender, var[] akArgs)
	; Empty function
EndEvent

Event OnUnload()
	Self.unregisterForAllEvents()
	Self.disable(False)
	Self.delete()
EndEvent

Event OnLoad()
	Self.loadBird()
EndEvent

Function playLandingSounds()
	myCallSound.play(Self as ObjectReference)
	NPCCrowWingFlapLand.play(Self as ObjectReference)
EndFunction

Event SimSettlementsV2:ObjectReferences:BirdSpawner.hide(simsettlementsv2:objectreferences:birdspawner akSender, var[] akArgs)
	Debug.trace("got hide event", 0)
	myCallSound = NPCCrowCallDistressed
	Self.flyToTree(True, False)
	Self.GotoState("Hiding")
EndEvent

Function timerBetweenFlights()
	Self.startTimer(Utility.RandomInt(10, 25) as float, flyToTreeID)
EndFunction

Function loadBird()
	If (Self.Is3dLoaded() && birdSpawned)
		currentPerch = myParentScript as ObjectReference
		myCallSound = NPCCrowCall
		numLinkedRefs = myParentScript.countLinkedRefChain(None, 100)
		Self.timerBetweenFlights()
		Self.registerForCustomEvent(myParentScript as ScriptObject, "simsettlementsv2:objectreferences:birdspawner_Flee")
		Self.registerForCustomEvent(myParentScript as ScriptObject, "simsettlementsv2:objectreferences:birdspawner_Hide")
		Self.registerForCustomEvent(myParentScript as ScriptObject, "simsettlementsv2:objectreferences:birdspawner_safe")
		Self.GotoState("Waiting")
	EndIf
EndFunction

Function playTakeoffSounds()
	myCallSound.play(Self as ObjectReference)
	NPCCrowWingFlapTakeoff.play(Self as ObjectReference)
EndFunction

Function land()
	Self.SetAnimationVariableFloat("fDampRate", 1)
	Self.SetAnimationVariableFloat("fFlapSpeed", 2.5)
	Self.playAnimation("LandingGlide")
	Self.playLandingSounds()
	currentPerch = nextPerch
EndFunction

Event SimSettlementsV2:ObjectReferences:BirdSpawner.flee(simsettlementsv2:objectreferences:birdspawner akSender, var[] akArgs)
	myCallSound = NPCCrowCallDistressed
	If (myParentScript.InteriorFlee == False)
		Self.flee()
	Else
		Self.GotoState("InteriorFleeState")
		Self.flyToTree(False, True)
	EndIf
EndEvent

Function flyToTree(bool akHide, bool InteriorFlee)
	float speedRandomFudge = Utility.RandomFloat(-10, 50)
	If (akHide == False && InteriorFlee == False)
		nextPerch = myParentScript.GetNthLinkedRef(Utility.RandomInt(1, numLinkedRefs), None)
	ElseIf (InteriorFlee == True && akHide == False)
		nextPerch = myParentScript.GetLinkedRef(LinkCustom01)
	Else
		nextPerch = myParentScript.GetLinkedRef(None)
		playerInZone = True
	EndIf
	If (currentPerch == nextPerch)
		Self.timerBetweenFlights()
	Else
		Self.playTakeoffSounds()
		Self.SetAnimationVariableFloat("fDampRate", 1)
		Self.SetAnimationVariableFloat("fFlapSpeed", 2)
		Self.playAnimation("Takeoff")
		Utility.wait(0.1)
		float perchDistance = currentPerch.GetDistance(nextPerch)
		Self.SplineTranslateToRefNode(nextPerch, myPerchName, perchDistance * 2 as float, 550 + speedRandomFudge, 0)
		Utility.wait(0.6)
		Self.SetAnimationVariableFloat("fDampRate", 0.05)
		Self.SetAnimationVariableFloat("fFlapSpeed", Utility.RandomFloat(1, 1.5))
		NPCCrowWingFlap.play(Self as ObjectReference)
	EndIf
EndFunction

Function flee()
	Self.GotoState("flee")
	Self.playTakeoffSounds()
	Self.playAnimation("flee")
	Utility.wait(4 as float)
	Self.disable(False)
	Self.delete()
EndFunction

Function spawnBird(string akPerchName, simsettlementsv2:objectreferences:birdspawner akParentScript)
	myPerchName = akPerchName
	myParentScript = akParentScript
	birdSpawned = True
	Self.loadBird()
EndFunction

;-- State -------------------------------------------
State InteriorFleeState

	Event OnTranslationComplete()
		Self.playAnimation("land")
		Self.flee()
	EndEvent

	Event OnTranslationAlmostComplete()
		Self.land()
	EndEvent
EndState

;-- State -------------------------------------------
State safe

	Event SimSettlementsV2:ObjectReferences:BirdSpawner.safe(simsettlementsv2:objectreferences:birdspawner akSender, var[] akArgs)
		myCallSound = NPCCrowCall
		Utility.wait(Utility.RandomInt(2, 7) as float)
		Self.flyToTree(False, False)
		Self.timerBetweenFlights()
		Self.GotoState("Waiting")
		playerInZone = False
	EndEvent

	Event OnBeginState(string asOldState)
		myCallSound = NPCCrowCall
		Utility.wait(Utility.RandomInt(2, 7) as float)
		Self.flyToTree(False, False)
		Self.timerBetweenFlights()
		Self.GotoState("Waiting")
	EndEvent
EndState

;-- State -------------------------------------------
State Hiding

	Event SimSettlementsV2:ObjectReferences:BirdSpawner.safe(simsettlementsv2:objectreferences:birdspawner akSender, var[] akArgs)
		playerInZone = False
		Self.GotoState("safe")
	EndEvent

	Event OnTranslationAlmostComplete()
		Self.land()
	EndEvent

	Event OnTranslationComplete()
		Self.playAnimation("land")
	EndEvent

	Event OnTimer(int aiTimerID)
		If (aiTimerID == hidingCaw)
			myCallSound.play(Self as ObjectReference)
			Self.startTimer(Utility.RandomInt(2, 15) as float, hidingCaw)
		EndIf
	EndEvent

	Event OnBeginState(string asOldState)
		Self.startTimer(Utility.RandomInt(2, 15) as float, hidingCaw)
	EndEvent
EndState

;-- State -------------------------------------------
State Waiting

	Event OnTranslationComplete()
		Self.playAnimation("land")
		Self.timerBetweenFlights()
	EndEvent

	Event OnTranslationAlmostComplete()
		Self.land()
	EndEvent

	Event OnTimer(int aiTimerID)
		If (aiTimerID == flyToTreeID)
			Self.flyToTree(False, False)
		EndIf
	EndEvent
EndState

;-- State -------------------------------------------
State flee
EndState
