;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\BirdSpawner.psc
Modified : 2019-12-03 04:49:33
Compiled : 2021-01-07 11:40:23
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:BirdSpawner extends ObjectReference
{ Spawns and manages groups of birds. }

;-- Properties --------------------------------------
Form Property BirdBase Auto Const
{ type of bird }
float Property ScaleMin = 1 Auto Const
float Property ScaleMax = 1 Auto Const
int Property BirdCount = 5 Auto Const
{ This system looks for nodes in the nif with the name CritterPerch0X - where X is a number. It will only spawn as many birds as perch nodes are found, starting with CritterPerch01 and incrementing each bird (ex. for 3 birds you would need CritterPerch01, CritterPerch02, and CritterPerch03 nodes) }
bool Property InteriorFlee = False Auto
{ Use interior fleeing }
int Property InteriorFleeRadius = 0 Auto
{ Don't care about weapon fire until within this radius. }

;-- Variables ---------------------------------------
bool bInitialSpawnComplete = False

;-- Functions ---------------------------------------

Event OnDistanceGreaterThan(ObjectReference akObj1, ObjectReference akObj2, float afDistance)
	Self.RegisterForDistanceLessThanEvent(Self as ScriptObject, Game.getPlayer() as ScriptObject, InteriorFleeRadius as float)
	Self.UnRegisterForAnimationEvent(Game.getPlayer() as ObjectReference, "WeaponFire")
EndEvent

ObjectReference Function spawnBird(string akPerchName)
	Activator BirdToSpawn = None
	FormList asFormlist = BirdBase as FormList
	If (asFormlist)
		BirdToSpawn = asFormlist.GetAt(Utility.RandomInt(0, asFormlist.GetSize() - 1)) as Activator
	Else
		BirdToSpawn = BirdBase as Activator
	EndIf
	ObjectReference birdSpawn = Self.PlaceAtNode(akPerchName, BirdToSpawn as Form, 1, False, False, True, False)
	If (birdSpawn)
		birdSpawn.SetScale(Utility.RandomFloat(ScaleMin, ScaleMax))
		simsettlementsv2:objectreferences:birdcritterscript newBirdScript = birdSpawn as simsettlementsv2:objectreferences:birdcritterscript
		newBirdScript.spawnBird(akPerchName, Self)
	EndIf
	return birdSpawn
EndFunction

Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	Self.SendCustomEvent("simsettlementsv2:objectreferences:birdspawner_flee", None)
	Self.GotoState("DoNothing")
EndEvent

Event OnUnload()
	If (InteriorFlee == False && InteriorFleeRadius == 0)
		Self.UnRegisterForAnimationEvent(Game.getPlayer() as ObjectReference, "WeaponFire")
	Else
		Self.UnRegisterForDistanceEvents(Self as ScriptObject, Game.getPlayer() as ScriptObject)
	EndIf
EndEvent

Event OnLoad()
	If (!bInitialSpawnComplete)
		Self.OnCellLoad()
		bInitialSpawnComplete = True
	EndIf
EndEvent

Event OnDistanceLessThan(ObjectReference akObj1, ObjectReference akObj2, float afDistance)
	Self.RegisterForDistanceGreaterThanEvent(Self as ScriptObject, Game.getPlayer() as ScriptObject, InteriorFleeRadius as float)
	Self.RegisterForAnimationEvent(Game.getPlayer() as ObjectReference, "WeaponFire")
EndEvent

Event OnCellLoad()
	If (InteriorFlee == False && InteriorFleeRadius == 0)
		Self.GotoState("")
		Self.RegisterForAnimationEvent(Game.getPlayer() as ObjectReference, "WeaponFire")
	Else
		Self.RegisterForDistanceLessThanEvent(Self as ScriptObject, Game.getPlayer() as ScriptObject, InteriorFleeRadius as float)
	EndIf
	Self.SpawnCritters(BirdCount)
EndEvent

Event OnInit()
	If (!Self.GetParentCell().IsLoaded())
		bInitialSpawnComplete = True
	EndIf
EndEvent

Function SpawnCritters(int aiCount)
	If (BirdBase)
		int I = 1
		While (I < aiCount + 1)
			Self.spawnBird("CritterPerch0" + I as string)
			I += 1
		EndWhile
	EndIf
EndFunction

Function Delete()
	Self.SendCustomEvent("simsettlementsv2:objectreferences:birdspawner_flee", None)
	Parent.Delete()
EndFunction

;-- State -------------------------------------------
State DoNothing

	Event OnTriggerEnter(ObjectReference akActionRef)
		; Empty function
	EndEvent

	Event OnDistanceLessThan(ObjectReference akObj1, ObjectReference akObj2, float afDistance)
		; Empty function
	EndEvent

	Event OnAnimationEvent(ObjectReference akSource, string asEventName)
		; Empty function
	EndEvent

	Event OnDistanceGreaterThan(ObjectReference akObj1, ObjectReference akObj2, float afDistance)
		; Empty function
	EndEvent

	Event OnTriggerLeave(ObjectReference akActionRef)
		; Empty function
	EndEvent
EndState
