;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\BreweryBoiler.psc
Modified : 2020-08-19 14:43:46
Compiled : 2021-01-07 11:40:33
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:BreweryBoiler extends ObjectReference

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const
	simsettlementsv2:quests:brewerymanager Property BreweryManager Auto Const
EndGroup

Group Assets
	Container Property BoilerContainerForm Auto Const
	{ Container that only accepts potions }
	Keyword Property MashKeyword Auto Const
EndGroup

Group Messages
	Message Property WortCooking Auto Const
	{ Message telling player the wort is still cooking }
	Message Property MashNeeded Auto Const
	{ Message telling player they need to prepare a mash }
	Message Property MashFirst Auto Const
	{ Message telling player to add a mash }
	Message Property AidItemsOnly Auto Const
	{ Message telling player to add aid items }
	Message Property BitternessHopping Auto Const
	{ Message asking the player if they'd like to add a hopping for bitterness }
	Message Property FlavorHopping Auto Const
	{ Message asking the player if they'd like to add a hopping for flavor }
	Message Property AromaHopping Auto Const
	{ Message asking the player if they'd like to add a hopping for aroma }
	Message Property ExtraHopping Auto Const
	{ Message asking the player if they'd like to add a little something extra }
	Message Property CloseTheContainer Auto Const
	{ Message telling the player to close the boiler lid to start the process }
EndGroup

bool Property bIsWortCooking
	bool Function Get()
		return BreweryManager.IsWortCooking(plotRef)
	EndFunction
EndProperty

;-- Variables ---------------------------------------
simsettlementsv2:objectreferences:simplot plotRef
ObjectReference containerRef
bool bPlayerIsAddingMash = False
bool bPlayerIsAddingFlavoring1 = False
bool bPlayerIsAddingFlavoring4 = False
bool bPlayerIsAddingFlavoring3 = False
bool bPlayerIsAddingFlavoring2 = False

;-- Functions ---------------------------------------

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
	If (asMenuName == "ContainerMenu" && !abOpening)
		Self.UnRegisterForMenuOpenCloseEvent("ContainerMenu")
		If (BreweryManager.StartBrew(plotRef, containerRef))
			Self.ShowWortCookTimeRemaining()
		Else
			MashNeeded.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		EndIf
	EndIf
EndEvent

Event ObjectReference.OnItemAdded(ObjectReference akTriggerRef, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	If (aiItemCount > 1)
		akTriggerRef.RemoveItem(akBaseItem, aiItemCount - 1, False, akSourceContainer)
	EndIf
	If (akTriggerRef.GetItemCount(None) > 5)
		akTriggerRef.RemoveItem(akBaseItem, akTriggerRef.GetItemCount(None) - 5, False, akSourceContainer)
		return 
	EndIf
	If (bPlayerIsAddingMash)
		If (!akBaseItem.HasKeyword(MashKeyword))
			akTriggerRef.RemoveItem(akBaseItem, -1, False, akSourceContainer)
			MashFirst.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
			return 
		EndIf
		bPlayerIsAddingMash = False
		bPlayerIsAddingFlavoring1 = True
		BitternessHopping.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		return 
	ElseIf (!akBaseItem as Potion)
		akTriggerRef.RemoveItem(akBaseItem, -1, False, akSourceContainer)
		AidItemsOnly.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		return 
	EndIf
	If (bPlayerIsAddingFlavoring1)
		bPlayerIsAddingFlavoring1 = False
		bPlayerIsAddingFlavoring2 = True
		FlavorHopping.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		return 
	EndIf
	If (bPlayerIsAddingFlavoring2)
		bPlayerIsAddingFlavoring2 = False
		bPlayerIsAddingFlavoring3 = True
		AromaHopping.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		return 
	EndIf
	If (bPlayerIsAddingFlavoring3)
		bPlayerIsAddingFlavoring3 = False
		bPlayerIsAddingFlavoring4 = True
		ExtraHopping.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		return 
	EndIf
	If (bPlayerIsAddingFlavoring4)
		bPlayerIsAddingFlavoring4 = False
		CloseTheContainer.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	EndIf
EndEvent

Function ShowWortCookTimeRemaining()
	float fTimeRemaining = BreweryManager.fWortTime - (Utility.GetCurrentGameTime() - BreweryManager.fWortBoilStarted[BreweryManager.GetBreweryIndex(plotRef)]) * 24 as float
	fTimeRemaining = Math.Ceiling(fTimeRemaining) as float
	If (fTimeRemaining < 1 as float)
		fTimeRemaining = 1
	EndIf
	WortCooking.Show(fTimeRemaining, 0, 0, 0, 0, 0, 0, 0, 0)
EndFunction

Event OnLoad()
	If (!plotRef)
		Utility.Wait(2)
		plotRef = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, BreweryManager.StageItemLinkKeyword)
		If (plotRef != None)
			BreweryManager.RegisterBrewery(plotRef)
		EndIf
	EndIf
	If (!containerRef)
		containerRef = Self.PlaceAtMe(BoilerContainerForm as Form, 1, False, False, True)
	EndIf
	bPlayerIsAddingMash = False
	bPlayerIsAddingFlavoring1 = False
	bPlayerIsAddingFlavoring2 = False
	bPlayerIsAddingFlavoring3 = False
	bPlayerIsAddingFlavoring4 = False
EndEvent

Function Delete()
	plotRef = None
	Self.UnRegisterForRemoteEvent(containerRef as ScriptObject, "OnItemAdded")
	Self.UnRegisterForMenuOpenCloseEvent("ContainerMenu")
	containerRef.Delete()
	containerRef = None
	Parent.Delete()
EndFunction

Event OnUnload()
	Self.UnRegisterForRemoteEvent(containerRef as ScriptObject, "OnItemAdded")
	Self.UnRegisterForMenuOpenCloseEvent("ContainerMenu")
EndEvent

Event OnActivate(ObjectReference akActivatedBy)
	Actor PlayerRef = Game.GetPlayer()
	If (akActivatedBy == PlayerRef as ObjectReference)
		If (!Self.bIsWortCooking)
			If (PlayerRef.GetItemCount(MashKeyword as Form) > 0)
				bPlayerIsAddingMash = True
				Self.AddInventoryEventFilter(None)
				Self.RegisterForRemoteEvent(containerRef as ScriptObject, "OnItemAdded")
				Self.RegisterForMenuOpenCloseEvent("ContainerMenu")
				containerRef.SetActorRefOwner(PlayerRef, False)
				containerRef.Activate(PlayerRef as ObjectReference, False)
			Else
				MashNeeded.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
			EndIf
		Else
			Self.ShowWortCookTimeRemaining()
		EndIf
	EndIf
EndEvent
