;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\ElevatorMasterAlternate.psc
Modified : 2021-03-07 23:29:41
Compiled : 2021-03-07 23:31:28
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:ElevatorMasterAlternate extends ObjectReference hidden conditional

;-- Properties --------------------------------------
Group Required_Properties
	bool Property bStartAtTop = True Auto
	{ If TRUE(DEFAULT) then this elevator is starting at the top. }
	float Property TimeTakenToMove = 4 Auto
	{ The time, in seconds, it takes for the elevator to move from point A to B. }
EndGroup

Group MultiCell_Properties
	Message Property Menu_ElevatorSelect Auto Const mandatory
	int Property iMenuIndex_LocalCellUpperFloor = 0 Auto Const
	{ The menu index of the upper floor this elevator goes to in the current cell }
	int Property iMenuIndex_LocalCellLowerFloor = 1 Auto Const
	{ The menu index of the lower floor this elevator goes to in the current cell }
	ObjectReference[] Property FloorTargets Auto Const mandatory
	{ Each entry should match one of the indexes in your Menu_ElevatorSelect. For the local cell floors of this button, leave None entries for those. The other targets should point to ElevatorMasterAlternate rigged up in a position the player can be teleported to. See our GNN Basement cell in chapter 2 for an example. }
EndGroup

Group Optional_Properties
	int Property bottomFloor = -99 Auto Const
	{ Bottom floor number, which tells the announcer what to say when thish floor is reached (Default = -99, which just makes a garbled "BBBzzzttt Floor!") }
	int Property upperFloor = -99 Auto Const
	{ Top floor number, which tells the announcer what to say when thish floor is reached (Default = -99, which just makes a garbled "BBBzzzttt Floor!") }
	bool Property bStartDeactivated = False Auto
	{ Whether this elevator starts "off" or not. }
	Message Property DeactivatedMessage Auto
	{ Message that shows up when any elevator button is pressed while it's deactivated. }
	bool Property CloseInnerDoor = True Auto
	{ Inner door closes by default. Set this to FALSE to keep it from closing at all. }
	bool Property ignoreOuterDoorAActivation = False Auto
	{ Activating elevator doors calls them by default. Set this to TRUE to ignore player activation of the upper door if it needs to be handled differently. }
	bool Property ignoreOuterDoorBActivation = False Auto
	{ Activating elevator doors calls them by default. Set this to TRUE to ignore player activation of the lower door if it needs to be handled differently. }
EndGroup

Group No_Touchy collapsedonref
	Keyword Property LinkCustom01 Auto
	Keyword Property LinkCustom02 Auto
	Keyword Property LinkCustom03 Auto
	Keyword Property LinkCustom04 Auto
	Keyword Property LinkCustom05 Auto
	Keyword Property LinkCustom06 Auto
	Keyword Property LinkCustom07 Auto
	Keyword Property LinkCustom08 Auto
	Keyword Property LinkCustom09 Auto
	Sound Property ElevatorLoop Auto
	Sound Property ElevatorDing Auto
	Sound Property ElevatorDoorOpen Auto
	Sound Property ElevatorDoorClose Auto
	Sound Property ElevatorCallButtonClick Auto
	ActorValue Property elevatorDestinationFloor Auto hidden
	Scene Property elevatorFloorAnnounceScene Auto Const
	Scene Property elevatorGoingUpDownScene Auto Const
	Quest Property DNMasterQuest Auto Const
	ReferenceAlias Property elevatorAlias Auto Const
	GlobalVariable Property LoadElevatorDown Auto Const mandatory
	{ SS2 Addition - this ensures the up down scene actually plays correctly }
EndGroup

bool Property bElevatorIsMoving = False Auto conditional hidden
bool Property bElevatorIsAtTop = False Auto conditional hidden
bool Property bHasAlreadyLoaded = False Auto hidden
bool Property bBeingActivated = False Auto hidden
int Property iCurrentFloor = 0 Auto hidden
int Property iTargetFloorIndex = 0 Auto hidden

;-- Variables ---------------------------------------
int ElevatorLoopInstance

;-- Functions ---------------------------------------

Function MoveElevatorMeterHandler(ObjectReference Meter1, ObjectReference Meter2)
	Meter1.PlayAnimation("Play01")
	Meter2.PlayAnimation("Play02")
EndFunction

Function MakeElevatorNonFunctional()
	ObjectReference CallButtonA = Self.GetLinkedRef(LinkCustom02)
	ObjectReference CallButtonB = Self.GetLinkedRef(LinkCustom03)
	ObjectReference InnerMeter = Self.GetLinkedRef(LinkCustom07)
	ObjectReference InnerMeterLinkRef = InnerMeter.GetLinkedRef(None)
	ObjectReference OuterMeterA = Self.GetLinkedRef(LinkCustom08)
	ObjectReference OuterMeterB = Self.GetLinkedRef(LinkCustom09)
	ObjectReference PlatformHelper = Self.GetLinkedRef(None)
	bStartDeactivated = True
	If (InnerMeter != None)
		InnerMeter.PlayAnimation("StartOff")
	EndIf
	If (CallButtonA != None)
		CallButtonA.PlayAnimation("StartOff")
	EndIf
	If (CallButtonB != None)
		CallButtonB.PlayAnimation("StartOff")
	EndIf
	If (InnerMeterLinkRef != None)
		InnerMeterLinkRef.PlayAnimation("StartOff")
	EndIf
	If (bStartAtTop)
		If (OuterMeterA != None)
			OuterMeterA.PlayAnimation("StartOff")
		EndIf
	ElseIf (OuterMeterB != None)
		OuterMeterB.PlayAnimation("StartOff")
	EndIf
	bHasAlreadyLoaded = True
	PlatformHelper.SetAnimationVariableFloat("fspeed", TimeTakenToMove)
EndFunction

Function MakeElevatorFunctional()
	ObjectReference CallButtonA = Self.GetLinkedRef(LinkCustom02)
	ObjectReference CallButtonB = Self.GetLinkedRef(LinkCustom03)
	ObjectReference InnerMeter = Self.GetLinkedRef(LinkCustom07)
	ObjectReference InnerMeterLinkRef = InnerMeter.GetLinkedRef(None)
	ObjectReference OuterMeterA = Self.GetLinkedRef(LinkCustom08)
	ObjectReference OuterMeterB = Self.GetLinkedRef(LinkCustom09)
	ObjectReference PlatformHelper = Self.GetLinkedRef(None)
	bStartDeactivated = False
	If (InnerMeter != None)
		InnerMeter.PlayAnimation("StartOn")
	EndIf
	If (CallButtonA != None)
		CallButtonA.PlayAnimation("Play02")
	EndIf
	If (CallButtonB != None)
		CallButtonB.PlayAnimation("Play02")
	EndIf
	If (InnerMeterLinkRef != None)
		InnerMeterLinkRef.PlayAnimation("StartOn")
	EndIf
	If (bStartAtTop)
		If (OuterMeterA != None)
			OuterMeterA.PlayAnimation("StartOn")
		EndIf
	ElseIf (OuterMeterB != None)
		OuterMeterB.PlayAnimation("StartOn")
	EndIf
	bHasAlreadyLoaded = True
	PlatformHelper.SetAnimationVariableFloat("fspeed", TimeTakenToMove)
EndFunction

Event ObjectReference.OnCellLoad(ObjectReference akLoadedRef)
	Self.UnregisterForRemoteEvent(akLoadedRef as ScriptObject, "OnCellLoad")
	SimSettlementsV2:ObjectReferences:ElevatorMasterAlternate asElevatorMaster = akLoadedRef as SimSettlementsV2:ObjectReferences:ElevatorMasterAlternate
	If (asElevatorMaster)
		Utility.Wait(0.1)
		Sound.StopInstance(ElevatorLoopInstance)
		bool bMoveElevator = False
		If (asElevatorMaster != None)
			If (asElevatorMaster.iMenuIndex_LocalCellUpperFloor != asElevatorMaster.iMenuIndex_LocalCellLowerFloor)
				If (asElevatorMaster.iMenuIndex_LocalCellUpperFloor == iTargetFloorIndex)
					If (!asElevatorMaster.bElevatorIsAtTop)
						bMoveElevator = True
					EndIf
				ElseIf (asElevatorMaster.bElevatorIsAtTop)
					bMoveElevator = True
				EndIf
			EndIf
		EndIf
		If (bMoveElevator)
			asElevatorMaster.ElevatorSetupFunction()
			If (asElevatorMaster.bElevatorIsAtTop)
				asElevatorMaster.HandleElevatorActivation(asElevatorMaster.GetLinkedRef(LinkCustom03))
			Else
				asElevatorMaster.HandleElevatorActivation(asElevatorMaster.GetLinkedRef(LinkCustom02))
			EndIf
		Else
			asElevatorMaster.ToggleElevatorDoorsAtCurrentFloor(True, True)
		EndIf
	EndIf
EndEvent

Function MoveElevatorDoorHandler(ObjectReference DoorRef)
	Self.HandleElevatorDoor(DoorRef, 1 as bool)
	Self.HandleElevatorDoor(DoorRef, 1 as bool)
EndFunction

Function HandleElevatorActivation(ObjectReference akFromObject)
	Debug.TraceStack(Self as string + " HandleElevatorActivation called from " + akFromObject as string, 0)
	Self.GoToState("Busy")
	ObjectReference CallButtonA = Self.GetLinkedRef(LinkCustom02)
	ObjectReference CallButtonB = Self.GetLinkedRef(LinkCustom03)
	ObjectReference OuterMeterA = Self.GetLinkedRef(LinkCustom08)
	ObjectReference OuterMeterB = Self.GetLinkedRef(LinkCustom09)
	ObjectReference OuterDoorA = Self.GetLinkedRef(LinkCustom04)
	ObjectReference OuterDoorB = Self.GetLinkedRef(LinkCustom05)
	ObjectReference InnerDoor = Self.GetLinkedRef(LinkCustom06)
	ObjectReference InnerDoorLinkRef = None
	If (InnerDoor != None)
		InnerDoorLinkRef = InnerDoor.GetLinkedRef(None)
	EndIf
	ObjectReference InnerMeter = Self.GetLinkedRef(LinkCustom07)
	ObjectReference InnerMeterLinkRef = None
	If (InnerMeter != None)
		InnerMeterLinkRef = InnerMeter.GetLinkedRef(None)
	EndIf
	ObjectReference ElevatorPanel = Self.GetLinkedRef(LinkCustom01)
	ObjectReference ElevatorPanelLinkRef = None
	If (ElevatorPanel != None)
		ElevatorPanelLinkRef = ElevatorPanel.GetLinkedRef(None)
	EndIf
	bool bIgnoreDoorActivation = False
	If (OuterDoorA != None && akFromObject == OuterDoorA && Math.ABS(OuterDoorA.GetHeadingAngle(Game.GetPlayer() as ObjectReference)) < 90 as float)
		bIgnoreDoorActivation = True
		OuterDoorA.SetOpen(True)
	EndIf
	If (OuterDoorB != None && akFromObject == OuterDoorB && Math.ABS(OuterDoorB.GetHeadingAngle(Game.GetPlayer() as ObjectReference)) < 90 as float)
		bIgnoreDoorActivation = True
		OuterDoorB.SetOpen(True)
	EndIf
	If (!bStartDeactivated && !bIgnoreDoorActivation)
		If (!bElevatorIsMoving && !bBeingActivated)
			Self.BlockAllButtons(True)
			bBeingActivated = True
			If (elevatorAlias != None)
				elevatorAlias.clear()
				elevatorAlias.forceRefTo(Self as ObjectReference)
			EndIf
			If (akFromObject == ElevatorPanel || akFromObject == ElevatorPanelLinkRef)
				If (bElevatorIsAtTop)
					iCurrentFloor = iMenuIndex_LocalCellUpperFloor
				Else
					iCurrentFloor = iMenuIndex_LocalCellLowerFloor
				EndIf
				int iConfirm = Menu_ElevatorSelect.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
				If (iConfirm == iCurrentFloor)
					Self.ToggleElevatorDoorsAtCurrentFloor(True, False)
				ElseIf (iConfirm == iMenuIndex_LocalCellUpperFloor || iConfirm == iMenuIndex_LocalCellLowerFloor)
					Self.GetLinkedRef(None).SetAnimationVariableFloat("fspeed", TimeTakenToMove)
					If (ElevatorPanel != None)
						ElevatorPanel.PlayAnimation("Play01")
					EndIf
					If (ElevatorPanelLinkRef != None)
						ElevatorPanelLinkRef.PlayAnimation("Play01")
					EndIf
					If (OuterDoorA != None)
						Self.HandleElevatorDoor(OuterDoorA, 0 as bool)
					EndIf
					If (OuterDoorB != None)
						Self.HandleElevatorDoor(OuterDoorB, 0 as bool)
					EndIf
					If (InnerDoor != None)
						Self.HandleElevatorDoor(InnerDoor, 0 as bool)
					EndIf
					If (InnerDoorLinkRef != None)
						Self.HandleElevatorDoor(InnerDoorLinkRef, 0 as bool)
					EndIf
					Utility.Wait(0.5)
					Self.MoveElevator(1 as bool)
				ElseIf (iConfirm != iCurrentFloor)
					iTargetFloorIndex = iConfirm
					Self.ToggleElevatorDoorsAtCurrentFloor(False, False)
					ObjectReference TargetFloor = FloorTargets[iConfirm]
					If (TargetFloor != None)
						InnerMeter.PlayAnimation("Play01")
						If (InnerMeterLinkRef != None)
							InnerMeterLinkRef.PlayAnimation("Play01")
						EndIf
						If (OuterMeterA != None)
							OuterMeterA.PlayAnimation("Play01")
						EndIf
						If (OuterMeterB != None)
							OuterMeterB.PlayAnimation("Play01")
						EndIf
						If (InnerDoor != None)
							Sound.StopInstance(ElevatorLoopInstance)
							ElevatorLoopInstance = ElevatorLoop.play(InnerDoor)
							Sound.SetInstanceVolume(ElevatorLoopInstance, 1 as float)
						EndIf
						If (elevatorAlias != None)
							elevatorAlias.clear()
							elevatorAlias.forceRefTo(Self as ObjectReference)
						EndIf
						If (iTargetFloorIndex < iMenuIndex_LocalCellUpperFloor)
							LoadElevatorDown.SetValueInt(0)
						Else
							LoadElevatorDown.SetValueInt(1)
						EndIf
						elevatorGoingUpDownScene.start()
						Utility.Wait(0.2)
						ElevatorPanel.PlayAnimation("Play01")
						If (ElevatorPanelLinkRef != None)
							ElevatorPanelLinkRef.PlayAnimation("Play01")
						EndIf
						Utility.Wait(4)
						If (InnerMeter != None)
							InnerMeter.PlayAnimation("Play02")
						EndIf
						If (InnerMeterLinkRef != None)
							InnerMeterLinkRef.PlayAnimation("Play02")
						EndIf
						ElevatorPanel.PlayAnimation("Play02")
						If (ElevatorPanelLinkRef != None)
							ElevatorPanelLinkRef.PlayAnimation("Play02")
						EndIf
						If (!bElevatorIsAtTop)
							Self.MoveElevatorMeterHandler(OuterMeterA, OuterMeterB)
						Else
							Self.MoveElevatorMeterHandler(OuterMeterB, OuterMeterA)
						EndIf
						Self.RegisterForRemoteEvent(TargetFloor as ScriptObject, "OnCellLoad")
						Game.GetPlayer().MoveTo(TargetFloor, 0, 0, 0, True)
						Utility.Wait(0.1)
					EndIf
				EndIf
			ElseIf (akFromObject == CallButtonA || akFromObject == OuterDoorA && !bStartDeactivated)
				ObjectReference kLinkedRef = Self.GetLinkedRef(None)
				If (kLinkedRef != None)
					kLinkedRef.SetAnimationVariableFloat("fspeed", TimeTakenToMove / 2 as float)
				EndIf
				If (CallButtonA != None)
					CallButtonA.PlayAnimation("Play01")
					int ElevatorCallButtonClickInstance = ElevatorCallButtonClick.play(CallButtonA)
					Sound.SetInstanceVolume(ElevatorCallButtonClickInstance, 1 as float)
				EndIf
				If (bElevatorIsAtTop)
					Utility.Wait(0.5)
					If (CallButtonA != None)
						CallButtonA.PlayAnimation("Play01")
					EndIf
					If (OuterDoorA != None)
						Self.HandleElevatorDoor(OuterDoorA, 1 as bool)
					EndIf
					Utility.Wait(Utility.RandomFloat(0.1, 0.3))
					If (InnerDoorLinkRef == None)
						If (InnerDoor != None)
							Self.HandleElevatorDoor(InnerDoor, 1 as bool)
						EndIf
					Else
						Self.HandleElevatorDoor(InnerDoorLinkRef, 1 as bool)
					EndIf
					bBeingActivated = False
					Self.BlockAllButtons(False)
				Else
					If (OuterDoorA != None)
						Self.HandleElevatorDoor(OuterDoorA, 0 as bool)
					EndIf
					Utility.Wait(Utility.RandomFloat(0.1, 0.3))
					If (OuterDoorB != None)
						Self.HandleElevatorDoor(OuterDoorB, 0 as bool)
					EndIf
					If (InnerDoor != None)
						Self.HandleElevatorDoor(InnerDoor, 0 as bool)
					EndIf
					If (InnerDoorLinkRef != None)
						Self.HandleElevatorDoor(InnerDoorLinkRef, 0 as bool)
					EndIf
					Utility.Wait(0.5)
					Self.MoveElevator(0 as bool)
					If (CallButtonA != None)
						CallButtonA.PlayAnimation("Play01")
					EndIf
				EndIf
			ElseIf (akFromObject == CallButtonB || akFromObject == OuterDoorB && !bStartDeactivated)
				ObjectReference klinkedref = Self.GetLinkedRef(None)
				If (klinkedref != None)
					klinkedref.SetAnimationVariableFloat("fspeed", TimeTakenToMove / 2 as float)
				EndIf
				If (CallButtonB != None)
					CallButtonB.PlayAnimation("Play01")
					int elevatorcallbuttonclickinstance = ElevatorCallButtonClick.play(CallButtonB)
					Sound.SetInstanceVolume(elevatorcallbuttonclickinstance, 1 as float)
				EndIf
				If (!bElevatorIsAtTop)
					Utility.Wait(0.5)
					If (CallButtonB != None)
						CallButtonB.PlayAnimation("Play01")
					EndIf
					If (OuterDoorB != None)
						Self.HandleElevatorDoor(OuterDoorB, 1 as bool)
					EndIf
					Utility.Wait(Utility.RandomFloat(0.1, 0.3))
					If (InnerDoor != None)
						Self.HandleElevatorDoor(InnerDoor, 1 as bool)
					EndIf
					bBeingActivated = False
					Self.BlockAllButtons(False)
				Else
					If (OuterDoorA != None)
						Self.HandleElevatorDoor(OuterDoorA, 0 as bool)
					EndIf
					Utility.Wait(Utility.RandomFloat(0.1, 0.3))
					If (OuterDoorB != None)
						Self.HandleElevatorDoor(OuterDoorB, 0 as bool)
					EndIf
					If (InnerDoor != None)
						Self.HandleElevatorDoor(InnerDoor, 0 as bool)
					EndIf
					If (InnerDoorLinkRef != None)
						Self.HandleElevatorDoor(InnerDoorLinkRef, 0 as bool)
					EndIf
					Utility.Wait(0.5)
					Self.MoveElevator(0 as bool)
					If (CallButtonB != None)
						CallButtonB.PlayAnimation("Play01")
					EndIf
				EndIf
			EndIf
		EndIf
	ElseIf (bStartDeactivated)
		DeactivatedMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	EndIf
	If (bIgnoreDoorActivation)
		bIgnoreDoorActivation = False
	EndIf
	If (!bElevatorIsMoving)
		Self.GoToState("")
	EndIf
EndFunction

Function HandleElevatorDoor(ObjectReference akDoor, bool bOpen)
	ObjectReference InnerDoor = Self.GetLinkedRef(LinkCustom06)
	If (bOpen)
		If (akDoor.GetOpenState() >= 3)
			akDoor.SetOpen(True)
		EndIf
	ElseIf (akDoor.GetOpenState() <= 2)
		If (akDoor == InnerDoor && !CloseInnerDoor)
			
		Else
			akDoor.SetOpen(False)
		EndIf
	EndIf
EndFunction

Function ElevatorSetupFunction()
	ObjectReference CallButtonA = Self.GetLinkedRef(LinkCustom02)
	ObjectReference CallButtonB = Self.GetLinkedRef(LinkCustom03)
	ObjectReference OuterDoorA = Self.GetLinkedRef(LinkCustom04)
	ObjectReference OuterDoorB = Self.GetLinkedRef(LinkCustom05)
	ObjectReference ElevatorPanel = Self.GetLinkedRef(LinkCustom01)
	Self.GoToState("AlreadyLoaded")
	If (ElevatorPanel != None)
		Self.RegisterForRemoteEvent(ElevatorPanel as ScriptObject, "OnActivate")
		If (ElevatorPanel.GetLinkedRef(None))
			Self.RegisterForRemoteEvent(ElevatorPanel.GetLinkedRef(None) as ScriptObject, "OnActivate")
		EndIf
	EndIf
	If (CallButtonA != None)
		Self.RegisterForRemoteEvent(CallButtonA as ScriptObject, "OnActivate")
	EndIf
	If (OuterDoorA != None)
		OuterDoorA.BlockActivation(True, False)
		If (!ignoreOuterDoorAActivation)
			Self.RegisterForRemoteEvent(OuterDoorA as ScriptObject, "OnActivate")
			Self.RegisterForRemoteEvent(OuterDoorA as ScriptObject, "OnOpen")
			Self.RegisterForRemoteEvent(OuterDoorA as ScriptObject, "OnClose")
		EndIf
	EndIf
	If (CallButtonB != None)
		Self.RegisterForRemoteEvent(CallButtonB as ScriptObject, "OnActivate")
	EndIf
	If (OuterDoorB != None)
		OuterDoorB.BlockActivation(True, False)
		If (!ignoreOuterDoorBActivation)
			Self.RegisterForRemoteEvent(OuterDoorB as ScriptObject, "OnActivate")
			Self.RegisterForRemoteEvent(OuterDoorB as ScriptObject, "OnOpen")
			Self.RegisterForRemoteEvent(OuterDoorB as ScriptObject, "OnClose")
			Debug.trace("Registering OuterDoorB", 0)
		EndIf
	EndIf
	If (!bHasAlreadyLoaded)
		ObjectReference InnerDoor = Self.GetLinkedRef(LinkCustom06)
		ObjectReference InnerMeter = Self.GetLinkedRef(LinkCustom07)
		ObjectReference InnerMeterLinkRef = InnerMeter.GetLinkedRef(None)
		If (!bStartDeactivated)
			If (!InnerMeter.Is3DLoaded())
				InnerMeter.Waitfor3dLoad()
			EndIf
			InnerMeter.PlayAnimation("StartOn")
			If (!CloseInnerDoor)
				If (!InnerDoor.Is3DLoaded())
					InnerDoor.Waitfor3dLoad()
				EndIf
				InnerDoor.SetOpen(True)
			EndIf
			If (OuterDoorA != None)
				OuterDoorA.BlockActivation(True, False)
			EndIf
			If (OuterDoorB != None)
				OuterDoorB.BlockActivation(True, False)
			EndIf
		Else
			If (CallButtonA != None)
				CallButtonA.PlayAnimation("StartOff")
			EndIf
			If (CallButtonB != None)
				CallButtonB.PlayAnimation("StartOff")
			EndIf
		EndIf
		If (InnerMeterLinkRef != None)
			If (!bStartDeactivated)
				InnerMeterLinkRef.PlayAnimation("StartOn")
			EndIf
		EndIf
		ObjectReference PlatformHelper = Self.GetLinkedRef(None)
		If (PlatformHelper != None)
			If (bStartAtTop)
				If (!bStartDeactivated)
					Self.GetLinkedRef(LinkCustom08).PlayAnimation("StartOn")
				EndIf
				PlatformHelper.SetAnimationVariableFloat("fspeed", 0 as float)
				PlatformHelper.SetAnimationVariableFloat("fvalue", 1 as float)
				PlatformHelper.PlayAnimation("Play01")
				bElevatorIsAtTop = True
			Else
				If (!bStartDeactivated)
					Self.GetLinkedRef(LinkCustom09).PlayAnimation("StartOn")
				EndIf
				If (!PlatformHelper.Is3DLoaded())
					PlatformHelper.Waitfor3dLoad()
				EndIf
				PlatformHelper.SetAnimationVariableFloat("fspeed", 0 as float)
				PlatformHelper.SetAnimationVariableFloat("fvalue", 0 as float)
				PlatformHelper.PlayAnimation("Play01")
				bElevatorIsAtTop = False
			EndIf
		EndIf
		bHasAlreadyLoaded = True
	EndIf
EndFunction

Event OnUnload()
	Self.UnregisterForDistanceEvents(Self as ScriptObject, Game.GetPlayer() as ScriptObject)
EndEvent

Event ObjectReference.OnClose(ObjectReference akSender, ObjectReference akActionRef)
	ObjectReference OuterDoorA = Self.GetLinkedRef(LinkCustom04)
	ObjectReference OuterDoorB = Self.GetLinkedRef(LinkCustom05)
	If (OuterDoorA != None && akSender == OuterDoorA)
		OuterDoorA.BlockActivation(True, False)
	ElseIf (OuterDoorB != None && akSender == OuterDoorB)
		OuterDoorB.BlockActivation(True, False)
	EndIf
EndEvent

Function BlockAllButtons(bool bShouldBlock)
	ObjectReference ElevatorPanel = Self.GetLinkedRef(LinkCustom01)
	ObjectReference CallButtonA = Self.GetLinkedRef(LinkCustom02)
	ObjectReference CallButtonB = Self.GetLinkedRef(LinkCustom03)
	If (ElevatorPanel != None)
		ElevatorPanel.BlockActivation(bShouldBlock, False)
		If (ElevatorPanel.GetLinkedRef(None))
			ElevatorPanel.GetLinkedRef(None).BlockActivation(True, False)
		EndIf
	EndIf
	If (CallButtonA != None)
		CallButtonA.BlockActivation(bShouldBlock, False)
	EndIf
	If (CallButtonB != None)
		CallButtonB.BlockActivation(bShouldBlock, False)
	EndIf
EndFunction

Event ObjectReference.OnActivate(ObjectReference akSender, ObjectReference akActionRef)
	If (akActionRef == Game.GetPlayer() as ObjectReference)
		Self.HandleElevatorActivation(akSender)
	EndIf
EndEvent

Event ObjectReference.OnOpen(ObjectReference akSender, ObjectReference akActionRef)
	ObjectReference OuterDoorA = Self.GetLinkedRef(LinkCustom04)
	ObjectReference OuterDoorB = Self.GetLinkedRef(LinkCustom05)
	If (OuterDoorA != None && akSender == OuterDoorA)
		OuterDoorA.BlockActivation(True, True)
	ElseIf (OuterDoorB != None && akSender == OuterDoorB)
		OuterDoorB.BlockActivation(True, True)
	EndIf
EndEvent

Function ToggleElevatorDoorsAtCurrentFloor(bool abOpen, bool abPlaySounds)
	bBeingActivated = True
	Self.BlockAllButtons(True)
	ObjectReference OuterDoorA = Self.GetLinkedRef(LinkCustom04)
	ObjectReference OuterDoorB = Self.GetLinkedRef(LinkCustom05)
	ObjectReference InnerDoor = Self.GetLinkedRef(LinkCustom06)
	ObjectReference InnerDoorLinkRef = InnerDoor.GetLinkedRef(None)
	If (abPlaySounds)
		int DingInstanceID = ElevatorDing.play(InnerDoor)
		Sound.SetInstanceVolume(DingInstanceID, 1 as float)
		Utility.Wait(0.5)
		If (elevatorAlias != None)
			elevatorAlias.clear()
			elevatorAlias.forceRefTo(Self as ObjectReference)
		EndIf
		If (bElevatorIsAtTop)
			Self.SetValue(elevatorDestinationFloor, upperFloor as float)
		Else
			Self.SetValue(elevatorDestinationFloor, bottomFloor as float)
		EndIf
		elevatorFloorAnnounceScene.start()
	EndIf
	If (bElevatorIsAtTop)
		If (OuterDoorA != None)
			Self.HandleElevatorDoor(OuterDoorA, (abOpen as int) as bool)
		EndIf
	ElseIf (OuterDoorB != None)
		Self.HandleElevatorDoor(OuterDoorB, (abOpen as int) as bool)
	EndIf
	Utility.Wait(Utility.RandomFloat(0.1, 0.3))
	If (InnerDoor != None)
		Self.HandleElevatorDoor(InnerDoor, (abOpen as int) as bool)
	EndIf
	If (InnerDoorLinkRef != None)
		Self.HandleElevatorDoor(InnerDoorLinkRef, (abOpen as int) as bool)
	EndIf
	bBeingActivated = False
	Self.BlockAllButtons(False)
EndFunction

Function MoveElevatorFloorPlatHandler(int iFloor, int PlatformHelperAnimVar)
	Self.SetValue(elevatorDestinationFloor, iFloor as float)
	ObjectReference PlatformHelper = Self.GetLinkedRef(None)
	If (PlatformHelper != None)
		PlatformHelper.SetAnimationVariableFloat("fvalue", PlatformHelperAnimVar as float)
	EndIf
	bElevatorIsAtTop = PlatformHelperAnimVar as bool
EndFunction

Event OnCellLoad()
	Self.ElevatorSetupFunction()
EndEvent

Function MoveElevator(bool bActivatedFromPanel)
	bElevatorIsMoving = True
	ObjectReference PlatformHelper = Self.GetLinkedRef(None)
	ObjectReference OuterMeterA = Self.GetLinkedRef(LinkCustom08)
	ObjectReference OuterMeterB = Self.GetLinkedRef(LinkCustom09)
	ObjectReference OuterDoorA = Self.GetLinkedRef(LinkCustom04)
	ObjectReference OuterDoorB = Self.GetLinkedRef(LinkCustom05)
	ObjectReference InnerDoor = Self.GetLinkedRef(LinkCustom06)
	ObjectReference InnerMeter = Self.GetLinkedRef(LinkCustom07)
	ObjectReference InnerMeterLinkRef = None
	If (InnerMeter != None)
		InnerMeterLinkRef = InnerMeter.GetLinkedRef(None)
	EndIf
	ObjectReference ElevatorPanel = Self.GetLinkedRef(LinkCustom01)
	ObjectReference ElevatorPanelLinkRef = None
	If (ElevatorPanel != None)
		ElevatorPanelLinkRef = ElevatorPanel.GetLinkedRef(None)
	EndIf
	ObjectReference InnerDoorLinkRef = None
	If (InnerDoor != None)
		InnerDoorLinkRef = InnerDoor.GetLinkedRef(None)
	EndIf
	InnerMeter.PlayAnimation("Play01")
	If (InnerMeterLinkRef != None)
		InnerMeterLinkRef.PlayAnimation("Play01")
	EndIf
	If (OuterMeterA != None)
		OuterMeterA.PlayAnimation("Play01")
	EndIf
	If (OuterMeterB != None)
		OuterMeterB.PlayAnimation("Play01")
	EndIf
	If (InnerDoor != None)
		Sound.StopInstance(ElevatorLoopInstance)
		ElevatorLoopInstance = ElevatorLoop.play(InnerDoor)
		Sound.SetInstanceVolume(ElevatorLoopInstance, 1 as float)
	EndIf
	If (bElevatorIsAtTop)
		LoadElevatorDown.SetValueInt(1)
	Else
		LoadElevatorDown.SetValueInt(0)
	EndIf
	elevatorGoingUpDownScene.start()
	Utility.Wait(0.2)
	If (bElevatorIsAtTop == True)
		Self.MoveElevatorFloorPlatHandler(bottomFloor, 0)
	Else
		Self.MoveElevatorFloorPlatHandler(upperFloor, 1)
	EndIf
	PlatformHelper.PlayAnimationAndWait("Play01", "done")
	Sound.StopInstance(ElevatorLoopInstance)
	If (bActivatedFromPanel)
		If (ElevatorPanel != None)
			ElevatorPanel.PlayAnimation("Play01")
		EndIf
		If (ElevatorPanelLinkRef != None)
			ElevatorPanelLinkRef.PlayAnimation("Play01")
		EndIf
	EndIf
	If (InnerMeter != None)
		InnerMeter.PlayAnimation("Play02")
	EndIf
	If (InnerMeterLinkRef != None)
		InnerMeterLinkRef.PlayAnimation("Play02")
	EndIf
	If (!bElevatorIsAtTop)
		Self.MoveElevatorMeterHandler(OuterMeterA, OuterMeterB)
	Else
		Self.MoveElevatorMeterHandler(OuterMeterB, OuterMeterA)
	EndIf
	int DingInstanceID = ElevatorDing.play(InnerDoor)
	Sound.SetInstanceVolume(DingInstanceID, 1 as float)
	Utility.Wait(0.5)
	elevatorFloorAnnounceScene.start()
	If (!bElevatorIsAtTop)
		Self.MoveElevatorDoorHandler(OuterDoorB)
	Else
		Self.MoveElevatorDoorHandler(OuterDoorA)
	EndIf
	Utility.Wait(Utility.RandomFloat(0.1, 0.3))
	If (!bElevatorIsAtTop)
		Self.MoveElevatorDoorHandler(InnerDoor)
	ElseIf (InnerDoorLinkRef == None)
		Self.MoveElevatorDoorHandler(InnerDoor)
	Else
		Self.MoveElevatorDoorHandler(InnerDoorLinkRef)
	EndIf
	Utility.Wait(1.2)
	Self.BlockAllButtons(False)
	bBeingActivated = False
	bElevatorIsMoving = False
	Self.GoToState("")
EndFunction

;-- State -------------------------------------------
State AlreadyLoaded

	Event OnCellLoad()
		; Empty function
	EndEvent
EndState

;-- State -------------------------------------------
State Busy
EndState
