;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\EmpireData.psc
Modified : 2021-04-03 10:41:29
Compiled : 2021-04-03 11:17:54
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:EmpireData extends WorkshopFramework:Library:ObjectRefs:ProtectedObjectRef
{ Stores all info on a particular empire }

;-- Properties --------------------------------------
Group Controllers
	simsettlementsv2:quests:empiremanager Property EmpireManager Auto Const mandatory
	simsettlementsv2:quests:settlementmanager Property SettlementManager Auto Const mandatory
	workshopparentscript Property WorkshopParent Auto Const mandatory
	workshopframework:workshopresourcemanager Property WSFW_ResourceManager Auto Const mandatory
	simsettlementsv2:datastructures#resourcenetworkforms[] Property NetworkForms Auto Const mandatory
	{ Link together each of the network types' corresponding forms }
EndGroup

Group ActorValues
	ActorValue Property RobotPopulationAV Auto Const mandatory
	ActorValue Property PopulationAV Auto Const mandatory
	ActorValue Property FoodAV Auto Const mandatory
	ActorValue Property WaterAV Auto Const mandatory
	ActorValue Property SafetyAV Auto Const mandatory
	ActorValue Property PowerGeneratedAV Auto Const mandatory
	ActorValue Property MunicipalPowerGenerationAV Auto Const mandatory
	ActorValue Property WSFW_PowerRequiredAV Auto Const mandatory
	ActorValue Property ExtraNeeds_Food Auto Const mandatory
	ActorValue Property ExtraNeeds_Water Auto Const mandatory
	ActorValue Property ExtraNeeds_Safety Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property LocTypeWorkshopSettlement Auto Const mandatory
	Keyword Property WorkshopCaravanKeyword Auto Const mandatory
	Keyword Property WorkshopType02 Auto Const mandatory
	Keyword Property WorkshopType02Vassal Auto Const mandatory
	Keyword Property EmpireCaravanKeyword Auto Const mandatory
	{ Represents a general connection created by our Empire system. This will let us distinguish those created by other mods/systems }
	Keyword Property WorkshopItemKeyword Auto Const mandatory
	Keyword Property CommunicationsNetworkKeyword Auto Const mandatory
	Keyword Property PowerNetworkKeyword Auto Const mandatory
	Keyword Property DefenseNetworkKeyword Auto Const mandatory
	Keyword Property HospitalNetworkKeyword Auto Const mandatory
	Keyword Property CemeteryNetworkKeyword Auto Const mandatory
EndGroup

Group LocRefTypes
	LocationRefType Property PowerTransferL1 Auto Const mandatory
	LocationRefType Property PowerTransferL2 Auto Const mandatory
	LocationRefType Property PowerTransferL3 Auto Const mandatory
	LocationRefType Property CaravanServicesL1 Auto Const mandatory
	LocationRefType Property CaravanServicesL2 Auto Const mandatory
	LocationRefType Property CaravanServicesL3 Auto Const mandatory
	LocationRefType Property DefenseTransferL1 Auto Const mandatory
	LocationRefType Property DefenseTransferL2 Auto Const mandatory
	LocationRefType Property DefenseTransferL3 Auto Const mandatory
EndGroup

bool Property bAllowCommandPost = True Auto hidden
bool Property bAllowCapitalCity = True Auto hidden
bool Property bVaccinesAvailableForDistribution = False Auto hidden
bool Property bPlayerRun = True Auto hidden
Faction Property FactionForm Auto hidden
workshopscript Property CapitalCity Auto hidden
workshopscript Property CommandPost Auto hidden
workshopscript[] Property Cities Auto hidden
workshopscript[] Property Outposts Auto hidden
workshopscript[] Property Vassals Auto hidden
Location[] Property ControlledLocations_Settlements Auto hidden
Location[] Property ControlledLocations_Other Auto hidden

;-- Variables ---------------------------------------
int iEmpireSettlementType_CommandPost = 5 Const
int iEmpireSettlementType_Outpost = 2 Const
bool bSharedResourcesUpdatingBlock = False
bool bResourceNetworksUpdatingBlock = False
int iEmpireSettlementType_City = 1 Const
int iEmpireSettlementType_CapitalCity = 4 Const
int iEmpireSettlementType_Vassal = 3 Const

;-- Functions ---------------------------------------

Function EstablishCapitalCity(workshopscript akWorkshopRef)
	If (!bAllowCapitalCity)
		return 
	EndIf
	int iPreviousType = iEmpireSettlementType_City
	If (!Self.IsSettlementInEmpire(akWorkshopRef))
		EmpireManager.AddWorkshopToEmpire(akWorkshopRef, iEmpireSettlementType_City, Self, None, False)
	Else
		iPreviousType = Self.GetSettlementType(akWorkshopRef)
	EndIf
	CapitalCity = akWorkshopRef
	int I = 0
	While (I < Cities.length)
		Location CityLocation = Cities[I].myLocation
		int iNetworkTypeIndex = 0
		While (iNetworkTypeIndex < NetworkForms.length)
			Location[] linkedLocations = CityLocation.GetAllLinkedLocations(NetworkForms[iNetworkTypeIndex].NetworkKeyword)
			If (linkedLocations.length > 0)
				int j = 0
				While (j < linkedLocations.length)
					If (ControlledLocations_Settlements.find(linkedLocations[j], 0) >= 0)
						Self.ClearEmpireNetwork(CityLocation, linkedLocations[j], NetworkForms[iNetworkTypeIndex].NetworkKeyword)
						If (NetworkForms[iNetworkTypeIndex].NetworkKeyword == EmpireCaravanKeyword && !Self.HasNormalCaravan(Cities[I].GetWorkshopID(), WorkshopParent.GetWorkshopFromLocation(linkedLocations[j]).GetWorkshopID()))
							Self.ClearEmpireNetwork(CityLocation, linkedLocations[j], WorkshopCaravanKeyword)
						EndIf
					EndIf
					j += 1
				EndWhile
			EndIf
			iNetworkTypeIndex += 1
		EndWhile
		I += 1
	EndWhile
	Self.UpdateResourceNetworks()
	var[] kArgs = new var[0]
	kArgs.add(akWorkshopRef as var, 1)
	kArgs.add(FactionForm as var, 1)
	kArgs.add(bPlayerRun as var, 1)
	kArgs.add(iEmpireSettlementType_CapitalCity as var, 1)
	kArgs.add(iPreviousType as var, 1)
	EmpireManager.SendCustomEvent("simsettlementsv2:quests:empiremanager_SettlementChangedTypeWithinEmpire", kArgs)
EndFunction

int Function GetSettlementType(workshopscript akWorkshopRef)
	If (akWorkshopRef == CapitalCity)
		return iEmpireSettlementType_CapitalCity
	ElseIf (akWorkshopRef == CommandPost)
		return iEmpireSettlementType_CommandPost
	ElseIf (akWorkshopRef.HasKeyword(WorkshopType02))
		return iEmpireSettlementType_Outpost
	ElseIf (akWorkshopRef.HasKeyword(WorkshopType02Vassal))
		return iEmpireSettlementType_Vassal
	Else
		return iEmpireSettlementType_City
	EndIf
EndFunction

Function EstablishCommandPost(workshopscript akWorkshopRef)
	If (!bAllowCommandPost)
		return 
	EndIf
	int iPreviousType = iEmpireSettlementType_Outpost
	If (!Self.IsSettlementInEmpire(akWorkshopRef))
		EmpireManager.AddWorkshopToEmpire(akWorkshopRef, iEmpireSettlementType_Outpost, Self, None, False)
	Else
		iPreviousType = Self.GetSettlementType(akWorkshopRef)
	EndIf
	CapitalCity = akWorkshopRef
	int I = 0
	While (I < Outposts.length)
		Location OutpostLocation = Outposts[I].myLocation
		int iNetworkTypeIndex = 0
		While (iNetworkTypeIndex < NetworkForms.length)
			Location[] linkedLocations = OutpostLocation.GetAllLinkedLocations(NetworkForms[iNetworkTypeIndex].NetworkKeyword)
			If (linkedLocations.length > 0)
				int j = 0
				While (j < linkedLocations.length)
					If (ControlledLocations_Settlements.find(linkedLocations[j], 0) >= 0)
						Self.ClearEmpireNetwork(OutpostLocation, linkedLocations[j], NetworkForms[iNetworkTypeIndex].NetworkKeyword)
						If (NetworkForms[iNetworkTypeIndex].NetworkKeyword == EmpireCaravanKeyword && !Self.HasNormalCaravan(Outposts[I].GetWorkshopID(), WorkshopParent.GetWorkshopFromLocation(linkedLocations[j]).GetWorkshopID()))
							Self.ClearEmpireNetwork(OutpostLocation, linkedLocations[j], WorkshopCaravanKeyword)
						EndIf
					EndIf
					j += 1
				EndWhile
			EndIf
			iNetworkTypeIndex += 1
		EndWhile
		I += 1
	EndWhile
	I = 0
	While (I < Vassals.length)
		Location VassalLocation = Vassals[I].myLocation
		int inetworktypeindex = 0
		While (inetworktypeindex < NetworkForms.length)
			Location[] linkedlocations = VassalLocation.GetAllLinkedLocations(NetworkForms[inetworktypeindex].NetworkKeyword)
			If (linkedlocations.length > 0)
				int j = 0
				While (j < linkedlocations.length)
					If (ControlledLocations_Settlements.find(linkedlocations[j], 0) >= 0)
						Self.ClearEmpireNetwork(VassalLocation, linkedlocations[j], NetworkForms[inetworktypeindex].NetworkKeyword)
						If (NetworkForms[inetworktypeindex].NetworkKeyword == EmpireCaravanKeyword && !Self.HasNormalCaravan(Vassals[I].GetWorkshopID(), WorkshopParent.GetWorkshopFromLocation(linkedlocations[j]).GetWorkshopID()))
							Self.ClearEmpireNetwork(VassalLocation, linkedlocations[j], WorkshopCaravanKeyword)
						EndIf
					EndIf
					j += 1
				EndWhile
			EndIf
			inetworktypeindex += 1
		EndWhile
		I += 1
	EndWhile
	Self.UpdateResourceNetworks()
	var[] kArgs = new var[0]
	kArgs.add(akWorkshopRef as var, 1)
	kArgs.add(FactionForm as var, 1)
	kArgs.add(bPlayerRun as var, 1)
	kArgs.add(iEmpireSettlementType_CommandPost as var, 1)
	kArgs.add(iPreviousType as var, 1)
	EmpireManager.SendSettlementChangedTypeWithinEmpireEvent(akWorkshopRef, FactionForm, bPlayerRun, iEmpireSettlementType_CommandPost, iPreviousType)
EndFunction

bool Function IsLocationInEmpire(Location akLocationRef)
	return ControlledLocations_Settlements.find(akLocationRef, 0) >= 0 || ControlledLocations_Other.find(akLocationRef, 0) >= 0
EndFunction

Function UpdateSharedResources()
	If (bSharedResourcesUpdatingBlock)
		return 
	EndIf
	bSharedResourcesUpdatingBlock = True
	simsettlementsv2:objectreferences:settlementdata[] SettlementDataStores = SettlementManager.SettlementDataStores
	int[] iFoodResults = new int[SettlementDataStores.length]
	int[] iWaterResults = new int[SettlementDataStores.length]
	int[] iPowerResults = new int[SettlementDataStores.length]
	int[] iDefenseResults = new int[SettlementDataStores.length]
	int[] iSharedSurplusFood = new int[SettlementDataStores.length]
	int[] iSharedSurplusWater = new int[SettlementDataStores.length]
	int[] iSharedSurplusPower = new int[SettlementDataStores.length]
	int[] iSharedSurplusDefense = new int[SettlementDataStores.length]
	simsettlementsv2:datastructures#resourcenetwork[] SettlementNetworks = new simsettlementsv2:datastructures#resourcenetwork[0]
	int I = 0
	While (I < SettlementDataStores.length)
		simsettlementsv2:datastructures#resourcenetwork newEntry = new simsettlementsv2:datastructures#resourcenetwork
		SettlementNetworks.add(newEntry, 1)
		I += 1
	EndWhile
	int iCaravanNetworkCounter = -1
	int iPowerNetworkCounter = -1
	int iDefenseNetworkCounter = -1
	int iCommunicationsNetworkCounter = -1
	I = 0
	While (I < SettlementDataStores.length)
		workshopscript thisWorkshop = SettlementDataStores[I].kWorkshopRef
		If (Self.IsSettlementInEmpire(thisWorkshop))
			thisWorkshop.RecalculateWorkshopResources(True)
			float fPopulation = thisWorkshop.GetBaseValue(PopulationAV)
			float fRobotPopulation = thisWorkshop.GetBaseValue(RobotPopulationAV)
			float fLivingPopulation = fPopulation - fRobotPopulation
			If (fLivingPopulation < 0 as float)
				fLivingPopulation = 0
			EndIf
			float fFoodProduction = WSFW_ResourceManager.GetWorkshopValue(thisWorkshop as ObjectReference, FoodAV)
			fFoodProduction += SettlementDataStores[I].iSharedFood as float
			If (fFoodProduction < 0 as float)
				fFoodProduction = 0 as float
			EndIf
			float fWaterProduction = WSFW_ResourceManager.GetWorkshopValue(thisWorkshop as ObjectReference, WaterAV)
			fWaterProduction += SettlementDataStores[I].iSharedWater as float
			If (fWaterProduction < 0 as float)
				fWaterProduction = 0 as float
			EndIf
			Location thisLocation = thisWorkshop.myLocation
			Location[] linkedCaravanLocations = thisLocation.GetAllLinkedLocations(EmpireCaravanKeyword)
			Location[] linkedPowerLocations = thisLocation.GetAllLinkedLocations(PowerNetworkKeyword)
			Location[] linkedDefenseLocations = thisLocation.GetAllLinkedLocations(DefenseNetworkKeyword)
			Location[] linkedCommunicationsLocations = thisLocation.GetAllLinkedLocations(CommunicationsNetworkKeyword)
			bool bCanShareFoodAndWater = linkedCaravanLocations.length > 0
			bool bCanSharePower = linkedPowerLocations.length > 0
			bool bCanShareDefense = linkedDefenseLocations.length > 0
			bool bCanShareCommunications = linkedCommunicationsLocations.length > 0
			If (bCanShareFoodAndWater)
				If (SettlementNetworks[I].iCaravanNetwork < 0)
					iCaravanNetworkCounter += 1
					SettlementNetworks[I].iCaravanNetwork = iCaravanNetworkCounter
					int k = 0
					While (k < linkedCaravanLocations.length)
						workshopscript kLinkedWorkshopRef = WorkshopParent.GetWorkshopFromLocation(linkedCaravanLocations[k])
						SettlementNetworks[kLinkedWorkshopRef.GetWorkshopID()].iCaravanNetwork = iCaravanNetworkCounter
						k += 1
					EndWhile
				EndIf
				float fFoodNeeds = fLivingPopulation + thisWorkshop.GetValue(ExtraNeeds_Food)
				float fWaterNeeds = fLivingPopulation + thisWorkshop.GetValue(ExtraNeeds_Water)
				iFoodResults[I] = Math.Floor(fFoodProduction) - Math.Floor(fFoodNeeds)
				iWaterResults[I] = Math.Floor(fWaterProduction) - Math.Floor(fWaterNeeds)
			Else
				iFoodResults[I] = 0
				iWaterResults[I] = 0
				int iShared = SettlementDataStores[I].iSharedFood
				If (iShared != 0)
					SettlementDataStores[I].SetSharedResource(FoodAV, 0 as float)
					SettlementDataStores[I].iSharedFood = 0
				EndIf
				iShared = SettlementDataStores[I].iSharedWater
				If (iShared != 0)
					SettlementDataStores[I].SetSharedResource(WaterAV, 0 as float)
					SettlementDataStores[I].iSharedWater = 0
				EndIf
			EndIf
			If (bCanSharePower)
				If (SettlementNetworks[I].iPowerNetwork < 0)
					iPowerNetworkCounter += 1
					SettlementNetworks[I].iPowerNetwork = iPowerNetworkCounter
					int k = 0
					While (k < linkedPowerLocations.length)
						workshopscript klinkedworkshopref = WorkshopParent.GetWorkshopFromLocation(linkedPowerLocations[k])
						SettlementNetworks[klinkedworkshopref.GetWorkshopID()].iPowerNetwork = iPowerNetworkCounter
						k += 1
					EndWhile
				EndIf
				float fPowerGenerated = thisWorkshop.GetBaseValue(PowerGeneratedAV) + SettlementDataStores[I].iSharedPower as float
				float fPowerRequired = thisWorkshop.GetBaseValue(WSFW_PowerRequiredAV)
				iPowerResults[I] = Math.Floor(fPowerGenerated) - Math.Floor(fPowerRequired)
			Else
				iPowerResults[I] = 0
				int ishared = SettlementDataStores[I].iSharedPower
				If (ishared != 0)
					SettlementDataStores[I].SetSharedResource(MunicipalPowerGenerationAV, 0 as float)
					SettlementDataStores[I].iSharedPower = 0
				EndIf
			EndIf
			If (bCanShareDefense)
				If (SettlementNetworks[I].iDefenseNetwork < 0)
					iDefenseNetworkCounter += 1
					SettlementNetworks[I].iDefenseNetwork = iDefenseNetworkCounter
					int k = 0
					While (k < linkedDefenseLocations.length)
						workshopscript klinkedworkshopref = WorkshopParent.GetWorkshopFromLocation(linkedDefenseLocations[k])
						SettlementNetworks[klinkedworkshopref.GetWorkshopID()].iDefenseNetwork = iDefenseNetworkCounter
						k += 1
					EndWhile
				EndIf
				float fDefenseProduction = WSFW_ResourceManager.GetWorkshopValue(thisWorkshop as ObjectReference, SafetyAV) + SettlementDataStores[I].iSharedDefense as float
				float fDefenseNeeds = fFoodProduction + fWaterProduction / 2 as float + thisWorkshop.GetValue(ExtraNeeds_Safety)
				iDefenseResults[I] = Math.Floor(fDefenseProduction) - Math.Floor(fDefenseNeeds)
			Else
				iDefenseResults[I] = 0
				int ishared = SettlementDataStores[I].iSharedDefense
				If (ishared != 0)
					SettlementDataStores[I].SetSharedResource(SafetyAV, 0 as float)
					SettlementDataStores[I].iSharedDefense = 0
				EndIf
			EndIf
			If (bCanShareCommunications)
				If (SettlementNetworks[I].iCommunicationsNetwork < 0)
					iCommunicationsNetworkCounter += 1
					SettlementNetworks[I].iCommunicationsNetwork = iCommunicationsNetworkCounter
					int k = 0
					While (k < linkedCommunicationsLocations.length)
						workshopscript klinkedworkshopref = WorkshopParent.GetWorkshopFromLocation(linkedCommunicationsLocations[k])
						SettlementNetworks[klinkedworkshopref.GetWorkshopID()].iCommunicationsNetwork = iCommunicationsNetworkCounter
						k += 1
					EndWhile
				EndIf
			EndIf
		EndIf
		I += 1
	EndWhile
	int iNeedyIndex = 0
	While (iNeedyIndex < SettlementDataStores.length)
		workshopscript thisworkshop = SettlementDataStores[iNeedyIndex].kWorkshopRef
		If (Self.IsSettlementInEmpire(thisworkshop))
			bool bResourceShared = False
			If (iFoodResults[iNeedyIndex] < 0)
				int iproducerindex = 0
				int iFoodToFind = -1 * iFoodResults[iNeedyIndex]
				bool bEnoughFoodAvailable = False
				While (iproducerindex < iFoodResults.length && !bEnoughFoodAvailable)
					If (iFoodResults[iproducerindex] > 0 && SettlementNetworks[iproducerindex].iCaravanNetwork == SettlementNetworks[iNeedyIndex].iCaravanNetwork)
						If (iFoodResults[iproducerindex] >= iFoodToFind)
							bEnoughFoodAvailable = True
						Else
							iFoodToFind -= iFoodResults[iproducerindex]
						EndIf
					EndIf
					iproducerindex += 1
				EndWhile
				If (bEnoughFoodAvailable)
					bResourceShared = True
					SettlementDataStores[iNeedyIndex].iSharedFood = iFoodResults[iNeedyIndex]
					SettlementDataStores[iNeedyIndex].SetSharedResource(FoodAV, Math.Floor((iFoodResults[iNeedyIndex] * -1) as float) as float)
					bool bFoodFound = False
					iproducerindex = 0
					iFoodToFind = -1 * iFoodResults[iNeedyIndex]
					While (iproducerindex < iFoodResults.length && !bFoodFound)
						If (iFoodResults[iproducerindex] > 0 && SettlementNetworks[iproducerindex].iCaravanNetwork == SettlementNetworks[iNeedyIndex].iCaravanNetwork)
							If (iFoodResults[iproducerindex] >= iFoodToFind)
								iSharedSurplusFood[iproducerindex] = iSharedSurplusFood[iproducerindex] + iFoodToFind
								iFoodResults[iproducerindex] = iFoodResults[iproducerindex] - iFoodToFind
								bFoodFound = True
							Else
								iSharedSurplusFood[iproducerindex] = iSharedSurplusFood[iproducerindex] + iFoodResults[iproducerindex]
								iFoodToFind -= iFoodResults[iproducerindex]
								iFoodResults[iproducerindex] = 0
							EndIf
						EndIf
						iproducerindex += 1
					EndWhile
				EndIf
			EndIf
			If (iWaterResults[iNeedyIndex] < 0)
				int iproducerindex = 0
				int iWaterToFind = -1 * iWaterResults[iNeedyIndex]
				bool bEnoughWaterAvailable = False
				While (iproducerindex < iWaterResults.length && !bEnoughWaterAvailable)
					If (iWaterResults[iproducerindex] > 0 && SettlementNetworks[iproducerindex].iCaravanNetwork == SettlementNetworks[iNeedyIndex].iCaravanNetwork)
						If (iWaterResults[iproducerindex] >= iWaterToFind)
							bEnoughWaterAvailable = True
						Else
							iWaterToFind -= iWaterResults[iproducerindex]
						EndIf
					EndIf
					iproducerindex += 1
				EndWhile
				If (bEnoughWaterAvailable)
					bResourceShared = True
					SettlementDataStores[iNeedyIndex].iSharedWater = iWaterResults[iNeedyIndex]
					SettlementDataStores[iNeedyIndex].SetSharedResource(WaterAV, Math.Floor((iWaterResults[iNeedyIndex] * -1) as float) as float)
					bool bWaterFound = False
					iproducerindex = 0
					iWaterToFind = -1 * iWaterResults[iNeedyIndex]
					While (iproducerindex < iWaterResults.length && !bWaterFound)
						If (iWaterResults[iproducerindex] > 0 && SettlementNetworks[iproducerindex].iCaravanNetwork == SettlementNetworks[iNeedyIndex].iCaravanNetwork)
							If (iWaterResults[iproducerindex] >= iWaterToFind)
								iSharedSurplusWater[iproducerindex] = iSharedSurplusWater[iproducerindex] + iWaterToFind
								iWaterResults[iproducerindex] = iWaterResults[iproducerindex] - iWaterToFind
								bWaterFound = True
							Else
								iSharedSurplusWater[iproducerindex] = iSharedSurplusWater[iproducerindex] + iWaterResults[iproducerindex]
								iWaterToFind -= iWaterResults[iproducerindex]
								iWaterResults[iproducerindex] = 0
							EndIf
						EndIf
						iproducerindex += 1
					EndWhile
				EndIf
			EndIf
			If (iPowerResults[iNeedyIndex] < 0)
				int iproducerindex = 0
				int iPowerToFind = -1 * iPowerResults[iNeedyIndex]
				bool bEnoughPowerAvailable = False
				While (iproducerindex < iPowerResults.length && !bEnoughPowerAvailable)
					If (iPowerResults[iproducerindex] > 0 && SettlementNetworks[iproducerindex].iPowerNetwork == SettlementNetworks[iNeedyIndex].iPowerNetwork)
						If (iPowerResults[iproducerindex] >= iPowerToFind)
							bEnoughPowerAvailable = True
						Else
							iPowerToFind -= iPowerResults[iproducerindex]
						EndIf
					EndIf
					iproducerindex += 1
				EndWhile
				If (bEnoughPowerAvailable)
					bResourceShared = True
					SettlementDataStores[iNeedyIndex].iSharedPower = iPowerResults[iNeedyIndex]
					SettlementDataStores[iNeedyIndex].SetSharedResource(MunicipalPowerGenerationAV, Math.Floor((iPowerResults[iNeedyIndex] * -1) as float) as float)
					bool bPowerFound = False
					iproducerindex = 0
					iPowerToFind = -1 * iPowerResults[iNeedyIndex]
					While (iproducerindex < iPowerResults.length && !bPowerFound)
						If (iPowerResults[iproducerindex] > 0 && SettlementNetworks[iproducerindex].iPowerNetwork == SettlementNetworks[iNeedyIndex].iPowerNetwork)
							If (iPowerResults[iproducerindex] >= iPowerToFind)
								iSharedSurplusPower[iproducerindex] = iSharedSurplusPower[iproducerindex] + iPowerToFind
								iPowerResults[iproducerindex] = iPowerResults[iproducerindex] - iPowerToFind
								bPowerFound = True
							Else
								iSharedSurplusPower[iproducerindex] = iSharedSurplusPower[iproducerindex] + iPowerResults[iproducerindex]
								iPowerToFind -= iPowerResults[iproducerindex]
								iPowerResults[iproducerindex] = 0
							EndIf
						EndIf
						iproducerindex += 1
					EndWhile
				EndIf
			EndIf
			If (iDefenseResults[iNeedyIndex] < 0)
				int iproducerindex = 0
				int iDefenseToFind = -1 * iDefenseResults[iNeedyIndex]
				bool bEnoughDefenseAvailable = False
				While (iproducerindex < iDefenseResults.length && !bEnoughDefenseAvailable)
					If (iDefenseResults[iproducerindex] > 0 && SettlementNetworks[iproducerindex].iDefenseNetwork == SettlementNetworks[iNeedyIndex].iDefenseNetwork)
						If (iDefenseResults[iproducerindex] >= iDefenseToFind)
							bEnoughDefenseAvailable = True
						Else
							iDefenseToFind -= iDefenseResults[iproducerindex]
						EndIf
					EndIf
					iproducerindex += 1
				EndWhile
				If (bEnoughDefenseAvailable)
					bResourceShared = True
					SettlementDataStores[iNeedyIndex].iSharedDefense = iDefenseResults[iNeedyIndex]
					SettlementDataStores[iNeedyIndex].SetSharedResource(SafetyAV, Math.Floor((iDefenseResults[iNeedyIndex] * -1) as float) as float)
					bool bDefenseFound = False
					iproducerindex = 0
					iDefenseToFind = -1 * iDefenseResults[iNeedyIndex]
					While (iproducerindex < iDefenseResults.length && !bDefenseFound)
						If (iDefenseResults[iproducerindex] > 0 && SettlementNetworks[iproducerindex].iDefenseNetwork == SettlementNetworks[iNeedyIndex].iDefenseNetwork)
							If (iDefenseResults[iproducerindex] >= iDefenseToFind)
								iSharedSurplusDefense[iproducerindex] = iSharedSurplusDefense[iproducerindex] + iDefenseToFind
								iDefenseResults[iproducerindex] = iDefenseResults[iproducerindex] - iDefenseToFind
								bDefenseFound = True
							Else
								iSharedSurplusDefense[iproducerindex] = iSharedSurplusDefense[iproducerindex] + iDefenseResults[iproducerindex]
								iDefenseToFind -= iDefenseResults[iproducerindex]
								iDefenseResults[iproducerindex] = 0
							EndIf
						EndIf
						iproducerindex += 1
					EndWhile
				EndIf
			EndIf
			If (bResourceShared)
				SettlementDataStores[iNeedyIndex].kWorkshopRef.RecalculateWorkshopResources(True)
			EndIf
		EndIf
		iNeedyIndex += 1
	EndWhile
	int iProducerIndex = 0
	While (iProducerIndex < SettlementDataStores.length)
		workshopscript thisworkshop = SettlementDataStores[iProducerIndex].kWorkshopRef
		If (Self.IsSettlementInEmpire(thisworkshop))
			bool bresourceshared = False
			If (iSharedSurplusFood[iProducerIndex] > 0)
				bresourceshared = True
				SettlementDataStores[iProducerIndex].iSharedFood = iSharedSurplusFood[iProducerIndex]
				SettlementDataStores[iProducerIndex].SetSharedResource(FoodAV, Math.Floor((iSharedSurplusFood[iProducerIndex] * -1) as float) as float)
			EndIf
			If (iSharedSurplusWater[iProducerIndex] > 0)
				bresourceshared = True
				SettlementDataStores[iProducerIndex].iSharedWater = iSharedSurplusWater[iProducerIndex]
				SettlementDataStores[iProducerIndex].SetSharedResource(WaterAV, Math.Floor((iSharedSurplusWater[iProducerIndex] * -1) as float) as float)
			EndIf
			If (iSharedSurplusPower[iProducerIndex] > 0)
				bresourceshared = True
				SettlementDataStores[iProducerIndex].iSharedPower = iSharedSurplusPower[iProducerIndex]
				SettlementDataStores[iProducerIndex].SetSharedResource(MunicipalPowerGenerationAV, Math.Floor((iSharedSurplusPower[iProducerIndex] * -1) as float) as float)
			EndIf
			If (iSharedSurplusDefense[iProducerIndex] > 0)
				bresourceshared = True
				SettlementDataStores[iProducerIndex].iSharedDefense = iSharedSurplusDefense[iProducerIndex]
				SettlementDataStores[iProducerIndex].SetSharedResource(SafetyAV, Math.Floor((iSharedSurplusDefense[iProducerIndex] * -1) as float) as float)
			EndIf
			If (bresourceshared)
				SettlementDataStores[iProducerIndex].kWorkshopRef.RecalculateWorkshopResources(True)
			EndIf
		EndIf
		iProducerIndex += 1
	EndWhile
	bSharedResourcesUpdatingBlock = False
EndFunction

Function BreakOtherEmpireConnections()
	Location[] EmpireLocations = Self.GetEmpireLocations()
	int I = 0
	While (I < EmpireLocations.length)
		int iNetworkTypeIndex = 0
		While (iNetworkTypeIndex < NetworkForms.length)
			Location[] linkedLocations = EmpireLocations[I].GetAllLinkedLocations(NetworkForms[iNetworkTypeIndex].NetworkKeyword)
			If (linkedLocations.length > 0)
				int j = 0
				While (j < linkedLocations.length)
					If (!Self.IsLocationInEmpire(linkedLocations[j]))
						Self.ClearEmpireNetwork(EmpireLocations[I], linkedLocations[j], NetworkForms[iNetworkTypeIndex].NetworkKeyword)
						If (NetworkForms[iNetworkTypeIndex].NetworkKeyword == EmpireCaravanKeyword)
							Self.ClearEmpireNetwork(EmpireLocations[I], linkedLocations[j], WorkshopCaravanKeyword)
						EndIf
					EndIf
					j += 1
				EndWhile
			EndIf
			iNetworkTypeIndex += 1
		EndWhile
		I += 1
	EndWhile
EndFunction

Function AddLocation_InternalOnly(Location akLocationRef)
	bool bAdded = False
	If (akLocationRef.HasKeyword(LocTypeWorkshopSettlement))
		If (ControlledLocations_Settlements.find(akLocationRef, 0) < 0)
			If (ControlledLocations_Settlements == None || ControlledLocations_Settlements.length == 0)
				ControlledLocations_Settlements = new Location[0]
			EndIf
			ControlledLocations_Settlements.add(akLocationRef, 1)
			bAdded = True
		EndIf
	ElseIf (ControlledLocations_Other.find(akLocationRef, 0) < 0)
		If (ControlledLocations_Other == None || ControlledLocations_Other.length == 0)
			ControlledLocations_Other = new Location[0]
		EndIf
		ControlledLocations_Other.add(akLocationRef, 1)
		bAdded = True
	EndIf
	If (bAdded)
		EmpireManager.SendLocationOccupiedEvent(akLocationRef, FactionForm, bPlayerRun)
	EndIf
EndFunction

Function ClearEmpireNetwork(Location akLocationOrigin, Location akLocationDestination, Keyword akNetworkKeyword)
	akLocationOrigin.RemoveLinkedLocation(akLocationDestination, akNetworkKeyword)
	akLocationDestination.RemoveLinkedLocation(akLocationDestination, akNetworkKeyword)
EndFunction

bool Function HasNormalCaravan(int aiOriginWorkshopID, int aiDestinationWorkshopID)
	RefCollectionAlias WorkshopCaravanActors = WorkshopParent.CaravanActorAliases
	int index = 0
	bool bNormalCaravanFound = False
	While (index < WorkshopCaravanActors.GetCount() && !bNormalCaravanFound)
		Actor caravanActor = WorkshopCaravanActors.GetAt(index) as Actor
		If (caravanActor)
			int iActorWorkshop = workshopframework:workshopfunctions.GetWorkshopID(caravanActor as ObjectReference)
			int iActorDestination = workshopframework:workshopfunctions.GetCaravanDestinationID(caravanActor)
			If (iActorWorkshop == aiOriginWorkshopID && iActorDestination == aiDestinationWorkshopID || iActorWorkshop == aiDestinationWorkshopID && iActorDestination == aiOriginWorkshopID)
				bNormalCaravanFound = True
			EndIf
		EndIf
		index += 1
	EndWhile
	return bNormalCaravanFound
EndFunction

Location[] Function GetEmpireLocations()
	Location[] Locations = new Location[0]
	int I = 0
	While (I < ControlledLocations_Settlements.length)
		If (Locations.find(ControlledLocations_Settlements[I], 0) < 0)
			Locations.add(ControlledLocations_Settlements[I], 1)
		EndIf
		I += 1
	EndWhile
	I = 0
	While (I < ControlledLocations_Other.length)
		If (Locations.find(ControlledLocations_Other[I], 0) < 0)
			Locations.add(ControlledLocations_Other[I], 1)
		EndIf
		I += 1
	EndWhile
	return Locations
EndFunction

Function UpdateResourceNetworks()
	If (bResourceNetworksUpdatingBlock)
		return 
	EndIf
	bResourceNetworksUpdatingBlock = True
	Self.BreakOtherEmpireConnections()
	workshopscript[] Workshops = Self.GetEmpireSettlements()
	If (CapitalCity != None && CommandPost != None && CapitalCity != CommandPost)
		Self.StartEmpireNetwork(CapitalCity.myLocation, CommandPost.myLocation, EmpireCaravanKeyword)
	EndIf
	If (CapitalCity != None)
		Location CapitalLocation = CapitalCity.myLocation
		int I = 0
		While (I < Cities.length)
			Location myLocation = Cities[I].myLocation
			int iNetworkTypeIndex = 0
			While (iNetworkTypeIndex < NetworkForms.length)
				bool bHasNetworkCapability = myLocation.HasRefType(NetworkForms[iNetworkTypeIndex].L3RefType) || myLocation.HasRefType(NetworkForms[iNetworkTypeIndex].L2RefType) || myLocation.HasRefType(NetworkForms[iNetworkTypeIndex].L1RefType)
				If (bHasNetworkCapability)
					Self.StartEmpireNetwork(myLocation, CapitalLocation, NetworkForms[iNetworkTypeIndex].NetworkKeyword)
				EndIf
				iNetworkTypeIndex += 1
			EndWhile
			I += 1
		EndWhile
	Else
		int i = 0
		While (i < Workshops.length)
			Location thisLocation = Workshops[i].myLocation
			If (!thisLocation)
				thisLocation = Workshops[i].GetCurrentLocation()
			EndIf
			int iWorkshopID = Workshops[i].GetWorkshopID()
			int inetworktypeindex = 0
			While (inetworktypeindex < NetworkForms.length)
				bool bhasnetworkcapability = thisLocation.HasRefType(NetworkForms[inetworktypeindex].L3RefType) || thisLocation.HasRefType(NetworkForms[inetworktypeindex].L2RefType) || thisLocation.HasRefType(NetworkForms[inetworktypeindex].L1RefType)
				string sTraceMessage = "[EmpireData] Location : " + thisLocation as string + Workshops[i] as string
				If (bhasnetworkcapability)
					sTraceMessage += " has "
				Else
					sTraceMessage += " does not have "
				EndIf
				sTraceMessage += NetworkForms[inetworktypeindex].NetworkKeyword as string + " network connection."
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), sTraceMessage, 0, False)
				Location[] linkedLocations = thisLocation.GetAllLinkedLocations(NetworkForms[inetworktypeindex].NetworkKeyword)
				If (linkedLocations.length > 0)
					int j = 0
					While (j < linkedLocations.length)
						bool bLinkedHasNetworkCapability = linkedLocations[j].HasRefType(NetworkForms[inetworktypeindex].L3RefType) || linkedLocations[j].HasRefType(NetworkForms[inetworktypeindex].L2RefType) || linkedLocations[j].HasRefType(NetworkForms[inetworktypeindex].L1RefType)
						If (NetworkForms[inetworktypeindex].NetworkKeyword == EmpireCaravanKeyword)
							bool bNormalCaravanFound = Self.HasNormalCaravan(iWorkshopID, WorkshopParent.GetWorkshopFromLocation(linkedLocations[j]).GetWorkshopID())
							If (!bNormalCaravanFound && (!bhasnetworkcapability || !bLinkedHasNetworkCapability))
								Self.ClearEmpireNetwork(thisLocation, linkedLocations[j], EmpireCaravanKeyword)
								If (!bNormalCaravanFound)
									Self.ClearEmpireNetwork(thisLocation, linkedLocations[j], WorkshopCaravanKeyword)
								EndIf
							EndIf
						ElseIf (!bhasnetworkcapability || !bLinkedHasNetworkCapability)
							Self.ClearEmpireNetwork(thisLocation, linkedLocations[j], NetworkForms[inetworktypeindex].NetworkKeyword)
						EndIf
						j += 1
					EndWhile
				EndIf
				If (bhasnetworkcapability)
					int j = 0
					While (j < Workshops.length)
						Location otherLocation = Workshops[j].myLocation
						If (j != i && linkedLocations.find(otherLocation, 0) < 0)
							bool bOtherHasNetworkCapability = otherLocation.HasRefType(NetworkForms[inetworktypeindex].L3RefType) || otherLocation.HasRefType(NetworkForms[inetworktypeindex].L2RefType) || otherLocation.HasRefType(NetworkForms[inetworktypeindex].L1RefType)
							If (bOtherHasNetworkCapability && Self.IsWithinNetworkDistance(Workshops[i], Workshops[j], NetworkForms[inetworktypeindex].NetworkKeyword))
								Self.StartEmpireNetwork(thisLocation, otherLocation, NetworkForms[inetworktypeindex].NetworkKeyword)
							EndIf
						EndIf
						j += 1
					EndWhile
				EndIf
				inetworktypeindex += 1
			EndWhile
			i += 1
		EndWhile
	EndIf
	If (CommandPost != None)
		int i = 0
		While (i < Workshops.length)
			int iType = Self.GetSettlementType(Workshops[i])
			If (iType == iEmpireSettlementType_Outpost || iType == iEmpireSettlementType_Vassal)
				Self.StartEmpireNetwork(CommandPost.myLocation, Workshops[i].myLocation, EmpireCaravanKeyword)
			EndIf
			i += 1
		EndWhile
	EndIf
	bResourceNetworksUpdatingBlock = False
EndFunction

bool Function AddSettlement_InternalOnly(workshopscript akWorkshopRef, int aiEmpireSettlementType)
	If (!akWorkshopRef)
		return False
	EndIf
	If (aiEmpireSettlementType == iEmpireSettlementType_CapitalCity || aiEmpireSettlementType == iEmpireSettlementType_CommandPost)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[Empire Manager: EmpireData] To configure a Capital City or Command Post, use EstablishCapitalCity or EstablishCommandPost, respectively.", 0, False)
		return False
	EndIf
	bool bAdded = False
	int iPreviousType = -1
	If (Self.IsSettlementInEmpire(akWorkshopRef))
		iPreviousType = Self.GetSettlementType(akWorkshopRef)
	EndIf
	If (aiEmpireSettlementType == iEmpireSettlementType_City)
		If (akWorkshopRef == CommandPost)
			return False
		EndIf
		Self.RemoveSettlement_InternalOnly(akWorkshopRef, iEmpireSettlementType_Outpost)
		Self.RemoveSettlement_InternalOnly(akWorkshopRef, iEmpireSettlementType_Vassal)
		If (Cities.find(akWorkshopRef, 0) < 0)
			If (Cities == None || Cities.length == 0)
				Cities = new workshopscript[0]
			EndIf
			Cities.add(akWorkshopRef, 1)
			bAdded = True
		Else
			return True
		EndIf
	ElseIf (aiEmpireSettlementType == iEmpireSettlementType_Outpost)
		If (akWorkshopRef == CapitalCity && akWorkshopRef != CommandPost)
			return False
		EndIf
		Self.RemoveSettlement_InternalOnly(akWorkshopRef, iEmpireSettlementType_City)
		Self.RemoveSettlement_InternalOnly(akWorkshopRef, iEmpireSettlementType_Vassal)
		If (Outposts.find(akWorkshopRef, 0) < 0)
			If (Outposts == None || Outposts.length == 0)
				Outposts = new workshopscript[0]
			EndIf
			Outposts.add(akWorkshopRef, 1)
			bAdded = True
		Else
			return True
		EndIf
	ElseIf (aiEmpireSettlementType == iEmpireSettlementType_Vassal)
		If (akWorkshopRef == CapitalCity || akWorkshopRef == CommandPost)
			return False
		EndIf
		Self.RemoveSettlement_InternalOnly(akWorkshopRef, iEmpireSettlementType_City)
		Self.RemoveSettlement_InternalOnly(akWorkshopRef, iEmpireSettlementType_Outpost)
		If (Vassals.find(akWorkshopRef, 0) < 0)
			If (Vassals == None || Vassals.length == 0)
				Vassals = new workshopscript[0]
			EndIf
			Vassals.add(akWorkshopRef, 1)
			bAdded = True
		Else
			return True
		EndIf
	EndIf
	If (bAdded)
		EmpireManager.SendSettlementAddedToEmpireEvent(akWorkshopRef, FactionForm, bPlayerRun, aiEmpireSettlementType, iPreviousType)
		return True
	Else
		return False
	EndIf
EndFunction

Function StartEmpireNetwork(Location akLocationOrigin, Location akLocationDestination, Keyword akNetworkKeyword)
	If (!akLocationOrigin.IsLinkedLocation(akLocationDestination, akNetworkKeyword))
		akLocationOrigin.AddLinkedLocation(akLocationDestination, akNetworkKeyword)
		If (akNetworkKeyword == EmpireCaravanKeyword)
			akLocationOrigin.AddLinkedLocation(akLocationDestination, WorkshopCaravanKeyword)
		EndIf
	EndIf
EndFunction

Function RemoveLocation_InternalOnly(Location akLocationRef)
	bool bRemoved = False
	If (akLocationRef.HasKeyword(LocTypeWorkshopSettlement))
		int iLocationIndex = ControlledLocations_Settlements.find(akLocationRef, 0)
		If (iLocationIndex >= 0)
			ControlledLocations_Settlements.remove(iLocationIndex, 1)
			bRemoved = True
		EndIf
	Else
		int ilocationindex = ControlledLocations_Other.find(akLocationRef, 0)
		If (ilocationindex >= 0)
			ControlledLocations_Other.remove(ilocationindex, 1)
			bRemoved = True
		EndIf
	EndIf
	If (bRemoved)
		EmpireManager.SendLocationAbandonedEvent(akLocationRef, FactionForm, bPlayerRun)
	EndIf
EndFunction

workshopscript[] Function GetEmpireSettlements()
	workshopscript[] Settlements = new workshopscript[0]
	int I = 0
	While (I < Cities.length)
		If (Settlements.find(Cities[I], 0) < 0)
			Settlements.add(Cities[I], 1)
		EndIf
		I += 1
	EndWhile
	I = 0
	While (I < Outposts.length)
		If (Settlements.find(Outposts[I], 0) < 0)
			Settlements.add(Outposts[I], 1)
		EndIf
		I += 1
	EndWhile
	I = 0
	While (I < Vassals.length)
		If (Settlements.find(Vassals[I], 0) < 0)
			Settlements.add(Vassals[I], 1)
		EndIf
		I += 1
	EndWhile
	return Settlements
EndFunction

bool Function IsWithinNetworkDistance(workshopscript akWorkshopOriginRef, workshopscript akWorkshopDestinationRef, Keyword akNetworkKeyword)
	int iNetworkTypeIndex = NetworkForms.findstruct("NetworkKeyword", akNetworkKeyword, 0)
	If (iNetworkTypeIndex < 0)
		return False
	EndIf
	ObjectReference kCheckMeOrigin = akWorkshopOriginRef as ObjectReference
	ObjectReference kCheckMeDestination = akWorkshopDestinationRef as ObjectReference
	If (akWorkshopOriginRef.IsInInterior())
		kCheckMeOrigin = akWorkshopOriginRef.myMapMarker
	EndIf
	If (akWorkshopDestinationRef.IsInInterior())
		kCheckMeDestination = akWorkshopDestinationRef.myMapMarker
	EndIf
	If (kCheckMeOrigin != None && kCheckMeDestination != None)
		If (kCheckMeOrigin.GetWorldSpace() == kCheckMeDestination.GetWorldSpace())
			If (kCheckMeOrigin.GetDistance(kCheckMeDestination) <= NetworkForms[iNetworkTypeIndex].gSameWorldspaceDistanceMax.GetValue())
				return True
			EndIf
		ElseIf (NetworkForms[iNetworkTypeIndex].gInterWorldspaceUnlock.GetValueInt() == 1)
			return True
		EndIf
	EndIf
	return False
EndFunction

Function RemoveSettlement_InternalOnly(workshopscript akWorkshopRef, int aiEmpireSettlementType)
	int iLastType = Self.GetSettlementType(akWorkshopRef)
	If (aiEmpireSettlementType == -1 || aiEmpireSettlementType == iEmpireSettlementType_City)
		int iIndex = Cities.find(akWorkshopRef, 0)
		If (iIndex >= 0)
			Cities.remove(iIndex, 1)
		EndIf
	EndIf
	If (aiEmpireSettlementType == -1 || aiEmpireSettlementType == iEmpireSettlementType_Outpost)
		int iindex = Outposts.find(akWorkshopRef, 0)
		If (iindex >= 0)
			Outposts.remove(iindex, 1)
		EndIf
	EndIf
	If (aiEmpireSettlementType == -1 || aiEmpireSettlementType == iEmpireSettlementType_Vassal)
		int iindex = Vassals.find(akWorkshopRef, 0)
		If (iindex >= 0)
			Vassals.remove(iindex, 1)
		EndIf
	EndIf
	If (aiEmpireSettlementType == -1 || aiEmpireSettlementType == iEmpireSettlementType_CapitalCity)
		CapitalCity = None
	EndIf
	If (aiEmpireSettlementType == -1 || aiEmpireSettlementType == iEmpireSettlementType_CommandPost)
		CommandPost = None
	EndIf
	If (aiEmpireSettlementType == -1)
		EmpireManager.SendSettlementRemovedFromEmpireEvent(akWorkshopRef, FactionForm, bPlayerRun, iLastType)
	EndIf
EndFunction

bool Function IsSettlementInEmpire(workshopscript akWorkshopRef)
	return Cities.find(akWorkshopRef, 0) >= 0 || Outposts.find(akWorkshopRef, 0) >= 0 || Vassals.find(akWorkshopRef, 0) >= 0
EndFunction
