;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\GunTurretScript.psc
Modified : 2019-12-03 07:14:06
Compiled : 2021-01-07 11:40:39
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:GunTurretScript extends ObjectReference
{ The script to place on a gun turret. }

;-- Properties --------------------------------------
ActorValue Property ignoreCrippleValue Auto Const
Keyword Property powerArmorArmorKeyword Auto

;-- Variables ---------------------------------------
Weapon priorEquippedWeapon
Weapon turretWeapon
Actor activatingActor
int iactorInitialAmmoCount
Ammo turretAmmo

;-- Functions ---------------------------------------

Function ExitTurret()
	Debug.trace("GunTurret ExitTurret", 0)
	Self.UnregisterForAnimationEvent(activatingActor as ObjectReference, "removingTurret")
	Self.UnregisterForRemoteEvent(activatingActor as ScriptObject, "OnDying")
	activatingActor.UnequipItem(turretWeapon as Form, False, True)
	activatingActor.RemoveItem(turretWeapon as Form, 1, True, None)
	activatingActor.UnequipItem(turretAmmo as Form, False, True)
	int iammoCount = activatingActor.GetItemCount(turretAmmo as Form)
	If (iammoCount > 0)
		activatingActor.RemoveItem(turretAmmo as Form, iammoCount, True, None)
	EndIf
	If (iactorInitialAmmoCount > 0)
		activatingActor.AddItem(turretAmmo as Form, iactorInitialAmmoCount, True)
	EndIf
	If (priorEquippedWeapon != None)
		activatingActor.EquipItem(priorEquippedWeapon as Form, False, True)
	EndIf
	If (powerArmorArmorKeyword == None || !activatingActor.WornHasKeyword(powerArmorArmorKeyword))
		activatingActor.SetValue(ignoreCrippleValue, 0 as float)
	EndIf
	iactorInitialAmmoCount = 0
	priorEquippedWeapon = None
	activatingActor = None
EndFunction

Function EnterTurret()
	Debug.trace("GunTurret EnterTurret", 0)
	priorEquippedWeapon = activatingActor.GetEquippedWeapon(0)
	iactorInitialAmmoCount = activatingActor.GetItemCount(turretAmmo as Form)
	If (iactorInitialAmmoCount > 0)
		activatingActor.RemoveItem(turretAmmo as Form, iactorInitialAmmoCount, True, None)
	EndIf
	int iammoCount = 1000
	activatingActor.AddItem(turretWeapon as Form, 1, True)
	activatingActor.AddItem(turretAmmo as Form, iammoCount, True)
	activatingActor.EquipItem(turretWeapon as Form, False, True)
	Self.RegisterForAnimationEvent(activatingActor as ObjectReference, "removingTurret")
	Self.RegisterForRemoteEvent(activatingActor as ScriptObject, "OnDying")
	activatingActor.SetValue(ignoreCrippleValue, 1 as float)
EndFunction

Event OnInit()
	Debug.trace("GunTurret OnInit", 0)
	activatingActor = None
	turretWeapon = None
	turretAmmo = None
	priorEquippedWeapon = None
	iactorInitialAmmoCount = 0
	Furniture turretFurniture = Self.GetBaseObject() as Furniture
	If (turretFurniture != None)
		turretWeapon = turretFurniture.GetAssociatedForm() as Weapon
		If (turretWeapon != None)
			turretAmmo = turretWeapon.GetAmmo()
		EndIf
	EndIf
EndEvent

Event Actor.OnDying(Actor akSender, Actor akKiller)
	Self.ExitTurret()
	Self.GoToState("TurretInactive")
EndEvent

;-- State -------------------------------------------
State TurretDisabled
EndState

;-- State -------------------------------------------
Auto State TurretInactive

	Event OnActivate(ObjectReference akActionRef)
		Debug.trace("turret got activate while inactive", 0)
		activatingActor = akActionRef as Actor
		If (activatingActor != None && turretWeapon != None && turretAmmo != None)
			Self.EnterTurret()
			Self.GoToState("TurretActive")
		EndIf
	EndEvent
EndState

;-- State -------------------------------------------
State TurretActive

	Event OnAnimationEvent(ObjectReference akSource, string asEventName)
		If (akSource == activatingActor as ObjectReference && activatingActor != None && asEventName == "removingTurret")
			Debug.trace("Handling remove of turret", 0)
			Self.BlockActivation(True, False)
			Self.UnregisterForAnimationEvent(activatingActor as ObjectReference, "removingTurret")
			If (iactorInitialAmmoCount > 0)
				activatingActor.AddItem(turretAmmo as Form, iactorInitialAmmoCount, True)
			EndIf
			iactorInitialAmmoCount = 0
			priorEquippedWeapon = None
			activatingActor = None
			Self.SetDestroyed(True)
			Self.GoToState("TurretDisabled")
		EndIf
	EndEvent

	Event OnActivate(ObjectReference akActionRef)
		Debug.trace("turret got activate while active", 0)
		If (akActionRef == activatingActor as ObjectReference)
			Self.ExitTurret()
			Self.GoToState("TurretInactive")
		EndIf
	EndEvent
EndState
