;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\InformationIcon.psc
Modified : 2019-12-08 02:41:43
Compiled : 2021-01-07 11:40:48
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:InformationIcon extends ObjectReference
{ Object to hold a variety of shaders as a means of displaying information }

;-- Properties --------------------------------------
Group Settings
	float Property fScaleOverride = 0 Auto Const
	{ If set to anything above 0, the icon will be set to this scale. Otherwise it will match the scale of the set it is a part of. }
	EffectShader Property DefaultShader Auto Const
	{ [Optional] If set, this shader will be used to start }
	EffectShader[] Property IndexedShaders Auto Const
	{ [Optional] If set, these shaders will be accessible by index # via ChangeShaderToIndex(X) }
	bool Property bAlwaysDisplay = False Auto Const
	{ If false, this will always be displayed - regardless of whether it has an info shader. }
EndGroup

EffectShader Property ActiveShader Auto hidden
bool Property bHidden = True Auto hidden
int Property iIconGroup = -1 Auto hidden
simsettlementsv2:quests:iconmanager Property IconManager Auto hidden
bool Property bForceStayHidden = False Auto hidden
bool Property bIsTryingToShow = False Auto hidden

;-- Variables ---------------------------------------
int iFormID_IconManager = 60193 Const

;-- Functions ---------------------------------------

Function ChangeShader(EffectShader aTargetShader)
	bool bIsDisabled = Self.IsDisabled()
	If (!bIsDisabled && Self.Is3dLoaded() && ActiveShader as bool)
		ActiveShader.Stop(Self as ObjectReference)
	EndIf
	ActiveShader = aTargetShader
	If (ActiveShader as bool && !bHidden && !bForceStayHidden && !bIsDisabled)
		ActiveShader.Play(Self as ObjectReference, -1)
	EndIf
EndFunction

Function ForceShow()
	bForceStayHidden = False
	Self.Show()
EndFunction

Function ForceHide()
	bForceStayHidden = True
	Self.Hide()
EndFunction

Function ChangeShaderToIndex(int aiShaderIndex)
	If (IndexedShaders.length > aiShaderIndex && IndexedShaders[aiShaderIndex] != None)
		Self.ChangeShader(IndexedShaders[aiShaderIndex])
	EndIf
EndFunction

Function Hide()
	If (bIsTryingToShow)
		return 
	EndIf
	bHidden = True
	If (ActiveShader)
		ActiveShader.Stop(Self as ObjectReference)
	EndIf
	Self.Disable(False)
EndFunction

Function UpdateVars()
	If (!IconManager)
		IconManager = Game.GetFormFromFile(iFormID_IconManager, simsettlementsv2:utilityfunctions.GetPluginName()) as simsettlementsv2:quests:iconmanager
	EndIf
EndFunction

Event OnLoad()
	Self.UpdateVars()
	If (!ActiveShader && DefaultShader != None)
		Self.ChangeShader(DefaultShader)
	EndIf
	If (!bIsTryingToShow && IconManager as bool)
		If (iIconGroup >= 0)
			If (!IconManager.ArePlayersDisplayOptionsHidingThis(iIconGroup))
				If (bHidden)
					Self.Show()
				EndIf
			ElseIf (!bHidden)
				Self.Hide()
			EndIf
		ElseIf ((IconManager.bAllIconsHidden || IconManager.ArePlayersDisplayOptionsHidingThis(-1)) && !bHidden)
			Self.Hide()
		EndIf
	EndIf
EndEvent

Function Show()
	If ((bAlwaysDisplay || ActiveShader != None) && !bForceStayHidden)
		bHidden = False
		bIsTryingToShow = True
		Self.Enable(False)
		If (ActiveShader)
			ActiveShader.Play(Self as ObjectReference, -1)
		EndIf
		bIsTryingToShow = False
	EndIf
EndFunction
