;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\InformationIconSet.psc
Modified : 2020-10-22 23:25:14
Compiled : 2021-01-07 11:40:52
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:InformationIconSet extends ObjectReference
{ Manages a row/column of information icons }

;-- Properties --------------------------------------
Group Settings
	bool Property bAsRow = True Auto Const
	{ If false, the icons will be spaced in a column instead }
	bool Property bInvert = False Auto Const
	{ If false, the icons will be placed left-to-right if bAsRow = true, or top-to-bottom if bAsRow = false; If true, the icons will be placed right-to-left if bAsRow = true, or bottom-to-top if bAsRow = false. }
	float Property fSpacing = 10 Auto Const
	{ Space between each icon }
	Form[] Property IconForms Auto Const
	{ Enter a form for each icon type to create }
	bool Property bDynamicPositioning = True Auto Const
	{ Icons will shift towards the starting point }
EndGroup

simsettlementsv2:quests:iconmanager Property IconManager Auto hidden
simsettlementsv2:objectreferences:informationicon[] Property Icons Auto hidden
bool Property bNeedsPositionUpdate = False Auto hidden
bool Property bCreated = False Auto hidden

;-- Variables ---------------------------------------
Keyword WorkshopStackedItemParentKeyword

;-- Functions ---------------------------------------

Function UpdatePositions(bool abSetMoved)
	If (!Self.Is3dLoaded())
		bNeedsPositionUpdate = True
		return 
	EndIf
	bNeedsPositionUpdate = False
	float[] CurrentPosition = new float[3]
	CurrentPosition[0] = Self.X
	CurrentPosition[1] = Self.Y
	CurrentPosition[2] = Self.Z
	float[] CurrentRotation = new float[3]
	CurrentRotation[0] = Self.GetAngleX()
	CurrentRotation[1] = Self.GetAngleY()
	CurrentRotation[2] = Self.GetAngleZ()
	float fOffset = 0
	int I = 0
	bool bFirst = True
	While (I < Icons.length)
		If (abSetMoved || !Icons[I].bHidden)
			If (!bFirst || abSetMoved)
				If (!bFirst)
					fOffset += Self.GetOffset(Icons[I] as ObjectReference)
				EndIf
				float[] PositionOffset = new float[3]
				float[] RotationOffset = new float[3]
				If (bAsRow)
					PositionOffset[0] = fOffset
				Else
					PositionOffset[2] = fOffset
				EndIf
				float[] NewCoords = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(CurrentPosition, CurrentRotation, PositionOffset, RotationOffset)
				Icons[I].SetPosition(NewCoords[0], NewCoords[1], NewCoords[2])
				Icons[I].SetAngle(NewCoords[3], NewCoords[4], NewCoords[5])
			EndIf
			If (bFirst)
				bFirst = False
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction

Function ForceShowIcon(int aiIconIndex)
	Icons[aiIconIndex].bForceStayHidden = False
	If (aiIconIndex >= Icons.length || aiIconIndex < 0 || Icons[aiIconIndex].iIconGroup >= 0 && IconManager.ArePlayersDisplayOptionsHidingThis(Icons[aiIconIndex].iIconGroup))
		return 
	EndIf
	Icons[aiIconIndex].ForceShow()
EndFunction

Function ChangeNumericIcon(int aiIconIndex, int aiNumber, int aiColorIndex)
	If (aiIconIndex >= Icons.length)
		return 
	EndIf
	simsettlementsv2:objectreferences:informationicon_numeric asNumeric = Icons[aiIconIndex] as simsettlementsv2:objectreferences:informationicon_numeric
	If (asNumeric)
		asNumeric.ChangeNumber(aiNumber, aiColorIndex)
	EndIf
EndFunction

Function ShowIcon(int aiIconIndex)
	If (aiIconIndex >= Icons.length || aiIconIndex < 0 || Icons[aiIconIndex].bForceStayHidden || IconManager.ArePlayersDisplayOptionsHidingThis(Icons[aiIconIndex].iIconGroup))
		return 
	EndIf
	bool bIconAlreadyShown = True
	If (Icons[aiIconIndex].bHidden)
		Icons[aiIconIndex].Show()
		bIconAlreadyShown = False
	EndIf
	If (!bIconAlreadyShown && bDynamicPositioning)
		Self.UpdatePositions(False)
	EndIf
EndFunction

Event OnRelease()
	Parent.OnRelease()
	If (Self.IsDeleted())
		return 
	Else
		Self.Enable(False)
		int I = 0
		While (I < Icons.length)
			Icons[I].SetLinkedRef(Self as ObjectReference, WorkshopStackedItemParentKeyword)
			Icons[I].bHidden = True
			I += 1
		EndWhile
		Self.UpdatePositions(True)
	EndIf
EndEvent

Function ChangeColoredIcon(int aiIconIndex, int aiColorIndex)
	If (aiIconIndex >= Icons.length)
		return 
	EndIf
	simsettlementsv2:objectreferences:informationicon_colored asColored = Icons[aiIconIndex] as simsettlementsv2:objectreferences:informationicon_colored
	If (asColored)
		asColored.ChangeColor(aiColorIndex)
	EndIf
EndFunction

Function ShowAll()
	int I = 0
	While (I < Icons.length)
		Self.ShowIcon(I)
		I += 1
	EndWhile
EndFunction

Function Cleanup()
	int I = 0
	While (I < Icons.length)
		Self.DeleteIcon(Icons[I] as ObjectReference)
		I += 1
	EndWhile
EndFunction

Function Disable(bool abFade)
	Self.HideAll()
	Parent.Disable(abFade)
EndFunction

Function UpdateVars()
	If (!IconManager)
		IconManager = Game.GetFormFromFile(60193, simsettlementsv2:utilityfunctions.GetPluginName()) as simsettlementsv2:quests:iconmanager
	EndIf
	If (!WorkshopStackedItemParentKeyword)
		WorkshopStackedItemParentKeyword = Game.GetFormFromFile(1859293, "Fallout4.esm") as Keyword
	EndIf
EndFunction

Function AddIcon(Form aIconForm, int aiInsertPosition, bool abShowImmediately, int aiGroup)
	simsettlementsv2:objectreferences:informationicon newIcon = Self.PlaceAtMe(aIconForm, 1, False, True, False) as simsettlementsv2:objectreferences:informationicon
	If (newIcon)
		newIcon.SetLinkedRef(Self as ObjectReference, WorkshopStackedItemParentKeyword)
		If (aiInsertPosition >= 0)
			Icons.insert(newIcon, aiInsertPosition)
		Else
			Icons.add(newIcon, 1)
		EndIf
		If (newIcon.fScaleOverride > 0 as float)
			newIcon.SetScale(newIcon.fScaleOverride)
		Else
			float fThisScale = Self.GetScale()
			newIcon.SetScale(fThisScale)
		EndIf
		newIcon.iIconGroup = aiGroup
		newIcon.OnLoad()
		If (abShowImmediately)
			newIcon.Show()
		EndIf
		Self.UpdatePositions(True)
		If (Self.GetState() == "Deleted")
			Self.DeleteIcon(newIcon as ObjectReference)
		EndIf
	EndIf
EndFunction

Function ChangeIconIndexedShader(int aiIconIndex, int aiShaderIndex)
	If (aiIconIndex >= Icons.length)
		return 
	EndIf
	Icons[aiIconIndex].ChangeShaderToIndex(aiShaderIndex)
EndFunction

Function DeleteIcon(ObjectReference akIconRef)
	akIconRef.SetLinkedRef(None, WorkshopStackedItemParentKeyword)
	akIconRef.Disable(False)
	akIconRef.Delete()
EndFunction

Function ChangeIconShader(int aiIconIndex, EffectShader aTargetShader)
	If (aiIconIndex >= Icons.length)
		return 
	EndIf
	Icons[aiIconIndex].ChangeShader(aTargetShader)
EndFunction

float Function GetOffset(ObjectReference akIconRef)
	float fOffset = 0
	If (bAsRow)
		fOffset = akIconRef.GetWidth() * akIconRef.GetScale() + fSpacing
		If (bInvert)
			fOffset *= -1
		EndIf
	Else
		fOffset = akIconRef.GetHeight() * akIconRef.GetScale() + fSpacing
		If (!bInvert)
			fOffset *= -1
		EndIf
	EndIf
	return fOffset
EndFunction

Function Delete()
	Self.GoToState("Deleted")
	Self.Cleanup()
	Parent.Delete()
EndFunction

Event OnLoad()
	If (!bCreated)
		Self.UpdateVars()
		If (!Icons)
			Icons = new simsettlementsv2:objectreferences:informationicon[0]
		EndIf
		Self.CreateIcons()
	ElseIf (Self.GetState() == "Deleted")
		If (Icons != None)
			Self.Cleanup()
		EndIf
	ElseIf (bNeedsPositionUpdate)
		Self.UpdatePositions(True)
	EndIf
EndEvent

Function ForceHideIcon(int aiIconIndex)
	If (aiIconIndex >= Icons.length || aiIconIndex < 0)
		return 
	EndIf
	Icons[aiIconIndex].ForceHide()
EndFunction

Function CreateIcons()
	If (bCreated)
		return 
	EndIf
	If (IconForms.length > 0)
		int I = 0
		While (I < IconForms.length)
			Self.AddIcon(IconForms[I], -1, False, -1)
			I += 1
		EndWhile
	EndIf
	bCreated = True
EndFunction

Function HideIcon(int aiIconIndex)
	If (aiIconIndex >= Icons.length)
		return 
	EndIf
	bool bIconAlreadyHidden = True
	If (!Icons[aiIconIndex].bHidden)
		Icons[aiIconIndex].Hide()
		bIconAlreadyHidden = False
	EndIf
	If (!bIconAlreadyHidden && bDynamicPositioning)
		Self.UpdatePositions(False)
	EndIf
EndFunction

Function HideAll()
	int I = 0
	While (I < Icons.length)
		Self.HideIcon(I)
		I += 1
	EndWhile
EndFunction

;-- State -------------------------------------------
State Deleted

	Function ShowIcon(int aiIconIndex)
		; Empty function
	EndFunction

	Function AddIcon(Form aIconForm, int aiInsertPosition, bool abShowImmediately, int aiGroup)
		; Empty function
	EndFunction

	Function ShowAll()
		; Empty function
	EndFunction

	Function UpdatePositions(bool abSetMoved)
		; Empty function
	EndFunction
EndState
