;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\InformationIconSet_Plot.psc
Modified : 2020-10-22 23:33:45
Compiled : 2021-01-07 11:40:53
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:InformationIconSet_Plot extends SimSettlementsV2:ObjectReferences:InformationIconSet
{ Manages a row/column of information icons for a SimPlot }

;-- Properties --------------------------------------
Group Configuration
	int Property iType = 0 Auto Const
	{ 0 = Plot Type; 1 = Power; 2 = Occupants; 3 = Status }
EndGroup

Group Controllers
	simsettlementsv2:quests:plotmanager Property PlotManager Auto Const mandatory
EndGroup

Group ActorValues
	ActorValue Property PowerGenerated Auto Const mandatory
	ActorValue Property PowerRequired Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property AccessoryLinkKeyword Auto Const mandatory
	{ Same as on PlotManager quest }
	Keyword Property NumericInformationIconKeyword Auto Const mandatory
	Keyword Property WorkshopCanBePowered Auto Const mandatory
EndGroup

Group Assets
	Form Property PositionHolderIconForm Auto Const mandatory
EndGroup

int Property TYPE_PLOT = 0 AutoReadOnly
int Property TYPE_POWER = 1 AutoReadOnly
int Property TYPE_OCCUPANTS = 2 AutoReadOnly
int Property TYPE_STATUS = 3 AutoReadOnly

;-- Variables ---------------------------------------
bool bUpdateDisplayBlock = False
int iIconGroup_PlotOccupant = -1
int iIconGroup_PlotOccupantNumbers = -1
int iIconGroup_PlotStatus = -1
int iIconGroup_PlotType = -1
int iIconGroup_PlotPower = -1
bool bNeedsUpdate = True
int iIconGroup_PlotLevel = -1

;-- Functions ---------------------------------------

Function Enable(bool abFade)
	Self.UpdateDisplay()
	Parent.Enable(abFade)
EndFunction

Event OnInit()
	iIconGroup_PlotLevel = PlotManager.iIconGroup_PlotLevel
	iIconGroup_PlotType = PlotManager.iIconGroup_PlotType
	iIconGroup_PlotOccupant = PlotManager.iIconGroup_PlotOccupant
	iIconGroup_PlotOccupantNumbers = PlotManager.iIconGroup_PlotOccupantNumbers
	iIconGroup_PlotStatus = PlotManager.iIconGroup_PlotStatus
	iIconGroup_PlotPower = PlotManager.iIconGroup_PlotPower
EndEvent

Event OnLoad()
	Parent.OnLoad()
	If (bNeedsUpdate)
		If (Self.UpdateDisplay())
			bNeedsUpdate = False
		EndIf
	EndIf
EndEvent

bool Function UpdateDisplay()
	If (bUpdateDisplayBlock || !bCreated || Self.IsDeleted())
		return False
	EndIf
	If (!Self.Is3dLoaded())
		bNeedsUpdate = True
		return False
	EndIf
	bUpdateDisplayBlock = True
	If (bNeedsPositionUpdate)
		Self.UpdatePositions(True)
	EndIf
	simsettlementsv2:objectreferences:simplot thisPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, AccessoryLinkKeyword)
	simsettlementsv2:miscobjects:plotconfiguration thisPlotConfig = None
	If (thisPlot)
		thisPlotConfig = thisPlot.GetPlotConfig()
	EndIf
	If (!thisPlot)
		Self.HideAll()
	ElseIf (iType == Self.TYPE_PLOT)
		Form PlotSubtypeIcon = PositionHolderIconForm
		simsettlementsv2:weapons:buildingplan BuildingPlan = thisPlot.GetParentBuildingPlan()
		If (BuildingPlan as bool && BuildingPlan.ClassKeyword != None)
			simsettlementsv2:datastructures#plotsubclass[] PlotSubClasses = PlotManager.GetPlotSubClasses()
			int iSubclassIndex = PlotSubClasses.findstruct("ClassKeyword", BuildingPlan.ClassKeyword, 0)
			If (iSubclassIndex >= 0)
				simsettlementsv2:armors:buildingclass thisClassForm = PlotSubClasses[iSubclassIndex].BuildingClassForm as simsettlementsv2:armors:buildingclass
				If (thisClassForm as bool && thisClassForm.InformationIcon != None && thisClassForm.InformationIcon != thisPlotConfig.InformationIcon_PlotType)
					PlotSubtypeIcon = thisClassForm.InformationIcon
				EndIf
			EndIf
		EndIf
		If (Icons[0].GetBaseObject() != thisPlotConfig.InformationIcon_PlotType)
			Icons[0].Disable(False)
			Icons[0].Delete()
			Icons.remove(0, 1)
			Self.AddIcon(thisPlotConfig.InformationIcon_PlotType, 0, True, iIconGroup_PlotType)
		EndIf
		Self.ForceShowIcon(0)
		If (Icons[1].GetBaseObject() != PlotSubtypeIcon)
			Icons[1].Disable(False)
			Icons[1].Delete()
			Icons.remove(1, 1)
			Self.AddIcon(PlotSubtypeIcon, 1, True, iIconGroup_PlotType)
		EndIf
		Self.ForceShowIcon(1)
		Self.ChangeNumericIcon(2, thisPlot.iCurrentLevel, 1)
		Self.ForceShowIcon(2)
	ElseIf (iType == Self.TYPE_OCCUPANTS)
		simsettlementsv2:weapons:buildinglevelplan LevelPlan = thisPlot.GetCurrentLevelPlan()
		If (LevelPlan as bool && LevelPlan.iMaxOccupants > 1)
			int iCurrentOccupants = thisPlot.iOccupants
			int iMaxOccupants = LevelPlan.iMaxOccupants
			If (iCurrentOccupants < iMaxOccupants)
				If (iCurrentOccupants == 0)
					Self.ChangeColoredIcon(0, 3)
					Self.ForceShowIcon(0)
					Self.ForceHideIcon(1)
					Self.ForceHideIcon(2)
				Else
					Self.ChangeColoredIcon(0, 2)
					Self.ForceShowIcon(0)
					Self.ChangeNumericIcon(1, iCurrentOccupants, 2)
					Self.ForceShowIcon(1)
					Self.ChangeNumericIcon(2, iMaxOccupants, 2)
					Self.ForceShowIcon(2)
				EndIf
			Else
				Self.ChangeColoredIcon(0, 1)
				Self.ForceShowIcon(0)
				Self.ChangeNumericIcon(1, iCurrentOccupants, 1)
				Self.ForceShowIcon(1)
				Self.ForceHideIcon(2)
			EndIf
		ElseIf ((thisPlot.iCurrentLevel > 0 && thisPlotConfig.bRequiresOccupant || thisPlot.iCurrentLevel == 0 && thisPlotConfig.bRequiresBuilder) && (!LevelPlan || LevelPlan.iMaxOccupants == 1))
			If (thisPlot.iOccupants > 0)
				Self.ChangeColoredIcon(0, 1)
			Else
				Self.ChangeColoredIcon(0, 3)
			EndIf
			Self.ForceShowIcon(0)
			Self.ForceHideIcon(1)
			Self.ForceHideIcon(2)
		Else
			Self.ForceHideIcon(0)
			Self.ForceHideIcon(1)
			Self.ForceHideIcon(2)
		EndIf
	ElseIf (iType == Self.TYPE_POWER)
		If (thisPlot.PlotRequiresPower(-1) || thisPlot.MissingPowerForUpgrade())
			float fPowerGenerated = thisPlot.GetValue(PowerGenerated)
			If (thisPlot.IsPowered() || fPowerGenerated > 0 as float)
				If (fPowerGenerated >= 1 as float)
					Self.ChangeColoredIcon(0, 1)
					Self.ForceShowIcon(0)
					Self.ChangeNumericIcon(1, fPowerGenerated as int, 1)
					Self.ForceShowIcon(1)
				Else
					Self.ForceHideIcon(0)
					Self.ForceHideIcon(1)
				EndIf
			Else
				Self.ChangeColoredIcon(0, 3)
				Self.ForceShowIcon(0)
				float fPowerRequired = thisPlot.GetValue(PowerRequired)
				If (fPowerRequired > 1 as float)
					int iDigit01 = -1
					int iDigit02 = -1
					int iDigit03 = -1
					float fRemainingToDivide = fPowerRequired
					If (fRemainingToDivide > 99 as float)
						int iHundredsPlace = Math.Floor(fRemainingToDivide / 100)
						fRemainingToDivide -= (iHundredsPlace * 100) as float
						iDigit01 = iHundredsPlace
					EndIf
					If (fRemainingToDivide > 9 as float)
						int iTensPlace = Math.Floor(fRemainingToDivide / 10)
						fRemainingToDivide -= (iTensPlace * 10) as float
						If (iDigit01 < 0)
							iDigit01 = iTensPlace
						Else
							iDigit02 = iTensPlace
						EndIf
					ElseIf (iDigit01 > 0)
						iDigit02 = 0
					EndIf
					If (fRemainingToDivide > 0 as float)
						If (iDigit01 < 0)
							iDigit01 = fRemainingToDivide as int
						ElseIf (iDigit02 < 0)
							iDigit02 = fRemainingToDivide as int
						ElseIf (iDigit03 < 0)
							iDigit03 = fRemainingToDivide as int
						EndIf
					EndIf
					If (iDigit01 >= 0)
						Self.ChangeNumericIcon(1, iDigit01, 3)
						Self.ForceShowIcon(1)
					Else
						Self.ForceHideIcon(1)
					EndIf
					If (iDigit02 >= 0)
						Self.ChangeNumericIcon(2, iDigit02, 3)
						Self.ForceShowIcon(2)
					Else
						Self.ForceHideIcon(2)
					EndIf
					If (iDigit03 >= 0)
						Self.ChangeNumericIcon(3, iDigit03, 3)
						Self.ForceShowIcon(3)
					Else
						Self.ForceHideIcon(3)
					EndIf
				Else
					Self.ForceHideIcon(1)
					Self.ForceHideIcon(2)
					Self.ForceHideIcon(3)
				EndIf
			EndIf
		Else
			Self.ForceHideIcon(0)
			Self.ForceHideIcon(1)
			Self.ForceHideIcon(2)
			Self.ForceHideIcon(3)
		EndIf
	ElseIf (iType == Self.TYPE_STATUS)
		If (thisPlot.StatusIcons.length > 0)
			int iStatusIconIndex = 0
			While (iStatusIconIndex < Icons.length - 1)
				If (thisPlot.StatusIcons.length > iStatusIconIndex)
					Self.ChangeIconShader(iStatusIconIndex, thisPlot.StatusIcons[iStatusIconIndex])
					Self.ForceShowIcon(iStatusIconIndex)
				Else
					Self.ForceHideIcon(iStatusIconIndex)
				EndIf
				iStatusIconIndex += 1
			EndWhile
		ElseIf (thisPlot.bReadyToUpgrade && (!thisPlot.ConstructionRequiresOwner || thisPlot.IsActorAssigned()))
			int I = 1
			While (I < Icons.length)
				Self.ForceHideIcon(I)
				I += 1
			EndWhile
		Else
			int i = 0
			While (i < Icons.length - 1)
				Self.ForceHideIcon(i)
				i += 1
			EndWhile
		EndIf
	EndIf
	If (IconManager.ArePlayersDisplayOptionsHidingThis(-1))
		Self.HideAll()
	EndIf
	bUpdateDisplayBlock = False
	return True
EndFunction

Function CreateIcons()
	Parent.CreateIcons()
	int iIconCount = Icons.length
	If (iType == Self.TYPE_PLOT)
		Icons[0].iIconGroup = iIconGroup_PlotType
		Icons[1].iIconGroup = iIconGroup_PlotType
		Icons[2].iIconGroup = iIconGroup_PlotLevel
	ElseIf (iType == Self.TYPE_OCCUPANTS)
		Icons[0].iIconGroup = iIconGroup_PlotOccupant
		If (iIconCount > 2)
			Icons[2].iIconGroup = iIconGroup_PlotOccupantNumbers
		EndIf
		If (iIconCount > 1)
			Icons[1].iIconGroup = iIconGroup_PlotOccupantNumbers
		EndIf
	ElseIf (iType == Self.TYPE_POWER)
		int I = 0
		While (I < Icons.length)
			Icons[I].iIconGroup = iIconGroup_PlotPower
			I += 1
		EndWhile
	ElseIf (iType == Self.TYPE_STATUS)
		int i = 0
		While (i < Icons.length)
			Icons[i].iIconGroup = iIconGroup_PlotStatus
			i += 1
		EndWhile
	EndIf
EndFunction
