;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\LeveledWorkshopObject.psc
Modified : 2020-05-18 17:53:27
Compiled : 2021-01-07 11:41:07
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:LeveledWorkshopObject extends WorkshopObjectScript
{ An assignable object that changes it's values as a corresponding city levels up }

;-- Properties --------------------------------------
Group LeveledSettings
	workshopframework:library:datastructures#worldobject[] Property ControlledObjectFormByLevel Auto Const mandatory
	{ A subobject will be spawned }
	simsettlementsv2:datastructures#levelavchange[] Property AVChanges Auto Const
	{ Actor values to be applied to this object based on the level }
	simsettlementsv2:datastructures#levelkeywordchange[] Property KeywordChanges Auto Const
	{ Keywords to be applied to this object based on the level }
	bool Property bRemoveKeywordsWhenUnassigned = False Auto Const
	bool Property bRemoveAVsWhenUnassigned = False Auto Const
EndGroup

ObjectReference Property kControlledRef Auto hidden
int Property iKnownLevel = 0 Auto hidden

;-- Variables ---------------------------------------
Keyword WorkshopStackedItemParentKeyword
int iFormID_WorkshopStackedItemParentKeyword = 1859293 Const
string sPlugin_WSFW = "WorkshopFramework.esm" Const
Keyword WorkshopWorkObject
string sPlugin_Fallout4 = "Fallout4.esm" Const
int iFormID_WorkshopWorkObject = 132498 Const
Keyword WorkshopItemKeyword
int iFormID_WorkshopItemKeyword = 347046 Const
ActorValue WorkshopResourceObject
int iFormID_WorkshopResourceObject = 1219212 Const

;-- Functions ---------------------------------------

Event OnWorkshopObjectMoved(ObjectReference akWorkshopRef)
	Self.DeleteControlledRef()
	Self.HandleUpdate()
	Parent.OnWorkshopObjectMoved(akWorkshopRef)
EndEvent

Event SimSettlementsV2:Quests:CityPlanManager.CityLevelChanged(simsettlementsv2:quests:cityplanmanager akSender, var[] akArgs)
	iKnownLevel = akArgs[1] as int
	Form CurrentControlledForm = kControlledRef.GetBaseObject()
	If (CurrentControlledForm != Self.GetControlledObjectForm())
		Self.DeleteControlledRef()
		Self.HandleUpdate()
	EndIf
EndEvent

workshopframework:library:datastructures#worldobject Function GetWorldObjectRecord()
	int iUseIndex = iKnownLevel
	int iMaxIndex = ControlledObjectFormByLevel.length - 1
	If (iUseIndex > iMaxIndex)
		iUseIndex = iMaxIndex
	EndIf
	return ControlledObjectFormByLevel[iUseIndex]
EndFunction

Form Function GetControlledObjectForm()
	If (iKnownLevel < 1)
		return workshopframework:library:utilityfunctions.GetWorldObjectForm(ControlledObjectFormByLevel[0], -1)
	Else
		return workshopframework:library:utilityfunctions.GetWorldObjectForm(Self.GetWorldObjectRecord(), -1)
	EndIf
EndFunction

Function DeleteControlledRef()
	kControlledRef.SetLinkedRef(None, WorkshopStackedItemParentKeyword)
	kControlledRef.SetLinkedRef(None, WorkshopItemKeyword)
	kControlledRef.Disable(False)
	kControlledRef.Delete()
	kControlledRef = None
EndFunction

Event OnInit()
	Parent.OnInit()
	Self.UpdateVars()
	Self.RegisterForCustomEvent(simsettlementsv2:utilityfunctions.GetCityPlanManager() as ScriptObject, "simsettlementsv2:quests:cityplanmanager_CityLevelChanged")
	WorkshopParent.ExcludeFromAssignmentRules(Self.GetBaseObject())
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_AssignmentRulesOverriden")
	If (workshopID < 0)
		workshopID = workshopframework:wsfw_api.GetNearestWorkshop(Self as ObjectReference).GetWorkshopID()
		If (workshopID < 0)
			return 
		EndIf
	EndIf
	simsettlementsv2:quests:settlementmanager SettlementManager = simsettlementsv2:utilityfunctions.GetSettlementManager()
	simsettlementsv2:objectreferences:settlementdata thisDataStore = SettlementManager.GetSettlementDataStore(workshopID)
	If (thisDataStore)
		iKnownLevel = thisDataStore.iCityLevel
	EndIf
	Self.HandleUpdate()
EndEvent

Function UpdateVars()
	If (!WorkshopItemKeyword)
		WorkshopItemKeyword = Game.GetFormFromFile(iFormID_WorkshopItemKeyword, sPlugin_Fallout4) as Keyword
	EndIf
	If (!WorkshopWorkObject)
		WorkshopWorkObject = Game.GetFormFromFile(iFormID_WorkshopWorkObject, sPlugin_Fallout4) as Keyword
	EndIf
	If (!WorkshopStackedItemParentKeyword)
		WorkshopStackedItemParentKeyword = Game.GetFormFromFile(iFormID_WorkshopStackedItemParentKeyword, sPlugin_Fallout4) as Keyword
	EndIf
	If (!WorkshopResourceObject)
		WorkshopResourceObject = Game.GetFormFromFile(iFormID_WorkshopResourceObject, sPlugin_Fallout4) as ActorValue
	EndIf
EndFunction

Function Cleanup()
	Self.GoToState("Deleted")
	Self.DeleteControlledRef()
EndFunction

Function Delete()
	Self.Cleanup()
EndFunction

Function HandleUpdate()
	If (Self.IsDeleted())
		Self.Cleanup()
		return 
	EndIf
	workshopscript thisWorkshop = Self.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	If (!kControlledRef)
		workshopframework:library:datastructures#worldobject PlaceWorldObject = Self.GetWorldObjectRecord()
		kControlledRef = workshopframework:wsfw_api.CreateSettlementObject(PlaceWorldObject, thisWorkshop, Self as ObjectReference, True)
		kControlledRef.SetLinkedRef(Self as ObjectReference, WorkshopStackedItemParentKeyword)
	EndIf
	If (kControlledRef.HasKeyword(WorkshopWorkObject))
		Actor thisActor = Self.GetActorRefOwner()
		If (thisActor != None)
			Actor ControlledRefActor = kControlledRef.GetActorRefOwner()
			If (thisActor != ControlledRefActor)
				If (kControlledRef as WorkshopObjectScript)
					(kControlledRef as WorkshopObjectScript).AssignNPC(thisActor)
				Else
					kControlledRef.SetActorRefOwner(thisActor, False)
				EndIf
			EndIf
		EndIf
	EndIf
	Actor kOwnerRef = Self.GetActorRefOwner()
	If (AVChanges.length)
		int I = 0
		While (I < AVChanges.length)
			If (AVChanges[I].AVToChange as bool && AVChanges[I].iLevel == iKnownLevel)
				If (!kOwnerRef && bRemoveAVsWhenUnassigned)
					Self.SetValue(AVChanges[I].AVToChange, 0)
				Else
					Self.SetValue(AVChanges[I].AVToChange, AVChanges[I].AVValue)
				EndIf
			EndIf
			I += 1
		EndWhile
		If (Self.GetValue(WorkshopResourceObject) > 0 as float)
			If (thisWorkshop)
				thisWorkshop.RecalculateWorkshopResources(True)
			EndIf
		EndIf
	EndIf
	If (KeywordChanges.length)
		int i = 0
		While (i < KeywordChanges.length)
			If (KeywordChanges[i].KeywordToAdd)
				If (KeywordChanges[i].iLevel < iKnownLevel && KeywordChanges[i].iRemoveLevel <= iKnownLevel || !kOwnerRef && bRemoveKeywordsWhenUnassigned)
					Self.RemoveKeyword(KeywordChanges[i].KeywordToAdd)
				ElseIf (KeywordChanges[i].iLevel <= iKnownLevel)
					Self.AddKeyword(KeywordChanges[i].KeywordToAdd)
				EndIf
			EndIf
			i += 1
		EndWhile
	EndIf
EndFunction

Event OnWorkshopObjectDestroyed(ObjectReference akWorkshopRef)
	Self.Cleanup()
	Parent.OnWorkshopObjectDestroyed(akWorkshopRef)
EndEvent

Function AssignNPCCustom(Actor newActor)
	Self.HandleUpdate()
EndFunction

Event WorkshopParentScript.AssignmentRulesOverriden(workshopparentscript akSender, var[] akArgs)
	If (akArgs[0] as ObjectReference == Self as ObjectReference)
		If (akArgs[3] as ObjectReference != kControlledRef)
			Self.AssignActor(None)
		EndIf
	EndIf
EndEvent

;-- State -------------------------------------------
State Deleted

	Function HandleUpdate()
		; Empty function
	EndFunction
EndState
