;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\MultiActivator.psc
Modified : 2019-10-09 00:58:54
Compiled : 2021-01-07 11:41:12
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:MultiActivator extends WorkshopObjectScript
{ Activator or Furniture that you'd like to spawn multiple sub-items on that can also be interacted with. }

;-- Properties --------------------------------------
Group Config
	workshopframework:library:datastructures#worldobject[] Property ExtraActivators Auto Const
	{ Additional activators to spawn and their relative positions/rotations to this object. }
EndGroup

Keyword Property WorkshopStackedItemParentKEYWORD Auto hidden
Keyword Property PreventTSExport Auto hidden
Keyword Property WorkshopItemKeyword Auto hidden
ObjectReference[] Property SpawnedObjects Auto hidden
bool Property bUpdateNeeded = False Auto hidden
bool Property bActivationBlocked = False Auto hidden

;-- Variables ---------------------------------------
int iFormID_WorkshopStackedItemParentKEYWORD = 1859293 Const
int iFormID_WorkshopItemKeyword = 347046 Const
int UpdateSpawnsTimerID = 0 Const
int iFormID_PreventTSExportKeyword = 2391846 Const

;-- Functions ---------------------------------------

Function BlockFromPlayer()
	bActivationBlocked = True
	Self.BlockActivation(True, True)
	int I = 0
	While (I < SpawnedObjects.length)
		SpawnedObjects[I].BlockActivation(True, True)
		I += 1
	EndWhile
EndFunction

Event OnRelease()
	Self.UpdateSpawns()
EndEvent

Function Disable(bool abFade)
	Self.DeleteSpawns()
	Parent.Disable(abFade)
EndFunction

Function UpdateSpawns()
	If (!Self.is3dLoaded())
		bUpdateNeeded = True
		return 
	EndIf
	Self.DeleteSpawns()
	int I = 0
	workshopscript thisWorkshop = Self.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	While (I < ExtraActivators.length && !Self.IsDisabled())
		Form FormToSpawn = workshopframework:library:utilityfunctions.GetWorldObjectForm(ExtraActivators[I], -1)
		If (FormToSpawn != None)
			ObjectReference spawn = Self.PlaceAtMe(FormToSpawn, 1, False, True, True)
			spawn.AddKeyword(PreventTSExport)
			If (spawn)
				float[] pfPositionOffset = new float[3]
				float[] pfRotationOffset = new float[3]
				pfPositionOffset[0] = ExtraActivators[I].fPosX
				pfPositionOffset[1] = ExtraActivators[I].fPosY
				pfPositionOffset[2] = ExtraActivators[I].fPosZ
				pfRotationOffset[0] = ExtraActivators[I].fAngleX
				pfRotationOffset[1] = ExtraActivators[I].fAngleY
				pfRotationOffset[2] = ExtraActivators[I].fAngleZ
				If (spawn is Actor)
					spawn.enable(False)
				EndIf
				workshopframework:library:thirdparty:cobb:cobblibraryrotations.MoveObjectRelativeToObject(spawn, Self as ObjectReference, pfPositionOffset, pfRotationOffset)
				If (ExtraActivators[I].fScale > 0 as float)
					spawn.SetScale(ExtraActivators[I].fScale)
				EndIf
				If (thisWorkshop as bool && !FormToSpawn as Static)
					spawn.SetLinkedRef(thisWorkshop as ObjectReference, WorkshopItemKeyword)
				EndIf
				spawn.enable(False)
				SpawnedObjects.add(spawn, 1)
				spawn.SetLinkedRef(Self as ObjectReference, WorkshopStackedItemParentKEYWORD)
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction

Event OnWorkshopObjectMoved(ObjectReference akReference)
	Self.UpdateSpawns()
	Parent.OnWorkshopObjectMoved(akReference)
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == UpdateSpawnsTimerID)
		Self.UpdateSpawns()
	EndIf
EndEvent

Function UpdateVars()
	If (!WorkshopStackedItemParentKEYWORD)
		WorkshopStackedItemParentKEYWORD = Game.GetFormFromFile(iFormID_WorkshopStackedItemParentKEYWORD, "Fallout4.esm") as Keyword
	EndIf
	If (!PreventTSExport)
		PreventTSExport = Game.GetFormFromFile(iFormID_PreventTSExportKeyword, "Fallout4.esm") as Keyword
	EndIf
	If (!WorkshopItemKeyword)
		WorkshopItemKeyword = Game.GetFormFromFile(iFormID_WorkshopItemKeyword, "Fallout4.esm") as Keyword
	EndIf
EndFunction

Function Delete()
	Self.DeleteSpawns()
	Parent.Delete()
EndFunction

Function UnBlockFromPlayer()
	Self.BlockActivation(False, False)
	int I = 0
	While (I < SpawnedObjects.length)
		SpawnedObjects[I].BlockActivation(False, False)
		I += 1
	EndWhile
	bActivationBlocked = False
EndFunction

Function enable(bool abFade)
	Self.UpdateSpawns()
	Parent.enable(abFade)
EndFunction

Function DeleteSpawns()
	int I = 0
	While (I < SpawnedObjects.length)
		SpawnedObjects[I].SetLinkedRef(None, WorkshopStackedItemParentKEYWORD)
		SpawnedObjects[I].Disable(False)
		SpawnedObjects[I].Delete()
		I += 1
	EndWhile
	SpawnedObjects = new ObjectReference[0]
	ObjectReference[] Linked = Self.GetLinkedRefChildren(WorkshopStackedItemParentKEYWORD)
	I = 0
	While (I < Linked.length)
		Linked[I].SetLinkedRef(None, WorkshopStackedItemParentKEYWORD)
		Linked[I].Disable(False)
		Linked[I].Delete()
		I += 1
	EndWhile
EndFunction

Event OnInit()
	SpawnedObjects = new ObjectReference[0]
	bUpdateNeeded = True
	Self.UpdateVars()
	Parent.OnInit()
EndEvent

Event OnWorkshopObjectGrabbed(ObjectReference akReference)
	Self.DeleteSpawns()
	Parent.OnWorkshopObjectGrabbed(akReference)
EndEvent

Event OnWorkshopObjectDestroyed(ObjectReference akReference)
	Self.DeleteSpawns()
	Parent.OnWorkshopObjectDestroyed(akReference)
EndEvent

Event OnLoad()
	If (Self.IsDisabled())
		return 
	EndIf
	Self.UpdateVars()
	workshopscript thisWorkshop = Self.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	If (!thisWorkshop)
		Utility.Wait(2)
		Self.OnLoad()
		return 
	EndIf
	If (bUpdateNeeded)
		Self.UpdateSpawns()
		bUpdateNeeded = False
	EndIf
	Parent.OnLoad()
EndEvent
