;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\PlotPowerLiftMiniCartScript.psc
Modified : 2019-11-05 22:54:19
Compiled : 2021-01-07 11:41:32
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:PlotPowerLiftMiniCartScript extends ObjectReference hidden

;-- Properties --------------------------------------
Group Required_Properties
	Keyword Property PlotSpawnedKeyword Auto Const mandatory
	Form[] Property FloorButtonForms Auto Const mandatory
	{ Should be the base forms you are using as buttons at each floor, with the first entry being your bottom floor and the last entry being your top floor }
	int[] Property FloorNumbers Auto Const mandatory
	{ Look at the graphic of the lift with markers enabled and enter the number each floor is on. First entry should be your bottom floor and the last entry your top floor }
	Form Property CartForm Auto Const mandatory
	GlobalVariable Property gMaxFloorsHolder Auto Const mandatory
	{ Global used to condition the FloorSelectMessage }
	Message Property FloorSelectMessage Auto Const mandatory
	{ Message with 1 through 17 buttons, each should be conditioned so that it only shows up if gMaxFloorsHolder >= to that number. We'll dynamically update gMaxFloorsHolder before showing the message for this elevator. }
EndGroup

Group Optional_Properties
	Form Property ShakePointForm Auto Const
	{ You can make the lift shake the player's cam by adding a marker form (such as an XMarker) at wherever the lift cart will start. This is determined by whether you check in StartAtTop or not and the FloorNumbers you set. For example, if you enter 1, 2, 3 in your FloorNumbers and choose StartAtTop, you should put the marker on the 1. If you don't check in StartAtTop you should put the marker on the 3. }
	Form Property CartButtonForm Auto Const
	{ Make sure this is a unique form ID, it cannot be the same as any of the FloorButtonForms. }
	bool Property StartAtTop = False Auto
	{ Whether the Cart starts at the top or not. }
	float Property SpeedOverride = -1 Auto
	{ Must use this if you set the Overrides above.  This is the seconds it takes for the lift to move from one point to the other. Normal speed is roughly a smidge over a second per level. }
EndGroup


;-- Variables ---------------------------------------
ObjectReference kShakePointRef
ObjectReference[] kButtonRefs
ObjectReference kCartRef
ObjectReference kCartButtonRef

;-- Functions ---------------------------------------

Function FindPlotSpawnedRefs()
	If (Self.IsDeleted())
		return 
	EndIf
	ObjectReference kPlotLinkRefHolder = Self.GetLinkedRef(PlotSpawnedKeyword)
	If (kPlotLinkRefHolder)
		ObjectReference[] kPlotSpawns = kPlotLinkRefHolder.GetLinkedRefChildren(PlotSpawnedKeyword)
		If (kPlotSpawns.length > 0)
			ObjectReference[] kTempButtonRefs = new ObjectReference[0]
			int I = 0
			int j = 0
			While (I < kPlotSpawns.length)
				If (!kPlotSpawns[I].IsDisabled())
					Form baseForm = kPlotSpawns[I].GetBaseObject()
					If (baseForm == CartForm)
						kCartRef = kPlotSpawns[I]
					ElseIf (baseForm == CartButtonForm)
						kCartButtonRef = kPlotSpawns[I]
					ElseIf (baseForm == ShakePointForm)
						kShakePointRef = kPlotSpawns[I]
					Else
						j = 0
						bool bFloorButtonFound = False
						While (j < FloorButtonForms.length && !bFloorButtonFound)
							If (FloorButtonForms[j] == baseForm)
								bFloorButtonFound = True
								kTempButtonRefs.add(kPlotSpawns[I], 1)
							EndIf
							j += 1
						EndWhile
					EndIf
				EndIf
				I += 1
			EndWhile
			If (kTempButtonRefs.length > 0)
				I = 0
				float[] fZeds = new float[0]
				While (I < kTempButtonRefs.length)
					fZeds.add(kTempButtonRefs[I].Z, 1)
					I += 1
				EndWhile
				ObjectReference kSort = None
				float fSort = 0
				I = fZeds.length - 1
				While (I > 0)
					j = 0
					While (j < I)
						If (fZeds[j] > fZeds[j + 1])
							kSort = kTempButtonRefs[j]
							kTempButtonRefs[j] = kTempButtonRefs[j + 1]
							kTempButtonRefs[j + 1] = kSort
							fSort = fZeds[j]
							fZeds[j] = fZeds[j + 1]
							fZeds[j + 1] = fSort
						EndIf
						j += 1
					EndWhile
					I -= 1
				EndWhile
				If (kButtonRefs == None || kButtonRefs.length == 0)
					kButtonRefs = new ObjectReference[0]
				EndIf
				I = 0
				While (I < kTempButtonRefs.length)
					If (kButtonRefs.length > I)
						kButtonRefs[I] = kTempButtonRefs[I]
					Else
						kButtonRefs.add(kTempButtonRefs[I], 1)
					EndIf
					I += 1
				EndWhile
			EndIf
		EndIf
	EndIf
	If (kCartRef as bool && kShakePointRef as bool)
		kShakePointRef.AttachTo(kCartRef)
	EndIf
	If (kCartRef as bool && kCartButtonRef as bool)
		kCartButtonRef.AttachTo(kCartRef)
	EndIf
EndFunction

Function ShakeItUp()
	If (kShakePointRef as bool && Game.GetPlayer().GetDistance(kShakePointRef) < 256 as float)
		Game.ShakeCamera(kShakePointRef, 0.2, 0.5)
		Game.ShakeController(0.1, 0.1, 0.5)
	EndIf
EndFunction

Function Delete()
	Self.Cleanup()
EndFunction

int Function GetCurrentFloor()
	float fAnimVar = kCartRef.GetAnimationVariableFloat("fvalue")
	float fCartScale = kCartRef.GetScale()
	If (fCartScale != 1)
		float fMultiplier = fAnimVar / fAnimVar * fCartScale
		fAnimVar /= fMultiplier
	EndIf
	If (fAnimVar < 0.0625)
		return 1
	ElseIf (fAnimVar >= 0.0625 && fAnimVar < 0.125)
		return 2
	ElseIf (fAnimVar >= 0.125 && fAnimVar < 0.1875)
		return 3
	ElseIf (fAnimVar >= 0.1875 && fAnimVar < 0.25)
		return 4
	ElseIf (fAnimVar >= 0.25 && fAnimVar < 0.3125)
		return 5
	ElseIf (fAnimVar >= 0.3125 && fAnimVar < 0.375)
		return 6
	ElseIf (fAnimVar >= 0.375 && fAnimVar < 0.4375)
		return 7
	ElseIf (fAnimVar >= 0.4375 && fAnimVar < 0.5)
		return 8
	ElseIf (fAnimVar >= 0.5 && fAnimVar < 0.5625)
		return 9
	ElseIf (fAnimVar >= 0.5625 && fAnimVar < 0.625)
		return 10
	ElseIf (fAnimVar >= 0.625 && fAnimVar < 0.6875)
		return 11
	ElseIf (fAnimVar >= 0.6875 && fAnimVar < 0.75)
		return 12
	ElseIf (fAnimVar >= 0.75 && fAnimVar < 0.8125)
		return 13
	ElseIf (fAnimVar >= 0.8125 && fAnimVar < 0.875)
		return 14
	ElseIf (fAnimVar >= 0.875 && fAnimVar < 0.9375)
		return 15
	ElseIf (fAnimVar >= 0.9375 && fAnimVar < 1)
		return 16
	ElseIf (fAnimVar >= 1)
		return 17
	EndIf
EndFunction

Event OnLoad()
	If (kButtonRefs == None)
		kButtonRefs = new ObjectReference[0]
	EndIf
	Utility.Wait(10)
	Self.FindPlotSpawnedRefs()
	int iDestinationCartFloor = FloorNumbers[0]
	If (StartAtTop)
		iDestinationCartFloor = FloorNumbers[FloorNumbers.length - 1]
	EndIf
	kCartRef.SetAnimationVariableFloat("fvalue", Self.GetFloorFloat(iDestinationCartFloor))
	kCartRef.SetAnimationVariableFloat("fspeed", 0 as float)
	kCartRef.PlayAnimation("Play01")
	Self.RegisterForRemoteEvent(kCartButtonRef as ScriptObject, "OnActivate")
	int I = 0
	While (I < kButtonRefs.length)
		Self.RegisterForRemoteEvent(kButtonRefs[I] as ScriptObject, "OnActivate")
		I += 1
	EndWhile
EndEvent

float Function GetFloorFloat(int iLevel)
	float fAnimValue = 0
	If (iLevel == 1)
		fAnimValue = 0
	ElseIf (iLevel == 2)
		fAnimValue = 0.0625
	ElseIf (iLevel == 3)
		fAnimValue = 0.125
	ElseIf (iLevel == 4)
		fAnimValue = 0.1875
	ElseIf (iLevel == 5)
		fAnimValue = 0.25
	ElseIf (iLevel == 6)
		fAnimValue = 0.3125
	ElseIf (iLevel == 7)
		fAnimValue = 0.375
	ElseIf (iLevel == 8)
		fAnimValue = 0.4375
	ElseIf (iLevel == 9)
		fAnimValue = 0.5
	ElseIf (iLevel == 10)
		fAnimValue = 0.5625
	ElseIf (iLevel == 11)
		fAnimValue = 0.625
	ElseIf (iLevel == 12)
		fAnimValue = 0.6875
	ElseIf (iLevel == 13)
		fAnimValue = 0.75
	ElseIf (iLevel == 14)
		fAnimValue = 0.8125
	ElseIf (iLevel == 15)
		fAnimValue = 0.875
	ElseIf (iLevel == 16)
		fAnimValue = 0.9375
	ElseIf (iLevel == 17)
		fAnimValue = 1
	EndIf
	float fCartScale = kCartRef.GetScale()
	float fCalculatedValue = Math.Min(1, fAnimValue * fAnimValue / fAnimValue * fCartScale)
	return fCalculatedValue
EndFunction

Function Cleanup()
	kCartRef = None
	kButtonRefs = None
	kCartButtonRef = None
EndFunction

Function MoveCart(int aiDestinationFloor)
	int iDestinationCartFloor = FloorNumbers[aiDestinationFloor]
	int iCurrentCartFloor = Self.GetCurrentFloor()
	If (iDestinationCartFloor == iCurrentCartFloor)
		return 
	EndIf
	kCartRef.SetAnimationVariableFloat("fvalue", Self.GetFloorFloat(iDestinationCartFloor))
	If (SpeedOverride != -1)
		kCartRef.SetAnimationVariableFloat("fspeed", SpeedOverride)
	Else
		int iLevelsToTravel = Math.Abs((iDestinationCartFloor - iCurrentCartFloor) as float) as int
		kCartRef.SetAnimationVariableFloat("fspeed", iLevelsToTravel as float * 1.15)
	EndIf
	Self.ShakeItUp()
	kCartRef.PlayAnimationAndWait("Play01", "Done")
	Self.ShakeItUp()
EndFunction

Event ObjectReference.OnActivate(ObjectReference akSender, ObjectReference akActionRef)
	; Empty function
EndEvent

;-- State -------------------------------------------
Auto State WaitingForActivation

	Event ObjectReference.OnActivate(ObjectReference akSender, ObjectReference akActionRef)
		Self.GoToState("busy")
		int iCurrentCartFloor = Self.GetCurrentFloor()
		int iButtonIndex = kButtonRefs.find(akSender, 0)
		int iButtonFloor = FloorNumbers[iButtonIndex]
		int iDestinationFloorIndex = 0
		If (iButtonIndex >= 0)
			iDestinationFloorIndex = FloorNumbers.find(iButtonFloor, 0)
		Else
			gMaxFloorsHolder.SetValue(FloorNumbers.length as float)
			iDestinationFloorIndex = FloorSelectMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		EndIf
		Self.MoveCart(iDestinationFloorIndex)
		Self.GoToState("WaitingForActivation")
	EndEvent
EndState

;-- State -------------------------------------------
State busy

	Event ObjectReference.OnActivate(ObjectReference akSender, ObjectReference akActionRef)
		; Empty function
	EndEvent
EndState
