;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\PlotSubSpawner.psc
Modified : 2020-10-22 00:06:52
Compiled : 2021-01-07 11:41:40
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:PlotSubSpawner extends ObjectReference
{ Designed to be spawned as part of a plot's stage items - all items this creates will be connected directly to the plot's system as if they were spawned by the plot's stage items. The difference is that this subspawner can control additional conditions on when these spawn and despawn. Also, if the subspawner is deleted, all of its items will go with it. }

;-- Properties --------------------------------------
Group SpawnData
	simsettlementsv2:miscobjects:stageitem[] Property SubSpawns Auto Const mandatory
	bool Property bRecheckItemsWithRequirements = False Auto Const
	{ If set to false, any items with the Requirements field filled out will only be tested for those Requirements the first time the items are spawned. If true, those Requirements will be re-tested each time the player returns to determine if they should be spawned. }
EndGroup

Group Advanced collapsedonref collapsedonbase
	bool Property bOnlyAddItemsWithRequirements = False Auto Const
	{ If set to true, items with the Requirements field filled out will never be removed later if the Requirements are no longer true. This should be used only for special cases as it involves retesting and rebuilding every item in this spawn. }
EndGroup


;-- Variables ---------------------------------------
Keyword StageItemLinkKeyword
bool bDeletedNormally = False
int iFormID_StageItemLinkKeyword = 84478 Const
bool bHasItemsToCheckForRequirements = False
int iFormID_SubSpawnLinkKeyword = 84847 Const
Keyword SubSpawnLinkKeyword
simsettlementsv2:miscobjects:stageitem[] RequirementsNotMet

;-- Functions ---------------------------------------

simsettlementsv2:objectreferences:simplot Function GetParentPlot()
	simsettlementsv2:objectreferences:simplot thisPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, StageItemLinkKeyword)
	If (thisPlot)
		return thisPlot
	EndIf
	int loopCount = 0
	While (loopCount < 100)
		Utility.wait(0.1)
		thisPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, StageItemLinkKeyword)
		If (thisPlot)
			Debug.trace("PlotSubSpawner: subspawner " + Self as string + " found it's parent plot after " + (loopCount + 2) as string + " attempts", 0)
			return thisPlot
		EndIf
		loopCount += 1
	EndWhile
	return None
EndFunction

Function UpdateSpawnedItems()
	ObjectReference[] SpawnedRefs = Self.GetLinkedRefChildren(SubSpawnLinkKeyword)
	If (!SpawnedRefs || SpawnedRefs.length == 0)
		If (Self.ItemsCanBeSpawned())
			Self.SpawnItems(False)
		EndIf
	ElseIf (Self.ItemsShouldBeRemoved())
		Self.Cleanup()
	ElseIf (bHasItemsToCheckForRequirements && bRecheckItemsWithRequirements)
		If (bOnlyAddItemsWithRequirements)
			
		Else
			Self.Cleanup()
			Self.SpawnItems(False)
		EndIf
	EndIf
EndFunction

bool Function ItemsShouldBeRemoved()
	return False
EndFunction

Event OnWorkshopObjectMoved(ObjectReference akWorkshopRef)
	Self.UpdateSpawnedItems()
	Parent.OnWorkshopObjectMoved(akWorkshopRef)
EndEvent

Event OnLoad()
	If (Self.IsDisabled())
		Self.Cleanup()
	Else
		Self.UpdateVars()
		Self.UpdateSpawnedItems()
	EndIf
EndEvent

Function UpdateVars()
	If (!SubSpawnLinkKeyword)
		SubSpawnLinkKeyword = Game.GetFormFromFile(iFormID_SubSpawnLinkKeyword, simsettlementsv2:utilityfunctions.GetPluginName()) as Keyword
	EndIf
	If (!StageItemLinkKeyword)
		StageItemLinkKeyword = Game.GetFormFromFile(iFormID_StageItemLinkKeyword, simsettlementsv2:utilityfunctions.GetPluginName()) as Keyword
	EndIf
EndFunction

bool Function ItemsCanBeSpawned()
	return True
EndFunction

Function Cleanup()
	ObjectReference[] SpawnedRefs = Self.GetLinkedRefChildren(SubSpawnLinkKeyword)
	int I = 0
	While (I < SpawnedRefs.length)
		SpawnedRefs[I].SetLinkedRef(None, SubSpawnLinkKeyword)
		If (!bDeletedNormally)
			SpawnedRefs[I].disable(False)
			SpawnedRefs[I].delete()
		EndIf
		I += 1
	EndWhile
EndFunction

Function SpawnItems(bool abCheckRequirementItemsOnly)
	int I = 0
	string[] NamedSpawns = new string[0]
	int[] ClearFromRequirementsNotMetIndexes = new int[0]
	simsettlementsv2:miscobjects:stageitem[] SpawnThese = SubSpawns
	workshopframework:library:datastructures#worldobject[] ShouldSpawn = new workshopframework:library:datastructures#worldobject[0]
	simsettlementsv2:objectreferences:simplot thisPlot = Self.GetParentPlot()
	If (!thisPlot)
		Debug.trace("PlotSubSpawner: subspawner " + Self as string + " failed to find it's parent plot, it will selfdestruct now.", 0)
		Self.disable(False)
		Self.delete()
		return 
	EndIf
	If (abCheckRequirementItemsOnly)
		If (RequirementsNotMet as bool && RequirementsNotMet.length > 0)
			SpawnThese = RequirementsNotMet
		Else
			bHasItemsToCheckForRequirements = False
			return 
		EndIf
	EndIf
	While (I < SpawnThese.length)
		bool bShouldSpawn = True
		If (SpawnThese[I].GetRequirements() as bool && !simsettlementsv2:utilityfunctions.CheckRequirements(SpawnThese[I].GetRequirements(), None, None, None))
			bHasItemsToCheckForRequirements = True
			If (abCheckRequirementItemsOnly)
				If (!RequirementsNotMet || RequirementsNotMet.length == 0)
					RequirementsNotMet = new simsettlementsv2:miscobjects:stageitem[0]
				EndIf
				RequirementsNotMet.add(SpawnThese[I], 1)
			EndIf
			bShouldSpawn = False
		ElseIf (SpawnThese[I].sSpawnName != "")
			If (NamedSpawns.find(SpawnThese[I].sSpawnName, 0) > -1)
				bShouldSpawn = False
			Else
				NamedSpawns.add(SpawnThese[I].sSpawnName, 1)
			EndIf
		EndIf
		If (bShouldSpawn)
			ShouldSpawn.add(SpawnThese[I].SpawnDetails, 1)
			If (abCheckRequirementItemsOnly)
				ClearFromRequirementsNotMetIndexes.add(I, 1)
			EndIf
		EndIf
		I += 1
	EndWhile
	If (ShouldSpawn.length > 0)
		thisPlot.SpawnStageItemBatch(ShouldSpawn, None, None, 0, 0, Self as ObjectReference)
	EndIf
	If (abCheckRequirementItemsOnly && ClearFromRequirementsNotMetIndexes.length > 0)
		I = ClearFromRequirementsNotMetIndexes.length - 1
		While (I >= 0)
			RequirementsNotMet.remove(ClearFromRequirementsNotMetIndexes[I], 1)
			I -= 1
		EndWhile
		If (RequirementsNotMet.length == 0)
			bHasItemsToCheckForRequirements = False
		EndIf
	EndIf
EndFunction

Function delete()
	bDeletedNormally = True
	Parent.delete()
EndFunction
