;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\RespawningSuppliesContainer.psc
Modified : 2020-05-21 23:40:42
Compiled : 2021-01-07 11:41:44
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:RespawningSuppliesContainer extends ObjectReference

;-- Properties --------------------------------------
LeveledItem Property SuppliesToSpawn Auto Const mandatory
{ The leveled item to generate each fRefillTime }
float Property fRefillTime = 1 Auto Const
{ Time in game days between refills. }
bool Property bOnlyRefillIfEmpty = True Auto Const
bool Property bRefillOnLoadOnly = True Auto Const
{ If set to false, this will remain in memory and continue to refill on a timer. This is only worth setting to false if also setting bOnlyRefillIfEmpty to false, in which case the container will amass more and more resources }
int Property iMaxItemCount = -1 Auto Const
{ If set, the container will stop generating resources once it reaches this count }

;-- Variables ---------------------------------------
bool bFirstLoad = True
float fLastFilled

;-- Functions ---------------------------------------

Function StartRefillTimer()
	Self.StartTimerGameTime(fRefillTime, 0)
EndFunction

Event OnLoad()
	If (bFirstLoad)
		Utility.Wait(3)
		bFirstLoad = False
	EndIf
	If (bRefillOnLoadOnly)
		float fCurrentTime = Utility.GetCurrentGameTime()
		If (fCurrentTime > fLastFilled + fRefillTime)
			Self.SpawnSupplies()
		EndIf
	Else
		Self.SpawnSupplies()
		Self.StartRefillTimer()
	EndIf
EndEvent

Event OnTimerGameTime(int aiTimerID)
	Self.SpawnSupplies()
	Self.StartRefillTimer()
EndEvent

Function SpawnSupplies()
	int iSupplyCount = Self.GetItemCount(None)
	If (bOnlyRefillIfEmpty && iSupplyCount > 0)
		return 
	EndIf
	If (iMaxItemCount > 0 && iSupplyCount > iMaxItemCount)
		return 
	EndIf
	Self.AddItem(SuppliesToSpawn as Form, 1, False)
	fLastFilled = Utility.GetCurrentGameTime()
EndFunction
