;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\SimpleSpotlight.psc
Modified : 2020-05-05 02:19:25
Compiled : 2021-01-07 11:41:51
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:SimpleSpotlight extends ObjectReference conditional

;-- Properties --------------------------------------
Group Advanced_Properties collapsedonref
	Form Property XMarker Auto Const
	float Property PatrolSpeed = 100 Auto Const
	{ Used for speed of patrol marker translation }
EndGroup

Group PatrolMarkers
	float[] Property MarkerAPos Auto Const
	float[] Property MarkerBPos Auto Const
EndGroup


;-- Variables ---------------------------------------
bool bPanForward = True
int iCurrentTargetMarkerIndex = 0
ObjectReference MarkerB
ObjectReference MarkerA
int iCreatePatrolMarkersTimerID = 101
bool bSetupDone = False
ObjectReference kPatrolMarkerRef
ObjectReference[] markerLinkedRefChain

;-- Functions ---------------------------------------

Function BridgeToPan(ObjectReference detectActor)
	kPatrolMarkerRef.TranslateToRef(markerLinkedRefChain[0], PatrolSpeed, 0 as float)
	Self.SetDirectAtTarget(kPatrolMarkerRef)
EndFunction

bool Function SetupDefault()
	If (!Self.Is3dLoaded())
		return False
	EndIf
	If (kPatrolMarkerRef == None)
		kPatrolMarkerRef = Self.PlaceAtMe(XMarker, 1, False, False, True)
	EndIf
	Self.RegisterForRemoteEvent(kPatrolMarkerRef as ScriptObject, "OnTranslationAlmostComplete")
	If (markerLinkedRefChain[0])
		kPatrolMarkerRef.WaitFor3DLoad()
		If (kPatrolMarkerRef != None)
			Self.StartPan(kPatrolMarkerRef)
			kPatrolMarkerRef.TranslateToRef(markerLinkedRefChain[0], PatrolSpeed * 4 as float, 0)
		EndIf
	EndIf
	return True
EndFunction

Function StartPan(ObjectReference akActionRef)
	Self.SetDirectAtTarget(akActionRef)
	Self.PlayAnimation("Direct01")
EndFunction

Event OnInit()
	Self.StartTimer(2 as float, iCreatePatrolMarkersTimerID)
EndEvent

Function CreatePatrolMarkers()
	If (!Self.Is3dLoaded() || Self.IsDisabled())
		return 
	EndIf
	If (MarkerAPos.length == 3 && MarkerBPos.length == 3)
		float[] rotation = new float[3]
		rotation[0] = 0
		rotation[1] = 0
		rotation[2] = 0
		MarkerA = Self.PlaceAtMe(XMarker, 1, False, False, True)
		workshopframework:library:thirdparty:cobb:cobblibraryrotations.MoveObjectRelativeToObject(MarkerA, Self as ObjectReference, MarkerAPos, rotation)
		Self.SetLinkedRef(MarkerA, None)
		MarkerB = Self.PlaceAtMe(XMarker, 1, False, False, True)
		workshopframework:library:thirdparty:cobb:cobblibraryrotations.MoveObjectRelativeToObject(MarkerB, Self as ObjectReference, MarkerBPos, rotation)
		MarkerA.SetLinkedRef(MarkerB, None)
		markerLinkedRefChain = Self.getLinkedRefChain(None, 100)
		bSetupDone = Self.SetupDefault()
		Utility.Wait(0.1)
		Self.StartPan(kPatrolMarkerRef)
		kPatrolMarkerRef.TranslateToRef(markerLinkedRefChain[0], PatrolSpeed * 4 as float, 0)
	EndIf
EndFunction

Event ObjectReference.OnTranslationAlmostComplete(ObjectReference akSender)
	If (markerLinkedRefChain.length > 1)
		kPatrolMarkerRef.TranslateToRef(markerLinkedRefChain[iCurrentTargetMarkerIndex], PatrolSpeed, 0 as float)
	EndIf
	int iMarkerChainLength = markerLinkedRefChain.length - 1
	If (bPanForward && iCurrentTargetMarkerIndex < iMarkerChainLength)
		iCurrentTargetMarkerIndex += 1
	ElseIf (bPanForward && iCurrentTargetMarkerIndex >= iMarkerChainLength)
		bPanForward = False
		iCurrentTargetMarkerIndex -= 1
	ElseIf (!bPanForward && iCurrentTargetMarkerIndex > 0)
		iCurrentTargetMarkerIndex -= 1
	ElseIf (!bPanForward && iCurrentTargetMarkerIndex <= 0)
		bPanForward = True
		iCurrentTargetMarkerIndex += 1
	EndIf
EndEvent

Event OnLoad()
	If (bSetupDone)
		Self.BridgeToPan(None)
	EndIf
EndEvent

Function Delete()
	If (kPatrolMarkerRef)
		kPatrolMarkerRef.Disable(False)
		kPatrolMarkerRef.Delete()
	EndIf
	kPatrolMarkerRef = None
	If (MarkerA)
		MarkerA.Disable(False)
		MarkerA.Delete()
	EndIf
	MarkerA = None
	If (MarkerB)
		MarkerB.Disable(False)
		MarkerB.Delete()
	EndIf
	MarkerB = None
	If (markerLinkedRefChain.length)
		int I = 0
		While (I < markerLinkedRefChain.length)
			markerLinkedRefChain[I].Disable(False)
			markerLinkedRefChain[I].Delete()
			I += 1
		EndWhile
		markerLinkedRefChain = new ObjectReference[0]
	EndIf
	Parent.Delete()
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iCreatePatrolMarkersTimerID)
		If (MarkerA == None || MarkerB == None)
			Self.CreatePatrolMarkers()
		EndIf
	EndIf
EndEvent

Event OnCellLoad()
	If (MarkerA == None || MarkerB == None)
		Self.StartTimer(2 as float, iCreatePatrolMarkersTimerID)
	EndIf
	If (!Self.IsDisabled())
		markerLinkedRefChain = Self.getLinkedRefChain(None, 100)
		If (!bSetupDone)
			bSetupDone = Self.SetupDefault()
		EndIf
	EndIf
EndEvent
