;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\SolarArrayController.psc
Modified : 2020-05-20 17:39:35
Compiled : 2021-01-07 11:42:10
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:SolarArrayController extends ObjectReference

;-- Properties --------------------------------------
Form Property SolarArrayForm Auto Const mandatory
Keyword Property PlotLinkKeyword Auto Const mandatory
workshopparentscript Property WorkshopParent Auto Const mandatory
ActorValue Property SolarArtilleryValue Auto Const mandatory
float Property fSolarArrayActiveTimer = 40 Auto Const
LocationRefType Property SolarArtilleryLocRefType Auto Const mandatory

;-- Variables ---------------------------------------
ObjectReference kPlotRef
int iSoundLoop
ObjectReference kSolarArray
bool bUpdateRequired = False

;-- Functions ---------------------------------------

Event OnTimer(int aiTimerID)
	Self.DeactivateArray()
EndEvent

Event OnLoad()
	Utility.Wait(2)
	If (!kPlotRef)
		kPlotRef = simsettlementsv2:utilityfunctions.GetLinkedPlot(Self as ObjectReference, PlotLinkKeyword) as ObjectReference
		If (kPlotRef)
			workshopscript thisWorkshop = WorkshopParent.GetWorkshop((kPlotRef as workshopobjectscript).workshopID)
			Self.SetLocRefType(thisWorkshop.myLocation, SolarArtilleryLocRefType)
			Self.RegisterForRemoteEvent(kPlotRef as ScriptObject, "OnPowerOn")
			Self.RegisterForRemoteEvent(kPlotRef as ScriptObject, "OnPowerOff")
			If (!kSolarArray)
				Self.FindSolarArray()
			EndIf
			Self.UpdatePowerState()
		EndIf
	EndIf
EndEvent

Event ObjectReference.OnPowerOn(ObjectReference akSenderRef, ObjectReference akGeneratorRef)
	Self.UpdatePowerState()
EndEvent

Function DeactivateArray()
	int iOpenState = kSolarArray.GetOpenState()
	If (iOpenState == 2 || iOpenState == 1)
		If (kSolarArray as bool && kSolarArray.Is3dLoaded())
			kSolarArray.Activate(Self as ObjectReference, False)
			kSolarArray.SetOpen(False)
		EndIf
	EndIf
EndFunction

Event ObjectReference.OnPowerOff(ObjectReference akSenderRef)
	Self.UpdatePowerState()
EndEvent

Function ActivateArray()
	If (!kSolarArray || kSolarArray.IsDisabled() || !kSolarArray.Is3dLoaded())
		Self.FindSolarArray()
	EndIf
	If (kSolarArray)
		int iOpenState = kSolarArray.GetOpenState()
		If (iOpenState == 3)
			kSolarArray.Activate(Self as ObjectReference, False)
			kSolarArray.SetOpen(True)
		EndIf
		Self.StartTimer(fSolarArrayActiveTimer, 0)
	EndIf
EndFunction

Function Disable(bool abFade)
	Self.Cleanup()
	Parent.Disable(abFade)
EndFunction

Function Cleanup()
	kSolarArray = None
	workshopscript thisWorkshop = WorkshopParent.GetWorkshop((kPlotRef as workshopobjectscript).workshopID)
	If (thisWorkshop)
		Self.SetLocRefType(thisWorkshop.myLocation, None)
	EndIf
	Self.UnregisterForRemoteEvent(kPlotRef as ScriptObject, "OnPowerOn")
	Self.UnregisterForRemoteEvent(kPlotRef as ScriptObject, "OnPowerOff")
	kPlotRef = None
EndFunction

Function TurnOff()
	workshopscript thisWorkshop = WorkshopParent.GetWorkshop((kPlotRef as workshopobjectscript).workshopID)
	float fArtilleryValue = thisWorkshop.GetValue(SolarArtilleryValue) - 1 as float
	If (fArtilleryValue < 0 as float)
		fArtilleryValue = 0 as float
	EndIf
	thisWorkshop.SetValue(SolarArtilleryValue, fArtilleryValue)
EndFunction

Function DisableNoWait(bool abFade)
	Self.Cleanup()
	Parent.DisableNoWait(abFade)
EndFunction

Function FindSolarArray()
	ObjectReference[] kArrays = Self.FindAllReferencesOfType(SolarArrayForm, 500)
	If (kArrays.length)
		int I = 0
		While (I < kArrays.length && !kSolarArray)
			If (!kArrays[I].IsDisabled())
				kSolarArray = kArrays[I]
			EndIf
			I += 1
		EndWhile
	EndIf
EndFunction

Function UpdatePowerState()
	If (Self.Is3dLoaded())
		bUpdateRequired = False
		If (kPlotRef.IsPowered() && (kSolarArray as simsettlementsv2:objectreferences:solararraytower).bSolarPowered)
			Self.TurnOn()
		Else
			Self.TurnOff()
		EndIf
	Else
		bUpdateRequired = True
	EndIf
EndFunction

Function TurnOn()
	workshopscript thisWorkshop = WorkshopParent.GetWorkshop((kPlotRef as workshopobjectscript).workshopID)
	float fArtilleryValue = thisWorkshop.GetValue(SolarArtilleryValue) + 1 as float
	thisWorkshop.SetValue(SolarArtilleryValue, fArtilleryValue)
EndFunction
