;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\SolarArrayTower.psc
Modified : 2020-05-20 17:34:45
Compiled : 2021-01-07 11:42:02
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:SolarArrayTower extends ObjectReference

;-- Properties --------------------------------------
workshopparentscript Property WorkshopParent Auto Const
Sound Property SolarArrayActiveSound Auto Const
Form Property ImageSpaceModifierExplosion Auto Const
{ Explosion to temporarily "blind" the player when the tower first turns on }
Keyword Property SolarPanelKeyword Auto Const
float Property fSolarPowerRequired = 50 Auto Const
ActorValue Property PowerGenerated Auto Const
float Property fFacingMax = -80 Auto Const
float Property fFacingMin = -110 Auto Const
Sound Property SolarPowerUpSound Auto Const
Form Property PoweredUpLoopingSoundForm Auto Const
Form Property SolarArrayControllerForm Auto Const
bool Property bSolarPowered = False Auto hidden

;-- Variables ---------------------------------------
ObjectReference kSolarController
int iLoopID
ObjectReference kEnabledSoundMaker
ObjectReference kIMod

;-- Functions ---------------------------------------

Function CheckForSolarPanels()
	ObjectReference[] Panels = Self.FindAllReferencesWithKeyword(SolarPanelKeyword as Form, 5000)
	If (Panels.length)
		int I = 0
		float fPowerProvided = 0
		While (I < Panels.length)
			If (Self.IsFacingMe(Panels[I]))
				fPowerProvided += Panels[I].GetValue(PowerGenerated)
			EndIf
			I += 1
		EndWhile
		If (fPowerProvided >= fSolarPowerRequired)
			Self.SolarPowerAvailable(True)
			return 
		EndIf
	EndIf
	Self.SolarPowerAvailable(False)
EndFunction

Event WorkshopParentScript.WorkshopObjectDestroyed(workshopparentscript WorkshopParent, var[] akargs)
	workshopobjectscript asWorkshopObject = akargs[0] as workshopobjectscript
	If (asWorkshopObject as bool && asWorkshopObject.HasKeyword(SolarPanelKeyword))
		Self.CheckForSolarPanels()
	EndIf
EndEvent

Function Cleanup()
	Self.UnregisterForAllEvents()
	kIMod.Disable(False)
	kIMod.Delete()
	kIMod = None
	If (kEnabledSoundMaker)
		kEnabledSoundMaker.Disable(False)
		kEnabledSoundMaker.Delete()
		kEnabledSoundMaker = None
	EndIf
	If (kSolarController)
		kSolarController = None
	EndIf
	ObjectReference[] Panels = Self.FindAllReferencesWithKeyword(SolarPanelKeyword as Form, 5000)
	If (Panels.length)
		int I = 0
		While (I < Panels.length)
			If (Panels[I] as simsettlementsv2:objectreferences:solarpanel)
				(Panels[I] as simsettlementsv2:objectreferences:solarpanel).PointedAtTower(False)
			EndIf
			I += 1
		EndWhile
	EndIf
	Sound.StopInstance(iLoopID)
	iLoopID = -1
EndFunction

Event OnLoad()
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopObjectBuilt")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopObjectDestroyed")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopObjectMoved")
	Utility.Wait(2)
	Self.FindSolarController()
	Self.CheckForSolarPanels()
EndEvent

Function DisableNoWait(bool abFade)
	Self.Cleanup()
	Parent.DisableNoWait(abFade)
EndFunction

Function SolarPowerAvailable(bool bEnable)
	If (bSolarPowered != bEnable)
		Self.FindSolarController()
		If (kSolarController)
			(kSolarController as simsettlementsv2:objectreferences:solararraycontroller).UpdatePowerState()
		EndIf
		If (!bSolarPowered && bEnable)
			SolarPowerUpSound.Play(Self as ObjectReference)
		EndIf
	EndIf
	bSolarPowered = bEnable
	If (bEnable)
		If (!kEnabledSoundMaker)
			kEnabledSoundMaker = Self.PlaceAtMe(PoweredUpLoopingSoundForm, 1, False, False, False)
		EndIf
	ElseIf (kEnabledSoundMaker)
		kEnabledSoundMaker.Disable(False)
		kEnabledSoundMaker.Delete()
		kEnabledSoundMaker = None
	EndIf
EndFunction

bool Function IsFacingMe(ObjectReference kPanelRef)
	float fAngle = kPanelRef.GetHeadingAngle(Self as ObjectReference)
	bool bIsFacing = False
	If (fAngle <= fFacingMax && fAngle >= fFacingMin)
		bIsFacing = True
	EndIf
	If (kPanelRef as simsettlementsv2:objectreferences:solarpanel)
		(kPanelRef as simsettlementsv2:objectreferences:solarpanel).PointedAtTower(bIsFacing)
	EndIf
	return bIsFacing
EndFunction

Function FindSolarController()
	If (!kSolarController)
		ObjectReference[] kControllers = Self.FindAllReferencesOfType(SolarArrayControllerForm, 500)
		If (kControllers.length)
			int I = 0
			While (I < kControllers.length)
				If (!kControllers[I].IsDisabled())
					kSolarController = kControllers[I]
				EndIf
				I += 1
			EndWhile
		EndIf
	EndIf
EndFunction

Event OnActivate(ObjectReference akActivatedBy)
	If (akActivatedBy is Actor)
		return 
	EndIf
	int iOpenState = Self.GetOpenState()
	If (iLoopID >= 0)
		Sound.StopInstance(iLoopID)
	EndIf
	If (iOpenState == 2 || iOpenState == 3)
		iLoopID = SolarArrayActiveSound.Play(Self as ObjectReference)
		Utility.Wait(1)
		If (ImageSpaceModifierExplosion)
			kIMod = Self.PlaceAtMe(ImageSpaceModifierExplosion, 1, False, False, True)
			kIMod.SetPosition(kIMod.X, kIMod.Y, kIMod.Z + 1000)
		EndIf
	Else
		kIMod.Disable(False)
		kIMod.Delete()
		kIMod = None
	EndIf
EndEvent

Event WorkshopParentScript.WorkshopObjectBuilt(workshopparentscript kWorkshopParent, var[] akargs)
	workshopobjectscript asWorkshopObject = akargs[0] as workshopobjectscript
	If (asWorkshopObject as bool && asWorkshopObject.HasKeyword(SolarPanelKeyword))
		Self.CheckForSolarPanels()
	EndIf
EndEvent

Event WorkshopParentScript.WorkshopObjectMoved(workshopparentscript WorkshopParent, var[] akargs)
	workshopobjectscript asWorkshopObject = akargs[0] as workshopobjectscript
	If (asWorkshopObject as bool && asWorkshopObject.HasKeyword(SolarPanelKeyword))
		Self.CheckForSolarPanels()
	EndIf
EndEvent

Function Disable(bool abFade)
	Self.Cleanup()
	Parent.Disable(abFade)
EndFunction
