;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\SolarPanel.psc
Modified : 2019-12-03 08:01:31
Compiled : 2021-01-07 11:42:02
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:SolarPanel extends ObjectReference

;-- Properties --------------------------------------
Form Property LightBeamForm Auto Const
float Property fLightX Auto Const
float Property fLightY Auto Const
float Property fLightZ Auto Const
float Property fLightRotX Auto Const
float Property fLightRotY Auto Const
float Property fLightRotZ Auto Const
float Property fScale Auto Const
Keyword Property LinkBeamKeyword Auto Const
GlobalVariable Property GameHour Auto Const
float Property MorningHour = 7 Auto Const
float Property NightHour = 20 Auto Const

;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

Function CreateBeam()
	ObjectReference kBeam = Self.PlaceAtMe(LightBeamForm, 1, False, False, True)
	float[] pfPositionOffset = new float[3]
	float[] pfRotationOffset = new float[3]
	pfPositionOffset[0] = fLightX
	pfPositionOffset[1] = fLightY
	pfPositionOffset[2] = fLightZ
	pfRotationOffset[0] = fLightRotX
	pfRotationOffset[1] = fLightRotY
	pfRotationOffset[2] = fLightRotZ
	workshopframework:library:thirdparty:cobb:cobblibraryrotations.MoveObjectRelativeToObject(kBeam, Self as ObjectReference, pfPositionOffset, pfRotationOffset)
	kBeam.SetScale(fScale)
	Self.SetLinkedRef(kBeam, LinkBeamKeyword)
EndFunction

Event OnLoad()
	Self.UpdateBeam()
	Self.RegisterForPlayerWait()
EndEvent

Function Cleanup()
	Self.DeleteBeam()
	Self.UnregisterForAllEvents()
EndFunction

Function HideBeam(bool abHide)
	ObjectReference kBeam = Self.GetLinkedRef(LinkBeamKeyword)
	If (kBeam)
		If (abHide)
			kBeam.DisableNoWait(False)
		Else
			kBeam.EnableNoWait(False)
		EndIf
	EndIf
EndFunction

Event OnWorkshopObjectMoved(ObjectReference akReference)
	Parent.OnWorkshopObjectMoved(akReference)
	Self.UpdateBeam()
EndEvent

Function PointedAtTower(bool abPointed)
	ObjectReference kBeam = Self.GetLinkedRef(LinkBeamKeyword)
	If (abPointed)
		If (!kBeam)
			Self.CreateBeam()
		EndIf
	ElseIf (kBeam)
		Self.SetLinkedRef(None, LinkBeamKeyword)
		kBeam.Disable(False)
		kBeam.Delete()
	EndIf
EndFunction

Event OnWorkshopObjectGrabbed(ObjectReference akReference)
	Parent.OnWorkshopObjectGrabbed(akReference)
	Self.DeleteBeam()
EndEvent

Function Disable(bool abFade)
	Self.Cleanup()
	Parent.Disable(abFade)
EndFunction

Event OnPlayerWaitStop(bool abInterrupted)
	If (Self.Is3dLoaded())
		Self.UpdateBeam()
	Else
		Self.UnregisterForPlayerWait()
	EndIf
EndEvent

Function DeleteBeam()
	ObjectReference kBeam = Self.GetLinkedRef(LinkBeamKeyword)
	If (kBeam)
		Self.SetLinkedRef(None, LinkBeamKeyword)
		kBeam.Disable(False)
		kBeam.Delete()
	EndIf
EndFunction

Function UpdateBeam()
	Weather thisWeather = Weather.GetCurrentWeather()
	float fHour = GameHour.GetValue()
	If (fHour < MorningHour || fHour > NightHour || thisWeather.GetClassification() != 0 && thisWeather.GetClassification() != 1)
		Self.HideBeam(True)
	Else
		Self.HideBeam(False)
	EndIf
EndFunction

Function DisableNoWait(bool abFade)
	Self.Cleanup()
	Parent.DisableNoWait(abFade)
EndFunction
