;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\SoundscapeEmitter.psc
Modified : 2020-10-29 01:36:43
Compiled : 2021-01-07 11:42:14
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:SoundscapeEmitter extends ObjectReference

;-- Properties --------------------------------------
simsettlementsv2:datastructures#keyworddensity[] Property ObjectDensity Auto hidden
simsettlementsv2:datastructures#weightedsound[] Property CurrentSoundArray Auto hidden
int Property iTotalDensityScore = 0 Auto hidden
bool Property bSoundArrayUpdateNeeded = True Auto hidden
Sound Property LastPlayedSound Auto hidden

;-- Variables ---------------------------------------
ObjectReference[] kTestRings

;-- Functions ---------------------------------------

Event ObjectReference.OnWorkshopObjectDestroyed(ObjectReference akDestroyedRef, ObjectReference akWorkshopRef)
	Self.UnregisterObject(akDestroyedRef)
EndEvent

Function ResetDensity()
	ObjectDensity = new simsettlementsv2:datastructures#keyworddensity[0]
	iTotalDensityScore = 0
EndFunction

Function UnregisterObject(ObjectReference akObjectRef)
	workshopobjectscript asWorkshopObject = akObjectRef as workshopobjectscript
	If (asWorkshopObject)
		Self.UnregisterForRemoteEvent(asWorkshopObject as ScriptObject, "OnWorkshopObjectDestroyed")
	EndIf
	simsettlementsv2:objectreferences:simplot asPlot = akObjectRef as simsettlementsv2:objectreferences:simplot
	int iAdjustBy = -1
	If (asPlot)
		Self.UnregisterForCustomEvent(asPlot as ScriptObject, "simsettlementsv2:objectreferences:simplot_PlotLevelChanged")
		Self.UnregisterForCustomEvent(asPlot as ScriptObject, "simsettlementsv2:objectreferences:simplot_PlotReset")
		iAdjustBy = -1 * asPlot.iCurrentLevel
	EndIf
	Self.AdjustDensity(akObjectRef, iAdjustBy)
EndFunction

Function ForcePlaySound(Sound aSound)
	EffectShader TestShader = Game.GetFormFromFile(68918, "SS2.esm") as EffectShader
	TestShader.Play(Self as ObjectReference, -1)
	aSound.PlayAndWait(Self as ObjectReference)
	TestShader.Stop(Self as ObjectReference)
EndFunction

Function ResetEmitter()
	Self.ConfigureArrays()
	iTotalDensityScore = 0
	bSoundArrayUpdateNeeded = True
	Self.Cleanup()
EndFunction

Function ConfigureArrays()
	ObjectDensity = new simsettlementsv2:datastructures#keyworddensity[0]
	CurrentSoundArray = new simsettlementsv2:datastructures#weightedsound[0]
EndFunction

Function ToggleTestRings()
	If (kTestRings == None)
		kTestRings = new ObjectReference[0]
		ObjectReference kThisRing = Self.PlaceAtMe(Game.GetFormFromFile(130363, "SS2.esm"), 1, False, False, True)
		kTestRings.add(kThisRing, 1)
		kThisRing = Self.PlaceAtMe(Game.GetFormFromFile(130362, "SS2.esm"), 1, False, False, True)
		kTestRings.add(kThisRing, 1)
		kThisRing = Self.PlaceAtMe(Game.GetFormFromFile(130361, "SS2.esm"), 1, False, False, True)
		kTestRings.add(kThisRing, 1)
	Else
		int I = 0
		While (I < kTestRings.length)
			kTestRings[I].Disable(False)
			kTestRings[I].Delete()
			I += 1
		EndWhile
		kTestRings = None
	EndIf
EndFunction

Event SimSettlementsV2:ObjectReferences:SimPlot.PlotReset(simsettlementsv2:objectreferences:simplot akSender, var[] akArgs)
	int iHoldLevel = akArgs[0] as int
	If (iHoldLevel >= 0)
		workshopframework:library:utilityfunctions.ModTraceCustom("SS2SoundScapeManager", Self as string + " received PlotReset event from plot " + akSender as string + ", iHoldLevel: " + iHoldLevel as string, 0, False)
		int iChangeDensity = iHoldLevel * -1
		If (iChangeDensity != 0)
			Self.AdjustDensity(akSender as ObjectReference, iChangeDensity)
		EndIf
	EndIf
EndEvent

Function RegisterObject(ObjectReference akObjectRef, Keyword[] aLocalDensityKeywords)
	If (ObjectDensity == None)
		Self.ConfigureArrays()
	EndIf
	int I = 0
	While (I < aLocalDensityKeywords.length)
		If (akObjectRef.HasKeyword(aLocalDensityKeywords[I]))
			int iDensityValue = 1
			simsettlementsv2:objectreferences:simplot asPlot = akObjectRef as simsettlementsv2:objectreferences:simplot
			If (asPlot)
				iDensityValue = asPlot.iCurrentLevel
				Self.RegisterForCustomEvent(asPlot as ScriptObject, "simsettlementsv2:objectreferences:simplot_PlotLevelChanged")
				Self.RegisterForCustomEvent(asPlot as ScriptObject, "simsettlementsv2:objectreferences:simplot_PlotReset")
			EndIf
			workshopobjectscript asWorkshopObject = akObjectRef as workshopobjectscript
			If (asWorkshopObject)
				Self.RegisterForRemoteEvent(asWorkshopObject as ScriptObject, "OnWorkshopObjectDestroyed")
			EndIf
			Self.AdjustKeywordDensity(aLocalDensityKeywords[I], iDensityValue)
		EndIf
		I += 1
	EndWhile
EndFunction

Function AdjustDensity(ObjectReference akObjectRef, int aiChangeBy)
	int I = 0
	While (I < ObjectDensity.length)
		If (akObjectRef.HasKeyword(ObjectDensity[I].KeywordToCheck))
			ObjectDensity[I].fDensity = ObjectDensity[I].fDensity + aiChangeBy as float
			iTotalDensityScore += aiChangeBy
		EndIf
		I += 1
	EndWhile
	If (aiChangeBy != 0)
		bSoundArrayUpdateNeeded = True
	EndIf
EndFunction

Function Delete()
	Self.Cleanup()
	Parent.Delete()
EndFunction

Event OnInit()
	Self.ConfigureArrays()
EndEvent

Event SimSettlementsV2:ObjectReferences:SimPlot.PlotLevelChanged(simsettlementsv2:objectreferences:simplot akSender, var[] akArgs)
	workshopframework:library:utilityfunctions.ModTraceCustom("SS2SoundScapeManager", Self as string + " received PlotLevelChanged event from plot " + akSender as string + ", iCurrentLevel: " + (akArgs[0] as int) as string + ", iPreviousLevel: " + (akArgs[1] as int) as string, 0, False)
	int iChangeDensity = akArgs[0] as int - akArgs[1] as int
	If (iChangeDensity != 0)
		Self.AdjustDensity(akSender as ObjectReference, iChangeDensity)
	EndIf
EndEvent

Function AdjustKeywordDensity(Keyword aKeyword, int aiChangeBy)
	If (ObjectDensity == None)
		ObjectDensity = new simsettlementsv2:datastructures#keyworddensity[0]
	EndIf
	int iIndex = ObjectDensity.findstruct("KeywordToCheck", aKeyword, 0)
	If (iIndex < 0)
		simsettlementsv2:datastructures#keyworddensity thisDensity = new simsettlementsv2:datastructures#keyworddensity
		thisDensity.KeywordToCheck = aKeyword
		thisDensity.fDensity = aiChangeBy as float
		ObjectDensity.add(thisDensity, 1)
	Else
		ObjectDensity[iIndex].fDensity = ObjectDensity[iIndex].fDensity + aiChangeBy as float
	EndIf
	iTotalDensityScore += aiChangeBy
EndFunction

int Function GetKeywordDensity(Keyword aKeyword)
	int iIndex = ObjectDensity.findstruct("KeywordToCheck", aKeyword, 0)
	If (iIndex >= 0)
		return ObjectDensity[iIndex].fDensity as int
	EndIf
	return 0
EndFunction

Function AddLayerSounds(simsettlementsv2:miscobjects:soundscapelayer aLayer)
	If (!aLayer)
		return 
	EndIf
	int iKeywordDensity = Self.GetKeywordDensity(aLayer.ObjectKeyword)
	If (iKeywordDensity >= aLayer.iDensityThreshold && (aLayer.iMaxDensity == 0 || iKeywordDensity <= aLayer.iMaxDensity))
		int I = 0
		simsettlementsv2:datastructures#weightedsound[] layerSounds = aLayer.GetWeightedSounds()
		While (I < layerSounds.length && CurrentSoundArray.length < 127 && CurrentSoundArray.findstruct("SoundToPlay", layerSounds[I].SoundToPlay, 0) < 0)
			CurrentSoundArray.add(layerSounds[I], 1)
			I += 1
		EndWhile
	EndIf
EndFunction

Function Cleanup()
	Self.UnregisterForAllEvents()
EndFunction
