;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\SubSpawner.psc
Modified : 2020-05-05 21:27:15
Compiled : 2021-01-07 11:42:09
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:SubSpawner extends ObjectReference
{ Do NOT use on Plots! Use PlotSubSpawner for that. }

;-- Properties --------------------------------------
Group Config
	workshopframework:library:datastructures#worldobject[] Property ExtraObjects Auto Const
	{ Additional objects to spawn and their relative positions/rotations to this object. IMPORTANT: Ensure a Constructible Object record exists withOUT a recipe filter to ensure these objects can be moved together with the parent in workshop mode - the easiest way to do this is to put all of these objects in a formlist and make a COBJ record for that formlist. }
EndGroup

Keyword Property WorkshopStackedItemParentKEYWORD Auto hidden
Keyword Property PreventTSExport Auto hidden
Keyword Property WorkshopItemKeyword Auto hidden
ObjectReference[] Property SpawnedObjects Auto hidden
bool Property bUpdateNeeded = False Auto hidden

;-- Variables ---------------------------------------
int iFormID_PreventTSExportKeyword = 2391846 Const
int iFormID_WorkshopItemKeyword = 347046 Const
int iFormID_WorkshopStackedItemParentKEYWORD = 1859293 Const
int UpdateSpawnsTimerID = 0 Const

;-- Functions ---------------------------------------

Event OnInit()
	SpawnedObjects = new ObjectReference[0]
	bUpdateNeeded = True
	Self.UpdateVars()
	Parent.OnInit()
EndEvent

Event OnWorkshopObjectDestroyed(ObjectReference akReference)
	Self.DeleteSpawns()
	Parent.OnWorkshopObjectDestroyed(akReference)
EndEvent

Event OnRelease()
	Self.UpdateSpawns()
EndEvent

Event OnWorkshopObjectMoved(ObjectReference akWorkshopRef)
	Self.UpdateSpawns()
	Parent.OnWorkshopObjectMoved(akWorkshopRef)
EndEvent

Function DeleteSpawns()
	int I = 0
	While (I < SpawnedObjects.length)
		SpawnedObjects[I].SetLinkedRef(None, WorkshopStackedItemParentKEYWORD)
		SpawnedObjects[I].Disable(False)
		SpawnedObjects[I].Delete()
		I += 1
	EndWhile
	SpawnedObjects = new ObjectReference[0]
	ObjectReference[] Linked = Self.GetLinkedRefChildren(WorkshopStackedItemParentKEYWORD)
	I = 0
	While (I < Linked.length)
		Linked[I].SetLinkedRef(None, WorkshopStackedItemParentKEYWORD)
		Linked[I].Disable(False)
		Linked[I].Delete()
		I += 1
	EndWhile
EndFunction

Function UpdateVars()
	If (!WorkshopStackedItemParentKEYWORD)
		WorkshopStackedItemParentKEYWORD = Game.GetFormFromFile(iFormID_WorkshopStackedItemParentKEYWORD, "Fallout4.esm") as Keyword
	EndIf
	If (!PreventTSExport)
		PreventTSExport = Game.GetFormFromFile(iFormID_PreventTSExportKeyword, "Fallout4.esm") as Keyword
	EndIf
	If (!WorkshopItemKeyword)
		WorkshopItemKeyword = Game.GetFormFromFile(iFormID_WorkshopItemKeyword, "Fallout4.esm") as Keyword
	EndIf
EndFunction

Function Disable(bool abFade)
	Self.DeleteSpawns()
	Parent.Disable(abFade)
EndFunction

Function enable(bool abFade)
	Self.UpdateSpawns()
	Parent.enable(abFade)
EndFunction

Function UpdateSpawns()
	If (!Self.is3dLoaded())
		bUpdateNeeded = True
		return 
	EndIf
	Self.DeleteSpawns()
	int I = 0
	workshopscript thisWorkshop = Self.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	While (I < ExtraObjects.length && !Self.IsDisabled())
		Form FormToSpawn = workshopframework:library:utilityfunctions.GetWorldObjectForm(ExtraObjects[I], -1)
		If (FormToSpawn != None)
			ObjectReference spawn = Self.PlaceAtMe(FormToSpawn, 1, False, True, True)
			spawn.AddKeyword(PreventTSExport)
			If (spawn)
				float[] pfPositionOffset = new float[3]
				float[] pfRotationOffset = new float[3]
				pfPositionOffset[0] = ExtraObjects[I].fPosX
				pfPositionOffset[1] = ExtraObjects[I].fPosY
				pfPositionOffset[2] = ExtraObjects[I].fPosZ
				pfRotationOffset[0] = ExtraObjects[I].fAngleX
				pfRotationOffset[1] = ExtraObjects[I].fAngleY
				pfRotationOffset[2] = ExtraObjects[I].fAngleZ
				If (spawn is Actor)
					spawn.enable(False)
				EndIf
				workshopframework:library:thirdparty:cobb:cobblibraryrotations.MoveObjectRelativeToObject(spawn, Self as ObjectReference, pfPositionOffset, pfRotationOffset)
				If (ExtraObjects[I].fScale > 0 as float)
					spawn.SetScale(ExtraObjects[I].fScale)
				EndIf
				If (thisWorkshop as bool && !FormToSpawn as Static)
					spawn.SetLinkedRef(thisWorkshop as ObjectReference, WorkshopItemKeyword)
				EndIf
				spawn.enable(False)
				SpawnedObjects.add(spawn, 1)
				spawn.SetLinkedRef(Self as ObjectReference, WorkshopStackedItemParentKEYWORD)
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction

Function Delete()
	Self.DeleteSpawns()
	Parent.Delete()
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == UpdateSpawnsTimerID)
		Self.UpdateSpawns()
	EndIf
EndEvent

Event OnLoad()
	If (Self.IsDisabled())
		return 
	EndIf
	Self.UpdateVars()
	workshopscript thisWorkshop = Self.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	If (!thisWorkshop)
		Utility.Wait(2)
		Self.OnLoad()
		return 
	EndIf
	If (bUpdateNeeded)
		Self.UpdateSpawns()
		bUpdateNeeded = False
	EndIf
	Parent.OnLoad()
EndEvent
