;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\TerraformBlock.psc
Modified : 2020-10-15 15:09:13
Compiled : 2021-01-07 11:42:25
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:TerraformBlock extends WorkshopObjectScript

;-- Properties --------------------------------------
Form Property CornerPiece Auto Const mandatory
Form Property EdgePiece Auto Const mandatory
float Property fWidth = 512 Auto Const
{ The unit width of your block - this is used to calculate the relative positions of the edge and corner pieces }
Keyword Property WorkshopStackedItemKeyword Auto hidden
Keyword Property WorkshopItemKeyword Auto hidden
Keyword Property TerraformerLinkKeyword Auto hidden
Keyword Property TerraformBlockKeyword Auto hidden
Keyword Property CityPlanSpawnKeyword Auto hidden
Form Property WSFWXMarker Auto hidden
GlobalVariable Property Setting_AutoplaceGradingDelay Auto hidden
GlobalVariable Property Setting_AutoplaceGrading Auto hidden
GlobalVariable Property Setting_AutoplaceGradingRemoveAll Auto hidden

;-- Variables ---------------------------------------
ObjectReference kLinkedRefHolder
bool bGradingCreated = False
bool bStackedItem = False
bool bPlacedByPlayer = False

;-- Functions ---------------------------------------

Function PlaceGrading()
	ObjectReference kStackedParentRef = Self.GetLinkedRef(WorkshopStackedItemKeyword)
	If (kStackedParentRef != None)
		simsettlementsv2:objectreferences:simplot asPlot = kStackedParentRef as simsettlementsv2:objectreferences:simplot
		If (asPlot)
			bPlacedByPlayer = True
			If (asPlot.bIsDestroyed)
				return 
			EndIf
			If (asPlot as bool && asPlot.bGrabbed)
				Self.StartTimer(3, 0)
				return 
			EndIf
		EndIf
	EndIf
	If (bGradingCreated || !bPlacedByPlayer || Self.IsDisabled() || Self.HasKeyword(CityPlanSpawnKeyword))
		bGradingCreated = True
		return 
	EndIf
	If (!kLinkedRefHolder)
		kLinkedRefHolder = Self.PlaceAtMe(WSFWXMarker, 1, False, False, False)
	EndIf
	bGradingCreated = True
	bool[] bGrades = Self.ShouldCreateGradingPieces()
	int I = 0
	float fAngle = 0 as float
	bool bEdge = False
	While (I < bGrades.length)
		If (bGrades[I])
			Self.PlaceGrade(bEdge, fAngle)
		EndIf
		If (!bEdge)
			bEdge = True
		Else
			bEdge = False
		EndIf
		If (I as float / 2 != Math.Floor(I as float / 2) as float)
			fAngle += 90
		EndIf
		I += 1
	EndWhile
EndFunction

Event OnWorkshopObjectGrabbed(ObjectReference akReference)
	Self.CancelTimer(0)
	If (!bStackedItem)
		Self.Cleanup()
		Parent.OnWorkshopObjectDestroyed(akReference)
	EndIf
EndEvent

Event OnLoad()
	If (Self.IsDisabled())
		return 
	EndIf
	Self.UpdateVars()
	If (!bGradingCreated)
		ObjectReference[] kExtras = Self.GetLinkedRefChildren(TerraformerLinkKeyword)
		If (kExtras.length > 0)
			Self.Cleanup()
		EndIf
	EndIf
	Self.StartTimer(Setting_AutoplaceGradingDelay.GetValue(), 0)
	Parent.OnLoad()
EndEvent

Event OnWorkshopObjectPlaced(ObjectReference akReference)
	bPlacedByPlayer = True
EndEvent

Event OnTimer(int aiTimerID)
	If (Setting_AutoplaceGrading.GetValue() == 1)
		Self.PlaceGrading()
	EndIf
	Parent.OnTimer(aiTimerID)
EndEvent

bool Function PositionHasBlock(ObjectReference akCheckRef, float[] afPosition)
	akCheckRef.SetPosition(afPosition[0], afPosition[1], afPosition[2])
	ObjectReference[] kTerraBlocks = akCheckRef.FindAllReferencesWithKeyword(TerraformBlockKeyword as Form, 10)
	If (kTerraBlocks.length > 0)
		return True
	Else
		return False
	EndIf
EndFunction

Function DisableNoWait(bool abFade)
	Self.CancelTimer(0)
	Self.Cleanup()
	Parent.DisableNoWait(abFade)
EndFunction

Function Cleanup()
	If (Setting_AutoplaceGradingRemoveAll.GetValue() == 1)
		bGradingCreated = False
		ObjectReference[] kExtras = None
		If (kLinkedRefHolder != None)
			kExtras = kLinkedRefHolder.GetLinkedRefChildren(TerraformerLinkKeyword)
		Else
			kExtras = Self.GetLinkedRefChildren(TerraformerLinkKeyword)
		EndIf
		int I = 0
		While (I < kExtras.length)
			kExtras[I].SetLinkedRef(None, WorkshopItemKeyword)
			kExtras[I].SetLinkedRef(None, TerraformerLinkKeyword)
			kExtras[I].SetLinkedRef(None, WorkshopStackedItemKeyword)
			kExtras[I].Disable(False)
			kExtras[I].Delete()
			I += 1
		EndWhile
	EndIf
	If (kLinkedRefHolder != None)
		kLinkedRefHolder.Disable(False)
		kLinkedRefHolder.Delete()
		kLinkedRefHolder = None
	EndIf
EndFunction

Function UpdateVars()
	string sSS2Plugin = simsettlementsv2:utilityfunctions.GetPluginName()
	If (!WorkshopStackedItemKeyword)
		WorkshopStackedItemKeyword = Game.GetFormFromFile(1859293, "Fallout4.esm") as Keyword
	EndIf
	If (!WorkshopItemKeyword)
		WorkshopItemKeyword = Game.GetFormFromFile(347046, "Fallout4.esm") as Keyword
	EndIf
	If (!TerraformerLinkKeyword)
		TerraformerLinkKeyword = Game.GetFormFromFile(103415, sSS2Plugin) as Keyword
	EndIf
	If (!WSFWXMarker)
		WSFWXMarker = Game.GetFormFromFile(17665, "WorkshopFramework.esm")
	EndIf
	If (!TerraformBlockKeyword)
		TerraformBlockKeyword = Game.GetFormFromFile(103416, sSS2Plugin) as Keyword
	EndIf
	If (!CityPlanSpawnKeyword)
		CityPlanSpawnKeyword = Game.GetFormFromFile(88038, sSS2Plugin) as Keyword
	EndIf
	If (!Setting_AutoplaceGradingDelay)
		Setting_AutoplaceGradingDelay = Game.GetFormFromFile(82421, sSS2Plugin) as GlobalVariable
	EndIf
	If (!Setting_AutoplaceGrading)
		Setting_AutoplaceGrading = Game.GetFormFromFile(82420, sSS2Plugin) as GlobalVariable
	EndIf
	If (!Setting_AutoplaceGradingRemoveAll)
		Setting_AutoplaceGradingRemoveAll = Game.GetFormFromFile(82422, sSS2Plugin) as GlobalVariable
	EndIf
EndFunction

Event OnWorkshopObjectDestroyed(ObjectReference akReference)
	Self.GoToState("Destroyed")
	Self.CancelTimer(0)
	Self.Cleanup()
	Parent.OnWorkshopObjectDestroyed(akReference)
EndEvent

Function Delete()
	Self.GoToState("Destroyed")
EndFunction

bool[] Function ShouldCreateGradingPieces()
	bool[] bCreate = new bool[0]
	float[] fMyPosition = new float[3]
	float[] fMyRotation = new float[3]
	float[] fCheckOffset = new float[3]
	float[] fCheckRotationOffset = new float[3]
	float[] TargetCoordinates = new float[6]
	fMyPosition[0] = Self.X
	fMyPosition[1] = Self.Y
	fMyPosition[2] = Self.Z
	fMyRotation[0] = Self.GetAngleX()
	fMyRotation[1] = Self.GetAngleY()
	fMyRotation[2] = Self.GetAngleZ()
	fCheckOffset[0] = 0
	fCheckOffset[1] = 0
	fCheckOffset[2] = 0
	fCheckRotationOffset[0] = 0
	fCheckRotationOffset[1] = 0
	fCheckRotationOffset[2] = 0
	ObjectReference kCheck = Self.PlaceAtMe(WSFWXMarker, 1, False, False, True)
	fCheckOffset[0] = (-1) as float * fWidth
	fCheckOffset[1] = fWidth
	TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
	bCreate.add(!Self.PositionHasBlock(kCheck, TargetCoordinates), 1)
	If (bCreate[bCreate.length - 1])
		float fCheckX = fWidth - fWidth / 4 as float
		While (fCheckX > 0 as float && bCreate[bCreate.length - 1])
			fCheckOffset[0] = (-1) as float * fCheckX
			fCheckOffset[1] = fWidth
			TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
			bCreate[bCreate.length - 1] = !Self.PositionHasBlock(kCheck, TargetCoordinates)
			fCheckX -= fWidth / 4 as float
		EndWhile
		float fCheckY = fWidth - fWidth / 4 as float
		While (fCheckY > 0 as float && bCreate[bCreate.length - 1])
			fCheckOffset[0] = (-1) as float * fWidth
			fCheckOffset[1] = fCheckY
			TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
			bCreate[bCreate.length - 1] = !Self.PositionHasBlock(kCheck, TargetCoordinates)
			fCheckY -= fWidth / 4 as float
		EndWhile
	EndIf
	fCheckOffset[0] = 0
	fCheckOffset[1] = fWidth
	TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
	bCreate.add(!Self.PositionHasBlock(kCheck, TargetCoordinates), 1)
	fCheckOffset[0] = fWidth
	fCheckOffset[1] = fWidth
	TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
	bCreate.add(!Self.PositionHasBlock(kCheck, TargetCoordinates), 1)
	If (bCreate[bCreate.length - 1])
		float fcheckx = fWidth - fWidth / 4 as float
		While (fcheckx > 0 as float && bCreate[bCreate.length - 1])
			fCheckOffset[0] = fcheckx
			fCheckOffset[1] = fWidth
			TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
			bCreate[bCreate.length - 1] = !Self.PositionHasBlock(kCheck, TargetCoordinates)
			fcheckx -= fWidth / 4 as float
		EndWhile
		float fchecky = fWidth - fWidth / 4 as float
		While (fchecky > 0 as float && bCreate[bCreate.length - 1])
			fCheckOffset[0] = fWidth
			fCheckOffset[1] = fchecky
			TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
			bCreate[bCreate.length - 1] = !Self.PositionHasBlock(kCheck, TargetCoordinates)
			fchecky -= fWidth / 4 as float
		EndWhile
	EndIf
	fCheckOffset[0] = fWidth
	fCheckOffset[1] = 0
	TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
	bCreate.add(!Self.PositionHasBlock(kCheck, TargetCoordinates), 1)
	fCheckOffset[0] = fWidth
	fCheckOffset[1] = (-1) as float * fWidth
	TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
	bCreate.add(!Self.PositionHasBlock(kCheck, TargetCoordinates), 1)
	If (bCreate[bCreate.length - 1])
		float fcheckx = fWidth - fWidth / 4 as float
		While (fcheckx > 0 as float && bCreate[bCreate.length - 1])
			fCheckOffset[0] = fcheckx
			fCheckOffset[1] = (-1) as float * fWidth
			TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
			bCreate[bCreate.length - 1] = !Self.PositionHasBlock(kCheck, TargetCoordinates)
			fcheckx -= fWidth / 4 as float
		EndWhile
		float fchecky = fWidth - fWidth / 4 as float
		While (fchecky > 0 as float && bCreate[bCreate.length - 1])
			fCheckOffset[0] = fWidth
			fCheckOffset[1] = (-1) as float * fchecky
			TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
			bCreate[bCreate.length - 1] = !Self.PositionHasBlock(kCheck, TargetCoordinates)
			fchecky -= fWidth / 4 as float
		EndWhile
	EndIf
	fCheckOffset[0] = 0
	fCheckOffset[1] = (-1) as float * fWidth
	TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
	bCreate.add(!Self.PositionHasBlock(kCheck, TargetCoordinates), 1)
	fCheckOffset[0] = (-1) as float * fWidth
	fCheckOffset[1] = (-1) as float * fWidth
	TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
	bCreate.add(!Self.PositionHasBlock(kCheck, TargetCoordinates), 1)
	If (bCreate[bCreate.length - 1])
		float fcheckx = fWidth - fWidth / 4 as float
		While (fcheckx > 0 as float && bCreate[bCreate.length - 1])
			fCheckOffset[0] = (-1) as float * fcheckx
			fCheckOffset[1] = (-1) as float * fWidth
			TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
			bCreate[bCreate.length - 1] = !Self.PositionHasBlock(kCheck, TargetCoordinates)
			fcheckx -= fWidth / 4 as float
		EndWhile
		float fchecky = fWidth - fWidth / 4 as float
		While (fchecky > 0 as float && bCreate[bCreate.length - 1])
			fCheckOffset[0] = (-1) as float * fWidth
			fCheckOffset[1] = (-1) as float * fchecky
			TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
			bCreate[bCreate.length - 1] = !Self.PositionHasBlock(kCheck, TargetCoordinates)
			fchecky -= fWidth / 4 as float
		EndWhile
	EndIf
	fCheckOffset[0] = (-1) as float * fWidth
	fCheckOffset[1] = 0
	TargetCoordinates = workshopframework:library:thirdparty:cobb:cobblibraryrotations.GetCoordinatesRelativeToBase(fMyPosition, fMyRotation, fCheckOffset, fCheckRotationOffset)
	bCreate.add(!Self.PositionHasBlock(kCheck, TargetCoordinates), 1)
	kCheck.Disable(False)
	kCheck.Delete()
	kCheck = None
	If (!bCreate[1])
		bCreate[0] = False
		bCreate[2] = False
	EndIf
	If (!bCreate[3])
		bCreate[2] = False
		bCreate[4] = False
	EndIf
	If (!bCreate[5])
		bCreate[4] = False
		bCreate[6] = False
	EndIf
	If (!bCreate[7])
		bCreate[6] = False
		bCreate[0] = False
	EndIf
	return bCreate
EndFunction

Function Disable(bool abFade)
	Self.CancelTimer(0)
	Self.Cleanup()
	Parent.Disable(abFade)
EndFunction

Function PlaceGrade(bool abEdge, float afAngle)
	If (Self.IsDisabled())
		return 
	EndIf
	Form PlaceForm = CornerPiece
	If (abEdge)
		PlaceForm = EdgePiece
	EndIf
	ObjectReference kPositionHelper = Self.PlaceAtMe(WSFWXMarker, 1, False, False, True)
	kPositionHelper.SetAngle(Self.GetAngleX(), Self.GetAngleY(), Self.GetAngleZ() + afAngle)
	ObjectReference kGradePiece = kPositionHelper.PlaceAtMe(PlaceForm, 1, False, False, False)
	kGradePiece.SetLinkedRef(Self.GetLinkedRef(WorkshopItemKeyword), WorkshopItemKeyword)
	If (kLinkedRefHolder != None)
		kGradePiece.SetLinkedRef(kLinkedRefHolder, TerraformerLinkKeyword)
	Else
		kGradePiece.SetLinkedRef(Self as ObjectReference, TerraformerLinkKeyword)
	EndIf
	kGradePiece.SetLinkedRef(Self as ObjectReference, WorkshopStackedItemKeyword)
	bStackedItem = True
	kPositionHelper.Disable(False)
	kPositionHelper.Delete()
EndFunction

Event OnWorkshopObjectMoved(ObjectReference akReference)
	If (!bStackedItem || !bGradingCreated)
		Self.StartTimer(Setting_AutoplaceGradingDelay.GetValue(), 0)
	EndIf
	Parent.OnWorkshopObjectMoved(akReference)
EndEvent

;-- State -------------------------------------------
State Destroyed

	Function PlaceGrading()
		; Empty function
	EndFunction

	Event OnLoad()
		; Empty function
	EndEvent

	Event OnTimer(int aiTimerID)
		; Empty function
	EndEvent

	Function PlaceGrade(bool abEdge, float afAngle)
		; Empty function
	EndFunction
EndState
