;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\TeslaCoilEffect.psc
Modified : 2020-05-12 12:39:07
Compiled : 2021-01-07 11:42:18
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:TeslaCoilEffect extends ObjectReference

;-- Properties --------------------------------------
Form Property LightingBoltTargetForm Auto Const
Form Property OriginMarkerForm Auto Const
float Property fMinFrequency = 30 Auto Const
float Property fMaxFrequency = 50 Auto Const
float Property fMinLightningFrequency = 0.5 Auto Const
float Property fMaxLightningFrequency = 3 Auto Const
Spell Property LightningBolt Auto Const
Sound Property LightingSFX Auto Const
workshopframework:library:datastructures#worldobject[] Property LightningPointData Auto Const
float Property fLightningHeight = 1000 Auto hidden

;-- Variables ---------------------------------------
int iLightingTimer = 2
ObjectReference[] LightningEmitters
int iTeslaTimer = 0
ObjectReference[] LightningTargets
int iStormTimer = 1
bool bActive = False

;-- Functions ---------------------------------------

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTeslaTimer)
		Self.PlayTeslaEffect()
		Self.StartTimer(Utility.RandomFloat(fMinFrequency, fMaxFrequency), iTeslaTimer)
	ElseIf (aiTimerID == iLightingTimer)
		Self.PlayLightingEffects()
	EndIf
EndEvent

Function Disable(bool abFade)
	int I = 0
	While (I < LightningEmitters.length)
		LightningEmitters[I].Disable(False)
		LightningEmitters[I].Delete()
		LightningEmitters[I] = None
		I += 1
	EndWhile
	LightningEmitters = new ObjectReference[0]
	Parent.Disable(abFade)
EndFunction

Function CancelEffects()
	Self.CancelTimer(iTeslaTimer)
	Self.CancelTimer(iStormTimer)
	Self.CancelTimer(iLightingTimer)
	bActive = False
EndFunction

Function PlayLightingEffects()
	If (!bActive)
		return 
	EndIf
	int[] RandomizedIndexes = workshopframework:library:utilityfunctions.GenerateRandomizedIntegerRangeArray(0, LightningTargets.length - 1)
	int I = 0
	While (I < LightningEmitters.length)
		int j = 0
		While (j < RandomizedIndexes.length)
			ObjectReference TargetRef = LightningTargets[RandomizedIndexes[j]]
			LightningBolt.Cast(LightningEmitters[I], TargetRef)
			Utility.Wait(Utility.RandomFloat(0, 0.5))
			j += 1
		EndWhile
		I += 1
	EndWhile
	Self.StartTimer(Utility.RandomFloat(0.4, 1), iLightingTimer)
EndFunction

Event OnLoad()
	If (LightningEmitters.length < LightningPointData.length)
		float fOriginalAngle = Self.GetAngleZ()
		Self.SetAngle(Self.GetAngleX(), Self.GetAngleY(), 0)
		LightningEmitters = new ObjectReference[0]
		int I = 0
		While (I < LightningPointData.length)
			ObjectReference OriginRef = Self.PlaceAtMe(OriginMarkerForm, 1, False, False, True)
			If (OriginRef)
				float[] pfPositionOffset = new float[3]
				float[] pfRotationOffset = new float[3]
				pfPositionOffset[0] = LightningPointData[I].fPosX
				pfPositionOffset[1] = LightningPointData[I].fPosY
				pfPositionOffset[2] = LightningPointData[I].fPosZ + 200
				pfRotationOffset[0] = LightningPointData[I].fAngleX
				pfRotationOffset[1] = LightningPointData[I].fAngleY
				pfRotationOffset[2] = LightningPointData[I].fAngleZ
				workshopframework:library:thirdparty:cobb:cobblibraryrotations.MoveObjectRelativeToObject(OriginRef, Self as ObjectReference, pfPositionOffset, pfRotationOffset)
				LightningEmitters.add(OriginRef, 1)
			EndIf
			I += 1
		EndWhile
		Self.SetAngle(Self.GetAngleX(), Self.GetAngleY(), fOriginalAngle)
	EndIf
	Self.StartTimer(1, iTeslaTimer)
EndEvent

Function PlayTeslaEffect()
	bActive = True
	ObjectReference[] TempTargets = Self.FindAllReferencesOfType(LightingBoltTargetForm, 10240)
	LightningTargets = new ObjectReference[0]
	int I = 0
	While (I < TempTargets.length)
		If (!TempTargets[I].IsDisabled())
			LightningTargets.add(TempTargets[I], 1)
		EndIf
		I += 1
	EndWhile
	Self.StartTimer(0.2, iLightingTimer)
	If (!Self.is3dLoaded())
		Self.CancelEffects()
		return 
	Else
		Self.PlayAnimation("Reset")
		Self.PlayAnimation("Powered")
	EndIf
	If (!Self.is3dLoaded())
		Self.CancelEffects()
		return 
	Else
		Utility.Wait(5)
		Self.PlayAnimation("Stage3")
	EndIf
EndFunction

Event OnUnload()
	bActive = False
EndEvent
