;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\ThemeControlledObject.psc
Modified : 2020-07-15 15:19:07
Compiled : 2021-01-07 11:42:27
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:ThemeControlledObject extends ObjectReference
{ IMPORTANT - Be sure to add keyword SS2_Tag_ThemeControlledObject to this object. Object that handles placing subobject based on a centrally controlled theme of some sort. }

;-- Properties --------------------------------------
Group Required
	simsettlementsv2:miscobjects:themeruleset Property ThemeRuleSet Auto Const mandatory
	{ Determines which group of ThemeDefinitions this should be accessing. }
	string Property ThemeScript Auto Const mandatory
	{ The ScriptName on theme definitions this object is looking for, ex. "SimSettlementsV2:Armors:ThemeDefinition_Flags". }
	string Property ThemePropertyName Auto Const mandatory
	{ The property name that holds the object form this wants to place from the SimSettlementsV2:Amors:ThemeDefinition that is active. }
	Form Property DefaultForm Auto Const
	{ The default object to spawn if the active theme doesn't have a form defined for the ThemePropertyName this is requesting. }
EndGroup

Group Options
	float[] Property Adjust3dData Auto Const
	{ [Optional] By default, these spawned objects will be positioned, rotated, and scaled based on the position, rotation, and scale of this controller object. Filling in this field allows overriding that behavior and instead changing those values. 7 entries, OffsetPositionX/OffsetPositionY/OffsetPositionZ/OffsetRotationX/OffsetRotationY/OffsetRotationZ/Scale. If only 3 entries are set, position will be adjusted; if only 6 entries are set, position and rotation will be adjusted; if 7 entries are set, position, rotation, and scale will be set. Note that all of these values are set relative to this controller object, including scale. }
EndGroup

simsettlementsv2:armors:themedefinition Property CurrentTheme Auto hidden
bool Property bFromPlot = False Auto hidden
ObjectReference Property kSpawnedRef Auto hidden
bool Property bInitialLoad = True Auto hidden

;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

Function ChangeTheme(simsettlementsv2:armors:themedefinition aNewTheme, bool abForceUpdate)
	bool bUpdateNeeded = abForceUpdate == True || CurrentTheme != aNewTheme
	CurrentTheme = aNewTheme
	If (bUpdateNeeded)
		Self.UpdateObject()
	EndIf
EndFunction

Event OnWorkshopObjectPlaced(ObjectReference akReference)
	CurrentTheme = ThemeRuleSet.GetInitialDefinition(akReference as workshopscript)
EndEvent

Event OnWorkshopObjectDestroyed(ObjectReference akReference)
	Self.DeleteObject()
EndEvent

Function Delete()
	Self.DeleteObject()
	Parent.Delete()
EndFunction

Event OnInit()
	float fTimer = 0.5
	If (bFromPlot)
		fTimer = 3
	EndIf
	Self.StartTimer(fTimer, 0)
EndEvent

Event OnLoad()
	If (bInitialLoad)
		bInitialLoad = False
		If (CurrentTheme == None)
			CurrentTheme = ThemeRuleSet.GetInitialDefinition(workshopframework:wsfw_api.GetNearestWorkshop(Self as ObjectReference))
		EndIf
	EndIf
EndEvent

Event OnRelease()
	Self.UpdateObject()
EndEvent

Function DeleteObject()
	If (kSpawnedRef)
		kSpawnedRef.Disable(False)
		kSpawnedRef.Delete()
	EndIf
	kSpawnedRef = None
EndFunction

Event OnTimer(int aiTimerID)
	Self.UpdateObject()
EndEvent

Function Disable(bool abFade)
	Self.DeleteObject()
	Parent.Disable(abFade)
EndFunction

Function UpdateObject()
	Self.DeleteObject()
	If (Self.IsDeleted())
		return 
	EndIf
	Form SpawnMe = DefaultForm
	If (CurrentTheme != None && ThemePropertyName != "" && ThemeScript != "")
		Form tempForm = CurrentTheme.CastAs(ThemeScript).GetPropertyValue(ThemePropertyName) as Form
		If (tempForm != None)
			SpawnMe = tempForm
		EndIf
	EndIf
	FormList asFormlist = SpawnMe as FormList
	If (asFormlist != None)
		SpawnMe = asFormlist.GetAt(Utility.RandomInt(0, asFormlist.GetSize() - 1))
	EndIf
	If (SpawnMe == None)
		return 
	EndIf
	kSpawnedRef = Self.PlaceAtMe(SpawnMe, 1, False, True, True)
	If (Adjust3dData.length >= 3)
		float[] pfPositionOffset = new float[3]
		float[] pfRotationOffset = new float[3]
		pfPositionOffset[0] = Adjust3dData[0]
		pfPositionOffset[1] = Adjust3dData[1]
		pfPositionOffset[2] = Adjust3dData[2]
		If (Adjust3dData.length >= 6)
			pfRotationOffset[0] = Adjust3dData[3]
			pfRotationOffset[1] = Adjust3dData[4]
			pfRotationOffset[2] = Adjust3dData[5]
		Else
			pfRotationOffset[0] = 0
			pfRotationOffset[1] = 0
			pfRotationOffset[2] = 0
			kSpawnedRef.SetAngle(Self.GetAngleX(), Self.GetAngleY(), Self.GetAngleZ())
		EndIf
		workshopframework:library:thirdparty:cobb:cobblibraryrotations.MoveObjectRelativeToObject(kSpawnedRef, Self as ObjectReference, pfPositionOffset, pfRotationOffset)
		If (Adjust3dData.length > 6)
			kSpawnedRef.SetScale(Self.GetScale() * Adjust3dData[6])
		Else
			kSpawnedRef.SetScale(Self.GetScale())
		EndIf
	Else
		kSpawnedRef.SetScale(Self.GetScale())
		kSpawnedRef.SetAngle(Self.GetAngleX(), Self.GetAngleY(), Self.GetAngleZ())
	EndIf
	kSpawnedRef.enable(False)
EndFunction

Function DisableNoWait(bool abFade)
	Self.DeleteObject()
	Parent.DisableNoWait(abFade)
EndFunction

Event OnWorkshopObjectMoved(ObjectReference akReference)
	Self.UpdateObject()
EndEvent
