;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\kgSIM_SP20L3_Button.psc
Modified : 2019-12-03 07:17:44
Compiled : 2021-01-07 11:40:45
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:kgSIM_SP20L3_Button extends ObjectReference

;-- Properties --------------------------------------
Group Required_Properties
	Message Property ToggleButtonInactiveMessage Auto
	{ Failure message to display if the player presses the button while it's in its inactive state. Can be changed via script if desired. }
	string Property animationName = "Press" Auto Const
	{ Animation to play when the button is activated. }
	Door Property ItemHatchForm Auto Const
	Form[] Property ItemToCreate Auto Const
	float[] Property ItemToCreate3dData Auto Const
	Message Property MissingIngredientsMessage Auto Const
EndGroup

Group Optional_Properties
	bool Property startsActive = False Auto Const
	{ Should the button start in the Active state? Default: False }
	bool Property playerActivationOnly = False Auto Const
	{ Should we block follower activation of this button? Default: False }
	bool Property shouldAutoReset = False Auto Const
	{ Should the button automatically return to the Inactive state after being pressed while in the active state? Assuming no other scripting, this effectively makes the button single-use. Default: False }
	Keyword Property LinkedRefToActivate Auto Const
	{ Keyword of a linked ref to activate when the button is successfully pressed. If None, don't activate anything. }
	string Property inactiveStateAnimation = "TurnOff01" Auto Const
	{ Name for the animation event called when the button enters the Inactive state. Default="Red" }
	string Property activeStateAnimation = "TurnOn01" Auto Const
	{ Name for the animation event called when the button enters the Active state. Default="Green" }
	Form[] Property Ingredients Auto Const
	int[] Property IngredientCounts Auto Const
	Sound Property AmbientSound Auto Const
	float Property AmbientVolume = 1 Auto Const
	Sound[] Property SoundsToPlay Auto Const
	Form Property SoundSourceForm Auto Const
EndGroup


;-- Variables ---------------------------------------
bool animationStateInactive = True
int SoundID
ObjectReference ItemHatch
ObjectReference SoundSource
bool firstTime = True
bool shouldBeActiveNext = False

;-- Functions ---------------------------------------

Function SetBusy(bool shouldBeBusy, bool returnToActive)
	Self.WaitFor3DLoad()
	If (shouldBeBusy)
		If (Self.GetState() != "Busy")
			Self.BlockActivation(True, False)
			Self.GoToState("Busy")
		EndIf
	Else
		Self.SetActive(returnToActive)
	EndIf
EndFunction

Event OnLoad()
	If (!ItemHatch || !SoundSource)
		Self.SetNoFavorAllowed(playerActivationOnly)
		Self.SetActive(startsActive)
		ItemHatch = Game.FindClosestReferenceOfTypeFromRef(ItemHatchForm as Form, Self as ObjectReference, 500)
		SoundSource = Game.FindClosestReferenceOfTypeFromRef(SoundSourceForm, Self as ObjectReference, 500)
	EndIf
EndEvent

Event OnPowerOn(ObjectReference akGenerator)
	Self.SetActive(True)
	If (AmbientSound)
		If (!SoundSource)
			SoundSource = Self as ObjectReference
		EndIf
		SoundID = AmbientSound.Play(SoundSource)
		Sound.SetInstanceVolume(SoundID, AmbientVolume)
	EndIf
EndEvent

Event OnPowerOff()
	Self.SetActive(False)
	Sound.StopInstance(SoundID)
EndEvent

Function SetActiveNoWait(bool shouldBeActive)
	shouldBeActiveNext = shouldBeActive
	Self.StartTimer(0 as float, 0)
EndFunction

Function SetActive(bool shouldBeActive)
	Self.WaitFor3DLoad()
	If (shouldBeActive)
		If (Self.GetState() != "Active")
			If (animationStateInactive)
				Self.PlayAnimationAndWait(activeStateAnimation, "End")
				animationStateInactive = False
			EndIf
			Self.BlockActivation(False, False)
			Self.GoToState("Active")
		EndIf
	ElseIf (Self.GetState() != "Inactive")
		If (!animationStateInactive)
			Self.PlayAnimationAndWait(inactiveStateAnimation, "End")
			animationStateInactive = True
		EndIf
		Self.BlockActivation(True, False)
		Self.GoToState("Inactive")
	EndIf
EndFunction

Event OnTimer(int timerID)
	Self.SetActive(shouldBeActiveNext)
EndEvent

;-- State -------------------------------------------
State Active

	Event OnActivate(ObjectReference akActionRef)
		int I = 0
		Self.SetBusy(True, True)
		Self.PlayAnimationAndWait(animationName, "End")
		If (LinkedRefToActivate != None && Self.GetLinkedRef(LinkedRefToActivate) != None)
			Self.GetLinkedRef(LinkedRefToActivate).Activate(akActionRef, False)
		EndIf
		bool ingredientsFound = False
		If (firstTime)
			ingredientsFound = True
			firstTime = False
		ElseIf (Ingredients.length)
			I = 0
			bool missingIngredient = False
			While (I < Ingredients.length && !missingIngredient)
				If (IngredientCounts[I] > 0)
					If (Game.GetPlayer().GetItemCount(Ingredients[I]) < IngredientCounts[I])
						missingIngredient = True
					EndIf
				EndIf
				I += 1
			EndWhile
			If (!missingIngredient)
				I = 0
				While (I < Ingredients.length)
					Game.GetPlayer().RemoveComponents(Ingredients[I] as component, IngredientCounts[I], False)
					I += 1
				EndWhile
				ingredientsFound = True
			EndIf
		Else
			ingredientsFound = True
		EndIf
		If (ingredientsFound)
			ObjectReference spawn = Self.PlaceAtMe(ItemToCreate[Utility.RandomInt(0, ItemToCreate.length - 1)], 1, False, True, True)
			float[] pfPositionOffset = new float[3]
			float[] pfRotationOffset = new float[3]
			pfPositionOffset[0] = ItemToCreate3dData[0]
			pfPositionOffset[1] = ItemToCreate3dData[1]
			pfPositionOffset[2] = ItemToCreate3dData[2]
			pfRotationOffset[0] = ItemToCreate3dData[3]
			pfRotationOffset[1] = ItemToCreate3dData[4]
			pfRotationOffset[2] = ItemToCreate3dData[5]
			spawn.SetScale(ItemToCreate3dData[6])
			workshopframework:library:thirdparty:cobb:cobblibraryrotations.MoveObjectRelativeToObject(spawn, Self as ObjectReference, pfPositionOffset, pfRotationOffset)
			spawn.enable(False)
			If (SoundsToPlay.length > 0)
				If (!SoundSource)
					SoundSource = Self as ObjectReference
				EndIf
				I = 0
				While (I < SoundsToPlay.length)
					SoundsToPlay[I].PlayAndWait(SoundSource)
					I += 1
				EndWhile
			EndIf
			If (ItemHatch)
				ItemHatch.Activate(Game.GetPlayer() as ObjectReference, True)
				Utility.Wait(2 as float)
				ItemHatch.Activate(Game.GetPlayer() as ObjectReference, True)
			EndIf
		Else
			MissingIngredientsMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		EndIf
		If (shouldAutoReset)
			Self.SetBusy(False, False)
		Else
			Self.SetBusy(False, True)
		EndIf
	EndEvent
EndState

;-- State -------------------------------------------
State Inactive

	Event OnActivate(ObjectReference akActionRef)
		Self.SetBusy(True, True)
		Self.PlayAnimationAndWait(animationName, "End")
		ToggleButtonInactiveMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		Self.SetBusy(False, False)
	EndEvent
EndState

;-- State -------------------------------------------
State Busy

	Event OnActivate(ObjectReference akActionRef)
		; Empty function
	EndEvent
EndState
