;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\ObjectReferences\kgSIM_Spotlight.psc
Modified : 2019-12-03 07:19:56
Compiled : 2021-01-07 11:40:49
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:ObjectReferences:kgSIM_Spotlight extends ObjectReference conditional

;-- Properties --------------------------------------
Group Required_Properties
	Faction Property factionOwner Auto
	{ pick a faction who owns the spotlight, anyone hostile to this faction will trigger the spotlight }
	Light Property SpotLightForm Auto Const
	{ the light for the spotlight }
	float[] Property SpolightStartingPosition Auto Const
	float[] Property SpotlightStartingAngle Auto Const
	Quest Property myQuest Auto Const
	{ optional: quest to set a stage on when player is first spotted by light }
	int Property myQuestStage Auto Const
	{ the stage to set for myQuest when player is first spotted by light }
	bool Property startsOff = False Auto Const
	{ default = false, set to true if you want the spotlight to start inactive }
EndGroup

Group Advanced_Properties collapsedonref
	Form Property xMarkerForm Auto Const
	{ defaults to an xmarker, used for linger marker and patrol marker }
	float Property LingerOffset = 200 Auto Const
	{ defaults to 400, used as offsets for how far to move the linger marker when the light is lingering on last known location }
	float Property PatrolSpeed = 100 Auto Const
	{ defaults to 100, used for speed of patrol marker translation }
EndGroup

Group Sounds collapsedonref
	Sound Property AlarmLP Auto Const mandatory
	{ locked on state where spotlight sees actor, but hasn't sounded alarm yet }
	Sound Property Destroy Auto Const mandatory
	{ plays destroy sound effect when destroyed }
	Sound Property Reset Auto Const mandatory
	{ a quick one-off that signifies the spotlight reset }
	Sound Property SearchMotorLPM Auto Const mandatory
	{ motor loop sound for searching and sweeping back and forth, needs a start and stop event }
	Sound Property SearchingLP Auto Const mandatory
	{ searching }
	Sound Property SearchingQuick Auto Const mandatory
	{ a quick one-off for when the spotlight is searching }
	Sound Property warning Auto Const mandatory
	{ warning }
EndGroup

Group PatrolMarkers
	float[] Property MarkerAPos Auto Const
	float[] Property MarkerBPos Auto Const
EndGroup

FormList Property AggressiveFactions Auto
ObjectReference Property mySpotlightLight Auto hidden
bool Property destroyed = False Auto conditional hidden
bool Property shutdown = False Auto conditional hidden
float Property lightxrot Auto
float Property lightyrot Auto
float Property lightzrot Auto
float Property lightx Auto
float Property lighty Auto
float Property lightz Auto

;-- Variables ---------------------------------------
ObjectReference[] markerLinkedRefChain
ObjectReference MarkerB
int SearchingLPID = -1
bool panForward = True
int WarningID = -1
ObjectReference myPatrolMarker
bool myQuestStageSetDone = False
int iAlarmSFX = 1
bool busy = False conditional
bool StillAlarming
bool SetupDone = False
bool bLingering
int iAlarmFunc
ObjectReference MarkerA
int SearchMotorLPMID = -1
int iCreatePatrolMarkersTimerID = 101
int AlarmLPID = -1
bool bAlarming
int currentTargetMarker = 0

;-- Functions ---------------------------------------

Function CreatePatrolMarkers()
	If (!Self.Is3dLoaded() || Self.IsDisabled())
		return 
	EndIf
	If (mySpotlightLight == None && SpotLightForm as bool)
		float[] fPosition = new float[3]
		fPosition[0] = 0
		fPosition[1] = 0
		fPosition[2] = 0
		float[] fRotation = new float[3]
		If (SpotlightStartingAngle.length)
			fRotation[0] = SpotlightStartingAngle[0]
			fRotation[1] = SpotlightStartingAngle[1]
			fRotation[2] = SpotlightStartingAngle[2]
		Else
			fRotation[0] = 0 as float
			fRotation[1] = 0 as float
			fRotation[2] = 0 as float
		EndIf
	EndIf
	If (MarkerAPos.length == 3 && MarkerBPos.length == 3)
		float[] rotation = new float[3]
		rotation[0] = 0
		rotation[1] = 0
		rotation[2] = 0
		MarkerA = Self.PlaceAtMe(xMarkerForm, 1, False, False, True)
		workshopframework:library:thirdparty:cobb:cobblibraryrotations.MoveObjectRelativeToObject(MarkerA, Self as ObjectReference, MarkerAPos, rotation)
		Self.SetLinkedRef(MarkerA, None)
		MarkerB = Self.PlaceAtMe(xMarkerForm, 1, False, False, True)
		workshopframework:library:thirdparty:cobb:cobblibraryrotations.MoveObjectRelativeToObject(MarkerB, Self as ObjectReference, MarkerBPos, rotation)
		MarkerA.SetLinkedRef(MarkerB, None)
		markerLinkedRefChain = Self.getLinkedRefChain(None, 100)
		If (!shutdown)
			SetupDone = True
			Self.SetupDefault()
			Utility.Wait(0.1)
			SearchMotorLPMID = SearchMotorLPM.play(Self as ObjectReference)
			Self.StartPan(myPatrolMarker)
			myPatrolMarker.TranslateToRef(markerLinkedRefChain[0], PatrolSpeed * 4 as float, 0)
		EndIf
	EndIf
EndFunction

Event OnReset()
	Self.ClearDestruction()
EndEvent

Function BridgeToPan(ObjectReference detectActor)
	; Empty function
EndFunction

Function StartPan(ObjectReference akActionRef)
	; Empty function
EndFunction

Function Delete()
	If (mySpotlightLight)
		mySpotlightLight.Disable(False)
		mySpotlightLight.Delete()
	EndIf
	mySpotlightLight = None
	If (myPatrolMarker)
		myPatrolMarker.Disable(False)
		myPatrolMarker.Delete()
	EndIf
	myPatrolMarker = None
	If (MarkerA)
		MarkerA.Disable(False)
		MarkerA.Delete()
	EndIf
	MarkerA = None
	If (MarkerB)
		MarkerB.Disable(False)
		MarkerB.Delete()
	EndIf
	MarkerB = None
	If (markerLinkedRefChain.length)
		int I = 0
		While (I < markerLinkedRefChain.length)
			markerLinkedRefChain[I].Disable(False)
			markerLinkedRefChain[I].Delete()
			I += 1
		EndWhile
		markerLinkedRefChain = new ObjectReference[0]
	EndIf
	Parent.Delete()
EndFunction

Function SoundAlarm(Actor detectActor)
	; Empty function
EndFunction

Function ReadyToSwap()
	; Empty function
EndFunction

Function RestartSpotlight()
	; Empty function
EndFunction

Event ObjectReference.OnTranslationAlmostComplete(ObjectReference akSender)
	; Empty function
EndEvent

Function ClearSound()
	; Empty function
EndFunction

Function shutdown()
	; Empty function
EndFunction

Function Linger(ObjectReference detectActor)
	; Empty function
EndFunction

bool Function SetupDefault()
	return False
EndFunction

Function Alarm(Actor detectActor)
	; Empty function
EndFunction

Function SetDetectDirect(Actor detectActor)
	; Empty function
EndFunction

Function Warn(Actor detectActor)
	; Empty function
EndFunction

;-- State -------------------------------------------
State busy
EndState

;-- State -------------------------------------------
Auto State Active

	Function StartPan(ObjectReference akActionRef)
		Self.SetDirectAtTarget(akActionRef)
		Self.playAnimation("Direct01")
		busy = False
	EndFunction

	Event OnLoad()
		If (mySpotlightLight != None && !destroyed)
			If (mySpotlightLight.IsDisabled() && !Self.IsDisabled())
				mySpotlightLight.Enable(False)
			EndIf
			If (SetupDone)
				Self.BridgeToPan(None)
			EndIf
		EndIf
	EndEvent

	Event ObjectReference.OnTranslationAlmostComplete(ObjectReference akSender)
		If (!bLingering && !bAlarming && !StillAlarming)
			Self.ClearSound()
			If (!Self.IsDestroyed())
				If (SearchMotorLPMID != -1)
					SearchMotorLPMID = SearchMotorLPM.play(Self as ObjectReference)
				EndIf
				If (markerLinkedRefChain.length > 1)
					myPatrolMarker.TranslateToRef(markerLinkedRefChain[currentTargetMarker], PatrolSpeed, 0 as float)
				EndIf
				int markerChainLength = markerLinkedRefChain.length
				markerChainLength -= 1
				If (panForward == True && currentTargetMarker < markerChainLength)
					currentTargetMarker += 1
				ElseIf (panForward && currentTargetMarker >= markerChainLength)
					panForward = False
					currentTargetMarker -= 1
				ElseIf (!panForward && currentTargetMarker > 0)
					currentTargetMarker -= 1
				ElseIf (!panForward && currentTargetMarker <= 0)
					panForward = True
					currentTargetMarker += 1
				EndIf
			EndIf
		EndIf
	EndEvent

	Function ClearSound()
		If (WarningID >= 0)
			Sound.stopInstance(WarningID)
			WarningID = -1
		EndIf
		If (SearchMotorLPMID >= 0)
			Sound.stopInstance(SearchMotorLPMID)
			SearchMotorLPMID = -1
		EndIf
		If (SearchingLPID >= 0)
			Sound.stopInstance(SearchingLPID)
			SearchingLPID = -1
		EndIf
		If (!StillAlarming)
			Self.CancelTimer(iAlarmSFX)
			Self.CancelTimer(iAlarmFunc)
		EndIf
		If (AlarmLPID >= 0)
			Sound.stopInstance(AlarmLPID)
			AlarmLPID = -1
		EndIf
	EndFunction

	Function Linger(ObjectReference detectActor)
		; Empty function
	EndFunction

	Event OnActivate(ObjectReference akActionRef)
		If (mySpotlightLight)
			If (!mySpotlightLight.IsDisabled())
				mySpotlightLight.Disable(False)
				shutdown = True
				Self.shutdown()
			Else
				busy = True
				Self.SetupDefault()
			EndIf
		ElseIf (shutdown)
			busy = True
			Self.SetupDefault()
		Else
			shutdown = True
			Self.shutdown()
		EndIf
	EndEvent

	Event OnTimer(int aiTimerID)
		If (aiTimerID == iAlarmSFX && !destroyed)
			AlarmLPID = AlarmLP.play(Self as ObjectReference)
			Self.StartTimer(12 as float, iAlarmSFX)
		EndIf
		If (aiTimerID == iAlarmFunc && !destroyed)
			Self.Alarm(None)
		EndIf
		If (aiTimerID == 99)
			If (!Self.IsDisabled() && !Self.IsDestroyed() && !shutdown)
				Self.ClearSound()
				Self.shutdown()
				Self.SetupDefault()
			EndIf
		EndIf
		If (aiTimerID == iCreatePatrolMarkersTimerID)
			If (MarkerA == None || MarkerB == None)
				Self.CreatePatrolMarkers()
			EndIf
		EndIf
	EndEvent

	Function Warn(Actor detectActor)
		; Empty function
	EndFunction

	bool Function SetupDefault()
		If (!Self.Is3dLoaded())
			return False
		EndIf
		If (myPatrolMarker == None)
			myPatrolMarker = Self.PlaceAtMe(xMarkerForm, 1, False, False, True)
		EndIf
		If (shutdown)
			Self.GoToState("busy")
			shutdown = False
			Utility.Wait(1)
			Self.playAnimation("TurnOn")
			mySpotlightLight.EnableNoWait(False)
			Self.GoToState("Active")
		EndIf
		Self.RegisterForRemoteEvent(myPatrolMarker as ScriptObject, "OnTranslationAlmostComplete")
		If (markerLinkedRefChain[0])
			SearchMotorLPMID = SearchMotorLPM.play(Self as ObjectReference)
			myPatrolMarker.WaitFor3DLoad()
			If (myPatrolMarker != None)
				Self.StartPan(myPatrolMarker)
				myPatrolMarker.TranslateToRef(markerLinkedRefChain[0], PatrolSpeed * 4 as float, 0)
			EndIf
		EndIf
		return True
	EndFunction

	Event OnInit()
		Self.StartTimer(2 as float, iCreatePatrolMarkersTimerID)
	EndEvent

	Function RestartSpotlight()
		busy = True
		Self.StartTimer(0.1, 99)
	EndFunction

	Function SoundAlarm(Actor detectActor)
		; Empty function
	EndFunction

	Function BridgeToPan(ObjectReference detectActor)
		Self.ClearSound()
		Reset.play(Self as ObjectReference)
		myPatrolMarker.TranslateToRef(markerLinkedRefChain[0], PatrolSpeed, 0 as float)
		Self.SetDirectAtTarget(myPatrolMarker)
	EndFunction

	Event OnDestructionStageChanged(int aiOldStage, int aiCurrentStage)
		If (aiCurrentStage == 3)
			Self.setDestroyed(Self as bool)
			Self.activate(Self as ObjectReference, False)
			Destroy.play(Self as ObjectReference)
			Self.ApplyHavokImpulse(0 as float, 0 as float, 1 as float, 5 as float)
		EndIf
	EndEvent

	Function SetDetectDirect(Actor detectActor)
		myPatrolMarker.TranslateToRef(detectActor as ObjectReference, PatrolSpeed * 5 as float, 0)
		Self.SetDirectAtTarget(detectActor as ObjectReference)
	EndFunction

	Event OnCellLoad()
		If (MarkerA == None || MarkerB == None)
			Self.StartTimer(2 as float, iCreatePatrolMarkersTimerID)
		EndIf
		If (!Self.IsDisabled() && !destroyed)
			markerLinkedRefChain = Self.getLinkedRefChain(None, 100)
			If (startsOff && !SetupDone)
				SetupDone = True
			Else
				shutdown = False
				SetupDone = Self.SetupDefault()
			EndIf
		EndIf
	EndEvent

	Function shutdown()
		Self.GoToState("busy")
		busy = True
		Utility.Wait(0.1)
		StillAlarming = False
		bAlarming = False
		bLingering = False
		Self.ClearSound()
		If (!Self.IsDestroyed())
			Self.playAnimationandWait("TurnOff", "Done")
		EndIf
		Self.SetDirectAtTarget(None)
		myPatrolMarker.moveto(Self as ObjectReference, 0 as float, 0 as float, (-256) as float, True)
		Self.GoToState("Active")
		busy = False
	EndFunction

	Function Alarm(Actor detectActor)
		; Empty function
	EndFunction
EndState
