;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\UtilityFunctions.psc
Modified : 2021-03-17 14:15:30
Compiled : 2021-03-17 14:16:41
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName simsettlementsv2:utilityfunctions extends ScriptObject Const

;-- Functions ---------------------------------------

Function LogPlotAVRequirementFail(ObjectReference akPlotRef, workshopframework:library:datastructures#actorvalueset aAVSet) global
	string sExplanation = ""
	ActorValue thisForm = workshopframework:library:utilityfunctions.GetActorValueSetForm(aAVSet)
	If (aAVSet.iCompareMethod == -2)
		sExplanation = "less than"
	ElseIf (aAVSet.iCompareMethod == -1)
		sExplanation = "less than or equal to"
	ElseIf (aAVSet.iCompareMethod == 0)
		sExplanation = "equal to"
	ElseIf (aAVSet.iCompareMethod == 1)
		sExplanation = "greater than or equal to"
	ElseIf (aAVSet.iCompareMethod == 2)
		sExplanation = "greater than"
	EndIf
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. Plot AV Check Failed: " + akPlotRef as string + "'s " + thisForm as string + " is not " + sExplanation + " " + aAVSet.fValue as string, 0, False)
EndFunction

ActorValue Function GetSicknessAV() global
	return Game.GetFormFromFile(60275, simsettlementsv2:utilityfunctions.GetPluginName()) as ActorValue
EndFunction

Function CleanKeywordArray(Keyword[] akArray) global
	int I = akArray.length
	While (I > 0)
		int iIndex = I - 1
		If (akArray[iIndex] == None || akArray[iIndex].GetFormID() == 0)
			akArray.remove(iIndex, 1)
		EndIf
		I -= 1
	EndWhile
EndFunction

workshopscript[] Function SortWorkshopsByDistanceToRef(workshopscript[] akSortArray, ObjectReference akDistanceCheckRef) global
	ObjectReference[] kAsObjectRefs = new ObjectReference[0]
	int I = 0
	While (I < akSortArray.length)
		kAsObjectRefs.add(akSortArray[I] as ObjectReference, 1)
		I += 1
	EndWhile
	ObjectReference[] kSorted = simsettlementsv2:utilityfunctions.SortReferencesByDistanceToRef(kAsObjectRefs, akDistanceCheckRef)
	workshopscript[] kSortedWorkshops = new workshopscript[0]
	I = 0
	While (I < kSorted.length)
		kSortedWorkshops.add(kSorted[I] as workshopscript, 1)
		I += 1
	EndWhile
	return kSortedWorkshops
EndFunction

bool Function AreSafetyNeedsMet(workshopscript akWorkshopRef) global
	If (!akWorkshopRef)
		return False
	EndIf
	float fSafety = simsettlementsv2:utilityfunctions.GetAvailableSafety(akWorkshopRef, False)
	float fTotalSafetyNeeds = simsettlementsv2:utilityfunctions.GetSafetyNeeds(akWorkshopRef)
	bool bResult = fSafety >= fTotalSafetyNeeds
	If (!bResult)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed AreSafetyNeedsMet: Workshop " + akWorkshopRef as string + " requires " + fTotalSafetyNeeds as string + " safety rating; but only has " + fSafety as string + ".", 0, False)
	EndIf
	return bResult
EndFunction

bool Function CheckSettlementDataRequirements(simsettlementsv2:miscobjects:usagerequirements akRequirements, workshopscript akWorkshopRef) global
	If (!akWorkshopRef)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. No settlement ref found, so could not pass SettlementDataRequirements: " + akRequirements as string, 0, False)
		return False
	ElseIf (akRequirements != None && akRequirements.SettlementDataRequirements != None)
		simsettlementsv2:quests:settlementmanager SettlementManager = simsettlementsv2:utilityfunctions.GetSettlementManager()
		int iWorkshopID = akWorkshopRef.GetWorkshopID()
		simsettlementsv2:objectreferences:settlementdata thisDataStore = SettlementManager.GetSettlementDataStore(iWorkshopID)
		If (!thisDataStore)
			return False
		EndIf
		int I = 0
		While (I < akRequirements.SettlementDataRequirements.length)
			If (!simsettlementsv2:utilityfunctions.CheckSettlementDataRequirement(thisDataStore, akRequirements.SettlementDataRequirements[I]))
				return False
			EndIf
			I += 1
		EndWhile
	EndIf
	return True
EndFunction

bool Function CheckWorkshopObjectKeywords(simsettlementsv2:miscobjects:usagerequirements akRequirements, ObjectReference akObjectRef) global
	If (!akObjectRef)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. No plot sent, so could not pass PlotKeywordRequirements.", 0, False)
		return False
	EndIf
	If (akRequirements != None && akRequirements.PlotKeywordRequirements != None)
		int I = 0
		While (I < akRequirements.PlotKeywordRequirements.length)
			Keyword thisForm = workshopframework:library:utilityfunctions.GetUniversalForm(akRequirements.PlotKeywordRequirements[I]) as Keyword
			If (thisForm as bool && !akObjectRef.HasKeyword(thisForm))
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. Plot " + akObjectRef as string + " lacks keyword " + thisForm as string + ".", 0, False)
				return False
			EndIf
			I += 1
		EndWhile
	EndIf
	If (akRequirements != None && akRequirements.PlotKeywordRestrictions != None)
		int i = 0
		While (i < akRequirements.PlotKeywordRestrictions.length)
			Keyword thisform = workshopframework:library:utilityfunctions.GetUniversalForm(akRequirements.PlotKeywordRestrictions[i]) as Keyword
			If (thisform as bool && akObjectRef.HasKeyword(thisform))
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. Plot  " + akObjectRef as string + " has restricted keyword " + thisform as string + ".", 0, False)
				return False
			EndIf
			i += 1
		EndWhile
	EndIf
	return True
EndFunction

simsettlementsv2:datastructures#plotresource[] Function CopyPlotResourceArray(simsettlementsv2:datastructures#plotresource[] aResources) global
	simsettlementsv2:datastructures#plotresource[] LocalCopy = new simsettlementsv2:datastructures#plotresource[0]
	int I = 0
	While (I < aResources.length)
		simsettlementsv2:datastructures#plotresource newRecord = new simsettlementsv2:datastructures#plotresource
		newRecord.ResourceAV = aResources[I].ResourceAV
		newRecord.fAmount = aResources[I].fAmount
		newRecord.iOccupantCount = aResources[I].iOccupantCount
		newRecord.iLevel = aResources[I].iLevel
		newRecord.UsageRequirements = aResources[I].UsageRequirements
		newRecord.iVirtualResourceHandling = aResources[I].iVirtualResourceHandling
		LocalCopy.add(newRecord, 1)
		I += 1
	EndWhile
	return LocalCopy
EndFunction

bool Function CheckSettlementWorkshopRequirements(simsettlementsv2:miscobjects:usagerequirements akRequirements, workshopscript akWorkshopRef) global
	If (!akWorkshopRef)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. No settlement ref found, so could not pass SettlementWorkshopRequirements: " + akRequirements as string, 0, False)
		return False
	ElseIf (akRequirements != None && akRequirements.SettlementWorkshopRequirements != None)
		int I = 0
		While (I < akRequirements.SettlementWorkshopRequirements.length)
			If (!workshopframework:library:utilityfunctions.CheckScriptPropertySet(akRequirements.SettlementWorkshopRequirements[I]))
				return False
			EndIf
			I += 1
		EndWhile
	EndIf
	return True
EndFunction

bool Function WithinGameDateRange(int aiStartMonth, int aiStartDay, int aiEndMonth, int aiEndDay) global
	If (aiEndMonth == aiStartMonth && aiStartDay == aiEndDay)
		return True
	EndIf
	int[] CurrentDate = workshopframework:library:utilityfunctions.GetGameDate(Utility.GetCurrentGameTime())
	int iMonth = CurrentDate[1]
	int iDay = CurrentDate[2]
	If (aiEndMonth < aiStartMonth || aiEndMonth == aiStartMonth && aiEndDay < aiStartDay)
		If (iMonth >= aiStartMonth && (iMonth > aiStartMonth || iDay >= aiStartDay) || iMonth <= aiEndMonth && (iMonth < aiEndMonth || iDay <= aiEndDay))
			return True
		Else
			return False
		EndIf
	ElseIf (iMonth >= aiStartMonth && (iMonth > aiStartMonth || iDay >= aiStartDay) && iMonth <= aiEndMonth && (iMonth < aiEndMonth || iDay <= aiEndDay))
		return True
	Else
		return False
	EndIf
EndFunction

string Function GetPluginName() global
	return "SS2.esm"
EndFunction

bool Function CheckRequiredPlugins(simsettlementsv2:miscobjects:usagerequirements akRequirements) global
	int I = 0
	While (I < akRequirements.RequiredPlugins.length)
		bool bPluginFound = workshopframework:library:utilityfunctions.CheckForPlugin(akRequirements.RequiredPlugins[I].PluginName, akRequirements.RequiredPlugins[I].bAvailableAsESP, akRequirements.RequiredPlugins[I].bAvailableAsESL, akRequirements.RequiredPlugins[I].bAvailableAsESM)
		If (!bPluginFound)
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. Missing plugin: " + akRequirements.RequiredPlugins[I].PluginName, 0, False)
			return False
		EndIf
		I += 1
	EndWhile
	return True
EndFunction

bool Function CheckPlotAVRequirements(simsettlementsv2:miscobjects:usagerequirements akRequirements, simsettlementsv2:objectreferences:simplot akPlotRef) global
	return simsettlementsv2:utilityfunctions.CheckWorkshopObjectAVRequirements(akRequirements, akPlotRef as ObjectReference)
EndFunction

float Function GetFoodNeeds(workshopscript akWorkshopRef) global
	If (!akWorkshopRef)
		return -1
	EndIf
	ActorValue PopulationAV = Game.GetFormFromFile(1208894, "Fallout4.esm") as ActorValue
	ActorValue RobotPopulationAV = Game.GetFormFromFile(1208895, "Fallout4.esm") as ActorValue
	ActorValue ExtraFoodNeedsAV = Game.GetFormFromFile(29423, "WorkshopFramework.esm") as ActorValue
	workshopframework:workshopresourcemanager ResourceManager = Game.GetFormFromFile(23583, "WorkshopFramework.esm") as workshopframework:workshopresourcemanager
	float fPopulation = akWorkshopRef.GetBaseValue(PopulationAV)
	float fRobotPopulation = akWorkshopRef.GetBaseValue(RobotPopulationAV)
	float fExtraFoodNeeds = akWorkshopRef.GetValue(ExtraFoodNeedsAV)
	float fTotalFoodNeeds = fPopulation - fRobotPopulation + fExtraFoodNeeds
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	simsettlementsv2:quests:settlementmanager SettlementManagerQuest = simsettlementsv2:utilityfunctions.GetSettlementManager()
	simsettlementsv2:objectreferences:settlementdata thisDataStore = SettlementManagerQuest.GetSettlementDataStore(iWorkshopID)
	workshopframework:library:datastructures#actorvaluemap[] Modifiers = thisDataStore.NeedsPercentageModifiers
	If (Modifiers != None)
		int iIndex = Modifiers.findstruct("ActorValueForm", ExtraFoodNeedsAV, 0)
		If (iIndex >= 0)
			fTotalFoodNeeds += fTotalFoodNeeds * Modifiers[iIndex].fValue
		EndIf
	EndIf
	return fTotalFoodNeeds
EndFunction

Function MoveBehindPlayer(ObjectReference akMoveMe, float afDistance) global
	ObjectReference[] kMoveRefs = new ObjectReference[1]
	kMoveRefs[0] = akMoveMe
	simsettlementsv2:utilityfunctions.MoveRefsBehindPlayer(kMoveRefs, afDistance)
EndFunction

float Function GetSafetyNeeds(workshopscript akWorkshopRef) global
	If (!akWorkshopRef)
		return -1
	EndIf
	ActorValue WaterAV = Game.GetFormFromFile(818, "Fallout4.esm") as ActorValue
	ActorValue FoodAV = Game.GetFormFromFile(817, "Fallout4.esm") as ActorValue
	ActorValue ExtraSafetyNeedsAV = Game.GetFormFromFile(29425, "WorkshopFramework.esm") as ActorValue
	workshopframework:workshopresourcemanager ResourceManager = Game.GetFormFromFile(23583, "WorkshopFramework.esm") as workshopframework:workshopresourcemanager
	float fExtraSafetyNeeds = akWorkshopRef.GetValue(ExtraSafetyNeedsAV)
	float fWater = ResourceManager.GetWorkshopValue(akWorkshopRef as ObjectReference, WaterAV)
	float fFood = ResourceManager.GetWorkshopValue(akWorkshopRef as ObjectReference, FoodAV)
	float fTotalSafetyNeeds = fFood + fWater / 2 as float + fExtraSafetyNeeds
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	simsettlementsv2:quests:settlementmanager SettlementManagerQuest = simsettlementsv2:utilityfunctions.GetSettlementManager()
	simsettlementsv2:objectreferences:settlementdata thisDataStore = SettlementManagerQuest.GetSettlementDataStore(iWorkshopID)
	workshopframework:library:datastructures#actorvaluemap[] Modifiers = thisDataStore.NeedsPercentageModifiers
	If (Modifiers != None)
		int iIndex = Modifiers.findstruct("ActorValueForm", ExtraSafetyNeedsAV, 0)
		If (iIndex >= 0)
			fTotalSafetyNeeds += fTotalSafetyNeeds * Modifiers[iIndex].fValue
		EndIf
	EndIf
	return fTotalSafetyNeeds
EndFunction

bool Function CheckSettlementDataRequirement(simsettlementsv2:objectreferences:settlementdata akDataStoreRef, workshopframework:library:datastructures#scriptpropertyset aScriptPropertyDataSet) global
	workshopframework:library:datastructures#scriptpropertyset newTestSet = new workshopframework:library:datastructures#scriptpropertyset
	newTestSet.CheckForm = akDataStoreRef as Form
	newTestSet.sScriptName = aScriptPropertyDataSet.sScriptName
	newTestSet.sPropertyName = aScriptPropertyDataSet.sPropertyName
	newTestSet.fValue = aScriptPropertyDataSet.fValue
	newTestSet.sValue = aScriptPropertyDataSet.sValue
	newTestSet.iCompareMethod = aScriptPropertyDataSet.iCompareMethod
	newTestSet.MatchForm = aScriptPropertyDataSet.MatchForm
	newTestSet.iMatchFormID = aScriptPropertyDataSet.iMatchFormID
	newTestSet.sMatchPluginName = aScriptPropertyDataSet.sMatchPluginName
	return workshopframework:library:utilityfunctions.CheckScriptPropertySet(newTestSet)
EndFunction

simsettlementsv2:quests:cityplanmanager Function GetCityPlanManager() global
	simsettlementsv2:quests:cityplanmanager CityPlanManagerQuest = Game.GetFormFromFile(126726, simsettlementsv2:utilityfunctions.GetPluginName()) as simsettlementsv2:quests:cityplanmanager
	return CityPlanManagerQuest
EndFunction

float Function GetAvailableFood(workshopscript akWorkshopRef, bool abIncludeBorrowed) global
	If (!akWorkshopRef)
		return -1
	EndIf
	ActorValue FoodAV = Game.GetFormFromFile(817, "Fallout4.esm") as ActorValue
	workshopframework:workshopresourcemanager ResourceManager = Game.GetFormFromFile(23583, "WorkshopFramework.esm") as workshopframework:workshopresourcemanager
	float fFood = ResourceManager.GetWorkshopValue(akWorkshopRef as ObjectReference, FoodAV)
	If (abIncludeBorrowed)
		int iWorkshopID = akWorkshopRef.GetWorkshopID()
		simsettlementsv2:quests:settlementmanager SettlementManagerQuest = simsettlementsv2:utilityfunctions.GetSettlementManager()
		simsettlementsv2:objectreferences:settlementdata thisDataStore = SettlementManagerQuest.GetSettlementDataStore(iWorkshopID)
		If (thisDataStore)
			fFood += thisDataStore.iSharedFood as float
		EndIf
	EndIf
	return fFood
EndFunction

bool Function CheckOwnerAVRequirements(simsettlementsv2:miscobjects:usagerequirements akRequirements, ObjectReference akOwnerRef) global
	If (akRequirements.bIgnoreOwnerRequirementsIfNoOwner && !akOwnerRef)
		return True
	ElseIf (akRequirements != None && akRequirements.OwnerAVRequirements != None)
		If (!akOwnerRef)
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. No owning actor found, so could not pass OwnerAVRequirements.", 0, False)
			return False
		Else
			int I = 0
			While (I < akRequirements.OwnerAVRequirements.length)
				ActorValue thisForm = workshopframework:library:utilityfunctions.GetActorValueSetForm(akRequirements.OwnerAVRequirements[I])
				If (!workshopframework:library:utilityfunctions.CheckActorValueSet(akOwnerRef, akRequirements.OwnerAVRequirements[I], False))
					simsettlementsv2:utilityfunctions.LogOwnerAVRequirementFail(akOwnerRef, akRequirements.OwnerAVRequirements[I])
					return False
				EndIf
				I += 1
			EndWhile
		EndIf
	EndIf
	return True
EndFunction

simsettlementsv2:quests:messagemanager Function GetMessageManager() global
	simsettlementsv2:quests:messagemanager MMQuest = Game.GetFormFromFile(60275, simsettlementsv2:utilityfunctions.GetPluginName()) as simsettlementsv2:quests:messagemanager
	return MMQuest
EndFunction

bool Function CheckGlobalRequirements(simsettlementsv2:miscobjects:usagerequirements akRequirements) global
	int I = 0
	While (I < akRequirements.GlobalRequirements.length)
		If (!workshopframework:library:utilityfunctions.CheckGlobalVariableSet(akRequirements.GlobalRequirements[I]))
			simsettlementsv2:utilityfunctions.LogGlobalRequirementFail(akRequirements.GlobalRequirements[I])
			return False
		EndIf
		I += 1
	EndWhile
	return True
EndFunction

Function MoveRefsBehindPlayer(ObjectReference[] akMoveMe, float afDistance) global
	ObjectReference PlayerRef = Game.GetPlayer() as ObjectReference
	float fPlayerAngle = PlayerRef.GetAngleZ()
	float fDistanceInFront = afDistance * -1
	float fX = Math.Sin(fPlayerAngle) * fDistanceInFront
	float fY = Math.Cos(fPlayerAngle) * fDistanceInFront
	int I = 0
	While (I < akMoveMe.length)
		akMoveMe[I].MoveTo(PlayerRef, fX, fY, 0, True)
		If (akMoveMe[I] as Actor)
			akMoveMe[I].MoveToNearestNavmeshLocation()
		EndIf
		I += 1
	EndWhile
EndFunction

Function CleanFormArray(Form[] akArray) global
	int I = akArray.length
	While (I > 0)
		int iIndex = I - 1
		If (akArray[iIndex] == None || akArray[iIndex].GetFormID() == 0)
			akArray.remove(iIndex, 1)
		EndIf
		I -= 1
	EndWhile
EndFunction

bool Function IsActorSick(Actor akActorRef) global
	return akActorRef.GetValue(simsettlementsv2:utilityfunctions.GetSicknessAV()) > 0 as float
EndFunction

bool Function IsActorIncapacitated(Actor akActorRef) global
	return False
	If (workshopframework:workshopfunctions.IsWounded(akActorRef))
		return True
	ElseIf (akActorRef.GetValue(simsettlementsv2:utilityfunctions.GetSicknessAV()) >= akActorRef.GetBaseValue(Game.GetEnduranceAV()))
		return True
	EndIf
	return False
EndFunction

bool Function AreFoodNeedsMet(workshopscript akWorkshopRef) global
	If (!akWorkshopRef)
		return False
	EndIf
	float fFood = simsettlementsv2:utilityfunctions.GetAvailableFood(akWorkshopRef, False)
	float fTotalFoodNeeds = simsettlementsv2:utilityfunctions.GetFoodNeeds(akWorkshopRef)
	return fFood >= fTotalFoodNeeds
EndFunction

bool Function CheckWorkshopObjectRequirements(simsettlementsv2:miscobjects:usagerequirements akRequirements, workshopobjectscript akObjectRef, ObjectReference akOwnerRef, workshopscript akWorkshopRef) global
	If (!akRequirements)
		return True
	EndIf
	If (!akWorkshopRef && akObjectRef != None)
		akWorkshopRef = akObjectRef.GetWorkshop()
	EndIf
	If (!akOwnerRef)
		If (akObjectRef != None)
			akOwnerRef = akObjectRef.GetAssignedNPC() as ObjectReference
		ElseIf (akWorkshopRef != None)
			simsettlementsv2:quests:settlementmanager SettlementManager = simsettlementsv2:utilityfunctions.GetSettlementManager()
			simsettlementsv2:objectreferences:settlementdata kDataStore = SettlementManager.GetSettlementDataStore(akWorkshopRef.GetWorkshopID())
			akOwnerRef = kDataStore.SettlementLeader as ObjectReference
		EndIf
	EndIf
	If (akRequirements.RequiredPlugins as bool && akRequirements.RequiredPlugins.length > 0)
		If (!simsettlementsv2:utilityfunctions.CheckRequiredPlugins(akRequirements))
			return False
		EndIf
	EndIf
	If (akRequirements.GlobalRequirements as bool && akRequirements.GlobalRequirements.length > 0)
		If (!simsettlementsv2:utilityfunctions.CheckGlobalRequirements(akRequirements))
			return False
		EndIf
	EndIf
	If (akRequirements.QuestRequirements as bool && akRequirements.QuestRequirements.length > 0)
		If (!simsettlementsv2:utilityfunctions.CheckQuestRequirements(akRequirements))
			return False
		EndIf
	EndIf
	If (akRequirements.PlotAVRequirements as bool && akRequirements.PlotAVRequirements.length > 0)
		If (!simsettlementsv2:utilityfunctions.CheckWorkshopObjectAVRequirements(akRequirements, akObjectRef as ObjectReference))
			return False
		EndIf
	EndIf
	If (akRequirements.PlotKeywordRequirements as bool && akRequirements.PlotKeywordRequirements.length > 0 || akRequirements.PlotKeywordRestrictions as bool && akRequirements.PlotKeywordRestrictions.length > 0)
		If (!simsettlementsv2:utilityfunctions.CheckWorkshopObjectKeywords(akRequirements, akObjectRef as ObjectReference))
			return False
		EndIf
	EndIf
	If (akRequirements.OwnerAVRequirements as bool && akRequirements.OwnerAVRequirements.length > 0)
		If (!simsettlementsv2:utilityfunctions.CheckOwnerAVRequirements(akRequirements, akOwnerRef))
			return False
		EndIf
	EndIf
	If (akRequirements.OwnerKeywordRequirements as bool && akRequirements.OwnerKeywordRequirements.length > 0 || akRequirements.OwnerKeywordRestrictions as bool && akRequirements.OwnerKeywordRestrictions.length > 0)
		If (!simsettlementsv2:utilityfunctions.CheckOwnerKeywords(akRequirements, akOwnerRef))
			return False
		EndIf
	EndIf
	If (akRequirements.SettlementAVRequirements as bool && akRequirements.SettlementAVRequirements.length > 0)
		If (!simsettlementsv2:utilityfunctions.CheckSettlementAVRequirements(akRequirements, akWorkshopRef))
			return False
		EndIf
	EndIf
	If (akRequirements.SettlementKeywordRequirements as bool && akRequirements.SettlementKeywordRequirements.length > 0 || akRequirements.SettlementKeywordRestrictions as bool && akRequirements.SettlementKeywordRestrictions.length > 0)
		If (!simsettlementsv2:utilityfunctions.CheckSettlementKeywords(akRequirements, akWorkshopRef))
			return False
		EndIf
	EndIf
	If (akRequirements.SettlementWorkshopRequirements as bool && akRequirements.SettlementWorkshopRequirements.length > 0)
		If (!simsettlementsv2:utilityfunctions.CheckSettlementWorkshopRequirements(akRequirements, akWorkshopRef))
			return False
		EndIf
	EndIf
	If (akRequirements.SettlementDataRequirements as bool && akRequirements.SettlementDataRequirements.length > 0)
		If (!simsettlementsv2:utilityfunctions.CheckSettlementDataRequirements(akRequirements, akWorkshopRef))
			return False
		EndIf
	EndIf
	return True
EndFunction

string Function GetLogName() global
	return "SimSettlementsV2Log"
EndFunction

Function AddActorArrayToRefCollection(Actor[] akActorRefs, RefCollectionAlias aCollection) global
	int I = 0
	While (I < akActorRefs.length)
		aCollection.AddRef(akActorRefs[I] as ObjectReference)
		I += 1
	EndWhile
EndFunction

float Function GetAvailableSafety(workshopscript akWorkshopRef, bool abIncludeBorrowed) global
	If (!akWorkshopRef)
		return -1
	EndIf
	ActorValue SafetyAV = Game.GetFormFromFile(819, "Fallout4.esm") as ActorValue
	workshopframework:workshopresourcemanager ResourceManager = Game.GetFormFromFile(23583, "WorkshopFramework.esm") as workshopframework:workshopresourcemanager
	float fSafety = ResourceManager.GetWorkshopValue(akWorkshopRef as ObjectReference, SafetyAV)
	If (abIncludeBorrowed)
		int iWorkshopID = akWorkshopRef.GetWorkshopID()
		simsettlementsv2:quests:settlementmanager SettlementManagerQuest = simsettlementsv2:utilityfunctions.GetSettlementManager()
		simsettlementsv2:objectreferences:settlementdata thisDataStore = SettlementManagerQuest.GetSettlementDataStore(iWorkshopID)
		If (thisDataStore)
			fSafety += thisDataStore.iSharedDefense as float
		EndIf
	EndIf
	return fSafety
EndFunction

bool Function CheckRequirements(simsettlementsv2:miscobjects:usagerequirements akRequirements, simsettlementsv2:objectreferences:simplot akPlotRef, ObjectReference akOwnerRef, workshopscript akWorkshopRef) global
	return simsettlementsv2:utilityfunctions.CheckWorkshopObjectRequirements(akRequirements, akPlotRef as workshopobjectscript, akOwnerRef, akWorkshopRef)
EndFunction

float Function CalculateModifiedValue(float afOriginalNumber, float afModifier, int aiOperatorType) global
	If (aiOperatorType == 3)
		return afModifier + afOriginalNumber
	ElseIf (aiOperatorType == 1)
		return afOriginalNumber * afModifier
	ElseIf (aiOperatorType == 2)
		return afOriginalNumber + afOriginalNumber * afModifier
	EndIf
	return afOriginalNumber
EndFunction

Function LogOwnerAVRequirementFail(ObjectReference akOwnerRef, workshopframework:library:datastructures#actorvalueset aAVSet) global
	string sExplanation = ""
	ActorValue thisForm = workshopframework:library:utilityfunctions.GetActorValueSetForm(aAVSet)
	If (aAVSet.iCompareMethod == -2)
		sExplanation = "less than"
	ElseIf (aAVSet.iCompareMethod == -1)
		sExplanation = "less than or equal to"
	ElseIf (aAVSet.iCompareMethod == 0)
		sExplanation = "equal to"
	ElseIf (aAVSet.iCompareMethod == 1)
		sExplanation = "greater than or equal to"
	ElseIf (aAVSet.iCompareMethod == 2)
		sExplanation = "greater than"
	EndIf
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. Owner AV Check Failed: " + akOwnerRef as string + "'s " + thisForm as string + " is not " + sExplanation + " " + aAVSet.fValue as string, 0, False)
EndFunction

simsettlementsv2:datastructures#productionitem[] Function CopyProductionItemArray(simsettlementsv2:datastructures#productionitem[] aProduction) global
	simsettlementsv2:datastructures#productionitem[] LocalCopy = new simsettlementsv2:datastructures#productionitem[0]
	int I = 0
	While (I < aProduction.length)
		simsettlementsv2:datastructures#productionitem newRecord = new simsettlementsv2:datastructures#productionitem
		newRecord.Item = aProduction[I].Item
		newRecord.iCount = aProduction[I].iCount
		newRecord.TargetContainerKeyword = aProduction[I].TargetContainerKeyword
		newRecord.sTargetVendorType = aProduction[I].sTargetVendorType
		newRecord.iTargetVendorLevel = aProduction[I].iTargetVendorLevel
		LocalCopy.add(newRecord, 1)
		I += 1
	EndWhile
	return LocalCopy
EndFunction

bool Function CheckSettlementKeywords(simsettlementsv2:miscobjects:usagerequirements akRequirements, workshopscript akWorkshopRef) global
	If (!akWorkshopRef)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. No settlement found, so could not pass SettlementKeywordRequirements.", 0, False)
		return False
	EndIf
	If (akRequirements != None && akRequirements.SettlementKeywordRequirements != None)
		int I = 0
		While (I < akRequirements.SettlementKeywordRequirements.length)
			Keyword thisForm = workshopframework:library:utilityfunctions.GetUniversalForm(akRequirements.SettlementKeywordRequirements[I]) as Keyword
			If (thisForm as bool && !akWorkshopRef.HasKeyword(thisForm))
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. Settlement " + akWorkshopRef as string + " lacks keyword " + thisForm as string + ".", 0, False)
				return False
			EndIf
			I += 1
		EndWhile
	EndIf
	If (akRequirements != None && akRequirements.SettlementKeywordRestrictions != None)
		int i = 0
		While (i < akRequirements.SettlementKeywordRestrictions.length)
			Keyword thisform = workshopframework:library:utilityfunctions.GetUniversalForm(akRequirements.SettlementKeywordRestrictions[i]) as Keyword
			If (thisform as bool && !akWorkshopRef.HasKeyword(thisform))
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. Settlement " + akWorkshopRef as string + " has restricted keyword " + thisform as string + ".", 0, False)
				return False
			EndIf
			i += 1
		EndWhile
	EndIf
	return True
EndFunction

simsettlementsv2:quests:settlementmanager Function GetSettlementManager() global
	simsettlementsv2:quests:settlementmanager SettlementManagerQuest = Game.GetFormFromFile(60192, simsettlementsv2:utilityfunctions.GetPluginName()) as simsettlementsv2:quests:settlementmanager
	return SettlementManagerQuest
EndFunction

simsettlementsv2:datastructures#behaviormodifier[] Function CopyBehaviorModifierArray(simsettlementsv2:datastructures#behaviormodifier[] aModifiers) global
	simsettlementsv2:datastructures#behaviormodifier[] LocalCopy = new simsettlementsv2:datastructures#behaviormodifier[0]
	int I = 0
	While (I < aModifiers.length)
		simsettlementsv2:datastructures#behaviormodifier newRecord = new simsettlementsv2:datastructures#behaviormodifier
		newRecord.TargetKeyword = aModifiers[I].TargetKeyword
		newRecord.fAmount = aModifiers[I].fAmount
		newRecord.iModifierType = aModifiers[I].iModifierType
		newRecord.iOperatorType = aModifiers[I].iOperatorType
		newRecord.RelatedForm01 = aModifiers[I].RelatedForm01
		newRecord.RelatedForm02 = aModifiers[I].RelatedForm02
		LocalCopy.add(newRecord, 1)
		I += 1
	EndWhile
	return LocalCopy
EndFunction

simsettlementsv2:datastructures#plotproduction[] Function CopyPlotProductionArray(simsettlementsv2:datastructures#plotproduction[] aProduction) global
	simsettlementsv2:datastructures#plotproduction[] LocalCopy = new simsettlementsv2:datastructures#plotproduction[0]
	int I = 0
	While (I < aProduction.length)
		simsettlementsv2:datastructures#plotproduction newRecord = new simsettlementsv2:datastructures#plotproduction
		newRecord.Item = aProduction[I].Item
		newRecord.iCount = aProduction[I].iCount
		newRecord.NameHolderForm = aProduction[I].NameHolderForm
		newRecord.iOccupantCount = aProduction[I].iOccupantCount
		newRecord.iLevel = aProduction[I].iLevel
		newRecord.TargetContainerKeyword = aProduction[I].TargetContainerKeyword
		newRecord.sTargetVendorType = aProduction[I].sTargetVendorType
		newRecord.iTargetVendorLevel = aProduction[I].iTargetVendorLevel
		newRecord.UsageRequirements = aProduction[I].UsageRequirements
		LocalCopy.add(newRecord, 1)
		I += 1
	EndWhile
	return LocalCopy
EndFunction

Function LogGlobalRequirementFail(workshopframework:library:datastructures#globalvariableset aGlobalSet) global
	string sExplanation = ""
	GlobalVariable thisForm = workshopframework:library:utilityfunctions.GetGlobalVariableSetForm(aGlobalSet)
	If (aGlobalSet.iCompareMethod == -2)
		sExplanation = "less than"
	ElseIf (aGlobalSet.iCompareMethod == -1)
		sExplanation = "less than or equal to"
	ElseIf (aGlobalSet.iCompareMethod == 0)
		sExplanation = "equal to"
	ElseIf (aGlobalSet.iCompareMethod == 1)
		sExplanation = "greater than or equal to"
	ElseIf (aGlobalSet.iCompareMethod == 2)
		sExplanation = "greater than"
	EndIf
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. Global Check Failed: " + thisForm as string + " is not " + sExplanation + " " + aGlobalSet.fValue as string, 0, False)
EndFunction

float Function GetAvailableWater(workshopscript akWorkshopRef, bool abIncludeBorrowed) global
	If (!akWorkshopRef)
		return -1
	EndIf
	ActorValue WaterAV = Game.GetFormFromFile(818, "Fallout4.esm") as ActorValue
	workshopframework:workshopresourcemanager ResourceManager = Game.GetFormFromFile(23583, "WorkshopFramework.esm") as workshopframework:workshopresourcemanager
	float fWater = ResourceManager.GetWorkshopValue(akWorkshopRef as ObjectReference, WaterAV)
	If (abIncludeBorrowed)
		int iWorkshopID = akWorkshopRef.GetWorkshopID()
		simsettlementsv2:quests:settlementmanager SettlementManagerQuest = simsettlementsv2:utilityfunctions.GetSettlementManager()
		simsettlementsv2:objectreferences:settlementdata thisDataStore = SettlementManagerQuest.GetSettlementDataStore(iWorkshopID)
		If (thisDataStore)
			fWater += thisDataStore.iSharedWater as float
		EndIf
	EndIf
	return fWater
EndFunction

bool Function CheckSettlementAVRequirements(simsettlementsv2:miscobjects:usagerequirements akRequirements, workshopscript akWorkshopRef) global
	If (!akWorkshopRef)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. No settlement ref found, so could not pass SettlementAVRequirements: " + akRequirements as string, 0, False)
		return False
	ElseIf (akRequirements != None && akRequirements.SettlementAVRequirements != None)
		int I = 0
		While (I < akRequirements.SettlementAVRequirements.length)
			If (!workshopframework:library:utilityfunctions.CheckActorValueSet(akWorkshopRef as ObjectReference, akRequirements.SettlementAVRequirements[I], False))
				simsettlementsv2:utilityfunctions.LogSettlementAVRequirementFail(akWorkshopRef as ObjectReference, akRequirements.SettlementAVRequirements[I])
				return False
			EndIf
			I += 1
		EndWhile
	EndIf
	return True
EndFunction

bool Function CheckSettlementWorkshopRequirement(workshopscript akWorkshopRef, workshopframework:library:datastructures#scriptpropertyset aScriptPropertyDataSet) global
	workshopframework:library:datastructures#scriptpropertyset newTestSet = new workshopframework:library:datastructures#scriptpropertyset
	Form CheckForm = workshopframework:library:utilityfunctions.GetScriptPropertySetCheckForm(aScriptPropertyDataSet)
	If (CheckForm == None)
		newTestSet.CheckForm = akWorkshopRef as Form
		newTestSet.sScriptName = aScriptPropertyDataSet.sScriptName
		newTestSet.sPropertyName = aScriptPropertyDataSet.sPropertyName
		newTestSet.fValue = aScriptPropertyDataSet.fValue
		newTestSet.sValue = aScriptPropertyDataSet.sValue
		newTestSet.iCompareMethod = aScriptPropertyDataSet.iCompareMethod
		newTestSet.MatchForm = aScriptPropertyDataSet.MatchForm
		newTestSet.iMatchFormID = aScriptPropertyDataSet.iMatchFormID
		newTestSet.sMatchPluginName = aScriptPropertyDataSet.sMatchPluginName
		return workshopframework:library:utilityfunctions.CheckScriptPropertySet(newTestSet)
	EndIf
	return workshopframework:library:utilityfunctions.CheckScriptPropertySet(aScriptPropertyDataSet)
EndFunction

bool Function CheckWorkshopObjectAVRequirements(simsettlementsv2:miscobjects:usagerequirements akRequirements, ObjectReference akObjectRef) global
	If (!akObjectRef)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. No plot reference sent, so could not pass PlotAVRequirements.", 0, False)
		return False
	ElseIf (akRequirements != None && akRequirements.PlotAVRequirements != None)
		int I = 0
		While (I < akRequirements.PlotAVRequirements.length)
			If (!workshopframework:library:utilityfunctions.CheckActorValueSet(akObjectRef, akRequirements.PlotAVRequirements[I], False))
				simsettlementsv2:utilityfunctions.LogPlotAVRequirementFail(akObjectRef, akRequirements.PlotAVRequirements[I])
				return False
			EndIf
			I += 1
		EndWhile
	EndIf
	return True
EndFunction

simsettlementsv2:datastructures#actorbasechance[] Function CopyActorBaseChanceArray(simsettlementsv2:datastructures#actorbasechance[] aChances) global
	simsettlementsv2:datastructures#actorbasechance[] LocalCopy = new simsettlementsv2:datastructures#actorbasechance[0]
	int I = 0
	While (I < aChances.length)
		simsettlementsv2:datastructures#actorbasechance newRecord = new simsettlementsv2:datastructures#actorbasechance
		newRecord.fChance = aChances[I].fChance
		newRecord.ActorBaseForm = aChances[I].ActorBaseForm
		LocalCopy.add(newRecord, 1)
		I += 1
	EndWhile
	return LocalCopy
EndFunction

bool Function CheckPlotKeywords(simsettlementsv2:miscobjects:usagerequirements akRequirements, simsettlementsv2:objectreferences:simplot akPlotRef) global
	return simsettlementsv2:utilityfunctions.CheckWorkshopObjectKeywords(akRequirements, akPlotRef as ObjectReference)
EndFunction

bool Function IsPhysicalItem(Form aItem) global
	If ((aItem as Ammo) as bool || (aItem as Armor) as bool || (aItem as Book) as bool || (aItem as holotape) as bool || (aItem as MiscObject) as bool || (aItem as Potion) as bool || (aItem as Weapon) as bool || (aItem as LeveledItem) as bool)
		return True
	EndIf
	return False
EndFunction

Function ShowFanfareMessage(string asIdentifier) global
	simsettlementsv2:quests:messagemanager MMQuest = simsettlementsv2:utilityfunctions.GetMessageManager()
	If (!MMQuest)
		Debug.Trace("[SS2] Failed to get MessageManager.", 0)
		return 
	EndIf
	MMQuest.ShowFanfareMessage(asIdentifier)
EndFunction

Function LogSettlementAVRequirementFail(ObjectReference akSettlementRef, workshopframework:library:datastructures#actorvalueset aAVSet) global
	string sExplanation = ""
	ActorValue thisForm = workshopframework:library:utilityfunctions.GetActorValueSetForm(aAVSet)
	If (aAVSet.iCompareMethod == -2)
		sExplanation = "less than"
	ElseIf (aAVSet.iCompareMethod == -1)
		sExplanation = "less than or equal to"
	ElseIf (aAVSet.iCompareMethod == 0)
		sExplanation = "equal to"
	ElseIf (aAVSet.iCompareMethod == 1)
		sExplanation = "greater than or equal to"
	ElseIf (aAVSet.iCompareMethod == 2)
		sExplanation = "greater than"
	EndIf
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. Settlement AV Check Failed: " + akSettlementRef as string + "'s " + thisForm as string + " is not " + sExplanation + " " + aAVSet.fValue as string, 0, False)
EndFunction

Function LogQuestRequirementFail(workshopframework:library:datastructures#queststageset aQuestSet) global
	string sExplanation = ""
	Quest thisForm = workshopframework:library:utilityfunctions.GetQuestStageSetForm(aQuestSet)
	If (aQuestSet.bNotDoneCheck)
		sExplanation = "was complete, and needed to not be"
	Else
		sExplanation = "was incomplete, and needed to be"
	EndIf
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. Quest Check Failed: " + thisForm as string + " stage " + aQuestSet.iStage as string + " " + sExplanation + ".", 0, False)
EndFunction

bool Function CheckQuestRequirements(simsettlementsv2:miscobjects:usagerequirements akRequirements) global
	int I = 0
	While (I < akRequirements.QuestRequirements.length)
		If (!workshopframework:library:utilityfunctions.CheckQuestStageSet(akRequirements.QuestRequirements[I]))
			simsettlementsv2:utilityfunctions.LogQuestRequirementFail(akRequirements.QuestRequirements[I])
			return False
		EndIf
		I += 1
	EndWhile
	return True
EndFunction

float Function GetWaterNeeds(workshopscript akWorkshopRef) global
	If (!akWorkshopRef)
		return -1
	EndIf
	ActorValue PopulationAV = Game.GetFormFromFile(1208894, "Fallout4.esm") as ActorValue
	ActorValue RobotPopulationAV = Game.GetFormFromFile(1208895, "Fallout4.esm") as ActorValue
	ActorValue ExtraWaterNeedsAV = Game.GetFormFromFile(29424, "WorkshopFramework.esm") as ActorValue
	workshopframework:workshopresourcemanager ResourceManager = Game.GetFormFromFile(23583, "WorkshopFramework.esm") as workshopframework:workshopresourcemanager
	float fPopulation = akWorkshopRef.GetBaseValue(PopulationAV)
	float fRobotPopulation = akWorkshopRef.GetBaseValue(RobotPopulationAV)
	float fExtraWaterNeeds = akWorkshopRef.GetValue(ExtraWaterNeedsAV)
	float fTotalWaterNeeds = fPopulation - fRobotPopulation + fExtraWaterNeeds
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	simsettlementsv2:quests:settlementmanager SettlementManagerQuest = simsettlementsv2:utilityfunctions.GetSettlementManager()
	simsettlementsv2:objectreferences:settlementdata thisDataStore = SettlementManagerQuest.GetSettlementDataStore(iWorkshopID)
	workshopframework:library:datastructures#actorvaluemap[] Modifiers = thisDataStore.NeedsPercentageModifiers
	If (Modifiers != None)
		int iIndex = Modifiers.findstruct("ActorValueForm", ExtraWaterNeedsAV, 0)
		If (iIndex >= 0)
			fTotalWaterNeeds += fTotalWaterNeeds * Modifiers[iIndex].fValue
		EndIf
	EndIf
	return fTotalWaterNeeds
EndFunction

bool Function CheckOwnerKeywords(simsettlementsv2:miscobjects:usagerequirements akRequirements, ObjectReference akOwnerRef) global
	If (!akOwnerRef)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. No owning actor found, so could not pass OwnerKeywordRequirements.", 0, False)
		return False
	EndIf
	If (akRequirements != None && akRequirements.OwnerKeywordRequirements != None)
		int I = 0
		While (I < akRequirements.OwnerKeywordRequirements.length)
			Keyword thisForm = workshopframework:library:utilityfunctions.GetUniversalForm(akRequirements.OwnerKeywordRequirements[I]) as Keyword
			If (thisForm as bool && !akOwnerRef.HasKeyword(thisForm))
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. Owning actor " + akOwnerRef as string + " lacks keyword " + thisForm as string + ".", 0, False)
				return False
			EndIf
			I += 1
		EndWhile
	EndIf
	If (akRequirements != None && akRequirements.OwnerKeywordRestrictions != None)
		int i = 0
		While (i < akRequirements.OwnerKeywordRestrictions.length)
			Keyword thisform = workshopframework:library:utilityfunctions.GetUniversalForm(akRequirements.OwnerKeywordRestrictions[i]) as Keyword
			If (thisform as bool && akOwnerRef.HasKeyword(thisform))
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "XXXXXXXXXX Failed UsageRequirements Check. Owning actor " + akOwnerRef as string + " has restricted keyword " + thisform as string + ".", 0, False)
				return False
			EndIf
			i += 1
		EndWhile
	EndIf
	return True
EndFunction

simsettlementsv2:datastructures#plotconsumption[] Function CopyPlotConsumptionArray(simsettlementsv2:datastructures#plotconsumption[] aCosts) global
	simsettlementsv2:datastructures#plotconsumption[] LocalCopy = new simsettlementsv2:datastructures#plotconsumption[0]
	int I = 0
	While (I < aCosts.length)
		simsettlementsv2:datastructures#plotconsumption newRecord = new simsettlementsv2:datastructures#plotconsumption
		newRecord.Item = aCosts[I].Item
		newRecord.iCount = aCosts[I].iCount
		newRecord.NameHolderForm = aCosts[I].NameHolderForm
		newRecord.iOccupantCount = aCosts[I].iOccupantCount
		newRecord.iLevel = aCosts[I].iLevel
		newRecord.PullOnlyFromContainerKeyword = aCosts[I].PullOnlyFromContainerKeyword
		newRecord.UsageRequirements = aCosts[I].UsageRequirements
		LocalCopy.add(newRecord, 1)
		I += 1
	EndWhile
	return LocalCopy
EndFunction

simsettlementsv2:objectreferences:simplot Function GetLinkedPlot(ObjectReference akLinkedTo, Keyword aKeyword) global
	ObjectReference kLinkedRef = akLinkedTo.GetLinkedRef(aKeyword)
	If (kLinkedRef != None)
		simsettlementsv2:objectreferences:plotlinkholder kPlotLink = kLinkedRef as simsettlementsv2:objectreferences:plotlinkholder
		If (kPlotLink)
			return kPlotLink.kPlotRef
		EndIf
	EndIf
	return None
EndFunction

ObjectReference[] Function SortReferencesByDistanceToRef(ObjectReference[] akSortArray, ObjectReference akDistanceCheckRef) global
	ObjectReference[] kSorted = new ObjectReference[0]
	float[] fDistances = new float[0]
	int I = 0
	While (I < akSortArray.length)
		fDistances.add(akSortArray[I].GetDistance(akDistanceCheckRef), 1)
		I += 1
	EndWhile
	While (fDistances.length > 0)
		ObjectReference kCurrentClosest = None
		float fShortestDistance = 1.00000e+07
		int iShortestIndex = -1
		I = 0
		While (I < fDistances.length)
			If (fDistances[I] < fShortestDistance)
				kCurrentClosest = akSortArray[I]
				fShortestDistance = fDistances[I]
				iShortestIndex = I
			EndIf
			I += 1
		EndWhile
		kSorted.add(kCurrentClosest, 1)
		akSortArray.remove(iShortestIndex, 1)
		fDistances.remove(iShortestIndex, 1)
	EndWhile
	return kSorted
EndFunction

simsettlementsv2:datastructures#cityplancostmultiplier[] Function CopyCityPlanCostMultiplierArray(simsettlementsv2:datastructures#cityplancostmultiplier[] aCosts) global
	simsettlementsv2:datastructures#cityplancostmultiplier[] LocalCopy = new simsettlementsv2:datastructures#cityplancostmultiplier[0]
	int I = 0
	While (I < aCosts.length)
		simsettlementsv2:datastructures#cityplancostmultiplier newRecord = new simsettlementsv2:datastructures#cityplancostmultiplier
		newRecord.Item = aCosts[I].Item
		newRecord.iCount = aCosts[I].iCount
		newRecord.NameHolderForm = aCosts[I].NameHolderForm
		newRecord.RequiredKeyword = aCosts[I].RequiredKeyword
		newRecord.iLevel = aCosts[I].iLevel
		LocalCopy.add(newRecord, 1)
		I += 1
	EndWhile
	return LocalCopy
EndFunction

bool Function AreWaterNeedsMet(workshopscript akWorkshopRef) global
	If (!akWorkshopRef)
		return False
	EndIf
	ActorValue WaterAV = Game.GetFormFromFile(818, "Fallout4.esm") as ActorValue
	workshopframework:workshopresourcemanager ResourceManager = Game.GetFormFromFile(23583, "WorkshopFramework.esm") as workshopframework:workshopresourcemanager
	float fWater = simsettlementsv2:utilityfunctions.GetAvailableWater(akWorkshopRef, False)
	float fTotalWaterNeeds = simsettlementsv2:utilityfunctions.GetWaterNeeds(akWorkshopRef)
	return fWater >= fTotalWaterNeeds
EndFunction
