;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Weapons\BuildingLevelPlan.psc
Modified : 2020-09-28 02:16:02
Compiled : 2021-01-07 11:44:34
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:Weapons:BuildingLevelPlan extends Form Const
{ Holds building level details. }

;-- Properties --------------------------------------
Group Config
	objectmod Property BuildingLevelDescription Auto Const
	{ [Optional] Make a copy of the ObjectMod SS2_Template_BuildingPlanDescription. The Title field of this is used to display an additional line of information labeled "Note" when the player chooses View Details from the menu. The Desc is only necessary on branching building plans, and should be a short description of what your level does - this is displayed when selecting between branches. }
	Message Property BuildingLevelConfirm Auto Const
	{ [Optional] This is sort of an extension of the description (the description is limited to about 425 characters). If your level plan is atypical, or requires the player have specific information when using it, this field can be a good way to ensure they get it after selecting your plan. You should also use this to describe any upgrade costs if you are setting them. Create a copy of the Message SS2_Template_BuildingPlanConfirm. Fill out the description with important information and leave the buttons as-is. }
	bool Property bPlayerSelectOnly = False Auto Const
	{ If true, this plan will never be randomly chosen }
	bool Property bHotSwappable = False Auto Const
	{ If true, this can be swapped for other BuildingLevel's of the same ilevel and same ParentBuildingPlan without the plot having to be reset. Generally used for things like material swaps, faction theming, or some other vanity change. }
	bool Property bDoesNotRequirePower = False Auto Const
	{ If set to true, the plot will not need to be powered. This will allow you to take away power requirements, even though the default rules require it. }
	bool Property bAlwaysRequirePower = False Auto Const
	{ If set to true, the plot will need to be powered. This will allow you to do things like allow a 2x2 agricultural plan to require power, even though the default rules don't. }
EndGroup

Group Basics
	Weapon Property ParentBuildingPlan Auto Const mandatory
	{ The building plan this is part of. }
	int Property iRequiredLevel Auto Const mandatory
	{ The level this is for }
	Form[] Property StageModels Auto Const mandatory
	{ Stage models in order from stage 1 to the final stage of the level. For old Sim Settlements devs, the building materials are now a separate field. }
	simsettlementsv2:datastructures#stageitemstruct[] Property StageItemSpawns Auto Const
	{ The extra items that should spawn at each stage. }
EndGroup

Group Optional_Extras
	workshopframework:library:datastructures#universalform Property DemolitionExplosionOverride Auto Const
	{ Should be an Explosion type record. If set, this explosion will be used instead of the default explosions for the plot type. This is meant to allow the building appear actually destructible. WARNING: Make sure you create an explosion record that doesn't do damage or you will kill things. }
EndGroup

Group Settlers
	int Property iMaxOccupants = 1 Auto Const
	{ If set, this will override how many people can be assigned to the plot. }
	Form[] Property AutoEquip Auto Const
	{ Include one entry per expected occupant. Can be an individual weapon/armor, an Outfit record, or a Formlist of equippable items. }
	Message[] Property JobTitle Auto Const
	{ Include one entry per expected occupant. The title to apply if this plan is for a job plot assignment. }
EndGroup

Group Advanced collapsedonbase collapsedonref
	MiscObject Property Requirements Auto Const
	{ Requirements for this to be built and operated. Must be of type SimSettlementsV2:MiscObjects:UsageRequirements }
	int Property iPriority = 0 Auto Const
	{ Currently unused. }
	int Property iMaxPerSettlement = 0 Auto Const
	{ [Optional] Set this to limit the number of this item that can appear in a settlement. 0 = unlimited }
	int Property iMaxPerGame = 0 Auto Const
	{ [Optional] Set this to limit the number of this item that can appear at a time in the game. 0 = unlimited }
	Keyword Property LevelKeyword Auto Const
	{ If set, this keyword will be applied to the plot once this level is reached and will remain until the plot building plan changes or a different BuildingLevel with the same iLevel is used to replace this one. You may use the same LevelKeyword for multiple BuildingLevels, but the primary idea behind this is to use it with the Requirements property to allow one level to depend on a another level having been applied earlier - for example, the way Industrial Revolution allows the Brewery to upgrade to a Distillery or Chemical Plant, but not to a Hydration Research Lab or Filtration Plant. }
	float[] Property PositionOffsets Auto Const
	{ Generally used with building plans imported from SS1. This will cause all stage models and stage items to be offset by these amounts when placed. }
	float[] Property PlotIconPositionOffsets Auto Const
	{ If the floating icons clip with your model, you can enter 3 numbers representing X, Y, and Z adjustments. (If you are looking for the same thing for the ASAM Sensor - spawn one of the SS2_Marker_ASAMSensorPositioner_ activator objects in your staeg item spawns) }
EndGroup

Group Resources collapsedonbase collapsedonref
	bool Property ConstructionCostsAreAdditional = True Auto Const
	{ If false, the ConstructionCosts will replace those at the BuildingPlan and Class level }
	simsettlementsv2:datastructures#plotconsumption[] Property ConstructionCosts Auto Const
	{ Items this plan will consume in order to be constructed/upgraded. iOccupants field is not used. }
	bool Property OperatingCostsAreAdditional = True Auto Const
	{ If false, the OperatingCosts will replace those at the BuildingPlan and Class level }
	simsettlementsv2:datastructures#plotconsumption[] Property OperatingCosts Auto Const
	{ Items this building plan will consume each cycle, if not available, the building will be made inactive until it can next consume the appropriate costs. The iOccupants field can be used to adjust the affects based on the number of people occupying the plot (ie. if iOccupants is > 1, that entry will only go into affect if at least that many people occupy the plot). }
	bool Property ProducedItemsAreAdditional = True Auto Const
	{ If false, the ProduceItems will replace those at the BuildingPlan and Class level }
	simsettlementsv2:datastructures#plotproduction[] Property ProducedItems Auto Const
	{ Items this building plan will produce each cycle . The iOccupants field can be used to adjust the affects based on the number of people occupying the plot (ie. if iOccupants is > 1, that entry will only go into affect if at least that many people occupy the plot). }
	bool Property SettlementResourcesAreAdditional = True Auto Const
	{ If false, the SettlementResources will replace those at the BuildingPlan and Class level }
	simsettlementsv2:datastructures#plotresource[] Property SettlementResources Auto Const
	{ These AVs will be set on the settlement while this is active. This is used to add things like, food, water, defense, etc as well as virtual resources like settlement building materials. The iOccupants field can be used to adjust the affects based on the number of people occupying the plot (ie. if iOccupants is > 1, that entry will only go into affect if at least that many people occupy the plot). }
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

simsettlementsv2:miscobjects:usagerequirements Function GetRequirements()
	return (Requirements as Form) as simsettlementsv2:miscobjects:usagerequirements
EndFunction

simsettlementsv2:weapons:buildingplan Function GetParentBuildingPlan()
	return (ParentBuildingPlan as Form) as simsettlementsv2:weapons:buildingplan
EndFunction
