;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Weapons\BuildingPlan.psc
Modified : 2020-12-20 02:48:46
Compiled : 2021-01-07 11:44:37
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:Weapons:BuildingPlan extends Form Const
{ Holds building plan details. }

;-- Properties --------------------------------------
Group Config
	Keyword Property ClassKeyword Auto Const mandatory
	{ Search for SS2_PlotTypeSubClass_ to find available options. Flags this building plan as being a particular subtype of the plot it is for. This is used in helping with even distribution of plans, as well as to instill certain functionality automatically. For example, this is how you tell SS if your shop is a Bar, or Weapons Store, or Clothing Store, etc. }
	objectmod Property BuildingPlanDescription Auto Const mandatory
	{ Make a copy of the ObjectMod SS2_Template_BuildingPlanDescription. The Desc should be a short description of what your plot provides - this is used for displaying information on the ASAM Sensor. }
	Message Property BuildingPlanConfirm Auto Const
	{ [Optional] This is sort of an extension of the description (the description is limited to about 425 characters). If your building plan is atypical, or requires the player have specific information when using it, this field can be a good way to ensure they get it after selecting your plan. Create a copy of the Message SS2_Template_BuildingPlanConfirm. Fill out the description with important information and leave the buttons as-is. }
	bool Property bPlayerSelectOnly = False Auto Const
	{ If true, this plan will never be randomly chosen }
	bool Property bIsBranchingPlan = False Auto Const
	{ If you have level plans that share a level, but are not hotswappable, you should set this to true so the player can have an opportunity to choose the upgrade branch manually. }
	FormList Property LevelPlansList Auto Const mandatory
	{ Formlist of BuildingLevelPlan objects that go with this plan. }
EndGroup

Group Optional_Extras
	Form Property BuildingMaterialsOverride Auto Const
	{ If set, this model will be used instead of one of the default building material types for the plot type. You may also use a Formlist here to provide a set of random options. }
	float[] Property BuildingMaterialsOverridePositionOffsets Auto Const
	{ [Optional] Generally used with building materials imported from SS1 only - offsets the placement of the building materials by these amounts from the plot itself. }
	workshopframework:library:datastructures#universalform Property DemolitionExplosionOverride Auto Const
	{ Should be an Explosion type record. If set, this explosion will be used instead of the default explosions for the plot type. If a BuildingLevelPlan has this same field set, that will be used instead. WARNING: Make sure you create an explosion record that doesn't do damage or you will kill things. }
EndGroup

Group Resources collapsedonbase collapsedonref
	bool Property ConstructionCostsAreAdditional = True Auto Const
	{ If false, the ConstructionCosts will replace those at the BuildingClass level }
	simsettlementsv2:datastructures#plotconsumption[] Property ConstructionCosts Auto Const
	{ Items this plan will consume in order to be constructed/upgraded. iOccupants field is not used. }
	bool Property OperatingCostsAreAdditional = True Auto Const
	{ If false, the OperatingCosts will replace those at the BuildingClass level }
	simsettlementsv2:datastructures#plotconsumption[] Property OperatingCosts Auto Const
	{ Items this building plan will consume each cycle, if not available, the building will be made inactive until it can next consume the appropriate costs. The iOccupants field can be used to adjust the affects based on the number of people occupying the plot (ie. if iOccupants is > 1, that entry will only go into affect if at least that many people occupy the plot). }
	bool Property ProducedItemsAreAdditional = True Auto Const
	{ If false, the ProduceItems will replace those at the BuildingClass level }
	simsettlementsv2:datastructures#plotproduction[] Property ProducedItems Auto Const
	{ Items this building plan will produce each cycle . The iOccupants field can be used to adjust the affects based on the number of people occupying the plot (ie. if iOccupants is > 1, that entry will only go into affect if at least that many people occupy the plot). }
	bool Property SettlementResourcesAreAdditional = True Auto Const
	{ If false, the SettlementResources will replace those at the BuildingClass level }
	simsettlementsv2:datastructures#plotresource[] Property SettlementResources Auto Const
	{ These AVs will be set on the settlement while this is active. This is used to add things like, food, water, defense, etc as well as virtual resources like settlement building materials. The iOccupants field can be used to adjust the affects based on the number of people occupying the plot (ie. if iOccupants is > 1, that entry will only go into affect if at least that many people occupy the plot). }
EndGroup

Group Advanced collapsedonbase collapsedonref
	MiscObject Property Requirements Auto Const
	{ Requirements for this to be built and operated. Must be of type SimSettlementsV2:MiscObjects:UsageRequirements }
	int Property iPriority = 0 Auto Const
	{ Currently unused. }
	int Property iMaxPerSettlement = 0 Auto Const
	{ [Optional] Set this to limit the number of this item that can appear in a settlement. 0 = unlimited }
	int Property iMaxPerGame = 0 Auto Const
	{ [Optional] Set this to limit the number of this item that can appear at a time in the game. 0 = unlimited }
	float[] Property PlotIconPositionOffsets Auto Const
	{ If the floating icons clip with your model, you can enter 3 numbers representing X, Y, and Z adjustments. (If you are looking for the same thing for the ASAM Sensor - spawn one of the SS2_Marker_ASAMSensorPositioner_ activator objects in your staeg item spawns) }
	workshopframework:library:datastructures#universalform[] Property OriginalPlans Auto Const
	{ Used for merged addons such as the MegaPacks to detect the original mod and pass control to it. }
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

simsettlementsv2:miscobjects:usagerequirements Function GetRequirements()
	return (Requirements as Form) as simsettlementsv2:miscobjects:usagerequirements
EndFunction

bool Function IsOriginalPlanInstalled()
	If (OriginalPlans == None || OriginalPlans.length == 0)
		return False
	EndIf
	int I = 0
	While (I < OriginalPlans.length)
		Form OriginalPlan = workshopframework:library:utilityfunctions.GetUniversalForm(OriginalPlans[I])
		If (OriginalPlan != None)
			return True
		EndIf
		I += 1
	EndWhile
	return False
EndFunction
