;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Weapons\CityPlanLayout.psc
Modified : 2021-03-23 18:03:44
Compiled : 2021-03-23 18:03:49
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:Weapons:CityPlanLayout extends WorkshopFramework:Weapons:SettlementLayout Const
{ Holds city plan layout details. }

;-- Properties --------------------------------------
Group LayoutDetails
	Form Property ParentCityPlan Auto Const mandatory
	{ Should be of type SimSettlementsV2:Weapons:CityPlan }
	int Property iMinLevel = 0 Auto Const
	int Property iRemoveAtLevel = -1 Auto Const
EndGroup

Group LayoutItems
	int Property iIndexOffset = 0 Auto Const
	{ Used to ensure that all items between all city plan layouts use the same index set. This allows us to reference items between layouts. }
	simsettlementsv2:datastructures#cityplanlayoutpairingdata[] Property SurviveLayoutChangeData Auto Const
	{ Holds information necessary so that things like plots can be moved and updated between layout shifts. For example, plots could be configured to move to a new location or change building plans - without screwing up assignment or other data applied to them by mods and players. }
	simsettlementsv2:datastructures#cityplanlayoutplotleveldata[] Property PlotLevelData Auto Const
	{ Holds information about what level each plot should be set to }
	workshopframework:library:datastructures#worldobject[] Property CameraMarkers Auto Const
	{ Holds camera markers if found in the settlement so these can be placed before the city plan construction starts. }
EndGroup

Group LayoutChanges collapsedonref collapsedonbase
	workshopframework:library:datastructures#universalform Property PreferredFlag Auto Const
	{ [Optional] Flag this settlement plan will use, if available }
	Message Property LayoutAppliedMessage Auto Const
	{ [Optional] If set, this message will be displayed when the settlement activates this layout }
	GlobalVariable Property ToggleGlobal Auto Const
	{ [Optional] If set, this global will be set to 1 after this layer is activated, and set to 0 if the layer is removed. }
EndGroup

Group Advanced collapsedonref collapsedonbase
	MiscObject Property Requirements Auto Const
	{ Requirements for this to be available to use. Must be of type SimSettlementsV2:MiscObjects:UsageRequirements }
	bool Property bScrapIfRequirementsFail = False Auto Const
	{ If true then if Requirements ever become false, this layout will be removed. }
	bool Property bIgnorePerformanceOptions = False Auto Const
	{ When set to true, these items will be displayed regardless of performance options. This should only be used for very small layers. }
	bool Property bDoNotUseCinematicMode = False Auto Const
	{ When true, this layer won't trigger cinematic mode. Useful for extra layers, or very small players where the player wouldn't understand why they were in Cinematic mode. }
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

GlobalVariable Function GetAllowCityPlansToStartPlotsAtHigherLevels()
	return Game.GetFormFromFile(285923, "SS2.esm") as GlobalVariable
EndFunction

simsettlementsv2:quests:plotmanager Function GetPlotManager()
	return Game.GetFormFromFile(60231, "SS2.esm") as simsettlementsv2:quests:plotmanager
EndFunction

GlobalVariable Function GetAllowCityPlanUpgradesToUpgradeAndChangePlots()
	return Game.GetFormFromFile(285916, "SS2.esm") as GlobalVariable
EndFunction

GlobalVariable Function GetUseDesignersPlotPlans()
	return Game.GetFormFromFile(66272, "SS2.esm") as GlobalVariable
EndFunction

var[] Function GetDesignersChoiceData(int aiWorkshopResourceIndex)
	var[] ChoiceData = new var[3]
	int iPlanIndex = ExtraData_Forms01.findstruct("iIndex", aiWorkshopResourceIndex, 0)
	If (iPlanIndex >= 0)
		ChoiceData[0] = workshopframework:library:utilityfunctions.GetIndexMappedUniversalForm(ExtraData_Forms01[iPlanIndex]) as var
	EndIf
	int iSkinIndex = ExtraData_Forms02.findstruct("iIndex", aiWorkshopResourceIndex, 0)
	If (iSkinIndex >= 0)
		ChoiceData[1] = workshopframework:library:utilityfunctions.GetIndexMappedUniversalForm(ExtraData_Forms02[iSkinIndex]) as var
	EndIf
	int iLevelIndex = PlotLevelData.findstruct("iLayoutIndex", aiWorkshopResourceIndex, 0)
	If (iLevelIndex >= 0)
		ChoiceData[2] = PlotLevelData[iLevelIndex].iLevel as var
	Else
		iLevelIndex = ExtraData_Numbers01.findstruct("iIndex", aiWorkshopResourceIndex, 0)
		If (iLevelIndex >= 0)
			ChoiceData[2] = (ExtraData_Numbers01[iLevelIndex].fNumber as int) as var
		Else
			ChoiceData[2] = (-2) as var
		EndIf
	EndIf
	return ChoiceData
EndFunction

bool Function ShouldPlaceObject(workshopscript akWorkshopRef, int aiObjectsGroupType, int aiObjectsGroupIndex)
	Form FormToCheck = None
	If (aiObjectsGroupType == iGroupType_WorkshopResources)
		FormToCheck = workshopframework:library:utilityfunctions.GetWorldObjectForm(WorkshopResources[aiObjectsGroupIndex], -1)
	ElseIf (aiObjectsGroupType == iGroupType_NonResources)
		FormToCheck = workshopframework:library:utilityfunctions.GetWorldObjectForm(NonResourceObjects[aiObjectsGroupIndex], -1)
	EndIf
	If (Self.GetAllDLCInstalled().GetValueInt() == 0)
		simsettlementsv2:quests:cityplanmanager CityPlanManager = Self.GetCityPlanManager()
		If (!CityPlanManager.SoftDLCRequirementsMet(FormToCheck))
			return False
		EndIf
	EndIf
	If (Self.GetAllPerformanceClassesEnabled().GetValueInt() == 0)
		simsettlementsv2:quests:cityplanmanager cityplanmanager = Self.GetCityPlanManager()
		If (!cityplanmanager.CheckPerformanceSettingsForPlacement(FormToCheck))
			return False
		EndIf
	EndIf
	If (SurviveLayoutChangeData == None || SurviveLayoutChangeData.length == 0 || SurviveLayoutChangeData.findstruct("iLayoutGroupType", aiObjectsGroupType, 0) < 0)
		return True
	EndIf
	int iOffsetIndex = aiObjectsGroupIndex + iIndexOffset
	int iSurviveIndex = SurviveLayoutChangeData.findstruct("iNewLayoutIndex", iOffsetIndex, 0)
	While (iSurviveIndex >= 0 && SurviveLayoutChangeData[iSurviveIndex].iLayoutGroupType != aiObjectsGroupType)
		iSurviveIndex = SurviveLayoutChangeData.findstruct("iNewLayoutIndex", iOffsetIndex, iSurviveIndex)
	EndWhile
	If (iSurviveIndex >= 0)
		int iNewLayoutIndex_OffsetRemoved = SurviveLayoutChangeData[iSurviveIndex].iNewLayoutIndex - iIndexOffset
		workshopframework:library:datastructures#worldobject ExpectedPositionData = None
		If (aiObjectsGroupType == iGroupType_WorkshopResources)
			ExpectedPositionData = WorkshopResources[iNewLayoutIndex_OffsetRemoved]
		ElseIf (aiObjectsGroupType == iGroupType_NonResources)
			ExpectedPositionData = NonResourceObjects[iNewLayoutIndex_OffsetRemoved]
		EndIf
		Form SearchFor = workshopframework:library:utilityfunctions.GetWorldObjectForm(ExpectedPositionData, -1)
		If (SearchFor != None)
			Form PositionHelper = Self.GetPositionHelper()
			If (PositionHelper != None)
				ObjectReference kPosHelperRef = akWorkshopRef.PlaceAtMe(PositionHelper, 1, False, False, True)
				kPosHelperRef.SetPosition(ExpectedPositionData.fPosX, ExpectedPositionData.fPosY, ExpectedPositionData.fPosZ)
				ObjectReference kFoundRef = Game.FindClosestReferenceOfTypeFromRef(SearchFor, kPosHelperRef, 16)
				kPosHelperRef.Disable(False)
				kPosHelperRef.Delete()
				If (kFoundRef)
					return False
				EndIf
			EndIf
		EndIf
	EndIf
	return True
EndFunction

simsettlementsv2:quests:optionsmanager Function GetOptionsManager()
	return Game.GetFormFromFile(60195, "SS2.esm") as simsettlementsv2:quests:optionsmanager
EndFunction

Function HandleSurviveLayoutChangeData(workshopscript akWorkshopRef)
	If (akWorkshopRef == None || !akWorkshopRef.Is3dLoaded() || SurviveLayoutChangeData == None || SurviveLayoutChangeData.length == 0)
		return 
	EndIf
	ActorValue LayoutIndexAV = Self.GetLayoutIndexAV()
	ActorValue LayoutIndexTypeAV = Self.GetLayoutIndexTypeAV()
	simsettlementsv2:quests:optionsmanager OptionsManager = Self.GetOptionsManager()
	simsettlementsv2:quests:plotmanager PlotManager = Self.GetPlotManager()
	workshopframework:wsfw_apiquest API = workshopframework:wsfw_api.GetAPI()
	workshopframework:placeobjectmanager PlaceObjectManager = API.PlaceObjectManager
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	ObjectReference[] kResourceRefs = akWorkshopRef.GetWorkshopResourceObjects(None, 0)
	bool bUseDesignersChoice = OptionsManager.GetSettingValue(Self.GetUseDesignersPlotPlans(), iWorkshopID) > 0 as float
	bool bAllowPlotChanges = OptionsManager.GetSettingValue(Self.GetAllowCityPlanUpgradesToUpgradeAndChangePlots(), iWorkshopID) > 0 as float
	Keyword PlotKeyword = Self.GetPlotKeyword()
	int I = 0
	While (I < kResourceRefs.length)
		If (!kResourceRefs[I].IsDisabled())
			int iThisIndex = kResourceRefs[I].GetValue(LayoutIndexAV) as int - 1
			int iThisGroupType = kResourceRefs[I].GetValue(LayoutIndexTypeAV) as int
			int iSurviveIndex = SurviveLayoutChangeData.findstruct("iNewLayoutIndex", iThisIndex, 0)
			While (iSurviveIndex >= 0 && SurviveLayoutChangeData[iSurviveIndex].iLayoutGroupType != iThisGroupType)
				iSurviveIndex = SurviveLayoutChangeData.findstruct("iNewLayoutIndex", iThisIndex, iSurviveIndex)
			EndWhile
			If (iSurviveIndex >= 0)
				If (kResourceRefs[I].HasKeyword(PlotKeyword))
					PlotManager.RegisterForCleanup(kResourceRefs[I])
				Else
					PlaceObjectManager.ScrapObject(kResourceRefs[I], False)
				EndIf
			EndIf
		EndIf
		I += 1
	EndWhile
	I = 0
	While (I < kResourceRefs.length)
		If (!kResourceRefs[I].IsDisabled())
			int ithisindex = kResourceRefs[I].GetValue(LayoutIndexAV) as int - 1
			int ithisgrouptype = kResourceRefs[I].GetValue(LayoutIndexTypeAV) as int
			int isurviveindex = SurviveLayoutChangeData.findstruct("iPreviousLayoutIndex", ithisindex, 0)
			While (isurviveindex >= 0 && SurviveLayoutChangeData[isurviveindex].iLayoutGroupType != ithisgrouptype)
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "HandleSurviveLayoutChangeData index " + isurviveindex as string + " does not match group type " + ithisgrouptype as string + ", checking ahead for additional entries for " + ithisindex as string, 0, False)
				If (SurviveLayoutChangeData.length <= isurviveindex)
					isurviveindex = -1
				Else
					isurviveindex = SurviveLayoutChangeData.findstruct("iPreviousLayoutIndex", ithisindex, isurviveindex + 1)
				EndIf
			EndWhile
			If (isurviveindex >= 0)
				int iNewLayoutIndex_OffsetRemoved = SurviveLayoutChangeData[isurviveindex].iNewLayoutIndex - iIndexOffset
				workshopframework:library:datastructures#worldobject newObjectData = None
				If (ithisgrouptype == iGroupType_WorkshopResources)
					newObjectData = WorkshopResources[iNewLayoutIndex_OffsetRemoved]
				ElseIf (ithisgrouptype == iGroupType_NonResources)
					newObjectData = NonResourceObjects[iNewLayoutIndex_OffsetRemoved]
				EndIf
				kResourceRefs[I].SetPosition(newObjectData.fPosX, newObjectData.fPosY, newObjectData.fPosZ)
				kResourceRefs[I].SetAngle(newObjectData.fAngleX, newObjectData.fAngleY, newObjectData.fAngleZ)
				If (newObjectData.fScale != 0 as float)
					kResourceRefs[I].SetScale(newObjectData.fScale)
				EndIf
				kResourceRefs[I].SetValue(LayoutIndexAV, (SurviveLayoutChangeData[isurviveindex].iNewLayoutIndex + 1) as float)
				int j = 0
				While (j < akWorkshopRef.AppliedLayouts.length)
					kResourceRefs[I].RemoveKeyword(akWorkshopRef.AppliedLayouts[j].TagKeyword)
					j += 1
				EndWhile
				kResourceRefs[I].AddKeyword(TagKeyword)
				If (kResourceRefs[I].HasKeyword(PlotKeyword) && bAllowPlotChanges)
					simsettlementsv2:objectreferences:simplot asPlot = kResourceRefs[I] as simsettlementsv2:objectreferences:simplot
					Form OriginalForm = asPlot.GetBaseObject()
					Form NewForm = workshopframework:library:utilityfunctions.GetWorldObjectForm(newObjectData, -1)
					Form DesignersChoicePlan = None
					Form DesignersChoiceSkin = None
					int iDesignersChoiceLevel = -2
					If (bUseDesignersChoice)
						var[] ChoiceData = Self.GetDesignersChoiceData(iNewLayoutIndex_OffsetRemoved)
						workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "ChoiceData returned: " + ChoiceData as string + " for index: " + iNewLayoutIndex_OffsetRemoved as string, 0, False)
						DesignersChoicePlan = ChoiceData[0] as Form
						DesignersChoiceSkin = ChoiceData[1] as Form
						iDesignersChoiceLevel = ChoiceData[2] as int
					EndIf
					If (NewForm != OriginalForm)
						var[] kArgs = new var[0]
						kArgs.add(asPlot as var, 1)
						kArgs.add(NewForm as var, 1)
						kArgs.add(False as var, 1)
						kArgs.add(DesignersChoicePlan as var, 1)
						kArgs.add(DesignersChoiceSkin as var, 1)
						PlotManager.CallFunctionNoWait("ChangePlot", kArgs)
					ElseIf (DesignersChoicePlan != None && !asPlot.bPlayerSelectedPlanManually)
						simsettlementsv2:datastructures#plotplanset newSet = new simsettlementsv2:datastructures#plotplanset
						int iRequiredLevel = -1
						If (DesignersChoicePlan as simsettlementsv2:weapons:buildinglevelplan)
							newSet.Level = DesignersChoicePlan as simsettlementsv2:weapons:buildinglevelplan
							iRequiredLevel = newSet.Level.iRequiredLevel
							newSet.Plan = ((DesignersChoicePlan as simsettlementsv2:weapons:buildinglevelplan).ParentBuildingPlan as Form) as simsettlementsv2:weapons:buildingplan
						ElseIf (DesignersChoicePlan as simsettlementsv2:weapons:buildingplan)
							newSet.Plan = DesignersChoicePlan as simsettlementsv2:weapons:buildingplan
						EndIf
						If (newSet.Plan != None)
							If (DesignersChoiceSkin != None)
								If (DesignersChoiceSkin as simsettlementsv2:weapons:buildinglevelskin)
									newSet.LevelSkin = DesignersChoiceSkin as simsettlementsv2:weapons:buildinglevelskin
									newSet.Skin = (newSet.LevelSkin.ParentBuildingSkin as Form) as simsettlementsv2:weapons:buildingskin
								ElseIf (DesignersChoiceSkin as simsettlementsv2:weapons:buildingskin)
									newSet.Skin = DesignersChoiceSkin as simsettlementsv2:weapons:buildingskin
								EndIf
							EndIf
							If (iRequiredLevel > 0)
								asPlot.iTargetLevel = iRequiredLevel
								iDesignersChoiceLevel = iRequiredLevel
							EndIf
							var[] kargs = new var[0]
							kargs.add(newSet as var, 1)
							kargs.add(False as var, 1)
							kargs.add(False as var, 1)
							asPlot.CallFunctionNoWait("AssignPlotPlanSet", kargs)
						EndIf
						If (iDesignersChoiceLevel > -2)
							var[] kargs = new var[0]
							kargs.add(iDesignersChoiceLevel as var, 1)
							kargs.add((-1) as var, 1)
							asPlot.CallFunctionNoWait("ForcePlotLevel", kargs)
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction

simsettlementsv2:miscobjects:usagerequirements Function GetRequirements()
	return (Requirements as Form) as simsettlementsv2:miscobjects:usagerequirements
EndFunction

GlobalVariable Function GetAllPerformanceClassesEnabled()
	return Game.GetFormFromFile(304706, "SS2.esm") as GlobalVariable
EndFunction

GlobalVariable Function GetAllDLCInstalled()
	return Game.GetFormFromFile(304706, "SS2.esm") as GlobalVariable
EndFunction

float Function CalculateBuildLimitUsage()
	float fUsage = 0
	workshopscript layoutWorkshopRef = workshopframework:library:utilityfunctions.GetUniversalForm(WorkshopRef) as workshopscript
	Keyword WorkshopItemKeyword = Self.GetWorkshopItemKeyword()
	ObjectReference[] kLinkedRefs = layoutWorkshopRef.GetLinkedRefChildren(WorkshopItemKeyword)
	ActorValue WorkshopCurrentDraws = Self.GetWorkshopCurrentDraws()
	int I = 0
	While (I < kLinkedRefs.length)
		If (kLinkedRefs[I].HasKeyword(TagKeyword))
			If (!kLinkedRefs[I] as simsettlementsv2:objectreferences:simplot)
				fUsage += kLinkedRefs[I].GetValue(WorkshopCurrentDraws)
			EndIf
		EndIf
		I += 1
	EndWhile
	return fUsage
EndFunction

GlobalVariable Function GetFauxPowerCityPlanObjects()
	return Game.GetFormFromFile(285922, "SS2.esm") as GlobalVariable
EndFunction

Keyword Function GetCityPlanSpawnedKeyword()
	return Game.GetFormFromFile(88039, "SS2.esm") as Keyword
EndFunction

Keyword Function GetPlotKeyword()
	return Game.GetFormFromFile(84388, "SS2.esm") as Keyword
EndFunction

bool Function PlaceObjectThreadLastCall(ObjectReference akThreadRef)
	workshopframework:objectrefs:thread_placeobject asPlaceObjectThread = akThreadRef as workshopframework:objectrefs:thread_placeobject
	ActorValue LayoutIndexAV = Self.GetLayoutIndexAV()
	Keyword CityPlanSpawned = Self.GetCityPlanSpawnedKeyword()
	int iFauxPowerSetting = Self.GetFauxPowerCityPlanObjects().GetValueInt()
	asPlaceObjectThread.bFauxPowered = iFauxPowerSetting == 1
	If (iMinLevel == 0 && asPlaceObjectThread.SpawnMe.HasKeyword(Self.GetPlotKeyword()))
		If (Self.GetAllowCityPlansToStartPlotsAtHigherLevels().GetValueInt() == 0)
			asPlaceObjectThread.ExtraData_Number01 = 0 as float
			asPlaceObjectThread.ExtraData_Number01Set = False
		EndIf
	EndIf
	Keyword WorkshopWorkObject = Self.GetWorkshopWorkObjectKeyword()
	If (asPlaceObjectThread.SpawnMe.HasKeyword(WorkshopWorkObject))
		asPlaceObjectThread.AddPlacedObjectToCollection = Self.GetNPCAssignmentManager().ObjectsAwaitingAssignment
	EndIf
	asPlaceObjectThread.AddTagKeyword(CityPlanSpawned)
	int iTagIndex = -1
	If (asPlaceObjectThread.TagAVs != None)
		int I = 0
		While (I < asPlaceObjectThread.TagAVs.length)
			If (workshopframework:library:utilityfunctions.GetActorValueSetForm(asPlaceObjectThread.TagAVs[I]) == LayoutIndexAV)
				iTagIndex = asPlaceObjectThread.TagAVs[I].fValue as int + iIndexOffset
				asPlaceObjectThread.TagAVs[I].fValue = iTagIndex as float
			EndIf
			I += 1
		EndWhile
	EndIf
	return True
EndFunction

Function PowerUp(workshopscript akWorkshopRef)
	workshopframework:f4semanager F4SEManager = Self.GetF4SEManager()
	If (F4SEManager.IsF4SERunning)
		If (!akWorkshopRef.bHasEnteredWorkshopModeHere)
			akWorkshopRef.StartWorkshop(True)
		EndIf
		If (PowerConnections != None)
			ObjectReference[] kLinkedRefs = akWorkshopRef.GetLinkedRefChildren(Self.GetWorkshopItemKeyword())
			ActorValue LayoutIndexAV = Self.GetLayoutIndexAV()
			ActorValue LayoutIndexTypeAV = Self.GetLayoutIndexTypeAV()
			ActorValue WorkshopPowerConnectionAV = Self.GetWorkshopPowerConnectionAV()
			ActorValue WorkshopSnapTransmitsPowerAV = Self.GetWorkshopSnapTransmitsPowerAV()
			Keyword WorkshopPowerConnectionKeyword = Self.GetWorkshopPowerConnectionKeyword()
			FormList SkipPowerOnList = Self.GetSkipPowerOnList()
			workshopframework:library:datastructures#powerconnectionlookup[] Group01 = new workshopframework:library:datastructures#powerconnectionlookup[0]
			workshopframework:library:datastructures#powerconnectionlookup[] Group02 = new workshopframework:library:datastructures#powerconnectionlookup[0]
			workshopframework:library:datastructures#powerconnectionlookup[] Group03 = new workshopframework:library:datastructures#powerconnectionlookup[0]
			workshopframework:library:datastructures#powerconnectionlookup[] Group04 = new workshopframework:library:datastructures#powerconnectionlookup[0]
			workshopframework:library:datastructures#powerconnectionlookup[] Group05 = new workshopframework:library:datastructures#powerconnectionlookup[0]
			workshopframework:library:datastructures#powerconnectionlookup[] Group06 = new workshopframework:library:datastructures#powerconnectionlookup[0]
			workshopframework:library:datastructures#powerconnectionlookup[] Group07 = new workshopframework:library:datastructures#powerconnectionlookup[0]
			workshopframework:library:datastructures#powerconnectionlookup[] Group08 = new workshopframework:library:datastructures#powerconnectionlookup[0]
			Keyword CityPlanSpawned = Self.GetCityPlanSpawnedKeyword()
			int I = 0
			int iPoweredConnectableCounter = 0
			int iPowerDataFoundFor = 0
			While (I < kLinkedRefs.length)
				If (!kLinkedRefs[I].IsDisabled() && kLinkedRefs[I].HasKeyword(CityPlanSpawned) && (kLinkedRefs[I].HasKeyword(WorkshopPowerConnectionKeyword) || kLinkedRefs[I].GetValue(WorkshopPowerConnectionAV) > 0 as float))
					iPoweredConnectableCounter += 1
					int iIndex = (kLinkedRefs[I].GetValue(LayoutIndexAV) - 1 as float) as int
					If (iIndex >= 0)
						iPowerDataFoundFor += 1
						int iType = kLinkedRefs[I].GetValue(LayoutIndexTypeAV) as int
						workshopframework:library:datastructures#powerconnectionlookup newLookup = new workshopframework:library:datastructures#powerconnectionlookup
						newLookup.kPowereableRef = kLinkedRefs[I]
						newLookup.iIndex = iIndex
						newLookup.iIndexType = iType
						If (Group01.length < 128)
							Group01.add(newLookup, 1)
						ElseIf (Group02.length < 128)
							Group02.add(newLookup, 1)
						ElseIf (Group03.length < 128)
							Group03.add(newLookup, 1)
						ElseIf (Group04.length < 128)
							Group04.add(newLookup, 1)
						ElseIf (Group05.length < 128)
							Group05.add(newLookup, 1)
						ElseIf (Group06.length < 128)
							Group06.add(newLookup, 1)
						ElseIf (Group07.length < 128)
							Group07.add(newLookup, 1)
						ElseIf (Group08.length < 128)
							If (Group08.length == 0)
								workshopframework:library:utilityfunctions.ModTrace(">>>>>>>>>>Filling group 8 - should add more groups to code base.", 0, False)
							EndIf
							Group08.add(newLookup, 1)
						EndIf
					EndIf
				EndIf
				I += 1
			EndWhile
			I = 0
			While (I < PowerConnections.length)
				ObjectReference kObjectRefA = Self.FindPowereableRef(Group01, PowerConnections[I], True)
				ObjectReference kObjectRefB = None
				If (!kObjectRefA)
					kObjectRefA = Self.FindPowereableRef(Group02, PowerConnections[I], True)
					If (!kObjectRefA)
						kObjectRefA = Self.FindPowereableRef(Group03, PowerConnections[I], True)
						If (!kObjectRefA)
							kObjectRefA = Self.FindPowereableRef(Group04, PowerConnections[I], True)
							If (!kObjectRefA)
								kObjectRefA = Self.FindPowereableRef(Group05, PowerConnections[I], True)
								If (!kObjectRefA)
									kObjectRefA = Self.FindPowereableRef(Group06, PowerConnections[I], True)
									If (!kObjectRefA)
										kObjectRefA = Self.FindPowereableRef(Group07, PowerConnections[I], True)
										If (!kObjectRefA)
											kObjectRefA = Self.FindPowereableRef(Group08, PowerConnections[I], True)
										EndIf
									EndIf
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
				If (kObjectRefA as bool && !kObjectRefB)
					kObjectRefB = Self.FindPowereableRef(Group01, PowerConnections[I], False)
					If (!kObjectRefB)
						kObjectRefB = Self.FindPowereableRef(Group02, PowerConnections[I], False)
						If (!kObjectRefB)
							kObjectRefB = Self.FindPowereableRef(Group03, PowerConnections[I], False)
							If (!kObjectRefB)
								kObjectRefB = Self.FindPowereableRef(Group04, PowerConnections[I], False)
								If (!kObjectRefB)
									kObjectRefB = Self.FindPowereableRef(Group05, PowerConnections[I], False)
									If (!kObjectRefB)
										kObjectRefB = Self.FindPowereableRef(Group06, PowerConnections[I], False)
										If (!kObjectRefB)
											kObjectRefB = Self.FindPowereableRef(Group07, PowerConnections[I], False)
											If (!kObjectRefB)
												kObjectRefB = Self.FindPowereableRef(Group08, PowerConnections[I], False)
											EndIf
										EndIf
									EndIf
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
				If (kObjectRefA as bool && kObjectRefB as bool)
					ObjectReference kWireRef = F4SEManager.AttachWire(kObjectRefA, kObjectRefB, None)
					If (kWireRef != None)
						kWireRef.Enable(False)
						kWireRef.AddKeyword(TagKeyword)
					Else
						kWireRef = F4SEManager.CreateWire(kObjectRefA, kObjectRefB, None)
						If (!kWireRef)
							workshopframework:library:utilityfunctions.ModTrace("[PowerUpAttemptResult] Failed to create wire between " + kObjectRefA as string + " and " + kObjectRefB as string + ".", 0, False)
						ElseIf (kWireRef.IsDisabled())
							kWireRef.Enable(False)
							kWireRef.AddKeyword(TagKeyword)
						EndIf
					EndIf
				Else
					workshopframework:library:utilityfunctions.ModTrace("[PowerUpFailure] Could not find refs to make connection: " + PowerConnections[I] as string, 0, False)
				EndIf
				I += 1
			EndWhile
			I = 0
			While (I < kLinkedRefs.length)
				If (!kLinkedRefs[I].IsDisabled())
					If (kLinkedRefs[I].GetValue(WorkshopSnapTransmitsPowerAV) > 0 as float)
						F4SEManager.TransmitConnectedPower(kLinkedRefs[I])
					EndIf
				EndIf
				I += 1
			EndWhile
			Self.ShutOffSkipPowerItems(akWorkshopRef)
		EndIf
	EndIf
EndFunction

simsettlementsv2:quests:npc_assignmentmanager Function GetNPCAssignmentManager()
	return Game.GetFormFromFile(60157, "SS2.esm") as simsettlementsv2:quests:npc_assignmentmanager
EndFunction

ActorValue Function GetWorkshopCurrentDraws()
	return Game.GetFormFromFile(842, "Fallout4.esm") as ActorValue
EndFunction

simsettlementsv2:weapons:cityplan Function GetParentCityPlan()
	return ParentCityPlan as simsettlementsv2:weapons:cityplan
EndFunction

simsettlementsv2:armors:themedefinition_flags Function GetPreferredFlag()
	If (PreferredFlag == None)
		return None
	EndIf
	Form FlagForm = workshopframework:library:utilityfunctions.GetUniversalForm(PreferredFlag)
	return FlagForm as simsettlementsv2:armors:themedefinition_flags
EndFunction

simsettlementsv2:quests:cityplanmanager Function GetCityPlanManager()
	return Game.GetFormFromFile(126726, "SS2.esm") as simsettlementsv2:quests:cityplanmanager
EndFunction

Keyword Function GetWorkshopWorkObjectKeyword()
	return Game.GetFormFromFile(132498, "Fallout4.esm") as Keyword
EndFunction

Form Function GetPositionHelper()
	return Game.GetFormFromFile(17665, "WorkshopFramework.esm")
EndFunction
