;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Weapons\LeaderCard.psc
Modified : 2020-12-02 02:12:41
Compiled : 2021-01-07 11:44:40
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:Weapons:LeaderCard extends Form Const
{ Holds leader details. }

;-- Properties --------------------------------------
Group ActorDetails
	workshopframework:library:datastructures#universalform Property ActorBaseForm Auto Const mandatory
	{ Should point to a unique actor's form }
	workshopframework:library:datastructures#universalform Property PreferredFlag Auto Const
	{ [Optional] Makes the leader put up a particular flag for the settlement when assigned. Point to an armor record with the SimSettlementsV2:Armors:ThemeDefinition_Flags script, there are several defined in SS2 by default that start with SS2_ThemeDefinition_Flags_ }
EndGroup

Group Traits
	workshopframework:library:datastructures#universalform Property MajorTrait Auto Const
	{ [Optional] High-impact trait. }
	workshopframework:library:datastructures#universalform[] Property MinorTraits Auto Const
	{ [Optional] Small beneficial traits. Must have one Weakness for each MinorTrait defined, this is done to prevent excessively powerful leaders from being defined. }
	workshopframework:library:datastructures#universalform[] Property Weaknesses Auto Const
	{ [Optional] Small negative traits. }
EndGroup

Group Requirements collapsedonbase collapsedonref
	workshopframework:library:datastructures#universalform[] Property LimitToSettlements Auto Const
	{ Leader can only be used at these settlements }
	workshopframework:library:datastructures#universalform[] Property ExcludeSettlements Auto Const
	{ Leader can NOT be used at these settlements }
	MiscObject Property Requirements Auto Const
	{ Various requirement rules for this person to be used. NOTE: Due to the caching system, the select screen will load faster if you use the Unlockables system to unlock a leader if these requirements only need to be met once (ex. if you want a companion to only be a leader after recruiting them, well the companion can't be unrecruited, so no need to have to check these requirements every single time the player access the leader screen) }
	bool Property bCanOnlyLeadOutposts = False Auto Const
	{ When true, this NPC cannot be the leader of normal settlements, only those converted to Outposts/Vassals. }
	bool Property bCanNotLeadOutposts = False Auto Const
	{ When true, this NPC cannot be the leader of Outposts/Vassals. }
EndGroup

Group Advanced collapsedonbase collapsedonref
	bool Property bIgnoreCommandableFlag = False Auto Const
	{ WARNING!!!!!!!!! Advanced Users Only: When set to true, Sim Settlements will allow them to be a leader, even if they aren't naturally commandable. The other City Leader rules outlined in the tutorial will still apply. This may have dire side effects, such as permanently breaking vanilla behavior on certain NPCs. Be certain you test what happens after you unassign them as leader and scrap the desk. You may need add your own scripting to restore their normal behavior. }
	bool Property bSkipDeskAssignmentWarning = False Auto Const
	{ This should generally be left false. The purpose of this flag is to allow quest moments where it would make sense to assign someone as a leader before the player has even had a chance to build a desk without it reminding the player to do so. }
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

Actor Function GetActor()
	ActorBase thisActorBase = workshopframework:library:utilityfunctions.GetUniversalForm(ActorBaseForm) as ActorBase
	If (thisActorBase != None)
		return thisActorBase.GetUniqueActor()
	EndIf
	return None
EndFunction

simsettlementsv2:armors:themedefinition_flags Function GetPreferredFlag()
	If (PreferredFlag == None)
		return None
	EndIf
	Form FlagForm = workshopframework:library:utilityfunctions.GetUniversalForm(PreferredFlag)
	return FlagForm as simsettlementsv2:armors:themedefinition_flags
EndFunction

simsettlementsv2:miscobjects:leadertrait[] Function GetTraits()
	simsettlementsv2:miscobjects:leadertrait[] Traits = new simsettlementsv2:miscobjects:leadertrait[0]
	If (MajorTrait != None)
		simsettlementsv2:miscobjects:leadertrait asTrait = workshopframework:library:utilityfunctions.GetUniversalForm(MajorTrait) as simsettlementsv2:miscobjects:leadertrait
		If (asTrait as bool && asTrait.iType == asTrait.iTraitType_Major)
			Traits.add(asTrait, 1)
		EndIf
	EndIf
	simsettlementsv2:miscobjects:leadertrait[] tempMinorTraits = new simsettlementsv2:miscobjects:leadertrait[0]
	int I = 0
	While (I < MinorTraits.length)
		If (MinorTraits[I] != None)
			simsettlementsv2:miscobjects:leadertrait astrait = workshopframework:library:utilityfunctions.GetUniversalForm(MinorTraits[I]) as simsettlementsv2:miscobjects:leadertrait
			If (astrait.iType == astrait.iTraitType_Minor)
				tempMinorTraits.add(astrait, 1)
			EndIf
		EndIf
		I += 1
	EndWhile
	simsettlementsv2:miscobjects:leadertrait[] tempWeaknesses = new simsettlementsv2:miscobjects:leadertrait[0]
	I = 0
	While (I < Weaknesses.length)
		simsettlementsv2:miscobjects:leadertrait astrait = workshopframework:library:utilityfunctions.GetUniversalForm(Weaknesses[I]) as simsettlementsv2:miscobjects:leadertrait
		If (astrait.iType == astrait.iTraitType_Weakness)
			tempWeaknesses.add(astrait, 1)
		EndIf
		I += 1
	EndWhile
	I = 0
	While (I < tempWeaknesses.length)
		If (tempMinorTraits.length > I)
			Traits.add(tempMinorTraits[I], 1)
		EndIf
		Traits.add(tempWeaknesses[I], 1)
		I += 1
	EndWhile
	return Traits
EndFunction

simsettlementsv2:miscobjects:usagerequirements Function GetRequirements()
	If (Requirements == None)
		return None
	EndIf
	return (Requirements as Form) as simsettlementsv2:miscobjects:usagerequirements
EndFunction
