;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\AddonPack.psc
Modified : 2020-10-29 21:54:21
Compiled : 2021-01-07 11:42:40
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:AddonPack extends Quest
{ For registering addon pack content with Sim Settlements 2 }

;-- Properties --------------------------------------
Group AddonData
	MiscObject Property MyAddonConfig Auto Const mandatory
	{ Must be of type SimSettlementsV2:MiscObjects:AddonPackConfiguration }
	simsettlementsv2:datastructures#customvendordata[] Property CustomVendorDefinitions Auto Const
	{ If you're using the Custom Vendor System from Workshop Framework, this will handle the registrations for you. }
EndGroup

workshopparentscript Property WorkshopParent Auto hidden
simsettlementsv2:quests:ss2main Property SS2Main Auto hidden
simsettlementsv2:quests:storemanager Property StoreManager Auto hidden
int Property iInstalledVersion = 0 Auto hidden

;-- Variables ---------------------------------------
int iFormID_PlayeRef = 20 Const
int iFormID_SS2AddonTemplate = 60191 Const
int iFormID_StoreManager = 60278 Const
int iFormID_SS2MainQuest = 60233 Const
string sFallout4Plugin = "Fallout4.esm" Const
Actor PlayerRef
int iFormID_SS2Version = 84428 Const
GlobalVariable SS2CurrentVersion

;-- Functions ---------------------------------------

Event Actor.OnPlayerLoadGame(Actor akActorRef)
	Self.UpdateVars()
	int iWaitCount = 0
	While (!SS2Main.IsRunning() && iWaitCount < 10)
		Utility.Wait(2)
	EndWhile
	Self.GameLoaded()
EndEvent

Function InstallModChanges()
	iInstalledVersion = SS2CurrentVersion.GetValueInt()
EndFunction

Event OnQuestInit()
	If (Self as Quest == Game.GetFormFromFile(iFormID_SS2AddonTemplate, "SS2.esm") as Quest)
		Self.Stop()
		return 
	EndIf
	Self.UpdateVars()
	If (SS2Main.IsRunning())
		Self.GameLoaded()
	Else
		Self.RegisterForRemoteEvent(SS2Main as ScriptObject, "OnQuestInit")
	EndIf
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Function GameLoaded()
	SS2Main.RegisterAddonPack(MyAddonConfig as Form)
	int I = 0
	While (I < CustomVendorDefinitions.length)
		WorkshopParent.RegisterCustomVendor(CustomVendorDefinitions[I].sCustomVendorID, CustomVendorDefinitions[I].CustomVendorInventoryFormlist, CustomVendorDefinitions[I].CustomVendorKeyword, CustomVendorDefinitions[I].CustomVendorFaction)
		StoreManager.RegisterCustomVendor(CustomVendorDefinitions[I])
		I += 1
	EndWhile
	If (iInstalledVersion < SS2CurrentVersion.GetValueInt())
		If (iInstalledVersion > 0)
			Self.InstallModChanges()
		Else
			iInstalledVersion = SS2CurrentVersion.GetValueInt()
		EndIf
	EndIf
EndFunction

Event Quest.OnQuestInit(Quest akSenderRef)
	If (akSenderRef == SS2Main as Quest)
		int iWaitCount = 0
		While (!SS2Main.IsRunning() && iWaitCount < 10)
			Utility.Wait(2)
			iWaitCount += 1
		EndWhile
		Self.UnregisterForRemoteEvent(akSenderRef as ScriptObject, "OnQuestInit")
	EndIf
EndEvent

simsettlementsv2:miscobjects:addonpackconfiguration Function GetAddonConfig()
	return (MyAddonConfig as Form) as simsettlementsv2:miscobjects:addonpackconfiguration
EndFunction

Function UpdateVars()
	If (SS2Main == None)
		SS2Main = Game.GetFormFromFile(iFormID_SS2MainQuest, "SS2.esm") as simsettlementsv2:quests:ss2main
	EndIf
	If (StoreManager == None)
		StoreManager = Game.GetFormFromFile(iFormID_StoreManager, "SS2.esm") as simsettlementsv2:quests:storemanager
	EndIf
	If (SS2CurrentVersion == None)
		SS2CurrentVersion = Game.GetFormFromFile(iFormID_SS2Version, "SS2.esm") as GlobalVariable
	EndIf
	If (PlayerRef == None)
		PlayerRef = Game.GetFormFromFile(iFormID_PlayeRef, sFallout4Plugin) as Actor
	EndIf
	If (WorkshopParent == None)
		WorkshopParent = Game.GetFormFromFile(132494, sFallout4Plugin) as workshopparentscript
	EndIf
EndFunction
