;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\BasicAttack.psc
Modified : 2020-08-21 01:09:24
Compiled : 2021-01-07 11:42:32
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:BasicAttack extends Quest

;-- Properties --------------------------------------
RefCollectionAlias Property Wave01 Auto Const
RefCollectionAlias Property Wave02 Auto Const
RefCollectionAlias Property Wave03 Auto Const
RefCollectionAlias Property SpawnPoints Auto Const
float Property fMinEnemyDistance = 2000 Auto Const
float Property fInitialDelay = 10 Auto Const
float Property fWaveTime = 60 Auto Const
float Property fStaggerWavePercent = 0 Auto Const
{ To divide the wave into groups, set this number }
float Property fStaggerDelay = 10 Auto Const
{ Amount of time to wait for the next batch of a wave - only used if iStaggerWaveGroupCount is set above 0 }
int Property iMinEnemies = 1 Auto Const
int Property iMaxEnemies = 0 Auto Const
{ If > 0, the number of enemies in the wave will be randomized up to the max configured in the wave alias or this number, whichever is smaller. }
int Property iStartupStageID = 0 AutoReadOnly
int Property iWave1StageID = 10 AutoReadOnly
int Property iWave2StageID = 20 AutoReadOnly
int Property iWave3StageID = 30 AutoReadOnly
int Property iCleanupStageID = 40 AutoReadOnly

;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

Function TriggerEnemies(RefCollectionAlias akEnemyGroup)
	int I = 0
	int iActivated = 0
	int iEnemyCount = akEnemyGroup.GetCount()
	int iMaxEnemiesThisAttack = iEnemyCount
	int iStaggerGroup = Math.Floor(iEnemyCount as float * fStaggerWavePercent)
	If (iMaxEnemies > 0)
		iMaxEnemiesThisAttack = Utility.RandomInt(iMinEnemies, iMaxEnemies)
	EndIf
	While (I < iEnemyCount)
		Actor thisEnemy = akEnemyGroup.GetAt(I) as Actor
		If (iActivated >= iMaxEnemiesThisAttack)
			thisEnemy.KillSilent(None)
		Else
			Self.RelocateEnemy(thisEnemy)
			thisEnemy.Enable(False)
			thisEnemy.EvaluatePackage(False)
			iActivated += 1
			If (fStaggerWavePercent > 0 as float && fStaggerDelay > 0 as float && iActivated as float / iStaggerGroup as float == Math.Floor(iActivated as float / iStaggerGroup as float) as float)
				Utility.Wait(fStaggerDelay)
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction

Event OnStageSet(int aiStageID, int aiItemID)
	If (aiStageID == Self.iStartupStageID)
		Self.StartTimer(fInitialDelay, 0)
	ElseIf (aiStageID == Self.iWave1StageID)
		Self.TriggerEnemies(Wave01)
		Self.StartTimer(fWaveTime, 0)
	ElseIf (aiStageID == Self.iWave2StageID)
		If (Wave02)
			Self.TriggerEnemies(Wave02)
			Self.StartTimer(fWaveTime, 0)
		Else
			Self.SetStage(Self.iCleanupStageID)
		EndIf
	ElseIf (aiStageID == Self.iWave3StageID)
		If (Wave03)
			Self.TriggerEnemies(Wave03)
			Self.StartTimer(fWaveTime, 0)
		Else
			Self.SetStage(Self.iCleanupStageID)
		EndIf
	ElseIf (aiStageID == Self.iCleanupStageID)
		Self.Stop()
	EndIf
EndEvent

Function RelocateEnemy(Actor akMoveMe)
	If (SpawnPoints.GetCount() > 0)
		akMoveMe.MoveTo(SpawnPoints.GetAt(Utility.RandomInt(0, SpawnPoints.GetCount() - 1)), 0, 0, 0, True)
	Else
		float fX = fMinEnemyDistance
		If (Utility.RandomInt(0, 1) == 0)
			fX *= (-1) as float
		EndIf
		float fY = fMinEnemyDistance
		If (Utility.RandomInt(0, 1) == 0)
			fY *= (-1) as float
		EndIf
		akMoveMe.SetPosition(fX, fY, akMoveMe.Z + 1000 as float)
	EndIf
	akMoveMe.MoveToNearestNavmeshLocation()
EndFunction

Event OnTimer(int aiTimerID)
	int iCurrentStage = Self.GetCurrentStageID()
	If (iCurrentStage < Self.iWave1StageID)
		Self.SetStage(Self.iWave1StageID)
	ElseIf (iCurrentStage < Self.iWave2StageID)
		Self.SetStage(Self.iWave2StageID)
	ElseIf (iCurrentStage < Self.iWave3StageID)
		Self.SetStage(Self.iWave3StageID)
	ElseIf (iCurrentStage < Self.iCleanupStageID)
		Self.SetStage(Self.iCleanupStageID)
	EndIf
EndEvent
