;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\BreweryManager.psc
Modified : 2020-11-20 13:20:06
Compiled : 2021-01-07 11:42:43
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:BreweryManager extends WorkshopFramework:Library:SlaveQuest

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const mandatory
	simsettlementsv2:quests:plotmanager Property PlotManager Auto Const mandatory
EndGroup

Group Assets
	FormList Property UndiscoveredRecipeList Auto Const mandatory
	{ Empty formlist for storing undiscovered recipes that are registered with the system }
	FormList Property KnownRecipeList Auto Const mandatory
	{ Empty formlist for storing the recipes the player knows }
	FormList Property BreweryBuildingPlans Auto Const mandatory
	{ Formlist with brewery building plans }
	Form Property BeerDepositContainerForm Auto Const mandatory
	{ The base form of the container that should be located on the plot so that finished beer can be deposited to after it ferments }
	Form[] Property DefaultBreweryBuildingPlans Auto Const mandatory
	LeveledItem Property LLBreweryProduction Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property StageItemLinkKeyword Auto Const mandatory
	Keyword Property WorkshopItemKeyword Auto Const mandatory
EndGroup

Group Configuration
	int Property iBeersToCreate = 6 Auto Const mandatory
	float Property fWortTime = 24 Auto Const mandatory
	{ Time in game hours before the ingredients are ready for fermentation }
	float Property fFermentationTime = 72 Auto Const mandatory
	{ Time in game hours before beer is ready }
EndGroup

Group Jumper
	Static Property XMarker Auto Const
	ActorBase Property DropMe Auto Const
	Sound Property Scream Auto Const
	ReferenceAlias Property BrewmastersApprencticeAlias Auto Const
	Topic Property IdleTopic Auto Const
EndGroup

simsettlementsv2:books:beerrecipe[] Property Boiler Auto hidden
simsettlementsv2:books:beerrecipe[] Property FermentingTank1 Auto hidden
simsettlementsv2:books:beerrecipe[] Property FermentingTank2 Auto hidden
simsettlementsv2:books:beerrecipe[] Property FermentingTank3 Auto hidden
float[] Property fWortBoilStarted Auto hidden
simsettlementsv2:objectreferences:simplot[] Property Breweries Auto hidden

;-- Variables ---------------------------------------
int iMaxBreweries = 50 Const

;-- Functions ---------------------------------------

Event OnTimerGameTime(int aiTimerID)
	Self.CleanupBreweriesArray(aiTimerID)
	If (aiTimerID < iMaxBreweries)
		simsettlementsv2:objectreferences:simplot asPlot = Breweries[aiTimerID]
		If (!FermentingTank1[aiTimerID])
			FermentingTank1[aiTimerID] = Boiler[aiTimerID]
			Boiler[aiTimerID] = None
			Self.StartTimerGameTime(fFermentationTime, aiTimerID + iMaxBreweries)
		ElseIf (!FermentingTank2[aiTimerID])
			FermentingTank2[aiTimerID] = Boiler[aiTimerID]
			Boiler[aiTimerID] = None
			Self.StartTimerGameTime(fFermentationTime, aiTimerID + iMaxBreweries * 2)
		ElseIf (!FermentingTank3[aiTimerID])
			FermentingTank3[aiTimerID] = Boiler[aiTimerID]
			Boiler[aiTimerID] = None
			Self.StartTimerGameTime(fFermentationTime, aiTimerID + iMaxBreweries * 3)
		Else
			Self.StartTimerGameTime(fWortTime, aiTimerID)
		EndIf
	Else
		int plotIndex = 0
		Potion BeerBrewed = None
		simsettlementsv2:books:beerrecipe RecipeDiscovered = None
		If (aiTimerID - iMaxBreweries * 3 >= 0)
			plotIndex = aiTimerID - iMaxBreweries * 3
			BeerBrewed = FermentingTank3[plotIndex].CreatedBeer
			RecipeDiscovered = FermentingTank3[plotIndex]
			FermentingTank3[plotIndex] = None
		ElseIf (aiTimerID - iMaxBreweries * 2 >= 0)
			plotIndex = aiTimerID - iMaxBreweries * 2
			BeerBrewed = FermentingTank2[plotIndex].CreatedBeer
			RecipeDiscovered = FermentingTank2[plotIndex]
			FermentingTank2[plotIndex] = None
		Else
			plotIndex = aiTimerID - iMaxBreweries
			BeerBrewed = FermentingTank1[plotIndex].CreatedBeer
			RecipeDiscovered = FermentingTank1[plotIndex]
			FermentingTank1[plotIndex] = None
		EndIf
		KnownRecipeList.AddForm(RecipeDiscovered as Form)
		UndiscoveredRecipeList.RemoveAddedForm(RecipeDiscovered as Form)
		If (RecipeDiscovered.LeveledItemController != None && RecipeDiscovered.LeveledItemController.GetValueInt() != 0)
			RecipeDiscovered.LeveledItemController.SetValueInt(0)
			If (RecipeDiscovered.LeveledItemInjector != None)
				LLBreweryProduction.AddForm(RecipeDiscovered.LeveledItemInjector as Form, 1, 1)
			EndIf
		EndIf
		ObjectReference[] LinkedStuff = Breweries[plotIndex].kLinkedRefHolder.GetLinkedRefChildren(StageItemLinkKeyword)
		ObjectReference DepositHere = None
		If (LinkedStuff.length)
			int I = 0
			While (I < LinkedStuff.length && !DepositHere)
				If (LinkedStuff[I].GetBaseObject() == BeerDepositContainerForm)
					DepositHere = LinkedStuff[I]
				EndIf
				I += 1
			EndWhile
		EndIf
		If (!DepositHere)
			workshopscript workshopRef = Breweries[plotIndex].GetLinkedRef(WorkshopItemKeyword) as workshopscript
			If (workshopRef)
				DepositHere = workshopRef.GetContainer()
			Else
				DepositHere = PlayerRef as ObjectReference
			EndIf
		EndIf
		DepositHere.AddItem(BeerBrewed as Form, iBeersToCreate, True)
	EndIf
EndEvent

int Function GetBreweryIndex(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (!akPlotRef)
		return -1
	EndIf
	int iBreweryIndex = Breweries.find(akPlotRef, 0)
	If (iBreweryIndex > -1)
		If (Breweries[iBreweryIndex].IsDisabled() || !Self.IsBrewery(akPlotRef as ObjectReference))
			Breweries[iBreweryIndex] = None
			Boiler[iBreweryIndex] = None
			FermentingTank1[iBreweryIndex] = None
			FermentingTank2[iBreweryIndex] = None
			FermentingTank3[iBreweryIndex] = None
		EndIf
	EndIf
	return iBreweryIndex
EndFunction

Function FallingMan(ObjectReference aboveMe, float fHeight)
	ObjectReference xmark = aboveMe.PlaceAtMe(XMarker as Form, 1, False, False, True)
	xmark.SetPosition(aboveMe.GetPositionX(), aboveMe.GetPositionY(), aboveMe.GetPositionZ() + fHeight)
	Actor spawn = xmark.PlaceActorAtMe(DropMe, 4, None)
	BrewmastersApprencticeAlias.ForceRefTo(spawn as ObjectReference)
	spawn.MoveTo(xmark, 0, 0, 0, True)
	Utility.Wait(1)
	spawn.MoveTo(xmark, 0, 0, 0, True)
	spawn.Say(IdleTopic, None, False, None)
	Utility.Wait(4.5)
	spawn.Kill(None)
	xmark.Delete()
EndFunction

Function RegisterBreweryBuildingPlan(Form aBuildingOrLevelPlan)
	If (aBuildingOrLevelPlan == None)
		return 
	EndIf
	If ((aBuildingOrLevelPlan as simsettlementsv2:weapons:buildingplan) as bool || (aBuildingOrLevelPlan as simsettlementsv2:weapons:buildinglevelplan) as bool)
		BreweryBuildingPlans.AddForm(aBuildingOrLevelPlan)
	EndIf
EndFunction

bool Function StartBrew(simsettlementsv2:objectreferences:simplot akPlotRef, ObjectReference akContainerRef)
	If (akPlotRef == None || akContainerRef == None)
		return False
	EndIf
	int plotIndex = Self.GetBreweryIndex(akPlotRef)
	If (plotIndex > iMaxBreweries || plotIndex < 0 || !akContainerRef)
		return False
	EndIf
	If (Boiler[plotIndex])
		return False
	EndIf
	int I = UndiscoveredRecipeList.GetSize() - 1
	simsettlementsv2:books:beerrecipe BrewMe = None
	While (I >= 0 && BrewMe == None)
		simsettlementsv2:books:beerrecipe potentialRecipe = UndiscoveredRecipeList.GetAt(I) as simsettlementsv2:books:beerrecipe
		If (Self.CanBrewRecipe(potentialRecipe, akContainerRef))
			BrewMe = potentialRecipe
		EndIf
		I -= 1
	EndWhile
	If (BrewMe == None)
		I = KnownRecipeList.GetSize() - 1
		While (I >= 0 && BrewMe == None)
			simsettlementsv2:books:beerrecipe potentialrecipe = KnownRecipeList.GetAt(I) as simsettlementsv2:books:beerrecipe
			If (Self.CanBrewRecipe(potentialrecipe, akContainerRef))
				BrewMe = potentialrecipe
			EndIf
			I -= 1
		EndWhile
	EndIf
	If (BrewMe != None)
		Boiler[plotIndex] = BrewMe
		akContainerRef.RemoveAllItems(None, False)
		fWortBoilStarted[plotIndex] = Utility.GetCurrentGameTime()
		Self.StartTimerGameTime(fWortTime, plotIndex)
	EndIf
	return BrewMe != None
EndFunction

bool Function CanBrewRecipe(simsettlementsv2:books:beerrecipe aRecipe, ObjectReference akContainerRef)
	If (akContainerRef.GetItemCount(aRecipe.Mash) > 0)
		bool bNoFlavoringsMissing = True
		int j = 0
		While (j < aRecipe.Flavorings.length)
			If (akContainerRef.GetItemCount(aRecipe.Flavorings[j]) <= 0)
				return False
			EndIf
			j += 1
		EndWhile
		return True
	EndIf
	return False
EndFunction

Function RegisterBeerRecipe(Form aRecipe)
	simsettlementsv2:books:beerrecipe thisRecipe = aRecipe as simsettlementsv2:books:beerrecipe
	If (thisRecipe as bool && !KnownRecipeList.HasForm(thisRecipe as Form))
		UndiscoveredRecipeList.AddForm(thisRecipe as Form)
	EndIf
EndFunction

Function HandleGameLoaded()
	int I = 0
	While (I < DefaultBreweryBuildingPlans.length)
		Self.RegisterBreweryBuildingPlan(DefaultBreweryBuildingPlans[I])
		I += 1
	EndWhile
	Parent.HandleGameLoaded()
EndFunction

bool Function IsWortCooking(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (!akPlotRef)
		return False
	EndIf
	int iBreweryIndex = Self.GetBreweryIndex(akPlotRef)
	If (iBreweryIndex >= 0 && Boiler[iBreweryIndex] as bool)
		return True
	Else
		return False
	EndIf
EndFunction

Function CleanupBreweriesArray(int aiTimerID)
	int iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[BreweryManager]: Unable to get lock!", 2, False)
		return 
	EndIf
	int plotIndex = -1
	If (aiTimerID < iMaxBreweries)
		plotIndex = aiTimerID
	ElseIf (aiTimerID - iMaxBreweries * 3 >= 0)
		plotIndex = aiTimerID - iMaxBreweries * 3
	ElseIf (aiTimerID - iMaxBreweries * 2 >= 0)
		plotIndex = aiTimerID - iMaxBreweries * 3
	ElseIf (aiTimerID - iMaxBreweries >= 0)
		plotIndex = aiTimerID - iMaxBreweries
	EndIf
	If (plotIndex > -1)
		If (Breweries[plotIndex].GetState() == "Destroyed" || !Self.IsBrewery(Breweries[plotIndex] as ObjectReference))
			Breweries[plotIndex] = None
			Boiler[plotIndex] = None
			FermentingTank1[plotIndex] = None
			FermentingTank2[plotIndex] = None
			FermentingTank3[plotIndex] = None
		EndIf
	EndIf
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[BreweryManager]: Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
EndFunction

Event SimSettlementsV2:Quests:PlotManager.PlotLevelChanged(simsettlementsv2:quests:plotmanager akSender, var[] akArgs)
	simsettlementsv2:objectreferences:simplot kPlotRef = akArgs[0] as simsettlementsv2:objectreferences:simplot
	If (kPlotRef as bool && akArgs[1] as int > 0)
		If (Self.IsBrewery(kPlotRef as ObjectReference))
			Self.RegisterBrewery(kPlotRef)
		EndIf
	EndIf
EndEvent

Function RegisterBeerRecipes(FormList aRecipeList)
	int I = 0
	While (I < aRecipeList.GetSize())
		Self.RegisterBeerRecipe(aRecipeList.GetAt(I))
		I += 1
	EndWhile
EndFunction

Function RegisterBrewery(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (akPlotRef == None)
		return 
	EndIf
	int iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[BreweryManager]: Unable to get lock!", 2, False)
		return 
	EndIf
	If (Breweries.find(akPlotRef, 0) < 0)
		int I = 0
		bool bSlotFound = False
		While (I < Breweries.length && !bSlotFound)
			If (Breweries[I] == None || Breweries[I].IsDeleted())
				Breweries[I] = akPlotRef
				bSlotFound = True
			EndIf
			I += 1
		EndWhile
	EndIf
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[BreweryManager]: Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
EndFunction

bool Function IsBrewery(ObjectReference akPlotRef)
	simsettlementsv2:objectreferences:simplot asPlot = akPlotRef as simsettlementsv2:objectreferences:simplot
	If (!asPlot)
		return False
	EndIf
	If (BreweryBuildingPlans.HasForm(asPlot.GetParentBuildingPlan() as Form) || BreweryBuildingPlans.HasForm(asPlot.GetCurrentLevelPlan() as Form))
		return True
	EndIf
	return False
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
	Boiler = new simsettlementsv2:books:beerrecipe[iMaxBreweries]
	FermentingTank1 = new simsettlementsv2:books:beerrecipe[iMaxBreweries]
	FermentingTank2 = new simsettlementsv2:books:beerrecipe[iMaxBreweries]
	FermentingTank3 = new simsettlementsv2:books:beerrecipe[iMaxBreweries]
	Breweries = new simsettlementsv2:objectreferences:simplot[iMaxBreweries]
	fWortBoilStarted = new float[iMaxBreweries]
	Self.RegisterForCustomEvent(PlotManager as ScriptObject, "simsettlementsv2:quests:plotmanager_PlotLevelChanged")
EndFunction
