;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\CameraManager.psc
Modified : 2021-02-11 13:21:11
Compiled : 2021-02-11 13:21:29
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:CameraManager extends WorkshopFramework:Library:SlaveQuest conditional
{ Handles the player's camera }

;-- Properties --------------------------------------
Group Quests
	workshopparentscript Property WorkshopParent Auto Const mandatory
	simsettlementsv2:quests:hudmanager Property HUDManager Auto Const mandatory
EndGroup

Group ActorValues
	ActorValue Property OriginalPositionXAV Auto Const mandatory
	{ WSFW_PositionX }
	ActorValue Property OriginalPositionYAV Auto Const mandatory
	{ WSFW_PositionY }
	ActorValue Property OriginalPositionZAV Auto Const mandatory
	{ WSFW_PositionZ }
EndGroup

Group Aliases
	RefCollectionAlias Property SpeedBoostNPCs Auto Const mandatory
EndGroup

Group Assets
	Form Property XMarkerHeading Auto Const mandatory
	Form Property CinematicTravelMarkerForm Auto Const mandatory
	Form Property WorkshopFastTravelTarget Auto Const mandatory
	SoundCategory Property AudioCategorySoundscape Auto Const
	{ Our dynamic soundscape category }
	SoundCategory Property AudioCategoryVOCGeneral Auto Const
	{ Use auto-fill }
	SoundCategory Property AudioCategoryMUS Auto Const
	{ Use auto-fill }
	Form Property DefaultSequenceSettings Auto Const mandatory
	Weather Property ClearWeather Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property Settings_CameraModeFreeLook Auto Const mandatory
	GlobalVariable Property Settings_PlayCameraModeMusic Auto Const mandatory
	GlobalVariable Property Settings_AllowWeatherChangeDuringCameraSequences Auto Const mandatory
	GlobalVariable Property Settings_UseWideShots Auto Const mandatory
	GlobalVariable Property Settings_CameraFaceTargetUpdateFrequency Auto Const mandatory
EndGroup

int Property iMode_CinematicCircle = 1 AutoReadOnly
int Property iMode_Tour = 2 AutoReadOnly
int Property iReturnPlayer_OriginalPosition = 1 AutoReadOnly
int Property iReturnPlayer_CenterPointRef = 2 AutoReadOnly
int Property iReturnPlayer_WorkshopFastTravelPoint = 3 AutoReadOnly
bool Property bIsCameraControlled = False Auto conditional hidden

;-- Variables ---------------------------------------
int iSongIndex = 0
bool bFaceTargetLoop = False
int iTimerID_SongEnd = 104 Const
float fCameraSpeed = 0
int iCircleIndex = 0
int iSongPlayCount = 0
bool bLastTransitionInverted = False
int iTimerID_WeatherChange = 103 Const
bool bForceLook = False
bool bPlayerRequested = False
float fFaceTargetFrequency = 1
int iNextTargetIndex = -1
float fCenterY = 0
float fTangentMagnitude = 0
bool bWasPlayerRadioOn = False
inputenablelayer CameraModeControlsLayer
Form CurrentSequenceSettings
float fCenterZ = 0
bool bWasPlayerIn1stPerson = False
float fWideDiameter = 0
float fMaxRotationSpeed = 0
int iTimerID_AutoStop = 102 Const
int iWeatherIndex = 0
ObjectReference[] kCameraTravelMarkers
int iCameraModeMusicSoundInstance = 0
float fCenterX = 0
ObjectReference kAlwaysLookAtTarget
workshopscript kWorkshopRef
ObjectReference kNextCameraLookTarget
float fLongDiameter = 0
workshopframework:library:datastructures#translatetarget[] CameraTravelStructs
int iTimerID_FaceTarget = 101 Const
bool bPCUser = True
int iLoopCount = 0
ObjectReference kReturnPlayerToRef

;-- Functions ---------------------------------------

Function WaitForWSPlusRaceChange()
	If (Game.IsPluginInstalled("WorkshopPlus.esp"))
		Race FlyingRace = Game.GetFormFromFile(13756, "WorkshopPlus.esp") as Race
		int iWaitCount = 0
		While (PlayerRef.GetRace() == FlyingRace && iWaitCount < 10)
			Utility.Wait(1)
			iWaitCount += 1
		EndWhile
	EndIf
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
	bPCUser = True
	If (Debug.GetPlatformName() != "Target File Unknown")
		bPCUser = False
	EndIf
EndFunction

Function StopCameraMode()
	If (!bIsCameraControlled)
		return 
	EndIf
	bIsCameraControlled = False
	Sound.StopInstance(iCameraModeMusicSoundInstance)
	AudioCategorySoundscape.UnMute()
	AudioCategoryVOCGeneral.UnMute()
	AudioCategoryMUS.UnMute()
	Self.UnregisterForRemoteEvent(PlayerRef as ScriptObject, "OnTranslationAlmostComplete")
	PlayerRef.ForceRemoveRagdollFromWorld()
	PlayerRef.StopTranslation()
	ObjectReference kReturnRef = kReturnPlayerToRef
	If (Self.GetCurrentSequenceSettings().iReturnPlayerToPosition == Self.iReturnPlayer_WorkshopFastTravelPoint)
		If (!kWorkshopRef)
			kWorkshopRef = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
		EndIf
		If (kWorkshopRef)
			ObjectReference FTTarget = Game.FindClosestReferenceOfTypeFromRef(WorkshopFastTravelTarget, kWorkshopRef as ObjectReference, 20000)
			If (FTTarget)
				kReturnRef = FTTarget
			Else
				kReturnRef = kReturnPlayerToRef
			EndIf
		EndIf
	ElseIf (Self.GetCurrentSequenceSettings().iReturnPlayerToPosition == Self.iReturnPlayer_CenterPointRef && kAlwaysLookAtTarget != None)
		kReturnRef = kAlwaysLookAtTarget
	EndIf
	If (kReturnRef != None)
		PlayerRef.MoveTo(kReturnRef, 0, 0, 5, True)
	Else
		PlayerRef.MoveToNearestNavmeshLocation()
	EndIf
	kAlwaysLookAtTarget = None
	kNextCameraLookTarget = None
	CameraTravelStructs = new workshopframework:library:datastructures#translatetarget[0]
	kCameraTravelMarkers = new ObjectReference[0]
	PlayerRef.SetGhost(False)
	CameraModeControlsLayer.Reset()
	CameraModeControlsLayer.Delete()
	If (bWasPlayerRadioOn && Self.GetCurrentSequenceSettings().bTurnOffPipboyRadio)
		Game.TurnPlayerRadioOn(True)
	EndIf
	If (WorkshopParent.DogmeatAlias.GetRef())
		WorkshopParent.WorkshopDogmeatWhileBuildingScene.Stop()
	EndIf
	If (WorkshopParent.CompanionAlias.GetRef())
		WorkshopParent.WorkshopCompanionWhileBuildingScene.Stop()
	EndIf
	SpeedBoostNPCs.RemoveAll()
	Weather.ReleaseOverride()
	kReturnPlayerToRef.Delete()
	kReturnPlayerToRef = None
	Utility.Wait(0.1)
	Self.StopFaceTargetLoop()
	Game.SetCharGenHUDMode(0)
	If (!bWasPlayerIn1stPerson)
		Game.ForceThirdPerson()
	EndIf
	If (HUDManager.HUDFrameworkManager.IsHUDFrameworkInstalled)
		HUDManager.GoToState("")
	EndIf
	Self.SendCameraStoppedEvent()
EndFunction

Function RecordCameraTargetData()
	CameraTravelStructs = new workshopframework:library:datastructures#translatetarget[0]
	int I = 0
	While (I < kCameraTravelMarkers.length)
		workshopframework:library:datastructures#translatetarget TTarget = new workshopframework:library:datastructures#translatetarget
		TTarget.kTarget = kCameraTravelMarkers[I]
		TTarget.fPosX = kCameraTravelMarkers[I].X
		TTarget.fPosY = kCameraTravelMarkers[I].Y
		TTarget.fPosZ = kCameraTravelMarkers[I].Z
		TTarget.fAngleX = kCameraTravelMarkers[I].GetAngleX()
		TTarget.fAngleY = kCameraTravelMarkers[I].GetAngleY()
		TTarget.fAngleZ = kCameraTravelMarkers[I].GetAngleZ()
		CameraTravelStructs.add(TTarget, 1)
		I += 1
	EndWhile
EndFunction

Function RotateCinematicMarkers(float afAngle)
	If (Self.GetCurrentSequenceSettings().iCameraMode != Self.iMode_CinematicCircle)
		return 
	EndIf
	float X = 0
	float Y = 0
	float Z = 0
	int I = 0
	While (I < CameraTravelStructs.length)
		float fAngle = (I * 90) as float + afAngle
		float fDiameter = fLongDiameter
		If (I == 0 || I == 2)
			fDiameter = fWideDiameter
		EndIf
		X = fCenterX + fDiameter * Math.cos(fAngle)
		Y = fCenterY + fDiameter * Math.sin(fAngle)
		Z = CameraTravelStructs[I].fPosZ
		CameraTravelStructs[I].kTarget.SetPosition(X, Y, Z)
		CameraTravelStructs[I].fPosX = X
		CameraTravelStructs[I].fPosY = Y
		CameraTravelStructs[I].fPosZ = Z
		I += 1
	EndWhile
EndFunction

Function FaceTargetLoop(ObjectReference akTargetRef, float afFrequency)
	fFaceTargetFrequency = afFrequency
	kNextCameraLookTarget = akTargetRef
	bFaceTargetLoop = True
	Self.StartTimer(afFrequency, iTimerID_FaceTarget)
EndFunction

Function TranslateCamera(ObjectReference akStartAt, ObjectReference akEndAt, ObjectReference akLootAt, float afSpeed)
	PlayerRef.ForceAddRagdollToWorld()
	Game.SetCharGenHUDMode(3)
	PlayerRef.TranslateToRef(akStartAt, 500, 0)
	Utility.Wait(5)
	Game.StartDialogueCameraOrCenterOnTarget(akLootAt)
	PlayerRef.TranslateToRef(akEndAt, afSpeed, 0)
EndFunction

Function StartCameraTour(ObjectReference[] akCameraMarkers, ObjectReference akCenterPoint, Form aCameraControlSequenceSettings, bool abTriggeredManually)
	kCameraTravelMarkers = akCameraMarkers
	Self.RecordCameraTargetData()
	If (aCameraControlSequenceSettings != None && (aCameraControlSequenceSettings as simsettlementsv2:miscobjects:cameracontrolsequence) as bool)
		CurrentSequenceSettings = aCameraControlSequenceSettings
	Else
		CurrentSequenceSettings = DefaultSequenceSettings
	EndIf
	bPlayerRequested = abTriggeredManually
	bForceLook = Self.GetCurrentSequenceSettings().bDefaultForceLook
	If (Settings_CameraModeFreeLook.GetValueInt() == 1)
		bForceLook = False
	EndIf
	kAlwaysLookAtTarget = akCenterPoint
	If (Self.GetCurrentSequenceSettings().bFaceCenterMarkerDuringSetup)
		kNextCameraLookTarget = akCenterPoint
	Else
		kNextCameraLookTarget = akCameraMarkers[0]
	EndIf
	Self.BeginCameraMode()
EndFunction

Function StopFaceTargetLoop()
	bFaceTargetLoop = False
	kNextCameraLookTarget = None
	Self.CancelTimer(iTimerID_FaceTarget)
EndFunction

Function ClearCameraTranslation()
	PlayerRef.ForceRemoveRagdollFromWorld()
	Game.SetCharGenHUDMode(0)
EndFunction

Function UpdateTourMarkers(ObjectReference[] akCameraMarkers, ObjectReference akCenterPoint)
	kCameraTravelMarkers = akCameraMarkers
	Self.RecordCameraTargetData()
	kAlwaysLookAtTarget = akCenterPoint
	If (akCenterPoint == None)
		Self.StopFaceTargetLoop()
	EndIf
EndFunction

Function SendCameraModeLoopingEvent(int aiLoopCount)
	var[] kArgs = new var[4]
	kArgs[0] = kWorkshopRef as var
	kArgs[1] = kNextCameraLookTarget as var
	kArgs[2] = Self.GetCurrentSequenceSettings().iCameraMode as var
	kArgs[3] = aiLoopCount as var
	Self.SendCustomEvent("simsettlementsv2:quests:cameramanager_CameraModeLooping", kArgs)
EndFunction

Function AdjustCinematicMarkers(float afNewDistance, float afNewHeight)
	If (Self.GetCurrentSequenceSettings().iCameraMode == Self.iMode_CinematicCircle)
		Self.PrepareCinematicMarkers(kAlwaysLookAtTarget, afNewDistance, afNewHeight)
	EndIf
EndFunction

Function PrepareCinematicMarkers(ObjectReference akCenterPoint, float afDistance, float afHeight)
	If (akCenterPoint == None)
		return 
	EndIf
	kCameraTravelMarkers = akCenterPoint.FindAllReferencesOfType(CinematicTravelMarkerForm, 20000)
	If (kCameraTravelMarkers.length < 4)
		kCameraTravelMarkers = new ObjectReference[4]
		int i = 0
		While (i < 4)
			ObjectReference thisMarker = akCenterPoint.PlaceAtMe(CinematicTravelMarkerForm, 1, False, False, True)
			kCameraTravelMarkers[i] = thisMarker
			i += 1
		EndWhile
	EndIf
	fCenterX = akCenterPoint.X
	fCenterY = akCenterPoint.Y
	fCenterZ = akCenterPoint.Z
	float fMarkerX = fCenterX
	float fMarkerY = fCenterY
	float fMarkerZ = fCenterZ + afHeight
	int I = 0
	While (I < 4)
		If (I == 0)
			fMarkerX = fCenterX + afDistance
			fMarkerY = fCenterY
		ElseIf (I == 1)
			fMarkerX = fCenterX
			fMarkerY = fCenterY + afDistance
		ElseIf (I == 2)
			fMarkerX = fCenterX - afDistance
			fMarkerY = fCenterY
		ElseIf (I == 3)
			fMarkerX = fCenterX
			fMarkerY = fCenterY - afDistance
		EndIf
		kCameraTravelMarkers[I].SetPosition(fMarkerX, fMarkerY, fMarkerZ)
		kCameraTravelMarkers[I].SetValue(OriginalPositionXAV, fMarkerX)
		kCameraTravelMarkers[I].SetValue(OriginalPositionYAV, fMarkerY)
		kCameraTravelMarkers[I].SetValue(OriginalPositionZAV, fMarkerZ)
		I += 1
	EndWhile
	fWideDiameter = kCameraTravelMarkers[0].GetDistance(kCameraTravelMarkers[2])
	fLongDiameter = kCameraTravelMarkers[1].GetDistance(kCameraTravelMarkers[3])
	Self.RecordCameraTargetData()
	kAlwaysLookAtTarget = akCenterPoint
EndFunction

Function SendCameraStoppedEvent()
	var[] kArgs = new var[3]
	kArgs[0] = kWorkshopRef as var
	kArgs[1] = kNextCameraLookTarget as var
	kArgs[2] = Self.GetCurrentSequenceSettings().iCameraMode as var
	Self.SendCustomEvent("simsettlementsv2:quests:cameramanager_CameraModeStopped", kArgs)
EndFunction

simsettlementsv2:miscobjects:cameracontrolsequence Function GetCurrentSequenceSettings()
	If (CurrentSequenceSettings != None)
		return CurrentSequenceSettings as simsettlementsv2:miscobjects:cameracontrolsequence
	Else
		return DefaultSequenceSettings as simsettlementsv2:miscobjects:cameracontrolsequence
	EndIf
EndFunction

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
	If (asMenuName == "PipboyMenu")
		If (!abOpening)
			If (bIsCameraControlled)
				Self.StopCameraMode()
			EndIf
		EndIf
	EndIf
EndEvent

Function StartCinematicCircle(ObjectReference akCenterPoint, Form aCameraControlSequenceSettings, bool abTriggeredManually)
	If (aCameraControlSequenceSettings != None && (aCameraControlSequenceSettings as simsettlementsv2:miscobjects:cameracontrolsequence) as bool)
		CurrentSequenceSettings = aCameraControlSequenceSettings
	Else
		CurrentSequenceSettings = DefaultSequenceSettings
	EndIf
	If (CurrentSequenceSettings == None)
		return 
	EndIf
	If (Self.GetCurrentSequenceSettings().CinematicCircles.length == 0)
		Debug.MessageBox("You must fill out the CinematicCircles data to use this function.")
		return 
	EndIf
	iCircleIndex = 0
	Self.PrepareCinematicMarkers(akCenterPoint, Self.GetCurrentSequenceSettings().CinematicCircles[iCircleIndex].fDistance, Self.GetCurrentSequenceSettings().CinematicCircles[iCircleIndex].fHeight)
	bPlayerRequested = abTriggeredManually
	bForceLook = Self.GetCurrentSequenceSettings().bDefaultForceLook
	kAlwaysLookAtTarget = akCenterPoint
	kNextCameraLookTarget = kCameraTravelMarkers[0]
	If (Settings_CameraModeFreeLook.GetValueInt() == 1)
		bForceLook = False
	EndIf
	Self.BeginCameraMode()
EndFunction

Function SendCameraStartedEvent()
	var[] kArgs = new var[2]
	kArgs[0] = kNextCameraLookTarget as var
	kArgs[1] = Self.GetCurrentSequenceSettings().iCameraMode as var
	Self.SendCustomEvent("simsettlementsv2:quests:cameramanager_CameraModeStarted", kArgs)
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_FaceTarget)
		If (bFaceTargetLoop && kNextCameraLookTarget as bool)
			Game.StartDialogueCameraOrCenterOnTarget(kNextCameraLookTarget)
			Self.StartTimer(fFaceTargetFrequency, iTimerID_FaceTarget)
		EndIf
	ElseIf (aiTimerID == iTimerID_WeatherChange)
		If (bIsCameraControlled && Settings_AllowWeatherChangeDuringCameraSequences.GetValueInt() == 1)
			iWeatherIndex += 1
			If (iWeatherIndex >= Self.GetCurrentSequenceSettings().WeatherChanges.length)
				iWeatherIndex = 0
			EndIf
			Self.GetCurrentSequenceSettings().WeatherChanges[iWeatherIndex].SetActive(True, True)
			Self.StartTimer(Self.GetCurrentSequenceSettings().fWeatherChangeTime, iTimerID_WeatherChange)
		EndIf
	ElseIf (aiTimerID == iTimerID_SongEnd)
		If (bIsCameraControlled)
			iSongPlayCount += 1
			If (Self.GetCurrentSequenceSettings().iMaxSongPlays > 0 && iSongPlayCount >= Self.GetCurrentSequenceSettings().iMaxSongPlays)
				Self.StopCameraMode()
			Else
				iSongIndex += 1
				If (Self.GetCurrentSequenceSettings().MusicTracks.length > 1 && !Self.GetCurrentSequenceSettings().bPlaySequentially)
					iSongIndex = Utility.RandomInt(0, Self.GetCurrentSequenceSettings().MusicTracks.length - 1)
				ElseIf (iSongIndex >= Self.GetCurrentSequenceSettings().MusicTracks.length)
					iSongIndex = 0
				EndIf
				Sound.StopInstance(iCameraModeMusicSoundInstance)
				If (Self.GetCurrentSequenceSettings().MusicTracks[iSongIndex].fTrackLength > 0 as float && Self.GetCurrentSequenceSettings().MusicTracks[iSongIndex].TrackSound != None)
					iCameraModeMusicSoundInstance = Self.GetCurrentSequenceSettings().MusicTracks[iSongIndex].TrackSound.Play(PlayerRef as ObjectReference)
					Self.StartTimer(Self.GetCurrentSequenceSettings().MusicTracks[iSongIndex].fTrackLength, iTimerID_SongEnd)
				EndIf
			EndIf
		EndIf
	ElseIf (aiTimerID == iTimerID_AutoStop)
		Self.StopCameraMode()
	EndIf
EndEvent

Function BeginCameraMode()
	If (bIsCameraControlled)
		If (kAlwaysLookAtTarget == None)
			Self.StopFaceTargetLoop()
		ElseIf (bForceLook && !bFaceTargetLoop)
			float fFrequency = 1
			If (Settings_CameraFaceTargetUpdateFrequency != None)
				fFrequency = Settings_CameraFaceTargetUpdateFrequency.GetValue()
			EndIf
			Self.FaceTargetLoop(kAlwaysLookAtTarget, fFrequency)
		EndIf
		return 
	EndIf
	kWorkshopRef = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
	kWorkshopRef.StartWorkshop(False)
	Self.WaitForWSPlusRaceChange()
	bWasPlayerRadioOn = Game.IsPlayerRadioOn()
	If (bWasPlayerRadioOn)
		If (Self.GetCurrentSequenceSettings().bTurnOffPipboyRadio)
			Game.TurnPlayerRadioOn(False)
		EndIf
	EndIf
	bIsCameraControlled = True
	bLastTransitionInverted = True
	iLoopCount = 0
	iSongPlayCount = 0
	If (Self.GetCurrentSequenceSettings().bMuteGameMusic)
		AudioCategoryMUS.Mute()
	EndIf
	If (Self.GetCurrentSequenceSettings().bMuteVoices)
		AudioCategoryVOCGeneral.Mute()
	EndIf
	If (Self.GetCurrentSequenceSettings().bMuteSoundscape)
		AudioCategorySoundscape.Mute()
	EndIf
	kReturnPlayerToRef = PlayerRef.PlaceAtMe(XMarkerHeading, 1, False, False, True)
	CameraModeControlsLayer = inputenablelayer.Create()
	CameraModeControlsLayer.DisablePlayerControls(True, True, True, True, True, True, True, True, True, True, True)
	CameraModeControlsLayer.EnableCamSwitch(False)
	bWasPlayerIn1stPerson = workshopframework:library:utilityfunctions.IsPlayerInFirstPerson()
	If (!bWasPlayerIn1stPerson)
		Game.ForceFirstPerson()
	EndIf
	Game.SetCharGenHUDMode(3)
	PlayerRef.SetGhost(True)
	If (bPCUser && bForceLook)
		CameraModeControlsLayer.EnableLooking(False)
	Else
		CameraModeControlsLayer.EnableLooking(True)
	EndIf
	Self.RegisterForMenuOpenCloseEvent("PipboyMenu")
	CameraModeControlsLayer.EnableMenu(True)
	PlayerRef.ForceAddRagdollToWorld()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnTranslationAlmostComplete")
	iNextTargetIndex = 0
	PlayerRef.TranslateTo(CameraTravelStructs[iNextTargetIndex].fPosX, CameraTravelStructs[iNextTargetIndex].fPosY, CameraTravelStructs[iNextTargetIndex].fPosZ, CameraTravelStructs[iNextTargetIndex].fAngleX, CameraTravelStructs[iNextTargetIndex].fAngleY, CameraTravelStructs[iNextTargetIndex].fAngleZ, Self.GetCurrentSequenceSettings().fSetupSpeed, 10)
	If (Self.GetCurrentSequenceSettings().MusicTracks.length as bool && Settings_PlayCameraModeMusic.GetValue() > 0 as float)
		iSongIndex = 0
		If (Self.GetCurrentSequenceSettings().MusicTracks.length > 1 && !Self.GetCurrentSequenceSettings().bPlaySequentially)
			iSongIndex = Utility.RandomInt(0, Self.GetCurrentSequenceSettings().MusicTracks.length - 1)
		EndIf
		Sound.StopInstance(iCameraModeMusicSoundInstance)
		If (Self.GetCurrentSequenceSettings().MusicTracks[iSongIndex].fTrackLength > 0 as float && Self.GetCurrentSequenceSettings().MusicTracks[iSongIndex].TrackSound != None)
			iCameraModeMusicSoundInstance = Self.GetCurrentSequenceSettings().MusicTracks[iSongIndex].TrackSound.Play(PlayerRef as ObjectReference)
			Self.StartTimer(Self.GetCurrentSequenceSettings().MusicTracks[iSongIndex].fTrackLength, iTimerID_SongEnd)
		EndIf
	EndIf
	If (Self.GetCurrentSequenceSettings().bSpeedUpNPCs)
		ObjectReference[] WorkshopActors = WorkshopParent.GetWorkshopActors(kWorkshopRef)
		SpeedBoostNPCs.AddArray(WorkshopActors)
	EndIf
	If (Self.GetCurrentSequenceSettings().WeatherChanges != None && Settings_AllowWeatherChangeDuringCameraSequences.GetValueInt() == 1)
		iWeatherIndex = 0
		Self.GetCurrentSequenceSettings().WeatherChanges[iWeatherIndex].SetActive(True, True)
		Self.StartTimer(Self.GetCurrentSequenceSettings().fFirstWeatherChangeTime, iTimerID_WeatherChange)
	EndIf
	If (WorkshopParent.DogmeatAlias.GetRef())
		WorkshopParent.WorkshopDogmeatWhileBuildingScene.Start()
	Else
		WorkshopParent.WorkshopDogmeatWhileBuildingScene.Stop()
	EndIf
	If (WorkshopParent.CompanionAlias.GetRef())
		WorkshopParent.WorkshopCompanionWhileBuildingScene.Start()
	Else
		WorkshopParent.WorkshopCompanionWhileBuildingScene.Stop()
	EndIf
	If (bPCUser && bForceLook && kAlwaysLookAtTarget != None)
		If (Self.GetCurrentSequenceSettings().bFaceCenterMarkerDuringSetup)
			float ffrequency = 1
			If (Settings_CameraFaceTargetUpdateFrequency != None)
				ffrequency = Settings_CameraFaceTargetUpdateFrequency.GetValue()
			EndIf
			Self.FaceTargetLoop(kAlwaysLookAtTarget, ffrequency)
		EndIf
	EndIf
	If (Self.GetCurrentSequenceSettings().fMaxSeconds > 0 as float)
		Self.StartTimer(Self.GetCurrentSequenceSettings().fMaxSeconds, iTimerID_AutoStop)
	EndIf
	HUDManager.GoToState("NoHUD")
	Self.SendCameraStartedEvent()
EndFunction

Event ObjectReference.OnTranslationAlmostComplete(ObjectReference akTranslatedRef)
	If (akTranslatedRef == PlayerRef as ObjectReference && bIsCameraControlled)
		iNextTargetIndex += 1
		If (iNextTargetIndex >= CameraTravelStructs.length)
			iLoopCount += 1
			iNextTargetIndex = 0
			Self.SendCameraModeLoopingEvent(iLoopCount)
			If (Self.GetCurrentSequenceSettings().iMaxLoops > 0 && iLoopCount >= Self.GetCurrentSequenceSettings().iMaxLoops)
				Self.StopCameraMode()
				return 
			EndIf
			If (bPCUser && bForceLook && kAlwaysLookAtTarget != None && !bFaceTargetLoop)
				Self.FaceTargetLoop(kAlwaysLookAtTarget, 1)
			EndIf
			If (Self.GetCurrentSequenceSettings().iCameraMode == Self.iMode_CinematicCircle)
				If (Self.GetCurrentSequenceSettings().CinematicCircles.length > 1)
					int iCheckCircleIndex = Self.GetCurrentSequenceSettings().CinematicCircles.findstruct("iChangeToAfterLoopCount", iLoopCount, 0)
					If (iCheckCircleIndex > 0 && Settings_UseWideShots.GetValueInt() == 1)
						iCircleIndex = iCheckCircleIndex
						Self.AdjustCinematicMarkers(Self.GetCurrentSequenceSettings().CinematicCircles[iCircleIndex].fDistance, Self.GetCurrentSequenceSettings().CinematicCircles[iCircleIndex].fHeight)
					EndIf
				EndIf
				If (Self.GetCurrentSequenceSettings().fRotateCameraMarkersAngleEachLoop > 0 as float)
					Self.RotateCinematicMarkers(Self.GetCurrentSequenceSettings().fRotateCameraMarkersAngleEachLoop)
				EndIf
			EndIf
		EndIf
		fCameraSpeed = Self.GetCurrentSequenceSettings().fCameraSpeed
		fTangentMagnitude = Self.GetCurrentSequenceSettings().fTangentMagnitude
		fMaxRotationSpeed = Self.GetCurrentSequenceSettings().fMaxRotationSpeed
		If (bIsCameraControlled)
			If (iNextTargetIndex >= CameraTravelStructs.length || CameraTravelStructs[iNextTargetIndex].kTarget == None)
				Self.StopCameraMode()
				return 
			EndIf
			float fDistance = PlayerRef.GetDistance(CameraTravelStructs[iNextTargetIndex].kTarget)
			If (fDistance < Self.GetCurrentSequenceSettings().fShortCameraTravelDistanceMax)
				fTangentMagnitude *= Self.GetCurrentSequenceSettings().fTangentMultiplier_ShortCameraTravelDistance
				fCameraSpeed *= Self.GetCurrentSequenceSettings().fSpeedMultiplier_ShortCameraTravelDistance
			ElseIf (fDistance > Self.GetCurrentSequenceSettings().fLongCameraTravelDistanceMin)
				fTangentMagnitude *= Self.GetCurrentSequenceSettings().fTangentMultiplier_LongCameraTravelDistance
				fCameraSpeed *= Self.GetCurrentSequenceSettings().fSpeedMultiplier_LongCameraTravelDistance
			EndIf
			If (Self.GetCurrentSequenceSettings().iCameraMode == Self.iMode_CinematicCircle)
				kNextCameraLookTarget = kAlwaysLookAtTarget
				If (Self.GetCurrentSequenceSettings().CinematicCircles[iCircleIndex].fOverrideSpeed > 0 as float)
					fCameraSpeed = Self.GetCurrentSequenceSettings().CinematicCircles[iCircleIndex].fOverrideSpeed
				EndIf
				If (Self.GetCurrentSequenceSettings().CinematicCircles[iCircleIndex].fOverrideTangentMagnitude > 0 as float)
					fTangentMagnitude = Self.GetCurrentSequenceSettings().CinematicCircles[iCircleIndex].fOverrideTangentMagnitude
				EndIf
			ElseIf (Self.GetCurrentSequenceSettings().iCameraMode == Self.iMode_Tour && !bFaceTargetLoop && bForceLook)
				Game.StartDialogueCameraOrCenterOnTarget(CameraTravelStructs[iNextTargetIndex].kTarget)
			EndIf
			If (Self.GetCurrentSequenceSettings().bDynamicallyToggleTangent)
				If (bLastTransitionInverted)
					bLastTransitionInverted = False
				Else
					fTangentMagnitude *= (-1) as float
					bLastTransitionInverted = True
				EndIf
			EndIf
			If (Self.GetCurrentSequenceSettings().bUseSplines)
				float fCentrifugalAcceleration = Math.pow(fCameraSpeed, 2 as float) / fLongDiameter / 2 as float
				PlayerRef.SplineTranslateTo(CameraTravelStructs[iNextTargetIndex].fPosX, CameraTravelStructs[iNextTargetIndex].fPosY, CameraTravelStructs[iNextTargetIndex].fPosZ, CameraTravelStructs[iNextTargetIndex].fAngleX, CameraTravelStructs[iNextTargetIndex].fAngleY, CameraTravelStructs[iNextTargetIndex].fAngleZ, fTangentMagnitude * fCentrifugalAcceleration, fCameraSpeed, fMaxRotationSpeed)
			Else
				PlayerRef.TranslateTo(CameraTravelStructs[iNextTargetIndex].fPosX, CameraTravelStructs[iNextTargetIndex].fPosY, CameraTravelStructs[iNextTargetIndex].fPosZ, CameraTravelStructs[iNextTargetIndex].fAngleX, CameraTravelStructs[iNextTargetIndex].fAngleY, CameraTravelStructs[iNextTargetIndex].fAngleZ, fCameraSpeed, fMaxRotationSpeed)
			EndIf
		EndIf
	EndIf
EndEvent
