;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\DialogueQuestOldPaul.psc
Modified : 2020-11-09 02:10:57
Compiled : 2021-01-07 11:42:47
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:DialogueQuestOldPaul extends Quest conditional

;-- Properties --------------------------------------
Group Controllers
	simsettlementsv2:quests:mqmaster Property MQMaster Auto Const mandatory
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property OldPaulAlias Auto Const mandatory
	ReferenceAlias Property ColaAlias Auto Const mandatory
	ReferenceAlias Property ColaAsPaulsPetAlias Auto Const mandatory
EndGroup

Group Assets
	Idle Property BarkPlayful Auto Const mandatory
	Idle Property RunInCircle Auto Const mandatory
	Idle Property AttackASAM Auto Const mandatory
	Idle[] Property ColaTricks Auto Const mandatory
	FormList Property MeatList Auto Const mandatory
	Potion Property DogFoodForm Auto Const mandatory
EndGroup

bool Property bColaHungry = True Auto conditional hidden

;-- Variables ---------------------------------------
float fTimerLength_ColaHungry = 24 Const
int iStage_FedMeat = 10 Const
int iLastInstalledVersion = 0
int iTimerID_QuestStartupComplete = 100 Const
int iStage_StartupComplete = 2 Const
int iStage_ColaTrick = 30 Const
int iStage_Started = 1 Const
int iTimerID_ColaHungry = 101 Const
int iStage_FedDogFood = 20 Const

;-- Functions ---------------------------------------

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Function MakeColaFollowPaul(bool abClearFollow)
	If (abClearFollow)
		ColaAsPaulsPetAlias.Clear()
		ColaAlias.TryToEvaluatePackage()
	Else
		ColaAsPaulsPetAlias.ForceRefTo(ColaAlias.GetRef())
		ColaAsPaulsPetAlias.TryToEvaluatePackage()
	EndIf
EndFunction

Function ColaFed()
	Utility.Wait(0.5)
	ColaAlias.GetActorRef().PlayIdle(BarkPlayful)
	bColaHungry = False
	Self.StartTimerGameTime(fTimerLength_ColaHungry, iTimerID_ColaHungry)
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	Self.HandleStageChanges(auiStageID, auiItemID)
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iTimerID_ColaHungry)
		bColaHungry = True
	EndIf
EndEvent

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		
	ElseIf (auiStageID == iStage_FedMeat)
		PlayerRef.RemoveItem(MeatList as Form, 1, False, None)
		Self.ColaFed()
	ElseIf (auiStageID == iStage_FedDogFood)
		PlayerRef.RemoveItem(DogFoodForm as Form, 1, False, None)
		Self.ColaFed()
	ElseIf (auiStageID == iStage_ColaTrick)
		Game.StartDialogueCameraOrCenterOnTarget(ColaAlias.GetRef())
		Utility.Wait(2)
		ColaAlias.GetActorRef().PlayIdle(BarkPlayful)
		Utility.Wait(4)
		ColaAlias.GetActorRef().PlayIdle(ColaTricks[Utility.RandomInt(0, ColaTricks.length - 1)])
	EndIf
EndFunction
