;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\DistilleryQuest.psc
Modified : 2020-08-21 01:06:54
Compiled : 2021-01-07 11:42:40
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:DistilleryQuest extends Quest

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const mandatory
	GlobalVariable Property CurrentVersion Auto Const mandatory
	customitemquestscript Property CustomItemQuest Auto Const mandatory
	Keyword Property AttackEventKeyword Auto Const mandatory
	Keyword Property IsSleepFurniture Auto Const mandatory
	Actor Property PlayerRef Auto Const mandatory
	WorldSpace Property CommonwealthWorldspace Auto Const mandatory
	Quest Property MagnumDialogueQuest Auto Const mandatory
	Faction Property MagnumNeutralFaction Auto Const mandatory
EndGroup

Group Assets
	Idle Property PassOutIdle Auto Const mandatory
	Idle Property WakeUpIdle Auto Const mandatory
	Idle Property ReturnToNormalIdle Auto Const mandatory
	float Property fPassOutIdleLength = 2.75 Auto Const
	float Property fWakeUpIdleLength = 13 Auto Const
	Sound Property PassOutSound Auto Const mandatory
	Sound Property WakeUpSound Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property MysticPinesSpawnPointAlias Auto Const mandatory
	ReferenceAlias Property TomSanfordAlias Auto Const mandatory
	ReferenceAlias Property TomSanfordStartPositionAlias Auto Const mandatory
	ReferenceAlias Property MysticPinesBodyCountEnabler Auto Const mandatory
	ReferenceAlias Property JalbertObjectEnabler Auto Const mandatory
	ReferenceAlias Property EdwinsObjectEnabler Auto Const mandatory
	ReferenceAlias Property MiltonsObjectEnabler Auto Const mandatory
	ReferenceAlias Property MiltonsTempObjectEnabler Auto Const mandatory
	ReferenceAlias Property MagnumAlias Auto Const mandatory
	RefCollectionAlias Property MagnumsGang Auto Const mandatory
EndGroup

Group Messages
	Message Property FirstDrinkMessage Auto Const mandatory
	Message Property SecondDrinkMessage Auto Const mandatory
	Message Property ThirdDrinkMessage Auto Const mandatory
EndGroup

float Property InstalledVersion = 0 Auto hidden
int Property iStartupStage = 0 AutoReadOnly
int Property iInitialStage = 1 AutoReadOnly
int Property iWokeupStage = 2 AutoReadOnly
int Property iReadNote01Stage = 5 AutoReadOnly
int Property iReadNote02Stage = 10 AutoReadOnly
int Property iReadNote03Stage = 15 AutoReadOnly
int Property iAttackedMagnumStage = 25 AutoReadOnly
int Property iMagnumDeadStage = 100 AutoReadOnly
int Property iMagnumDialogueAttackStage = 10 AutoReadOnly
int Property iCustomItemStage_Lily = 10 AutoReadOnly
int Property iMainObjective = 1 AutoReadOnly
int Property iJalbertObjective = 10 AutoReadOnly
int Property iEdwinsObjective = 20 AutoReadOnly
int Property iMedfordObjective = 30 AutoReadOnly

;-- Variables ---------------------------------------
bool bTimerRunning = False
int iLastStageSet = -1
bool bRecentStageChange = True
float fMinTimeBetweenAttacks = 24
int iDrinkBoozeDailyResetTimerID = 1
int iBountyAttackTimerID = 0
int iDrinksToday = 0

;-- Functions ---------------------------------------

Event Quest.OnStageSet(Quest akSenderRef, int auiStageID, int auiItemID)
	If (auiStageID == Self.iMagnumDialogueAttackStage)
		PlayerRef.RemoveFromFaction(MagnumNeutralFaction)
		MagnumsGang.StartCombatAll(PlayerRef)
		MagnumAlias.GetActorRef().StartCombat(PlayerRef, True)
	EndIf
EndEvent

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iBountyAttackTimerID)
		bTimerRunning = False
	ElseIf (aiTimerID == iDrinkBoozeDailyResetTimerID)
		iDrinksToday = 0
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	bool bSimple = True
	If (auiStageID >= Self.iStartupStage)
		iLastStageSet = auiStageID
	EndIf
	If (auiStageID == -1)
		If (auiItemID == -3)
			Self.ConfigureObjectives(True)
		ElseIf (auiItemID == -1)
			Self.Maintenance()
		EndIf
	Else
		bRecentStageChange = True
		Self.UpdateAliases()
		Self.ConfigureObjectives(False)
		If (auiStageID == Self.iInitialStage)
			MysticPinesBodyCountEnabler.GetRef().Enable(False)
			Actor TomSanford = TomSanfordAlias.GetActorRef()
			TomSanford.MoveTo(TomSanfordStartPositionAlias.GetRef(), 0, 0, 0, True)
			TomSanford.Enable(False)
			Self.PlayerPassOut(MysticPinesSpawnPointAlias.GetRef())
			Self.SetStage(Self.iWokeupStage)
		ElseIf (auiStageID == Self.iWokeupStage)
			Self.RegisterForPlayerTeleport()
			Self.RegisterForPlayerWait()
			Self.RegisterForPlayerSleep()
			Self.RegisterForRemoteEvent(MagnumDialogueQuest as ScriptObject, "OnStageSet")
			Self.RegisterForRemoteEvent(MagnumAlias.GetActorRef() as ScriptObject, "OnDeath")
			PlayerRef.AddToFaction(MagnumNeutralFaction)
			JalbertObjectEnabler.GetRef().Enable(False)
			EdwinsObjectEnabler.GetRef().Enable(False)
			MiltonsObjectEnabler.GetRef().Enable(False)
			MiltonsTempObjectEnabler.GetRef().Enable(False)
			CustomItemQuest.SetStage(Self.iCustomItemStage_Lily)
		ElseIf (auiStageID == Self.iAttackedMagnumStage)
			MagnumDialogueQuest.SetStage(Self.iMagnumDialogueAttackStage)
		ElseIf (auiStageID == Self.iMagnumDeadStage)
			Self.UnregisterForAllEvents()
			Self.CompleteAllObjectives()
			Self.CompleteQuest()
			Self.RegisterForRemoteEvent(MagnumAlias.GetRef() as ScriptObject, "OnUnload")
		EndIf
	EndIf
EndEvent

Event OnPlayerWaitStop(bool abInterrupted)
	Self.CheckForBountyAttack()
EndEvent

Event OnPlayerTeleport()
	Self.CheckForBountyAttack()
EndEvent

Event ObjectReference.OnUnload(ObjectReference akSenderRef)
	MagnumDialogueQuest.Stop()
	MysticPinesBodyCountEnabler.GetRef().Disable(False)
	MiltonsTempObjectEnabler.GetRef().Disable(False)
	Self.UnregisterForAllEvents()
EndEvent

Function InstallModChanges()
	InstalledVersion = CurrentVersion.GetValue()
EndFunction

Event OnPlayerSleepStop(bool abInterrupted, ObjectReference akBed)
	Self.CheckForBountyAttack()
EndEvent

Function Maintenance()
	If (InstalledVersion * 10000 as float < CurrentVersion.GetValue() * 10000 as float)
		If (InstalledVersion > 0 as float || Self.IsRunning() && !Self.IsCompleted())
			Self.InstallModChanges()
		Else
			InstalledVersion = CurrentVersion.GetValue()
		EndIf
	EndIf
EndFunction

Function ConfigureObjectives(bool bSimpleSwap)
	bool bSimple = True
	If (bSimpleSwap)
		Self.SetObjectiveDisplayed(Self.iJalbertObjective, False, False)
		Self.SetObjectiveDisplayed(Self.iEdwinsObjective, False, False)
		Self.SetObjectiveDisplayed(Self.iMedfordObjective, False, False)
	EndIf
	If (iLastStageSet == Self.iWokeupStage)
		Self.SetObjectiveDisplayed(Self.iMainObjective, True, False)
	ElseIf (iLastStageSet == Self.iReadNote01Stage)
		If (bSimple)
			Self.SetObjectiveDisplayed(Self.iJalbertObjective, True, False)
		EndIf
	ElseIf (iLastStageSet == Self.iReadNote02Stage)
		Self.SetObjectiveCompleted(Self.iJalbertObjective, True)
		If (bSimple)
			Self.SetObjectiveDisplayed(Self.iEdwinsObjective, True, False)
		EndIf
	ElseIf (iLastStageSet == Self.iReadNote03Stage)
		Self.SetObjectiveCompleted(Self.iEdwinsObjective, True)
		If (bSimple)
			Self.SetObjectiveDisplayed(Self.iMedfordObjective, True, False)
		EndIf
	EndIf
EndFunction

Function CheckForBountyAttack()
	Utility.Wait(1)
	If (!bTimerRunning)
		If (PlayerRef.GetWorldSpace() == CommonwealthWorldspace && !MagnumAlias.GetRef().Is3dLoaded())
			AttackEventKeyword.SendStoryEvent(PlayerRef.GetCurrentLocation(), PlayerRef as ObjectReference, None, 0, 0)
		EndIf
		bTimerRunning = True
		Self.StartTimerGameTime(fMinTimeBetweenAttacks, iBountyAttackTimerID)
	EndIf
EndFunction

bool Function PlayerPassOut(ObjectReference akDestination)
	inputenablelayer controlLayer = inputenablelayer.Create()
	controlLayer.DisablePlayerControls(True, True, True, True, True, True, True, True, True, True, True)
	Game.ForceThirdPerson()
	Utility.Wait(1)
	PlayerRef.PlayIdle(PassOutIdle)
	Utility.Wait(fPassOutIdleLength)
	Game.FadeOutGame(True, True, 0.1, 1, True)
	PassOutSound.Play(PlayerRef as ObjectReference)
	Utility.Wait(2)
	Game.FastTravel(akDestination)
	Utility.Wait(0.1)
	PlayerRef.SetAngle(0, 0, 90)
	Game.FadeOutGame(False, True, 2, 2, False)
	WakeUpSound.Play(PlayerRef as ObjectReference)
	PlayerRef.PlayIdle(WakeUpIdle)
	Utility.Wait(fWakeUpIdleLength)
	Game.ForceFirstPerson()
	PlayerRef.PlayIdle(ReturnToNormalIdle)
	controlLayer.Reset()
	controlLayer.Delete()
EndFunction

Function DrinkBoozeWater()
	Utility.Wait(3)
	If (iDrinksToday == 0)
		Self.StartTimerGameTime(24, iDrinkBoozeDailyResetTimerID)
	EndIf
	iDrinksToday += 1
	If (iDrinksToday == 1)
		FirstDrinkMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	ElseIf (iDrinksToday == 2)
		SecondDrinkMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	ElseIf (iDrinksToday == 3)
		ThirdDrinkMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	EndIf
	If (iDrinksToday > 3)
		iDrinksToday = 0
		Self.CancelTimerGameTime(iDrinkBoozeDailyResetTimerID)
		If (!Self.IsCompleted() && !Self.GetStageDone(Self.iInitialStage))
			Self.SetStage(Self.iInitialStage)
		Else
			ObjectReference[] EligibleBeds = new ObjectReference[0]
			int I = 0
			While (I < WorkshopParent.Workshops.length && EligibleBeds.length < 128)
				ObjectReference[] beds = WorkshopParent.GetBeds(WorkshopParent.Workshops[I])
				int j = 0
				While (j < beds.length && EligibleBeds.length < 128)
					EligibleBeds.add(beds[j], 1)
					j += 1
				EndWhile
				I += 0
			EndWhile
			If (EligibleBeds.length > 0)
				Self.PlayerPassOut(EligibleBeds[Utility.RandomInt(0, EligibleBeds.length - 1)])
			EndIf
		EndIf
	EndIf
EndFunction

Function UpdateAliases()
	If (iLastStageSet == Self.iInitialStage)
		
	EndIf
EndFunction

Event Actor.OnDeath(Actor akSenderRef, Actor akKiller)
	Self.SetStage(Self.iMagnumDeadStage)
EndEvent
