;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\EmpireManager.psc
Modified : 2020-09-03 22:13:16
Compiled : 2021-01-07 11:42:49
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:EmpireManager extends WorkshopFramework:Library:SlaveQuest
{ Handles empire of settlements }

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const mandatory
	workshopframework:mainthreadmanager Property ThreadManager Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property SafeSpawnPoint Auto Const mandatory
EndGroup

Group Assets
	Faction Property PlayerFaction Auto Const mandatory
	Form Property EmpireDataForm Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property WorkshopType02 Auto Const mandatory
	Keyword Property WorkshopType02Vassal Auto Const mandatory
	Keyword Property EmpireCaravanKeyword Auto Const mandatory
	{ Represents a general connection created by our Empire system. This will let us distinguish those created by other mods/systems }
EndGroup

int Property iEmpireSettlementType_City = 1 AutoReadOnly
int Property iEmpireSettlementType_Outpost = 2 AutoReadOnly
int Property iEmpireSettlementType_Vassal = 3 AutoReadOnly
int Property iEmpireSettlementType_CapitalCity = 4 AutoReadOnly
int Property iEmpireSettlementType_CommandPost = 5 AutoReadOnly
simsettlementsv2:datastructures#factionempiredatamap[] Property FactionEmpireDataMaps_Player Auto hidden
simsettlementsv2:datastructures#factionempiredatamap[] Property FactionEmpireDataMaps_NPC Auto hidden
simsettlementsv2:datastructures#locationempiredatamap[] Property LocationEmpireDataMaps_Player Auto hidden
simsettlementsv2:datastructures#locationempiredatamap[] Property LocationEmpireDataMaps_NPC Auto hidden
simsettlementsv2:datastructures#workshopempiredatamap[] Property WorkshopEmpireDataMaps_Player Auto hidden
simsettlementsv2:datastructures#workshopempiredatamap[] Property WorkshopEmpireDataMaps_NPC Auto hidden
simsettlementsv2:objectreferences:empiredata[] Property EmpireDataStores Auto hidden

;-- Variables ---------------------------------------
bool bDataStoresUpdatingBlock = False

;-- Functions ---------------------------------------

Function SendSettlementRemovedFromEmpireEvent(workshopscript akWorkshopRef, Faction aPreviousOwningFaction, bool abWasOwnedByPlayer, int aiEmpireSettlementType)
	var[] kArgs = new var[0]
	kArgs.add(akWorkshopRef as var, 1)
	kArgs.add(aPreviousOwningFaction as var, 1)
	kArgs.add(abWasOwnedByPlayer as var, 1)
	kArgs.add(aiEmpireSettlementType as var, 1)
	Self.SendCustomEvent("simsettlementsv2:quests:empiremanager_SettlementRemovedFromEmpire", kArgs)
EndFunction

Function SetupPlayerGenericEmpire()
	simsettlementsv2:objectreferences:empiredata empireData = Self.GetEmpireDataStoreFromFaction(PlayerFaction, True, True)
	empireData.bAllowCommandPost = False
	empireData.bAllowCapitalCity = False
	workshopscript[] Workshops = workshopframework:workshopfunctions.GetPlayerOwnedSettlements(False, False, False)
	int I = 0
	int iAdded = 0
	While (I < Workshops.length)
		If (Workshops[I].OwnedByPlayer)
			Self.AddWorkshopToEmpire(Workshops[I], Self.iEmpireSettlementType_City, empireData, None, False)
			iAdded += 1
		EndIf
		I += 1
	EndWhile
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopPlayerOwnershipChanged")
	Self.SetupPlayerGenericEmpire()
EndFunction

simsettlementsv2:objectreferences:empiredata Function ConfigureEmpireDataStore(Faction aFactionForm, bool abPlayerControlled)
	int iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "ConfigureEmpireDataStore: Unable to get lock!", 2, False)
		return None
	EndIf
	ObjectReference kPlaceAt = SafeSpawnPoint.GetRef()
	If (kPlaceAt)
		ObjectReference kDataStore = kPlaceAt.PlaceAtMe(EmpireDataForm, 1, True, False, False)
		If (kDataStore)
			simsettlementsv2:objectreferences:empiredata asDataStore = kDataStore as simsettlementsv2:objectreferences:empiredata
			If (asDataStore)
				asDataStore.FactionForm = aFactionForm
				asDataStore.bPlayerRun = abPlayerControlled
				If (EmpireDataStores == None || EmpireDataStores.length == 0)
					EmpireDataStores = new simsettlementsv2:objectreferences:empiredata[0]
				EndIf
				EmpireDataStores.add(asDataStore, 1)
				simsettlementsv2:datastructures#factionempiredatamap newEntry = new simsettlementsv2:datastructures#factionempiredatamap
				newEntry.FactionForm = aFactionForm
				newEntry.iDataStoreIndex = EmpireDataStores.length - 1
				If (FactionEmpireDataMaps_Player == None || FactionEmpireDataMaps_Player.length == 0)
					FactionEmpireDataMaps_Player = new simsettlementsv2:datastructures#factionempiredatamap[0]
				EndIf
				If (FactionEmpireDataMaps_NPC == None || FactionEmpireDataMaps_NPC.length == 0)
					FactionEmpireDataMaps_NPC = new simsettlementsv2:datastructures#factionempiredatamap[0]
				EndIf
				simsettlementsv2:datastructures#factionempiredatamap[] AddToMe = FactionEmpireDataMaps_Player
				If (!asDataStore.bPlayerRun)
					AddToMe = FactionEmpireDataMaps_NPC
				EndIf
				int iIndex = AddToMe.findstruct("FactionForm", aFactionForm, 0)
				If (iIndex < 0)
					AddToMe.add(newEntry, 1)
				EndIf
			EndIf
		EndIf
	EndIf
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "ConfigureEmpireDataStore: Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
	return EmpireDataStores[EmpireDataStores.length - 1]
EndFunction

Function RemoveWorkshopFromEmpire(workshopscript akWorkshopRef, int aiEmpireSettlementType, simsettlementsv2:objectreferences:empiredata akEmpireRef, Faction aFactionForm, bool abPlayerControlled)
	If (akWorkshopRef == None)
		return 
	EndIf
	If (akEmpireRef == None)
		akEmpireRef = Self.GetEmpireDataStoreFromFaction(aFactionForm, abPlayerControlled, False)
		If (akEmpireRef == None)
			return 
		EndIf
	EndIf
	akEmpireRef.RemoveSettlement_InternalOnly(akWorkshopRef, -1)
	Self.RemoveLocationFromEmpire(akWorkshopRef.myLocation, akEmpireRef, None, False)
EndFunction

Function RemoveLocationFromEmpire(Location akLocationRef, simsettlementsv2:objectreferences:empiredata akEmpireRef, Faction aFactionForm, bool abPlayerControlled)
	If (akLocationRef == None)
		return 
	EndIf
	If (akEmpireRef == None)
		akEmpireRef = Self.GetEmpireDataStoreFromFaction(aFactionForm, abPlayerControlled, False)
		If (akEmpireRef == None)
			return 
		EndIf
	EndIf
	akEmpireRef.RemoveLocation_InternalOnly(akLocationRef)
EndFunction

bool Function DoesPlayerControlSettlement(workshopscript akWorkshopRef)
	simsettlementsv2:objectreferences:empiredata thisDataStore = Self.GetEmpireDataStoreFromWorkshop(akWorkshopRef)
	If (!thisDataStore)
		return False
	EndIf
	return thisDataStore.bPlayerRun
EndFunction

Function UpdateAllSharedResources()
	int I = 0
	While (I < EmpireDataStores.length)
		var[] kArgs = new var[0]
		ThreadManager.QueueRemoteFunctionThread("", EmpireDataStores[I] as Form, "simsettlementsv2:objectreferences:empiredata", "UpdateSharedResources", kArgs)
		I += 1
	EndWhile
EndFunction

Function SendLocationOccupiedEvent(Location akLocationRef, Faction aEmpireFaction, bool abOwnedByPlayer)
	var[] kArgs = new var[0]
	kArgs.add(akLocationRef as var, 1)
	kArgs.add(aEmpireFaction as var, 1)
	kArgs.add(abOwnedByPlayer as var, 1)
	Self.SendCustomEvent("simsettlementsv2:quests:empiremanager_LocationOccupied", kArgs)
EndFunction

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
EndFunction

workshopscript[] Function GetEmpireNetworkContainingSettlement(Keyword aNetworkKeyword, workshopscript akWorkshopRef, bool abIncludeContainedSettlementInArray)
	simsettlementsv2:objectreferences:empiredata kEmpireDataStore = Self.GetEmpireDataStoreFromWorkshop(akWorkshopRef)
	If (!kEmpireDataStore)
		return None
	EndIf
	Location thisLocation = akWorkshopRef.myLocation
	If (!thisLocation)
		thisLocation = akWorkshopRef.GetCurrentLocation()
	EndIf
	Location[] workshopLocations = WorkshopParent.workshopLocations
	workshopscript[] Workshops = WorkshopParent.Workshops
	workshopscript[] thisNetwork = new workshopscript[0]
	Location[] linkedNetworkLocations = thisLocation.GetAllLinkedLocations(aNetworkKeyword)
	int I = 0
	While (I < linkedNetworkLocations.length)
		int iIndex = workshopLocations.find(linkedNetworkLocations[I], 0)
		If (iIndex >= 0)
			thisNetwork.add(Workshops[iIndex], 1)
		EndIf
		I += 1
	EndWhile
	If (abIncludeContainedSettlementInArray)
		thisNetwork.add(akWorkshopRef, 1)
	EndIf
	return thisNetwork
EndFunction

bool Function AddWorkshopToEmpire(workshopscript akWorkshopRef, int aiEmpireSettlementType, simsettlementsv2:objectreferences:empiredata akEmpireRef, Faction aFactionForm, bool abPlayerControlled)
	If (akWorkshopRef == None)
		return False
	EndIf
	If (akEmpireRef == None)
		akEmpireRef = Self.GetEmpireDataStoreFromFaction(aFactionForm, abPlayerControlled, False)
		If (akEmpireRef == None)
			return False
		EndIf
	EndIf
	simsettlementsv2:objectreferences:empiredata kPreviousEmpireDataStore = Self.GetEmpireDataStoreFromWorkshop(akWorkshopRef)
	If (kPreviousEmpireDataStore != None)
		kPreviousEmpireDataStore.RemoveSettlement_InternalOnly(akWorkshopRef, -1)
	EndIf
	bool bAdded = akEmpireRef.AddSettlement_InternalOnly(akWorkshopRef, aiEmpireSettlementType)
	If (bAdded)
		simsettlementsv2:datastructures#workshopempiredatamap newEntry = new simsettlementsv2:datastructures#workshopempiredatamap
		newEntry.kWorkshopRef = akWorkshopRef
		newEntry.iDataStoreIndex = EmpireDataStores.find(akEmpireRef, 0)
		If (WorkshopEmpireDataMaps_Player == None || WorkshopEmpireDataMaps_Player.length == 0)
			WorkshopEmpireDataMaps_Player = new simsettlementsv2:datastructures#workshopempiredatamap[0]
		EndIf
		If (WorkshopEmpireDataMaps_NPC == None || WorkshopEmpireDataMaps_NPC.length == 0)
			WorkshopEmpireDataMaps_NPC = new simsettlementsv2:datastructures#workshopempiredatamap[0]
		EndIf
		simsettlementsv2:datastructures#workshopempiredatamap[] AddToMe = WorkshopEmpireDataMaps_Player
		simsettlementsv2:datastructures#workshopempiredatamap[] RemoveFromMe = WorkshopEmpireDataMaps_NPC
		If (!akEmpireRef.bPlayerRun)
			AddToMe = WorkshopEmpireDataMaps_NPC
			RemoveFromMe = WorkshopEmpireDataMaps_Player
		EndIf
		int iIndex = AddToMe.findstruct("kWorkshopRef", akWorkshopRef, 0)
		If (iIndex < 0)
			AddToMe.add(newEntry, 1)
		EndIf
		iIndex = RemoveFromMe.findstruct("kWorkshopRef", akWorkshopRef, 0)
		If (iIndex >= 0)
			RemoveFromMe.remove(iIndex, 1)
		EndIf
		Self.AddLocationToEmpire(akWorkshopRef.myLocation, akEmpireRef, None, False)
	EndIf
	return bAdded
EndFunction

Function SendSettlementAddedToEmpireEvent(workshopscript akWorkshopRef, Faction aEmpireFaction, bool abOwnedByPlayer, int aiEmpireSettlementType, int aiPreviousSettlementType)
	var[] kArgs = new var[0]
	kArgs.add(akWorkshopRef as var, 1)
	kArgs.add(aEmpireFaction as var, 1)
	kArgs.add(abOwnedByPlayer as var, 1)
	kArgs.add(aiEmpireSettlementType as var, 1)
	kArgs.add(aiPreviousSettlementType as var, 1)
	Self.SendCustomEvent("simsettlementsv2:quests:empiremanager_SettlementAddedToEmpire", kArgs)
EndFunction

Event WorkshopParentScript.WorkshopPlayerOwnershipChanged(workshopparentscript akSender, var[] akArgs)
	workshopscript thisWorkshop = akArgs[1] as workshopscript
	If (thisWorkshop.OwnedByPlayer)
		If (Self.GetEmpireDataStoreFromWorkshop(thisWorkshop) == None)
			simsettlementsv2:objectreferences:empiredata empireData = Self.GetEmpireDataStoreFromFaction(PlayerFaction, True, False)
			Self.AddWorkshopToEmpire(thisWorkshop, Self.iEmpireSettlementType_City, empireData, None, False)
		EndIf
	EndIf
EndEvent

Function DumpDataStore(workshopscript akWorkshopRef)
	If (!akWorkshopRef)
		akWorkshopRef = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
	EndIf
	simsettlementsv2:objectreferences:empiredata thisDataStore = Self.GetEmpireDataStoreFromWorkshop(akWorkshopRef)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[EmpireManager] ===================================", 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[EmpireManager] Beginning data dump for empire containing settlement " + akWorkshopRef as string + ", Data Store Ref: " + thisDataStore as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[EmpireManager] ===================================", 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[EmpireManager] Player Run?: " + thisDataStore.bPlayerRun as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[EmpireManager] CapitalCity: " + thisDataStore.CapitalCity as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[EmpireManager] CommandPost: " + thisDataStore.CommandPost as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[EmpireManager] Cities: " + thisDataStore.Cities as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[EmpireManager] Outposts: " + thisDataStore.Outposts as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[EmpireManager] Vassals: " + thisDataStore.Vassals as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[EmpireManager] ===================================", 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[EmpireManager] Finished data dump for " + akWorkshopRef as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[EmpireManager] ===================================", 0, False)
EndFunction

Function SendSettlementChangedTypeWithinEmpireEvent(workshopscript akWorkshopRef, Faction aEmpireFaction, bool abOwnedByPlayer, int aiEmpireSettlementType, int aiPreviousSettlementType)
	var[] kArgs = new var[0]
	kArgs.add(akWorkshopRef as var, 1)
	kArgs.add(aEmpireFaction as var, 1)
	kArgs.add(abOwnedByPlayer as var, 1)
	kArgs.add(aiEmpireSettlementType as var, 1)
	kArgs.add(aiPreviousSettlementType as var, 1)
	Self.SendCustomEvent("simsettlementsv2:quests:empiremanager_SettlementChangedTypeWithinEmpire", kArgs)
EndFunction

bool Function IsPartOfANetwork(workshopscript akWorkshopRef, Keyword aNetworkKeyword)
	If (aNetworkKeyword == None)
		aNetworkKeyword = EmpireCaravanKeyword
	EndIf
	Location thisLocation = akWorkshopRef.myLocation
	If (!thisLocation)
		thisLocation = akWorkshopRef.GetCurrentLocation()
	EndIf
	Location[] linkedNetworkLocations = thisLocation.GetAllLinkedLocations(aNetworkKeyword)
	return linkedNetworkLocations.length > 0
EndFunction

simsettlementsv2:objectreferences:empiredata Function GetEmpireDataStoreFromWorkshop(workshopscript akWorkshopRef)
	int iMapIndex = WorkshopEmpireDataMaps_Player.findstruct("kWorkshopRef", akWorkshopRef, 0)
	If (iMapIndex >= 0)
		return EmpireDataStores[WorkshopEmpireDataMaps_Player[iMapIndex].iDataStoreIndex]
	EndIf
	iMapIndex = WorkshopEmpireDataMaps_NPC.findstruct("kWorkshopRef", akWorkshopRef, 0)
	If (iMapIndex >= 0)
		return EmpireDataStores[WorkshopEmpireDataMaps_NPC[iMapIndex].iDataStoreIndex]
	EndIf
	return None
EndFunction

simsettlementsv2:objectreferences:empiredata Function GetEmpireDataStoreFromFaction(Faction aFactionForm, bool abPlayerControlled, bool abCreateIfMissing)
	If (abPlayerControlled)
		int iMapIndex = FactionEmpireDataMaps_Player.findstruct("FactionForm", aFactionForm, 0)
		If (iMapIndex >= 0)
			return EmpireDataStores[FactionEmpireDataMaps_Player[iMapIndex].iDataStoreIndex]
		EndIf
	Else
		int imapindex = FactionEmpireDataMaps_NPC.findstruct("FactionForm", aFactionForm, 0)
		If (imapindex >= 0)
			return EmpireDataStores[FactionEmpireDataMaps_NPC[imapindex].iDataStoreIndex]
		EndIf
	EndIf
	If (abCreateIfMissing)
		return Self.ConfigureEmpireDataStore(aFactionForm, abPlayerControlled)
	Else
		return None
	EndIf
EndFunction

simsettlementsv2:objectreferences:empiredata Function GetEmpireDataStoreFromLocation(Location akLocationRef)
	int iMapIndex = LocationEmpireDataMaps_Player.findstruct("kLocationRef", akLocationRef, 0)
	If (iMapIndex >= 0)
		return EmpireDataStores[LocationEmpireDataMaps_Player[iMapIndex].iDataStoreIndex]
	EndIf
	iMapIndex = LocationEmpireDataMaps_NPC.findstruct("kLocationRef", akLocationRef, 0)
	If (iMapIndex >= 0)
		return EmpireDataStores[LocationEmpireDataMaps_NPC[iMapIndex].iDataStoreIndex]
	EndIf
	return None
EndFunction

Function SendLocationAbandonedEvent(Location akLocationRef, Faction aFormerEmpireFaction, bool abOwnedByPlayer)
	var[] kArgs = new var[0]
	kArgs.add(akLocationRef as var, 1)
	kArgs.add(aFormerEmpireFaction as var, 1)
	kArgs.add(abOwnedByPlayer as var, 1)
	Self.SendCustomEvent("simsettlementsv2:quests:empiremanager_LocationAbandoned", kArgs)
EndFunction

bool Function AddLocationToEmpire(Location akLocationRef, simsettlementsv2:objectreferences:empiredata akEmpireRef, Faction aFactionForm, bool abPlayerControlled)
	If (akLocationRef == None)
		return False
	EndIf
	If (akEmpireRef == None)
		akEmpireRef = Self.GetEmpireDataStoreFromFaction(aFactionForm, abPlayerControlled, False)
		If (akEmpireRef == None)
			return False
		EndIf
	EndIf
	simsettlementsv2:objectreferences:empiredata kPreviousEmpireDataStore = Self.GetEmpireDataStoreFromLocation(akLocationRef)
	If (kPreviousEmpireDataStore != None)
		kPreviousEmpireDataStore.RemoveLocation_InternalOnly(akLocationRef)
	EndIf
	akEmpireRef.AddLocation_InternalOnly(akLocationRef)
	simsettlementsv2:datastructures#locationempiredatamap newEntry = new simsettlementsv2:datastructures#locationempiredatamap
	newEntry.kLocationRef = akLocationRef
	newEntry.iDataStoreIndex = EmpireDataStores.find(akEmpireRef, 0)
	If (LocationEmpireDataMaps_Player == None || LocationEmpireDataMaps_Player.length == 0)
		LocationEmpireDataMaps_Player = new simsettlementsv2:datastructures#locationempiredatamap[0]
	EndIf
	If (LocationEmpireDataMaps_NPC == None || LocationEmpireDataMaps_NPC.length == 0)
		LocationEmpireDataMaps_NPC = new simsettlementsv2:datastructures#locationempiredatamap[0]
	EndIf
	simsettlementsv2:datastructures#locationempiredatamap[] AddToMe = LocationEmpireDataMaps_Player
	simsettlementsv2:datastructures#locationempiredatamap[] RemoveFromMe = LocationEmpireDataMaps_NPC
	If (!akEmpireRef.bPlayerRun)
		AddToMe = LocationEmpireDataMaps_NPC
		RemoveFromMe = LocationEmpireDataMaps_Player
	EndIf
	int iIndex = AddToMe.findstruct("kLocationRef", akLocationRef, 0)
	If (iIndex < 0)
		AddToMe.add(newEntry, 1)
	EndIf
	iIndex = RemoveFromMe.findstruct("kLocationRef", akLocationRef, 0)
	If (iIndex >= 0)
		RemoveFromMe.remove(iIndex, 1)
	EndIf
	return True
EndFunction
