;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\IconManager.psc
Modified : 2020-08-06 13:25:57
Compiled : 2021-01-07 11:43:01
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:IconManager extends WorkshopFramework:Library:SlaveQuest conditional
{ Handles display of information icons }

;-- Properties --------------------------------------
Group Controllers
	workshopframework:mainquest Property WSFW_Main Auto Const mandatory
	simsettlementsv2:quests:optionsmanager Property OptionsManager Auto Const mandatory
	GlobalVariable Property Settings_DisplayIcons Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property InformationIconKeyword Auto Const mandatory
	Keyword Property Event_UpdateInformationIconVisibility Auto Const mandatory
EndGroup

bool Property bIconUpdateNeeded = False Auto hidden
bool Property bAllIconsHidden = True Auto hidden
int[] Property iPlayerOptions_IconGroupDisplay Auto hidden
int Property NextRegisteredIconGroup
	int Function Get()
		iNextRegisteredIconGroup += 1
		If (iNextRegisteredIconGroup > 127)
			return -1
		EndIf
		return iNextRegisteredIconGroup
	EndFunction
EndProperty

;-- Variables ---------------------------------------
float fLoadedSearchDistance = 20000 Const
int iIconSettingGlobal_UseGroupSettings = 3 Const
int iIconGroupDisplay_Show = 1 Const
int iIconSettingGlobal_AlwaysShow = 1 Const
int iNextRegisteredIconGroup = -1
int iIconGroupDisplay_Hide = 0 Const
int iIconGroupDisplay_WSModeOnly = 2 Const
int iIconSettingGlobal_WSModeOnly = 2 Const
int iIconSettingGlobal_HideAll = 0 Const

;-- Functions ---------------------------------------

Function HandleQuestInit()
	Parent.HandleQuestInit()
	iPlayerOptions_IconGroupDisplay = new int[0]
	Self.RegisterForCustomEvent(WSFW_Main as ScriptObject, "workshopframework:mainquest_PlayerEnteredSettlement")
	Self.RegisterForCustomEvent(WSFW_Main as ScriptObject, "workshopframework:mainquest_PlayerExitedSettlement")
	Self.RegisterForMenuOpenCloseEvent("WorkshopMenu")
	Self.RegisterForMenuOpenCloseEvent("PauseMenu")
	Self.RegisterForMenuOpenCloseEvent("PipboyMenu")
	Self.RegisterForMenuOpenCloseEvent("TerminalMenu")
EndFunction

Function UpdateLoadedIcons(ObjectReference akCenterPoint)
	If (Self.ArePlayersDisplayOptionsHidingThis(-1))
		bAllIconsHidden = True
	Else
		bAllIconsHidden = False
	EndIf
	If (bAllIconsHidden)
		Self.HideLoadedIcons(akCenterPoint, -1)
	Else
		bool bAllIconsShown = Settings_DisplayIcons.GetValueInt() == iIconSettingGlobal_AlwaysShow
		If (bAllIconsShown)
			bAllIconsHidden = False
			Self.ShowLoadedIcons(akCenterPoint, -1)
		Else
			bool bInWorkshopMode = workshopframework:wsfw_api.IsPlayerInWorkshopMode()
			bAllIconsHidden = True
			int I = 0
			While (I < iPlayerOptions_IconGroupDisplay.length)
				If (iPlayerOptions_IconGroupDisplay[I] == iIconGroupDisplay_Show || bInWorkshopMode && iPlayerOptions_IconGroupDisplay[I] == iIconGroupDisplay_WSModeOnly)
					Self.ShowLoadedIcons(akCenterPoint, I)
					bAllIconsHidden = False
				Else
					Self.HideLoadedIcons(akCenterPoint, I)
				EndIf
				I += 1
			EndWhile
		EndIf
	EndIf
EndFunction

Function HideIconGroup(int aiIconGroup)
	If (aiIconGroup >= 0 && iPlayerOptions_IconGroupDisplay.length > aiIconGroup)
		iPlayerOptions_IconGroupDisplay[aiIconGroup] = iIconGroupDisplay_Hide
		Self.HideLoadedIcons(PlayerRef as ObjectReference, aiIconGroup)
	EndIf
EndFunction

Function IconSettingsChanged()
	bIconUpdateNeeded = True
EndFunction

Function PlayerTriggered_ToggleIcons()
	If (bAllIconsHidden)
		bool bAllsGroupsMatch = True
		int iGroupSetting = -1
		int I = 0
		While (I < iPlayerOptions_IconGroupDisplay.length && bAllsGroupsMatch)
			If (iGroupSetting < 0)
				iGroupSetting = iPlayerOptions_IconGroupDisplay[I]
			ElseIf (iPlayerOptions_IconGroupDisplay[I] != iGroupSetting)
				bAllsGroupsMatch = False
			EndIf
			I += 1
		EndWhile
		If (bAllsGroupsMatch)
			Self.ShowLoadedIcons(None, -1)
		Else
			I = 0
			While (I < iPlayerOptions_IconGroupDisplay.length)
				If (iPlayerOptions_IconGroupDisplay[I] != iIconGroupDisplay_Hide)
					Self.ShowLoadedIcons(PlayerRef as ObjectReference, I)
				EndIf
				I += 1
			EndWhile
		EndIf
	Else
		Self.HideLoadedIcons(None, -1)
	EndIf
EndFunction

bool Function ArePlayersDisplayOptionsHidingThis(int aiIconGroup)
	int iGlobalHideSetting = Settings_DisplayIcons.GetValueInt()
	If (iGlobalHideSetting == iIconSettingGlobal_HideAll)
		return True
	ElseIf (iGlobalHideSetting == iIconSettingGlobal_WSModeOnly)
		If (workshopframework:wsfw_api.IsPlayerInWorkshopMode())
			return False
		Else
			return True
		EndIf
	ElseIf (aiIconGroup >= 0 && iGlobalHideSetting == iIconSettingGlobal_UseGroupSettings && iPlayerOptions_IconGroupDisplay.length > aiIconGroup && (iPlayerOptions_IconGroupDisplay[aiIconGroup] == iIconGroupDisplay_Hide || iPlayerOptions_IconGroupDisplay[aiIconGroup] == iIconGroupDisplay_WSModeOnly && !workshopframework:wsfw_api.IsPlayerInWorkshopMode()))
		return True
	EndIf
	return False
EndFunction

Function HideLoadedIcons(ObjectReference akCenterPoint, int aiIconGroup)
	If (!akCenterPoint)
		akCenterPoint = PlayerRef as ObjectReference
	EndIf
	If (!Event_UpdateInformationIconVisibility.SendStoryEventAndWait(None, akCenterPoint, None, aiIconGroup + 1, 2))
		ObjectReference[] Icons = akCenterPoint.FindAllReferencesWithKeyword(InformationIconKeyword as Form, fLoadedSearchDistance)
		int I = 0
		While (I < Icons.length)
			If (!Icons[I].IsDeleted())
				simsettlementsv2:objectreferences:informationicon asIcon = Icons[I] as simsettlementsv2:objectreferences:informationicon
				If (asIcon as bool && (aiIconGroup == -1 || asIcon.iIconGroup == aiIconGroup))
					asIcon.Hide()
				EndIf
			EndIf
			I += 1
		EndWhile
	EndIf
	If (aiIconGroup == -1)
		bAllIconsHidden = True
	EndIf
EndFunction

Function HandleGameLoaded()
	Self.RegisterForMenuOpenCloseEvent("WorkshopMenu")
EndFunction

Function ShowIconGroup(int aiIconGroup)
	If (aiIconGroup >= 0 && iPlayerOptions_IconGroupDisplay.length > aiIconGroup)
		iPlayerOptions_IconGroupDisplay[aiIconGroup] = iIconGroupDisplay_Show
		Self.ShowLoadedIcons(PlayerRef as ObjectReference, aiIconGroup)
	EndIf
EndFunction

Event WorkshopFramework:MainQuest.PlayerEnteredSettlement(workshopframework:mainquest akQuestRef, var[] akArgs)
	workshopscript kWorkshopRef = akArgs[0] as workshopscript
	bool bPreviouslyUnloaded = akArgs[1] as bool
	Self.UpdateLoadedIcons(kWorkshopRef as ObjectReference)
EndEvent

int Function RegisterNewIconGroup(int aiStartSetting)
	int iNextGroupIndex = Self.NextRegisteredIconGroup
	If (iNextGroupIndex >= 0)
		iPlayerOptions_IconGroupDisplay.add(aiStartSetting, 1)
	EndIf
	return iNextGroupIndex
EndFunction

Function ShowLoadedIcons(ObjectReference akCenterPoint, int aiIconGroup)
	If (!akCenterPoint)
		akCenterPoint = PlayerRef as ObjectReference
	EndIf
	bAllIconsHidden = False
	If (!Event_UpdateInformationIconVisibility.SendStoryEventAndWait(None, akCenterPoint, None, aiIconGroup + 1, 1))
		ObjectReference[] Icons = akCenterPoint.FindAllReferencesWithKeyword(InformationIconKeyword as Form, fLoadedSearchDistance)
		int I = 0
		While (I < Icons.length)
			If (!Icons[I].IsDeleted())
				simsettlementsv2:objectreferences:informationicon asIcon = Icons[I] as simsettlementsv2:objectreferences:informationicon
				If (asIcon as bool && (aiIconGroup == -1 || asIcon.iIconGroup == aiIconGroup))
					asIcon.Show()
				EndIf
			EndIf
			I += 1
		EndWhile
	EndIf
EndFunction

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
	If (asMenuName == "WorkshopMenu")
		int iGlobalHideSetting = Settings_DisplayIcons.GetValueInt()
		If (iGlobalHideSetting == iIconSettingGlobal_WSModeOnly)
			If (abOpening)
				Self.UpdateLoadedIcons(PlayerRef as ObjectReference)
			Else
				Self.HideLoadedIcons(PlayerRef as ObjectReference, -1)
			EndIf
		ElseIf (iGlobalHideSetting == iIconSettingGlobal_UseGroupSettings)
			Self.UpdateLoadedIcons(PlayerRef as ObjectReference)
		EndIf
	ElseIf (!abOpening && bIconUpdateNeeded)
		Self.UpdateLoadedIcons(PlayerRef as ObjectReference)
	EndIf
EndEvent

Event WorkshopFramework:MainQuest.PlayerExitedSettlement(workshopframework:mainquest akQuestRef, var[] akArgs)
	workshopscript kWorkshopRef = akArgs[0] as workshopscript
	bool bStillLoaded = akArgs[1] as bool
EndEvent
