;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\InjectionManager.psc
Modified : 2020-10-28 16:10:40
Compiled : 2021-01-07 11:42:54
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:InjectionManager extends WorkshopFramework:Library:SlaveQuest
{ Handles injection into leveled lists. Overall goal is to allow multiple mods to alter the same list without requiring patches and reducing the likelihood of crashes if a player uninstalls an injected mod mid-playthrough }

;-- Properties --------------------------------------
Group Injectables
	LeveledActor Property VisitorLCharHolder Auto Const mandatory
	{ Blank leveled actor }
	workshopframework:library:datastructures#injectionmap[] Property DefaultInjections Auto Const mandatory
EndGroup

Group InjectableRecords
	workshopframework:library:datastructures#injectableactormap[] Property InjectableLeveledActors Auto Const
	workshopframework:library:datastructures#injectableitemmap[] Property InjectableLeveledItems Auto Const
EndGroup


;-- Variables ---------------------------------------
int iLastDefaultInjectionIndex = -1
bool bSetupListsBlock

;-- Functions ---------------------------------------

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
	Self.SetupLeveledLists()
EndFunction

Function RebuildItemList(workshopframework:library:datastructures#injectableitemmap aListToRebuild)
	int iLockKey = 0
	iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTrace("Unable to get lock!", 2, False)
		return 
	EndIf
	LeveledItem asLI = aListToRebuild.TargetLeveledItem
	If (asLI)
		asLI.Revert()
		If (aListToRebuild.DefaultEntries)
			int I = 0
			While (I < aListToRebuild.DefaultEntries.GetSize())
				Form thisForm = aListToRebuild.DefaultEntries.GetAt(I)
				If (!aListToRebuild.RemovedDefaultEntries || aListToRebuild.RemovedDefaultEntries.Find(thisForm) < 0)
					asLI.AddForm(thisForm, 1, 1)
				EndIf
				I += 1
			EndWhile
		EndIf
		If (aListToRebuild.AdditionalEntries)
			workshopframework:library:utilityfunctions.CleanFormList(aListToRebuild.AdditionalEntries, -1)
			int i = 0
			While (i < aListToRebuild.AdditionalEntries.GetSize())
				Form thisform = aListToRebuild.AdditionalEntries.GetAt(i)
				asLI.AddForm(thisform, 1, 1)
				i += 1
			EndWhile
		EndIf
	EndIf
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTrace("Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
EndFunction

workshopframework:library:datastructures#injectableactormap Function FindInjectableActorMap(LeveledActor aTargetList)
	int I = 0
	While (I < InjectableLeveledActors.length)
		If (InjectableLeveledActors[I].TargetLeveledActor == aTargetList)
			return InjectableLeveledActors[I]
		EndIf
		I += 1
	EndWhile
	return None
EndFunction

Function RemoveDefault(Form aFormToRemove, Form aTargetList)
	LeveledActor asLA = aTargetList as LeveledActor
	LeveledItem asLI = aTargetList as LeveledItem
	If (asLA)
		workshopframework:library:datastructures#injectableactormap thisMap = Self.FindInjectableActorMap(asLA)
		If (thisMap as bool && thisMap.RemovedDefaultEntries as bool)
			thisMap.RemovedDefaultEntries.AddForm(aFormToRemove)
			Self.RebuildActorList(thisMap)
		EndIf
	ElseIf (asLI)
		workshopframework:library:datastructures#injectableitemmap thismap = Self.FindInjectableItemMap(asLI)
		If (thismap as bool && thismap.RemovedDefaultEntries as bool)
			thismap.RemovedDefaultEntries.AddForm(aFormToRemove)
			Self.RebuildItemList(thismap)
		EndIf
	EndIf
EndFunction

Function RebuildActorList(workshopframework:library:datastructures#injectableactormap aListToRebuild)
	int iLockKey = 0
	iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTrace("Unable to get lock!", 2, False)
		return 
	EndIf
	LeveledActor asLA = aListToRebuild.TargetLeveledActor
	If (asLA)
		asLA.Revert()
		If (aListToRebuild.DefaultEntries)
			int I = 0
			While (I < aListToRebuild.DefaultEntries.GetSize())
				Form thisForm = aListToRebuild.DefaultEntries.GetAt(I)
				If (!aListToRebuild.RemovedDefaultEntries || aListToRebuild.RemovedDefaultEntries.Find(thisForm) < 0)
					asLA.AddForm(thisForm, 1)
				EndIf
				I += 1
			EndWhile
		EndIf
		If (aListToRebuild.AdditionalEntries)
			workshopframework:library:utilityfunctions.CleanFormList(aListToRebuild.AdditionalEntries, -1)
			int i = 0
			While (i < aListToRebuild.AdditionalEntries.GetSize())
				Form thisform = aListToRebuild.AdditionalEntries.GetAt(i)
				asLA.AddForm(thisform, 1)
				i += 1
			EndWhile
		EndIf
	EndIf
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTrace("Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
EndFunction

Function AddToList(Form aTargetList, Form aAddForm)
	LeveledActor asLA = aTargetList as LeveledActor
	LeveledItem asLI = aTargetList as LeveledItem
	FormList asFormList = aAddForm as FormList
	If (asLA)
		workshopframework:library:datastructures#injectableactormap thisMap = Self.FindInjectableActorMap(asLA)
		If (thisMap as bool && thisMap.AdditionalEntries as bool)
			If (asFormList)
				int I = 0
				While (I < asFormList.GetSize())
					thisMap.AdditionalEntries.AddForm(asFormList.GetAt(I))
					asLA.AddForm(asFormList.GetAt(I), 1)
					I += 1
				EndWhile
			Else
				thisMap.AdditionalEntries.AddForm(aAddForm)
				asLA.AddForm(aAddForm, 1)
			EndIf
		EndIf
	ElseIf (asLI)
		workshopframework:library:datastructures#injectableitemmap thismap = Self.FindInjectableItemMap(asLI)
		If (thismap as bool && thismap.AdditionalEntries as bool)
			If (asFormList)
				int i = 0
				While (i < asFormList.GetSize())
					thismap.AdditionalEntries.AddForm(asFormList.GetAt(i))
					asLI.AddForm(asFormList.GetAt(i), 1, 1)
					i += 1
				EndWhile
			Else
				thismap.AdditionalEntries.AddForm(aAddForm)
				asLI.AddForm(aAddForm, 1, 1)
			EndIf
		EndIf
	EndIf
EndFunction

Function SetupLeveledLists()
	If (bSetupListsBlock)
		return 
	EndIf
	bSetupListsBlock = True
	int I = 0
	While (I < InjectableLeveledActors.length)
		Self.RebuildActorList(InjectableLeveledActors[I])
		I += 1
	EndWhile
	I = 0
	While (I < InjectableLeveledItems.length)
		Self.RebuildItemList(InjectableLeveledItems[I])
		I += 1
	EndWhile
	I = 0
	While (I < DefaultInjections.length)
		If (iLastDefaultInjectionIndex < I)
			iLastDefaultInjectionIndex = I
			int j = 0
			While (j < DefaultInjections[iLastDefaultInjectionIndex].NewEntries.GetSize())
				DefaultInjections[iLastDefaultInjectionIndex].TargetLeveledItem.AddForm(DefaultInjections[iLastDefaultInjectionIndex].NewEntries.GetAt(j), DefaultInjections[iLastDefaultInjectionIndex].iLevel, DefaultInjections[iLastDefaultInjectionIndex].iCount)
				j += 1
			EndWhile
		EndIf
		I += 1
	EndWhile
	bSetupListsBlock = False
EndFunction

workshopframework:library:datastructures#injectableitemmap Function FindInjectableItemMap(LeveledItem aTargetList)
	int I = 0
	While (I < InjectableLeveledItems.length)
		If (InjectableLeveledItems[I].TargetLeveledItem == aTargetList)
			return InjectableLeveledItems[I]
		EndIf
		I += 1
	EndWhile
	return None
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
EndFunction

Function RebuildItemListFromTargetLL(LeveledItem aTargetLL)
	int iIndex = InjectableLeveledItems.findstruct("TargetLeveledItem", aTargetLL, 0)
	If (iIndex >= 0)
		Self.RebuildItemList(InjectableLeveledItems[iIndex])
	EndIf
EndFunction
