;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\ListManager.psc
Modified : 2020-06-13 01:22:32
Compiled : 2021-01-07 11:43:04
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:ListManager extends WorkshopFramework:Library:SlaveQuest
{ Has various tools for managing lists of objects, such as the building plans and city plans }

;-- Properties --------------------------------------
Group Aliases
	ReferenceAlias Property SafeSpawnPoint Auto Const mandatory
EndGroup

Group Assets
	Form Property DummyContainerForm Auto Const mandatory
	{ Empty container form, will be spawned on the fly to sort various items }
	FormList[] Property SortingLists Auto Const mandatory
	{ Blank formlists to be used for sorting things, can have up to 128. Adding more will allow more things to operate simultaneously, such as plots being registered that need new building plans. }
	FormList[] Property CacheLists01 Auto Const
	{ Used in the same way as Sorting Lists, but longer term. Naming 01 in case we decide to expand }
EndGroup

int Property iMaxCachedLists01 = 0 Auto hidden

;-- Variables ---------------------------------------
bool[] bBusyCacheLists01
bool[] bBusySortingLists

;-- Functions ---------------------------------------

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
	Self.UpdateMaxCache()
EndFunction

simsettlementsv2:datastructures#indexedformlist Function RequestList(FormList[] aListArray, bool[] aBusyArray)
	simsettlementsv2:datastructures#indexedformlist ReturnSortingList = new simsettlementsv2:datastructures#indexedformlist
	ReturnSortingList.IndexedList = None
	If (!aBusyArray)
		aBusyArray = new bool[128]
	EndIf
	While (ReturnSortingList.IndexedList == None)
		int I = 0
		While (I < aListArray.length && ReturnSortingList.IndexedList == None)
			If (!aBusyArray[I])
				aBusyArray[I] = True
				ReturnSortingList.iListIndex = I
				ReturnSortingList.IndexedList = aListArray[I]
			EndIf
			I += 1
		EndWhile
		If (ReturnSortingList.IndexedList == None)
			Utility.Wait(1)
		EndIf
	EndWhile
	return ReturnSortingList
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
	bBusySortingLists = new bool[128]
	bBusyCacheLists01 = new bool[128]
	Self.UpdateMaxCache()
EndFunction

Function FreeList(FormList[] aListArray, bool[] aBusyArray, int aiListIndex)
	aListArray[aiListIndex].Revert()
	aBusyArray[aiListIndex] = False
EndFunction

Function FreeListArray(FormList[] aListArray, bool[] aBusyArray)
	int I = 0
	While (I < aListArray.length)
		aListArray[I].Revert()
		aBusyArray[I] = False
		I += 1
	EndWhile
EndFunction

Function FreeCacheList(int aiSortingListIndex, int aiCacheSet)
	If (aiCacheSet == 1)
		Self.FreeList(CacheLists01, bBusyCacheLists01, aiSortingListIndex)
	EndIf
EndFunction

Function FreeAllSortingLists()
	Self.FreeListArray(SortingLists, bBusySortingLists)
EndFunction

Function UpdateMaxCache()
	iMaxCachedLists01 = CacheLists01.length
EndFunction

Function FreeSortingList(int aiSortingListIndex)
	Self.FreeList(SortingLists, bBusySortingLists, aiSortingListIndex)
EndFunction

simsettlementsv2:datastructures#indexedformlist Function RequestCacheList(int aiCacheSet)
	If (aiCacheSet == 1)
		return Self.RequestList(CacheLists01, bBusyCacheLists01)
	Else
		return None
	EndIf
EndFunction

Function FreeAllCacheLists(int aiCacheSet)
	If (aiCacheSet == 1)
		Self.FreeListArray(CacheLists01, bBusyCacheLists01)
	EndIf
EndFunction

simsettlementsv2:datastructures#indexedformlist Function RequestSortingList()
	return Self.RequestList(SortingLists, bBusySortingLists)
EndFunction
