;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\MagazineManager.psc
Modified : 2021-04-15 21:49:03
Compiled : 2021-04-15 21:50:02
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:Quests:MagazineManager extends WorkshopFramework:Library:SlaveQuest conditional

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const mandatory
	simsettlementsv2:quests:plotmanager Property PlotManager Auto Const mandatory
	simsettlementsv2:quests:settlementmanager Property SettlementManager Auto Const mandatory
	simsettlementsv2:quests:optionsmanager Property OptionsManager Auto Const mandatory
EndGroup

Group Assets
	FormList Property RegisteredIssuesList Auto Const mandatory
	{ Empty formlist for storing unprinted Magazines that are registered with the system }
	FormList Property UnlockedIssuesList Auto Const mandatory
	{ Empty formlist for Magazines that are eligible to be printed but haven't been yet }
	FormList Property PrintedIssuesList Auto Const mandatory
	{ Empty formlist for storing Magazines that have been printed }
	FormList Property SeenIssuesList Auto Const mandatory
	{ Empty formlist for Magazines the player has already seen }
	FormList Property MagazineBuildingPlans Auto Const mandatory
	{ Formlist with magazine building plans }
	Form[] Property DefaultMagazineBuildingPlans Auto Const mandatory
	LeveledItem Property PrintedIssuesLL Auto Const mandatory
	{ Leveledlist for distributing printed Magazines in the game world }
EndGroup

Group Config
	float Property fMinTimeBetweenIssues = 7 Auto Const
	{ in game days }
	float Property fMaxTimeBetweenIssues = 14 Auto Const
	{ in game days }
EndGroup

simsettlementsv2:objectreferences:simplot[] Property MagazineBuildings Auto hidden
Form Property NextIssue Auto hidden
Form Property LastPrintedIssue Auto hidden
float Property fLastIssuePrintTimestamp = 0 Auto hidden
float Property fNextIssuePrintTimestamp = 0 Auto hidden

;-- Variables ---------------------------------------
int iTimerID_CompleteInitilization = 101 Const
int iTimerID_CheckIssues = 102 Const

;-- Functions ---------------------------------------

Function RegisterMagazineBuilding(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (akPlotRef == None)
		return 
	EndIf
	int iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[MagazineManager]: Unable to get lock!", 2, False)
		return 
	EndIf
	Self.SetStage(5)
	If (MagazineBuildings.find(akPlotRef, 0) < 0)
		int I = 0
		bool bSlotFound = False
		While (I < MagazineBuildings.length && !bSlotFound)
			If (MagazineBuildings[I] == None)
				MagazineBuildings[I] = akPlotRef
				bSlotFound = True
			EndIf
			I += 1
		EndWhile
	EndIf
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[MagazineManager]: Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
EndFunction

Function ForceNextIssue(Form aIssue)
	NextIssue = aIssue
EndFunction

Event SimSettlementsV2:Quests:PlotManager.PlotLevelChanged(simsettlementsv2:quests:plotmanager akSender, var[] akArgs)
	simsettlementsv2:objectreferences:simplot kPlotRef = akArgs[0] as simsettlementsv2:objectreferences:simplot
	If (kPlotRef as bool && akArgs[1] as int > 0)
		If (Self.IsMagazineBuilding(kPlotRef as ObjectReference))
			Self.RegisterMagazineBuilding(kPlotRef)
		EndIf
	EndIf
EndEvent

Function PrintIssue(Form aIssue)
	fLastIssuePrintTimestamp = Utility.GetCurrentGameTime()
	LastPrintedIssue = aIssue
	fNextIssuePrintTimestamp = fLastIssuePrintTimestamp + Utility.RandomFloat(fMinTimeBetweenIssues, fMaxTimeBetweenIssues)
	If (!PrintedIssuesList.HasForm(aIssue))
		PrintedIssuesList.AddForm(aIssue)
		PrintedIssuesLL.AddForm(aIssue, 1, 1)
		RegisteredIssuesList.RemoveAddedForm(aIssue)
		UnlockedIssuesList.RemoveAddedForm(aIssue)
	EndIf
EndFunction

Function RegisterIssue(Form aIssue)
	If (!PrintedIssuesList.HasForm(aIssue) && !UnlockedIssuesList.HasForm(aIssue))
		simsettlementsv2:books:magazineissue asIssue = aIssue as simsettlementsv2:books:magazineissue
		If (asIssue != None)
			RegisteredIssuesList.AddForm(aIssue)
		Else
			UnlockedIssuesList.AddForm(aIssue)
		EndIf
	EndIf
EndFunction

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
	int I = 0
	While (I < DefaultMagazineBuildingPlans.length)
		Self.RegisterMagazineBuildingPlan(DefaultMagazineBuildingPlans[I])
		I += 1
	EndWhile
	Self.CleanupMagazineBuildingsArray()
	workshopframework:library:utilityfunctions.CleanFormlist(RegisteredIssuesList, -1)
	workshopframework:library:utilityfunctions.CleanFormlist(PrintedIssuesList, -1)
	workshopframework:library:utilityfunctions.CleanFormlist(SeenIssuesList, -1)
	workshopframework:library:utilityfunctions.CleanFormlist(UnlockedIssuesList, -1)
	workshopframework:library:utilityfunctions.CleanFormlist(MagazineBuildingPlans, -1)
EndFunction

Function RegisterIssues(FormList aIssueList)
	int I = 0
	While (I < aIssueList.GetSize())
		Self.RegisterIssue(aIssueList.GetAt(I))
		I += 1
	EndWhile
EndFunction

bool Function IsMagazineBuilding(ObjectReference akPlotRef)
	simsettlementsv2:objectreferences:simplot asPlot = akPlotRef as simsettlementsv2:objectreferences:simplot
	If (!asPlot)
		return False
	EndIf
	If (MagazineBuildingPlans.HasForm(asPlot.GetParentBuildingPlan() as Form) || MagazineBuildingPlans.HasForm(asPlot.GetCurrentLevelPlan() as Form))
		return True
	EndIf
	return False
EndFunction

Function MarkIssueSeen(Form aIssue)
	SeenIssuesList.AddForm(aIssue)
EndFunction

Event OnTimerGameTime(int aiTimerID)
	Parent.OnTimerGameTime(aiTimerID)
	If (aiTimerID == iTimerID_CheckIssues)
		Self.CheckIssueEligibility()
		Self.StartTimerGameTime(24, iTimerID_CheckIssues)
	EndIf
EndEvent

Form Function GetTodaysIssue()
	If (!OptionsManager.bPCUser)
		return None
	EndIf
	If (Utility.GetCurrentGameTime() < fNextIssuePrintTimestamp)
		return LastPrintedIssue
	EndIf
	int iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[MagazineManager]: Unable to get lock!", 2, False)
		return None
	EndIf
	If (NextIssue)
		Self.PrintIssue(NextIssue)
		NextIssue = None
	Else
		Form[] PotentialIssues = new Form[0]
		int iHighestPriority = -1
		int I = 0
		While (I < UnlockedIssuesList.GetSize())
			Form thisIssue = UnlockedIssuesList.GetAt(I)
			simsettlementsv2:books:magazineissue asIssue = thisIssue as simsettlementsv2:books:magazineissue
			int iPriority = 0
			If (asIssue)
				iPriority = asIssue.iPriority
			EndIf
			If (iPriority > 21)
				iPriority = 20
			EndIf
			If (iPriority > iHighestPriority)
				iHighestPriority = iPriority
				PotentialIssues = new Form[0]
			EndIf
			If (iPriority == iHighestPriority)
				PotentialIssues.add(thisIssue, 1)
			EndIf
			I += 1
		EndWhile
		If (PotentialIssues.length > 0)
			int iPrintIndex = Utility.RandomInt(0, PotentialIssues.length - 1)
			Self.PrintIssue(PotentialIssues[iPrintIndex])
		Else
			I = 0
			While (I < PrintedIssuesList.GetSize())
				Form thisissue = PrintedIssuesList.GetAt(I)
				If (!SeenIssuesList.HasForm(thisissue))
					PotentialIssues.add(thisissue, 1)
				EndIf
				I += 1
			EndWhile
			If (PotentialIssues.length > 0)
				int iprintindex = Utility.RandomInt(0, PotentialIssues.length - 1)
				Self.PrintIssue(PotentialIssues[iprintindex])
			Else
				int iprintindex = Utility.RandomInt(0, PrintedIssuesList.GetSize() - 1)
				Self.PrintIssue(PrintedIssuesList.GetAt(iprintindex))
			EndIf
		EndIf
	EndIf
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[MagazineManager]: Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
	return LastPrintedIssue
EndFunction

Function RegisterMagazineBuildingPlan(Form aBuildingOrLevelPlan)
	If (aBuildingOrLevelPlan == None)
		return 
	EndIf
	If ((aBuildingOrLevelPlan as simsettlementsv2:weapons:buildingplan) as bool || (aBuildingOrLevelPlan as simsettlementsv2:weapons:buildinglevelplan) as bool)
		MagazineBuildingPlans.AddForm(aBuildingOrLevelPlan)
	EndIf
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
	MagazineBuildings = new simsettlementsv2:objectreferences:simplot[0]
	Self.RegisterForCustomEvent(PlotManager as ScriptObject, "simsettlementsv2:quests:plotmanager_PlotLevelChanged")
	Self.StartTimer(3, iTimerID_CompleteInitilization)
	Self.StartTimerGameTime(24, iTimerID_CheckIssues)
EndFunction

Function UnlockIssue(Form aIssue)
	RegisteredIssuesList.RemoveAddedForm(aIssue)
	UnlockedIssuesList.AddForm(aIssue)
EndFunction

Function CheckIssueEligibility()
	int I = 0
	While (I < RegisteredIssuesList.GetSize())
		Form thisForm = RegisteredIssuesList.GetAt(I)
		simsettlementsv2:books:magazineissue thisIssue = thisForm as simsettlementsv2:books:magazineissue
		If (thisIssue as bool && Self.IsEligibleToPrint(thisIssue as Form))
			Self.UnlockIssue(thisIssue as Form)
		ElseIf (!thisIssue)
			Self.UnlockIssue(thisForm)
		EndIf
		I += 1
	EndWhile
EndFunction

bool Function IsEligibleToPrint(Form aIssue)
	simsettlementsv2:books:magazineissue asIssue = aIssue as simsettlementsv2:books:magazineissue
	If (!asIssue)
		return True
	EndIf
	bool bCanPrint = asIssue.IsEligibleToPrint()
	If (bCanPrint)
		If (bCanPrint && asIssue.iMinPlayerLevel > 0 && PlayerRef.GetLevel() < asIssue.iMinPlayerLevel)
			bCanPrint = False
		EndIf
		workshopscript[] OwnedSettlements = new workshopscript[0]
		bool bOwnedSettlementsCheckedAlready = False
		If (bCanPrint && asIssue.iMinOwnedSettlements > 0)
			bOwnedSettlementsCheckedAlready = True
			OwnedSettlements = workshopframework:workshopfunctions.GetPlayerOwnedSettlements(True, True, False)
			If (OwnedSettlements.length < asIssue.iMinOwnedSettlements)
				bCanPrint = False
			EndIf
		EndIf
		If (bCanPrint && asIssue.GetRequirements() as bool)
			bCanPrint = simsettlementsv2:utilityfunctions.CheckRequirements(asIssue.GetRequirements(), None, None, None)
		EndIf
		If (bCanPrint && asIssue.MinimumPlotsBuilt != None)
			int I = 0
			While (I < asIssue.MinimumPlotsBuilt.length && bCanPrint)
				If (asIssue.MinimumPlotsBuilt[I].iL0Count > 0)
					int iPlots = 0
					If (asIssue.MinimumPlotsBuilt[I].BuildingClass != None)
						iPlots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsBuilt[I].BuildingClass, 0, -1, False, True)
					Else
						iPlots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsBuilt[I].PlotType, 0, -1, False, True)
					EndIf
					If (iPlots < asIssue.MinimumPlotsBuilt[I].iL0Count)
						bCanPrint = False
					EndIf
				EndIf
				If (bCanPrint && asIssue.MinimumPlotsBuilt[I].iL1Count > 0)
					int iplots = 0
					If (asIssue.MinimumPlotsBuilt[I].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsBuilt[I].BuildingClass, 1, -1, False, True)
					Else
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsBuilt[I].PlotType, 1, -1, False, True)
					EndIf
					If (iplots < asIssue.MinimumPlotsBuilt[I].iL1Count)
						bCanPrint = False
					EndIf
				EndIf
				If (bCanPrint && asIssue.MinimumPlotsBuilt[I].iL2Count > 0)
					int iplots = 0
					If (asIssue.MinimumPlotsBuilt[I].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsBuilt[I].BuildingClass, 2, -1, False, True)
					Else
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsBuilt[I].PlotType, 2, -1, False, True)
					EndIf
					If (iplots < asIssue.MinimumPlotsBuilt[I].iL2Count)
						bCanPrint = False
					EndIf
				EndIf
				If (bCanPrint && asIssue.MinimumPlotsBuilt[I].iL3Count > 0)
					int iplots = 0
					If (asIssue.MinimumPlotsBuilt[I].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsBuilt[I].BuildingClass, 3, -1, False, True)
					Else
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsBuilt[I].PlotType, 3, -1, False, True)
					EndIf
					If (iplots < asIssue.MinimumPlotsBuilt[I].iL3Count)
						bCanPrint = False
					EndIf
				EndIf
				I += 1
			EndWhile
		EndIf
		If (bCanPrint && asIssue.MinimumPlotsActive != None)
			int i = 0
			While (i < asIssue.MinimumPlotsActive.length && bCanPrint)
				If (asIssue.MinimumPlotsActive[i].iL0Count > 0)
					int iplots = 0
					If (asIssue.MinimumPlotsActive[i].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsActive[i].BuildingClass, 0, -1, True, True)
					Else
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsActive[i].PlotType, 0, -1, True, True)
					EndIf
					If (iplots < asIssue.MinimumPlotsActive[i].iL0Count)
						bCanPrint = False
					EndIf
				EndIf
				If (bCanPrint && asIssue.MinimumPlotsActive[i].iL1Count > 0)
					int iplots = 0
					If (asIssue.MinimumPlotsActive[i].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsActive[i].BuildingClass, 1, -1, True, True)
					Else
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsActive[i].PlotType, 1, -1, True, True)
					EndIf
					If (iplots < asIssue.MinimumPlotsActive[i].iL1Count)
						bCanPrint = False
					EndIf
				EndIf
				If (bCanPrint && asIssue.MinimumPlotsActive[i].iL2Count > 0)
					int iplots = 0
					If (asIssue.MinimumPlotsActive[i].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsActive[i].BuildingClass, 2, -1, True, True)
					Else
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsActive[i].PlotType, 2, -1, True, True)
					EndIf
					If (iplots < asIssue.MinimumPlotsActive[i].iL2Count)
						bCanPrint = False
					EndIf
				EndIf
				If (bCanPrint && asIssue.MinimumPlotsActive[i].iL3Count > 0)
					int iplots = 0
					If (asIssue.MinimumPlotsActive[i].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsActive[i].BuildingClass, 3, -1, True, True)
					Else
						iplots = SettlementManager.GetPlotCount(asIssue.MinimumPlotsActive[i].PlotType, 3, -1, True, True)
					EndIf
					If (iplots < asIssue.MinimumPlotsActive[i].iL3Count)
						bCanPrint = False
					EndIf
				EndIf
				i += 1
			EndWhile
		EndIf
		If (bCanPrint && asIssue.MustOwnSettlements != None && bCanPrint)
			int i = 0
			While (i < asIssue.MustOwnSettlements.length)
				ObjectReference thisRef = workshopframework:library:utilityfunctions.GetUniversalForm(asIssue.MustOwnSettlements[i]) as ObjectReference
				If (thisRef != None)
					workshopscript thisWorkshop = thisRef as workshopscript
					If (bOwnedSettlementsCheckedAlready)
						If (OwnedSettlements.find(thisWorkshop, 0) < 0)
							bCanPrint = False
						EndIf
					ElseIf (thisWorkshop == None || !thisWorkshop.OwnedByPlayer)
						bCanPrint = False
					EndIf
				Else
					bCanPrint = False
				EndIf
				i += 1
			EndWhile
		EndIf
		If (bCanPrint && asIssue.ClearedLocations != None)
			int i = 0
			While (i < asIssue.ClearedLocations.length)
				Location thisLocation = workshopframework:library:utilityfunctions.GetUniversalForm(asIssue.ClearedLocations[i]) as Location
				If (thisLocation != None)
					If (thisLocation == None || !thisLocation.HasEverBeenCleared())
						bCanPrint = False
					Else
						Self.RegisterForRemoteEvent(thisLocation as ScriptObject, "OnLocationCleared")
					EndIf
				Else
					bCanPrint = False
				EndIf
				i += 1
			EndWhile
		EndIf
		If (bCanPrint && asIssue.MinimumCityPlansAtEachLevel != None)
			simsettlementsv2:objectreferences:settlementdata[] SettlementDataStores = SettlementManager.SettlementDataStores
			int[] iLevelCounts = new int[128]
			int i = 0
			While (i < SettlementDataStores.length)
				int iCurrentLevel = SettlementDataStores[i].iCityLevel
				If (iCurrentLevel >= 0)
					iLevelCounts[iCurrentLevel] = iLevelCounts[iCurrentLevel] + 1
				EndIf
				i += 1
			EndWhile
			i = 0
			While (i < asIssue.MinimumCityPlansAtEachLevel.length && bCanPrint)
				If (iLevelCounts[i] < asIssue.MinimumCityPlansAtEachLevel[i])
					bCanPrint = False
				EndIf
				i += 1
			EndWhile
		EndIf
	EndIf
	return bCanPrint
EndFunction

Function CleanupMagazineBuildingsArray()
	int iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[BreweryManager]: Unable to get lock!", 2, False)
		return 
	EndIf
	int I = 0
	While (I < MagazineBuildings.length)
		If (MagazineBuildings[I].GetState() == "Destroyed" || !Self.IsMagazineBuilding(MagazineBuildings[I] as ObjectReference))
			MagazineBuildings[I] = None
		EndIf
		I += 1
	EndWhile
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[BreweryManager]: Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
EndFunction
