;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\MuseumManager.psc
Modified : 2021-02-16 13:55:08
Compiled : 2021-02-16 13:55:15
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:Quests:MuseumManager extends WorkshopFramework:Library:SlaveQuest

;-- Properties --------------------------------------
Group Aliases
	ReferenceAlias Property PlaqueAlias Auto Const mandatory
	ReferenceAlias Property NoTitlePlaqueAlias Auto Const mandatory
EndGroup

Group CheckForms
	workshopframework:library:datastructures#universalform Property MarineArmorBodyEF Auto Const mandatory
	workshopframework:library:datastructures#universalform Property MarineArmorHelmetEF Auto Const mandatory
	workshopframework:library:datastructures#universalform Property MarineArmorLegLeftEF Auto Const mandatory
	workshopframework:library:datastructures#universalform Property MarineArmorLegRightEF Auto Const mandatory
	workshopframework:library:datastructures#universalform Property MarineArmorArmLeftEF Auto Const mandatory
	workshopframework:library:datastructures#universalform Property MarineArmorArmRightEF Auto Const mandatory
	workshopframework:library:datastructures#universalform Property InquisitorQuestEF Auto Const mandatory
	workshopframework:library:datastructures#universalform Property NucleusQuestEF Auto Const mandatory
	workshopframework:library:datastructures#universalform Property TektusEF Auto Const mandatory
	workshopframework:library:datastructures#universalform Property TektusSynthEF Auto Const mandatory
	workshopframework:library:datastructures#universalform Property VimRedEF Auto Const mandatory
	workshopframework:library:datastructures#universalform Property VimGreenEF Auto Const mandatory
	workshopframework:library:datastructures#universalform Property BowlingBallEF Auto Const mandatory
EndGroup

int Property iMarineArmorAquiredStage = 100 Auto hidden
int Property iCOA02Stage = 200 Auto hidden
int Property iCOA03Stage = 300 Auto hidden
int Property iVimStage = 400 Auto hidden
int Property iStrikerStage = 500 Auto hidden
float Property InstalledVersion = 0 Auto hidden

;-- Variables ---------------------------------------
int iRequiredStrikerKills = 50
int HandleLocationChangeTimerID = 1
int iStrikerKillCounter = 0
int HandleGameLoadTimerID = 0

;-- Functions ---------------------------------------

Event Quest.OnStageSet(Quest akSenderRef, int aiStageID, int aiItemID)
	Self.CheckForQuestCompletions()
EndEvent

Event ObjectReference.OnItemAdded(ObjectReference akSenderRef, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	Self.CheckForQuestCompletions()
EndEvent

Event Actor.OnKill(Actor akKiller, Actor akVictim)
	If (akKiller == PlayerRef)
		Keyword BowlingBallModKeyword = workshopframework:library:utilityfunctions.GetUniversalForm(BowlingBallEF) as Keyword
		If (akKiller.WornHasKeyword(BowlingBallModKeyword))
			iStrikerKillCounter += 1
			If (iStrikerKillCounter >= iRequiredStrikerKills)
				Self.SetStage(iStrikerStage)
				Self.UnregisterForRemoteEvent(PlayerRef as ScriptObject, "OnKill")
			EndIf
		EndIf
	EndIf
EndEvent

Event Actor.OnDeath(Actor akDeadActor, Actor akKiller)
	Self.CheckForQuestCompletions()
EndEvent

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
	Self.CheckForQuestCompletions()
EndFunction

Function CheckForQuestCompletions()
	If (!Game.IsPluginInstalled("DLCCoast.esm"))
		return 
	EndIf
	If (!Self.GetStageDone(iMarineArmorAquiredStage))
		Form MarineArmor_ArmLeft = workshopframework:library:utilityfunctions.GetUniversalForm(MarineArmorArmLeftEF)
		Form MarineArmor_ArmRight = workshopframework:library:utilityfunctions.GetUniversalForm(MarineArmorArmRightEF)
		Form MarineArmor_Body = workshopframework:library:utilityfunctions.GetUniversalForm(MarineArmorBodyEF)
		Form MarineArmor_Helmet = workshopframework:library:utilityfunctions.GetUniversalForm(MarineArmorHelmetEF)
		Form MarineArmor_LegLeft = workshopframework:library:utilityfunctions.GetUniversalForm(MarineArmorLegLeftEF)
		Form MarineArmor_LegRight = workshopframework:library:utilityfunctions.GetUniversalForm(MarineArmorLegRightEF)
		If (PlayerRef.GetItemCount(MarineArmor_ArmLeft) > 0 && PlayerRef.GetItemCount(MarineArmor_ArmRight) > 0 && PlayerRef.GetItemCount(MarineArmor_Body) > 0 && PlayerRef.GetItemCount(MarineArmor_Helmet) > 0 && PlayerRef.GetItemCount(MarineArmor_LegRight) > 0 && PlayerRef.GetItemCount(MarineArmor_LegLeft) > 0)
			Self.SetStage(iMarineArmorAquiredStage)
			Self.RemoveInventoryEventFilter(MarineArmor_ArmLeft)
			Self.RemoveInventoryEventFilter(MarineArmor_ArmRight)
			Self.RemoveInventoryEventFilter(MarineArmor_Body)
			Self.RemoveInventoryEventFilter(MarineArmor_Helmet)
			Self.RemoveInventoryEventFilter(MarineArmor_LegRight)
			Self.RemoveInventoryEventFilter(MarineArmor_LegLeft)
			Self.UnregisterForRemoteEvent(PlayerRef as ScriptObject, "OnItemAdded")
		Else
			Self.AddInventoryEventFilter(MarineArmor_ArmLeft)
			Self.AddInventoryEventFilter(MarineArmor_ArmRight)
			Self.AddInventoryEventFilter(MarineArmor_Body)
			Self.AddInventoryEventFilter(MarineArmor_Helmet)
			Self.AddInventoryEventFilter(MarineArmor_LegRight)
			Self.AddInventoryEventFilter(MarineArmor_LegLeft)
			Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnItemAdded")
		EndIf
	EndIf
	If (!Self.GetStageDone(iCOA02Stage))
		Quest InquisitorQuest = workshopframework:library:utilityfunctions.GetUniversalForm(InquisitorQuestEF) as Quest
		If (InquisitorQuest.GetStageDone(300) || InquisitorQuest.GetStageDone(310))
			Self.SetStage(iCOA02Stage)
			Self.UnregisterForRemoteEvent(InquisitorQuest as ScriptObject, "OnStageSet")
		Else
			Self.RegisterForRemoteEvent(InquisitorQuest as ScriptObject, "OnStageSet")
		EndIf
	EndIf
	If (!Self.GetStageDone(iCOA03Stage))
		Quest NucleusQuest = workshopframework:library:utilityfunctions.GetUniversalForm(NucleusQuestEF) as Quest
		Actor Tektus = workshopframework:library:utilityfunctions.GetUniversalForm(TektusEF) as Actor
		Actor TektusSynth = workshopframework:library:utilityfunctions.GetUniversalForm(TektusSynthEF) as Actor
		If (NucleusQuest.GetStageDone(250) || Tektus.IsDead() || TektusSynth.IsDead())
			Self.SetStage(iCOA03Stage)
			Self.UnregisterForRemoteEvent(Tektus as ScriptObject, "OnDeath")
			Self.UnregisterForRemoteEvent(TektusSynth as ScriptObject, "OnDeath")
			Self.UnregisterForRemoteEvent(NucleusQuest as ScriptObject, "OnStageSet")
		Else
			Self.RegisterForRemoteEvent(NucleusQuest as ScriptObject, "OnStageSet")
			Self.RegisterForRemoteEvent(Tektus as ScriptObject, "OnDeath")
			Self.RegisterForRemoteEvent(TektusSynth as ScriptObject, "OnDeath")
		EndIf
	EndIf
	If (!Self.GetStageDone(iVimStage))
		GlobalVariable VimRed = workshopframework:library:utilityfunctions.GetUniversalForm(VimRedEF) as GlobalVariable
		GlobalVariable VimGreen = workshopframework:library:utilityfunctions.GetUniversalForm(VimGreenEF) as GlobalVariable
		If (VimRed.GetValue() == 1 as float && VimGreen.GetValue() == 1 as float)
			Self.SetStage(iVimStage)
		EndIf
	EndIf
	If (!Self.GetStageDone(iStrikerStage))
		If (iStrikerKillCounter >= iRequiredStrikerKills)
			Self.SetStage(iStrikerStage)
			Self.UnregisterForRemoteEvent(PlayerRef as ScriptObject, "OnKill")
		Else
			Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnKill")
		EndIf
	EndIf
EndFunction
