;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\NPC_AssignmentManager.psc
Modified : 2021-03-12 16:36:22
Compiled : 2021-03-12 16:36:40
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:NPC_AssignmentManager extends WorkshopFramework:Library:SlaveQuest
{ Handles NPC assignment related activity. }

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const mandatory
	workshopframework:workshopresourcemanager Property ResourceManager Auto Const mandatory
	workshopframework:npcmanager Property WSFW_NPCManager Auto Const mandatory
	workshopframework:mainquest Property WSFW_Main Auto Const mandatory
	workshopframework:settlementlayoutmanager Property SettlementLayoutManager Auto Const mandatory
	simsettlementsv2:quests:optionsmanager Property OptionsManager Auto Const mandatory
	simsettlementsv2:quests:settlementmanager Property SettlementManager Auto Const mandatory
	simsettlementsv2:quests:cameramanager Property CameraManager Auto Const mandatory
EndGroup

Group ActorValues
	Form[] Property DefaultAssignmentPriority Auto Const mandatory
	{ The resources to prioritize when searching for plots to assign first }
	ActorValue Property BedAV Auto Const mandatory
EndGroup

Group Aliases
	RefCollectionAlias Property ObjectsAwaitingAssignment Auto Const mandatory
	ReferenceAlias[] Property KidnappedAliases Auto Const
	{ caravanActor Alias on quest MinRadiantOwned03ChangeLocOnly and KidnappedActor on quest MinRecruit02 }
	RefCollectionAlias Property BoundSettlers Auto Const mandatory
EndGroup

Group Assets
	Sound[] Property TownMeetingSounds Auto Const mandatory
	{ Sounds to play during the town meeting fade }
	Static Property PositionHelper Auto Const mandatory
	GlobalVariable Property gGameHour Auto Const mandatory
	Race Property HumanRace Auto Const mandatory
	{ Autofill }
	Race Property GhoulRace Auto Const mandatory
	{ Autofill }
	Faction Property PlayerFriendFaction Auto Const mandatory
	{ Autofill }
	Faction Property WorkshopNPCFaction Auto Const mandatory
	{ Autofill }
	Faction Property MinRadiantDialogueThankful Auto Const mandatory
	{ Autofill }
	Form Property BoundFurnitureForm Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property WSFW_DoNotAutoassign Auto Const mandatory
	Keyword Property EventKeyword_TownMeeting Auto Const mandatory
	Keyword Property WorkshopWorkObject Auto Const mandatory
	Keyword Property PlotTypeKeyword Auto Const mandatory
	Keyword Property OutpostKeyword Auto Const mandatory
	Keyword Property VassalKeyword Auto Const mandatory
	Keyword Property RelaxationClassKeyword Auto Const mandatory
	Keyword Property ManagementDeskKeyword Auto Const mandatory
	Keyword Property ActorTypeRobotKeyword Auto Const mandatory
	Keyword Property LinkCustom01 Auto Const mandatory
	{ Autofill }
	Keyword Property PlotSpawnedKeyword Auto Const mandatory
	Keyword Property StageItemLinkKeyword Auto Const mandatory
	Keyword Property HQLocationKeyword Auto Const mandatory
EndGroup

Group Keywords_AssignmentTypes
	Keyword Property AssignmentType_Home Auto Const mandatory
	Keyword Property AssignmentType_Job Auto Const mandatory
	Keyword Property AssignmentType_Leisure Auto Const mandatory
	Keyword Property SecondaryAssignmentMarkerLinkKeyword Auto Const mandatory
	Keyword Property WorkshopItemKeyword Auto Const mandatory
EndGroup

Group Messages
	Message Property Menu_TownMeeting Auto Const mandatory
	Message Property ClosePipboyToRunTool Auto Const mandatory
	Message Property Confirm_Unassign Auto Const mandatory
	Message Property NotInSettlementMessage Auto Const mandatory
	Message Property MeetingInProgressMessage Auto Const mandatory
	Message Property SummoningNrOfSettlersMessage Auto Const mandatory
	Message Property NoSettlersToSummonMessage Auto Const mandatory
EndGroup

Group Settings
	GlobalVariable Property gSettings_AutoAssignment Auto Const mandatory
	GlobalVariable Property gSettings_FollowTownMeeting Auto Const mandatory
	float Property fTownMeetingFadeTime = 1.5 Auto Const
	{ Time to fade the screen when gathering settlers for a town meeting }
EndGroup


;-- Variables ---------------------------------------
bool bTownMeetingInProgress = False
bool[] bEnterSettlementBlock
bool bAutoAssignmentBlock = False
bool[] bExitSettlementBlock
string sAutoAssignmentLog = "SS2AutoAssignment"
float fTimerLength_AutoAssignment = 11
int iTimerID_AutoAssignment = 201
int iTimerID_TownMeetingFade = 202

;-- Functions ---------------------------------------

Function UpdateAssignmentKeywordsAndJobTitle(Actor akActor)
	If (!akActor.Is3dLoaded())
		return 
	EndIf
	workshopscript thisWorkshop = akActor.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	ObjectReference[] kAssignedRefs = thisWorkshop.GetWorkshopOwnedObjects(akActor)
	Self.ApplyAssignmentKeywordsFromOwnedObjects(akActor, kAssignedRefs)
	Self.ApplyJobTitleFromOwnedObjects(akActor, kAssignedRefs)
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
	Self.StartTimerGameTime(fTimerLength_AutoAssignment, iTimerID_AutoAssignment)
	Self.RegisterForCustomEvent(WSFW_Main as ScriptObject, "workshopframework:mainquest_PlayerEnteredSettlement")
	Self.RegisterForCustomEvent(WSFW_Main as ScriptObject, "workshopframework:mainquest_PlayerExitedSettlement")
	Self.RegisterForCustomEvent(SettlementLayoutManager as ScriptObject, "workshopframework:settlementlayoutmanager_SettlementLayoutBuilt")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopAddActor")
EndFunction

Event WorkshopParentScript.WorkshopAddActor(workshopparentscript akSender, var[] akArgs)
	Utility.Wait(2)
	If (Self.ShouldBeAutoassigned(akArgs[0] as Actor))
		Self.HandleAutoAssignmentForNPC(akArgs[0] as Actor, WorkshopParent.GetWorkshop(akArgs[1] as int), False)
	EndIf
EndEvent

Event ObjectReference.OnUnload(ObjectReference akSender)
	workshopscript thisWorkshop = akSender as workshopscript
	If (thisWorkshop)
		Self.HandlePlayerExitedSettlement(thisWorkshop)
	EndIf
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnUnload")
EndEvent

Actor[] Function GetSettlers(workshopscript akWorkshopRef, bool abIncludePermanent)
	simsettlementsv2:quests:mi:grabnpcs NPCGrabber = (Self as Quest) as simsettlementsv2:quests:mi:grabnpcs
	return NPCGrabber.GetSettlers(akWorkshopRef, abIncludePermanent)
EndFunction

Function CallTownMeeting(workshopscript akWorkshopRef, ObjectReference akDestinationTarget, bool abFadeToBlack)
	If (!akWorkshopRef)
		akWorkshopRef = workshopframework:workshopfunctions.GetNearestWorkshop(PlayerRef as ObjectReference)
		If (!akWorkshopRef || !PlayerRef.IsWithinBuildableArea(akWorkshopRef as ObjectReference))
			NotInSettlementMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
			return 
		EndIf
	EndIf
	If (bTownMeetingInProgress)
		MeetingInProgressMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		return 
	EndIf
	bTownMeetingInProgress = True
	If (!akDestinationTarget)
		If (gSettings_FollowTownMeeting.GetValue() == 1 as float)
			akDestinationTarget = PlayerRef as ObjectReference
		Else
			akDestinationTarget = PlayerRef.PlaceAtMe(PositionHelper as Form, 1, False, False, True)
		EndIf
	EndIf
	Actor[] WorkshopActors = Self.GetSettlers(akWorkshopRef, True)
	int I = 0
	If (abFadeToBlack)
		Self.TownMeetingFade(fTownMeetingFadeTime, 1.2)
	EndIf
	While (I < WorkshopActors.length)
		bool bKidnapped = False
		int j = 0
		While (j < KidnappedAliases.length && !bKidnapped)
			If (KidnappedAliases[j].GetRef() == WorkshopActors[I] as ObjectReference)
				bKidnapped = True
			EndIf
			j += 1
		EndWhile
		If (!bKidnapped && (WorkshopActors[I] as workshopnpcscript).bCommandable)
			WorkshopActors[I].MoveTo(akDestinationTarget, 0, 0, 0, True)
			WorkshopActors[I].MoveToNearestNavmeshLocation()
		EndIf
		I += 1
	EndWhile
	If (WorkshopActors.length > 0)
		EventKeyword_TownMeeting.SendStoryEvent(akDestinationTarget.GetCurrentLocation(), akDestinationTarget, None, 0, 0)
	EndIf
	bTownMeetingInProgress = False
EndFunction

Function ShowTownMeetingMenu()
	int iConfirm = 0
	bool bTownmeeting = False
	iConfirm = Menu_TownMeeting.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	If (iConfirm == 0)
		return 
	ElseIf (iConfirm == 1)
		If (Utility.IsInMenuMode())
			ClosePipboyToRunTool.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
			Utility.Wait(0.1)
		EndIf
		Self.TownMeetingFade(fTownMeetingFadeTime * 2 as float, 1.2)
		workshopscript thisWorkshop = workshopframework:workshopfunctions.GetNearestWorkshop(PlayerRef as ObjectReference)
		If (thisWorkshop != None)
			Self.IdleAllActors(thisWorkshop)
			ObjectReference[] kResourceObjects = thisWorkshop.GetWorkshopResourceObjects(None, 0)
			int I = 0
			While (I < kResourceObjects.length)
				If (kResourceObjects[I].HasKeyword(WorkshopWorkObject) && !kResourceObjects[I].HasKeyword(WSFW_DoNotAutoassign) && !kResourceObjects[I].HasKeyword(PlotSpawnedKeyword))
					ObjectsAwaitingAssignment.AddRef(kResourceObjects[I])
				EndIf
				I += 1
			EndWhile
			Self.HandleAutoAssignmentForWorkshop(thisWorkshop, False)
		EndIf
	ElseIf (iConfirm == 2)
		If (Utility.IsInMenuMode())
			ClosePipboyToRunTool.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
			Utility.Wait(0.1)
		EndIf
		Self.CallTownMeeting(None, None, True)
	ElseIf (iConfirm == 3)
		Self.SummonSettlersByStatus(False, True, False)
	ElseIf (iConfirm == 4)
		Self.SummonSettlersByStatus(True, False, False)
	ElseIf (iConfirm == 5)
		Self.SummonSettlersByStatus(False, False, True)
	ElseIf (iConfirm == 6)
		iConfirm = Confirm_Unassign.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		If (iConfirm > 0)
			If (Utility.IsInMenuMode())
				ClosePipboyToRunTool.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
				Utility.Wait(0.1)
			EndIf
			If (iConfirm == 2)
				Self.CallTownMeeting(None, None, True)
			Else
				Self.TownMeetingFade(fTownMeetingFadeTime, 1.2)
			EndIf
			workshopscript thisworkshop = workshopframework:workshopfunctions.GetNearestWorkshop(PlayerRef as ObjectReference)
			Self.ClearAllAssignments(thisworkshop)
		EndIf
	EndIf
EndFunction

Event ObjectReference.OnWorkshopObjectPlaced(ObjectReference akWorkshop, ObjectReference akBuiltRef)
	If (!akBuiltRef.HasKeyword(PlotTypeKeyword) && akBuiltRef.HasKeyword(WorkshopWorkObject))
		ObjectsAwaitingAssignment.AddRef(akBuiltRef)
	EndIf
EndEvent

Function ApplyJobTitleFromOwnedObjects(Actor akActor, ObjectReference[] akAssignedRefs)
	bool bTitleSet = False
	workshopscript assignedWorkshop = akActor.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	bool bIsHQWorker = False
	If (HQLocationKeyword != None)
		bIsHQWorker = assignedWorkshop.GetCurrentLocation().GetKeywordData(HQLocationKeyword) > 0 as float
	EndIf
	If (bIsHQWorker)
		bTitleSet = True
	Else
		int I = 0
		While (I < akAssignedRefs.length && !bTitleSet)
			simsettlementsv2:objectreferences:simplot asPlot = akAssignedRefs[I] as simsettlementsv2:objectreferences:simplot
			If (!asPlot)
				asPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(akAssignedRefs[I], SecondaryAssignmentMarkerLinkKeyword)
			EndIf
			If (asPlot)
				bTitleSet = asPlot.SetJobTitle(akActor, -1)
			EndIf
			I += 1
		EndWhile
	EndIf
	If (!bTitleSet)
		akActor.SetActivateTextOverride(None)
	EndIf
EndFunction

Event ObjectReference.OnCellLoad(ObjectReference akSenderRef)
	If (akSenderRef as workshopscript)
		bool bRemainingBoundSettlersHere = False
		int I = 0
		While (I < BoundSettlers.GetCount())
			Actor thisActor = BoundSettlers.GetAt(I) as Actor
			Self.BindNPC(thisActor)
			If (!bRemainingBoundSettlersHere && thisActor.GetLinkedRef(WorkshopItemKeyword) == akSenderRef)
				bRemainingBoundSettlersHere = True
			EndIf
			I += 1
		EndWhile
		If (!bRemainingBoundSettlersHere)
			Self.UnregisterForRemoteEvent(akSenderRef as ScriptObject, "OnLoad")
		EndIf
	EndIf
EndEvent

Function UnbindAllSettlers(workshopscript akWorkshopRef, bool abRemainCaptives)
	int I = BoundSettlers.GetCount()
	While (I > 0)
		int iIndex = I - 1
		Actor thisActor = BoundSettlers.GetAt(iIndex) as Actor
		If (thisActor.GetLinkedRef(WorkshopItemKeyword) == akWorkshopRef as ObjectReference)
			Self.UnbindNPC(thisActor)
			If (!abRemainCaptives && workshopframework:workshopfunctions.CountsForPopulation(thisActor))
				thisActor.AddToFaction(MinRadiantDialogueThankful)
			EndIf
			thisActor.AddToFaction(WorkshopNPCFaction)
			thisActor.RemoveFromFaction(PlayerFriendFaction)
			workshopnpcscript asWorkshopNPC = thisActor as workshopnpcscript
			If (akWorkshopRef.SettlementOwnershipFaction as bool && akWorkshopRef.UseOwnershipFaction && (!asWorkshopNPC || asWorkshopNPC.bApplyWorkshopOwnerFaction))
				If (asWorkshopNPC as bool && asWorkshopNPC.bCountsForPopulation)
					thisActor.SetCrimeFaction(akWorkshopRef.SettlementOwnershipFaction)
				Else
					thisActor.SetFactionOwner(akWorkshopRef.SettlementOwnershipFaction, False)
				EndIf
			EndIf
		EndIf
		I -= 1
	EndWhile
EndFunction

Function UpdateJobTitle(Actor akActor)
	If (!akActor.Is3dLoaded())
		return 
	EndIf
	workshopscript thisWorkshop = akActor.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	ObjectReference[] kAssignedRefs = thisWorkshop.GetWorkshopOwnedObjects(akActor)
	Self.ApplyJobTitleFromOwnedObjects(akActor, kAssignedRefs)
EndFunction

Function SummonSettlersByStatus(bool abSelectHomeless, bool abSelectUnemployed, bool abSelectHobbyless)
	If (Utility.IsInMenuMode())
		ClosePipboyToRunTool.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		Utility.Wait(0.1)
	EndIf
	workshopscript akWorkshopRef = workshopframework:workshopfunctions.GetNearestWorkshop(PlayerRef as ObjectReference)
	ObjectReference akDestinationTarget = PlayerRef as ObjectReference
	If (!akWorkshopRef)
		akWorkshopRef = workshopframework:workshopfunctions.GetNearestWorkshop(PlayerRef as ObjectReference)
		If (!akWorkshopRef || !PlayerRef.IsWithinBuildableArea(akWorkshopRef as ObjectReference))
			NotInSettlementMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
			return 
		EndIf
	EndIf
	If (bTownMeetingInProgress)
		MeetingInProgressMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		return 
	EndIf
	bTownMeetingInProgress = True
	Self.TownMeetingFade(fTownMeetingFadeTime, 1.2)
	int numSettlers = 0
	Actor[] WorkshopActors = Self.GetSettlers(akWorkshopRef, True)
	int I = 0
	While (I < WorkshopActors.length)
		bool bKidnapped = False
		int j = 0
		Actor curActor = WorkshopActors[I]
		While (j < KidnappedAliases.length && !bKidnapped)
			If (KidnappedAliases[j].GetRef() == curActor as ObjectReference)
				bKidnapped = True
			EndIf
			j += 1
		EndWhile
		If (!bKidnapped && (curActor as workshopnpcscript).bCommandable)
			bool bIsRobot = curActor.HasKeyword(ActorTypeRobotKeyword)
			bool bNeedsHome = !curActor.HasKeyword(AssignmentType_Home) && !bIsRobot
			bool bNeedsJob = !curActor.HasKeyword(AssignmentType_Job) && !workshopframework:workshopfunctions.IsCaravanNPC(curActor, None)
			bool bNeedsLeisure = !curActor.HasKeyword(AssignmentType_Leisure) && !bIsRobot
			If (abSelectHomeless && bNeedsHome || abSelectUnemployed && bNeedsJob || abSelectHobbyless && bNeedsLeisure)
				numSettlers += 1
				curActor.MoveTo(akDestinationTarget, 0, 0, 0, True)
				curActor.MoveToNearestNavmeshLocation()
			EndIf
		EndIf
		I += 1
	EndWhile
	bTownMeetingInProgress = False
	If (numSettlers > 0)
		SummoningNrOfSettlersMessage.Show(numSettlers as float, 0, 0, 0, 0, 0, 0, 0, 0)
	Else
		NoSettlersToSummonMessage.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	EndIf
EndFunction

Event ObjectReference.OnWorkshopObjectDestroyed(ObjectReference akWorkshop, ObjectReference akDestroyedRef)
	ObjectsAwaitingAssignment.RemoveRef(akDestroyedRef)
EndEvent

Function HandlePlayerExitedSettlement(workshopscript akWorkshopRef)
	If (!akWorkshopRef)
		return 
	EndIf
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	If (!bExitSettlementBlock || bExitSettlementBlock.length < 128)
		bExitSettlementBlock = new bool[128]
	EndIf
	If (bExitSettlementBlock[iWorkshopID])
		return 
	EndIf
	bExitSettlementBlock[iWorkshopID] = True
	bExitSettlementBlock[iWorkshopID] = False
EndFunction

Function HandleAutoAssignment()
	If (bAutoAssignmentBlock)
		return 
	EndIf
	bAutoAssignmentBlock = True
	int I = 0
	workshopscript[] kWorkshopRefs = ResourceManager.Workshops
	int iWorkshopCount = kWorkshopRefs.length
	While (I < iWorkshopCount)
		If (OptionsManager.GetSettingValue(gSettings_AutoAssignment, kWorkshopRefs[I].GetWorkshopID()) == 1 as float)
			Self.HandleAutoAssignmentForWorkshop(kWorkshopRefs[I], True)
		EndIf
		I += 1
	EndWhile
	bAutoAssignmentBlock = False
EndFunction

Function HandleAutoAssignmentForNPC(Actor akActorRef, workshopscript akWorkshopRef, bool abUpdateAssignmentKeywords)
	If (!akWorkshopRef)
		akWorkshopRef = ResourceManager.Workshops[workshopframework:workshopfunctions.GetWorkshopID(akActorRef as ObjectReference)]
		If (!akWorkshopRef)
			return 
		EndIf
	EndIf
	If (akActorRef.GetLinkedRef(WorkshopItemKeyword) != akWorkshopRef as ObjectReference)
		return 
	EndIf
	If (akActorRef.HasKeyword(WSFW_DoNotAutoassign))
		return 
	EndIf
	If (abUpdateAssignmentKeywords)
		Self.UpdateAssignmentKeywords(akActorRef)
	EndIf
	bool bIsRobot = akActorRef.HasKeyword(ActorTypeRobotKeyword)
	bool bNeedsHome = !akActorRef.HasKeyword(AssignmentType_Home) && !bIsRobot
	bool bNeedsJob = !akActorRef.HasKeyword(AssignmentType_Job) && !workshopframework:workshopfunctions.IsCaravanNPC(akActorRef, None)
	bool bNeedsLeisure = !akActorRef.HasKeyword(AssignmentType_Leisure) && !bIsRobot
	workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "Actor " + akActorRef as string + " assignments: bNeedsHome = " + bNeedsHome as string + ", bNeedsJob = " + bNeedsJob as string + ", bNeedsLeisure = " + bNeedsLeisure as string, 0, False)
	If (bNeedsHome || bNeedsJob || bNeedsLeisure)
		simsettlementsv2:objectreferences:simplot[] kPlotRefs = new simsettlementsv2:objectreferences:simplot[0]
		workshopobjectscript[] kBedRefs = new workshopobjectscript[0]
		workshopobjectscript[] kJobRefs = new workshopobjectscript[0]
		int I = 0
		ObjectReference[] kClearOut = new ObjectReference[0]
		int iNPCWorkshopID = workshopframework:workshopfunctions.GetWorkshopID(akActorRef as ObjectReference)
		workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "Actor " + akActorRef as string + " workshop ID = " + iNPCWorkshopID as string, 0, False)
		While (I < ObjectsAwaitingAssignment.GetCount())
			workshopobjectscript thisObject = ObjectsAwaitingAssignment.GetAt(I) as workshopobjectscript
			If (!thisObject || thisObject.HasKeyword(WSFW_DoNotAutoassign))
				workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "[NPCManager] >>>>>>>>>>>> Removing object from autoassignment queue " + thisObject as string + " Not a workshopobjectscript type.<<<<<<<<<<", 0, False)
				kClearOut.add(thisObject as ObjectReference, 1)
			ElseIf (thisObject.workshopID == iNPCWorkshopID)
				simsettlementsv2:objectreferences:simplot asPlot = thisObject as simsettlementsv2:objectreferences:simplot
				If (asPlot)
					simsettlementsv2:miscobjects:plotconfiguration thisPlotConfig = asPlot.GetPlotConfig()
					If (asPlot.GetCurrentLevelPlan() != None && asPlot.iOccupants >= asPlot.GetMaxOccupants())
						workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "[NPCManager] >>>>>>>>>>>> Removing object from autoassignment queue " + thisObject as string + ": Plot has max occupants.<<<<<<<<<<", 0, False)
						kClearOut.add(asPlot as ObjectReference, 1)
					Else
						bool bIsHome = thisPlotConfig.AssignmentTypeKeywords.find(AssignmentType_Home, 0) >= 0
						bool bIsJob = thisPlotConfig.AssignmentTypeKeywords.find(AssignmentType_Job, 0) >= 0
						bool bIsLeisure = thisPlotConfig.AssignmentTypeKeywords.find(AssignmentType_Leisure, 0) >= 0
						If ((!bIsHome || bNeedsHome) && (!bIsJob || bNeedsJob) && (!bIsLeisure || bNeedsLeisure))
							kPlotRefs.add(asPlot, 1)
						Else
							workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, ">>>>>>>>>>>> Plot " + thisObject as string + ": does not match " + akActorRef as string + " needs, skipping.<<<<<<<<<<", 0, False)
						EndIf
					EndIf
				Else
					bool bIsBed = thisObject.IsBed()
					If (bIsBed && thisObject.GetActorRefOwner() != None)
						workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "[NPCManager] >>>>>>>>>>>> Removing bed from autoassignment queue " + thisObject as string + ": Already assigned.<<<<<<<<<<", 0, False)
						kClearOut.add(thisObject as ObjectReference, 1)
					ElseIf (!bIsBed && thisObject.IsActorAssigned())
						workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "[NPCManager] >>>>>>>>>>>> Removing object from autoassignment queue " + thisObject as string + ": Already assigned.<<<<<<<<<<", 0, False)
						kClearOut.add(thisObject as ObjectReference, 1)
					ElseIf (bIsBed && bNeedsHome)
						kBedRefs.add(thisObject, 1)
					ElseIf (bNeedsJob && !bIsBed)
						kJobRefs.add(thisObject, 1)
					EndIf
				EndIf
			EndIf
			I += 1
		EndWhile
		workshopframework:library:datastructures#resourceshortage[] ShortResources = akWorkshopRef.ShortResources
		If (kPlotRefs.length > 0)
			simsettlementsv2:objectreferences:simplot[] kSortedPlots = new simsettlementsv2:objectreferences:simplot[0]
			simsettlementsv2:objectreferences:simplot[] kUnsortedPlots = new simsettlementsv2:objectreferences:simplot[0]
			I = 0
			While (I < kPlotRefs.length)
				bool bSorted = False
				int j = 0
				While (j < ShortResources.length && !bSorted)
					If (kSortedPlots.find(kPlotRefs[I], 0) < 0 && kPlotRefs[I].GetProducedResourceAmount(ShortResources[j].ResourceAV, True) > 0 as float)
						kSortedPlots.add(kPlotRefs[I], 1)
						bSorted = True
					EndIf
					j += 1
				EndWhile
				If (!bSorted)
					kUnsortedPlots.add(kPlotRefs[I], 1)
				EndIf
				I += 1
			EndWhile
			I = 0
			While (I < DefaultAssignmentPriority.length)
				int j = 0
				While (j < kUnsortedPlots.length)
					If (kSortedPlots.find(kUnsortedPlots[j], 0) < 0 && kUnsortedPlots[j].GetPlotConfig() as Form == DefaultAssignmentPriority[I])
						kSortedPlots.add(kUnsortedPlots[j], 1)
					EndIf
					j += 1
				EndWhile
				I += 1
			EndWhile
			int j = 0
			While (j < kUnsortedPlots.length)
				If (kSortedPlots.find(kUnsortedPlots[j], 0) < 0)
					kSortedPlots.add(kUnsortedPlots[j], 1)
				EndIf
				j += 1
			EndWhile
			If (kSortedPlots.length)
				I = 0
				While (I < kSortedPlots.length && (bNeedsHome || bNeedsJob || bNeedsLeisure))
					bool bishome = False
					bool bisjob = False
					bool bisleisure = False
					simsettlementsv2:miscobjects:plotconfiguration thisplotconfig = kSortedPlots[I].GetPlotConfig()
					If (thisplotconfig.AssignmentTypeKeywords.find(AssignmentType_Home, 0) >= 0)
						bishome = True
					EndIf
					If (thisplotconfig.AssignmentTypeKeywords.find(AssignmentType_Job, 0) >= 0)
						bisjob = True
					EndIf
					If (thisplotconfig.AssignmentTypeKeywords.find(AssignmentType_Leisure, 0) >= 0)
						bisleisure = True
					EndIf
					If (bishome && bNeedsHome || bisjob && bNeedsJob || bisleisure && bNeedsLeisure)
						workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "Attempting to assign " + akActorRef as string + " to " + kSortedPlots[I] as string, 0, False)
						If (kSortedPlots[I].TryToAssignActor(akActorRef, False, 0))
							If (bishome)
								bNeedsHome = False
							EndIf
							If (bisjob)
								bNeedsJob = False
							EndIf
							If (bisleisure)
								bNeedsLeisure = False
							EndIf
						EndIf
					EndIf
					I += 1
				EndWhile
			EndIf
		EndIf
		If (bNeedsHome && kBedRefs.length > 0)
			workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "Actor " + akActorRef as string + " does not have a home. Assigning a regular bed " + kBedRefs[0] as string + ".", 0, False)
			Self.AssignActorToNonPlot(kBedRefs[0], akActorRef)
		EndIf
		If (bNeedsJob && kJobRefs.length > 0)
			workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "Actor " + akActorRef as string + " does not have a job. Assigning a regular job " + kJobRefs[0] as string + ".", 0, False)
			Self.AssignActorToNonPlot(kJobRefs[0], akActorRef)
		EndIf
		If (kClearOut.length > 0)
			I = 0
			While (I < kClearOut.length)
				If (kClearOut[I] != None)
					ObjectsAwaitingAssignment.RemoveRef(kClearOut[I])
				EndIf
				I += 1
			EndWhile
		EndIf
	EndIf
EndFunction

Event WorkshopFramework:MainQuest.PlayerEnteredSettlement(workshopframework:mainquest akQuestRef, var[] akArgs)
	workshopscript kWorkshopRef = akArgs[0] as workshopscript
	bool bPreviouslyUnloaded = akArgs[1] as bool
	If (bPreviouslyUnloaded)
		Self.HandlePlayerEnteredSettlement(kWorkshopRef)
	EndIf
EndEvent

Function HandlePlayerEnteredSettlement(workshopscript akWorkshopRef)
	If (!akWorkshopRef)
		return 
	EndIf
	If (CameraManager.bIsCameraControlled)
		return 
	EndIf
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	If (!bEnterSettlementBlock || bEnterSettlementBlock.length < 128)
		bEnterSettlementBlock = new bool[128]
	EndIf
	If (bEnterSettlementBlock[iWorkshopID])
		return 
	EndIf
	bEnterSettlementBlock[iWorkshopID] = True
	Self.RegisterForRemoteEvent(akWorkshopRef as ScriptObject, "OnWorkshopObjectPlaced")
	Self.RegisterForRemoteEvent(akWorkshopRef as ScriptObject, "OnWorkshopObjectDestroyed")
	bEnterSettlementBlock[iWorkshopID] = False
EndFunction

Function DumpSettlersAndAssignables(workshopscript akWorkshopRef, bool abUnassignedOnly)
	Actor[] kSettlerRefs = Self.GetSettlers(akWorkshopRef, True)
	ObjectReference[] kResourceObjects = akWorkshopRef.GetWorkshopResourceObjects(None, 0)
	string sLogName = sAutoAssignmentLog
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, " =================== Dumping settlers and assignables for " + akWorkshopRef as string, 0, False)
	int I = 0
	While (I < kSettlerRefs.length)
		Self.UpdateAssignmentKeywords(kSettlerRefs[I])
		bool bIsRobot = kSettlerRefs[I].HasKeyword(ActorTypeRobotKeyword)
		bool bNeedsHome = !kSettlerRefs[I].HasKeyword(AssignmentType_Home) && !bIsRobot
		bool bNeedsJob = !kSettlerRefs[I].HasKeyword(AssignmentType_Job) && !workshopframework:workshopfunctions.IsCaravanNPC(kSettlerRefs[I], None)
		bool bNeedsLeisure = !kSettlerRefs[I].HasKeyword(AssignmentType_Leisure) && !bIsRobot
		If (!abUnassignedOnly || bNeedsHome || bNeedsJob || bNeedsLeisure)
			workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, " -- Settler: " + kSettlerRefs[I] as string + ", bNeedsHome: " + bNeedsHome as string + ", bNeedsJob: " + bNeedsJob as string + ", bNeedsLeisure: " + bNeedsLeisure as string, 0, False)
		EndIf
		I += 1
	EndWhile
	I = 0
	While (I < kResourceObjects.length)
		If (kResourceObjects[I].HasKeyword(WorkshopWorkObject) && !kResourceObjects[I].HasKeyword(PlotSpawnedKeyword))
			Actor kOwnerRef = kResourceObjects[I].GetActorRefOwner()
			workshopobjectscript thisObject = kResourceObjects[I] as workshopobjectscript
			If (thisObject != None)
				bool bIsHome = False
				bool bIsJob = False
				bool bIsLeisure = False
				simsettlementsv2:objectreferences:simplot asPlot = thisObject as simsettlementsv2:objectreferences:simplot
				Actor[] kSecondaryOwners = new Actor[0]
				If (asPlot)
					simsettlementsv2:miscobjects:plotconfiguration thisPlotConfig = asPlot.GetPlotConfig()
					bIsHome = thisPlotConfig.AssignmentTypeKeywords.find(AssignmentType_Home, 0) >= 0
					bIsJob = thisPlotConfig.AssignmentTypeKeywords.find(AssignmentType_Job, 0) >= 0
					bIsLeisure = thisPlotConfig.AssignmentTypeKeywords.find(AssignmentType_Leisure, 0) >= 0
					kSecondaryOwners = asPlot.GetAllAssignedNPCs()
				ElseIf (thisObject.IsBed())
					bIsHome = True
				Else
					bIsJob = True
				EndIf
				If (!abUnassignedOnly || kOwnerRef == None || kOwnerRef == PlayerRef)
					string sAssignType = ""
					If (bIsHome)
						sAssignType = "Home/Bed"
					ElseIf (bIsJob)
						sAssignType = "Job"
					ElseIf (bIsLeisure)
						sAssignType = "Leisure"
					EndIf
					workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, " -- " + sAssignType + ": " + kResourceObjects[I] as string + ", Owned By: " + kOwnerRef as string, 0, False)
					If (kSecondaryOwners.length > 1)
						int j = 0
						While (j < kSecondaryOwners.length)
							If (kSecondaryOwners[j] != kOwnerRef)
								workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, " -- " + sAssignType + ": " + kResourceObjects[I] as string + ", (Multi-assigned) Owned By: " + kSecondaryOwners[j] as string, 0, False)
							EndIf
							j += 1
						EndWhile
					EndIf
				EndIf
			EndIf
		EndIf
		I += 1
	EndWhile
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, " =================== Completed dump of settlers and assignables for " + akWorkshopRef as string, 0, False)
EndFunction

Function BindAllSettlers(workshopscript akWorkshopRef, bool abIncludePermanent, Actor[] aExceptions)
	Self.RegisterForRemoteEvent(akWorkshopRef as ScriptObject, "OnCellLoad")
	Actor[] Settlers = Self.GetSettlers(akWorkshopRef, True)
	int I = 0
	While (I < Settlers.length)
		If (aExceptions == None || aExceptions.find(Settlers[I], 0) < 0)
			BoundSettlers.AddRef(Settlers[I] as ObjectReference)
			Race thisRace = Settlers[I].GetRace()
			If (thisRace == HumanRace || thisRace == GhoulRace)
				Self.BindNPC(Settlers[I])
			EndIf
			If (akWorkshopRef.SettlementOwnershipFaction != None)
				Settlers[I].AddToFaction(PlayerFriendFaction)
				Settlers[I].RemoveFromFaction(akWorkshopRef.SettlementOwnershipFaction)
				Settlers[I].RemoveFromFaction(WorkshopNPCFaction)
				Settlers[I].SetCrimeFaction(None)
				Settlers[I].SetFactionOwner(None, False)
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction

Function BindNPC(Actor akActorRef)
	ObjectReference kBoundFurnitureRef = akActorRef.GetLinkedRef(LinkCustom01)
	If (kBoundFurnitureRef == None)
		kBoundFurnitureRef = akActorRef.PlaceAtMe(BoundFurnitureForm, 1, False, False, False)
		If (kBoundFurnitureRef)
			akActorRef.SetLinkedRef(kBoundFurnitureRef, LinkCustom01)
			If (akActorRef.Is3dLoaded())
				akActorRef.EvaluatePackage(False)
			EndIf
		EndIf
	Else
		kBoundFurnitureRef.MoveTo(akActorRef as ObjectReference, 0, 0, 0, True)
		akActorRef.SnapIntoInteraction(kBoundFurnitureRef)
		akActorRef.EvaluatePackage(False)
	EndIf
EndFunction

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iTimerID_AutoAssignment)
		Self.HandleAutoAssignment()
		Self.StartTimerGameTime(fTimerLength_AutoAssignment, iTimerID_AutoAssignment)
	EndIf
EndEvent

Function AssignActorToNonPlot(workshopobjectscript akObjectRef, Actor akActorRef)
	If (!akObjectRef || !akActorRef)
		return 
	EndIf
	workshopframework:workshopfunctions.AssignActorToObject(akObjectRef, akActorRef, True, True, True)
	If (akObjectRef.IsBed())
		akActorRef.AddKeyword(AssignmentType_Home)
	Else
		akActorRef.AddKeyword(AssignmentType_Job)
	EndIf
EndFunction

simsettlementsv2:miscobjects:plotconfiguration Function GetDefaultAssignmentPriority(int aiIndex)
	return DefaultAssignmentPriority[aiIndex] as simsettlementsv2:miscobjects:plotconfiguration
EndFunction

Function DumpBedAssignments(workshopscript akWorkshopRef)
	If (akWorkshopRef == None)
		akWorkshopRef = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
	EndIf
	ObjectReference[] kResourceObjects = akWorkshopRef.GetWorkshopResourceObjects(BedAV, 0)
	Actor[] kBedFoundForSettlers = new Actor[0]
	string sLogName = sAutoAssignmentLog
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, " =================== Dumping bed assignments for " + akWorkshopRef as string, 0, False)
	int I = 0
	While (I < kResourceObjects.length)
		simsettlementsv2:objectreferences:simplot parentPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(kResourceObjects[I], StageItemLinkKeyword)
		Actor kOwnerRef = kResourceObjects[I].GetActorRefOwner()
		float fBedValue = kResourceObjects[I].GetValue(BedAV)
		If (kOwnerRef == None && parentPlot != None)
			kOwnerRef = parentPlot.GetActorRefOwner()
		EndIf
		If (kOwnerRef != None)
			If (kBedFoundForSettlers.find(kOwnerRef, 0) >= 0)
				workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, " -- DUPLICATE OWNERSHIP: " + kOwnerRef as string + ", has multiple beds assigned.", 0, False)
			Else
				kBedFoundForSettlers.add(kOwnerRef, 1)
			EndIf
		EndIf
		If (parentPlot)
			workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, " -- Bed on Plot " + parentPlot as string + ": " + kResourceObjects[I] as string + ", Owned By: " + kOwnerRef as string, 0, False)
		ElseIf (kOwnerRef == None)
			workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, " -- Bed UNASSIGNED: " + kResourceObjects[I] as string, 0, False)
		Else
			workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, " -- Bed: " + kResourceObjects[I] as string + ", Owned By: " + kOwnerRef as string, 0, False)
		EndIf
		If (fBedValue <= 0 as float)
			workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, " ------ Shelter issue detected on " + kResourceObjects[I] as string, 0, False)
		EndIf
		I += 1
	EndWhile
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, " =================== Completed dump of settlers and assignables for " + akWorkshopRef as string, 0, False)
EndFunction

Function HandleAutoAssignmentForWorkshop(workshopscript akWorkshopRef, bool abSkipSettingsCheck)
	If (!abSkipSettingsCheck)
		If (OptionsManager.GetSettingValue(gSettings_AutoAssignment, akWorkshopRef.GetWorkshopID()) != 1 as float)
			return 
		EndIf
	EndIf
	Actor[] kSettlerRefs = Self.GetSettlers(akWorkshopRef, True)
	int I = 0
	int iSettlerCount = kSettlerRefs.length
	workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "[NPC_AssignmentManager] Found " + iSettlerCount as string + " settlers at " + akWorkshopRef as string + ", attempting autoassignment.", 0, False)
	While (I < iSettlerCount)
		If (Self.ShouldBeAutoassigned(kSettlerRefs[I]))
			Self.UpdateAssignmentKeywords(kSettlerRefs[I])
			Self.HandleAutoAssignmentForNPC(kSettlerRefs[I], akWorkshopRef, False)
		EndIf
		I += 1
	EndWhile
EndFunction

Function IdleAllActors(workshopscript akWorkshopRef)
	If (!akWorkshopRef)
		return 
	EndIf
	float fGamehour = gGameHour.GetValue()
	Actor[] WorkshopActors = Self.GetSettlers(akWorkshopRef, True)
	Actor[] MoveActors = new Actor[0]
	int I = 0
	ObjectReference temp = akWorkshopRef.PlaceAtMe(PositionHelper as Form, 1, False, False, True)
	temp.SetPosition(0, 0, 0)
	While (I < WorkshopActors.length)
		If (workshopframework:workshopfunctions.IsCommandable(WorkshopActors[I]))
			WorkshopActors[I].MoveTo(temp, 0, 0, 0, True)
			MoveActors.add(WorkshopActors[I], 1)
		EndIf
		I += 1
	EndWhile
	temp.Disable(False)
	temp.Delete()
	I = 0
	While (I < MoveActors.length)
		ObjectReference[] RelaxationObjects = akWorkshopRef.FindAllReferencesWithKeyword(RelaxationClassKeyword as Form, 10000)
		ObjectReference kMoveTo = None
		If (fGamehour > 20 as float)
			kMoveTo = RelaxationObjects[Utility.RandomInt(0, RelaxationObjects.length - 1)]
		Else
			ObjectReference[] OwnedObjects = akWorkshopRef.GetWorkshopOwnedObjects(MoveActors[I])
			int j = 0
			While (j < OwnedObjects.length && !kMoveTo)
				workshopobjectscript asWorkshopObject = OwnedObjects[I] as workshopobjectscript
				If (workshopframework:workshopfunctions.DoesWork24Hours(MoveActors[I]) || fGamehour > 7 as float && fGamehour < 21 as float)
					If (!asWorkshopObject.IsBed())
						kMoveTo = asWorkshopObject as ObjectReference
					EndIf
				ElseIf (asWorkshopObject.IsBed())
					kMoveTo = asWorkshopObject as ObjectReference
				EndIf
				j += 1
			EndWhile
			If (!kMoveTo)
				kMoveTo = RelaxationObjects[Utility.RandomInt(0, RelaxationObjects.length - 1)]
			EndIf
		EndIf
		If (!kMoveTo)
			kMoveTo = akWorkshopRef as ObjectReference
		EndIf
		MoveActors[I].MoveTo(kMoveTo, 0, 0, 0, True)
		MoveActors[I].MoveToNearestNavmeshLocation()
		MoveActors[I].EvaluatePackage(False)
		I += 1
	EndWhile
EndFunction

Function DumpNPCAssignments(Actor akActor)
	workshopscript thisWorkshop = akActor.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	ObjectReference[] kAssignedRefs = thisWorkshop.GetWorkshopOwnedObjects(akActor)
	workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "[NPC_AssignmentManager] Dumping assignments for: " + akActor as string + " at settlement " + thisWorkshop as string, 0, False)
	int I = 0
	While (I < kAssignedRefs.length)
		workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "[NPC_AssignmentManager] " + kAssignedRefs[I] as string, 0, False)
		I += 1
	EndWhile
	workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, "[NPC_AssignmentManager] Ending assignment dump for: " + akActor as string, 0, False)
EndFunction

Event WorkshopFramework:SettlementLayoutManager.SettlementLayoutBuilt(workshopframework:settlementlayoutmanager akSender, var[] akArgs)
	workshopscript thisWorkshop = akArgs[0] as workshopscript
	If (thisWorkshop != None)
		SettlementManager.UpdateLeaderDeskAssignments(thisWorkshop)
		ObjectReference[] kResourceObjects = thisWorkshop.GetWorkshopResourceObjects(None, 0)
		int I = 0
		While (I < kResourceObjects.length)
			If (!kResourceObjects[I].HasKeyword(PlotTypeKeyword) && kResourceObjects[I].HasKeyword(WorkshopWorkObject))
				ObjectsAwaitingAssignment.AddRef(kResourceObjects[I])
			EndIf
			I += 1
		EndWhile
		Self.HandleAutoAssignmentForWorkshop(thisWorkshop, False)
	EndIf
EndEvent

Function HandleGameLoaded()
	Debug.OpenUserLog(sAutoAssignmentLog)
	Parent.HandleGameLoaded()
EndFunction

Function TownMeetingFade(float afTownMeetingFadeTime, float fWaitTime)
	Game.FadeOutGame(True, True, 0, 1, True)
	Self.StartTimer(afTownMeetingFadeTime, iTimerID_TownMeetingFade)
	If (TownMeetingSounds.length)
		int soundIndex = 0
		While (soundIndex < TownMeetingSounds.length)
			TownMeetingSounds[soundIndex].Play(PlayerRef as ObjectReference)
			soundIndex += 1
		EndWhile
	EndIf
	Utility.Wait(fWaitTime)
EndFunction

simsettlementsv2:miscobjects:plotconfiguration[] Function GetDefaultAssignmentPriorities()
	simsettlementsv2:miscobjects:plotconfiguration[] TheseAssignmentPriorities = new simsettlementsv2:miscobjects:plotconfiguration[0]
	int I = 0
	While (I < DefaultAssignmentPriority.length)
		TheseAssignmentPriorities.add(DefaultAssignmentPriority[I] as simsettlementsv2:miscobjects:plotconfiguration, 1)
		I += 1
	EndWhile
EndFunction

bool Function ShouldBeAutoassigned(Actor akActorRef)
	If (akActorRef != None && !akActorRef.IsDisabled() && workshopframework:workshopfunctions.IsCommandable(akActorRef) && workshopframework:workshopfunctions.CountsForPopulation(akActorRef) && !akActorRef.HasKeyword(WSFW_DoNotAutoassign))
		return True
	EndIf
	return False
EndFunction

Function UpdateAssignmentKeywords(Actor akActor)
	If (!akActor.Is3dLoaded())
		return 
	EndIf
	akActor.RemoveKeyword(AssignmentType_Home)
	akActor.RemoveKeyword(AssignmentType_Job)
	akActor.RemoveKeyword(AssignmentType_Leisure)
	If (workshopframework:workshopfunctions.IsCaravanNPC(akActor, None))
		akActor.AddKeyword(AssignmentType_Job)
		workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, akActor as string + " assignment found: Provisioner which counts as " + AssignmentType_Job as string, 0, False)
	EndIf
	workshopscript thisWorkshop = akActor.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	ObjectReference[] kAssignedRefs = thisWorkshop.GetWorkshopOwnedObjects(akActor)
	Self.ApplyAssignmentKeywordsFromOwnedObjects(akActor, kAssignedRefs)
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_TownMeetingFade)
		Game.FadeOutGame(False, True, fTownMeetingFadeTime, 1.5, False)
	EndIf
EndEvent

Event WorkshopFramework:MainQuest.PlayerExitedSettlement(workshopframework:mainquest akQuestRef, var[] akArgs)
	workshopscript kWorkshopRef = akArgs[0] as workshopscript
	bool bStillLoaded = akArgs[1] as bool
	If (!bStillLoaded)
		Self.HandlePlayerExitedSettlement(kWorkshopRef)
	Else
		Self.RegisterForRemoteEvent(kWorkshopRef as ScriptObject, "OnUnload")
	EndIf
EndEvent

Function UnbindNPC(Actor akActorRef)
	BoundSettlers.RemoveRef(akActorRef as ObjectReference)
	ObjectReference kBoundFurnitureRef = akActorRef.GetLinkedRef(LinkCustom01)
	If (kBoundFurnitureRef)
		akActorRef.SetLinkedRef(None, LinkCustom01)
		kBoundFurnitureRef.Disable(False)
		kBoundFurnitureRef.Delete()
	EndIf
	If (akActorRef.Is3dLoaded())
		akActorRef.EvaluatePackage(False)
	EndIf
EndFunction

Function ClearAllAssignments(workshopscript akWorkshopRef)
	Actor[] WorkshopActors = Self.GetSettlers(akWorkshopRef, True)
	int I = 0
	While (I < WorkshopActors.length)
		If (workshopframework:workshopfunctions.IsCommandable(WorkshopActors[I]))
			workshopframework:workshopfunctions.UnassignActor(WorkshopActors[I], True, True, False, False, akWorkshopRef)
		EndIf
		I += 1
	EndWhile
EndFunction

Function ApplyAssignmentKeywordsFromOwnedObjects(Actor akActor, ObjectReference[] akAssignedRefs)
	int I = 0
	While (I < akAssignedRefs.length)
		workshopobjectscript asWorkshopObject = akAssignedRefs[I] as workshopobjectscript
		simsettlementsv2:objectreferences:simplot asPlot = akAssignedRefs[I] as simsettlementsv2:objectreferences:simplot
		If (!asPlot)
			asPlot = simsettlementsv2:utilityfunctions.GetLinkedPlot(akAssignedRefs[I], SecondaryAssignmentMarkerLinkKeyword)
		EndIf
		If (asPlot)
			int j = 0
			simsettlementsv2:miscobjects:plotconfiguration thisPlotConfig = asPlot.GetPlotConfig()
			While (j < thisPlotConfig.AssignmentTypeKeywords.length)
				workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, akActor as string + " assignment found: " + asPlot as string + " which counts as " + thisPlotConfig.AssignmentTypeKeywords[j] as string, 0, False)
				akActor.AddKeyword(thisPlotConfig.AssignmentTypeKeywords[j])
				j += 1
			EndWhile
		ElseIf (asWorkshopObject as bool && !asWorkshopObject.HasKeyword(PlotSpawnedKeyword))
			If (asWorkshopObject.IsBed())
				workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, akActor as string + " assignment found: " + asWorkshopObject as string + " which counts as " + AssignmentType_Home as string, 0, False)
				akActor.AddKeyword(AssignmentType_Home)
			Else
				workshopframework:library:utilityfunctions.ModTraceCustom(sAutoAssignmentLog, akActor as string + " assignment found: " + asWorkshopObject as string + " which counts as " + AssignmentType_Job as string, 0, False)
				akActor.AddKeyword(AssignmentType_Job)
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction
