;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\NPC_DataManager.psc
Modified : 2021-04-03 11:37:52
Compiled : 2021-04-03 11:42:08
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:NPC_DataManager extends WorkshopFramework:Library:SlaveQuest
{ Handles NPC data - in particular the settlement level data stores }

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const mandatory
	workshopframework:mainquest Property WSFW_Main Auto Const mandatory
	workshopframework:workshopresourcemanager Property WSFW_ResourceManager Auto Const mandatory
	workshopframework:npcmanager Property WSFW_NPCManager Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property SafeSpawnPoint Auto Const mandatory
	RefCollectionAlias Property CurrentSettlementLinkedNPCs Auto Const mandatory
EndGroup

Group Assets
	Form Property NPCDataForm Auto Const mandatory
EndGroup

Group Config
	simsettlementsv2:datastructures#npcclass[] Property NPCClasses Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property WorkshopItemKeyword Auto Const mandatory
EndGroup

simsettlementsv2:objectreferences:settlementnpcdata[] Property NPCDataStores Auto hidden

;-- Variables ---------------------------------------
workshopscript kCurrentWorkshop
bool[] bEnterSettlementBlock
bool[] bExitSettlementBlock
bool bDataStoresUpdatingBlock = False

;-- Functions ---------------------------------------

Function HandlePlayerEnteredSettlement(workshopscript akWorkshopRef)
	If (!akWorkshopRef)
		return 
	EndIf
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	If (!bEnterSettlementBlock || bEnterSettlementBlock.length < 128)
		bEnterSettlementBlock = new bool[128]
	EndIf
	If (bEnterSettlementBlock[iWorkshopID])
		return 
	EndIf
	bEnterSettlementBlock[iWorkshopID] = True
	CurrentSettlementLinkedNPCs.RemoveAll()
	Actor[] kLocalNPCs = Self.GetSettlers(akWorkshopRef)
	If (kLocalNPCs.length > 0)
		simsettlementsv2:utilityfunctions.AddActorArrayToRefCollection(kLocalNPCs, CurrentSettlementLinkedNPCs)
	EndIf
	bEnterSettlementBlock[iWorkshopID] = False
EndFunction

simsettlementsv2:objectreferences:settlementnpcdata Function GetNPCDataStore(int aiWorkshopID)
	simsettlementsv2:objectreferences:settlementnpcdata kDataStoreRef = None
	If (NPCDataStores as bool && NPCDataStores.length > aiWorkshopID)
		kDataStoreRef = NPCDataStores[aiWorkshopID]
	Else
		kDataStoreRef = Self.ConfigureNPCDataStore(aiWorkshopID, True)
	EndIf
	return kDataStoreRef
EndFunction

Function DumpDataStore(workshopscript akWorkshopRef)
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	simsettlementsv2:objectreferences:settlementnpcdata thisDataStore = NPCDataStores[iWorkshopID]
	string sLogName = simsettlementsv2:utilityfunctions.GetLogName()
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, "============= Starting Settlement NPC Data Dump [" + thisDataStore as string + "] =============", 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, thisDataStore.AlternateSettlerRecruitment as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, "============= End Settlement Data Dump [" + thisDataStore as string + "] =============", 0, False)
EndFunction

Event WorkshopParentScript.WorkshopAddActor(workshopparentscript akSender, var[] akArgs)
	Actor thisActor = akArgs[0] as Actor
	int iWorkshopID = akArgs[1] as int
	If (kCurrentWorkshop != None)
		int iCurrentWorkshopID = kCurrentWorkshop.GetWorkshopID()
		If (iCurrentWorkshopID == iWorkshopID)
			CurrentSettlementLinkedNPCs.AddRef(thisActor as ObjectReference)
		EndIf
	EndIf
EndEvent

Event WorkshopFramework:MainQuest.PlayerEnteredSettlement(workshopframework:mainquest akQuestRef, var[] akArgs)
	workshopscript kWorkshopRef = akArgs[0] as workshopscript
	bool bPreviouslyUnloaded = akArgs[1] as bool
	If (bPreviouslyUnloaded || kCurrentWorkshop != kWorkshopRef)
		kCurrentWorkshop = kWorkshopRef
		Self.HandlePlayerEnteredSettlement(kWorkshopRef)
	EndIf
EndEvent

Function HandleQuestInit()
	Parent.HandleQuestInit()
	Self.SetupDataStores()
	Self.RegisterForCustomEvent(WSFW_Main as ScriptObject, "workshopframework:mainquest_PlayerEnteredSettlement")
	Self.RegisterForCustomEvent(WSFW_Main as ScriptObject, "workshopframework:mainquest_PlayerExitedSettlement")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopAddActor")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopRemoveActor")
EndFunction

simsettlementsv2:objectreferences:settlementnpcdata Function GetNPCDataStoreFromWorkshop(workshopscript akWorkshopRef)
	return Self.GetNPCDataStore(akWorkshopRef.GetWorkshopID())
EndFunction

simsettlementsv2:datastructures#npcclass Function GetClassFromActor(Actor akActorRef)
	int I = 0
	While (I < NPCClasses.length)
		If (NPCClasses[I].ClassKeyword != None && akActorRef.HasKeyword(NPCClasses[I].ClassKeyword) || NPCClasses[I].ClassRefType != None && akActorRef.HasLocRefType(NPCClasses[I].ClassRefType))
			return NPCClasses[I]
		EndIf
		I += 1
	EndWhile
	return None
EndFunction

Event ObjectReference.OnUnload(ObjectReference akSender)
	workshopscript thisWorkshop = akSender as workshopscript
	If (thisWorkshop)
		Self.HandlePlayerExitedSettlement(thisWorkshop)
	EndIf
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnUnload")
EndEvent

Function HandlePlayerExitedSettlement(workshopscript akWorkshopRef)
	If (!akWorkshopRef)
		return 
	EndIf
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	If (!bExitSettlementBlock || bExitSettlementBlock.length < 128)
		bExitSettlementBlock = new bool[128]
	EndIf
	If (bExitSettlementBlock[iWorkshopID])
		return 
	EndIf
	bExitSettlementBlock[iWorkshopID] = True
	If (!bExitSettlementBlock[iWorkshopID])
		CurrentSettlementLinkedNPCs.RemoveAll()
	Else
		int I = CurrentSettlementLinkedNPCs.GetCount() - 1
		While (I >= 0)
			ObjectReference thisRef = CurrentSettlementLinkedNPCs.GetAt(I)
			If (thisRef as bool && thisRef.GetLinkedRef(WorkshopItemKeyword) == akWorkshopRef as ObjectReference)
				CurrentSettlementLinkedNPCs.RemoveRef(thisRef)
			EndIf
			I -= 1
		EndWhile
	EndIf
	bExitSettlementBlock[iWorkshopID] = False
EndFunction

Function ApplyUpdateChanges(simsettlementsv2:objectreferences:settlementnpcdata aDataStore)
	; Empty function
EndFunction

Function SetupDataStores()
	If (bDataStoresUpdatingBlock)
		return 
	EndIf
	bDataStoresUpdatingBlock = True
	int iLoopCounter = 0
	While (!WorkshopParent.Initialized && iLoopCounter < 10)
		iLoopCounter += 1
		Utility.Wait(5)
	EndWhile
	int iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "NPC_DataManager.SetupDataStores: Unable to get lock!", 2, False)
		return 
	EndIf
	If (NPCDataStores == None || NPCDataStores.length == 0)
		NPCDataStores = new simsettlementsv2:objectreferences:settlementnpcdata[0]
	EndIf
	workshopscript[] Workshops = WorkshopParent.Workshops
	int I = 0
	While (I < Workshops.length)
		Self.ConfigureNPCDataStore(I, False)
		I += 1
	EndWhile
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "NPC_DataManager.SetupDataStores: Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
	bDataStoresUpdatingBlock = False
EndFunction

simsettlementsv2:objectreferences:settlementnpcdata Function ConfigureNPCDataStore(int aiWorkshopID, bool abGetLock)
	int iLockKey = 0
	If (abGetLock)
		iLockKey = Self.GetLock(0, True)
		If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "ConfigureNPCDataStore: Unable to get lock!", 2, False)
			return None
		EndIf
	EndIf
	If (NPCDataStores.length < aiWorkshopID)
		int I = NPCDataStores.length
		While (I < aiWorkshopID)
			Self.ConfigureNPCDataStore(I, False)
			I += 1
		EndWhile
	EndIf
	If (NPCDataStores.length > aiWorkshopID && NPCDataStores[aiWorkshopID] != None && NPCDataStores[aiWorkshopID].IsBoundGameObjectAvailable())
		Self.ApplyUpdateChanges(NPCDataStores[aiWorkshopID])
	Else
		ObjectReference kPlaceAt = SafeSpawnPoint.GetRef()
		If (kPlaceAt)
			ObjectReference kDataStore = kPlaceAt.PlaceAtMe(NPCDataForm, 1, True, False, False)
			If (kDataStore)
				simsettlementsv2:objectreferences:settlementnpcdata asDataStore = kDataStore as simsettlementsv2:objectreferences:settlementnpcdata
				If (asDataStore)
					asDataStore.kWorkshopRef = WorkshopParent.GetWorkshop(aiWorkshopID)
					If (NPCDataStores.length > aiWorkshopID)
						NPCDataStores[aiWorkshopID] = asDataStore
					Else
						NPCDataStores.add(asDataStore, 1)
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	If (abGetLock)
		If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "ConfigureNPCDataStore: Failed to release lock " + iLockKey as string + "!", 2, False)
		EndIf
	EndIf
	return NPCDataStores[aiWorkshopID]
EndFunction

Event WorkshopFramework:MainQuest.PlayerExitedSettlement(workshopframework:mainquest akQuestRef, var[] akArgs)
	workshopscript kWorkshopRef = akArgs[0] as workshopscript
	bool bStillLoaded = akArgs[1] as bool
	If (!bStillLoaded || kWorkshopRef != kCurrentWorkshop)
		Self.HandlePlayerExitedSettlement(kWorkshopRef)
	Else
		Self.RegisterForRemoteEvent(kWorkshopRef as ScriptObject, "OnUnload")
	EndIf
EndEvent

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
	Self.SetupDataStores()
	If (kCurrentWorkshop == None)
		workshopscript kWorkshopRef = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
		If (kWorkshopRef != None && kWorkshopRef.GetCurrentLocation() == PlayerRef.GetCurrentLocation())
			Self.HandlePlayerEnteredSettlement(kWorkshopRef)
		EndIf
	EndIf
EndFunction

Actor[] Function GetSettlers(workshopscript akWorkshopRef)
	simsettlementsv2:quests:mi:grabnpcs NPCGrabber = (Self as Quest) as simsettlementsv2:quests:mi:grabnpcs
	return NPCGrabber.GetSettlers(akWorkshopRef, True)
EndFunction

Event WorkshopParentScript.WorkshopRemoveActor(workshopparentscript akSenderRef, var[] akArgs)
	Actor thisActor = akArgs[0] as Actor
	If (kCurrentWorkshop != None && kCurrentWorkshop == akArgs[1] as workshopscript)
		CurrentSettlementLinkedNPCs.RemoveRef(thisActor as ObjectReference)
	EndIf
EndEvent
