;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\NewspaperManager.psc
Modified : 2021-03-16 00:29:28
Compiled : 2021-03-16 00:29:45
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:Quests:NewspaperManager extends WorkshopFramework:Library:SlaveQuest

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const mandatory
	simsettlementsv2:quests:plotmanager Property PlotManager Auto Const mandatory
	simsettlementsv2:quests:aliasgrabber_newsmanager Property AliasGrabber Auto Const mandatory
	simsettlementsv2:quests:settlementmanager Property SettlementManager Auto Const mandatory
	Quest Property LevelUpQuest Auto Const mandatory
EndGroup

Group Aliases
	LocationAlias Property StationOliviaAlias Auto Const mandatory
	ReferenceAlias Property EditorStrongAlias Auto Const mandatory
	ReferenceAlias Property RoachKingAlias Auto Const mandatory
	ReferenceAlias Property HangmansAlleyWorkbenchAlias Auto Const mandatory
	simsettlementsv2:datastructures#buildingplanfirstlocationtracking[] Property FirstBuildLocations Auto Const mandatory
EndGroup

Group Assets
	FormList Property RegisteredArticlesList Auto Const mandatory
	{ Empty formlist for storing unprinted articles that are registered with the system }
	FormList Property UnlockedArticlesList Auto Const mandatory
	{ Empty formlist for articles that are eligible to be printed but haven't been yet }
	FormList Property PrintedArticlesList Auto Const mandatory
	{ Empty formlist for storing articles that have been printed }
	FormList Property SeenArticlesList Auto Const mandatory
	{ Empty formlist for articles the player has already seen }
	FormList Property NewspaperBuildingPlans Auto Const mandatory
	{ Formlist with newspaper building plans }
	Form[] Property DefaultNewspaperBuildingPlans Auto Const mandatory
	LeveledItem Property PrintedArticlesLL Auto Const mandatory
	{ Leveledlist for distributing printed articles in the game world }
	Keyword Property StageItemLinkKeyword Auto Const mandatory
	{ Same as on PlotManager }
EndGroup

Group Config
	float Property fTimeBetweenArticles = 24 Auto Const
	{ In game hours }
EndGroup

simsettlementsv2:objectreferences:simplot[] Property NewspaperBuildings Auto hidden
Form Property NextArticle Auto hidden
Form Property LastPrintedArticle Auto hidden

;-- Variables ---------------------------------------
int iTimerID_CheckArticles = 102 Const
float fLastArticlePrintTimestamp = 0
int iTimerID_CompleteInitilization = 101 Const

;-- Functions ---------------------------------------

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
	int I = 0
	While (I < DefaultNewspaperBuildingPlans.length)
		Self.RegisterNewspaperBuildingPlan(DefaultNewspaperBuildingPlans[I])
		I += 1
	EndWhile
	Self.CleanupNewspaperBuildingsArray()
	workshopframework:library:utilityfunctions.CleanFormlist(RegisteredArticlesList, -1)
	workshopframework:library:utilityfunctions.CleanFormlist(PrintedArticlesList, -1)
	workshopframework:library:utilityfunctions.CleanFormlist(SeenArticlesList, -1)
	workshopframework:library:utilityfunctions.CleanFormlist(UnlockedArticlesList, -1)
	workshopframework:library:utilityfunctions.CleanFormlist(NewspaperBuildingPlans, -1)
EndFunction

Function FillAliases()
	If (!AliasGrabber.IsRunning())
		AliasGrabber.Start()
	EndIf
	EditorStrongAlias.ForceRefTo(AliasGrabber.StrongAlias.GetRef())
	StationOliviaAlias.ForceLocationTo(AliasGrabber.StationOliviaAlias.GetLocation())
	RoachKingAlias.ForceRefTo(AliasGrabber.RoachKingAlias.GetRef())
	HangmansAlleyWorkbenchAlias.ForceRefTo(AliasGrabber.HangmansAlleyWorkbenchAlias.GetRef())
	AliasGrabber.Stop()
EndFunction

Function PrintNewsArticle(Form aArticle)
	fLastArticlePrintTimestamp = Utility.GetCurrentGameTime()
	LastPrintedArticle = aArticle
	If (!PrintedArticlesList.HasForm(aArticle))
		PrintedArticlesList.AddForm(aArticle)
		PrintedArticlesLL.AddForm(aArticle, 1, 1)
		RegisteredArticlesList.RemoveAddedForm(aArticle)
		UnlockedArticlesList.RemoveAddedForm(aArticle)
	EndIf
EndFunction

Function CheckArticleEligibility()
	int I = 0
	While (I < RegisteredArticlesList.GetSize())
		simsettlementsv2:books:newsarticle thisArticle = RegisteredArticlesList.GetAt(I) as simsettlementsv2:books:newsarticle
		If (thisArticle as bool && Self.IsEligibleToPrint(thisArticle))
			Self.UnlockNewsArticle(thisArticle as Form)
		EndIf
		I += 1
	EndWhile
EndFunction

Form Function GetTodaysArticle()
	If (fLastArticlePrintTimestamp + fTimeBetweenArticles / 24 > Utility.GetCurrentGameTime())
		return LastPrintedArticle
	EndIf
	int iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[NewspaperManager]: Unable to get lock!", 2, False)
		return None
	EndIf
	If (NextArticle)
		Self.PrintNewsArticle(NextArticle)
		NextArticle = None
	Else
		simsettlementsv2:books:newsarticle[] PotentialArticles = new simsettlementsv2:books:newsarticle[0]
		int iHighestPriority = -1
		int I = 0
		While (I < UnlockedArticlesList.GetSize())
			simsettlementsv2:books:newsarticle thisArticle = UnlockedArticlesList.GetAt(I) as simsettlementsv2:books:newsarticle
			If (thisArticle)
				int iPriority = thisArticle.iPriority
				If (iPriority > 21)
					iPriority = 20
				EndIf
				If (iPriority > iHighestPriority)
					iHighestPriority = iPriority
					PotentialArticles = new simsettlementsv2:books:newsarticle[0]
				EndIf
				If (iPriority == iHighestPriority)
					PotentialArticles.add(thisArticle, 1)
				EndIf
			EndIf
			I += 1
		EndWhile
		If (PotentialArticles.length > 0)
			int iPrintIndex = Utility.RandomInt(0, PotentialArticles.length - 1)
			Self.PrintNewsArticle(PotentialArticles[iPrintIndex] as Form)
		Else
			I = 0
			While (I < PrintedArticlesList.GetSize())
				simsettlementsv2:books:newsarticle thisarticle = PrintedArticlesList.GetAt(I) as simsettlementsv2:books:newsarticle
				If (!SeenArticlesList.HasForm(thisarticle as Form))
					PotentialArticles.add(thisarticle, 1)
				EndIf
				I += 1
			EndWhile
			If (PotentialArticles.length > 0)
				int iprintindex = Utility.RandomInt(0, PotentialArticles.length - 1)
				Self.PrintNewsArticle(PotentialArticles[iprintindex] as Form)
			Else
				int iprintindex = Utility.RandomInt(0, PrintedArticlesList.GetSize() - 1)
				Self.PrintNewsArticle(PrintedArticlesList.GetAt(iprintindex))
			EndIf
		EndIf
	EndIf
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[NewspaperManager]: Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
	return LastPrintedArticle
EndFunction

Event SimSettlementsV2:Quests:PlotManager.PlotLevelChanged(simsettlementsv2:quests:plotmanager akSender, var[] akArgs)
	simsettlementsv2:objectreferences:simplot kPlotRef = akArgs[0] as simsettlementsv2:objectreferences:simplot
	If (kPlotRef as bool && akArgs[1] as int > 0)
		If (Self.IsNewspaperBuilding(kPlotRef as ObjectReference))
			Self.RegisterNewspaperBuilding(kPlotRef)
			If (kPlotRef.GetAssignedNPC() == EditorStrongAlias.GetActorRef())
				Self.SetStage(20)
			EndIf
		EndIf
		int I = 0
		While (I < FirstBuildLocations.length)
			If (FirstBuildLocations[I].BuildingPlan == kPlotRef.GetParentBuildingPlan() as Form && FirstBuildLocations[I].FirstLocationAlias.GetLocation() == None)
				FirstBuildLocations[I].FirstLocationAlias.ForceLocationTo(kPlotRef.GetCurrentLocation())
				If (FirstBuildLocations[I].QuestToSetStage != None)
					FirstBuildLocations[I].QuestToSetStage.SetStage(FirstBuildLocations[I].iStageNum)
				EndIf
			EndIf
			I += 1
		EndWhile
	EndIf
EndEvent

Function RegisterNewsArticles(FormList aArticleList)
	int I = 0
	While (I < aArticleList.GetSize())
		Self.RegisterNewsArticle(aArticleList.GetAt(I))
		I += 1
	EndWhile
EndFunction

Event OnTimerGameTime(int aiTimerID)
	Parent.OnTimerGameTime(aiTimerID)
	If (aiTimerID == iTimerID_CheckArticles)
		Self.CheckArticleEligibility()
		Self.StartTimerGameTime(24, iTimerID_CheckArticles)
	EndIf
EndEvent

Event Location.OnLocationCleared(Location akLocation)
	Self.UnregisterForRemoteEvent(akLocation as ScriptObject, "OnLocationCleared")
	Self.CheckArticleEligibility()
EndEvent

bool Function IsNewspaperBuilding(ObjectReference akPlotRef)
	simsettlementsv2:objectreferences:simplot asPlot = akPlotRef as simsettlementsv2:objectreferences:simplot
	If (!asPlot)
		return False
	EndIf
	If (NewspaperBuildingPlans.HasForm(asPlot.GetParentBuildingPlan() as Form) || NewspaperBuildingPlans.HasForm(asPlot.GetCurrentLevelPlan() as Form))
		return True
	EndIf
	return False
EndFunction

Event Quest.OnQuestInit(Quest akQuestRef)
	If (akQuestRef == LevelUpQuest)
		Self.CheckArticleEligibility()
	EndIf
EndEvent

Function ForceNextArticle(Form aArticle)
	NextArticle = aArticle
EndFunction

Function UnlockNewsArticle(Form aArticle)
	RegisteredArticlesList.RemoveAddedForm(aArticle)
	UnlockedArticlesList.AddForm(aArticle)
EndFunction

Function RegisterNewspaperBuildingPlan(Form aBuildingOrLevelPlan)
	If (aBuildingOrLevelPlan == None)
		return 
	EndIf
	If ((aBuildingOrLevelPlan as simsettlementsv2:weapons:buildingplan) as bool || (aBuildingOrLevelPlan as simsettlementsv2:weapons:buildinglevelplan) as bool)
		NewspaperBuildingPlans.AddForm(aBuildingOrLevelPlan)
	EndIf
EndFunction

Function CleanupNewspaperBuildingsArray()
	int iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[BreweryManager]: Unable to get lock!", 2, False)
		return 
	EndIf
	int I = 0
	While (I < NewspaperBuildings.length)
		If (NewspaperBuildings[I].GetState() == "Destroyed" || !Self.IsNewspaperBuilding(NewspaperBuildings[I] as ObjectReference))
			NewspaperBuildings[I] = None
		EndIf
		I += 1
	EndWhile
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[BreweryManager]: Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
EndFunction

Event OnTimer(int aiTimerID)
	Parent.OnTimer(aiTimerID)
	If (aiTimerID == iTimerID_CompleteInitilization)
		Self.RegisterForRemoteEvent(LevelUpQuest as ScriptObject, "OnQuestInit")
		Self.FillAliases()
	EndIf
EndEvent

Function RegisterNewsArticle(Form aArticle)
	simsettlementsv2:books:newsarticle thisArticle = aArticle as simsettlementsv2:books:newsarticle
	If (thisArticle as bool && !UnlockedArticlesList.HasForm(thisArticle as Form) && !PrintedArticlesList.HasForm(thisArticle as Form))
		RegisteredArticlesList.AddForm(thisArticle as Form)
	EndIf
EndFunction

Function MarkArticleSeen(Form aArticle)
	SeenArticlesList.AddForm(aArticle)
EndFunction

bool Function IsEligibleToPrint(simsettlementsv2:books:newsarticle aArticle)
	bool bCanPrint = aArticle.IsEligibleToPrint()
	If (bCanPrint)
		If (bCanPrint && aArticle.iMinPlayerLevel > 0 && PlayerRef.GetLevel() < aArticle.iMinPlayerLevel)
			bCanPrint = False
		EndIf
		workshopscript[] OwnedSettlements = new workshopscript[0]
		bool bOwnedSettlementsCheckedAlready = False
		If (bCanPrint && aArticle.iMinOwnedSettlements > 0)
			bOwnedSettlementsCheckedAlready = True
			OwnedSettlements = workshopframework:workshopfunctions.GetPlayerOwnedSettlements(True, True, False)
			If (OwnedSettlements.length < aArticle.iMinOwnedSettlements)
				bCanPrint = False
			EndIf
		EndIf
		If (bCanPrint && aArticle.GetRequirements() as bool)
			bCanPrint = simsettlementsv2:utilityfunctions.CheckRequirements(aArticle.GetRequirements(), None, None, None)
		EndIf
		If (bCanPrint && aArticle.MinimumPlotsBuilt != None)
			int I = 0
			While (I < aArticle.MinimumPlotsBuilt.length && bCanPrint)
				If (aArticle.MinimumPlotsBuilt[I].iL0Count > 0)
					int iPlots = 0
					If (aArticle.MinimumPlotsBuilt[I].BuildingClass != None)
						iPlots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsBuilt[I].BuildingClass, 0, -1, False, True)
					Else
						iPlots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsBuilt[I].PlotType, 0, -1, False, True)
					EndIf
					If (iPlots < aArticle.MinimumPlotsBuilt[I].iL0Count)
						bCanPrint = False
					EndIf
				EndIf
				If (bCanPrint && aArticle.MinimumPlotsBuilt[I].iL1Count > 0)
					int iplots = 0
					If (aArticle.MinimumPlotsBuilt[I].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsBuilt[I].BuildingClass, 1, -1, False, True)
					Else
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsBuilt[I].PlotType, 1, -1, False, True)
					EndIf
					If (iplots < aArticle.MinimumPlotsBuilt[I].iL1Count)
						bCanPrint = False
					EndIf
				EndIf
				If (bCanPrint && aArticle.MinimumPlotsBuilt[I].iL2Count > 0)
					int iplots = 0
					If (aArticle.MinimumPlotsBuilt[I].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsBuilt[I].BuildingClass, 2, -1, False, True)
					Else
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsBuilt[I].PlotType, 2, -1, False, True)
					EndIf
					If (iplots < aArticle.MinimumPlotsBuilt[I].iL2Count)
						bCanPrint = False
					EndIf
				EndIf
				If (bCanPrint && aArticle.MinimumPlotsBuilt[I].iL3Count > 0)
					int iplots = 0
					If (aArticle.MinimumPlotsBuilt[I].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsBuilt[I].BuildingClass, 3, -1, False, True)
					Else
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsBuilt[I].PlotType, 3, -1, False, True)
					EndIf
					If (iplots < aArticle.MinimumPlotsBuilt[I].iL3Count)
						bCanPrint = False
					EndIf
				EndIf
				I += 1
			EndWhile
		EndIf
		If (bCanPrint && aArticle.MinimumPlotsActive != None)
			int i = 0
			While (i < aArticle.MinimumPlotsActive.length && bCanPrint)
				If (aArticle.MinimumPlotsActive[i].iL0Count > 0)
					int iplots = 0
					If (aArticle.MinimumPlotsActive[i].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsActive[i].BuildingClass, 0, -1, True, True)
					Else
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsActive[i].PlotType, 0, -1, True, True)
					EndIf
					If (iplots < aArticle.MinimumPlotsActive[i].iL0Count)
						bCanPrint = False
					EndIf
				EndIf
				If (bCanPrint && aArticle.MinimumPlotsActive[i].iL1Count > 0)
					int iplots = 0
					If (aArticle.MinimumPlotsActive[i].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsActive[i].BuildingClass, 1, -1, True, True)
					Else
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsActive[i].PlotType, 1, -1, True, True)
					EndIf
					If (iplots < aArticle.MinimumPlotsActive[i].iL1Count)
						bCanPrint = False
					EndIf
				EndIf
				If (bCanPrint && aArticle.MinimumPlotsActive[i].iL2Count > 0)
					int iplots = 0
					If (aArticle.MinimumPlotsActive[i].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsActive[i].BuildingClass, 2, -1, True, True)
					Else
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsActive[i].PlotType, 2, -1, True, True)
					EndIf
					If (iplots < aArticle.MinimumPlotsActive[i].iL2Count)
						bCanPrint = False
					EndIf
				EndIf
				If (bCanPrint && aArticle.MinimumPlotsActive[i].iL3Count > 0)
					int iplots = 0
					If (aArticle.MinimumPlotsActive[i].BuildingClass != None)
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsActive[i].BuildingClass, 3, -1, True, True)
					Else
						iplots = SettlementManager.GetPlotCount(aArticle.MinimumPlotsActive[i].PlotType, 3, -1, True, True)
					EndIf
					If (iplots < aArticle.MinimumPlotsActive[i].iL3Count)
						bCanPrint = False
					EndIf
				EndIf
				i += 1
			EndWhile
		EndIf
		If (bCanPrint && aArticle.MustOwnSettlements != None)
			int i = 0
			While (i < aArticle.MustOwnSettlements.length)
				ObjectReference thisRef = workshopframework:library:utilityfunctions.GetUniversalForm(aArticle.MustOwnSettlements[i]) as ObjectReference
				If (thisRef != None)
					workshopscript thisWorkshop = thisRef as workshopscript
					If (bOwnedSettlementsCheckedAlready)
						If (OwnedSettlements.find(thisWorkshop, 0) < 0)
							bCanPrint = False
						EndIf
					ElseIf (thisWorkshop == None || !thisWorkshop.OwnedByPlayer)
						bCanPrint = False
					EndIf
				Else
					bCanPrint = False
				EndIf
				i += 1
			EndWhile
		EndIf
		If (bCanPrint && aArticle.ClearedLocations != None)
			int i = 0
			While (i < aArticle.ClearedLocations.length)
				Location thisLocation = workshopframework:library:utilityfunctions.GetUniversalForm(aArticle.ClearedLocations[i]) as Location
				If (thisLocation != None)
					If (thisLocation == None || !thisLocation.HasEverBeenCleared())
						bCanPrint = False
					Else
						Self.RegisterForRemoteEvent(thisLocation as ScriptObject, "OnLocationCleared")
					EndIf
				Else
					bCanPrint = False
				EndIf
				i += 1
			EndWhile
		EndIf
		If (bCanPrint && aArticle.MinimumCityPlansAtEachLevel != None)
			simsettlementsv2:objectreferences:settlementdata[] SettlementDataStores = SettlementManager.SettlementDataStores
			int[] iLevelCounts = new int[128]
			int i = 0
			While (i < SettlementDataStores.length)
				int iCurrentLevel = SettlementDataStores[i].iCityLevel
				If (iCurrentLevel >= 0)
					iLevelCounts[iCurrentLevel] = iLevelCounts[iCurrentLevel] + 1
				EndIf
				i += 1
			EndWhile
			i = 0
			While (i < aArticle.MinimumCityPlansAtEachLevel.length && bCanPrint)
				If (iLevelCounts[i] < aArticle.MinimumCityPlansAtEachLevel[i])
					bCanPrint = False
				EndIf
				i += 1
			EndWhile
		EndIf
	EndIf
	return bCanPrint
EndFunction

Function RegisterNewspaperBuilding(simsettlementsv2:objectreferences:simplot akPlotRef)
	If (akPlotRef == None)
		return 
	EndIf
	int iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[NewspaperManager]: Unable to get lock!", 2, False)
		return 
	EndIf
	Self.SetStage(5)
	If (NewspaperBuildings.find(akPlotRef, 0) < 0)
		int I = 0
		bool bSlotFound = False
		While (I < NewspaperBuildings.length && !bSlotFound)
			If (NewspaperBuildings[I] == None || NewspaperBuildings[I].IsDeleted())
				NewspaperBuildings[I] = akPlotRef
				bSlotFound = True
			EndIf
			I += 1
		EndWhile
	EndIf
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[NewspaperManager]: Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
	NewspaperBuildings = new simsettlementsv2:objectreferences:simplot[0]
	Self.RegisterForCustomEvent(PlotManager as ScriptObject, "simsettlementsv2:quests:plotmanager_PlotLevelChanged")
	Self.StartTimer(3, iTimerID_CompleteInitilization)
	Self.StartTimerGameTime(24, iTimerID_CheckArticles)
EndFunction
