;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\OptionsManager.psc
Modified : 2021-04-06 19:12:36
Compiled : 2021-04-06 19:17:50
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:OptionsManager extends SimSettlementsV2:Quests:ListManager conditional
{ Handles options in the mod so we can easily isolate global versus local options }

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const mandatory
	workshopframework:f4semanager Property F4SEManager Auto Const mandatory
	simsettlementsv2:quests:settlementmanager Property SettlementManager Auto Const mandatory
	simsettlementsv2:quests:empiremanager Property EmpireManager Auto Const mandatory
EndGroup

Group Defaults
	workshopframework:library:datastructures#globalsettingmap[] Property DefaultXboxSettings Auto Const mandatory
	{ These values will be set the first time a player loads the mod on Xbox }
	workshopframework:library:datastructures#globalsettingmap[] Property DefaultF4SESettings Auto Const mandatory
	{ These values will be set the first time a player loads the mod on PC if they have F4SE installed }
	workshopframework:library:datastructures#globalsettingmap[] Property InvolvementDefaults_None Auto Const mandatory
	workshopframework:library:datastructures#globalsettingmap[] Property InvolvementDefaults_Low Auto Const mandatory
	workshopframework:library:datastructures#globalsettingmap[] Property InvolvementDefaults_Moderate Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property PhantomVendor_Flags Auto Const mandatory
	ReferenceAlias Property PhantomVendorContainer_Flags Auto Const mandatory
	ReferenceAlias Property AvailableFlagsCacheContainer Auto Const mandatory
	ReferenceAlias Property PhantomVendor_LeaderCards Auto Const mandatory
	ReferenceAlias Property PhantomVendorContainer_LeaderCards Auto Const mandatory
	ReferenceAlias Property AvailableLeaderCardsCacheContainer Auto Const mandatory
	LocationAlias Property MessageLocationAlias Auto Const mandatory
	ReferenceAlias Property MessageLeaderAlias Auto Const mandatory
	ReferenceAlias[] Property TraitTypeHolders Auto Const mandatory
	{ Blank reference aliases for us to spawn and fill with objects to be displayed in leader messages }
	ReferenceAlias[] Property TraitNameHolders Auto Const mandatory
	{ Blank reference aliases for us to spawn and fill with objects to be displayed in leader messages }
	ReferenceAlias[] Property TraitTypeNameHolders Auto Const mandatory
	{ One of each trait type set up in order of iTraitType as defined in SimSettlementsV2:MiscObjects:LeaderTrait }
	ReferenceAlias Property TraitDetails_TypeHolderAlias Auto Const mandatory
	ReferenceAlias Property TraitDetails_NameHolderAlias Auto Const mandatory
	ReferenceAlias Property TraitDetails_DescriptionHolderAlias Auto Const mandatory
EndGroup

Group Assets
	Form Property SettlementOptionsForm Auto Const mandatory
	simsettlementsv2:miscobjects:themeruleset[] Property DefaultThemeRuleSets Auto Const
EndGroup

Group Formlists
	FormList Property BanList_BuildingPlans_LastGenerated Auto Const
	FormList Property BanList_BuildingPlans_Global Auto Const
	FormList Property AvailableFlags Auto Const mandatory
	FormList Property RegisteredHolidays Auto Const mandatory
	FormList Property AvailableLeaderCards Auto Const mandatory
	FormList Property RegisteredLeaderCards Auto Const mandatory
	FormList Property DeadLeaderCards Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property Settings_TaxRate Auto Const mandatory
	GlobalVariable Property Settings_Involvement Auto Const mandatory
	GlobalVariable Property MenuControl_LeaderMenuLabel Auto Const mandatory
	GlobalVariable Property MenuControl_LeaderMenu_ViewDetails Auto Const mandatory
	GlobalVariable[] Property PerformanceClasses Auto Const mandatory
	GlobalVariable Property AllPerformanceClassesEnabled Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property ThemeDefinitionKeyword Auto Const mandatory
	Keyword Property LeaderCardKeyword Auto Const mandatory
EndGroup

Group Messages
	Message Property Message_SettlementCustomizationInProgress Auto Const mandatory
	Message Property Message_ProblemDisplayingFlagSelect Auto Const mandatory
	Message Property Message_ProblemDisplayingLeaderSelect Auto Const mandatory
	Message Property Message_NoUniqueLeadersAvailable Auto Const mandatory
	Message Property Message_GeneratingLeaderList Auto Const mandatory
	Message Property Message_LeaderTraitDetails Auto Const mandatory
	Message[] Property Messages_LeaderConfirmation Auto Const mandatory
	{ Messages with a varying amount of trait lines, should be in order from 1 trait to X traits }
	Message Property Menu_SimpleProfileSelect Auto Const mandatory
	Message Property Menu_AutoRunProfileSelect Auto Const mandatory
	Message Property Message_OptionProfileApplied Auto Const mandatory
	Form[] Property DefaultOptionProfiles Auto Const mandatory
EndGroup

simsettlementsv2:miscobjects:themeruleset[] Property RegisteredThemeRuleSets Auto hidden
simsettlementsv2:datastructures#themerulesetactivedefinitionmap[] Property GlobalActiveThemeDefinitions Auto hidden
simsettlementsv2:objectreferences:settlementoptions[] Property SettlementOptionsStores Auto hidden
bool Property bPCUser = True Auto conditional hidden
bool Property bThemeTesting = False Auto hidden

;-- Variables ---------------------------------------
int iPerformanceClass_Containers = 8 Const
int iPerformanceClass_Animated = 3 Const
int iInvolvement_GlobalSettings = 3 Const
int iPerformanceClass_WaterPlanes = 10 Const
int iPerformanceClass_Clutter = 9 Const
bool bInitialProfileSelected = False
int iPerformanceClass_Actors = 7 Const
int iBarterMenu_LeaderCards = 2 Const
int iPerformanceClass_SoundEmitters = 6 Const
int iPerformanceClass_Effects = 4 Const
int iPerformanceClass_DetailedLight = 2 Const
int iLeaderMenuLabel_Commander = 1 Const
bool bSubBarterMenuOpened = False
int iPerformanceClass_DetailedModel = 1 Const
int iInvolvement_Low = 1 Const
int iInvolvement_Moderate = 2 Const
workshopscript kSelectingForWorkshop
int iLastUsedBarterMenu = -1
bool bIsDirty_BannedList = False
bool bLocalBanlistsConfigured = False
bool bOptionStoresUpdatingBlock = False
bool bReshowBarterMenu = False
int iBarterMenu_Flags = 1 Const
int iPerformanceClass_AnimationMarkers = 11 Const
int iInvolvement_None = 0 Const
int iLeaderMenuLabel_Leader = 0 Const
int iPerformanceClass_Radios = 5 Const

;-- Functions ---------------------------------------

simsettlementsv2:weapons:leadercard[] Function GetAllLeaderCardsForActor(Actor akActorRef)
	If (!akActorRef.GetActorBase().IsUnique())
		return None
	EndIf
	simsettlementsv2:weapons:leadercard[] Cards = new simsettlementsv2:weapons:leadercard[0]
	int I = 0
	While (I < AvailableLeaderCards.GetSize())
		simsettlementsv2:weapons:leadercard thisCard = AvailableLeaderCards.GetAt(I) as simsettlementsv2:weapons:leadercard
		If (thisCard != None && thisCard.GetActor() == akActorRef)
			Cards.add(thisCard, 1)
		EndIf
		I += 1
	EndWhile
	return Cards
EndFunction

Function RebuildLeaderCardsCache()
	ObjectReference kCacheContainer = AvailableLeaderCardsCacheContainer.GetRef()
	If (kCacheContainer)
		kCacheContainer.RemoveAllItems(None, False)
		int I = 0
		While (I < AvailableLeaderCards.GetSize())
			Form thisForm = AvailableLeaderCards.GetAt(I)
			If (thisForm != None && kCacheContainer.GetItemCount(thisForm) == 0)
				kCacheContainer.AddItem(thisForm, 1, False)
			EndIf
			I += 1
		EndWhile
	EndIf
EndFunction

Function ChangeGlobalTaxRate(int aiNewRate, bool abForcePlayerSettlementsToGlobalRate)
	float fMaxTaxRate = Math.Abs(WorkshopParent.happinessModifierMin)
	If (aiNewRate < 0)
		aiNewRate = 0
	ElseIf (aiNewRate as float > fMaxTaxRate)
		aiNewRate = fMaxTaxRate as int
	EndIf
	Settings_TaxRate.SetValueInt(aiNewRate)
	simsettlementsv2:objectreferences:settlementdata[] SettlementDataStores = SettlementManager.SettlementDataStores
	int I = 0
	While (I < SettlementDataStores.length)
		workshopscript thisWorkshop = SettlementDataStores[I].kWorkshopRef
		If (EmpireManager.DoesPlayerControlSettlement(thisWorkshop))
			If (abForcePlayerSettlementsToGlobalRate)
				Self.SetSettingValue(Settings_TaxRate, -1, I)
			EndIf
			If (Self.GetSettingValue(Settings_TaxRate, I) == -1)
				SettlementDataStores[I].UpdateTaxHappinessPenalty()
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction

Function RegisterThemeRuleSet(simsettlementsv2:miscobjects:themeruleset aThemeRuleSet)
	If (RegisteredThemeRuleSets.find(aThemeRuleSet, 0) < 0)
		RegisteredThemeRuleSets.add(aThemeRuleSet, 1)
	EndIf
EndFunction

Function RebuildFlagsCache()
	ObjectReference kFlagContainer = AvailableFlagsCacheContainer.GetRef()
	If (kFlagContainer)
		kFlagContainer.RemoveAllItems(None, False)
		int I = 0
		While (I < AvailableFlags.GetSize())
			Form thisFlagForm = AvailableFlags.GetAt(I)
			If (thisFlagForm != None && kFlagContainer.GetItemCount(thisFlagForm) == 0)
				kFlagContainer.AddItem(thisFlagForm, 1, False)
			EndIf
			I += 1
		EndWhile
	EndIf
EndFunction

Function SetActiveThemeDefinition(simsettlementsv2:armors:themedefinition aThemeDefinition, int aiWorkshopID)
	If (aThemeDefinition == None || aThemeDefinition.ThemeRuleSet == None)
		return 
	EndIf
	If (aThemeDefinition.ThemeRuleSet.bGlobalRuleset)
		If (GlobalActiveThemeDefinitions == None)
			GlobalActiveThemeDefinitions = new simsettlementsv2:datastructures#themerulesetactivedefinitionmap[0]
		EndIf
		int iIndex = GlobalActiveThemeDefinitions.findstruct("RuleSet", aThemeDefinition.ThemeRuleSet, 0)
		If (iIndex >= 0)
			GlobalActiveThemeDefinitions[iIndex].Definition = aThemeDefinition
		Else
			simsettlementsv2:datastructures#themerulesetactivedefinitionmap newMap = new simsettlementsv2:datastructures#themerulesetactivedefinitionmap
			newMap.RuleSet = aThemeDefinition.ThemeRuleSet
			newMap.Definition = aThemeDefinition
			GlobalActiveThemeDefinitions.add(newMap, 1)
		EndIf
	ElseIf (aiWorkshopID >= 0)
		simsettlementsv2:objectreferences:settlementoptions theseOptions = Self.GetSettlementOptionsStore(aiWorkshopID)
		If (theseOptions)
			If (theseOptions.ActiveThemeDefinitions == None)
				theseOptions.ActiveThemeDefinitions = new simsettlementsv2:datastructures#themerulesetactivedefinitionmap[0]
			EndIf
			int iindex = theseOptions.ActiveThemeDefinitions.findstruct("RuleSet", aThemeDefinition.ThemeRuleSet, 0)
			If (iindex >= 0)
				theseOptions.ActiveThemeDefinitions[iindex].Definition = aThemeDefinition
			Else
				simsettlementsv2:datastructures#themerulesetactivedefinitionmap newmap = new simsettlementsv2:datastructures#themerulesetactivedefinitionmap
				newmap.RuleSet = aThemeDefinition.ThemeRuleSet
				newmap.Definition = aThemeDefinition
				theseOptions.ActiveThemeDefinitions.add(newmap, 1)
			EndIf
		EndIf
	EndIf
EndFunction

Function ChangePerformanceClassSetting(int aiClass, bool abEnable)
	int iIndex = aiClass - 1
	If (PerformanceClasses.length > iIndex)
		PerformanceClasses[iIndex].SetValueInt(abEnable as int)
	EndIf
	If (abEnable)
		int I = 0
		While (I < PerformanceClasses.length)
			iIndex = I + 1
			If (!Self.IsPerformanceClassEnabled(iIndex))
				return 
			EndIf
			I += 1
		EndWhile
		AllPerformanceClassesEnabled.SetValueInt(1)
	Else
		AllPerformanceClassesEnabled.SetValueInt(0)
	EndIf
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
	Self.SetupOptionStores()
	bPCUser = True
	If (Debug.GetPlatformName() != "Target File Unknown")
		bPCUser = False
	EndIf
	Self.SetupDefaultOptionsForSystem()
	Self.SetupDefaultOptionsProfile()
EndFunction

Function ShowFlagSelect(workshopscript akWorkshopRef)
	If (kSelectingForWorkshop != None)
		Message_SettlementCustomizationInProgress.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		return 
	EndIf
	If (!akWorkshopRef)
		Message_ProblemDisplayingFlagSelect.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		return 
	EndIf
	kSelectingForWorkshop = akWorkshopRef
	Actor kVendorRef = PhantomVendor_Flags.GetActorRef()
	ObjectReference kVendorContainerRef = PhantomVendorContainer_Flags.GetRef()
	If (kVendorRef)
		ObjectReference kFlagCache = AvailableFlagsCacheContainer.GetRef()
		If (kFlagCache.GetItemCount(None) == 0)
			Self.RebuildFlagsCache()
		EndIf
		kFlagCache.SetActorRefOwner(PlayerRef, False)
		kFlagCache.RemoveItem(ThemeDefinitionKeyword as Form, -1, True, kVendorContainerRef)
		Self.RegisterForMenuOpenCloseEvent("BarterMenu")
		iLastUsedBarterMenu = iBarterMenu_Flags
		kVendorRef.ShowBarterMenu()
	Else
		Debug.MessageBox("Could not find flag vendor")
		kSelectingForWorkshop = None
	EndIf
EndFunction

simsettlementsv2:armors:themedefinition Function GetActiveThemeDefinition(simsettlementsv2:miscobjects:themeruleset aThemeRuleSet, int aiWorkshopID)
	If (aThemeRuleSet == None)
		return None
	EndIf
	If (aThemeRuleSet.bGlobalRuleset)
		int iIndex = GlobalActiveThemeDefinitions.findstruct("RuleSet", aThemeRuleSet, 0)
		If (iIndex >= 0)
			return GlobalActiveThemeDefinitions[iIndex].Definition
		EndIf
	ElseIf (aiWorkshopID >= 0)
		simsettlementsv2:objectreferences:settlementoptions theseOptions = Self.GetSettlementOptionsStore(aiWorkshopID)
		If (theseOptions)
			int iindex = theseOptions.ActiveThemeDefinitions.findstruct("RuleSet", aThemeRuleSet, 0)
			If (iindex >= 0)
				return theseOptions.ActiveThemeDefinitions[iindex].Definition
			EndIf
		EndIf
	EndIf
	return None
EndFunction

Event Actor.OnDeath(Actor akSender, Actor akKiller)
	simsettlementsv2:weapons:leadercard[] ActorCards = Self.GetAllLeaderCardsForActor(akSender)
	ObjectReference kCacheContainer = AvailableLeaderCardsCacheContainer.GetRef()
	int I = 0
	While (I < ActorCards.length)
		DeadLeaderCards.AddForm(ActorCards[I] as Form)
		AvailableLeaderCards.RemoveAddedForm(ActorCards[I] as Form)
		kCacheContainer.RemoveItem(ActorCards[I] as Form, -1, False, None)
		I += 1
	EndWhile
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnDeath")
EndEvent

Function SetupDefaultOptionsForSystem()
	If (!bPCUser)
		int I = 0
		While (I < DefaultXboxSettings.length)
			DefaultXboxSettings[I].GlobalForm.SetValue(DefaultXboxSettings[I].fValue)
			I += 1
		EndWhile
	ElseIf (F4SEManager.IsF4SERunning)
		int i = 0
		While (i < DefaultF4SESettings.length)
			DefaultF4SESettings[i].GlobalForm.SetValue(DefaultF4SESettings[i].fValue)
			i += 1
		EndWhile
	EndIf
EndFunction

Function ClearLocalSetting(GlobalVariable aSetting, int aiWorkshopID)
	simsettlementsv2:objectreferences:settlementoptions thisOptionsStore = Self.GetSettlementOptionsStore(aiWorkshopID)
	If (thisOptionsStore)
		thisOptionsStore.ClearLocalSetting(aSetting)
	EndIf
EndFunction

simsettlementsv2:weapons:leadercard Function GetLeaderCardForActor(Actor akActorRef)
	If (!akActorRef.GetActorBase().IsUnique())
		return None
	EndIf
	int I = 0
	While (I < AvailableLeaderCards.GetSize())
		simsettlementsv2:weapons:leadercard thisCard = AvailableLeaderCards.GetAt(I) as simsettlementsv2:weapons:leadercard
		If (thisCard != None && thisCard.GetActor() == akActorRef)
			return thisCard
		EndIf
		I += 1
	EndWhile
	return None
EndFunction

Function ConfigureInvolvementSettings(workshopscript akWorkshopRef, int aiInvolvementValue)
	If (akWorkshopRef == None)
		return 
	EndIf
	int iPreviousInvolvement = Settings_Involvement.GetValueInt()
	If (aiInvolvementValue == iPreviousInvolvement)
		return 
	EndIf
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	simsettlementsv2:objectreferences:settlementoptions thisOptionsStore = Self.GetSettlementOptionsStore(iWorkshopID)
	If (aiInvolvementValue == iInvolvement_GlobalSettings)
		workshopframework:library:datastructures#globalsettingmap[] ResetMe = new workshopframework:library:datastructures#globalsettingmap[0]
		If (iPreviousInvolvement == iInvolvement_None)
			ResetMe = InvolvementDefaults_None
		ElseIf (iPreviousInvolvement == iInvolvement_Low)
			ResetMe = InvolvementDefaults_Low
		ElseIf (iPreviousInvolvement == iInvolvement_Moderate)
			ResetMe = InvolvementDefaults_Moderate
		EndIf
		int I = 0
		While (I < ResetMe.length)
			thisOptionsStore.ClearLocalSetting(ResetMe[I].GlobalForm)
			I += 1
		EndWhile
	Else
		workshopframework:library:datastructures#globalsettingmap[] ApplyMe = new workshopframework:library:datastructures#globalsettingmap[0]
		If (aiInvolvementValue == iInvolvement_None)
			ApplyMe = InvolvementDefaults_None
		ElseIf (aiInvolvementValue == iInvolvement_Low)
			ApplyMe = InvolvementDefaults_Low
		ElseIf (aiInvolvementValue == iInvolvement_Moderate)
			ApplyMe = InvolvementDefaults_Moderate
		EndIf
		int i = 0
		While (i < ApplyMe.length)
			thisOptionsStore.SetSettingValue(ApplyMe[i].GlobalForm, ApplyMe[i].fValue)
			i += 1
		EndWhile
	EndIf
EndFunction

Function SetupDefaultOptionsProfile()
	int iDifficulty = Game.GetDifficulty()
	int iProfileIndex = 1
	If (iDifficulty <= 1)
		iProfileIndex = 0
	ElseIf (iDifficulty < 5)
		iProfileIndex = 1
	Else
		iProfileIndex = 2
	EndIf
	simsettlementsv2:miscobjects:optionsprofile DefaultProfile = DefaultOptionProfiles[iProfileIndex] as simsettlementsv2:miscobjects:optionsprofile
	DefaultProfile.ApplyOptionsProfile()
EndFunction

simsettlementsv2:datastructures#indexedformlist Function GetBannedPlanList(workshopscript akWorkshopRef)
	simsettlementsv2:datastructures#indexedformlist SortingList = Self.RequestSortingList()
	return SortingList
EndFunction

Function RegisterLeaderCard(Form aCard)
	simsettlementsv2:weapons:leadercard thisCard = aCard as simsettlementsv2:weapons:leadercard
	If (thisCard as bool && !AvailableLeaderCards.HasForm(thisCard as Form) && !RegisteredLeaderCards.HasForm(thisCard as Form) && !DeadLeaderCards.HasForm(thisCard as Form))
		RegisteredLeaderCards.AddForm(thisCard as Form)
	EndIf
EndFunction

float Function GetSettingValue(GlobalVariable aSetting, int aiWorkshopID)
	If (aiWorkshopID >= 0)
		simsettlementsv2:objectreferences:settlementoptions thisOptionsStore = Self.GetSettlementOptionsStore(aiWorkshopID)
		If (thisOptionsStore)
			return thisOptionsStore.GetSettingValue(aSetting)
		EndIf
	EndIf
	return aSetting.GetValue()
EndFunction

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
	Self.SetupOptionStores()
	Self.CleanThemeRuleSets()
	int I = 0
	While (I < DefaultThemeRuleSets.length)
		Self.RegisterThemeRuleSet(DefaultThemeRuleSets[I])
		I += 1
	EndWhile
EndFunction

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
	If (asMenuName == "BarterMenu" && !abOpening)
		bSubBarterMenuOpened = False
		Self.ProcessBarterSelection()
	EndIf
EndEvent

Function HandleInstallModChanges()
	int iHotfix102aVersion = 16
	If (iInstalledVersion < iHotfix102aVersion)
		Self.FreeAllSortingLists()
	EndIf
EndFunction

Function ApplyUpdateChanges(simsettlementsv2:objectreferences:settlementoptions aDataStore)
	; Empty function
EndFunction

Function DebugAvailableLeaderCards()
	Debug.MessageBox("Beginning debug of " + RegisteredLeaderCards.GetSize() as string + " registered cards. See " + simsettlementsv2:utilityfunctions.GetLogName() + " for additional details.")
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Starting debug output of RegisteredLeaderCards formlist " + RegisteredLeaderCards as string, 0, False)
	int I = 0
	While (I < RegisteredLeaderCards.GetSize())
		Form CardForm = RegisteredLeaderCards.GetAt(I)
		simsettlementsv2:weapons:leadercard thisCard = CardForm as simsettlementsv2:weapons:leadercard
		If (thisCard)
			Actor thisActor = thisCard.GetActor()
			If (!thisActor)
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Failed to find actor for LeaderCard: " + thisCard as string, 0, False)
			ElseIf (SettlementManager.IsActorEligibleToLead(thisActor, None, thisCard, True, True))
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), thisActor as string + " is eligible to lead with LeaderCard: " + thisCard as string, 0, False)
			Else
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "SettlementManager.IsActorEligibleToLead check failed for " + thisCard as string, 0, False)
			EndIf
		Else
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Could not cast card as SimSettlementsV2:Weapons:LeaderCard " + CardForm as string, 0, False)
		EndIf
		I += 1
	EndWhile
	Debug.MessageBox("Completed debug of " + RegisteredLeaderCards.GetSize() as string + " registered cards.")
EndFunction

Function ClearThemeTestingFlag()
	bThemeTesting = False
EndFunction

Function TestThemeChange(simsettlementsv2:armors:themedefinition aTheme, int aiWorkshopID, bool abForceUpdate)
	If (aiWorkshopID < 0)
		workshopscript kNearestWorkshop = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
		aiWorkshopID = kNearestWorkshop.GetWorkshopID()
	EndIf
	Self.SetActiveThemeDefinition(aTheme, aiWorkshopID)
	bThemeTesting = True
	If (abForceUpdate)
		SettlementManager.UpdateThemeControlledObjects(aiWorkshopID)
	EndIf
EndFunction

Function CheckForAutoActiveThemeRuleSetDefinitionChanges()
	int I = 0
	While (I < RegisteredThemeRuleSets.length)
		If (RegisteredThemeRuleSets[I].bGlobalRuleset)
			simsettlementsv2:armors:themedefinition GlobalActiveOverride = RegisteredThemeRuleSets[I].GetAutoActiveDefinitionChange(None)
			If (GlobalActiveOverride != None)
				Self.SetActiveThemeDefinition(GlobalActiveOverride, -1)
			ElseIf (RegisteredThemeRuleSets[I].bClearIfNoAutoActiveDefinition)
				Self.ClearActiveThemeDefinition(RegisteredThemeRuleSets[I], -1)
			EndIf
		Else
			int j = 0
			While (j < SettlementOptionsStores.length)
				simsettlementsv2:armors:themedefinition ActiveOverride = RegisteredThemeRuleSets[I].GetAutoActiveDefinitionChange(SettlementOptionsStores[j].kWorkshopRef)
				If (ActiveOverride != None)
					Self.SetActiveThemeDefinition(ActiveOverride, j)
				ElseIf (RegisteredThemeRuleSets[I].bClearIfNoAutoActiveDefinition)
					Self.ClearActiveThemeDefinition(RegisteredThemeRuleSets[I], j)
				EndIf
				j += 1
			EndWhile
		EndIf
		I += 1
	EndWhile
EndFunction

simsettlementsv2:objectreferences:settlementoptions Function GetSettlementOptionsStore(int aiWorkshopID)
	simsettlementsv2:objectreferences:settlementoptions kOptionsStoreRef = None
	If (aiWorkshopID < 0)
		return None
	EndIf
	If (SettlementOptionsStores as bool && SettlementOptionsStores.length > aiWorkshopID)
		kOptionsStoreRef = SettlementOptionsStores[aiWorkshopID]
	Else
		kOptionsStoreRef = Self.ConfigureSetlementOptionsStore(aiWorkshopID, True)
	EndIf
	return kOptionsStoreRef
EndFunction

Function ProcessBarterSelection()
	Self.UnregisterForMenuOpenCloseEvent("BarterMenu")
	ObjectReference kVendorContainerRef = None
	bReshowBarterMenu = False
	If (iLastUsedBarterMenu == iBarterMenu_Flags)
		Self.ProcessFlagSelection()
		kVendorContainerRef = PhantomVendorContainer_Flags.GetRef()
	ElseIf (iLastUsedBarterMenu == iBarterMenu_LeaderCards)
		Self.ProcessLeaderCardSelection()
		kVendorContainerRef = PhantomVendorContainer_LeaderCards.GetRef()
	EndIf
	If (!bSubBarterMenuOpened)
		kVendorContainerRef.RemoveItem(ThemeDefinitionKeyword as Form, -1, True, None)
		PlayerRef.RemoveItem(ThemeDefinitionKeyword as Form, -1, True, None)
		kVendorContainerRef.RemoveItem(LeaderCardKeyword as Form, -1, True, None)
		PlayerRef.RemoveItem(LeaderCardKeyword as Form, -1, True, None)
		If (bReshowBarterMenu)
			var[] kArgs = new var[1]
			kArgs[0] = kSelectingForWorkshop as var
			string sFunctionName = ""
			kSelectingForWorkshop = None
			If (iLastUsedBarterMenu == iBarterMenu_Flags)
				sFunctionName = "ShowFlagSelect"
			ElseIf (iLastUsedBarterMenu == iBarterMenu_LeaderCards)
				sFunctionName = "ShowLeaderSelect"
			EndIf
			Self.CallFunctionNoWait(sFunctionName, kArgs)
		Else
			kSelectingForWorkshop = None
		EndIf
	EndIf
EndFunction

Function DumpAllOptionsByVariable(string asVarName)
	string sLogName = simsettlementsv2:utilityfunctions.GetLogName()
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, "============= Dumping variable: " + asVarName + " for all settlements =============", 0, False)
	int I = 0
	While (I < SettlementOptionsStores.length)
		workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, asVarName + ": " + SettlementOptionsStores[I].GetPropertyValue(asVarName) as string, 0, False)
		I += 1
	EndWhile
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, "============= End Dumping variable: " + asVarName + " =============", 0, False)
EndFunction

Function ClearActiveThemeDefinition(simsettlementsv2:miscobjects:themeruleset aThemeRuleSet, int aiWorkshopID)
	If (aiWorkshopID >= 0)
		simsettlementsv2:objectreferences:settlementoptions theseOptions = Self.GetSettlementOptionsStore(aiWorkshopID)
		If (theseOptions)
			int iIndex = theseOptions.ActiveThemeDefinitions.findstruct("RuleSet", aThemeRuleSet, 0)
			If (iIndex >= 0)
				theseOptions.ActiveThemeDefinitions[iIndex].Definition = None
			EndIf
		EndIf
	Else
		int iindex = GlobalActiveThemeDefinitions.findstruct("RuleSet", aThemeRuleSet, 0)
		If (iindex >= 0)
			GlobalActiveThemeDefinitions[iindex].Definition = None
		EndIf
	EndIf
EndFunction

Function DumpOptionsStore(workshopscript akWorkshopRef)
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	simsettlementsv2:objectreferences:settlementoptions thisOptionsStore = SettlementOptionsStores[iWorkshopID]
	string sLogName = simsettlementsv2:utilityfunctions.GetLogName()
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, "============= Starting Settlement Options Dump [DataStore: " + thisOptionsStore as string + "] [Workshop: " + akWorkshopRef as string + "] =============", 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, "LocalSettings: " + thisOptionsStore.LocalSettings as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, "ActiveThemeDefinitions: " + thisOptionsStore.ActiveThemeDefinitions as string, 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, "============= End Settlement Options Dump [" + akWorkshopRef as string + "] =============", 0, False)
EndFunction

Function ChangeLocalTaxRate(workshopscript akWorkshopRef, int aiNewRate)
	If (akWorkshopRef == None)
		return 
	EndIf
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	simsettlementsv2:objectreferences:settlementdata thisDataStore = SettlementManager.GetSettlementDataStore(iWorkshopID)
	float fMaxTaxRate = Math.Abs(WorkshopParent.happinessModifierMin)
	If (aiNewRate < 0)
		aiNewRate = 0
	ElseIf (aiNewRate as float > fMaxTaxRate)
		aiNewRate = fMaxTaxRate as int
	EndIf
	Self.SetSettingValue(Settings_TaxRate, aiNewRate as float, iWorkshopID)
	thisDataStore.UpdateTaxHappinessPenalty()
EndFunction

Function ProcessLeaderCardSelection()
	bReshowBarterMenu = False
	ObjectReference kVendorContainerRef = PhantomVendorContainer_Flags.GetRef()
	ObjectReference kCacheContainer = AvailableLeaderCardsCacheContainer.GetRef()
	kVendorContainerRef.RemoveItem(LeaderCardKeyword as Form, -1, True, kCacheContainer)
	simsettlementsv2:datastructures#indexedformlist thisSortingList = Self.RequestSortingList()
	int I = 0
	int iSelectedCards = PlayerRef.GetItemCount(AvailableLeaderCards as Form)
	While (I < AvailableLeaderCards.GetSize())
		Form thisForm = AvailableLeaderCards.GetAt(I)
		If (PlayerRef.GetItemCount(thisForm) > 0 && (thisForm as simsettlementsv2:weapons:leadercard) as bool && SettlementManager.IsActorEligibleToLead((thisForm as simsettlementsv2:weapons:leadercard).GetActor(), kSelectingForWorkshop, thisForm as simsettlementsv2:weapons:leadercard, True, iSelectedCards == 1))
			thisSortingList.IndexedList.AddForm(thisForm)
		EndIf
		I += 1
	EndWhile
	int iSize = thisSortingList.IndexedList.GetSize()
	If (iSize > 0)
		int iRandomIndex = Utility.RandomInt(0, iSize - 1)
		simsettlementsv2:weapons:leadercard SelectedCard = thisSortingList.IndexedList.GetAt(iRandomIndex) as simsettlementsv2:weapons:leadercard
		Actor thisActor = SelectedCard.GetActor()
		If (Self.ShowLeaderConfirmationMessage(thisActor, kSelectingForWorkshop, SelectedCard))
			SettlementManager.AssignLeader(thisActor, kSelectingForWorkshop, SelectedCard, True)
		Else
			bReshowBarterMenu = True
		EndIf
	EndIf
	PlayerRef.RemoveItem(LeaderCardKeyword as Form, -1, True, kCacheContainer)
	Self.FreeSortingList(thisSortingList.iListIndex)
EndFunction

Function ShowTraitArrayDetails(simsettlementsv2:miscobjects:leadertrait[] aTraits, int aiDisplayIndex)
	ObjectReference kSpawnAt = SafeSpawnPoint.GetRef()
	If (aiDisplayIndex >= aTraits.length)
		aiDisplayIndex = aTraits.length - 1
	EndIf
	TraitDetails_TypeHolderAlias.ForceRefTo(TraitTypeHolders[aTraits[aiDisplayIndex].iType].GetRef())
	ObjectReference kTraitName = kSpawnAt.PlaceAtMe(aTraits[aiDisplayIndex] as Form, 1, False, False, True)
	TraitDetails_NameHolderAlias.ForceRefTo(kTraitName)
	ObjectReference kTraitDescription = kSpawnAt.PlaceAtMe(aTraits[aiDisplayIndex].TraitDescriptionHolder, 1, False, False, True)
	TraitDetails_DescriptionHolderAlias.ForceRefTo(kTraitDescription)
	int iConfirm = Message_LeaderTraitDetails.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	If (iConfirm == 0)
		int iNextIndex = aiDisplayIndex + 1
		If (iNextIndex >= aTraits.length)
			iNextIndex = 0
		EndIf
		Self.ShowTraitArrayDetails(aTraits, iNextIndex)
	ElseIf (iConfirm == 1)
		int iPreviousIndex = aiDisplayIndex - 1
		If (iPreviousIndex < 0)
			iPreviousIndex = aTraits.length - 1
		EndIf
		Self.ShowTraitArrayDetails(aTraits, iPreviousIndex)
	Else
		return 
	EndIf
EndFunction

bool Function ShowLeaderConfirmationMessage(Actor akActorRef, workshopscript akWorkshopRef, simsettlementsv2:weapons:leadercard aCard)
	MenuControl_LeaderMenuLabel.SetValueInt(iLeaderMenuLabel_Leader)
	simsettlementsv2:miscobjects:leadertrait[] LeaderTraits = new simsettlementsv2:miscobjects:leadertrait[0]
	If (aCard != None)
		LeaderTraits = aCard.GetTraits()
	EndIf
	If (LeaderTraits.length > 0)
		MenuControl_LeaderMenu_ViewDetails.SetValueInt(1)
	Else
		MenuControl_LeaderMenu_ViewDetails.SetValueInt(0)
	EndIf
	Location SettlementLocation = akWorkshopRef.myLocation
	If (SettlementLocation == None)
		SettlementLocation = akWorkshopRef.GetCurrentLocation()
	EndIf
	MessageLocationAlias.ForceLocationTo(SettlementLocation)
	MessageLeaderAlias.ForceRefTo(akActorRef as ObjectReference)
	ObjectReference kSpawnAt = SafeSpawnPoint.GetRef()
	int I = 0
	While (I < LeaderTraits.length)
		ObjectReference kNameRef = kSpawnAt.PlaceAtMe(LeaderTraits[I] as Form, 1, False, False, True)
		TraitNameHolders[I].ForceRefTo(kNameRef)
		TraitTypeHolders[I].ForceRefTo(TraitTypeNameHolders[LeaderTraits[I].iType].GetRef())
		I += 1
	EndWhile
	int iMessageIndex = LeaderTraits.length
	If (iMessageIndex >= Messages_LeaderConfirmation.length)
		iMessageIndex = Messages_LeaderConfirmation.length - 1
	EndIf
	bool bSelected = False
	bool bReshow = False
	int iConfirm = Messages_LeaderConfirmation[iMessageIndex].Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	If (iConfirm == 0)
		bSelected = False
	ElseIf (iConfirm == 1)
		Self.ShowTraitArrayDetails(LeaderTraits, 0)
		bReshow = True
	Else
		bSelected = True
	EndIf
	I = 0
	While (I < TraitNameHolders.length)
		TraitNameHolders[I].Clear()
		I += 1
	EndWhile
	I = 0
	While (I < TraitTypeHolders.length)
		TraitTypeHolders[I].Clear()
		I += 1
	EndWhile
	If (bReshow)
		return Self.ShowLeaderConfirmationMessage(akActorRef, akWorkshopRef, aCard)
	EndIf
	return bSelected
EndFunction

Function UpdateAvailableLeaderCards()
	int I = RegisteredLeaderCards.GetSize()
	While (I > 0)
		int iIndex = I - 1
		Form CardForm = RegisteredLeaderCards.GetAt(iIndex)
		simsettlementsv2:weapons:leadercard thisCard = CardForm as simsettlementsv2:weapons:leadercard
		If (thisCard)
			Actor thisActor = thisCard.GetActor()
			If (thisActor)
				If (SettlementManager.IsActorEligibleToLead(thisActor, None, thisCard, False, False))
					AvailableLeaderCards.AddForm(thisCard as Form)
					RegisteredLeaderCards.RemoveAddedForm(thisCard as Form)
					Self.RegisterForRemoteEvent(thisActor as ScriptObject, "OnDeath")
				EndIf
			EndIf
		EndIf
		I -= 1
	EndWhile
EndFunction

Function ShowLeaderSelect(workshopscript akWorkshopRef)
	If (kSelectingForWorkshop != None)
		Message_SettlementCustomizationInProgress.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		return 
	EndIf
	If (!akWorkshopRef)
		Message_ProblemDisplayingLeaderSelect.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		return 
	EndIf
	kSelectingForWorkshop = akWorkshopRef
	Actor kVendorRef = PhantomVendor_LeaderCards.GetActorRef()
	ObjectReference kVendorContainerRef = PhantomVendorContainer_LeaderCards.GetRef()
	If (kVendorRef)
		Message_GeneratingLeaderList.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		ObjectReference kCacheContainer = AvailableLeaderCardsCacheContainer.GetRef()
		If (kCacheContainer.GetItemCount(None) == 0)
			Self.RebuildLeaderCardsCache()
		EndIf
		kCacheContainer.SetActorRefOwner(PlayerRef, False)
		kCacheContainer.RemoveItem(LeaderCardKeyword as Form, -1, True, kVendorContainerRef)
		simsettlementsv2:objectreferences:settlementdata[] DataStores = SettlementManager.SettlementDataStores
		int I = 0
		While (I < DataStores.length)
			If (DataStores[I].SettlementLeader != None)
				simsettlementsv2:weapons:leadercard[] ActorCards = Self.GetAllLeaderCardsForActor(DataStores[I].SettlementLeader)
				int j = 0
				While (j < ActorCards.length)
					kVendorContainerRef.RemoveItem(ActorCards[I] as Form, -1, True, kCacheContainer)
					j += 1
				EndWhile
			EndIf
			I += 1
		EndWhile
		If (kVendorContainerRef.GetItemCount(None) == 0)
			kSelectingForWorkshop = None
			kVendorContainerRef.RemoveItem(LeaderCardKeyword as Form, -1, True, kCacheContainer)
			Message_NoUniqueLeadersAvailable.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
			return 
		EndIf
		Self.RegisterForMenuOpenCloseEvent("BarterMenu")
		iLastUsedBarterMenu = iBarterMenu_LeaderCards
		kVendorRef.ShowBarterMenu()
	Else
		Debug.MessageBox("Could not find leader card vendor")
		kSelectingForWorkshop = None
	EndIf
EndFunction

Function HolotapeLoaded()
	If (!bInitialProfileSelected)
		bInitialProfileSelected = True
		int iConfirm = Menu_AutoRunProfileSelect.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		If (iConfirm == 0)
			Message_OptionProfileApplied.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
			return 
		Else
			Self.ShowProfileSelect()
		EndIf
	EndIf
EndFunction

Function SetupOptionStores()
	If (bOptionStoresUpdatingBlock)
		return 
	EndIf
	bOptionStoresUpdatingBlock = True
	int iLoopCounter = 0
	While (!WorkshopParent.Initialized && iLoopCounter < 10)
		iLoopCounter += 1
		Utility.Wait(5)
	EndWhile
	int iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "SetupOptionStores: Unable to get lock!", 2, False)
		return 
	EndIf
	If (SettlementOptionsStores == None || SettlementOptionsStores.length == 0)
		SettlementOptionsStores = new simsettlementsv2:objectreferences:settlementoptions[0]
	EndIf
	workshopscript[] Workshops = WorkshopParent.Workshops
	int I = 0
	While (I < Workshops.length)
		Self.ConfigureSetlementOptionsStore(I, False)
		I += 1
	EndWhile
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "SetupOptionStores: Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
	bOptionStoresUpdatingBlock = False
EndFunction

Function CleanThemeRuleSets()
	If (!RegisteredThemeRuleSets || RegisteredThemeRuleSets.length == 0)
		RegisteredThemeRuleSets = new simsettlementsv2:miscobjects:themeruleset[0]
	Else
		simsettlementsv2:miscobjects:themeruleset[] Temp = new simsettlementsv2:miscobjects:themeruleset[0]
		int I = RegisteredThemeRuleSets.length - 1
		While (I >= 0)
			If (RegisteredThemeRuleSets[I] != None && RegisteredThemeRuleSets[I].GetFormID() != 0)
				Temp.add(RegisteredThemeRuleSets[I], 1)
			EndIf
			I -= 1
		EndWhile
		RegisteredThemeRuleSets = Temp
	EndIf
EndFunction

Function ProcessFlagSelection()
	ObjectReference kVendorContainerRef = PhantomVendorContainer_Flags.GetRef()
	ObjectReference kFlagCache = AvailableFlagsCacheContainer.GetRef()
	kVendorContainerRef.RemoveItem(ThemeDefinitionKeyword as Form, -1, True, kFlagCache)
	simsettlementsv2:datastructures#indexedformlist thisSortingList = Self.RequestSortingList()
	int I = 0
	While (I < AvailableFlags.GetSize())
		Form thisForm = AvailableFlags.GetAt(I)
		If (PlayerRef.GetItemCount(thisForm) > 0 && (thisForm as simsettlementsv2:armors:themedefinition_flags) as bool)
			thisSortingList.IndexedList.AddForm(thisForm)
		EndIf
		I += 1
	EndWhile
	int iSize = thisSortingList.IndexedList.GetSize()
	If (iSize > 0)
		int iRandomIndex = Utility.RandomInt(0, iSize - 1)
		int iWorkshopID = kSelectingForWorkshop.GetWorkshopID()
		simsettlementsv2:armors:themedefinition_flags SelectedTheme = thisSortingList.IndexedList.GetAt(iRandomIndex) as simsettlementsv2:armors:themedefinition_flags
		If (SelectedTheme as simsettlementsv2:armors:themedefinition != Self.GetActiveThemeDefinition(SelectedTheme.ThemeRuleSet, iWorkshopID))
			Self.SetActiveThemeDefinition(SelectedTheme as simsettlementsv2:armors:themedefinition, iWorkshopID)
			SettlementManager.UpdateThemeControlledObjects(iWorkshopID)
		EndIf
	EndIf
	PlayerRef.RemoveItem(ThemeDefinitionKeyword as Form, -1, True, kFlagCache)
	Self.FreeSortingList(thisSortingList.iListIndex)
EndFunction

simsettlementsv2:objectreferences:settlementoptions Function ConfigureSetlementOptionsStore(int aiWorkshopID, bool abGetLock)
	int iLockKey = 0
	If (abGetLock)
		iLockKey = Self.GetLock(0, True)
		If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "ConfigureSetlementOptionsStore: Unable to get lock!", 2, False)
			return None
		EndIf
	EndIf
	If (!SettlementOptionsStores)
		SettlementOptionsStores = new simsettlementsv2:objectreferences:settlementoptions[0]
	EndIf
	If (SettlementOptionsStores.length < aiWorkshopID)
		int I = SettlementOptionsStores.length
		While (I < aiWorkshopID)
			Self.ConfigureSetlementOptionsStore(I, True)
			I += 1
		EndWhile
	EndIf
	If (SettlementOptionsStores.length > aiWorkshopID && SettlementOptionsStores[aiWorkshopID] != None && SettlementOptionsStores[aiWorkshopID].IsBoundGameObjectAvailable())
		Self.ApplyUpdateChanges(SettlementOptionsStores[aiWorkshopID])
	Else
		ObjectReference kSpawnPoint = SafeSpawnPoint.GetRef()
		If (kSpawnPoint)
			simsettlementsv2:objectreferences:settlementoptions kOptionsStoreRef = kSpawnPoint.PlaceAtMe(SettlementOptionsForm, 1, True, False, False) as simsettlementsv2:objectreferences:settlementoptions
			If (kOptionsStoreRef)
				kOptionsStoreRef.kWorkshopRef = WorkshopParent.GetWorkshop(aiWorkshopID)
				If (SettlementOptionsStores.length > aiWorkshopID)
					SettlementOptionsStores[aiWorkshopID] = kOptionsStoreRef
				Else
					SettlementOptionsStores.add(kOptionsStoreRef, 1)
				EndIf
				If (SettlementOptionsStores.length > aiWorkshopID)
					SettlementOptionsStores[aiWorkshopID].Disable(False)
					SettlementOptionsStores[aiWorkshopID].Delete()
					SettlementOptionsStores[aiWorkshopID] = kOptionsStoreRef
				Else
					SettlementOptionsStores.add(kOptionsStoreRef, 1)
				EndIf
			EndIf
		EndIf
	EndIf
	If (abGetLock)
		If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "ConfigureSetlementOptionsStore: Failed to release lock " + iLockKey as string + "!", 2, False)
		EndIf
	EndIf
	return SettlementOptionsStores[aiWorkshopID]
EndFunction

Function SetSettingValue(GlobalVariable aSetting, float afValue, int aiWorkshopID)
	If (aiWorkshopID >= 0)
		simsettlementsv2:objectreferences:settlementoptions thisOptionsStore = Self.GetSettlementOptionsStore(aiWorkshopID)
		If (thisOptionsStore)
			thisOptionsStore.SetSettingValue(aSetting, afValue)
		EndIf
	Else
		aSetting.SetValue(afValue)
	EndIf
EndFunction

bool Function IsPerformanceClassEnabled(int aiPerformanceClass)
	int iIndex = aiPerformanceClass - 1
	If (PerformanceClasses.length > iIndex)
		return PerformanceClasses[iIndex].GetValueInt() == 1
	EndIf
	return True
EndFunction

Function ShowProfileSelect()
	int iConfirm = Menu_SimpleProfileSelect.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	If (iConfirm == 0)
		
	ElseIf (iConfirm <= DefaultOptionProfiles.length)
		int iChosenProfileIndex = iConfirm - 1
		simsettlementsv2:miscobjects:optionsprofile ChosenProfile = DefaultOptionProfiles[iChosenProfileIndex] as simsettlementsv2:miscobjects:optionsprofile
		iConfirm = ChosenProfile.ProfileConfirmation.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		If (iConfirm == 1)
			ChosenProfile.ApplyOptionsProfile()
			Message_OptionProfileApplied.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		EndIf
	EndIf
EndFunction

Function RegisterLeaderCards(FormList aCardList)
	int I = 0
	While (I < aCardList.GetSize())
		Self.RegisterLeaderCard(aCardList.GetAt(I))
		I += 1
	EndWhile
EndFunction
