;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\OutfitManager.psc
Modified : 2020-08-01 01:59:11
Compiled : 2021-01-07 11:43:28
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:OutfitManager extends WorkshopFramework:Library:SlaveQuest conditional
{ Handles Outfit related tasks }

;-- Properties --------------------------------------
Group HotSwaps
	simsettlementsv2:datastructures#hotswapomod[] Property DefaultHotSwaps Auto Const mandatory
EndGroup

Group JakesOutfit
	Weapon Property Laser44Form Auto Const mandatory
	Keyword Property HasLaser44EquippedKeyword Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
string sHotswapID_JakesHolster = "JakesHolster" Const
Actor[] RecentlyUnequippedActors

;-- Functions ---------------------------------------

Function UnregisterWearer(Actor akActor)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Unregistering wearer of Jake's Holster: " + akActor as string, 0, False)
	Self.UnregisterForAnimationEvent(akActor as ObjectReference, "WeapEquip")
	Self.UnregisterForAnimationEvent(akActor as ObjectReference, "weaponSheathe")
	Self.UnregisterForAnimationEvent(akActor as ObjectReference, "WeaponUnequip")
	Self.UnregisterForAnimationEvent(akActor as ObjectReference, "weapSneakEquip")
	Self.UnregisterForAnimationEvent(akActor as ObjectReference, "weaponDraw")
	Self.UnregisterForRemoteEvent(akActor as ScriptObject, "OnItemEquipped")
	Self.UnregisterForRemoteEvent(akActor as ScriptObject, "OnItemUnequipped")
EndFunction

Function RegisterNewWearer(Actor akActor)
	int I = 0
	While (I < DefaultHotSwaps.length)
		If (akActor.IsEquipped(DefaultHotSwaps[I].TargetEquipmentForm))
			int iUnequippedIndex = RecentlyUnequippedActors.find(akActor, 0)
			If (iUnequippedIndex >= 0)
				RecentlyUnequippedActors.remove(iUnequippedIndex, 1)
			EndIf
			If (DefaultHotSwaps[I].sHotswapID == sHotswapID_JakesHolster)
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Actor " + akActor as string + " equipped Jake's Holster, and is now registered for item swap.", 0, False)
				Self.RegisterForAnimationEvent(akActor as ObjectReference, "WeapEquip")
				Self.RegisterForAnimationEvent(akActor as ObjectReference, "weaponSheathe")
				Self.RegisterForAnimationEvent(akActor as ObjectReference, "WeaponUnequip")
				Self.RegisterForAnimationEvent(akActor as ObjectReference, "weapSneakEquip")
				Self.RegisterForAnimationEvent(akActor as ObjectReference, "weaponDraw")
			EndIf
		EndIf
		I += 1
	EndWhile
	Self.RegisterForRemoteEvent(akActor as ScriptObject, "OnItemEquipped")
	Self.RegisterForRemoteEvent(akActor as ScriptObject, "OnItemUnequipped")
EndFunction

Function HandleHotSwaps(Actor akActor, string asLastEvent)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "HandleHotSwaps called on " + akActor as string, 0, False)
	Self.UnregisterForRemoteEvent(akActor as ScriptObject, "OnItemEquipped")
	int I = 0
	While (I < DefaultHotSwaps.length)
		Form thisEquipment = DefaultHotSwaps[I].TargetEquipmentForm
		If (akActor.IsEquipped(thisEquipment))
			If (DefaultHotSwaps[I].sHotswapID == sHotswapID_JakesHolster)
				If (akActor.GetItemCount(Laser44Form as Form) < 1)
					akActor.AttachModToInventoryItem(thisEquipment, DefaultHotSwaps[I].ModBForm)
				ElseIf (akActor.IsWeaponDrawn() || asLastEvent == "weaponDraw")
					If (akActor.WornHasKeyword(HasLaser44EquippedKeyword))
						akActor.AttachModToInventoryItem(thisEquipment, DefaultHotSwaps[I].ModBForm)
					Else
						akActor.AttachModToInventoryItem(thisEquipment, DefaultHotSwaps[I].ModAForm)
					EndIf
				Else
					akActor.AttachModToInventoryItem(thisEquipment, DefaultHotSwaps[I].ModAForm)
				EndIf
			EndIf
		EndIf
		I += 1
	EndWhile
	Utility.Wait(1)
	Self.RegisterForRemoteEvent(akActor as ScriptObject, "OnItemEquipped")
EndFunction

Event OnTimer(int aiTimerID)
	int I = 0
	While (I < RecentlyUnequippedActors.length)
		If (!Self.ActorHasHotSwappableEquipment(RecentlyUnequippedActors[I]))
			Self.UnregisterWearer(RecentlyUnequippedActors[I])
		EndIf
		I += 1
	EndWhile
	RecentlyUnequippedActors = new Actor[0]
EndEvent

Event Actor.OnItemEquipped(Actor akSender, Form akBaseObject, ObjectReference akReference)
	Self.HandleHotSwaps(akSender, akBaseObject as string)
EndEvent

Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	Self.HandleHotSwaps(akSource as Actor, asEventName)
EndEvent

Event Actor.OnItemUnequipped(Actor akSender, Form akBaseObject, ObjectReference akReference)
	int iIndex = DefaultHotSwaps.findstruct("TargetEquipmentForm", akBaseObject, 0)
	If (iIndex >= 0)
		If (RecentlyUnequippedActors == None)
			RecentlyUnequippedActors = new Actor[0]
		EndIf
		If (RecentlyUnequippedActors.find(akSender, 0) <= 0)
			RecentlyUnequippedActors.add(akSender, 1)
		EndIf
		Self.StartTimer(10, 0)
	EndIf
EndEvent

bool Function ActorHasHotSwappableEquipment(Actor akActorRef)
	int I = 0
	While (I < DefaultHotSwaps.length)
		If (akActorRef.IsEquipped(DefaultHotSwaps[I].TargetEquipmentForm))
			return True
		EndIf
		I += 1
	EndWhile
	return False
EndFunction
