;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\SS2_MQ02.psc
Modified : 2020-11-03 00:10:33
Compiled : 2021-01-07 11:43:43
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:SS2_MQ02 extends Quest conditional

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const mandatory
	simsettlementsv2:quests:mqmaster Property MQMaster Auto Const mandatory
	simsettlementsv2:quests:plotmanager Property PlotManager Auto Const mandatory
	Quest Property MQ03 Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property OldPaulAlias Auto Const mandatory
	ReferenceAlias Property JakeWorkshopAlias Auto Const mandatory
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ModVersion Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property WorkshopItemKeyword Auto Const mandatory
EndGroup

Group Scenes
	Scene Property PlayerPlacedNonAgriculturalPlotBark Auto Const mandatory
	Scene Property PlayerPlacedNonIndustrialPlotBark Auto Const mandatory
	Scene Property PaulWalkInScene Auto Const mandatory
	Scene Property WalkToAgriculturalPlotScene Auto Const mandatory
	Scene Property WalkToIndustrialPlotScene Auto Const mandatory
	Scene Property ASAMIndustrialScene Auto Const mandatory
EndGroup

int Property iStage_Started = 1 AutoReadOnly
int Property iStage_StartupComplete = 2 AutoReadOnly
int Property iStage_PlayerWalkaway = 10 AutoReadOnly
int Property iStage_AgriculturalTask = 20 AutoReadOnly
int Property iStage_PlayerBuiltAgricultural = 21 AutoReadOnly
int Property iStage_JakeAssignedAndArrivedAtAgricultural = 25 AutoReadOnly
int Property iStage_JakeAgriculturalSceneComplete = 30 AutoReadOnly
int Property iStage_ReadyForASAMAgriculturalScene = 35 AutoReadOnly
int Property iStage_ASAMAgriculturalSceneComplete = 40 AutoReadOnly
int Property iStage_IndustrialTask = 50 AutoReadOnly
int Property iStage_PlayerBuiltIndustrial = 51 AutoReadOnly
int Property iStage_JakeAssignedAndArrivedAtIndustrial = 55 AutoReadOnly
int Property iStage_JakeIndustrialSceneComplete = 60 AutoReadOnly
int Property iStage_ReadyForASAMIndustrialScene = 65 AutoReadOnly
int Property iStage_TriggerOldPaulWalkScene = 68 AutoReadOnly
int Property iStage_ASAMIndustrialSceneComplete = 70 AutoReadOnly
int Property iStage_OldPaulArrivedInConversation = 80 AutoReadOnly
int Property iStage_OldPaulIntroSceneComplete = 90 AutoReadOnly
int Property iStage_QuestComplete = 100 AutoReadOnly
int Property iObjective_MeetJake = 10 AutoReadOnly
int Property iObjective_BuildAgricultural = 20 AutoReadOnly
int Property iObjective_WatchJakeBuild = 30 AutoReadOnly
int Property iObjective_BuildIndustrial = 40 AutoReadOnly

;-- Variables ---------------------------------------
int iTimerID_QuestStartupComplete = 101 Const
int iLastInstalledVersion = 0
int iTimerID_TeleportJakeBehindPlayer = 102 Const

;-- Functions ---------------------------------------

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (aiTimerID == iTimerID_TeleportJakeBehindPlayer)
		If (!PlayerRef.HasDetectionLOS(MQMaster.JakeAlias.GetActorRef() as ObjectReference))
			simsettlementsv2:utilityfunctions.MoveBehindPlayer(MQMaster.JakeAlias.GetRef(), 150)
		EndIf
	EndIf
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(Self.iStage_StartupComplete)
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function Startup()
	int iModVersion = ModVersion.GetValueInt()
	If (iLastInstalledVersion < iModVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iModVersion
		EndIf
	EndIf
EndFunction

Event SimSettlementsV2:Quests:MQMaster.PlayerBuiltWrongPlotType(simsettlementsv2:quests:mqmaster akSender, var[] akArgs)
	If (Self.GetStageDone(Self.iStage_AgriculturalTask) && !Self.GetStageDone(Self.iStage_PlayerBuiltAgricultural))
		PlayerPlacedNonAgriculturalPlotBark.Start()
	ElseIf (Self.GetStageDone(Self.iStage_IndustrialTask) && !Self.GetStageDone(Self.iStage_PlayerBuiltIndustrial))
		PlayerPlacedNonIndustrialPlotBark.Start()
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	Self.HandleStageChanges(auiStageID, auiItemID)
EndEvent

Function StartJakeBuildingNextPlot()
	simsettlementsv2:objectreferences:simplot kPlotRef = None
	If (Self.GetStageDone(Self.iStage_JakeAssignedAndArrivedAtIndustrial) && !Self.GetStageDone(Self.iStage_ASAMIndustrialSceneComplete))
		kPlotRef = MQMaster.IndustrialPlotAlias.GetRef() as simsettlementsv2:objectreferences:simplot
	ElseIf (Self.GetStageDone(Self.iStage_JakeAssignedAndArrivedAtAgricultural) && !Self.GetStageDone(Self.iStage_ASAMAgriculturalSceneComplete))
		kPlotRef = MQMaster.AgriculturalPlotAlias.GetRef() as simsettlementsv2:objectreferences:simplot
	EndIf
	If (kPlotRef != None)
		kPlotRef.bForceLocked = False
		kPlotRef.TryToUnlockLevel(True, True)
	EndIf
EndFunction

Function InstallChanges()
	int iHotfix100eVersion = 5
	If (iLastInstalledVersion < iHotfix100eVersion)
		If (Self.GetStageDone(Self.iStage_JakeIndustrialSceneComplete) && !Self.GetStageDone(Self.iStage_ASAMIndustrialSceneComplete))
			If (!MQMaster.IndustrialPlotAlias.GetRef().Is3dLoaded())
				MQMaster.JakeAlias.GetRef().MoveTo(MQMaster.IndustrialPlotAlias.GetRef(), 0, 0, 0, True)
			EndIf
			ASAMIndustrialScene.Start()
		EndIf
	EndIf
	iLastInstalledVersion = ModVersion.GetValueInt()
EndFunction

Event OnQuestInit()
	Self.RegisterForCustomEvent(MQMaster as ScriptObject, "simsettlementsv2:quests:mqmaster_PlayerBuiltWrongPlotType")
EndEvent

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == Self.iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == Self.iStage_StartupComplete)
		Self.SetObjectiveDisplayed(Self.iObjective_MeetJake, True, True)
		Self.SetActive(True)
	ElseIf (auiStageID == Self.iStage_AgriculturalTask)
		PlotManager.SetStage(PlotManager.iStage_PlotUnlock_Agricultural)
		Self.SetObjectiveCompleted(Self.iObjective_MeetJake, True)
		Utility.Wait(1)
		Self.SetObjectiveDisplayed(Self.iObjective_BuildAgricultural, True, True)
	ElseIf (auiStageID == Self.iStage_PlayerBuiltAgricultural)
		If (!Self.GetStageDone(Self.iStage_JakeAgriculturalSceneComplete) && !WalkToAgriculturalPlotScene.IsPlaying())
			WorkshopParent.WorkshopNewSettler.Clear()
			WorkshopParent.WorkshopSpokesmanAfterRaiderAttack.Clear()
			Self.StartTimer(9, iTimerID_TeleportJakeBehindPlayer)
			MQMaster.TryToAssignJakeToNextPlot()
			Utility.Wait(3)
			WalkToAgriculturalPlotScene.Start()
			Self.SetObjectiveCompleted(Self.iObjective_BuildAgricultural, True)
		EndIf
	ElseIf (auiStageID == Self.iStage_JakeAssignedAndArrivedAtAgricultural)
		Self.StartJakeBuildingNextPlot()
		Self.SetObjectiveDisplayed(Self.iObjective_WatchJakeBuild, True, True)
	ElseIf (auiStageID == Self.iStage_JakeAgriculturalSceneComplete)
		simsettlementsv2:objectreferences:simplot kPlotRef = MQMaster.AgriculturalPlotAlias.GetRef() as simsettlementsv2:objectreferences:simplot
		If (kPlotRef.iCurrentLevel == 0)
			kPlotRef.ForcePlotLevel(1, -1)
		EndIf
		Self.SetObjectiveCompleted(Self.iObjective_WatchJakeBuild, True)
		Self.SetStage(Self.iStage_ReadyForASAMAgriculturalScene)
	ElseIf (auiStageID == Self.iStage_ASAMAgriculturalSceneComplete)
		simsettlementsv2:objectreferences:simplot kplotref = MQMaster.AgriculturalPlotAlias.GetRef() as simsettlementsv2:objectreferences:simplot
		MQMaster.DeleteTalkingASAM()
		MQMaster.FreePlotFromQuestScene(kplotref)
		kplotref.UnassignActor(MQMaster.JakeAlias.GetActorRef())
	ElseIf (auiStageID == Self.iStage_IndustrialTask)
		PlotManager.SetStage(PlotManager.iStage_PlotUnlock_Industrial)
		Self.SetObjectiveDisplayed(Self.iObjective_BuildIndustrial, True, False)
	ElseIf (auiStageID == Self.iStage_PlayerBuiltIndustrial)
		If (!Self.GetStageDone(Self.iStage_JakeIndustrialSceneComplete) && !WalkToIndustrialPlotScene.IsPlaying())
			WorkshopParent.WorkshopNewSettler.Clear()
			WorkshopParent.WorkshopSpokesmanAfterRaiderAttack.Clear()
			Self.StartTimer(9, iTimerID_TeleportJakeBehindPlayer)
			MQMaster.TryToAssignJakeToNextPlot()
			Utility.Wait(3)
			WalkToIndustrialPlotScene.Start()
			Self.SetObjectiveCompleted(Self.iObjective_BuildIndustrial, True)
		EndIf
	ElseIf (auiStageID == Self.iStage_JakeAssignedAndArrivedAtIndustrial)
		Self.StartJakeBuildingNextPlot()
		Self.SetObjectiveCompleted(Self.iObjective_WatchJakeBuild, False)
	ElseIf (auiStageID == Self.iStage_JakeIndustrialSceneComplete)
		Self.SetObjectiveCompleted(Self.iObjective_WatchJakeBuild, True)
		simsettlementsv2:objectreferences:simplot kplotref = MQMaster.IndustrialPlotAlias.GetRef() as simsettlementsv2:objectreferences:simplot
		If (kplotref.iCurrentLevel == 0)
			kplotref.ForcePlotLevel(1, -1)
		EndIf
		MQMaster.FreePlotFromQuestScene(kplotref)
		kplotref.UnassignActor(MQMaster.JakeAlias.GetActorRef())
		Self.SetStage(Self.iStage_ReadyForASAMIndustrialScene)
	ElseIf (auiStageID == Self.iStage_TriggerOldPaulWalkScene)
		OldPaulAlias.GetRef().MoveTo(JakeWorkshopAlias.GetRef(), 0, 0, 0, True)
		simsettlementsv2:utilityfunctions.MoveBehindPlayer(OldPaulAlias.GetRef(), 300)
		PaulWalkInScene.Start()
	ElseIf (auiStageID == Self.iStage_ASAMIndustrialSceneComplete)
		
	ElseIf (auiStageID == Self.iStage_OldPaulArrivedInConversation)
		
	ElseIf (auiStageID == Self.iStage_OldPaulIntroSceneComplete)
		workshopframework:workshopfunctions.AddActorToWorkshop(OldPaulAlias.GetActorRef(), JakeWorkshopAlias.GetRef() as workshopscript, False)
	ElseIf (auiStageID == Self.iStage_QuestComplete)
		MQMaster.DeleteTalkingASAM()
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		MQMaster.SendJakeToConcordHome(False)
		MQ03.Start()
		Self.Stop()
	EndIf
EndFunction
