;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\SS2_MQ05.psc
Modified : 2020-11-09 21:14:21
Compiled : 2021-01-07 11:43:53
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:SS2_MQ05 extends Quest conditional

;-- Properties --------------------------------------
Group Controllers
	simsettlementsv2:quests:mqmaster Property MQMaster Auto Const mandatory
	Quest Property MQ06 Auto Const mandatory
	Quest Property DrumlinQuest Auto Const mandatory
	Quest Property MinRecruit03 Auto Const mandatory
	simsettlementsv2:quests:event_localnpcgrabber[] Property LocalNPCGrabberQuests Auto Const mandatory
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property JakeAlias Auto Const mandatory
	ReferenceAlias Property BlakeAbernathyAlias Auto Const mandatory
	ReferenceAlias Property CacheMarkerAlias Auto Const mandatory
	ReferenceAlias Property OliviaMapMarkerAlias Auto Const mandatory
	ReferenceAlias Property DoorAlias Auto Const mandatory
	ReferenceAlias Property CommHubAlias Auto Const mandatory
	ReferenceAlias Property CommHubNoteAlias Auto Const mandatory
	LocationAlias Property USAFLocation Auto Const mandatory
	RefCollectionAlias Property ExteriorRaiders Auto Const mandatory
	RefCollectionAlias Property InteriorRaiders Auto Const mandatory
	ReferenceAlias Property AmbushJakeRaider01 Auto Const mandatory
	ReferenceAlias Property AmbushJakeRaider02 Auto Const mandatory
	ReferenceAlias Property AmbushJakeRaiderCorpse Auto Const mandatory
EndGroup

Group Assets
	Armor Property JakeHelmet Auto Const mandatory
	LeveledItem Property CacheItemsForPlayer Auto Const mandatory
	Faction Property RaiderFaction Auto Const mandatory
	Keyword Property EventKeyword_LocalNPCGrabber Auto Const mandatory
	Potion Property StimpakForm Auto Const mandatory
	Sound Property StimpakSound Auto Const mandatory
EndGroup

Group Scenes
	Scene Property DrumlinCommentScene Auto Const mandatory
	Scene Property AbernathyCommentScene Auto Const mandatory
	Scene Property CacheScene Auto Const mandatory
	Scene Property ApproachingOliviaScene Auto Const mandatory
	Scene Property ScoutingPerimeterScene Auto Const mandatory
	Scene Property ShootoutScene Auto Const mandatory
	Scene Property PostQuestScene Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iObjective_KillRaidersOutside = 60 Const
int iStage_OpenDoor = 105 Const
int iStage_ShowKillRaidersObjective = 36 Const
int iStage_PlayerCloseToShootout = 68 Const
int iStage_RaidersInsideDead = 65 Const
int iStage_RaidersOutsideDead = 40 Const
int iStage_SuggestedAbernathyFarm = 19 Const
int iObjective_FindCache = 50 Const
int iTimerID_QuestStartupComplete = 100 Const
int iObjective_ListenToJakesPitch = 10 Const
int iStage_StartupComplete = 2 Const
int iStage_ShootoutRaidersDead = 69 Const
int iStage_HandPlayerItems = 31 Const
int iStage_ShowKillRaidersObjectiveInterior = 60 Const
int iObjective_Drumlin = 40 Const
int iObjective_BringJakeStimpak = 120 Const
int iTimerID_ShutdownQuest = 102 Const
int iStage_AtOlivia = 35 Const
int iObjective_KillRaidersInside = 90 Const
int iObjective_HeadInside = 80 Const
int iStage_Started = 1 Const
int iStage_EquipJakeHelmet = 30 Const
int iLastInstalledVersion = 0
int iObjective_ReturnToJake = 100 Const
int iStage_PlayerGaveStimpakToJake = 85 Const
int iStage_RemoveHelmet = 100 Const
int iStage_PlayerAgreesToHelp = 20 Const
int iStage_HeadInside = 49 Const
int iStage_QuestComplete = 120 Const
int iTimerID_CheckForDead = 101 Const
int iStage_InteriorLoaded = 55 Const
int iObjective_Abernathy = 30 Const
int iStage_MentionsWestEverett = 115 Const
int iStage_ReachedCache = 25 Const
int iStage_JakeShot = 70 Const
int iObjective_GoToOlivia = 20 Const
int iStage_JakeAskedForStimpak = 80 Const
int iObjective_TalkWithJake = 70 Const
int iObjective_HelpJake = 110 Const
int iStage_JakeCured = 90 Const

;-- Functions ---------------------------------------

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function CheckForRaidersDead()
	If (Self.GetStageDone(iStage_RaidersInsideDead) && Self.GetStageDone(iStage_RaidersOutsideDead))
		return 
	EndIf
	RefCollectionAlias CheckCollection = ExteriorRaiders
	bool bExterior = True
	bool bInteriorChecked = False
	If (PlayerRef.IsInInterior() && PlayerRef.GetCurrentLocation() == USAFLocation.GetLocation())
		CheckCollection = InteriorRaiders
		bExterior = False
		If (!Self.GetStageDone(iStage_InteriorLoaded))
			return 
		EndIf
		If (CheckCollection.GetCount() == 0)
			Utility.Wait(2)
			Self.GrabRaiders(USAFLocation.GetLocation(), False)
			bInteriorChecked = True
		EndIf
	EndIf
	If (CheckCollection.GetCount() > 0 || bInteriorChecked)
		bool bAllDead = True
		int I = 0
		While (I < CheckCollection.GetCount() && bAllDead)
			Actor thisActor = CheckCollection.GetAt(I) as Actor
			If (!thisActor.IsDead() && !thisActor.IsDisabled())
				bAllDead = False
			EndIf
			I += 1
		EndWhile
		If (bAllDead)
			If (bExterior)
				If (!Self.GetStageDone(iStage_RaidersOutsideDead))
					Self.SetStage(iStage_RaidersOutsideDead)
				EndIf
			ElseIf (!Self.GetStageDone(iStage_RaidersInsideDead))
				Self.SetStage(iStage_RaidersInsideDead)
			EndIf
		Else
			Self.StartTimer(10, iTimerID_CheckForDead)
		EndIf
	Else
		Self.StartTimer(10, iTimerID_CheckForDead)
	EndIf
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		Self.SetObjectiveDisplayed(iObjective_ListenToJakesPitch, True, True)
		Self.SetActive(True)
	ElseIf (auiStageID == iStage_PlayerAgreesToHelp)
		USAFLocation.GetLocation().Reset()
		CommHubNoteAlias.TryToEnable()
		Self.SetObjectiveCompleted(iObjective_ListenToJakesPitch, True)
		MQMaster.SetMQCharacterAsTeammate(JakeAlias.GetActorRef(), True, False, True, True)
		Self.SetObjectiveDisplayed(iObjective_GoToOlivia, True, True)
		Self.SetObjectiveDisplayed(iObjective_FindCache, True, True)
		If (Self.GetStageDone(iStage_SuggestedAbernathyFarm))
			Self.RegisterForRemoteEvent(MinRecruit03 as ScriptObject, "OnStageSet")
			Self.SetObjectiveDisplayed(iObjective_Abernathy, True, True)
			Self.RegisterForRemoteEvent(BlakeAbernathyAlias.GetRef() as ScriptObject, "OnActivate")
		ElseIf (!DrumlinQuest.IsCompleted())
			Self.RegisterForRemoteEvent(DrumlinQuest as ScriptObject, "OnStageSet")
			Self.SetObjectiveDisplayed(iObjective_Drumlin, True, True)
		EndIf
		Self.RegisterForDistanceLessThanEvent(PlayerRef as ScriptObject, OliviaMapMarkerAlias.GetRef() as ScriptObject, 4500)
		Self.RegisterForDistanceLessThanEvent(PlayerRef as ScriptObject, CacheMarkerAlias.GetRef() as ScriptObject, 512)
		Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnLocationChange")
		Self.RegisterForPlayerTeleport()
		Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnCombatStateChanged")
	ElseIf (auiStageID == iStage_EquipJakeHelmet)
		JakeAlias.GetActorRef().EquipItem(JakeHelmet as Form, False, False)
	ElseIf (auiStageID == iStage_HandPlayerItems)
		PlayerRef.AddItem(CacheItemsForPlayer as Form, 1, False)
		Self.SetObjectiveCompleted(iObjective_FindCache, True)
	ElseIf (auiStageID == iStage_AtOlivia)
		Self.GrabRaiders(USAFLocation.GetLocation(), False)
		simsettlementsv2:utilityfunctions.MoveBehindPlayer(JakeAlias.GetActorRef() as ObjectReference, 200)
		ApproachingOliviaScene.Start()
	ElseIf (auiStageID == iStage_ShowKillRaidersObjective)
		Self.SetObjectiveCompleted(iObjective_GoToOlivia, True)
		Utility.Wait(1)
		Self.SetObjectiveDisplayed(iObjective_KillRaidersOutside, True, True)
	ElseIf (auiStageID == iStage_RaidersOutsideDead)
		Self.CancelTimer(iTimerID_CheckForDead)
		Self.SetObjectiveCompleted(iObjective_KillRaidersOutside, True)
		Utility.Wait(1)
		Self.SetObjectiveDisplayed(iObjective_TalkWithJake, True, True)
	ElseIf (auiStageID == iStage_HeadInside)
		Self.SetObjectiveCompleted(iObjective_TalkWithJake, True)
		Utility.Wait(0.5)
		Self.SetObjectiveDisplayed(iObjective_HeadInside, True, True)
	ElseIf (auiStageID == iStage_InteriorLoaded)
		If (!Self.IsObjectiveCompleted(iObjective_KillRaidersOutside))
			Self.SetObjectiveDisplayed(iObjective_KillRaidersOutside, False, False)
		EndIf
		ScoutingPerimeterScene.Stop()
		JakeAlias.GetActorRef().MoveTo(PlayerRef as ObjectReference, 0, 0, 0, True)
		JakeAlias.GetActorRef().MoveToNearestNavmeshLocation()
		Self.UnregisterForRemoteEvent(PlayerRef as ScriptObject, "OnLocationChange")
		Self.UnregisterForPlayerTeleport()
		If (Self.IsObjectiveDisplayed(iObjective_TalkWithJake))
			Self.SetObjectiveDisplayed(iObjective_TalkWithJake, False, False)
		EndIf
		If (!Self.IsObjectiveDisplayed(iObjective_HeadInside))
			Self.SetObjectiveDisplayed(iObjective_HeadInside, True, True)
		EndIf
		ObjectReference kDoorRef = DoorAlias.GetRef()
		kDoorRef.SetOpen(False)
		kDoorRef.SetLockLevel(253)
		Utility.Wait(1)
		Self.GrabRaiders(kDoorRef.GetCurrentLocation(), False)
	ElseIf (auiStageID == iStage_ShowKillRaidersObjectiveInterior)
		Self.SetObjectiveDisplayed(iObjective_HeadInside, False, False)
		Self.SetObjectiveDisplayed(iObjective_KillRaidersInside, True, True)
		MQMaster.SetMQCharacterAsTeammate(JakeAlias.GetActorRef(), False, False, True, True)
	ElseIf (auiStageID == iStage_RaidersInsideDead)
		ShootoutScene.Start()
		Self.SetObjectiveCompleted(iObjective_KillRaidersInside, True)
		Utility.Wait(1)
		Self.SetObjectiveDisplayed(iObjective_ReturnToJake, True, True)
		Self.RegisterForRemoteEvent(AmbushJakeRaider01.GetActorRef() as ScriptObject, "OnDeath")
		Self.RegisterForRemoteEvent(AmbushJakeRaider02.GetActorRef() as ScriptObject, "OnDeath")
		AmbushJakeRaider01.TryToEnable()
		AmbushJakeRaider02.TryToEnable()
		AmbushJakeRaiderCorpse.TryToEnable()
		AmbushJakeRaider01.GetActorRef().StartCombat(JakeAlias.GetActorRef(), False)
		AmbushJakeRaider02.GetActorRef().StartCombat(JakeAlias.GetActorRef(), False)
		If (PlayerRef.GetDistance(JakeAlias.GetRef()) < 1000)
			Self.SetStage(iStage_PlayerCloseToShootout)
		Else
			Self.RegisterForDistanceLessThanEvent(PlayerRef as ScriptObject, JakeAlias.GetRef() as ScriptObject, 1000)
		EndIf
	ElseIf (auiStageID == iStage_PlayerCloseToShootout)
		If (!Self.GetStageDone(iStage_EquipJakeHelmet))
			Self.SetStage(iStage_JakeShot)
		EndIf
		Self.SetObjectiveDisplayed(iObjective_HelpJake, True, True)
	ElseIf (auiStageID == iStage_ShootoutRaidersDead)
		Self.SetObjectiveCompleted(iObjective_HelpJake, True)
	ElseIf (auiStageID == iStage_JakeAskedForStimpak)
		Self.SetObjectiveDisplayed(iObjective_BringJakeStimpak, True, True)
	ElseIf (auiStageID == iStage_PlayerGaveStimpakToJake)
		StimpakSound.Play(JakeAlias.GetRef())
		PlayerRef.RemoveItem(StimpakForm as Form, 1, False, None)
	ElseIf (auiStageID == iStage_JakeCured)
		Self.SetObjectiveCompleted(iObjective_BringJakeStimpak, True)
	ElseIf (auiStageID == iStage_RemoveHelmet)
		JakeAlias.GetActorRef().UnequipItem(JakeHelmet as Form, False, False)
	ElseIf (auiStageID == iStage_OpenDoor)
		DoorAlias.GetRef().SetOpen(True)
	ElseIf (auiStageID == iStage_MentionsWestEverett)
		MQMaster.SetObjectiveDisplayed(30, True, False)
	ElseIf (auiStageID == iStage_QuestComplete)
		If (Self.IsObjectiveDisplayed(iObjective_Abernathy))
			Self.SetObjectiveDisplayed(iObjective_Abernathy, False, False)
		EndIf
		If (Self.IsObjectiveDisplayed(iObjective_Drumlin))
			Self.SetObjectiveDisplayed(iObjective_Drumlin, False, False)
		EndIf
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.UnregisterForAllEvents()
		Self.CancelTimer(iTimerID_CheckForDead)
		Self.StartTimerGameTime(36, iTimerID_ShutdownQuest)
		Utility.Wait(6)
		PostQuestScene.Start()
	EndIf
EndFunction

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iTimerID_ShutdownQuest)
		CommHubAlias.TryToDisable()
		CommHubNoteAlias.TryToDisable()
		MQMaster.SendJakeToConcordHome(False)
		MQ06.Start()
		Self.Stop()
	EndIf
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	Self.HandleStageChanges(auiStageID, auiItemID)
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event Actor.OnLocationChange(Actor akActorRef, Location akOldLoc, Location akNewLoc)
	If (akActorRef == PlayerRef && akNewLoc == USAFLocation.GetLocation() && akActorRef.IsInInterior())
		If (!Self.GetStageDone(iStage_InteriorLoaded))
			Self.SetStage(iStage_InteriorLoaded)
		Else
			Self.HandleStageChanges(iStage_InteriorLoaded, -1)
		EndIf
	EndIf
EndEvent

Function GrabRaiders(Location aLocation, bool abAllowDisabled)
	int iCallerID = Utility.RandomInt(0, 1000000)
	If (EventKeyword_LocalNPCGrabber.SendStoryEventAndWait(aLocation, None, None, iCallerID, 0))
		Utility.Wait(0.01)
		simsettlementsv2:quests:event_localnpcgrabber GrabberQuest = None
		int iAttempts = 0
		While (GrabberQuest == None && iAttempts < 5)
			int iQuestIndex = 0
			Utility.Wait(0.1)
			While (iQuestIndex < LocalNPCGrabberQuests.length && GrabberQuest == None)
				If (LocalNPCGrabberQuests[iQuestIndex].iCallerID == iCallerID)
					GrabberQuest = LocalNPCGrabberQuests[iQuestIndex]
				EndIf
				iQuestIndex += 1
			EndWhile
		EndWhile
		If (GrabberQuest != None)
			int I = 0
			While (I < GrabberQuest.FoundActors.GetCount())
				Actor thisActor = GrabberQuest.FoundActors.GetAt(I) as Actor
				If ((abAllowDisabled || !thisActor.IsDisabled()) && thisActor.IsInFaction(RaiderFaction) && thisActor != PlayerRef)
					If (thisActor.IsInInterior())
						InteriorRaiders.AddRef(thisActor as ObjectReference)
					Else
						ExteriorRaiders.AddRef(thisActor as ObjectReference)
					EndIf
					Self.RegisterForRemoteEvent(thisActor as ScriptObject, "OnDeath")
				EndIf
				I += 1
			EndWhile
			GrabberQuest.Stop()
		EndIf
	EndIf
	Self.StartTimer(10, iTimerID_CheckForDead)
EndFunction

Event OnDistanceLessThan(ObjectReference akObj1, ObjectReference akObj2, float afDistance)
	If (akObj1 == PlayerRef as ObjectReference && akObj2 == OliviaMapMarkerAlias.GetRef())
		Self.SetStage(iStage_AtOlivia)
		Self.UnregisterForDistanceEvents(akObj1 as ScriptObject, akObj2 as ScriptObject)
	ElseIf (akObj1 == PlayerRef as ObjectReference && akObj2 == CacheMarkerAlias.GetRef())
		simsettlementsv2:utilityfunctions.MoveBehindPlayer(JakeAlias.GetActorRef() as ObjectReference, 200)
		CacheScene.Start()
		Self.UnregisterForDistanceEvents(akObj1 as ScriptObject, akObj2 as ScriptObject)
	ElseIf (akObj1 == PlayerRef as ObjectReference && akObj2 == JakeAlias.GetRef())
		Self.SetStage(iStage_PlayerCloseToShootout)
		Self.UnregisterForDistanceEvents(akObj1 as ScriptObject, akObj2 as ScriptObject)
	EndIf
EndEvent

Event Quest.OnStageSet(Quest akSender, int auiStageID, int auiItemID)
	If (akSender == MinRecruit03)
		If (auiStageID == 20)
			AbernathyCommentScene.Start()
			Self.SetObjectiveCompleted(iObjective_Abernathy, True)
			Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnStageSet")
		EndIf
	ElseIf (akSender == DrumlinQuest)
		If (auiStageID >= 4000)
			DrumlinCommentScene.Start()
			Self.SetObjectiveCompleted(iObjective_Drumlin, True)
			Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnStageSet")
		EndIf
	EndIf
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Event ObjectReference.OnActivate(ObjectReference akSender, ObjectReference akActivatedBy)
	If (akSender == BlakeAbernathyAlias.GetRef())
		If (Self.IsObjectiveDisplayed(iObjective_Abernathy))
			Self.SetObjectiveCompleted(iObjective_Abernathy, True)
		EndIf
	EndIf
EndEvent

Event Actor.OnCombatStateChanged(Actor akSender, Actor akTarget, int aeCombatState)
	If (akSender == PlayerRef)
		If (akTarget.IsInFaction(RaiderFaction) && akTarget.GetCurrentLocation() == USAFLocation.GetLocation())
			If (!Self.IsObjectiveCompleted(iObjective_KillRaidersOutside))
				Self.SetObjectiveDisplayed(iObjective_KillRaidersOutside, True, False)
			EndIf
			Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnCombatStateChanged")
		EndIf
	EndIf
EndEvent

Event OnPlayerTeleport()
	Location thisLocation = PlayerRef.GetCurrentLocation()
	If (thisLocation == USAFLocation.GetLocation() && PlayerRef.IsInInterior())
		If (!Self.GetStageDone(iStage_InteriorLoaded))
			Self.SetStage(iStage_InteriorLoaded)
		Else
			Self.HandleStageChanges(iStage_InteriorLoaded, -1)
		EndIf
	EndIf
EndEvent

Event Actor.OnDeath(Actor akSender, Actor akKiller)
	Self.CheckForRaidersDead()
	If (akSender.IsInInterior() && InteriorRaiders.Find(akSender as ObjectReference) < 0)
		If (AmbushJakeRaider01.GetActorRef().IsDead() && AmbushJakeRaider02.GetActorRef().IsDead())
			Self.SetStage(iStage_ShootoutRaidersDead)
		EndIf
	EndIf
EndEvent

Function Startup()
	If (!Self.GetStageDone(iStage_RaidersInsideDead) && Self.GetStageDone(iStage_ShowKillRaidersObjectiveInterior))
		Self.CheckForRaidersDead()
	EndIf
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Function InstallChanges()
	int iHotfixMVersion = 11
	If (iLastInstalledVersion < iHotfixMVersion)
		If (Self.GetStageDone(iStage_InteriorLoaded) && !Self.GetStageDone(iStage_RaidersOutsideDead))
			Self.RegisterForPlayerTeleport()
			Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnLocationChange")
		EndIf
	EndIf
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction
