;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\SS2_MQ06.psc
Modified : 2020-11-08 21:56:20
Compiled : 2021-01-07 11:43:53
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:SS2_MQ06 extends Quest conditional

;-- Properties --------------------------------------
Group Controllers
	simsettlementsv2:quests:mqmaster Property MQMaster Auto Const mandatory
	Quest Property MQ07 Auto Const mandatory
EndGroup

Group HardwareStoreUpdates
	ReferenceAlias[] Property DisableAliases Auto Const
	{ Set up an alias for each item you want to disable with Optional and Allow Disabled checked in }
	ReferenceAlias[] Property EnableAliases Auto Const
	{ Set up an alias for each item you want to enable with Optional and Allow Disabled checked in }
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property JakeAlias Auto Const mandatory
	ReferenceAlias Property JakeRadioStationAlias Auto Const mandatory
	ReferenceAlias Property CommHubAlias Auto Const mandatory
	ReferenceAlias Property CommHubDestroyedEnableParent Auto Const mandatory
	ReferenceAlias Property CommHubExplosionMarker Auto Const mandatory
	ReferenceAlias Property GeneratorAlias Auto Const mandatory
	ReferenceAlias Property KickMarkerAlias Auto Const mandatory
	ReferenceAlias Property RedButtonAlias Auto Const mandatory
	ReferenceAlias Property EmergencyLightsEnablerAlias Auto Const mandatory
	ReferenceAlias Property Stage1EffectsEnablerAlias Auto Const mandatory
	ReferenceAlias Property Stage2EffectsEnablerAlias Auto Const mandatory
	ReferenceAlias Property Stage3EffectsEnablerAlias Auto Const mandatory
	ReferenceAlias Property CommHubFurnMarkerWrenchAlias Auto Const mandatory
	ReferenceAlias Property CommHubFurnMarkerScrewdriverAlias Auto Const mandatory
EndGroup

Group PoweredOnChanges
	ReferenceAlias[] Property EnablePowerAliases Auto Const
	ReferenceAlias[] Property DisablePowerAliases Auto Const
EndGroup

Group Assets
	Scene Property JakeRadioMessageScene Auto Const mandatory
	Sound Property StartupPlutoniumWellSound Auto Const mandatory
	Explosion Property CommHubExplosion Auto Const mandatory
	headpart Property JakeFaceSoot Auto Const mandatory
	Sound Property EarsRingingSound Auto Const mandatory
	ImageSpaceModifier Property FlashBangImageSpace Auto Const mandatory
	Keyword Property BlockPlayerActivationKeyword Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_PlayerAgreedToHelp = 70 Const
int iStage_QuestComplete = 110 Const
int iTimerID_Repair = 101 Const
int iStage_PlayerHeardRadioMessage = 10 Const
int iLastInstalledVersion = 0
int iStage_StartExplosionSequence = 95 Const
int iObjective_VisitJake = 10 Const
int iTimerID_QuestStartupComplete = 100 Const
int iObjective_ReturnToJake = 40 Const
int iStage_Started = 1 Const
int iStage_ExplosionFinished = 100 Const
int iStage_ButtonPushed = 71 Const
int iStage_ButtonPushedAgain = 75 Const
int iStage_PowerupComplete = 80 Const
int iStage_PlayerActivatedGenerator = 72 Const
int iStage_KickComplete = 73 Const
int iStage_StartupComplete = 2 Const
int iObjective_RestartGenerator = 20 Const
int iObjective_FigureOutGenerator = 30 Const

;-- Functions ---------------------------------------

Function UpdateHardwareStore()
	int I = 0
	While (I < DisableAliases.length)
		DisableAliases[I].GetRef().Disable(False)
		I += 1
	EndWhile
	I = 0
	While (I < EnableAliases.length)
		EnableAliases[I].GetRef().Enable(False)
		I += 1
	EndWhile
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	Self.HandleStageChanges(auiStageID, auiItemID)
EndEvent

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iTimerID_Repair)
		JakeRadioMessageScene.Stop()
		MQ07.Start()
		Self.UnregisterForAllEvents()
		Self.Stop()
	EndIf
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		MQMaster.SendJakeToConcordHome(True)
		Self.UpdateHardwareStore()
		JakeRadioStationAlias.TryToEnable()
		JakeRadioMessageScene.Start()
		Utility.Wait(1)
		MQMaster.SetObjectiveDisplayed(40, True, True)
	ElseIf (auiStageID == iStage_PlayerHeardRadioMessage)
		MQMaster.SetObjectiveDisplayed(40, False, False)
		Self.SetObjectiveDisplayed(iObjective_VisitJake, True, True)
		Self.SetActive(True)
	ElseIf (auiStageID == iStage_PlayerAgreedToHelp)
		JakeRadioStationAlias.TryToDisable()
		If (Self.IsObjectiveDisplayed(iObjective_VisitJake))
			Self.SetObjectiveCompleted(iObjective_VisitJake, True)
		EndIf
		Self.SetObjectiveDisplayed(iObjective_RestartGenerator, True, False)
		Self.RegisterForRemoteEvent(GeneratorAlias.GetRef() as ScriptObject, "OnActivate")
		Self.RegisterForRemoteEvent(RedButtonAlias.GetRef() as ScriptObject, "OnActivate")
		GeneratorAlias.GetRef().RemoveKeyword(BlockPlayerActivationKeyword)
	ElseIf (auiStageID == iStage_ButtonPushed)
		Self.SetObjectiveDisplayed(iObjective_FigureOutGenerator, True, True)
	ElseIf (auiStageID == iStage_PlayerActivatedGenerator)
		GeneratorAlias.GetRef().AddKeyword(BlockPlayerActivationKeyword)
		ObjectReference kKickMarkerRef = KickMarkerAlias.GetRef()
		Game.ForceThirdPerson()
		PlayerRef.SnapIntoInteraction(kKickMarkerRef)
		Utility.Wait(6)
		GeneratorAlias.GetRef().PlayAnimation("Reset")
		GeneratorAlias.GetRef().PlayAnimation("Powered")
		kKickMarkerRef.Activate(PlayerRef as ObjectReference, False)
		kKickMarkerRef.Disable(False)
		Utility.Wait(0.5)
		Stage1EffectsEnablerAlias.TryToEnable()
		Utility.Wait(0.25)
		EmergencyLightsEnablerAlias.TryToEnable()
		Self.SetStage(iStage_KickComplete)
	ElseIf (auiStageID == iStage_ButtonPushedAgain)
		Utility.Wait(0.5)
		StartupPlutoniumWellSound.Play(Stage1EffectsEnablerAlias.GetRef())
		Utility.Wait(0.5)
		StartupPlutoniumWellSound.Play(Stage2EffectsEnablerAlias.GetRef())
		Stage2EffectsEnablerAlias.TryToEnable()
		Utility.Wait(1)
		Stage3EffectsEnablerAlias.TryToEnable()
		Self.SetStage(iStage_PowerupComplete)
	ElseIf (auiStageID == iStage_PowerupComplete)
		int I = 0
		While (I < EnablePowerAliases.length)
			EnablePowerAliases[I].TryToEnable()
			I += 1
		EndWhile
		I = 0
		While (I < DisablePowerAliases.length)
			DisablePowerAliases[I].TryToDisable()
			I += 1
		EndWhile
		Self.SetObjectiveCompleted(iObjective_FigureOutGenerator, True)
		Self.SetObjectiveCompleted(iObjective_RestartGenerator, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToJake, True, True)
	ElseIf (auiStageID == iStage_StartExplosionSequence)
		CommHubExplosionMarker.GetRef().PlaceAtMe(CommHubExplosion as Form, 1, False, False, True)
		Utility.Wait(0.1)
		CommHubDestroyedEnableParent.GetRef().Enable(False)
		CommHubAlias.GetRef().Disable(False)
		Utility.Wait(1)
		Self.SetStage(iStage_ExplosionFinished)
	ElseIf (auiStageID == iStage_QuestComplete)
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.StartTimerGameTime(48, iTimerID_Repair)
	EndIf
EndFunction

Function InstallChanges()
	int iHotfixLVersion = 10
	If (iLastInstalledVersion < iHotfixLVersion)
		CommHubFurnMarkerWrenchAlias.TryToEnable()
		CommHubFurnMarkerScrewdriverAlias.TryToEnable()
	EndIf
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event ObjectReference.OnActivate(ObjectReference akSender, ObjectReference akActivatedBy)
	If (akSender == RedButtonAlias.GetRef() && akActivatedBy == PlayerRef as ObjectReference)
		If (Self.GetStageDone(iStage_KickComplete))
			Self.SetStage(iStage_ButtonPushedAgain)
		ElseIf (!Self.GetStageDone(iStage_ButtonPushed))
			Self.SetStage(iStage_ButtonPushed)
		EndIf
	ElseIf (akSender == GeneratorAlias.GetRef() && akActivatedBy == PlayerRef as ObjectReference)
		If (!Self.GetStageDone(iStage_PlayerActivatedGenerator))
			Self.SetStage(iStage_PlayerActivatedGenerator)
		EndIf
	EndIf
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction
