;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\SS2_MQ08.psc
Modified : 2020-11-01 16:20:42
Compiled : 2021-01-07 11:43:54
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:SS2_MQ08 extends Quest conditional

;-- Properties --------------------------------------
Group Controllers
	simsettlementsv2:quests:mqmaster Property MQMaster Auto Const mandatory
	Quest Property PlanetX Auto Const mandatory
	Quest Property GreyMatters Auto Const mandatory
	Quest Property VimAndVigor Auto Const mandatory
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property CharacterHoldingCellAlias Auto Const mandatory
	ReferenceAlias Property BermanAlias Auto Const mandatory
	ReferenceAlias Property WiseAlias Auto Const mandatory
	ReferenceAlias Property GuestChairAlias Auto Const mandatory
	ReferenceAlias Property VitomaticBlueprintsAlias Auto Const mandatory
	LocationAlias Property RonsOfficeLocationAlias Auto Const mandatory
EndGroup

Group Assets
	Form Property PickpocketFromBerman Auto Const mandatory
	MiscObject Property Caps001 Auto Const mandatory
	Form Property VitomaticBlueprint Auto Const mandatory
	Book Property SettlerNote Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Scenes
	Scene Property GunnerTalkScene Auto Const mandatory
	Scene Property GunnerApproachPlayerScene Auto Const mandatory
	Scene Property GunnerWalkScene Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_PlayerCloseToGunners = 20 Const
int iStage_TriggerQuests = 80 Const
int iObjective_SpeakToTheRon = 10 Const
int iStage_NegotiatedPriceDown250 = 66 Const
int iTimerID_QuestStartupComplete = 100 Const
int iStage_PickpocketedBerman = 21 Const
int iStage_StartupComplete = 2 Const
int iStage_PaidRon = 69 Const
int iStage_GunnerSceneComplete = 30 Const
int iStage_Started = 1 Const
int iStage_PlayerSeated = 60 Const
int iStage_QuestComplete = 100 Const
int iStage_NegotiatedPriceDown200 = 67 Const
int iLastInstalledVersion = 0
int iStage_GivenVitomaticInfo = 70 Const

;-- Functions ---------------------------------------

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event OnDistanceLessThan(ObjectReference akObj1, ObjectReference akObj2, float afDistance)
	If (akObj1 == PlayerRef as ObjectReference && akObj2 == BermanAlias.GetRef())
		Self.SetStage(iStage_PlayerCloseToGunners)
		Self.UnregisterForDistanceEvents(akObj1 as ScriptObject, akObj2 as ScriptObject)
	EndIf
EndEvent

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event OnPlayerTeleport()
	Location thisLocation = PlayerRef.GetCurrentLocation()
	Self.HandleLocationChange(thisLocation)
EndEvent

Event Actor.OnLocationChange(Actor akActorRef, Location akOldLoc, Location akNewLoc)
	If (akActorRef == PlayerRef)
		Self.HandleLocationChange(akNewLoc)
	EndIf
EndEvent

Function HandleLocationChange(Location akNewLoc)
	If (akNewLoc == RonsOfficeLocationAlias.GetLocation())
		Self.UnregisterForRemoteEvent(PlayerRef as ScriptObject, "OnLocationChange")
		Self.UnregisterForPlayerTeleport()
		GunnerApproachPlayerScene.Stop()
		GunnerTalkScene.Stop()
		GunnerWalkScene.Stop()
		ObjectReference kHoldingCellRef = CharacterHoldingCellAlias.GetRef()
		BermanAlias.GetActorRef().MoveTo(kHoldingCellRef, 0, 0, 0, True)
		WiseAlias.GetActorRef().MoveTo(kHoldingCellRef, 0, 0, 0, True)
	EndIf
EndFunction

Event OnStageSet(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		BermanAlias.TryToEnable()
		WiseAlias.TryToEnable()
		GunnerTalkScene.Start()
		Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnSit")
		Self.RegisterForDistanceLessThanEvent(PlayerRef as ScriptObject, BermanAlias.GetRef() as ScriptObject, 500)
		Self.SetObjectiveDisplayed(iObjective_SpeakToTheRon, True, True)
		Self.SetActive(True)
	ElseIf (auiStageID == iStage_PlayerCloseToGunners)
		GunnerTalkScene.Stop()
		GunnerApproachPlayerScene.Start()
	ElseIf (auiStageID == iStage_PickpocketedBerman)
		BermanAlias.GetActorRef().RemoveItem(PickpocketFromBerman, 1, False, PlayerRef as ObjectReference)
		PlayerRef.AddItem(Caps001 as Form, Utility.RandomInt(25, 50), False)
	ElseIf (auiStageID == iStage_PaidRon)
		If (Self.GetStageDone(iStage_NegotiatedPriceDown200))
			PlayerRef.RemoveItem(Caps001 as Form, 200, False, None)
		ElseIf (Self.GetStageDone(iStage_NegotiatedPriceDown250))
			PlayerRef.RemoveItem(Caps001 as Form, 250, False, None)
		Else
			PlayerRef.RemoveItem(Caps001 as Form, 300, False, None)
		EndIf
	ElseIf (auiStageID == iStage_GivenVitomaticInfo)
		PlayerRef.AddItem(VitomaticBlueprintsAlias.GetRef() as Form, 1, False)
	ElseIf (auiStageID == iStage_TriggerQuests)
		If (SettlerNote != None)
			PlayerRef.AddItem(SettlerNote as Form, 1, False)
		EndIf
		MQMaster.SetObjectiveDisplayed(10, True, False)
		MQMaster.SetObjectiveDisplayed(20, True, False)
		PlanetX.SetStage(10)
		GreyMatters.Start()
	ElseIf (auiStageID == iStage_QuestComplete)
		ObjectReference kHoldingCellRef = CharacterHoldingCellAlias.GetRef()
		BermanAlias.GetActorRef().MoveTo(kHoldingCellRef, 0, 0, 0, True)
		WiseAlias.GetActorRef().MoveTo(kHoldingCellRef, 0, 0, 0, True)
		Self.UnregisterForAllEvents()
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		VimAndVigor.SetStage(5)
		Self.Stop()
	EndIf
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Event Actor.OnSit(Actor akSender, ObjectReference akFurniture)
	If (akFurniture == GuestChairAlias.GetRef())
		Utility.Wait(0.5)
		Self.SetStage(iStage_PlayerSeated)
		Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnSit")
	EndIf
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent
