;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\SS2_MQ15.psc
Modified : 2021-03-01 16:56:43
Compiled : 2021-03-01 16:56:54
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:Quests:SS2_MQ15 extends Quest conditional

;-- Properties --------------------------------------
Group Controllers
	simsettlementsv2:quests:mqmaster Property MQMaster Auto Const mandatory
	simsettlementsv2:quests:unlockmanager Property UnlockManager Auto Const mandatory
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property JakeAlias Auto Const mandatory
	ReferenceAlias Property AidenAlias Auto Const mandatory
	ReferenceAlias Property AidenMarkerAlias Auto Const mandatory
	ReferenceAlias Property CharacterHoldingCellReturnPointAlias Auto Const mandatory
	ReferenceAlias Property MALAAlias Auto Const mandatory
EndGroup

Group HardwareStoreUpdates
	ReferenceAlias[] Property DisableAliases Auto Const
	{ Set up an alias for each item you want to disable with Optional and Allow Disabled checked in }
	ReferenceAlias[] Property EnableAliases Auto Const
	{ Set up an alias for each item you want to enable with Optional and Allow Disabled checked in }
EndGroup

Group Assets
	Form Property Mark1BeaconUnlockForm Auto Const mandatory
	Form Property CommunicationsClassUnlockForm Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iStage_AidenHandedItem = 20 Const
int iStage_AidenConversationComplete = 30 Const
int iTimerID_QuestStartupComplete = 100 Const
int iStage_AidenLeaves = 40 Const
int iLastInstalledVersion = 0
int iObjective_ToBeContinued = 10 Const
int iStage_StartupComplete = 2 Const
int iStage_Started = 1 Const
int iTimerID_AidenDisappear = 101 Const

;-- Functions ---------------------------------------

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		Self.UpdateHardwareStore()
		JakeAlias.GetRef().MoveTo(CharacterHoldingCellReturnPointAlias.GetRef(), 0, 0, 0, True)
		MQMaster.JakeAtConcordAlias.Clear()
		AidenMarkerAlias.TryToEnable()
		AidenAlias.GetRef().MoveTo(AidenMarkerAlias.GetRef(), 0, 0, 0, True)
	ElseIf (auiStageID == iStage_AidenHandedItem)
		UnlockManager.Unlock(Mark1BeaconUnlockForm as simsettlementsv2:miscobjects:unlockable, False)
		Utility.Wait(0.1)
		UnlockManager.Unlock(CommunicationsClassUnlockForm as simsettlementsv2:miscobjects:unlockable, False)
	ElseIf (auiStageID == iStage_AidenConversationComplete)
		Self.SetObjectiveDisplayed(iObjective_ToBeContinued, True, True)
		Utility.Wait(5)
		Self.SetObjectiveDisplayed(iObjective_ToBeContinued, False, False)
		Self.StartTimerGameTime(24, iTimerID_AidenDisappear)
		AidenMarkerAlias.TryToDisable()
		Utility.Wait(5)
		simsettlementsv2:utilityfunctions.ShowFanFareMessage("Chapter1_Complete")
	ElseIf (auiStageID == iStage_AidenLeaves)
		AidenAlias.GetRef().MoveTo(CharacterHoldingCellReturnPointAlias.GetRef(), 0, 0, 0, True)
		MALAAlias.GetRef().MoveTo(AidenMarkerAlias.GetRef(), 0, 0, 0, True)
		MALAAlias.GetActorRef().EvaluatePackage(False)
	EndIf
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	Self.HandleStageChanges(auiStageID, auiItemID)
EndEvent

Function InstallChanges()
	int iHotfixVersion101b = 15
	If (iLastInstalledVersion < iHotfixVersion101b)
		If (Self.GetStageDone(iStage_AidenConversationComplete) && !Self.GetStageDone(iStage_AidenLeaves))
			Self.SetStage(iStage_AidenLeaves)
		EndIf
	EndIf
	int iVersion109 = 26
	If (iLastInstalledVersion < iVersion109)
		MALAAlias.GetRef().MoveTo(AidenMarkerAlias.GetRef(), 0, 0, 0, True)
		MALAAlias.GetActorRef().EvaluatePackage(False)
	EndIf
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Function UpdateHardwareStore()
	int I = 0
	While (I < DisableAliases.length)
		DisableAliases[I].GetRef().Disable(False)
		I += 1
	EndWhile
	I = 0
	While (I < EnableAliases.length)
		EnableAliases[I].GetRef().Enable(False)
		I += 1
	EndWhile
EndFunction

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iTimerID_AidenDisappear)
		Self.SetStage(iStage_AidenLeaves)
	EndIf
EndEvent
