;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\SS2_OP01.psc
Modified : 2020-10-23 07:04:24
Compiled : 2021-01-07 11:44:08
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:SS2_OP01 extends Quest conditional

;-- Properties --------------------------------------
Group Controllers
	simsettlementsv2:quests:mqmaster Property MQMaster Auto Const mandatory
	simsettlementsv2:quests:dialoguequestoldpaul Property OldPaulDialogueQuest Auto Const mandatory
EndGroup

Group References
	Actor Property PlayerRef Auto Const mandatory
EndGroup

Group Globals
	GlobalVariable Property ESPVersion Auto Const mandatory
EndGroup

Group Aliases
	ReferenceAlias Property OldPaulAlias Auto Const mandatory
	ReferenceAlias Property ColaAlias Auto Const mandatory
	ReferenceAlias Property ColaInInventoryAlias Auto Const mandatory
	ReferenceAlias Property ColaInjuredFurnitureAlias Auto Const mandatory
	ReferenceAlias Property ColaWhiningMarkerAlias Auto Const mandatory
	ReferenceAlias Property ShedSceneEnableParentAlias Auto Const mandatory
	ReferenceAlias Property VanillaShedDoorAlias Auto Const mandatory
	ReferenceAlias Property AmosAlias Auto Const mandatory
EndGroup

Group Assets
	Scene Property ColaInjuredScene Auto Const mandatory
	Scene Property PostPetColaScene Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------
int iTimerID_QuestStartupComplete = 100 Const
int iLastInstalledVersion = 0
int iStage_PlayerCloseToAmos = 30 Const
int iStage_ReturnedToPaul = 85 Const
int iStage_PlayerAgreesToHelp = 20 Const
int iObjective_HelpTheDog = 30 Const
int iObjective_InvestigateWimpering = 20 Const
int iStage_PlayerPetDog = 65 Const
int iStage_PlayerActivatedDog = 60 Const
int iStage_QuestComplete = 100 Const
int iStage_PlayerKnowsOfAmos = 10 Const
int iStage_StartupComplete = 2 Const
int iObjective_ReturnToOldPaul = 40 Const
int iStage_PickedUpDog = 80 Const
int iStage_Started = 1 Const
int iObjective_CheckOnAmos = 10 Const
int iStage_ToldPaul = 90 Const
int iStage_PaulPetCola = 95 Const

;-- Functions ---------------------------------------

Function InstallChanges()
	iLastInstalledVersion = ESPVersion.GetValueInt()
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_QuestStartupComplete)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	EndIf
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	Self.Startup()
EndEvent

Event OnDistanceLessThan(ObjectReference akObj1, ObjectReference akObj2, float afDistance)
	If (akObj1 == PlayerRef as ObjectReference && akObj2 == AmosAlias.GetRef())
		Self.SetStage(iStage_PlayerCloseToAmos)
	EndIf
	Self.UnregisterForDistanceEvents(akObj1 as ScriptObject, akObj2 as ScriptObject)
EndEvent

Event OnStageSet(int auiStageID, int auiItemID)
	Self.HandleStageChanges(auiStageID, auiItemID)
EndEvent

Event OnQuestInit()
	Self.RegisterForRemoteEvent(PlayerRef as ScriptObject, "OnPlayerLoadGame")
EndEvent

Function StopInjuryScene()
	ColaInjuredScene.Stop()
EndFunction

Function PetCola(Actor akPetter)
	If (akPetter == None)
		return 
	EndIf
	simsettlementsv2:actors:bulldogactorscript akBulldogRef = ColaAlias.GetActorRef() as simsettlementsv2:actors:bulldogactorscript
	akBulldogRef.PetDog(akPetter)
EndFunction

Function Startup()
	int iEspVersion = ESPVersion.GetValueInt()
	If (iLastInstalledVersion < iEspVersion)
		If (iLastInstalledVersion > 0)
			Self.InstallChanges()
		Else
			iLastInstalledVersion = iEspVersion
		EndIf
	EndIf
EndFunction

Function TriggerInitialStartup()
	Self.Startup()
	Self.SetStage(iStage_StartupComplete)
EndFunction

Function HandleStageChanges(int auiStageID, int auiItemID)
	If (auiStageID == iStage_Started)
		If (Self.IsRunning())
			Self.TriggerInitialStartup()
		Else
			Self.StartTimer(2, iTimerID_QuestStartupComplete)
		EndIf
	ElseIf (auiStageID == iStage_StartupComplete)
		
	ElseIf (auiStageID == iStage_PlayerKnowsOfAmos)
		VanillaShedDoorAlias.TryToDisable()
		ShedSceneEnableParentAlias.TryToEnable()
		ColaAlias.GetRef().MoveTo(ColaInjuredFurnitureAlias.GetRef(), 0, 0, 0, True)
		ColaInjuredScene.Start()
		ColaWhiningMarkerAlias.TryToEnable()
	ElseIf (auiStageID == iStage_PlayerAgreesToHelp)
		Self.SetObjectiveDisplayed(iObjective_CheckOnAmos, True, False)
		Self.RegisterForDistanceLessThanEvent(PlayerRef as ScriptObject, AmosAlias.GetRef() as ScriptObject, 500)
	ElseIf (auiStageID == iStage_PlayerCloseToAmos)
		Self.SetObjectiveCompleted(iObjective_CheckOnAmos, True)
		Self.SetObjectiveDisplayed(iObjective_InvestigateWimpering, True, False)
	ElseIf (auiStageID == iStage_PlayerActivatedDog)
		Self.SetObjectiveCompleted(iObjective_InvestigateWimpering, True)
		Self.SetObjectiveDisplayed(iObjective_HelpTheDog, True, False)
	ElseIf (auiStageID == iStage_PlayerPetDog)
		Self.PetCola(PlayerRef)
		Utility.Wait(4)
		PostPetColaScene.Start()
	ElseIf (auiStageID == iStage_PickedUpDog)
		ColaWhiningMarkerAlias.TryToDisable()
		ColaAlias.TryToDisable()
		Self.StopInjuryScene()
		PlayerRef.AddItem(ColaInInventoryAlias.GetRef() as Form, 1, False)
		Self.SetObjectiveCompleted(iObjective_HelpTheDog, True)
		Self.SetObjectiveDisplayed(iObjective_ReturnToOldPaul, True, False)
	ElseIf (auiStageID == iStage_ReturnedToPaul)
		ColaAlias.TryToEnable()
		simsettlementsv2:utilityfunctions.MoveBehindPlayer(ColaAlias.GetRef(), 100)
		PlayerRef.RemoveItem(ColaInInventoryAlias.GetRef() as Form, 1, False, None)
		OldPaulDialogueQuest.MakeColaFollowPaul(False)
	ElseIf (auiStageID == iStage_PaulPetCola)
		Self.PetCola(OldPaulAlias.GetActorRef())
	ElseIf (auiStageID == iStage_QuestComplete)
		Self.CompleteAllObjectives()
		Self.CompleteQuest()
		Self.Stop()
	EndIf
EndFunction
