;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\SolarArrayArtillery.psc
Modified : 2020-05-20 17:33:46
Compiled : 2021-01-07 11:43:30
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:SolarArrayArtillery extends Quest

;-- Properties --------------------------------------
GlobalVariable Property CanFireNextTime Auto Const
float Property fMinHoursBetweenFiring = 24 Auto Const
GlobalVariable Property IsSolarArtilleryAvailable Auto Const
Form Property SolarArrayControllerForm Auto Const
Sound Property LaserChargeSound Auto Const
Sound Property LaserFireSound Auto Const
Message Property SolarArtilleryRecharging Auto Const
Message Property PoorWeather Auto Const
Message Property NoActiveSolarArray Auto Const
Message Property CurrentlyIndoors Auto Const
ReferenceAlias Property SolarArrayAlias Auto Const
ReferenceAlias Property PaintedTargetAlias Auto Const
float Property fAttackDelay = 20 Auto Const
Form Property PillarofLight Auto Const
float Property fExplosionDelay = 5 Auto Const
Explosion Property ExplosionForm Auto Const

;-- Variables ---------------------------------------
int iStartAttackTimerID = 0
ObjectReference kPillar
int iCloudyWeatherClass = 1
ObjectReference kTarget
int iPlaceExplosionTimerID = 1
int iPleasantWeatherClass = 0

;-- Functions ---------------------------------------

Function FireSolarArray(ObjectReference akTargetRef)
	If (!akTargetRef)
		return 
	EndIf
	If (PillarofLight)
		kPillar = akTargetRef.PlaceAtMe(PillarofLight, 1, False, False, True)
		If (LaserChargeSound)
			LaserChargeSound.Play(kPillar)
		EndIf
	EndIf
	kTarget = akTargetRef
	Self.StartTimer(fExplosionDelay, iPlaceExplosionTimerID)
EndFunction

Event OnStageSet(int aiStageID, int aiItemID)
	bool bFired = False
	ObjectReference SolarController = SolarArrayAlias.GetRef()
	If (!SolarController)
		ObjectReference[] kControllers = Game.GetPlayer().FindAllReferencesOfType(SolarArrayControllerForm, 50000)
		If (kControllers.length)
			int I = 0
			While (I < kControllers.length && !SolarController)
				If (!kControllers[I].IsDisabled())
					SolarController = kControllers[I]
				EndIf
				I += 1
			EndWhile
		EndIf
	EndIf
	If (IsSolarArtilleryAvailable.GetValue() <= 0 as float)
		NoActiveSolarArray.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	ElseIf (Utility.GetCurrentGameTime() < CanFireNextTime.GetValue())
		SolarArtilleryRecharging.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
	ElseIf (PaintedTargetAlias.GetRef())
		Weather thisWeather = Weather.GetCurrentWeather()
		If (thisWeather.GetClassification() != iPleasantWeatherClass && thisWeather.GetClassification() != iCloudyWeatherClass)
			PoorWeather.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		ElseIf (Weather.GetSkyMode() != 3)
			CurrentlyIndoors.Show(0, 0, 0, 0, 0, 0, 0, 0, 0)
		Else
			bFired = True
			CanFireNextTime.SetValue(Utility.GetCurrentGameTime() + fMinHoursBetweenFiring / 24)
			If (SolarController)
				simsettlementsv2:objectreferences:solararraycontroller kController = SolarController as simsettlementsv2:objectreferences:solararraycontroller
				If (kController)
					kController.ActivateArray()
				EndIf
			EndIf
			Self.StartTimer(fAttackDelay, iStartAttackTimerID)
		EndIf
	EndIf
	If (!bFired)
		Self.Stop()
	EndIf
EndEvent

Event OnTimer(int aiTimerID)
	If (aiTimerID == iStartAttackTimerID)
		Self.FireSolarArray(PaintedTargetAlias.GetRef())
	ElseIf (aiTimerID == iPlaceExplosionTimerID)
		Self.TriggerExplosions()
	EndIf
EndEvent

Function TriggerExplosions()
	int iSoundID = LaserFireSound.Play(kTarget)
	Utility.Wait(0.05)
	Sound.StopInstance(iSoundID)
	Utility.Wait(0.65)
	kTarget.PlaceAtMe(ExplosionForm as Form, 1, False, False, True)
	kTarget = None
	If (kPillar)
		Utility.Wait(1)
		kPillar.Disable(False)
		kPillar.Delete()
		kPillar = None
	EndIf
	Self.Stop()
EndFunction
