;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\SoundscapeManager.psc
Modified : 2020-11-07 23:10:35
Compiled : 2021-01-07 11:43:38
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:SoundscapeManager extends WorkshopFramework:Library:SlaveQuest
{ Handles the soundscape of settlements }

;-- Properties --------------------------------------
Group Quests
	workshopparentscript Property WorkshopParent Auto Const mandatory
	workshopframework:placeobjectmanager Property PlaceObjectManager Auto Const mandatory
	workshopframework:mainthreadmanager Property ThreadManager Auto Const mandatory
	workshopframework:f4semanager Property F4SEManager Auto Const mandatory
	workshopframework:mainquest Property WSFW_Main Auto Const mandatory
	simsettlementsv2:quests:settlementmanager Property SettlementManager Auto Const mandatory
	simsettlementsv2:quests:optionsmanager Property OptionsManager Auto Const mandatory
EndGroup

Group Configuration
	Form[] Property DefaultSoundscapeLayers Auto Const mandatory
	{ These layers will be applied automatically }
	float Property fBaseEmitChance = 0.06 Auto Const
	{ The % chance a sound will play from each emitter }
	float Property fMaxEmitChance = 0.2 Auto Const
	{ The max % chance a sound will play from each emitter }
	float Property fDensityWeight = 0.025 Auto Const
	{ The effect density has on fBaseEmitChance }
	float Property fEmitterSearchRadius = 10000 Auto Const
	{ Radius around the player to use emitters }
	float Property fMaxObjectToEmitterRadius = 1024 Auto Const
	{ Max distance an object should be from an emitter to count towards its density rating }
	float Property fLoopTimerDelay = 5 Auto Const
	{ Delay between loops of the current emitters }
	workshopframework:library:datastructures#gridsettings Property EmitterGridSettings Auto Const mandatory
	{ Grid layout details for the Sound Emitters }
	MusicType[] Property DefaultArriveTracks Auto Const mandatory
	MusicType[] Property DefaultBackgroundTracks Auto Const mandatory
EndGroup

Group Assets
	Form Property EmitterForm Auto Const mandatory
	EffectShader Property TestShader Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property RegisteredWithEmittersKeyword Auto Const mandatory
	Keyword Property EmitterLinkKeyword Auto Const mandatory
	Keyword Property EmitterKeyword Auto Const mandatory
	Keyword Property WorkshopLinkCenter Auto Const mandatory
EndGroup

Group Settings
	GlobalVariable Property Settings_DynamicSoundscape Auto Const mandatory
EndGroup

bool Property bSoundscapePlaying = False Auto hidden
bool Property bLocalEmittersUpdating = False Auto hidden
bool Property bInterruptSoundscape = False Auto hidden
bool Property bInTestMode = False Auto hidden

;-- Variables ---------------------------------------
bool[] bGridDestructionNeeded
int iTimerID_LoopSoundscape = 101
ObjectReference[] LocalEmitters
int iTimerID_ResetRecentlyUpdatedFlags = 102
bool[] bGridCreated
int[] iGridCreationCallbackID
Keyword[] LocalDensityKeywords
Form[] RegisteredLayers
bool[] bEmitterRefreshNeeded
bool[] bRecentlyUpdated

;-- Functions ---------------------------------------

Function HandleQuestInit()
	Parent.HandleQuestInit()
	bGridDestructionNeeded = new bool[128]
	bGridCreated = new bool[128]
	iGridCreationCallbackID = new int[128]
	bEmitterRefreshNeeded = new bool[128]
	bRecentlyUpdated = new bool[128]
	int I = 0
	While (I < 128)
		iGridCreationCallbackID[I] = -1
		I += 1
	EndWhile
	Self.RegisterForCustomEvent(WSFW_Main as ScriptObject, "workshopframework:mainquest_PlayerEnteredSettlement")
	Self.RegisterForCustomEvent(WSFW_Main as ScriptObject, "workshopframework:mainquest_PlayerExitedSettlement")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopObjectBuilt")
EndFunction

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
	Self.FindLocalEmitters()
EndFunction

simsettlementsv2:datastructures#weightedsound Function PickSound(simsettlementsv2:objectreferences:soundscapeemitter akEmitter)
	If (akEmitter)
		If (akEmitter.bSoundArrayUpdateNeeded)
			Self.UpdateSoundArray(akEmitter)
		EndIf
		If (bInTestMode)
			workshopframework:library:utilityfunctions.ModTraceCustom("SS2SoundScapeManager", "Sound Array for emitter " + akEmitter as string + ": " + akEmitter.CurrentSoundArray as string, 0, False)
		EndIf
		int I = 0
		int index = -1
		int iRand = Utility.RandomInt(1, 100)
		simsettlementsv2:datastructures#weightedsound[] localSoundArrayCopy = akEmitter.CurrentSoundArray
		While (I < localSoundArrayCopy.length && index < 0)
			iRand -= localSoundArrayCopy[I].Weight
			If (iRand <= 0)
				index = I
			EndIf
			I += 1
		EndWhile
		If (index < 0)
			return None
		EndIf
		If (localSoundArrayCopy.length > index)
			return localSoundArrayCopy[index]
		EndIf
	EndIf
	return None
EndFunction

Function ToggleSoundscape()
	Self.GoToState("Stop")
	If (bGridDestructionNeeded == None)
		bGridDestructionNeeded = new bool[128]
	EndIf
	int I = 0
	While (I < bGridCreated.length)
		bGridDestructionNeeded[I] = True
		I += 1
	EndWhile
	If (bInTestMode)
		Debug.Notification("Soundscape disabled.")
	EndIf
EndFunction

Event ObjectReference.OnUnload(ObjectReference akSender)
	workshopscript thisWorkshop = akSender as workshopscript
	If (thisWorkshop)
		Self.HandlePlayerExitedSettlement(thisWorkshop)
	EndIf
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnUnload")
EndEvent

Function HandleNewObjectBuilt(ObjectReference akObjectRef)
	Self.RegisterObjectWithEmitters(akObjectRef)
EndFunction

Function SetAllEmittersToRefresh()
	bEmitterRefreshNeeded = new bool[128]
	int I = 0
	While (I < bEmitterRefreshNeeded.length)
		bEmitterRefreshNeeded.add(True, 1)
		I += 1
	EndWhile
EndFunction

Function RefreshEmitters(workshopscript akWorkshopRef, bool abResetDensity)
	ObjectReference[] WorkshopEmitters = akWorkshopRef.GetLinkedRefChildren(EmitterLinkKeyword)
	If (WorkshopEmitters.length)
		int I = 0
		While (I < WorkshopEmitters.length)
			simsettlementsv2:objectreferences:soundscapeemitter asEmitter = WorkshopEmitters[I] as simsettlementsv2:objectreferences:soundscapeemitter
			If (abResetDensity)
				asEmitter.ResetDensity()
			EndIf
			asEmitter.bSoundArrayUpdateNeeded = True
			I += 1
		EndWhile
		If (abResetDensity)
			Self.FindAndRegisterObjects(akWorkshopRef, True)
		EndIf
	EndIf
EndFunction

Function FindAndRegisterObjects(workshopscript akWorkshopRef, bool abReregister)
	If (!akWorkshopRef || !akWorkshopRef.GetParentCell().IsLoaded())
		return 
	EndIf
	ObjectReference[] workObjects = akWorkshopRef.GetWorkshopResourceObjects(None, 0)
	If (workObjects.length)
		int I = 0
		While (I < workObjects.length)
			If (abReregister || !workObjects[I].HasKeyword(RegisteredWithEmittersKeyword))
				Self.RegisterObjectWithEmitters(workObjects[I])
			EndIf
			I += 1
		EndWhile
	EndIf
EndFunction

Function HandleInstallModChanges()
	int iHotfix100eVersion = 5
	If (iInstalledVersion < iHotfix100eVersion)
		Self.SetAllEmittersToRefresh()
	EndIf
EndFunction

Function DumpEmitterDensities()
	Debug.OpenUserLog("SS2SoundScapeManager")
	int I = 0
	While (I < LocalEmitters.length)
		workshopframework:library:utilityfunctions.ModTraceCustom("SS2SoundScapeManager", LocalEmitters[I] as string + ": " + (LocalEmitters[I] as simsettlementsv2:objectreferences:soundscapeemitter).ObjectDensity as string, 0, False)
		I += 1
	EndWhile
EndFunction

Function ToggleTestMode()
	If (bInTestMode)
		bInTestMode = False
		Debug.Notification("Soundscape test mode disabled.")
	Else
		bInTestMode = True
		Debug.Notification("Soundscape test mode enabled.")
	EndIf
EndFunction

Function UpdateLocalDensityKeywords(workshopscript akWorkshopRef)
	LocalDensityKeywords = new Keyword[0]
	int I = 0
	While (I < DefaultSoundscapeLayers.length)
		Keyword thisKeyword = (DefaultSoundscapeLayers[I] as simsettlementsv2:miscobjects:soundscapelayer).ObjectKeyword
		If (thisKeyword as bool && LocalDensityKeywords.find(thisKeyword, 0) < 0)
			LocalDensityKeywords.add(thisKeyword, 1)
		EndIf
		I += 1
	EndWhile
	I = 0
	While (I < RegisteredLayers.length)
		Keyword thiskeyword = (RegisteredLayers[I] as simsettlementsv2:miscobjects:soundscapelayer).ObjectKeyword
		If (thiskeyword as bool && LocalDensityKeywords.find(thiskeyword, 0) < 0)
			LocalDensityKeywords.add(thiskeyword, 1)
		EndIf
		I += 1
	EndWhile
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	simsettlementsv2:objectreferences:settlementdata thisDataStore = SettlementManager.GetSettlementDataStore(iWorkshopID)
	If (thisDataStore.ExtraSoundscapeLayers != None)
		I = 0
		While (I < thisDataStore.ExtraSoundscapeLayers.length)
			Keyword thiskeyword = (thisDataStore.ExtraSoundscapeLayers[I] as simsettlementsv2:miscobjects:soundscapelayer).ObjectKeyword
			If (thiskeyword as bool && LocalDensityKeywords.find(thiskeyword, 0) < 0)
				LocalDensityKeywords.add(thiskeyword, 1)
			EndIf
			I += 1
		EndWhile
	EndIf
EndFunction

Function RegisterLayer(simsettlementsv2:miscobjects:soundscapelayer aSoundscapeLayer)
	If (RegisteredLayers == None)
		RegisteredLayers = new Form[0]
	EndIf
	If (RegisteredLayers.find(aSoundscapeLayer as Form, 0) >= 0)
		return 
	EndIf
	RegisteredLayers.add(aSoundscapeLayer as Form, 1)
	Self.SetAllEmittersToRefresh()
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_LoopSoundscape)
		Self.PlaySounds()
	EndIf
EndEvent

Event WorkshopFramework:MainQuest.PlayerEnteredSettlement(workshopframework:mainquest akQuestRef, var[] akArgs)
	workshopscript kWorkshopRef = akArgs[0] as workshopscript
	bool bPreviouslyUnloaded = akArgs[1] as bool
	If (bPreviouslyUnloaded)
		Self.HandlePlayerEnteredSettlement(kWorkshopRef)
	EndIf
EndEvent

Event WorkshopFramework:MainQuest.PlayerExitedSettlement(workshopframework:mainquest akQuestRef, var[] akArgs)
	workshopscript kWorkshopRef = akArgs[0] as workshopscript
	bool bStillLoaded = akArgs[1] as bool
	If (!bStillLoaded)
		Self.HandlePlayerExitedSettlement(kWorkshopRef)
	Else
		Self.RegisterForRemoteEvent(kWorkshopRef as ScriptObject, "OnUnload")
	EndIf
EndEvent

Function HandlePlayerExitedSettlement(workshopscript akWorkshopRef)
	; Empty function
EndFunction

Function UpdateSoundArray(simsettlementsv2:objectreferences:soundscapeemitter akEmitter)
	akEmitter.bSoundArrayUpdateNeeded = False
	akEmitter.CurrentSoundArray = new simsettlementsv2:datastructures#weightedsound[0]
	int I = 0
	While (I < DefaultSoundscapeLayers.length)
		simsettlementsv2:miscobjects:soundscapelayer thisLayer = DefaultSoundscapeLayers[I] as simsettlementsv2:miscobjects:soundscapelayer
		akEmitter.AddLayerSounds(thisLayer)
		I += 1
	EndWhile
	I = 0
	While (I < RegisteredLayers.length)
		simsettlementsv2:miscobjects:soundscapelayer thislayer = RegisteredLayers[I] as simsettlementsv2:miscobjects:soundscapelayer
		akEmitter.AddLayerSounds(thislayer)
		I += 1
	EndWhile
	workshopscript kWorkshopRef = akEmitter.GetLinkedRef(EmitterLinkKeyword) as workshopscript
	If (kWorkshopRef)
		int iWorkshopID = kWorkshopRef.GetWorkshopID()
		simsettlementsv2:objectreferences:settlementdata thisDataStore = SettlementManager.GetSettlementDataStore(iWorkshopID)
		If (thisDataStore.ExtraSoundscapeLayers != None)
			I = 0
			While (I < thisDataStore.ExtraSoundscapeLayers.length)
				simsettlementsv2:miscobjects:soundscapelayer thislayer = thisDataStore.ExtraSoundscapeLayers[I] as simsettlementsv2:miscobjects:soundscapelayer
				akEmitter.AddLayerSounds(thislayer)
				I += 1
			EndWhile
		EndIf
	EndIf
EndFunction

Function PlaySounds()
	If (bSoundscapePlaying)
		return 
	EndIf
	If (bInTestMode)
		Debug.OpenUserLog("SS2SoundScapeManager")
		workshopframework:library:utilityfunctions.ModTraceCustom("SS2SoundScapeManager", "PlaySounds called. Found " + LocalEmitters.length as string + " emitters.", 0, False)
	EndIf
	bSoundscapePlaying = True
	int I = 0
	While (I < LocalEmitters.length)
		If (bLocalEmittersUpdating || bInterruptSoundscape || Self.GetState() == "Stop")
			bSoundscapePlaying = False
			return 
		EndIf
		simsettlementsv2:objectreferences:soundscapeemitter thisEmitter = LocalEmitters[I] as simsettlementsv2:objectreferences:soundscapeemitter
		float fPlayThreshold = Utility.RandomFloat(0, 1)
		int iDensityScore = thisEmitter.iTotalDensityScore
		float fEmitChance = fBaseEmitChance + iDensityScore as float * fDensityWeight
		If (fEmitChance > fMaxEmitChance)
			fEmitChance = fMaxEmitChance
		EndIf
		If (iDensityScore > 0 && fPlayThreshold < fEmitChance)
			simsettlementsv2:datastructures#weightedsound selectedSound = Self.PickSound(thisEmitter)
			If (selectedSound)
				If (bInTestMode)
					workshopframework:library:utilityfunctions.ModTraceCustom("SS2SoundScapeManager", thisEmitter as string + " Playing sound " + selectedSound.SoundToPlay as string, 0, False)
					TestShader.Play(thisEmitter as ObjectReference, 5)
					thisEmitter.LastPlayedSound = selectedSound.SoundToPlay
				EndIf
				selectedSound.SoundToPlay.Play(thisEmitter as ObjectReference)
			ElseIf (bInTestMode)
				workshopframework:library:utilityfunctions.ModTraceCustom("SS2SoundScapeManager", thisEmitter as string + "Sound should play, but no eligible sound was found.", 0, False)
			EndIf
		ElseIf (bInTestMode)
			workshopframework:library:utilityfunctions.ModTraceCustom("SS2SoundScapeManager", thisEmitter as string + "Threshold: " + fPlayThreshold as string + ", EmitChance: " + fEmitChance as string + ", Base Chance: " + fBaseEmitChance as string + ", Density: " + iDensityScore as string + ", Density Bonus: " + fDensityWeight as string, 0, False)
		EndIf
		I += 1
	EndWhile
	bSoundscapePlaying = False
	If (!bInterruptSoundscape && Self.GetState() != "Stop")
		Self.StartTimer(fLoopTimerDelay, iTimerID_LoopSoundscape)
	EndIf
EndFunction

Event WorkshopParentScript.WorkshopObjectBuilt(workshopparentscript akWorkshopParent, var[] akArgs)
	Self.HandleNewObjectBuilt(akArgs[0] as ObjectReference)
EndEvent

Event WorkshopFramework:PlaceObjectManager.GridCreated(workshopframework:placeobjectmanager akSender, var[] akArgs)
	int iWorkshopID = iGridCreationCallbackID.find(akArgs[0] as int, 0)
	If (iWorkshopID >= 0)
		bGridCreated[iWorkshopID] = True
		iGridCreationCallbackID[iWorkshopID] = -1
		workshopscript kWorkshopRef = WorkshopParent.GetWorkshop(iWorkshopID)
		Self.FindAndRegisterObjects(kWorkshopRef, False)
	EndIf
EndEvent

Function CreateEmitters(workshopscript akWorkshopRef)
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	If (bGridCreated[iWorkshopID] || iGridCreationCallbackID[iWorkshopID] >= 0)
		return 
	EndIf
	iGridCreationCallbackID[iWorkshopID] = 1
	ObjectReference kCenterPoint = akWorkshopRef.GetLinkedRef(WorkshopLinkCenter)
	If (!kCenterPoint)
		kCenterPoint = akWorkshopRef as ObjectReference
	EndIf
	Self.RegisterForCustomEvent(PlaceObjectManager as ScriptObject, "workshopframework:placeobjectmanager_GridCreated")
	iGridCreationCallbackID[iWorkshopID] = PlaceObjectManager.CreateObjectGrid(kCenterPoint, EmitterForm, EmitterGridSettings, akWorkshopRef as ObjectReference, EmitterLinkKeyword, False)
EndFunction

Function DestroyEmitters(workshopscript akWorkshopRef)
	ObjectReference[] WorkshopEmitters = akWorkshopRef.GetLinkedRefChildren(EmitterLinkKeyword)
	If (WorkshopEmitters.length)
		int I = 0
		While (I < WorkshopEmitters.length)
			WorkshopEmitters[I].SetLinkedRef(None, EmitterLinkKeyword)
			WorkshopEmitters[I].Delete()
			I += 1
		EndWhile
	EndIf
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	bGridCreated[iWorkshopID] = False
EndFunction

Function FindLocalEmitters()
	If (bLocalEmittersUpdating)
		return 
	EndIf
	bLocalEmittersUpdating = True
	LocalEmitters = PlayerRef.FindAllReferencesOfType(EmitterForm, fEmitterSearchRadius)
	bLocalEmittersUpdating = False
	If (LocalEmitters.length > 0)
		bInterruptSoundscape = False
		If (!bSoundscapePlaying)
			Self.PlaySounds()
		EndIf
	Else
		bInterruptSoundscape = True
	EndIf
EndFunction

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iTimerID_ResetRecentlyUpdatedFlags)
		bRecentlyUpdated = new bool[128]
		Self.StartTimerGameTime(24, iTimerID_ResetRecentlyUpdatedFlags)
	EndIf
EndEvent

Function HandlePlayerEnteredSettlement(workshopscript akWorkshopRef)
	If (!akWorkshopRef)
		return 
	EndIf
	If (Settings_DynamicSoundscape.GetValueInt() == 0 && Self.GetState() != "Stop")
		Self.ToggleSoundscape()
	EndIf
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	LocalEmitters = akWorkshopRef.GetLinkedRefChildren(EmitterLinkKeyword)
	If (bGridDestructionNeeded[iWorkshopID])
		Self.DestroyEmitters(akWorkshopRef)
	ElseIf (Self.GetState() != "Stop")
		Self.UpdateLocalDensityKeywords(akWorkshopRef)
		If (!bGridCreated[iWorkshopID])
			Self.CreateEmitters(akWorkshopRef)
		ElseIf (!bRecentlyUpdated[iWorkshopID])
			bRecentlyUpdated[iWorkshopID] = True
			Self.FindAndRegisterObjects(akWorkshopRef, False)
			If (bEmitterRefreshNeeded[iWorkshopID])
				Self.RefreshEmitters(akWorkshopRef, True)
			Else
				Self.RefreshEmitters(akWorkshopRef, False)
			EndIf
		EndIf
	EndIf
EndFunction

Function HandleLocationChange(Location akNewLoc)
	Self.FindLocalEmitters()
EndFunction

Function RegisterObjectWithEmitters(ObjectReference akObjectRef)
	If (!akObjectRef.GetParentCell().IsLoaded())
		return 
	EndIf
	ObjectReference[] Emitters = akObjectRef.FindAllReferencesOfType(EmitterForm, fMaxObjectToEmitterRadius)
	If (Emitters.length)
		int I = 0
		While (I < Emitters.length)
			simsettlementsv2:objectreferences:soundscapeemitter asEmitter = Emitters[I] as simsettlementsv2:objectreferences:soundscapeemitter
			asEmitter.RegisterObject(akObjectRef, LocalDensityKeywords)
			I += 1
		EndWhile
	EndIf
	akObjectRef.AddKeyword(RegisteredWithEmittersKeyword)
EndFunction

;-- State -------------------------------------------
State Stop

	Function PlaySounds()
		; Empty function
	EndFunction

	Function RegisterObjectWithEmitters(ObjectReference akObjectRef)
		; Empty function
	EndFunction

	Function FindAndRegisterObjects(workshopscript akWorkshopRef, bool abReregister)
		; Empty function
	EndFunction

	Function ToggleSoundscape()
		Self.GoToState("")
		If (bInTestMode)
			Debug.Notification("Soundscape enabled.")
		EndIf
		Self.FindLocalEmitters()
	EndFunction

	Function RefreshEmitters(workshopscript akWorkshopRef, bool abResetDensity)
		; Empty function
	EndFunction

	Function CreateEmitters(workshopscript akWorkshopRef)
		; Empty function
	EndFunction
EndState
