;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\StoreManager.psc
Modified : 2021-01-08 22:06:04
Compiled : 2021-01-08 22:06:12
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:StoreManager extends WorkshopFramework:Library:SlaveQuest
{ Handles Commercial Store related tasks, such as inventory injections }

;-- Properties --------------------------------------
Group Controllers
	workshopparentscript Property WorkshopParent Auto Const mandatory
	simsettlementsv2:quests:injectionmanager Property InjectionManager Auto Const mandatory
	simsettlementsv2:quests:empiremanager Property EmpireManager Auto Const mandatory
EndGroup

Group ActorValues
	ActorValue Property VendorLevelAV Auto Const mandatory
	{ Set by commercial plots on actors }
EndGroup

Group Aliases
	ReferenceAlias Property TinyTimVendorChestAlias Auto Const mandatory
	ReferenceAlias Property SafeSpawnPoint Auto Const mandatory
EndGroup

Group Assets
	Form Property ShopDataForm Auto Const mandatory
	Form Property DummyContainerForm Auto Const mandatory
	Faction Property WorkshopArmorVendorFaction Auto Const mandatory
	Faction Property WorkshopBarVendorFaction Auto Const mandatory
	Faction Property WorkshopClinicVendorFaction Auto Const mandatory
	Faction Property WorkshopClothingVendorFaction Auto Const mandatory
	Faction Property WorkshopGeneralVendorFaction Auto Const mandatory
	Faction Property WorkshopWeaponVendorFaction Auto Const mandatory
	simsettlementsv2:datastructures#lookupform[] Property StoreNameForms Auto Const mandatory
	{ Array of objects with store names for use with message display system. Look up by vendorID as used by the workshopParent vendor system }
	FormList Property VendorContainerKeywords Auto Const mandatory
	{ autofill - we only want this for injecting additional eligible keyword links }
	FormList Property FrenchBulldogPetStoreItems Auto Const mandatory
EndGroup

Group Settings
	GlobalVariable Property Settings_ShopsAutoRestock Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property WorkshopItemKeyword Auto Const mandatory
	Keyword[] Property VendorContainerKeywords_Vanilla Auto Const mandatory
	{ Quicker than accessing the entries in the VendorContainerKeywords formlist }
	Keyword[] Property VendorLinkKeywords_SS2 Auto Const mandatory
	Keyword[] Property VanillaShopkeeperKeywords Auto Const mandatory
	{ Custom keywords for identifying vanilla plot shop keepers. Should be in same order as vanilla shop type ID }
	Keyword Property EmpireCaravanKeyword Auto Const mandatory
EndGroup

Group SS2Stores
	Keyword Property VendorKeyword_Barber Auto Const mandatory
	Keyword Property VendorKeyword_BookStore Auto Const mandatory
	Keyword Property VendorKeyword_FurnitureStore Auto Const mandatory
	Keyword Property VendorKeyword_PetStore Auto Const mandatory
	Keyword Property VendorKeyword_PowerArmorStore Auto Const mandatory
	FormList Property VendorContainersList_Barber Auto Const mandatory
	FormList Property VendorContainersList_BookStore Auto Const mandatory
	FormList Property VendorContainersList_FurnitureStore Auto Const mandatory
	FormList Property VendorContainersList_PetStore Auto Const mandatory
	FormList Property VendorContainersList_PowerArmorStore Auto Const mandatory
	FormList Property AllFurnitureItemsList Auto Const mandatory
	LeveledItem[] Property VendorFurnitureLeveledLists Auto Const mandatory
	FormList[] Property FurnitureDisplayGroupLists Auto Const mandatory
	FormList Property AllPetStoreItemsList Auto Const mandatory
	LeveledItem[] Property VendorPetStoreLeveledLists Auto Const mandatory
	FormList[] Property PetStoreDisplayGroupLists Auto Const mandatory
EndGroup

string Property sCustomVendorID_BookStore = "SSBookStore" AutoReadOnly
string Property sCustomVendorID_FurnitureStore = "SSFurnitureStore" AutoReadOnly
string Property sCustomVendorID_PetStore = "SSPetStore" AutoReadOnly
string Property sCustomVendorID_PowerArmorStore = "SSPowerArmorStore" AutoReadOnly
string Property sCustomVendorID_Barber = "SSBarber" AutoReadOnly
int Property iHandleFormlistMethod_AddAll = 0 AutoReadOnly
int Property iHandleFormlistMethod_AddEvenAmounts = 1 AutoReadOnly
int Property iHandleFormlistMethod_AddRandomEach = 2 AutoReadOnly
int Property iHandleFormlistMethod_AddRandomAll = 3 AutoReadOnly
simsettlementsv2:datastructures#customvendordata[] Property AddonRegisteredCustomVendors Auto hidden
simsettlementsv2:objectreferences:settlementshopdata[] Property ShopDataStores Auto hidden
int Property NextCalcIndex
	int Function Get()
		iNextCalcIndex += 1
		If (iNextCalcIndex > 127)
			iNextCalcIndex = 0
		EndIf
		return iNextCalcIndex
	EndFunction
EndProperty

;-- Variables ---------------------------------------
int iVanillaType_Clothing = 5 Const
int iMaxPlotLevel = 3 Const
int iNextCalcIndex = -1
ObjectReference[] kCalculatingValueFor
float[] fValueCalculation
ObjectReference kTestContainer
bool bDataStoresUpdatingBlock = False
int iVanillaType_General = 0 Const
int iStage_UnlockFrenchBulldogs = 100 Const
int[] iAwaitingCalculation
int iVanillaType_Bar = 3 Const
int iVanillaType_Clinic = 4 Const
float fBaseValueCapLevelMultiplier = 1.25 Const
int iBaseValueCapPerItemType = 500 Const
int iVanillaType_Weapons = 2 Const
int iVanillaType_Armor = 1 Const

;-- Functions ---------------------------------------

Function SetupDataStores()
	If (bDataStoresUpdatingBlock)
		return 
	EndIf
	bDataStoresUpdatingBlock = True
	int iLoopCounter = 0
	While (!WorkshopParent.Initialized && iLoopCounter < 10)
		iLoopCounter += 1
		Utility.Wait(5)
	EndWhile
	int iLockKey = Self.GetLock(0, True)
	If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "StoreManager.SetupDataStores: Unable to get lock!", 2, False)
		return 
	EndIf
	If (ShopDataStores == None || ShopDataStores.length == 0)
		ShopDataStores = new simsettlementsv2:objectreferences:settlementshopdata[0]
	EndIf
	workshopscript[] Workshops = WorkshopParent.Workshops
	int I = 0
	While (I < Workshops.length)
		Self.ConfigureShopDataStore(I, False)
		I += 1
	EndWhile
	If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "StoreManager.SetupDataStores: Failed to release lock " + iLockKey as string + "!", 2, False)
	EndIf
	bDataStoresUpdatingBlock = False
EndFunction

Function DumpDataStore(workshopscript akWorkshopRef)
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	simsettlementsv2:objectreferences:settlementshopdata thisDataStore = ShopDataStores[iWorkshopID]
	string sLogName = simsettlementsv2:utilityfunctions.GetLogName()
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, "============= Starting Settlement Shop Data Dump [" + thisDataStore as string + "] =============", 0, False)
	workshopframework:library:utilityfunctions.ModTraceCustom(sLogName, "============= End Settlement Shop Data Dump [" + thisDataStore as string + "] =============", 0, False)
EndFunction

Function ApplyVendorKeyword(Actor akActorRef, string asVendorID)
	If (asVendorID == iVanillaType_General as string)
		akActorRef.AddKeyword(VanillaShopkeeperKeywords[iVanillaType_General])
	ElseIf (asVendorID == iVanillaType_Armor as string)
		akActorRef.AddKeyword(VanillaShopkeeperKeywords[iVanillaType_Armor])
	ElseIf (asVendorID == iVanillaType_Weapons as string)
		akActorRef.AddKeyword(VanillaShopkeeperKeywords[iVanillaType_Weapons])
	ElseIf (asVendorID == iVanillaType_Bar as string)
		akActorRef.AddKeyword(VanillaShopkeeperKeywords[iVanillaType_Bar])
	ElseIf (asVendorID == iVanillaType_Clinic as string)
		akActorRef.AddKeyword(VanillaShopkeeperKeywords[iVanillaType_Clinic])
	ElseIf (asVendorID == iVanillaType_Clothing as string)
		akActorRef.AddKeyword(VanillaShopkeeperKeywords[iVanillaType_Clothing])
	Else
		int iCustomIndex = WorkshopParent.CustomVendorTypes.findstruct("sVendorID", asVendorID, 0)
		If (iCustomIndex >= 0 && WorkshopParent.CustomVendorTypes[iCustomIndex].VendorKeyword != None)
			akActorRef.AddKeyword(WorkshopParent.CustomVendorTypes[iCustomIndex].VendorKeyword)
		EndIf
	EndIf
EndFunction

Function AddItemsToContainer(Form aAddMe, int aiCount, ObjectReference akTargetContainer, int aiHandleFormlistMethod)
	FormList asFormlist = aAddMe as FormList
	If (asFormlist == None || aiHandleFormlistMethod == Self.iHandleFormlistMethod_AddAll)
		akTargetContainer.AddItem(aAddMe, aiCount, False)
	ElseIf (aiHandleFormlistMethod == Self.iHandleFormlistMethod_AddRandomAll)
		akTargetContainer.AddItem(asFormlist.GetAt(Utility.RandomInt(0, asFormlist.GetSize() - 1)), aiCount, False)
	Else
		int iSize = asFormlist.GetSize()
		int iRemainingToDistribute = aiCount
		int I = 0
		While (I < iSize - 1 && iRemainingToDistribute > 0)
			int iIndex = I
			If (aiHandleFormlistMethod == Self.iHandleFormlistMethod_AddRandomEach)
				iIndex = Utility.RandomInt(0, iSize - 1)
			EndIf
			akTargetContainer.AddItem(asFormlist.GetAt(iIndex), 1, False)
			iRemainingToDistribute -= 1
			I += 1
		EndWhile
	EndIf
EndFunction

float Function GetItemValue(Form aForm)
	If (aForm as ObjectReference)
		aForm = (aForm as ObjectReference).GetBaseObject()
	EndIf
	If (aForm as FormList)
		float fSum = 0 as float
		int iSize = (aForm as FormList).GetSize()
		int I = 0
		While (I < iSize)
			Form thisItem = (aForm as FormList).GetAt(I)
			float thisValue = thisItem.GetGoldValue() as float
			If (thisValue > 0 as float)
				fSum += thisValue
			EndIf
			I += 1
		EndWhile
		return fSum / iSize as float
	EndIf
	float fValue = aForm.GetGoldValue() as float
	If (fValue < 0 as float)
		fValue = 0 as float
	EndIf
	return fValue
EndFunction

Event OnStageSet(int auiStageId, int auiItemId)
	Parent.OnStageSet(auiStageId, auiItemId)
	If (auiStageId == iStage_UnlockFrenchBulldogs)
		Self.RegisterPetStoreItems(FrenchBulldogPetStoreItems)
	EndIf
EndEvent

Function RemoveVendorData(Actor akActorRef, string asVendorID)
	Self.RemoveVendorKeyword(akActorRef, asVendorID)
	Self.RemoveFromVendorFaction(akActorRef, asVendorID)
EndFunction

Event ObjectReference.OnItemRemoved(ObjectReference akSender, Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	Utility.Wait(0.01)
	int iCalcIndex = kCalculatingValueFor.find(akDestContainer, 0)
	If (iCalcIndex >= 0)
		fValueCalculation[iCalcIndex] = fValueCalculation[iCalcIndex] + (akBaseItem.GetGoldValue() * aiItemCount) as float
		iAwaitingCalculation[iCalcIndex] = iAwaitingCalculation[iCalcIndex] - aiItemCount
	EndIf
EndEvent

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
	Self.SetupDataStores()
	int I = 0
	While (I < VendorLinkKeywords_SS2.length)
		VendorContainerKeywords.AddForm(VendorLinkKeywords_SS2[I] as Form)
		I += 1
	EndWhile
EndFunction

Function TraceVendorContainers(workshopscript akWorkshopRef, string asVendorID)
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	bool bUseNoRespawnContainers = Settings_ShopsAutoRestock.GetValueInt() == 0
	simsettlementsv2:objectreferences:settlementshopdata thisDataStore = Self.GetShopDataStore(iWorkshopID)
	If (thisDataStore == None)
		return 
	EndIf
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[ShopManager] TraceVendorContainers called. bUseNoRespawnContainers = " + bUseNoRespawnContainers as string, 0, False)
	ObjectReference[] kVendorContainers = thisDataStore.GetVendorContainers(asVendorID, bUseNoRespawnContainers)
	workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[ShopManager] TraceVendorContainers: " + kVendorContainers as string, 0, False)
EndFunction

Function HandleInstallModChanges()
	int iHotfixMVersion = 12
	If (iInstalledVersion < iHotfixMVersion)
		simsettlementsv2:datastructures#customvendordata[] UniqueVendorData = new simsettlementsv2:datastructures#customvendordata[0]
		int I = 0
		While (I < AddonRegisteredCustomVendors.length)
			int iUniqueIndex = UniqueVendorData.findstruct("sCustomVendorID", AddonRegisteredCustomVendors[I].sCustomVendorID, 0)
			If (iUniqueIndex <= -1)
				simsettlementsv2:datastructures#customvendordata newDataRecord = new simsettlementsv2:datastructures#customvendordata
				newDataRecord.sCustomVendorID = AddonRegisteredCustomVendors[I].sCustomVendorID
				newDataRecord.CustomVendorInventoryFormlist = AddonRegisteredCustomVendors[I].CustomVendorInventoryFormlist
				newDataRecord.CustomVendorKeyword = AddonRegisteredCustomVendors[I].CustomVendorKeyword
				newDataRecord.CustomVendorFaction = AddonRegisteredCustomVendors[I].CustomVendorFaction
				UniqueVendorData.add(newDataRecord, 1)
			EndIf
			I += 1
		EndWhile
		AddonRegisteredCustomVendors = new simsettlementsv2:datastructures#customvendordata[0]
		I = 0
		While (I < UniqueVendorData.length)
			simsettlementsv2:datastructures#customvendordata newdatarecord = new simsettlementsv2:datastructures#customvendordata
			newdatarecord.sCustomVendorID = UniqueVendorData[I].sCustomVendorID
			newdatarecord.CustomVendorInventoryFormlist = UniqueVendorData[I].CustomVendorInventoryFormlist
			newdatarecord.CustomVendorKeyword = UniqueVendorData[I].CustomVendorKeyword
			newdatarecord.CustomVendorFaction = UniqueVendorData[I].CustomVendorFaction
			AddonRegisteredCustomVendors.add(newdatarecord, 1)
			I += 1
		EndWhile
	EndIf
	int iHotfixNVersion = 13
	If (iInstalledVersion < iHotfixNVersion)
		WorkshopParent.RegisterCustomVendor(Self.sCustomVendorID_PetStore, VendorContainersList_PetStore, VendorKeyword_PetStore, None)
		int i = 0
		While (i < AllPetStoreItemsList.GetSize())
			simsettlementsv2:miscobjects:petstorecreatureitem thisItem = AllPetStoreItemsList.GetAt(i) as simsettlementsv2:miscobjects:petstorecreatureitem
			If (thisItem.iVendorLevel == 3)
				InjectionManager.AddToList(VendorPetStoreLeveledLists[2] as Form, thisItem as Form)
				Self.AddItemToExistingPetStores(thisItem)
			EndIf
			i += 1
		EndWhile
	EndIf
EndFunction

Function AddItemToExistingFurnitureStores(simsettlementsv2:miscobjects:furniturestoreitem aFurnitureItem)
	workshopscript[] Workshops = WorkshopParent.Workshops
	int iFurnitureStoreIndex = WorkshopParent.CustomVendorTypes.findstruct("sVendorID", Self.sCustomVendorID_FurnitureStore, 0)
	If (iFurnitureStoreIndex < 0)
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "[SS2Main] Furniture Store type did not correctly register with WorkshopParent. Possible this save file was from before alpha 21?", 0, False)
		return 
	EndIf
	int I = 0
	While (I < Workshops.length)
		If (aFurnitureItem.iVendorLevel == 1)
			If (Workshops[I].kCustomVendorContainersL0.length > iFurnitureStoreIndex && Workshops[I].kCustomVendorContainersL0[iFurnitureStoreIndex] != None)
				Workshops[I].kCustomVendorContainersL0[iFurnitureStoreIndex].AddItem(aFurnitureItem as Form, 1, False)
			EndIf
		ElseIf (aFurnitureItem.iVendorLevel == 2)
			If (Workshops[I].kCustomVendorContainersL1.length > iFurnitureStoreIndex && Workshops[I].kCustomVendorContainersL1[iFurnitureStoreIndex] != None)
				Workshops[I].kCustomVendorContainersL1[iFurnitureStoreIndex].AddItem(aFurnitureItem as Form, 1, False)
			EndIf
		ElseIf (aFurnitureItem.iVendorLevel == 3)
			If (Workshops[I].kCustomVendorContainersL2.length > iFurnitureStoreIndex && Workshops[I].kCustomVendorContainersL2[iFurnitureStoreIndex] != None)
				Workshops[I].kCustomVendorContainersL2[iFurnitureStoreIndex].AddItem(aFurnitureItem as Form, 1, False)
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction

Function ProduceVendorItemsArray(workshopscript akWorkshopRef, simsettlementsv2:datastructures#productionitem[] aProduceMe, int aiHandleFormlistMethod, bool abStoreInNetworkIfLocalFull)
	int I = 0
	While (I < aProduceMe.length)
		Self.ProduceVendorItems(akWorkshopRef, aProduceMe[I].sTargetVendorType, aProduceMe[I].Item, aProduceMe[I].iCount, aiHandleFormlistMethod, aProduceMe[I].iTargetVendorLevel, abStoreInNetworkIfLocalFull)
		I += 1
	EndWhile
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
	WorkshopParent.RegisterCustomVendor(Self.sCustomVendorID_Barber, VendorContainersList_Barber, VendorKeyword_Barber, None)
	WorkshopParent.RegisterCustomVendor(Self.sCustomVendorID_BookStore, VendorContainersList_BookStore, VendorKeyword_BookStore, None)
	WorkshopParent.RegisterCustomVendor(Self.sCustomVendorID_PowerArmorStore, VendorContainersList_PowerArmorStore, VendorKeyword_PowerArmorStore, WorkshopArmorVendorFaction)
	WorkshopParent.RegisterCustomVendor(Self.sCustomVendorID_FurnitureStore, VendorContainersList_FurnitureStore, VendorKeyword_FurnitureStore, None)
	WorkshopParent.RegisterCustomVendor(Self.sCustomVendorID_PetStore, VendorContainersList_PetStore, VendorKeyword_PetStore, None)
	Self.RegisterForMenuOpenCloseEvent("BarterMenu")
	Self.RegisterForMenuOpenCloseEvent("DialogueMenu")
	Self.SetupDataStores()
EndFunction

Function RemoveFromVendorFaction(Actor akActorRef, string asVendorID)
	If (asVendorID == iVanillaType_General as string)
		akActorRef.RemoveFromFaction(WorkshopGeneralVendorFaction)
	ElseIf (asVendorID == iVanillaType_Armor as string)
		akActorRef.RemoveFromFaction(WorkshopArmorVendorFaction)
	ElseIf (asVendorID == iVanillaType_Weapons as string)
		akActorRef.RemoveFromFaction(WorkshopWeaponVendorFaction)
	ElseIf (asVendorID == iVanillaType_Bar as string)
		akActorRef.RemoveFromFaction(WorkshopBarVendorFaction)
	ElseIf (asVendorID == iVanillaType_Clinic as string)
		akActorRef.RemoveFromFaction(WorkshopClinicVendorFaction)
	ElseIf (asVendorID == iVanillaType_Clothing as string)
		akActorRef.RemoveFromFaction(WorkshopClothingVendorFaction)
	Else
		int iCustomIndex = WorkshopParent.CustomVendorTypes.findstruct("sVendorID", asVendorID, 0)
		If (iCustomIndex >= 0 && WorkshopParent.CustomVendorTypes[iCustomIndex].VendorFaction != None)
			akActorRef.RemoveFromFaction(WorkshopParent.CustomVendorTypes[iCustomIndex].VendorFaction)
		EndIf
	EndIf
EndFunction

Function ClearSS2ShopKeeperLinks(Actor akActorRef)
	int I = 0
	While (I < VendorLinkKeywords_SS2.length)
		akActorRef.SetLinkedRef(None, VendorLinkKeywords_SS2[I])
		I += 1
	EndWhile
EndFunction

Function AddToVendorFaction(Actor akActorRef, string asVendorID)
	If (asVendorID == iVanillaType_General as string)
		akActorRef.AddToFaction(WorkshopGeneralVendorFaction)
	ElseIf (asVendorID == iVanillaType_Armor as string)
		akActorRef.AddToFaction(WorkshopArmorVendorFaction)
	ElseIf (asVendorID == iVanillaType_Weapons as string)
		akActorRef.AddToFaction(WorkshopWeaponVendorFaction)
	ElseIf (asVendorID == iVanillaType_Bar as string)
		akActorRef.AddToFaction(WorkshopBarVendorFaction)
	ElseIf (asVendorID == iVanillaType_Clinic as string)
		akActorRef.AddToFaction(WorkshopClinicVendorFaction)
	ElseIf (asVendorID == iVanillaType_Clothing as string)
		akActorRef.AddToFaction(WorkshopClothingVendorFaction)
	Else
		int iCustomIndex = WorkshopParent.CustomVendorTypes.findstruct("sVendorID", asVendorID, 0)
		If (iCustomIndex >= 0 && WorkshopParent.CustomVendorTypes[iCustomIndex].VendorFaction != None)
			akActorRef.AddToFaction(WorkshopParent.CustomVendorTypes[iCustomIndex].VendorFaction)
		EndIf
	EndIf
EndFunction

Function ApplyVendorData(Actor akActorRef, string asVendorID)
	Self.ApplyVendorKeyword(akActorRef, asVendorID)
	Self.AddToVendorFaction(akActorRef, asVendorID)
EndFunction

Function RemoveVendorKeyword(Actor akActorRef, string asVendorID)
	If (asVendorID == iVanillaType_General as string)
		akActorRef.RemoveKeyword(VanillaShopkeeperKeywords[iVanillaType_General])
	ElseIf (asVendorID == iVanillaType_Armor as string)
		akActorRef.RemoveKeyword(VanillaShopkeeperKeywords[iVanillaType_Armor])
	ElseIf (asVendorID == iVanillaType_Weapons as string)
		akActorRef.RemoveKeyword(VanillaShopkeeperKeywords[iVanillaType_Weapons])
	ElseIf (asVendorID == iVanillaType_Bar as string)
		akActorRef.RemoveKeyword(VanillaShopkeeperKeywords[iVanillaType_Bar])
	ElseIf (asVendorID == iVanillaType_Clinic as string)
		akActorRef.RemoveKeyword(VanillaShopkeeperKeywords[iVanillaType_Clinic])
	ElseIf (asVendorID == iVanillaType_Clothing as string)
		akActorRef.RemoveKeyword(VanillaShopkeeperKeywords[iVanillaType_Clothing])
	Else
		int iCustomIndex = WorkshopParent.CustomVendorTypes.findstruct("sVendorID", asVendorID, 0)
		If (iCustomIndex >= 0 && WorkshopParent.CustomVendorTypes[iCustomIndex].VendorKeyword != None)
			akActorRef.RemoveKeyword(WorkshopParent.CustomVendorTypes[iCustomIndex].VendorKeyword)
		EndIf
	EndIf
EndFunction

int Function GetTotalProducedVendorItemValue(workshopscript akWorkshopRef, string asVendorID, Form aItem, int aiSpecificLevel)
	If (aItem as ActorValue)
		return 0
	EndIf
	If (aItem as LeveledItem)
		return 0
	EndIf
	int iItemCount = Self.GetProducedVendorItemCount(akWorkshopRef, asVendorID, aItem, aiSpecificLevel)
	float fItemValue = Self.GetItemValue(aItem)
	int iTotalValue = Math.Floor(iItemCount as float * fItemValue)
	return iTotalValue
EndFunction

float[] Function TestFunction_GetVendorContainerValues(workshopscript akWorkshopRef, string sVendorID)
	ObjectReference[] kVendorContainers = new ObjectReference[0]
	If (sVendorID == "0" || sVendorID == "1" || sVendorID == "2" || sVendorID == "3" || sVendorID == "4" || sVendorID == "5")
		kVendorContainers = akWorkshopRef.GetVendorContainersByType(sVendorID as int)
	Else
		kVendorContainers = akWorkshopRef.GetCustomVendorContainers(sVendorID)
	EndIf
	float[] fValues = new float[4]
	int I = 0
	While (I < kVendorContainers.length)
		fValues[I] = Self.TestFunction_CalculateContainerValue(kVendorContainers[I])
		I += 1
	EndWhile
	Debug.MessageBox("L1: " + fValues[0] as string + ", L2: " + fValues[1] as string + ", L3: " + fValues[2] as string + ", L4: " + fValues[3] as string)
	return fValues
EndFunction

float Function TestFunction_CalculateContainerValue(ObjectReference akContainerRef)
	If (akContainerRef == None)
		return 0
	EndIf
	Self.AddInventoryEventFilter(None)
	Self.RegisterForRemoteEvent(akContainerRef as ScriptObject, "OnItemRemoved")
	If (fValueCalculation == None)
		fValueCalculation = new float[128]
		kCalculatingValueFor = new ObjectReference[128]
		iAwaitingCalculation = new int[128]
	EndIf
	ObjectReference kTempContainer = akContainerRef.PlaceAtMe(DummyContainerForm, 1, False, False, True)
	int iCalcIndex = Self.NextCalcIndex
	fValueCalculation[iCalcIndex] = 0 as float
	kCalculatingValueFor[iCalcIndex] = kTempContainer
	iAwaitingCalculation[iCalcIndex] = akContainerRef.GetItemCount(None)
	akContainerRef.RemoveAllItems(kTempContainer, True)
	int iWaitTimes = 0
	While (iAwaitingCalculation[iCalcIndex] > 0 && iWaitTimes < 1000)
		Utility.Wait(0.1)
		iWaitTimes += 1
	EndWhile
	Self.UnregisterForRemoteEvent(akContainerRef as ScriptObject, "OnItemRemoved")
	kTempContainer.RemoveAllItems(akContainerRef, False)
	Debug.MessageBox("Container has " + fValueCalculation[iCalcIndex] as string + " worth of goods.")
	float fCalculatedValue = fValueCalculation[iCalcIndex]
	kTempContainer.Disable(False)
	kTempContainer.Delete()
	fValueCalculation[iCalcIndex] = 0 as float
	kCalculatingValueFor[iCalcIndex] = None
	iAwaitingCalculation[iCalcIndex] = 0
	return fCalculatedValue
EndFunction

int Function GetProducedVendorItemCount(workshopscript akWorkshopRef, string asVendorID, Form aItem, int aiSpecificLevel)
	int iCount = 0
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	simsettlementsv2:objectreferences:settlementshopdata thisDataStore = Self.GetShopDataStore(iWorkshopID)
	If (thisDataStore != None)
		ObjectReference[] kVendorContainers = thisDataStore.GetVendorContainers(asVendorID, False)
		int iTotal = kVendorContainers.length
		If (aiSpecificLevel == 0 || aiSpecificLevel == 3)
			iCount += kVendorContainers[iTotal - 1].GetItemCount(aItem)
		EndIf
		If (aiSpecificLevel == 0 || aiSpecificLevel == 2)
			iCount += kVendorContainers[iTotal - 2].GetItemCount(aItem)
		EndIf
		If (aiSpecificLevel == 0 || aiSpecificLevel == 1)
			iCount += kVendorContainers[iTotal - 3].GetItemCount(aItem)
		EndIf
	EndIf
	return iCount
EndFunction

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
	If (asMenuName == "DialogueMenu")
		If (abOpening)
			Actor kTarget = PlayerRef.GetDialogueTarget()
			Self.UpdateShopkeeperContainers(kTarget)
		EndIf
	EndIf
EndEvent

simsettlementsv2:objectreferences:settlementshopdata Function ConfigureShopDataStore(int aiWorkshopID, bool abGetLock)
	int iLockKey = 0
	If (abGetLock)
		iLockKey = Self.GetLock(0, True)
		If (iLockKey <= Self.GENERICLOCK_KEY_NONE)
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "ConfigureShopDataStore: Unable to get lock!", 2, False)
			return None
		EndIf
	EndIf
	If (ShopDataStores.length < aiWorkshopID)
		int I = ShopDataStores.length
		While (I < aiWorkshopID)
			Self.ConfigureShopDataStore(I, False)
			I += 1
		EndWhile
	EndIf
	If (ShopDataStores.length > aiWorkshopID && ShopDataStores[aiWorkshopID] != None && ShopDataStores[aiWorkshopID].IsBoundGameObjectAvailable())
		Self.ApplyUpdateChanges(ShopDataStores[aiWorkshopID])
	Else
		ObjectReference kPlaceAt = SafeSpawnPoint.GetRef()
		If (kPlaceAt)
			ObjectReference kDataStore = kPlaceAt.PlaceAtMe(ShopDataForm, 1, True, False, False)
			If (kDataStore)
				simsettlementsv2:objectreferences:settlementshopdata asDataStore = kDataStore as simsettlementsv2:objectreferences:settlementshopdata
				If (asDataStore)
					asDataStore.kWorkshopRef = WorkshopParent.GetWorkshop(aiWorkshopID)
					If (ShopDataStores.length > aiWorkshopID)
						ShopDataStores[aiWorkshopID] = asDataStore
					Else
						ShopDataStores.add(asDataStore, 1)
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	If (abGetLock)
		If (Self.ReleaseLock(iLockKey) < Self.GENERICLOCK_KEY_NONE)
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "ConfigureShopDataStore: Failed to release lock " + iLockKey as string + "!", 2, False)
		EndIf
	EndIf
	return ShopDataStores[aiWorkshopID]
EndFunction

Function RegisterPetStoreItem(Form aPetStoreItem)
	simsettlementsv2:miscobjects:petstorecreatureitem thisItem = aPetStoreItem as simsettlementsv2:miscobjects:petstorecreatureitem
	If (thisItem as bool && !AllPetStoreItemsList.HasForm(thisItem as Form))
		Form CreatedForm = workshopframework:library:utilityfunctions.GetUniversalForm(thisItem.DisplayVersion)
		If (CreatedForm != None)
			AllPetStoreItemsList.AddForm(thisItem as Form)
			If (thisItem.iSize > 0)
				int iGroupListIndex = thisItem.iSize - 1
				PetStoreDisplayGroupLists[iGroupListIndex].AddForm(thisItem as Form)
			EndIf
			int iVendorListIndex = thisItem.iVendorLevel - 1
			If (iVendorListIndex >= 0 && iVendorListIndex < VendorPetStoreLeveledLists.length)
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Injecting " + thisItem as string + " into petstore list " + VendorPetStoreLeveledLists[iVendorListIndex] as string, 0, False)
				InjectionManager.AddToList(VendorPetStoreLeveledLists[iVendorListIndex] as Form, thisItem as Form)
				Self.AddItemToExistingPetStores(thisItem)
			Else
				workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Unable to inject " + thisItem as string + " into petstore list. iVendorListIndex = " + iVendorListIndex as string, 0, False)
			EndIf
		EndIf
	EndIf
EndFunction

Function RegisterFurnitureItem(Form aFurnitureItem)
	simsettlementsv2:miscobjects:furniturestoreitem thisItem = aFurnitureItem as simsettlementsv2:miscobjects:furniturestoreitem
	If (thisItem as bool && !AllFurnitureItemsList.HasForm(thisItem as Form))
		AllFurnitureItemsList.AddForm(thisItem as Form)
		If (thisItem.iPositionGroup > 0)
			int iGroupListIndex = thisItem.iPositionGroup - 1
			FurnitureDisplayGroupLists[iGroupListIndex].AddForm(thisItem as Form)
		EndIf
		int iVendorListIndex = thisItem.iVendorLevel - 1
		If (iVendorListIndex < VendorFurnitureLeveledLists.length)
			InjectionManager.AddToList(VendorFurnitureLeveledLists[iVendorListIndex] as Form, thisItem as Form)
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Injecting " + thisItem as string + " into furniture store list " + VendorFurnitureLeveledLists[iVendorListIndex] as string, 0, False)
			Self.AddItemToExistingFurnitureStores(thisItem)
		EndIf
	EndIf
EndFunction

Function RegisterCustomVendor(simsettlementsv2:datastructures#customvendordata aNewVendorType)
	If (AddonRegisteredCustomVendors == None)
		AddonRegisteredCustomVendors = new simsettlementsv2:datastructures#customvendordata[0]
	EndIf
	int iIndex = AddonRegisteredCustomVendors.findstruct("sCustomVendorID", aNewVendorType.sCustomVendorID, 0)
	If (iIndex >= 0)
		AddonRegisteredCustomVendors[iIndex] = aNewVendorType
	Else
		AddonRegisteredCustomVendors.add(aNewVendorType, 1)
	EndIf
EndFunction

Function UpdateShopkeeperContainers(Actor akActorRef)
	Self.ClearSS2ShopKeeperLinks(akActorRef)
	int iVendorLevel = akActorRef.GetValue(VendorLevelAV) as int
	If (iVendorLevel < 1)
		return 
	EndIf
	workshopscript thisWorkshop = akActorRef.GetLinkedRef(WorkshopItemKeyword) as workshopscript
	If (thisWorkshop == None)
		return 
	EndIf
	int iWorkshopID = thisWorkshop.GetWorkshopID()
	bool bUseNoRespawnContainers = Settings_ShopsAutoRestock.GetValueInt() == 0
	simsettlementsv2:objectreferences:settlementshopdata thisDataStore = Self.GetShopDataStore(iWorkshopID)
	If (thisDataStore == None)
		return 
	EndIf
	ObjectReference[] kVendorContainers = new ObjectReference[0]
	If (akActorRef.HasKeyword(VendorKeyword_Barber))
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found Barber keyword on " + akActorRef as string + ", updating shopkeeper inventory.", 0, False)
		kVendorContainers = thisDataStore.GetVendorContainers(Self.sCustomVendorID_Barber, bUseNoRespawnContainers)
	ElseIf (akActorRef.HasKeyword(VendorKeyword_BookStore))
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found BookStore keyword on " + akActorRef as string + ", updating shopkeeper inventory.", 0, False)
		kVendorContainers = thisDataStore.GetVendorContainers(Self.sCustomVendorID_BookStore, bUseNoRespawnContainers)
	ElseIf (akActorRef.HasKeyword(VendorKeyword_PetStore))
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found PetStore keyword on " + akActorRef as string + ", updating shopkeeper inventory.", 0, False)
		kVendorContainers = thisDataStore.GetVendorContainers(Self.sCustomVendorID_PetStore, bUseNoRespawnContainers)
	ElseIf (akActorRef.HasKeyword(VendorKeyword_FurnitureStore))
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found FurnitureStore keyword on " + akActorRef as string + ", updating shopkeeper inventory.", 0, False)
		kVendorContainers = thisDataStore.GetVendorContainers(Self.sCustomVendorID_FurnitureStore, bUseNoRespawnContainers)
	ElseIf (akActorRef.HasKeyword(VendorKeyword_PowerArmorStore))
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found PowerArmorStore keyword on " + akActorRef as string + ", updating shopkeeper inventory.", 0, False)
		kVendorContainers = thisDataStore.GetVendorContainers(Self.sCustomVendorID_PowerArmorStore, bUseNoRespawnContainers)
	ElseIf (akActorRef.HasKeyword(VanillaShopkeeperKeywords[iVanillaType_General]))
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found GeneralStore keyword on " + akActorRef as string + ", updating shopkeeper inventory.", 0, False)
		kVendorContainers = thisDataStore.GetVendorContainers(iVanillaType_General as string, bUseNoRespawnContainers)
	ElseIf (akActorRef.HasKeyword(VanillaShopkeeperKeywords[iVanillaType_Armor]))
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found ArmorStore keyword on " + akActorRef as string + ", updating shopkeeper inventory.", 0, False)
		kVendorContainers = thisDataStore.GetVendorContainers(iVanillaType_Armor as string, bUseNoRespawnContainers)
	ElseIf (akActorRef.HasKeyword(VanillaShopkeeperKeywords[iVanillaType_Weapons]))
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found WeaponStore keyword on " + akActorRef as string + ", updating shopkeeper inventory.", 0, False)
		kVendorContainers = thisDataStore.GetVendorContainers(iVanillaType_Weapons as string, bUseNoRespawnContainers)
	ElseIf (akActorRef.HasKeyword(VanillaShopkeeperKeywords[iVanillaType_Bar]))
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found Bar keyword on " + akActorRef as string + ", updating shopkeeper inventory.", 0, False)
		kVendorContainers = thisDataStore.GetVendorContainers(iVanillaType_Bar as string, bUseNoRespawnContainers)
	ElseIf (akActorRef.HasKeyword(VanillaShopkeeperKeywords[iVanillaType_Clinic]))
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found Clinic keyword on " + akActorRef as string + ", updating shopkeeper inventory.", 0, False)
		kVendorContainers = thisDataStore.GetVendorContainers(iVanillaType_Clinic as string, bUseNoRespawnContainers)
	ElseIf (akActorRef.HasKeyword(VanillaShopkeeperKeywords[iVanillaType_Clothing]))
		workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Found ClothingStore keyword on " + akActorRef as string + ", updating shopkeeper inventory.", 0, False)
		kVendorContainers = thisDataStore.GetVendorContainers(iVanillaType_Clothing as string, bUseNoRespawnContainers)
	Else
		int i = 0
		bool bMatchFound = False
		While (i < AddonRegisteredCustomVendors.length && !bMatchFound)
			If (AddonRegisteredCustomVendors[i].CustomVendorKeyword != None)
				If (akActorRef.HasKeyword(AddonRegisteredCustomVendors[i].CustomVendorKeyword))
					kVendorContainers = thisDataStore.GetVendorContainers(AddonRegisteredCustomVendors[i].sCustomVendorID, bUseNoRespawnContainers)
					bMatchFound = True
				EndIf
			EndIf
			i += 1
		EndWhile
		If (!bMatchFound)
			If (akActorRef.IsInFaction(WorkshopArmorVendorFaction))
				kVendorContainers = thisDataStore.GetVendorContainers(iVanillaType_Armor as string, bUseNoRespawnContainers)
			ElseIf (akActorRef.IsInFaction(WorkshopBarVendorFaction))
				kVendorContainers = thisDataStore.GetVendorContainers(iVanillaType_Bar as string, bUseNoRespawnContainers)
			ElseIf (akActorRef.IsInFaction(WorkshopClinicVendorFaction))
				kVendorContainers = thisDataStore.GetVendorContainers(iVanillaType_Clinic as string, bUseNoRespawnContainers)
			ElseIf (akActorRef.IsInFaction(WorkshopClothingVendorFaction))
				kVendorContainers = thisDataStore.GetVendorContainers(iVanillaType_Clothing as string, bUseNoRespawnContainers)
			ElseIf (akActorRef.IsInFaction(WorkshopGeneralVendorFaction))
				kVendorContainers = thisDataStore.GetVendorContainers(iVanillaType_General as string, bUseNoRespawnContainers)
			ElseIf (akActorRef.IsInFaction(WorkshopWeaponVendorFaction))
				kVendorContainers = thisDataStore.GetVendorContainers(iVanillaType_Weapons as string, bUseNoRespawnContainers)
			EndIf
		EndIf
	EndIf
	If (bUseNoRespawnContainers)
		int i = 0
		While (i < 3)
			akActorRef.SetLinkedRef(None, VendorContainerKeywords_Vanilla[i])
			i += 1
		EndWhile
	EndIf
	int I = 0
	While (I < kVendorContainers.length)
		If (I < iVendorLevel || I == kVendorContainers.length - 1 && iVendorLevel == 3 || I == kVendorContainers.length - 2 && iVendorLevel == 2 || I == kVendorContainers.length - 3 && iVendorLevel == 1)
			akActorRef.SetLinkedRef(kVendorContainers[I], VendorLinkKeywords_SS2[I])
		ElseIf (I < VendorLinkKeywords_SS2.length - 1)
			akActorRef.SetLinkedRef(None, VendorLinkKeywords_SS2[I])
		EndIf
		I += 1
	EndWhile
EndFunction

Function RegisterFurnitureItems(FormList aNewFurnitureItemsList)
	int I = 0
	While (I < aNewFurnitureItemsList.GetSize())
		Self.RegisterFurnitureItem(aNewFurnitureItemsList.GetAt(I))
		I += 1
	EndWhile
EndFunction

Function RegisterPetStoreItems(FormList aNewPetStoreItemsList)
	int I = 0
	While (I < aNewPetStoreItemsList.GetSize())
		Self.RegisterPetStoreItem(aNewPetStoreItemsList.GetAt(I))
		I += 1
	EndWhile
EndFunction

Function ProduceVendorItems(workshopscript akWorkshopRef, string asVendorID, Form aItem, int aiProduceCount, int aiHandleFormlistMethod, int aiMinLevel, bool abStoreInNetworkIfLocalFull)
	float fItemValue = Self.GetItemValue(aItem)
	float[] fCurrentValueByLevel = new float[iMaxPlotLevel]
	If (aiMinLevel < 1)
		aiMinLevel = 1
	ElseIf (aiMinLevel > iMaxPlotLevel)
		aiMinLevel = iMaxPlotLevel
	EndIf
	int I = aiMinLevel
	While (I <= iMaxPlotLevel)
		fCurrentValueByLevel[I - 1] = Self.GetProducedVendorItemCount(akWorkshopRef, asVendorID, aItem, I) as float
		I += 1
	EndWhile
	float fTotalValueRemainingToProduce = fItemValue * aiProduceCount as float
	int iWorkshopID = akWorkshopRef.GetWorkshopID()
	simsettlementsv2:objectreferences:settlementshopdata thisDataStore = Self.GetShopDataStore(iWorkshopID)
	If (thisDataStore != None)
		ObjectReference[] kVendorContainers = thisDataStore.GetVendorContainers(asVendorID, False)
		I = aiMinLevel
		While (I <= iMaxPlotLevel)
			int iLevelIndex = I - 1
			ObjectReference kThisContainer = kVendorContainers[kVendorContainers.length - iMaxPlotLevel - iLevelIndex]
			int iValueCapPerItemType = iBaseValueCapPerItemType
			If (thisDataStore.fValueCapPerItemTypeModifier != 0 as float)
				iValueCapPerItemType = Math.Floor(iValueCapPerItemType as float + iValueCapPerItemType as float * thisDataStore.fValueCapPerItemTypeModifier)
			EndIf
			float fValueCapLevelMultiplier = fBaseValueCapLevelMultiplier
			If (thisDataStore.fValueCapLevelMultiplierModifier != 0 as float)
				fValueCapLevelMultiplier = Math.Floor(fValueCapLevelMultiplier + fValueCapLevelMultiplier * thisDataStore.fValueCapLevelMultiplierModifier) as float
			EndIf
			float fMaxThisLevel = iValueCapPerItemType as float * fValueCapLevelMultiplier
			float fSpaceAvailable = fMaxThisLevel - fCurrentValueByLevel[iLevelIndex]
			If (fTotalValueRemainingToProduce <= fSpaceAvailable)
				fTotalValueRemainingToProduce = 0 as float
				Self.AddItemsToContainer(aItem, aiProduceCount, kThisContainer, aiHandleFormlistMethod)
			ElseIf (fSpaceAvailable > 0 as float)
				int iProduce = Math.Floor(fSpaceAvailable / fItemValue)
				fTotalValueRemainingToProduce -= iProduce as float * fItemValue
				Self.AddItemsToContainer(aItem, iProduce, kThisContainer, aiHandleFormlistMethod)
			EndIf
			I += 1
		EndWhile
		If (fTotalValueRemainingToProduce > 0 as float && abStoreInNetworkIfLocalFull)
			workshopscript[] kNetworkRefs = EmpireManager.GetEmpireNetworkContainingSettlement(EmpireCaravanKeyword, akWorkshopRef, False)
			kNetworkRefs = simsettlementsv2:utilityfunctions.SortWorkshopsByDistanceToRef(kNetworkRefs, akWorkshopRef as ObjectReference)
			I = 0
			While (I < kNetworkRefs.length && fTotalValueRemainingToProduce > 0 as float)
				int iNetworkWorkshopID = kNetworkRefs[I].GetWorkshopID()
				thisDataStore = Self.GetShopDataStore(iNetworkWorkshopID)
				If (thisDataStore != None)
					kVendorContainers = thisDataStore.GetVendorContainers(asVendorID, False)
					I = aiMinLevel
					While (I <= iMaxPlotLevel)
						int ilevelindex = I - 1
						ObjectReference kthiscontainer = kVendorContainers[kVendorContainers.length - iMaxPlotLevel - ilevelindex]
						int ivaluecapperitemtype = iBaseValueCapPerItemType
						If (thisDataStore.fValueCapPerItemTypeModifier != 0 as float)
							ivaluecapperitemtype = Math.Floor(ivaluecapperitemtype as float + ivaluecapperitemtype as float * thisDataStore.fValueCapPerItemTypeModifier)
						EndIf
						float fvaluecaplevelmultiplier = fBaseValueCapLevelMultiplier
						If (thisDataStore.fValueCapLevelMultiplierModifier != 0 as float)
							fvaluecaplevelmultiplier = Math.Floor(fvaluecaplevelmultiplier + fvaluecaplevelmultiplier * thisDataStore.fValueCapLevelMultiplierModifier) as float
						EndIf
						float fmaxthislevel = ivaluecapperitemtype as float * fvaluecaplevelmultiplier
						float fspaceavailable = fmaxthislevel - fCurrentValueByLevel[ilevelindex]
						If (fTotalValueRemainingToProduce <= fspaceavailable)
							fTotalValueRemainingToProduce = 0 as float
							Self.AddItemsToContainer(aItem, aiProduceCount, kthiscontainer, aiHandleFormlistMethod)
						ElseIf (fspaceavailable > 0 as float)
							int iproduce = Math.Floor(fspaceavailable / fItemValue)
							fTotalValueRemainingToProduce -= iproduce as float * fItemValue
							Self.AddItemsToContainer(aItem, iproduce, kthiscontainer, aiHandleFormlistMethod)
						EndIf
						I += 1
					EndWhile
				EndIf
				I += 1
			EndWhile
		EndIf
	EndIf
EndFunction

Function AddItemToExistingPetStores(simsettlementsv2:miscobjects:petstorecreatureitem aPetStoreItem)
	workshopscript[] Workshops = WorkshopParent.Workshops
	int iPetStoreIndex = WorkshopParent.CustomVendorTypes.findstruct("sVendorID", Self.sCustomVendorID_PetStore, 0)
	If (iPetStoreIndex < 0)
		return 
	EndIf
	int I = 0
	While (I < Workshops.length)
		If (aPetStoreItem.iVendorLevel == 1)
			If (Workshops[I].kCustomVendorContainersL0.length > iPetStoreIndex && Workshops[I].kCustomVendorContainersL0[iPetStoreIndex] != None)
				Workshops[I].kCustomVendorContainersL0[iPetStoreIndex].AddItem(aPetStoreItem as Form, 1, False)
			EndIf
		ElseIf (aPetStoreItem.iVendorLevel == 2)
			If (Workshops[I].kCustomVendorContainersL1.length > iPetStoreIndex && Workshops[I].kCustomVendorContainersL1[iPetStoreIndex] != None)
				Workshops[I].kCustomVendorContainersL1[iPetStoreIndex].AddItem(aPetStoreItem as Form, 1, False)
			EndIf
		ElseIf (aPetStoreItem.iVendorLevel == 3)
			If (Workshops[I].kCustomVendorContainersL2.length > iPetStoreIndex && Workshops[I].kCustomVendorContainersL2[iPetStoreIndex] != None)
				Workshops[I].kCustomVendorContainersL2[iPetStoreIndex].AddItem(aPetStoreItem as Form, 1, False)
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction

simsettlementsv2:objectreferences:settlementshopdata Function GetShopDataStore(int aiWorkshopID)
	simsettlementsv2:objectreferences:settlementshopdata kDataStoreRef = None
	If (ShopDataStores as bool && ShopDataStores.length > aiWorkshopID)
		kDataStoreRef = ShopDataStores[aiWorkshopID]
	Else
		kDataStoreRef = Self.ConfigureShopDataStore(aiWorkshopID, True)
	EndIf
	return kDataStoreRef
EndFunction

Function ApplyUpdateChanges(simsettlementsv2:objectreferences:settlementshopdata aDataStore)
	; Empty function
EndFunction
