;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\StreamInteractionManager.psc
Modified : 2020-11-12 13:21:04
Compiled : 2021-01-07 11:44:16
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:StreamInteractionManager extends WorkshopFramework:Library:SlaveQuest conditional
{ Handles special functions and gameplay designed for streamers }

;-- Properties --------------------------------------
Group Controllers
	simsettlementsv2:quests:npc_recruitmentmanager Property NPC_RecruitmentManager Auto Const mandatory
	simsettlementsv2:quests:unlockmanager Property UnlockManager Auto Const mandatory
	simsettlementsv2:quests:resourcemanager Property ResourceManager Auto Const mandatory
	simsettlementsv2:quests:optionsmanager Property OptionsManager Auto Const mandatory
EndGroup

Group Assets
	FormList Property PurchaseablePetList Auto Const mandatory
	FormList Property VirtualResourceAVList Auto Const mandatory
EndGroup

Group Keywords
	Keyword Property PlotTagKeyword Auto Const mandatory
EndGroup


;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

Function TriggerUniqueVisitor(bool abBypassRequirements)
	simsettlementsv2:miscobjects:unlockablecharacter UnlockMe = None
	FormList UnlockableCharacters_Eligible = NPC_RecruitmentManager.UnlockableCharacters_Eligible
	int iEligibleCount = UnlockableCharacters_Eligible.GetSize()
	If (iEligibleCount > 0)
		UnlockMe = UnlockableCharacters_Eligible.GetAt(Utility.RandomInt(0, iEligibleCount - 1)) as simsettlementsv2:miscobjects:unlockablecharacter
	ElseIf (abBypassRequirements)
		FormList AwaitingUnlockables = UnlockManager.AwaitingUnlockables
		simsettlementsv2:miscobjects:unlockablecharacter[] UnlockableCharacterRecords = new simsettlementsv2:miscobjects:unlockablecharacter[0]
		int I = 0
		While (I < AwaitingUnlockables.GetSize())
			simsettlementsv2:miscobjects:unlockablecharacter thisUnlock = AwaitingUnlockables.GetAt(I) as simsettlementsv2:miscobjects:unlockablecharacter
			If (thisUnlock != None)
				UnlockableCharacterRecords.add(thisUnlock, 1)
			EndIf
			I += 1
		EndWhile
		If (UnlockableCharacterRecords.length > 0)
			UnlockMe = UnlockableCharacterRecords[Utility.RandomInt(0, UnlockableCharacterRecords.length - 1)]
		EndIf
	EndIf
	If (UnlockMe != None)
		NPC_RecruitmentManager.TestUnlockableCharacter(UnlockMe as Form, True, False)
	EndIf
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
EndFunction

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
EndFunction

Function SpawnRandomPet(bool abSendToNearestSettlement, bool abMakeFamiliar)
	simsettlementsv2:miscobjects:petstorecreatureitem[] PotentialPets = new simsettlementsv2:miscobjects:petstorecreatureitem[0]
	int I = 0
	While (I < PurchaseablePetList.GetSize())
		simsettlementsv2:miscobjects:petstorecreatureitem thisItem = PurchaseablePetList.GetAt(I) as simsettlementsv2:miscobjects:petstorecreatureitem
		If (thisItem != None)
			PotentialPets.add(thisItem, 1)
		EndIf
		I += 1
	EndWhile
	simsettlementsv2:miscobjects:petstorecreatureitem asCreatureItem = PotentialPets[Utility.RandomInt(0, PotentialPets.length - 1)]
	If (asCreatureItem != None)
		workshopscript kSendToSettlement = None
		If (abSendToNearestSettlement)
			kSendToSettlement = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
		EndIf
		NPC_RecruitmentManager.PetStoreCreaturePurchased(asCreatureItem, PlayerRef as ObjectReference, kSendToSettlement)
	EndIf
EndFunction

Function ForceHoliday(int aiHolidayIndex)
	simsettlementsv2:armors:themedefinition ForceHoliday = None
	FormList RegisteredHolidays = OptionsManager.RegisteredHolidays
	If (aiHolidayIndex < 0 || aiHolidayIndex >= RegisteredHolidays.GetSize())
		ForceHoliday = RegisteredHolidays.GetAt(Utility.RandomInt(0, RegisteredHolidays.GetSize() - 1)) as simsettlementsv2:armors:themedefinition
	Else
		ForceHoliday = RegisteredHolidays.GetAt(aiHolidayIndex) as simsettlementsv2:armors:themedefinition
	EndIf
	If (ForceHoliday != None)
		workshopscript kNearestWorkshop = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
		OptionsManager.TestThemeChange(ForceHoliday, kNearestWorkshop.GetWorkshopID(), True)
	EndIf
EndFunction

Function GiveResources(int aiResourceIndex, int aiAmount)
	ActorValue ResourceAV = None
	If (aiResourceIndex < 0 || aiResourceIndex >= VirtualResourceAVList.GetSize())
		ResourceAV = VirtualResourceAVList.GetAt(Utility.RandomInt(0, VirtualResourceAVList.GetSize() - 1)) as ActorValue
	Else
		ResourceAV = VirtualResourceAVList.GetAt(aiResourceIndex) as ActorValue
	EndIf
	workshopscript kNearestWorkshop = workshopframework:wsfw_api.GetNearestWorkshop(PlayerRef as ObjectReference)
	ResourceManager.ProduceSettlementVirtualResource(kNearestWorkshop.GetWorkshopID(), ResourceAV, aiAmount as float, True)
EndFunction

Function DestroyNearbyPlot(bool abDestroyJustTheBuilding)
	ObjectReference[] kPlotRefs = PlayerRef.FindAllReferencesWithKeyword(PlotTagKeyword as Form, 10000)
	If (kPlotRefs.length > 0)
		float fClosestDistance = 1.00000e+07
		simsettlementsv2:objectreferences:simplot kClosestPlot = None
		int I = 0
		While (I < kPlotRefs.length)
			simsettlementsv2:objectreferences:simplot thisPlot = kPlotRefs[I] as simsettlementsv2:objectreferences:simplot
			If (thisPlot as bool && !thisPlot.bIsComplete && !thisPlot.bUnderConstruction)
				float fThisDistance = PlayerRef.GetDistance(kPlotRefs[I])
				If (fThisDistance < fClosestDistance)
					fClosestDistance = fThisDistance
					kClosestPlot = thisPlot
				EndIf
			EndIf
			I += 1
		EndWhile
		If (kClosestPlot != None)
			If (abDestroyJustTheBuilding)
				kClosestPlot.PlayDemolitionFX()
				kClosestPlot.ResetPlot(False, False, False)
				kClosestPlot.ClearOldStageModels(False, True)
				kClosestPlot.ClearOldStageItems(False, True)
				kClosestPlot.ClearOldIndicators(False, True)
			Else
				kClosestPlot.SelfDestruct(True)
			EndIf
		EndIf
	EndIf
EndFunction

Function UpgradeNearbyPlot()
	ObjectReference[] kPlotRefs = PlayerRef.FindAllReferencesWithKeyword(PlotTagKeyword as Form, 10000)
	If (kPlotRefs.length > 0)
		float fClosestDistance = 1.00000e+07
		simsettlementsv2:objectreferences:simplot kClosestPlot = None
		int I = 0
		While (I < kPlotRefs.length)
			simsettlementsv2:objectreferences:simplot thisPlot = kPlotRefs[I] as simsettlementsv2:objectreferences:simplot
			If (thisPlot as bool && !thisPlot.bIsComplete && !thisPlot.bUnderConstruction)
				float fThisDistance = PlayerRef.GetDistance(kPlotRefs[I])
				If (fThisDistance < fClosestDistance)
					fClosestDistance = fThisDistance
					kClosestPlot = thisPlot
				EndIf
			EndIf
			I += 1
		EndWhile
		If (kClosestPlot != None)
			kClosestPlot.ForcePlotLevel(kClosestPlot.iCurrentLevel + 1, -1)
		EndIf
	EndIf
EndFunction
