;/ Decompiled by Champollion V1.0.6
PEX format v3.9 GameID: 2
Source   : C:\Program Files (x86)\Steam\steamapps\common\CC-F\Data\Scripts\Source\User\SimSettlementsV2\Quests\UnlockManager.psc
Modified : 2020-12-27 20:55:45
Compiled : 2021-01-20 16:53:10
User     : simse
Computer : DESKTOP-V5NSCCR
/;
ScriptName SimSettlementsV2:quests:UnlockManager extends WorkshopFramework:Library:SlaveQuest
{ Handles unlocking things in the mod, such as gameplay introduced elements over time, or discoveries }

;-- Properties --------------------------------------
Group Controllers
	simsettlementsv2:quests:cameramanager Property CameraManager Auto Const mandatory
	simsettlementsv2:quests:plotmanager Property PlotManager Auto Const mandatory
	simsettlementsv2:quests:settlementmanager Property SettlementManager Auto Const mandatory
	workshopparentscript Property WorkshopParent Auto Const mandatory
EndGroup

Group Assets
	Sound Property UnlockSound Auto Const mandatory
	{ Default sound to play when something is unlocked - this can be overridden at the Unlockable level }
	workshopframework:library:datastructures#globalsettingmap[] Property PlotUnlockMaps Auto Const mandatory
EndGroup

Group Formlists
	FormList Property AwaitingUnlockables Auto Const mandatory
	{ Blank formlist to hold registered unlockables that haven't been unlocked yet }
	FormList Property CompletedUnlockables Auto Const mandatory
	{ Blank formlist to hold registered unlockables that have been unlocked }
EndGroup


;-- Variables ---------------------------------------
float fQuestTriggeredUnlockDelay = 5 Const
int iTimerID_DelayedUnlockCheck = 101 Const
int iTimerID_DailyCheck = 100 Const
float fTimerLength_DailyCheck = 24 Const
bool bTryToTriggerUnlocksBlock = False

;-- Functions ---------------------------------------

Function RegisterUnlockable(simsettlementsv2:miscobjects:unlockable aUnlockable)
	If (aUnlockable == None)
		return 
	EndIf
	If (!AwaitingUnlockables.HasForm(aUnlockable as Form) && !CompletedUnlockables.HasForm(aUnlockable as Form))
		If (Self.ShouldUnlock(aUnlockable))
			Self.Unlock(aUnlockable, False)
		Else
			AwaitingUnlockables.AddForm(aUnlockable as Form)
			If (aUnlockable.GetRequirements())
				If (aUnlockable.GetRequirements().QuestRequirements as bool && aUnlockable.GetRequirements().QuestRequirements.length > 0)
					int I = 0
					While (I < aUnlockable.GetRequirements().QuestRequirements.length)
						Quest thisQuest = workshopframework:library:utilityfunctions.GetQuestStageSetForm(aUnlockable.GetRequirements().QuestRequirements[I])
						If (thisQuest)
							Self.MonitorQuest(thisQuest, aUnlockable.GetRequirements().QuestRequirements[I].iStage)
						EndIf
						I += 1
					EndWhile
				EndIf
			EndIf
		EndIf
	EndIf
EndFunction

Event Quest.OnStageSet(Quest akSenderRef, int aiStageID, int aiStageItemID)
	If (akSenderRef == PlotManager as Quest)
		int iIndex = PlotUnlockMaps.findstruct("fValue", aiStageID as float, 0)
		If (iIndex > -1)
			PlotUnlockMaps[iIndex].GlobalForm.SetValueInt(1)
		EndIf
	EndIf
	Self.StartTimer(fQuestTriggeredUnlockDelay, iTimerID_DelayedUnlockCheck)
EndEvent

Function UnlockBuildingPlanClass(Keyword aClassKeyword)
	simsettlementsv2:datastructures#plotsubclass[] PlotSubClasses = PlotManager.GetPlotSubClasses()
	simsettlementsv2:datastructures#buildingplanlistmap[] BuildingPlanListMaps = PlotManager.BuildingPlanListMaps
	If (BuildingPlanListMaps.length < PlotManager.DefaultBuildingPlanListMaps.length)
		BuildingPlanListMaps = PlotManager.DefaultBuildingPlanListMaps
	EndIf
	int iSubClassIndex = PlotSubClasses.findstruct("ClassKeyword", aClassKeyword, 0)
	If (iSubClassIndex < 0)
		return 
	EndIf
	simsettlementsv2:armors:buildingclass thisClassForm = PlotSubClasses[iSubClassIndex].BuildingClassForm as simsettlementsv2:armors:buildingclass
	If (thisClassForm as bool && (thisClassForm.gUnlock == None || thisClassForm.gUnlock.GetValueInt() > 0))
		return 
	EndIf
	thisClassForm.gUnlock.SetValueInt(1)
	FormList[] InvalidateMyCache = new FormList[0]
	int I = 0
	While (I < BuildingPlanListMaps.length)
		int j = BuildingPlanListMaps[I].UnlockableList.GetSize() - 1
		While (j >= 0)
			simsettlementsv2:weapons:buildingplan asBuildingPlan = BuildingPlanListMaps[I].UnlockableList.GetAt(j) as simsettlementsv2:weapons:buildingplan
			If (asBuildingPlan as bool && asBuildingPlan.ClassKeyword == aClassKeyword)
				If (InvalidateMyCache.find(BuildingPlanListMaps[I].PlanList, 0) < 0)
					InvalidateMyCache.add(BuildingPlanListMaps[I].PlanList, 1)
				EndIf
				BuildingPlanListMaps[I].PlanList.AddForm(asBuildingPlan as Form)
				BuildingPlanListMaps[I].UnlockableList.RemoveAddedForm(asBuildingPlan as Form)
			EndIf
			j -= 1
		EndWhile
		I += 1
	EndWhile
	I = 0
	While (I < InvalidateMyCache.length)
		PlotManager.ResetCacheByFormlist(InvalidateMyCache[I])
		I += 1
	EndWhile
EndFunction

Function HandleGameLoaded()
	Parent.HandleGameLoaded()
	workshopframework:library:utilityfunctions.CleanFormlist(AwaitingUnlockables, -1)
	workshopframework:library:utilityfunctions.CleanFormlist(CompletedUnlockables, -1)
	Self.TryToTriggerUnlocks()
EndFunction

bool Function ShouldUnlock(simsettlementsv2:miscobjects:unlockable aUnlockable)
	bool bShouldUnlock = aUnlockable.ShouldUnlock()
	return bShouldUnlock
EndFunction

Event Location.OnLocationCleared(Location akSender)
	Self.UnregisterForRemoteEvent(akSender as ScriptObject, "OnLocationCleared")
	Self.TryToTriggerUnlocks()
EndEvent

Function RefreshMonitors()
	int I = 0
	int iSize = AwaitingUnlockables.GetSize()
	While (I < iSize)
		simsettlementsv2:miscobjects:unlockable thisUnlockable = AwaitingUnlockables.GetAt(I) as simsettlementsv2:miscobjects:unlockable
		If (thisUnlockable.GetRequirements())
			If (thisUnlockable.GetRequirements().QuestRequirements as bool && thisUnlockable.GetRequirements().QuestRequirements.length > 0)
				int j = 0
				While (j < thisUnlockable.GetRequirements().QuestRequirements.length)
					Quest thisQuest = workshopframework:library:utilityfunctions.GetQuestStageSetForm(thisUnlockable.GetRequirements().QuestRequirements[j])
					If (thisQuest)
						Self.MonitorQuest(thisQuest, thisUnlockable.GetRequirements().QuestRequirements[j].iStage)
					EndIf
					j += 1
				EndWhile
			EndIf
		EndIf
		I += 1
	EndWhile
EndFunction

Function UnlockBuildingPlan(Form aBuildingPlan, FormList aTargetBuildingPlanList)
	simsettlementsv2:datastructures#buildingplanlistmap[] BuildingPlanListMaps = PlotManager.BuildingPlanListMaps
	If (BuildingPlanListMaps.length < PlotManager.DefaultBuildingPlanListMaps.length)
		BuildingPlanListMaps = PlotManager.DefaultBuildingPlanListMaps
	EndIf
	If (aTargetBuildingPlanList)
		aTargetBuildingPlanList.AddForm(aBuildingPlan)
		PlotManager.ResetCacheByFormlist(aTargetBuildingPlanList)
		int iIndex = BuildingPlanListMaps.findstruct("PlanList", aTargetBuildingPlanList, 0)
		If (iIndex >= 0)
			BuildingPlanListMaps[iIndex].UnlockableList.RemoveAddedForm(aBuildingPlan)
		EndIf
	Else
		int I = 0
		bool bFoundForm = False
		While (I < BuildingPlanListMaps.length && !bFoundForm)
			If (BuildingPlanListMaps[I].UnlockableList.HasForm(aBuildingPlan))
				bFoundForm = True
				BuildingPlanListMaps[I].PlanList.AddForm(aBuildingPlan)
				BuildingPlanListMaps[I].UnlockableList.RemoveAddedForm(aBuildingPlan)
				PlotManager.ResetCacheByFormlist(BuildingPlanListMaps[I].PlanList)
			EndIf
			I += 1
		EndWhile
	EndIf
EndFunction

Function HandleQuestInit()
	Parent.HandleQuestInit()
	Self.RegisterForRemoteEvent(PlotManager as ScriptObject, "OnStageSet")
	Self.RegisterForCustomEvent(PlotManager as ScriptObject, "simsettlementsv2:quests:plotmanager_PlotLevelChanged")
	Self.RegisterForCustomEvent(WorkshopParent as ScriptObject, "workshopparentscript_WorkshopPlayerOwnershipChanged")
	Self.StartTimerGameTime(fTimerLength_DailyCheck, iTimerID_DailyCheck)
EndFunction

bool Function IsBuildingClassUnlocked(Keyword aClassKeyword)
	If (aClassKeyword == None)
		return True
	EndIf
	simsettlementsv2:datastructures#plotsubclass[] PlotSubClasses = PlotManager.GetPlotSubClasses()
	int iSubIndex = PlotSubClasses.findstruct("ClassKeyword", aClassKeyword, 0)
	simsettlementsv2:armors:buildingclass thisClassForm = PlotSubClasses[iSubIndex].BuildingClassForm as simsettlementsv2:armors:buildingclass
	If (iSubIndex < 0 || !thisClassForm || thisClassForm.gUnlock == None || thisClassForm.gUnlock.GetValueInt() > 0)
		return True
	Else
		return False
	EndIf
EndFunction

Event SimSettlementsV2:Quests:CameraManager.CameraModeStopped(simsettlementsv2:quests:cameramanager akSender, var[] akArgs)
	Self.TryToTriggerUnlocks()
	Self.UnregisterForCustomEvent(akSender as ScriptObject, "simsettlementsv2:quests:cameramanager_CameraModeStopped")
EndEvent

Function Unlock(simsettlementsv2:miscobjects:unlockable aUnlockable, bool abSuppressFanfare)
	While (PlayerRef.GetSitState() != 0 || workshopframework:wsfw_api.IsPlayerInWorkshopMode())
		Utility.Wait(5)
	EndWhile
	If (aUnlockable.GetRequirements() as bool && aUnlockable.GetRequirements().QuestRequirements as bool && aUnlockable.GetRequirements().QuestRequirements.length > 0)
		int I = 0
		While (I < aUnlockable.GetRequirements().QuestRequirements.length)
			Quest thisQuest = workshopframework:library:utilityfunctions.GetQuestStageSetForm(aUnlockable.GetRequirements().QuestRequirements[I])
			If (thisQuest)
				Self.UnregisterForRemoteEvent(thisQuest as ScriptObject, "OnStageSet")
			EndIf
			I += 1
		EndWhile
	EndIf
	AwaitingUnlockables.RemoveAddedForm(aUnlockable as Form)
	CompletedUnlockables.AddForm(aUnlockable as Form)
	aUnlockable.HandleUnlock(abSuppressFanfare)
EndFunction

Function TryToTriggerUnlocks()
	If (bTryToTriggerUnlocksBlock)
		return 
	EndIf
	If (CameraManager.bIsCameraControlled)
		Self.RegisterForCustomEvent(CameraManager as ScriptObject, "simsettlementsv2:quests:cameramanager_CameraModeStopped")
		return 
	EndIf
	bTryToTriggerUnlocksBlock = True
	int I = AwaitingUnlockables.GetSize() - 1
	While (I >= 0)
		simsettlementsv2:miscobjects:unlockable thisUnlockable = AwaitingUnlockables.GetAt(I) as simsettlementsv2:miscobjects:unlockable
		If (thisUnlockable)
			workshopframework:library:utilityfunctions.ModTraceCustom(simsettlementsv2:utilityfunctions.GetLogName(), "Checking unlockable: " + thisUnlockable as string, 0, False)
			If (Self.ShouldUnlock(thisUnlockable))
				Utility.Wait(0.1)
				Self.Unlock(thisUnlockable, False)
			EndIf
		EndIf
		I -= 1
	EndWhile
	Self.RefreshMonitors()
	bTryToTriggerUnlocksBlock = False
EndFunction

Function MonitorQuest(Quest aQuest, int aiStageID)
	If (!aQuest.IsStageDone(aiStageID))
		Self.RegisterForRemoteEvent(aQuest as ScriptObject, "OnStageSet")
	EndIf
EndFunction

Event OnTimer(int aiTimerID)
	If (aiTimerID == iTimerID_DelayedUnlockCheck)
		Self.TryToTriggerUnlocks()
	EndIf
EndEvent

Event WorkshopParentScript.WorkshopPlayerOwnershipChanged(workshopparentscript akSender, var[] akArgs)
	Self.TryToTriggerUnlocks()
EndEvent

Event OnTimerGameTime(int aiTimerID)
	If (aiTimerID == iTimerID_DailyCheck)
		Self.TryToTriggerUnlocks()
		Self.StartTimerGameTime(fTimerLength_DailyCheck, iTimerID_DailyCheck)
	EndIf
EndEvent

Event SimSettlementsV2:Quests:PlotManager.PlotLevelChanged(simsettlementsv2:quests:plotmanager akSender, var[] akArgs)
	Self.TryToTriggerUnlocks()
EndEvent
